Package: TCGAbiolinks
Type: Package
Title: TCGAbiolinks: An R/Bioconductor package for integrative analysis
        with GDC data
Version: 2.40.0
Date: 2024-01-01
Author: Antonio Colaprico,
    Tiago Chedraoui Silva,
    Catharina Olsen,
    Luciano Garofano,
    Davide Garolini,
    Claudia Cava,
    Thais Sabedot,
    Tathiane Malta,
    Stefano M. Pagnotta,
    Isabella Castiglioni,
    Michele Ceccarelli,
    Gianluca Bontempi,
    Houtan Noushmehr
Maintainer: Tiago Chedraoui Silva <tiagochst@gmail.com>,
 Antonio Colaprico <axc1833@med.miami.edu>
Depends: R (>= 4.1.0)
Imports: downloader (>= 0.4), grDevices, biomaRt, dplyr, graphics,
        tibble, GenomicRanges, XML (>= 3.98.0), data.table, jsonlite
        (>= 1.0.0), plyr, knitr, methods, ggplot2, stringr (>= 1.0.0),
        IRanges, rvest (>= 0.3.0), stats, utils, S4Vectors, R.utils,
        SummarizedExperiment (>= 1.4.0), TCGAbiolinksGUI.data (>=
        1.15.1), readr, tools, tidyr, purrr, xml2, httr (>= 1.2.1)
Description: The aim of TCGAbiolinks is : i) facilitate the GDC open-access
    data retrieval, ii) prepare the data using the appropriate pre-processing
    strategies, iii) provide the means to carry out different standard analyses
    and iv) to easily reproduce earlier research results. In more detail, the package
    provides multiple methods for analysis (e.g., differential expression analysis,
    identifying differentially methylated regions) and methods for visualization
    (e.g., survival plots, volcano plots, starburst plots) in order to easily
    develop complete analysis pipelines.
License: GPL (>= 3)
biocViews: DNAMethylation, DifferentialMethylation, GeneRegulation,
        GeneExpression, MethylationArray, DifferentialExpression,
        Pathways, Network, Sequencing, Survival, Software
Suggests: jpeg, png, BiocStyle, rmarkdown, devtools, maftools,
        parmigene, c3net, minet, Biobase, affy, testthat, sesame,
        AnnotationHub, ExperimentHub, pathview, clusterProfiler,
        Seurat, ComplexHeatmap, circlize, ConsensusClusterPlus, igraph,
        limma, edgeR, sva, EDASeq, survminer, genefilter, gridExtra,
        survival, doParallel, parallel, ggrepel (>= 0.6.3), scales,
        grid, DT
VignetteBuilder: knitr
LazyData: true
URL: https://github.com/BioinformaticsFMRP/TCGAbiolinks
BugReports: https://github.com/BioinformaticsFMRP/TCGAbiolinks/issues
RoxygenNote: 7.3.3
Encoding: UTF-8
git_url: https://git.bioconductor.org/packages/TCGAbiolinks
git_branch: RELEASE_3_23
git_last_commit: 2f9d249
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-29 01:12:08 UTC; biocbuild

Package: TCGAbiolinks
Type: Package
Title: TCGAbiolinks: An R/Bioconductor package for integrative analysis
        with GDC data
Version: 2.34.1
Date: 2024-01-01
Author: Antonio Colaprico,
    Tiago Chedraoui Silva,
    Catharina Olsen,
    Luciano Garofano,
    Davide Garolini,
    Claudia Cava,
    Thais Sabedot,
    Tathiane Malta,
    Stefano M. Pagnotta,
    Isabella Castiglioni,
    Michele Ceccarelli,
    Gianluca Bontempi,
    Houtan Noushmehr
Maintainer: Tiago Chedraoui Silva <tiagochst@gmail.com>,
 Antonio Colaprico <axc1833@med.miami.edu>
Depends: R (>= 4.0)
Imports: downloader (>= 0.4), grDevices, biomaRt, dplyr, graphics,
        tibble, GenomicRanges, XML (>= 3.98.0), data.table, jsonlite
        (>= 1.0.0), plyr, knitr, methods, ggplot2, stringr (>= 1.0.0),
        IRanges, rvest (>= 0.3.0), stats, utils, S4Vectors, R.utils,
        SummarizedExperiment (>= 1.4.0), TCGAbiolinksGUI.data (>=
        1.15.1), readr, tools, tidyr, purrr, xml2, httr (>= 1.2.1)
Description: The aim of TCGAbiolinks is : i) facilitate the GDC open-access
    data retrieval, ii) prepare the data using the appropriate pre-processing
    strategies, iii) provide the means to carry out different standard analyses
    and iv) to easily reproduce earlier research results. In more detail, the package
    provides multiple methods for analysis (e.g., differential expression analysis,
    identifying differentially methylated regions) and methods for visualization
    (e.g., survival plots, volcano plots, starburst plots) in order to easily
    develop complete analysis pipelines.
License: GPL (>= 3)
biocViews: DNAMethylation, DifferentialMethylation, GeneRegulation,
        GeneExpression, MethylationArray, DifferentialExpression,
        Pathways, Network, Sequencing, Survival, Software
Suggests: jpeg, png, BiocStyle, rmarkdown, devtools, maftools,
        parmigene, c3net, minet, Biobase, affy, testthat, sesame,
        AnnotationHub, ExperimentHub, pathview, clusterProfiler,
        Seurat, ComplexHeatmap, circlize, ConsensusClusterPlus, igraph,
        supraHex, limma, edgeR, sva, EDASeq, survminer, genefilter,
        gridExtra, survival, doParallel, parallel, ggrepel (>= 0.6.3),
        scales, grid, DT
VignetteBuilder: knitr
LazyData: true
URL: https://github.com/BioinformaticsFMRP/TCGAbiolinks
BugReports: https://github.com/BioinformaticsFMRP/TCGAbiolinks/issues
RoxygenNote: 7.3.1
Encoding: UTF-8
git_url: https://git.bioconductor.org/packages/TCGAbiolinks
git_branch: RELEASE_3_20
git_last_commit: 93c796a4
git_last_commit_date: 2025-03-06
Repository: Bioconductor 3.20
Date/Publication: 2025-03-06
NeedsCompilation: no
Packaged: 2025-03-07 00:57:31 UTC; biocbuild

[![Build Status](https://travis-ci.org/BioinformaticsFMRP/TCGAbiolinks.svg?branch=master)](https://travis-ci.org/BioinformaticsFMRP/TCGAbiolinks)
[![AppVeyor Build Status](https://ci.appveyor.com/api/projects/status/github/BioinformaticsFMRP/TCGAbiolinks?branch=master&svg=true)](https://ci.appveyor.com/project/BioinformaticsFMRP/TCGAbiolinks)
[![codecov.io](https://codecov.io/github/BioinformaticsFMRP/TCGAbiolinks/coverage.svg?branch=master)](https://codecov.io/github/BioinformaticsFMRP/TCGAbiolinks?branch=master)
[![bioc](http://www.bioconductor.org/shields/years-in-bioc/TCGAbiolinks.svg)](http://bioconductor.org/packages/TCGAbiolinks/)
[![bioc](http://bioconductor.org/shields/availability/devel/TCGAbiolinks.svg)](http://bioconductor.org/packages/TCGAbiolinks/)

------------------------------------------------------------------------

# TCGAbiolinks - An R/Bioconductor package for integrative analysis with TCGA data

TCGAbiolinks is able to access The National Cancer Institute (NCI) Genomic Data Commons (GDC) thorough its
GDC Application Programming Interface (API) to search, download and prepare relevant data for analysis in R.

### Installation from GitHub ###
```R
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("BioinformaticsFMRP/TCGAbiolinksGUI.data")
BiocManager::install("BioinformaticsFMRP/TCGAbiolinks")
```

### Installation from Bioconductor ###
```R
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("TCGAbiolinks")
```

------------------------------------------------------------------------

### Docker image ###

TCGAbiolinks is available as Docker image (self-contained environments that contain everything needed to run the software), 
which can be easily run on Mac OS, Windows and Linux systems. 

This [PDF](https://drive.google.com/open?id=0B0-8N2fjttG-QXp5LVlPQnVQejg) show how to install and execute the image.

The image can be obtained from Docker Hub: https://hub.docker.com/r/tiagochst/tcgabiolinksgui/

For more information please check: https://docs.docker.com/ and https://www.bioconductor.org/help/docker/


### Manual ###

http://bioconductor.org/packages/devel/bioc/vignettes/TCGAbiolinks/inst/doc/index.html

------------------------------------------------------------------------


## Citation

Please cite both TCGAbiolinks package: 

* Colaprico A, Silva TC, Olsen C, Garofano L, Cava C, Garolini D, Sabedot T, Malta TM, Pagnotta SM, Castiglioni I, Ceccarelli M, Bontempi G and Noushmehr H. "TCGAbiolinks: an R/Bioconductor package for integrative analysis of TCGA data." Nucleic acids research (2015): gkv1507.

* Mounir, Mohamed, Lucchetta, Marta, Silva, C T, Olsen, Catharina, Bontempi, Gianluca, Chen, Xi, Noushmehr, Houtan, Colaprico, Antonio, Papaleo, Elena (2019). “New functionalities in the TCGAbiolinks package for the study and integration of cancer data from GDC and GTEx.” PLoS computational biology, 15(3), e1006701.

* Silva TC, Colaprico A, Olsen C et al.TCGA Workflow: Analyze cancer genomics and epigenomics data using Bioconductor packages [version 2; peer review: 1 approved, 2 approved with reservations]. F1000Research 2016, 5:1542
(https://doi.org/10.12688/f1000research.8923.2)

[![doi](https://img.shields.io/badge/doi-10.1093/nar/gkv1507-green.svg?style=flat)](http://dx.doi.org/10.1093/nar/gkv1507) [![citation](https://img.shields.io/badge/cited%20by-1151-green.svg?style=flat)](https://scholar.google.com.hk/scholar?oi=bibs&hl=en&cites=15937881581405647591) [![Altmetric](https://img.shields.io/badge/Altmetric-44-green.svg?style=flat)](https://www.altmetric.com/details/4919535)

Also, if you have used ELMER analysis please cite:

* Yao, L., Shen, H., Laird, P. W., Farnham, P. J., & Berman, B. P. "Inferring regulatory element landscapes and transcription factor networks from cancer methylomes." Genome Biol 16 (2015): 105.
* Yao, Lijing, Benjamin P. Berman, and Peggy J. Farnham. "Demystifying the secret mission of enhancers: linking distal regulatory elements to target genes." Critical reviews in biochemistry and molecular biology 50.6 (2015): 550-573.
* Tiago C Silva, Simon G Coetzee, Nicole Gull, Lijing Yao, Dennis J Hazelett, Houtan Noushmehr, De-Chen Lin, Benjamin P Berman, ELMER v.2: an R/Bioconductor package to reconstruct gene regulatory networks from DNA methylation and transcriptome profiles, Bioinformatics, Volume 35, Issue 11, 1 June 2019, Pages 1974–1977, https://doi.org/10.1093/bioinformatics/bty902

#' @title Prepare GDC data
#' @description
#'   Reads the data downloaded and prepare it into an R object
#' @param query A query for GDCquery function
#' @param save Save result as RData object?
#' @param save.filename Name of the file to be save if empty an automatic will be created
#' @param directory Directory/Folder where the data was downloaded. Default: GDCdata
#' @param summarizedExperiment Create a summarizedExperiment? Default TRUE (if possible)
#' @param remove.files.prepared Remove the files read? Default: FALSE
#' This argument will be considered only if save argument is set to true
#' @param add.gistic2.mut If a list of genes (gene symbol) is given, columns with gistic2 results from GDAC firehose (hg19)
#' and a column indicating if there is or not mutation in that gene (hg38)
#' (TRUE or FALSE - use the MAF file for more information)
#' will be added to the sample matrix in the summarized Experiment object.
#' @param mutant_variant_classification List of mutant_variant_classification that will be
#' consider a sample mutant or not. Default: "Frame_Shift_Del", "Frame_Shift_Ins",
#' "Missense_Mutation", "Nonsense_Mutation", "Splice_Site", "In_Frame_Del",
#' "In_Frame_Ins", "Translation_Start_Site", "Nonstop_Mutation"
#' @export
#' @examples
#' \dontrun{
#' query <- GDCquery(
#'   project = "TCGA-KIRP",
#'   data.category = "Simple Nucleotide Variation",
#'   data.type = "Masked Somatic Mutation"
#' )
#' GDCdownload(query, method = "api", directory = "maf")
#' maf <- GDCprepare(query, directory = "maf")
#'
#' }
#' @return A summarizedExperiment or a data.frame
#' @importFrom  S4Vectors DataFrame
#' @importFrom SummarizedExperiment metadata<-
#' @importFrom data.table setcolorder setnames
#' @importFrom GenomicRanges GRanges
#' @importFrom IRanges IRanges
#' @importFrom purrr map_chr
#' @author Tiago Chedraoui Silva
GDCprepare <- function(
        query,
        save = FALSE,
        save.filename,
        directory = "GDCdata",
        summarizedExperiment = TRUE,
        remove.files.prepared = FALSE,
        add.gistic2.mut = NULL,
        mutant_variant_classification = c(
            "Frame_Shift_Del",
            "Frame_Shift_Ins",
            "Missense_Mutation",
            "Nonsense_Mutation",
            "Splice_Site",
            "In_Frame_Del",
            "In_Frame_Ins",
            "Translation_Start_Site",
            "Nonstop_Mutation"
        )
){

    isServeOK()
    if(missing(query)) stop("Please set query parameter")

    test.duplicated.cases <- (
        any(
            duplicated(query$results[[1]]$cases)) & # any duplicated
            !(query$data.type %in% c(
                "Clinical data",
                "Protein expression quantification",
                "Raw intensities",
                "Masked Intensities",
                "Clinical Supplement",
                "Masked Somatic Mutation",
                "Biospecimen Supplement"
            )
            )
    )


    if(test.duplicated.cases) {
        dup <- query$results[[1]]$cases[duplicated(query$results[[1]]$cases)]
        cols <- c("tags","cases","experimental_strategy","analysis_workflow_type")
        cols <- cols[cols %in% colnames(query$results[[1]])]
        dup <- query$results[[1]][query$results[[1]]$cases %in% dup,cols]
        dup <- dup[order(dup$cases),]
        print(knitr::kable(dup))
        stop("There are samples duplicated. We will not be able to prepare it")
    }

    if (!save & remove.files.prepared) {
        stop("To remove the files, please set save to TRUE. Otherwise, the data will be lost")
    }

    # We save the files in project/data.category/data.type/file_id/file_name
    files <- file.path(
        query$results[[1]]$project,
        gsub(" ","_",query$results[[1]]$data_category),
        gsub(" ","_",query$results[[1]]$data_type),
        gsub(" ","_",query$results[[1]]$file_id),
        gsub(" ","_",query$results[[1]]$file_name)
    )

    files <- file.path(directory, files)

    # For IDAT prepare since we need to put all IDATs in the same folder the code below will not work
    # a second run
    if (!all(file.exists(files))) {
        # We have to check we moved the files
        if (
            unique(query$results[[1]]$data_type) == "Masked Intensities" |
            unique(query$results[[1]]$data_category) == "Raw microarray data"
        ){

            files.idat <- file.path(
                query$results[[1]]$project,
                gsub(" ","_",query$results[[1]]$data_category),
                gsub(" ","_",query$results[[1]]$data_type),
                gsub(" ","_",query$results[[1]]$file_name)
            )

            files.idat <- file.path(directory, files.idat)
            if (!all(file.exists(files) | file.exists(files.idat))) {
                stop(
                    paste0(
                        "I couldn't find all the files from the query. ",
                        "Please check if the directory parameter is right ",
                        "or `GDCdownload` downloaded the samples."
                    )
                )
            }
        } else {
            stop(
                paste0(
                    "I couldn't find all the files from the query. ",
                    "Please check if the directory parameter is right ",
                    "or `GDCdownload` downloaded the samples."
                )
            )
        }
    }

    cases <- ifelse(
        grepl("TCGA|TARGET|CGCI-HTMCP-CC|CPTAC-2|BEATAML1.0-COHORT",query$results[[1]]$project %>% unlist()),
        query$results[[1]]$cases,
        query$results[[1]]$sample.submitter_id
    )

    if (grepl("Transcriptome Profiling", query$data.category, ignore.case = TRUE)){

        if(unique(query$results[[1]]$experimental_strategy) == "scRNA-Seq"){
            #if (grepl("Single Cell Analysis", unique(query$results[[1]]$data_type), ignore.case = TRUE)){

            data <- readSingleCellAnalysis(
                files = files,
                data_format = unique(query$results[[1]]$data_format),
                workflow.type = unique(query$results[[1]]$analysis_workflow_type),
                cases = cases
            )
            return(data)
        } else {
            data <- readTranscriptomeProfiling(
                files = files,
                data.type = ifelse(!is.na(query$data.type),  as.character(query$data.type),  unique(query$results[[1]]$data_type)),
                workflow.type = unique(query$results[[1]]$analysis_workflow_type),
                cases = cases,
                summarizedExperiment
            )
        }
    } else if(grepl("Copy Number Variation",query$data.category,ignore.case = TRUE)) {
        if (unique(query$results[[1]]$data_type) == "Gene Level Copy Number Scores") {
            data <- readGISTIC(files, query$results[[1]]$cases)
        } else if (unique(query$results[[1]]$data_type) == "Gene Level Copy Number") {
            data <- read_gene_level_copy_number(
                files = files,
                cases = query$results[[1]]$sample.submitter_id,
                summarizedExperiment = summarizedExperiment
            )
        } else {
            data <- read_copy_number_variation(
                files = files, cases = query$results[[1]]$cases
            )
        }
    }  else if (grepl("Methylation Beta Value",unique(query$results[[1]]$data_type), ignore.case = TRUE)) {
        data <- readDNAmethylation(
            files = files,
            cases = cases,
            summarizedExperiment = summarizedExperiment,
            platform =  unique(query$results[[1]]$platform)
        )
    }  else if (grepl("Raw intensities|Masked Intensities",query$data.type, ignore.case = TRUE)) {
        # preparing IDAT files
        data <- readIDATDNAmethylation(
            files = files,
            barcode = cases,
            summarizedExperiment = summarizedExperiment,
            platform =  unique(query$results[[1]]$platform)
        )
    } else if (grepl("Proteome Profiling",query$data.category,ignore.case = TRUE)) {

        data <- readProteomeProfiling(files, cases = cases)

    } else if (grepl("Protein expression",query$data.category,ignore.case = TRUE)) {

        data <- readProteinExpression(files, cases = cases)

        if (summarizedExperiment) {
            message("SummarizedExperiment not implemented, if you need samples metadata use the function TCGAbiolinks:::colDataPrepare")
        }

    }  else if (grepl("Simple Nucleotide Variation",query$data.category,ignore.case = TRUE)) {

        if (grepl("Masked Somatic Mutation",query$results[[1]]$data_type[1],ignore.case = TRUE)){
            data <- readSimpleNucleotideVariationMaf(files)
        }

    }  else if (grepl("Clinical|Biospecimen", query$data.category, ignore.case = TRUE)){
        data <- read_clinical(files, query$data.type, cases = cases)
        summarizedExperiment <- FALSE
    } else if (grepl("Gene expression",query$data.category,ignore.case = TRUE)) {
        if (query$data.type == "Gene expression quantification")
            data <- read_gene_expression_quantification(
                files = files,
                cases = cases,
                summarizedExperiment = summarizedExperiment,
                genome = "hg38",
                experimental.strategy = unique(query$results[[1]]$experimental_strategy)
            )

        if (query$data.type == "miRNA gene quantification")
            data <- read_gene_expression_quantification(
                files = files,
                cases = cases,
                summarizedExperiment = FALSE,
                genome = "hg38",
                experimental.strategy = unique(query$results[[1]]$experimental_strategy)
            )

        if (query$data.type == "miRNA isoform quantification")
            data <- readmiRNAIsoformQuantification(
                files = files,
                cases = query$results[[1]]$cases
            )

        if (query$data.type == "Isoform expression quantification")
            data <- readIsoformExpressionQuantification(files = files, cases = cases)

        if (query$data.type == "Exon quantification")
            data <- readExonQuantification(
                files = files,
                cases = cases,
                summarizedExperiment = summarizedExperiment
            )

    }
    # Add data release to object
    if (summarizedExperiment & !is.data.frame(data)) {
        metadata(data) <- list("data_release" = getGDCInfo()$data_release)
    }


    if ((!is.null(add.gistic2.mut)) & summarizedExperiment) {
        message("=> Adding GISTIC2 and mutation information....")
        genes <- tolower(levels(EAGenes$Gene))
        if (!all(tolower(add.gistic2.mut) %in% genes)) {
            message(
                paste("These genes were not found:\n",
                      paste(add.gistic2.mut[! tolower(add.gistic2.mut) %in% genes],collapse = "\n=> ")
                )
            )
        }
        add.gistic2.mut <- add.gistic2.mut[tolower(add.gistic2.mut) %in% tolower(genes)]
        if (length(add.gistic2.mut) > 0){
            info <- colData(data)
            for(i in unlist(query$project)){
                info <- get.mut.gistc.information(
                    info,
                    i,
                    add.gistic2.mut,
                    mutant_variant_classification = mutant_variant_classification
                )
            }
            colData(data) <- info
        }
    }
    if("samples" %in% colnames(data)){
        if(any(duplicated(data$sample))) {
            message("Replicates found.")
            if(any(data$is_ffpe)) message("FFPE should be removed. You can modify the data with the following command:\ndata <- data[,!data$is_ffpe]")
            print(as.data.frame(colData(data)[data$sample %in% data$sample[duplicated(data$sample)],c("is_ffpe"),drop = FALSE]))
        }
    }


    if(save){
        if(missing(save.filename) & !missing(query)) save.filename <- paste0(query$project,gsub(" ","_", query$data.category),gsub(" ","_",date()),".RData")
        message(paste0("=> Saving file: ",save.filename))
        save(data, file = save.filename)
        message("=> File saved")

        # save is true, due to the check in the beggining of the code
        if(remove.files.prepared){
            # removes files and empty directories
            remove_files_recursively(files)
        }
    }

    return(data)
}

remove_files_recursively <- function(files){
    files2rm <- dirname(files)
    unlink(files2rm,recursive = TRUE)
    files2rm <- dirname(files2rm) # data category
    if(length(list.files(files2rm)) == 0) remove_files_recursively(files2rm)
}


read_clinical <- function(files, data.type, cases){
    if(data.type == "Clinical data"){
        suppressMessages({
            ret <- plyr::alply(files,.margins = 1,readr::read_tsv, .progress = "text")
        })
        names(ret) <- gsub("nationwidechildrens.org_","",gsub(".txt","",basename(files)))
    } else if(data.type %in% c("Clinical Supplement","Biospecimen Supplement")){
        ret <- plyr::alply(files,.margins = 1,function(f) {
            readr::read_tsv(f,col_types = readr::cols())
        }, .progress = "text")
        names(ret) <- gsub("nationwidechildrens.org_","",gsub(".txt","",basename(files)))
    }
    return(ret)
}


readSingleCellAnalysis <- function(
        files = files,
        data_format = NULL,
        workflow.type = NULL,
        cases = cases
) {

    if(data_format == "MEX" & workflow.type == "CellRanger - 10x Filtered Counts"){
        check_package("Seurat")
        ret <- plyr::llply(files,.fun = function(f){
            untar(tarfile = f,exdir = dirname(f))
            Seurat::Read10X(data.dir = gsub("\\.tar\\.gz","",f))
        },.progress = "time")
        names(ret) <- cases
    }

    if(data_format == "MEX" & workflow.type == "CellRanger - 10x Raw Counts"){
        ret <- plyr::llply(files,.fun = function(f){
            # uncompress raw file
            untar(tarfile = f,exdir = dirname(f))
            Read10X(data.dir = gsub("\\.tar\\.gz","",f))
        },.progress = "time")
        names(ret) <- cases
    }
    # TSV files
    if(data_format == "TSV"){
        ret <- plyr::llply(files,.fun = function(f){
            readr::read_tsv(f)
        },.progress = "time")
        names(ret) <- cases
    }

    if(data_format == "HDF5"){

        stop("We are not preparing loom files")
        # check_package("SeuratDisk")
        # check_package("Seurat")
        # ret <- SeuratDisk::Connect(filename = files, mode = "r")
        # ret <- Seurat::as.Seurat(ret)
        print(files)
    }

    # HDF5
    return(ret)
}

#' @importFrom tidyr separate
readExonQuantification <- function (
        files,
        cases,
        summarizedExperiment = TRUE
){
    pb <- txtProgressBar(min = 0, max = length(files), style = 3)
    assay.list <- NULL

    for (i in seq_along(files)) {
        data <- fread(files[i], header = TRUE, sep = "\t", stringsAsFactors = FALSE)

        if(!missing(cases)) {
            assay.list <- gsub(" |\\(|\\)|\\/","_",colnames(data)[2:ncol(data)])
            # We will use this because there might be more than one col for each samples
            setnames(data,colnames(data)[2:ncol(data)],
                     paste0(gsub(" |\\(|\\)|\\/","_",colnames(data)[2:ncol(data)]),"_",cases[i]))
        }
        if (i == 1) {
            df <- data
        } else {
            df <- merge(df, data, by=colnames(data)[1], all = TRUE)
        }

        setTxtProgressBar(pb, i)
    }
    setDF(df)
    rownames(df) <- df[,1]
    df <- df %>% separate(exon,into = c("seqnames","coordinates","strand"),sep = ":") %>%
        separate(coordinates,into = c("start","end"),sep = "-")

    if(summarizedExperiment) {
        suppressWarnings({
            assays <- lapply(assay.list, function (x) {
                return(data.matrix(subset(df, select = grep(x,colnames(df),ignore.case = TRUE))))
            })
        })
        names(assays) <- assay.list
        regex <- paste0(
            "[:alnum:]{4}-[:alnum:]{2}-[:alnum:]{4}",
            "-[:alnum:]{3}-[:alnum:]{3}-[:alnum:]{4}-[:alnum:]{2}"
        )
        samples <- na.omit(unique(str_match(colnames(df),regex)[,1]))
        colData <-  colDataPrepare(samples)
        assays <- lapply(assays, function(x){
            colnames(x) <- NULL
            rownames(x) <- NULL
            return(x)
        })
        rowRanges <- makeGRangesFromDataFrame(df)
        message("Available assays in SummarizedExperiment : \n  => ",paste(names(assays), collapse = "\n  => "))
        rse <- SummarizedExperiment(
            assays = assays,
            rowRanges = rowRanges,
            colData = colData
        )
        return(rse)
    }
    return(df)

}
readIsoformExpressionQuantification <- function (files, cases){
    pb <- txtProgressBar(min = 0, max = length(files), style = 3)

    for (i in seq_along(files)) {
        data <- fread(files[i], header = TRUE, sep = "\t", stringsAsFactors = FALSE)

        if(!missing(cases)) {
            assay.list <- gsub(" |\\(|\\)|\\/","_",colnames(data)[2:ncol(data)])
            # We will use this because there might be more than one col for each samples
            setnames(data,colnames(data)[2:ncol(data)],
                     paste0(gsub(" |\\(|\\)|\\/","_",colnames(data)[2:ncol(data)]),"_",cases[i]))
        }
        if (i == 1) {
            df <- data
        } else {
            df <- merge(df, data, by=colnames(data)[1], all = TRUE)
        }
        setTxtProgressBar(pb, i)
    }
    setDF(df)
    rownames(df) <- df[,1]
    df[,1] <- NULL
    return(df)

}
readmiRNAIsoformQuantification <- function (files, cases){
    pb <- txtProgressBar(min = 0, max = length(files), style = 3)

    for (i in seq_along(files)) {
        data <- fread(files[i], header = TRUE, sep = "\t", stringsAsFactors = FALSE)
        data$barcode <- cases[i]
        if (i == 1) {
            df <- data
        } else {
            df <- rbind(df, data)
        }
        setTxtProgressBar(pb, i)
    }
    setDF(df)

}

readSimpleNucleotideVariationMaf <- function(files){

    ret <- files |>
        purrr::map_dfr(.f = function(x) {
            tab <- readr::read_tsv(
                x,
                show_col_types = FALSE,
                comment = "#",
                col_types = readr::cols(
                    SOMATIC =  col_character(),
                    PUBMED = col_character(),
                    miRNA = col_character(),
                    HGVS_OFFSET = col_integer(),
                    PHENO = col_character(),
                    Entrez_Gene_Id = col_integer(),
                    Start_Position = col_integer(),
                    End_Position = col_integer(),
                    t_depth = col_integer(),
                    t_ref_count = col_integer(),
                    t_alt_count = col_integer(),
                    n_depth = col_integer(),
                    TRANSCRIPT_STRAND = col_integer(),
                    PICK = col_integer(),
                    TSL = col_integer(),
                    Allele =  col_character(),
                    Tumor_Seq_Allele1 =  col_character(),
                    Reference_Allele = col_character(),
                    Tumor_Seq_Allele2 = col_character(),
                    DISTANCE = col_integer()
                ))

            # empty MAF file
            # https://portal.gdc.cancer.gov/files/7917fcbe-cb66-447d-8ea8-3a324feee3fa
            if(nrow(tab) == 0) {return (NULL)}
            tab
        })

    return(ret)
}

read_gene_expression_quantification <- function(
        files,
        cases,
        genome = "hg19",
        summarizedExperiment = TRUE,
        experimental.strategy,
        platform
){
    skip <- unique((ifelse(experimental.strategy == "Gene expression array",1,0)))

    if(length(skip) > 1) stop("It is not possible to handle those different platforms together")

    print.header(paste0("Reading ", length(files)," files"),"subsection")
    ret <- plyr::alply(
        .data = seq_along(files),
        .margins = 1,
        .fun = function(i,cases){

            data <- fread(
                input = files[i],
                header = TRUE,
                sep = "\t",
                stringsAsFactors = FALSE,
                skip = skip
            )

            if(!missing(cases)) {
                assay.list <<- gsub(" |\\(|\\)|\\/","_",colnames(data)[2:ncol(data)])
                # We will use this because there might be more than one col for each samples
                setnames(
                    data,
                    colnames(data)[2:ncol(data)],
                    paste0(gsub(" |\\(|\\)|\\/","_",colnames(data)[2:ncol(data)]),"_",cases[i])
                )
            }
            data
        },.progress = "time",cases = cases)

    print.header(paste0("Merging ", length(files)," files"),"subsection")

    # Just check if the data is in the same order, since we will not merge
    # the data frames to save memory
    stopifnot(all(unlist(ret %>% map(function(y){all(y[,1] ==  ret[[1]][,1])}) )))

    # need to check if it works in all cases
    df <- ret %>% map( ~ (.x %>% dplyr::select(-1))) %>% bind_cols()
    df <- bind_cols(ret[[1]][,1],df)

    if (summarizedExperiment) {
        df <- make_se_from_gene_exoression_quantification(df, assay.list, genome = genome)
    } else {
        rownames(df) <- df$gene_id
        df$gene_id <- NULL
    }
    return(df)
}


make_se_from_gene_exoression_quantification <- function(
        df,
        assay.list,
        genome = "hg19"
){

    # Access genome information to create SE
    gene.location <- get.GRCh.bioMart(genome)

    if(all(grepl("\\|",df[[1]]))){
        aux <- strsplit(df$gene_id,"\\|")
        GeneID <- unlist(lapply(aux,function(x) x[2]))
        df$entrezgene_id <- as.numeric(GeneID)
        gene.location <- gene.location[!duplicated(gene.location$entrezgene_id),]
        df <- merge(df, gene.location, by = "entrezgene_id")
    } else {
        df$external_gene_name <- as.character(df[[1]])
        df <- merge(df, gene.location, by = "external_gene_name")
    }


    if("transcript_id" %in% assay.list){
        rowRanges <- GRanges(
            seqnames = paste0("chr", df$chromosome_name),
            ranges = IRanges(start = df$start_position,
                             end = df$end_position),
            strand = df$strand,
            gene_id = df$external_gene_name,
            entrezgene = df$entrezgene_id,
            ensembl_gene_id = df$ensembl_gene_id,
            transcript_id = subset(df, select = 5)
        )
        names(rowRanges) <- as.character(df$gene_id)
        assay.list <- assay.list[which(assay.list != "transcript_id")]
    } else {
        rowRanges <- GRanges(
            seqnames = paste0("chr", df$chromosome_name),
            ranges = IRanges(
                start = df$start_position,
                end = df$end_position
            ),
            strand = df$strand,
            gene_id = df$external_gene_name,
            entrezgene = df$entrezgene_id,
            ensembl_gene_id = df$ensembl_gene_id
        )
        names(rowRanges) <- as.character(df$external_gene_name)
    }

    suppressWarnings({
        assays <- lapply(assay.list, function(x) {
            return(
                data.matrix(
                    subset(df, select = grep(x,colnames(df),ignore.case = TRUE))
                )
            )
        })
    })

    names(assays) <- assay.list
    regex <- paste0("[:alnum:]{4}-[:alnum:]{2}-[:alnum:]{4}",
                    "-[:alnum:]{3}-[:alnum:]{3}-[:alnum:]{4}-[:alnum:]{2}")
    samples <- na.omit(unique(str_match(colnames(df),regex)[,1]))
    colData <-  colDataPrepare(samples)

    assays <- lapply(assays, function(x){
        colnames(x) <- NULL
        rownames(x) <- NULL
        return(x)
    })

    message("Available assays in SummarizedExperiment : \n  => ",paste(names(assays), collapse = "\n  => "))
    rse <- SummarizedExperiment(
        assays = assays,
        rowRanges = rowRanges,
        colData = colData
    )
    return(rse)
}


#' @importFrom downloader download
#' @importFrom S4Vectors DataFrame
makeSEFromDNAMethylationMatrix <- function(
        betas,
        genome = "hg38",
        met.platform = c(
            "Illumina Human Methylation 450",
            "Illumina Human Methylation 27",
            "Illumina Methylation Epic"
        )
) {
    message("=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-")
    message("Creating a SummarizedExperiment from DNA methylation input")

    # Instead of looking on the size, it is better to set it as a argument as the annotation is different
    annotation <-   getMetPlatInfo(platform = met.platform, genome = genome)

    rowRanges <- annotation[names(annotation) %in% rownames(betas),,drop = FALSE]

    colData <- tryCatch({
        colDataPrepare(colnames(betas))
    }, error = function(e){
        DataFrame(samples = colnames(betas))
    })
    betas <- betas[rownames(betas) %in% names(rowRanges),,drop = FALSE]
    betas <- betas[names(rowRanges),,drop = FALSE]
    assay <- data.matrix(betas)

    betas <- SummarizedExperiment(
        assays = assay,
        rowRanges = rowRanges,
        colData = colData
    )
    return(betas)
}

makeSEfromDNAmethylation <- function(df, probeInfo = NULL){
    if(is.null(probeInfo)) {
        rowRanges <- GRanges(
            seqnames = paste0("chr", df$Chromosome),
            ranges = IRanges(start = df$Genomic_Coordinate,
                             end = df$Genomic_Coordinate),
            probeID = df$Composite.Element.REF,
            Gene_Symbol = df$Gene_Symbol
        )

        names(rowRanges) <- as.character(df$Composite.Element.REF)
        colData <-  colDataPrepare(colnames(df)[5:ncol(df)])
        assay <- data.matrix(subset(df,select = c(5:ncol(df))))
    } else {
        rowRanges <- makeGRangesFromDataFrame(probeInfo, keep.extra.columns = TRUE)
        colData <-  colDataPrepare(colnames(df)[(ncol(probeInfo) + 1):ncol(df)])
        assay <- data.matrix(subset(df,select = c((ncol(probeInfo) + 1):ncol(df))))
    }
    colnames(assay) <- rownames(colData)
    rownames(assay) <- as.character(df$Composite.Element.REF)
    rse <- SummarizedExperiment(assays = assay, rowRanges = rowRanges, colData = colData)
}

readIDATDNAmethylation <- function(
        files,
        barcode,
        summarizedExperiment,
        platform
) {

    check_package("sesame")

    # Check if moved files would be moved outside of scope folder, if so, path doesn't change
    moved.files <- sapply(files,USE.NAMES = FALSE,function(x){
        if (grepl("Raw_intensities|Masked_Intensities",dirname(dirname(x)))) {
            return(file.path(dirname(dirname(x)), basename(x)))
        }
        return(x)
    })

    # for each file move it to upper parent folder if necessary
    plyr::a_ply(files, 1,function(x){
        if (grepl("Raw_intensities|Masked_Intensities",dirname(dirname(x)))) {
            tryCatch(
                move(x,
                     file.path(dirname(dirname(x)), basename(x)),
                     keep.copy = FALSE
                ),
                error = function(e){
                })
        }
    })

    samples <- unique(gsub("_Grn.idat|_Red.idat","",moved.files))
    message("Processing  IDATs with Sesame - http://bioconductor.org/packages/sesame/")
    message("Running opensesame - applying quality masking and nondetection masking (threshold P-value 0.05)")
    message("Please cite: doi: 10.1093/nar/gky691 and 10.1093/nar/gkt090")
    message("This might take a while....")
    betas <- sesame::openSesame(samples)  %>% as.matrix
    barcode <- unique(data.frame("file" = gsub("_Grn.idat|_Red.idat","",basename(moved.files)), "barcode" = barcode))
    colnames(betas) <- barcode$barcode[match(basename(samples),barcode$file)]

    if (summarizedExperiment) {

        betas <- makeSEFromDNAMethylationMatrix(
            betas = betas,
            genome ="hg38",
            met.platform = platform
        )
        colData(betas) <- DataFrame(colDataPrepare(colnames(betas)))
    }
    return(betas)

}

# We will try to make this function easier to use this function in its own data
# In case it is not TCGA I should not consider that there is a barcode in the header
# Instead the user should be able to add the names to his data
# The only problem is that the data from the user will not have all the columns
# TODO: Improve this function to be more generic as possible
#' @importFrom GenomicRanges makeGRangesFromDataFrame
#' @importFrom tibble as_data_frame
#' @importFrom data.table fread
readDNAmethylation <- function(
        files,
        cases,
        summarizedExperiment = TRUE,
        platform
){
    if(length(platform) > 1){

        print(knitr::kable(platform))
        stop("More than one DNA methylation platform found. Only one is accepted")
    }
    if (missing(cases)) cases <- NULL


    if (grepl("OMA00",platform)) {
        pb <- txtProgressBar(min = 0, max = length(files), style = 3)
        for (i in seq_along(files)) {
            data <- fread(
                files[i],
                header = TRUE,
                sep = "\t",
                stringsAsFactors = FALSE,
                skip = 1,
                na.strings = "N/A",
                colClasses = c(
                    "character", # Composite Element REF
                    "numeric" # # beta value
                )
            )
            setnames(data,gsub(" ", "\\.", colnames(data)))
            if (!is.null(cases)) setnames(data,2,cases[i])
            if (i == 1) {
                df <- data
            } else {
                df <- merge(df, data, by = "Composite.Element.REF")
            }
            setTxtProgressBar(pb, i)
        }
        setDF(df)
        rownames(df) <- df$Composite.Element.REF
        df$Composite.Element.REF <- NULL
    } else if (all(grepl("methylation_array.sesame.level3betas", files))){
        # methylation_array.sesame.level3betas has only two columns with not header
        print.header(paste0("Reading ", length(files)," files"),"subsection")

        x <- plyr::alply(files,1, function(f) {
            data <- fread(
                f,
                header = FALSE,
                sep = "\t",
                stringsAsFactors = FALSE,
                skip = 0,
                colClasses = c(
                    "character", # CpG
                    "numeric" # beta value
                )
            )
            setnames(data,gsub(" ", "\\.", colnames(data)))
            if (!is.null(cases)) setnames(data,2,cases[which(f == files)])
        }, .progress = "time")

        print.header(paste0("Merging ", length(files)," files"),"subsection")

        # Just check if the data is in the same order, since we will not merge
        # the data frames to save memory
        # C3N-01362-01 has less probes than C3L-00913-03 due to version of the array
        # CPTAC cohort: 55 samples with EPIC v1 and 1808  with EPIC V2
        # EPIC v1 has less probes than EPIC V2

        # In case we have multiple versions of the array we will
        # 1. Check the names of all of the same nrow
        # 2. Bind the ones with same nrow
        # 3. Full join the two objects
        nrow_vec <- purrr::map_int(x,nrow) # number of rows each file
        nrow_vec_numbers <- nrow_vec %>% unique # unique number of rows

        for(nb_rows in nrow_vec_numbers){
            aux <- x[which(nrow_vec == nb_rows)]
            stopifnot(all(unlist(aux %>% map(function(y){all(y[,1]$V1 ==  aux[[1]][,1]$V1)}) )))
        }

        df <- map(nrow_vec_numbers,.f = function(nb_rows){
            file_equal_probes <- x[which(nrow_vec == nb_rows)]
            df <- file_equal_probes %>% map_df(2)
            colnames(df) <- file_equal_probes %>% map_chr(.f = function(y) colnames(y)[2])
            df$V1 <- file_equal_probes[[1]]$V1
            if (any(duplicated(colnames(df)))){
                message("oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo")
                message("Duplicated samples names were found. Adding _rep suffix to name")
                message("oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo")
            }
            colnames(df)[duplicated(colnames(df))] <- paste0(colnames(df)[duplicated(colnames(df))],"_rep")
            df
        }) %>% purrr::reduce(dplyr::full_join,by = "V1") %>% as.data.frame()
        rownames(df) <- df$V1
        df$V1 <- NULL
        df <- data.matrix(df)

        if (summarizedExperiment) {

            df <- makeSEFromDNAMethylationMatrix(
                betas = df,
                genome = "hg38",
                met.platform = platform
            )
        }

    } else {
        skip <- ifelse(all(grepl("hg38",files)), 0,1)
        colClasses <- NULL
        if (!all(grepl("hg38",files))) {
            colClasses <- c(
                "character", # Composite Element REF
                "numeric",   # beta value
                "character", # Gene symbol
                "character", # Chromosome
                "integer"
            )
        }


        x <- plyr::alply(files,1, function(f) {
            data <- fread(
                f,
                header = TRUE,
                sep = "\t",
                stringsAsFactors = FALSE,
                skip = skip,
                colClasses = colClasses
            )
            setnames(data,gsub(" ", "\\.", colnames(data)))
            if (!is.null(cases)) setnames(data,2,cases[which(f == files)])
            setcolorder(data,c(1, 3:ncol(data), 2))
        }, .progress = "time")


        print.header(paste0("Merging ", length(files)," files"),"subsection")

        # Just check if the data is in the same order, since we will not merge
        # the data frames to save memory
        stopifnot(all(unlist(x %>% map(function(y){all(y[,1] ==  x[[1]][,1])}) )))

        # if hg38 we have 10 columns with probe metadata
        # if hg19 we have 4 columns with probe metadata
        idx.dnam <- grep("TCGA",colnames(x[[1]]))
        df <- x %>%  map_df(idx.dnam)
        colnames(df) <- x %>%  map_chr(.f = function(y) colnames(y)[idx.dnam])
        df <- bind_cols(x[[1]][,1:(idx.dnam-1)],df)

        if (summarizedExperiment) {
            if(skip == 0) {
                df <- makeSEfromDNAmethylation(
                    df,
                    probeInfo = data.frame(df)[,grep("TCGA",colnames(df),invert = TRUE)]
                )
            } else {
                df <- makeSEfromDNAmethylation(df)
            }
        } else {
            setDF(df)
            rownames(df) <- df$Composite.Element.REF
            df$Composite.Element.REF <- NULL
        }
    }
    return(df)
}

# Barcode example MMRF_1358_1_BM_CD138pos_T1_TSMRU_L02337
colDataPrepareMMRF <- function(
        barcode
){
    DataFrame(
        barcode = barcode,
        sample = barcode,
        patient = substr(barcode,1,9)
    )
}

colDataPrepareTARGET <- function(
        barcode
){

    message("Adding description to TARGET samples")
    tissue.code <- c(
        '01',
        '02',
        '03',
        '04',
        '05',
        '06',
        '07',
        '08',
        '09',
        '10',
        '11',
        '12',
        '13',
        '14',
        '15',
        '16',
        '17',
        '20',
        '40',
        '41',
        '42',
        '50',
        '60',
        '61',
        '85',
        '99'
    )

    definition <- c(
        "Primary solid Tumor", # 01
        "Recurrent Solid Tumor", # 02
        "Primary Blood Derived Cancer - Peripheral Blood", # 03
        "Recurrent Blood Derived Cancer - Bone Marrow", # 04
        "Additional - New Primary", # 05
        "Metastatic", # 06
        "Additional Metastatic", # 07
        "Tissue disease-specific post-adjuvant therapy", # 08
        "Primary Blood Derived Cancer - Bone Marrow", # 09
        "Blood Derived Normal", # 10
        "Solid Tissue Normal",  # 11
        "Buccal Cell Normal",   # 12
        "EBV Immortalized Normal", # 13
        "Bone Marrow Normal", # 14
        "Fibroblasts from Bone Marrow Normal", # 15
        "Mononuclear Cells from Bone Marrow Normal", # 16
        "Lymphatic Tissue Normal (including centroblasts)", # 17
        "Control Analyte", # 20
        "Recurrent Blood Derived Cancer - Peripheral Blood", # 40
        "Blood Derived Cancer- Bone Marrow, Post-treatment", # 41
        "Blood Derived Cancer- Peripheral Blood, Post-treatment", # 42
        "Cell line from patient tumor", # 50
        "Xenograft from patient not grown as intermediate on plastic tissue culture dish", # 60
        "Xenograft grown in mice from established cell lines", #61
        "Next Generation Cancer Model", # 85
        "Granulocytes after a Ficoll separation"
    ) # 99
    aux <- data.frame(tissue.code = tissue.code,definition)

    # Exceptions: TARGET-AML
    # "TARGET-20-PAYKXV-Sorted-CD34neg-Lymphoid-09A" 727f5e27-09e9-425f-9757-81da66c054bd
    # "TARGET-20-PAWUEX-EOI2-14A"  11fb7cce-06ad-445b-b09f-9dc1050e4cd4
    # "TARGET-20-PAUSTZ-EOI1-14A" 3ad6dfa7-734d-41b0-ad66-15f0cff630d0
    # "TARGET-20-PAYHMK-Sorted-leukemic-09A" f5bd72ae-919f-481c-8203-f878ee1c651a
    # "TARGET-20-D7-Myeloid-mock3-85" 88712125-67e5-4e47-a413-e55b522a641c
    # Normal case: TARGET-20-PANLXK-09A-03R
    # in case multiple equal barcode
    #regex <- paste0("[:alnum:]{6}-[:alnum:]{2}-[:alnum:]{6}",
    #                "-[:alnum:]{3}-[:alnum:]{3}")
    #samples <- str_match(barcode,regex)[,1]

    # this breaks for the exceptions
    if(!any(grepl(";",barcode))){
        ret <- data.frame(
            barcode = barcode,
            tumor.code = stringr::str_extract(pattern = "TARGET-[[:alnum:]]{2}",barcode) %>% gsub(pattern = "TARGET-","",.),
            sample = gsub(pattern = "-[[:alnum:]]{3}$","",barcode),
            patient = gsub(pattern = "-[[:alnum:]]{2,3}-[[:alnum:]]{3}$","",barcode),
            case.unique.id = gsub(pattern = "-[[:alnum:]]{2,3}-[[:alnum:]]{3}$","",barcode) %>%  gsub(pattern = "TARGET-[[:alnum:]]{2}-","",.),
            tissue.code = barcode %>% stringr::str_extract("[[:alnum:]]{2,3}-[[:alnum:]]{3}$") %>% stringr::str_extract("[[:alnum:]]{2,3}") %>% stringr::str_sub(1,2),
            nucleic.acid.code = barcode %>% stringr::str_extract("[[:alnum:]]{3}$")  %>% stringr::str_sub(3,3)
        )
    } else {
        # mixed samples case
        ret <- purrr::map_dfr(.x = barcode,.f = function(b){
            data.frame(
                barcode = b,
                tumor.code = stringr::str_extract(pattern = "TARGET-[[:alnum:]]{2}",b) %>% gsub(pattern = "TARGET-","",.),
                sample = b %>% stringr::str_split(";") %>% unlist %>% sapply(FUN = function(y) gsub(pattern = "-[[:alnum:]]{3}$","",y)) %>% paste0(collapse = ";"),
                patient = b %>% stringr::str_split(";") %>% unlist %>% sapply(FUN = function(y)  gsub(pattern = "-[[:alnum:]]{2,3}-[[:alnum:]]{3}$","",y)) %>% paste0(collapse = ";"),
                case.unique.id = b %>% stringr::str_split(";") %>% unlist %>% sapply(FUN = function(y)  gsub(pattern = "-[[:alnum:]]{2,3}-[[:alnum:]]{3}$","",y)  %>%  gsub(pattern = "TARGET-[[:alnum:]]{2}-","",.) %>% paste0(collapse = ";")),
                tissue.code = b %>% stringr::str_extract("[[:alnum:]]{2,3}-[[:alnum:]]{3}$") %>% stringr::str_extract("[[:alnum:]]{2,3}") %>% stringr::str_sub(1,2),
                nucleic.acid.code = b %>% stringr::str_extract("[[:alnum:]]{3}$")  %>% stringr::str_sub(3,3)
            )
        })
    }
    ret <-  ret %>% dplyr::left_join(aux, by = "tissue.code")

    tumor.code <- c('00','01','02','03','04','10','15','20','21','30','40',
                    '41','50','51','52','60','61','62','63','64','65','70','71','80','81')

    tumor.definition <- c(
        "Non-cancerous tissue", # 00
        "Diffuse Large B-Cell Lymphoma (DLBCL)", # 01
        "Lung Cancer (all types)", # 02
        "Cervical Cancer (all types)", # 03
        "Anal Cancer (all types)", # 04
        "Acute lymphoblastic leukemia (ALL)", # 10
        "Mixed phenotype acute leukemia (MPAL)", # 15
        "Acute myeloid leukemia (AML)", # 20
        "Induction Failure AML (AML-IF)", # 21
        "Neuroblastoma (NBL)", # 30
        "Osteosarcoma (OS)",  # 40
        "Ewing sarcoma",   # 41
        "Wilms tumor (WT)", # 50
        "Clear cell sarcoma of the kidney (CCSK)", # 51
        "Rhabdoid tumor (kidney) (RT)", # 52
        "CNS, ependymoma", # 60
        "CNS, glioblastoma (GBM)", # 61
        "CNS, rhabdoid tumor", # 62
        "CNS, low grade glioma (LGG)", # 63
        "CNS, medulloblastoma", # 64
        "CNS, other", # 65
        "NHL, anaplastic large cell lymphoma", # 70
        "NHL, Burkitt lymphoma (BL)", # 71
        "Rhabdomyosarcoma", #80
        "Soft tissue sarcoma, non-rhabdomyosarcoma"
    ) # 81
    aux <- data.frame(tumor.code = tumor.code,tumor.definition)
    ret <- ret %>% dplyr::left_join(aux, by = "tumor.code")

    nucleic.acid.code <- c('D','E','W','X','Y','R','S')
    nucleic.acid.description <-  c(
        "DNA, unamplified, from the first isolation of a tissue",
        "DNA, unamplified, from the first isolation of a tissue embedded in FFPE",
        "DNA, whole genome amplified by Qiagen (one independent reaction)",
        "DNA, whole genome amplified by Qiagen (a second, separate independent reaction)",
        "DNA, whole genome amplified by Qiagen (pool of 'W' and 'X' aliquots)",
        "RNA, from the first isolation of a tissue",
        "RNA, from the first isolation of a tissue embedded in FFPE"
    )
    aux <- data.frame(nucleic.acid.code = nucleic.acid.code,nucleic.acid.description)
    ret <- ret %>% dplyr::left_join(aux, by = "nucleic.acid.code")

    ret <- ret[match(barcode,ret$barcode),]
    rownames(ret) <- gsub("\\.","-",make.names(ret$barcode,unique=TRUE))
    ret$code <- NULL
    return(DataFrame(ret))
}

colDataPrepareTCGA <- function(barcode){
    # For the moment this will work only for TCGA Data
    # We should search what TARGET data means

    code <- c(
        '01','02','03','04','05','06','07','08','09','10','11',
        '12','13','14','20','40','50','60','61'
    )
    shortLetterCode <- c(
        "TP","TR","TB","TRBM","TAP","TM","TAM","THOC",
        "TBM","NB","NT","NBC","NEBV","NBM","CELLC","TRB",
        "CELL","XP","XCL"
    )

    definition <- c(
        "Primary solid Tumor", # 01
        "Recurrent Solid Tumor", # 02
        "Primary Blood Derived Cancer - Peripheral Blood", # 03
        "Recurrent Blood Derived Cancer - Bone Marrow", # 04
        "Additional - New Primary", # 05
        "Metastatic", # 06
        "Additional Metastatic", # 07
        "Human Tumor Original Cells", # 08
        "Primary Blood Derived Cancer - Bone Marrow", # 09
        "Blood Derived Normal", # 10
        "Solid Tissue Normal",  # 11
        "Buccal Cell Normal",   # 12
        "EBV Immortalized Normal", # 13
        "Bone Marrow Normal", # 14
        "Control Analyte", # 20
        "Recurrent Blood Derived Cancer - Peripheral Blood", # 40
        "Cell Lines", # 50
        "Primary Xenograft Tissue", # 60
        "Cell Line Derived Xenograft Tissue"
    ) # 61
    aux <- DataFrame(code = code,shortLetterCode,definition)

    # in case multiple equal barcode
    regex <- paste0("[:alnum:]{4}-[:alnum:]{2}-[:alnum:]{4}",
                    "-[:alnum:]{3}-[:alnum:]{3}-[:alnum:]{4}-[:alnum:]{2}")
    samples <- str_match(barcode,regex)[,1]

    ret <- DataFrame(
        barcode = barcode,
        patient = substr(barcode, 1, 12),
        sample = substr(barcode, 1, 16),
        code = substr(barcode, 14, 15)
    )
    ret <- merge(ret,aux, by = "code", sort = FALSE)
    ret <- ret[match(barcode,ret$barcode),]
    rownames(ret) <- gsub("\\.","-",make.names(ret$barcode,unique=TRUE))
    ret$code <- NULL
    return(DataFrame(ret))
}

#' @title Create samples information matrix for GDC samples
#' @description Create samples information matrix for GDC samples add subtype information
#' @param barcode TCGA or TARGET barcode
#' @importFrom plyr rbind.fill
#' @importFrom dplyr left_join
#' @examples
#'  metadata <- colDataPrepare(c("TCGA-OR-A5K3-01A","C3N-00321-01"))
#'  metadata <- colDataPrepare(c("BLGSP-71-06-00157-01A",
#'                               "BLGSP-71-22-00332-01A"))
#' @export
colDataPrepare <- function(barcode){
    # For the moment this will work only for TCGA Data
    # We should search what TARGET data means
    message("Starting to add information to samples")
    ret <- NULL

    if(all(grepl("TARGET",barcode))) ret <- colDataPrepareTARGET(barcode)
    if(all(grepl("TCGA",barcode))) ret <- colDataPrepareTCGA(barcode)
    if(all(grepl("MMRF",barcode))) ret <- colDataPrepareMMRF(barcode)

    # How to deal with mixed samples "C3N-02003-01;C3N-02003-021" ?
    # Check if this breaks the package
    if(any(grepl("C3N-|C3L-",barcode))) {
        ret <- data.frame(
            sample = map(barcode,.f = function(x) stringr::str_split(x,";") %>% unlist) %>% unlist()
        )
    }

    if(is.null(ret)) {
        ret <- data.frame(
            sample = barcode %>% unique,
            stringsAsFactors = FALSE
        )
    }

    message(" => Add clinical information to samples")
    # There is a limitation on the size of the string, so this step will be splited in cases of 100
    patient.info <- NULL

    patient.info <- splitAPICall(
        FUN = getBarcodeInfo,
        step = 10,
        items = ret$sample
    )

    if(!is.null(patient.info)) {
        ret$sample_submitter_id <- ret$sample %>% as.character()
        ret <- left_join(ret %>% as.data.frame, patient.info %>% unique, by = "sample_submitter_id")
    }
    ret$bcr_patient_barcode <- ret$sample %>% as.character()
    ret$sample_submitter_id <- ret$sample %>% as.character()
    if(!"project_id" %in% colnames(ret)) {
        if("disease_type" %in% colnames(ret)){
            aux <- getGDCprojects()[,c(5,7)]
            aux <- aux[aux$disease_type == unique(ret$disease_type),2]
            ret$project_id <- as.character(aux)
        }
    }
    # There is no subtype info for target, return as it is
    if(any(grepl("TCGA",barcode))) {
        ret <- addSubtypeInfo(ret)
    }

    # na.omit should not be here, exceptional case
    if(is.null(ret)) {
        return(
            data.frame(
                row.names = barcode,
                barcode,
                stringsAsFactors = FALSE
            )
        )
    }

    # Add purity information from http://www.nature.com/articles/ncomms9971
    # purity  <- getPurityinfo()
    # ret <- merge(ret, purity, by = "sample", all.x = TRUE, sort = FALSE)

    # Put data in the right order
    ret <- ret[!duplicated(ret$bcr_patient_barcode),]

    # This part might not work with multiple projects
    idx <- sapply(
        X = substr(barcode,1,min(stringr::str_length(ret$bcr_patient_barcode))),
        FUN =  function(x) {
            grep(x,ret$bcr_patient_barcode)
        }
    )
    # the code above does not work, since the projects have different string lengths
    if(all(na.omit(ret$project_id) %in% c("TARGET-ALL-P3","TARGET-AML"))) {
        idx <- sapply(gsub("-[[:alnum:]]{3}$","",barcode), function(x) {
            grep(x,ret$bcr_patient_barcode)
        })
    }

    if(any(ret$project_id == "CPTAC-3",na.rm = T)) {

        # only merge mixed samples
        mixed_samples <- grep(";",barcode,value = T)
        if(length(mixed_samples) > 0){
            mixed_samples <- mixed_samples %>% str_split(";") %>% unlist %>% unique

            ret_mixed_samples <- ret %>% dplyr::filter(sample_submitter_id %in% mixed_samples) %>%
                dplyr::group_by(submitter_id) %>%
                dplyr::summarise_all(~trimws(paste(unique(.), collapse = ';'))) %>%
                as.data.frame()
            ret <- rbind(ret_mixed_samples,ret)
        }
        idx <- match(barcode,ret$bcr_patient_barcode)

        #idx <- sapply(gsub("-[[:alnum:]]{3}$","",barcode), function(x) {
        #    if(grepl(";",x = x)) x <- stringr::str_split(x[1],";")[[1]][1] # mixed samples
        #    grep(x,ret$bcr_patient_barcode)
        #})

    }

    if(any(ret$project_id %in% c("CMI-MBC","TARGET-NBL"),na.rm = T)) {
        idx <- match(barcode,ret$bcr_patient_barcode)
        # Workaround for the moment, still need to understand the barcode (cases)
        # is TARGET-30-PAPKXS-01A-01D and not TARGET-30-PAPKXS-01A
        if(all(is.na(idx))){
            idx <- match(
                stringr::str_sub(barcode,1,min(stringr::str_length(ret$bcr_patient_barcode))),
                ret$bcr_patient_barcode
            )
        }
    }


    if(is.list(idx)){
        stop(
            "Prepare will not be possible.
            \nIf you are trying to prepare more than
             one different project at a time, please do it separately"
        )
    }


    ret <- ret[idx,]

    if("barcode" %in% colnames(ret)) ret$barcode <- barcode

    rownames(ret) <- barcode
    return(ret)
}

addSubtypeInfo <- function(ret){
    out <- NULL
    message(" => Adding TCGA molecular information from marker papers")
    message(" => Information will have prefix 'paper_' ")

    for(proj in na.omit(unique(ret$project_id))){
        if(grepl("TCGA",proj,ignore.case = TRUE)) {
            # remove letter from 01A 01B etc
            ret$sample.aux <- substr(ret$sample,1,15)

            tumor <- gsub("TCGA-","",proj)
            available <- c(
                "ACC",
                "BRCA",
                "BLCA",
                "CESC",
                "CHOL",
                "COAD",
                "ESCA",
                "GBM",
                "HNSC",
                "KICH",
                "KIRC",
                "KIRP",
                "LGG",
                "LUAD",
                "LUSC",
                "PAAD",
                "PCPG",
                "PRAD",
                "READ",
                "SKCM",
                "SARC",
                "STAD",
                "THCA",
                "UCEC",
                "UCS",
                "UVM"
            )
            if (grepl(paste(c(available,"all"),collapse = "|"),tumor,ignore.case = TRUE)) {
                subtype <- TCGAquery_subtype(tumor)
                colnames(subtype) <- paste0("paper_", colnames(subtype))

                if(all(str_length(subtype$paper_patient) == 12)){
                    # Subtype information were to primary tumor in priority
                    subtype$sample.aux <- paste0(subtype$paper_patient,"-01")
                }
                ret.aux <- ret[ret$sample.aux %in% subtype$sample.aux,]
                ret.aux <- merge(ret.aux,subtype, by = "sample.aux", all.x = TRUE)
                out <- rbind.fill(as.data.frame(out),as.data.frame(ret.aux))
            }
        }
    }
    if(is.null(out)) return(ret)

    # We need to put together the samples with subtypes with samples without subytpes
    ret.aux <- ret[!ret$sample %in% out$sample,]
    ret <- rbind.fill(as.data.frame(out),as.data.frame(ret.aux))
    ret$sample.aux <- NULL

    return(ret)
}

readProteinExpression <- function(files,cases) {
    pb <- txtProgressBar(min = 0, max = length(files), style = 3)
    for (i in seq_along(files)) {
        data <- read_tsv(file = files[i], col_names = TRUE,skip = 1, col_types = c("cn"))
        if(!missing(cases))  colnames(data)[2] <- cases[i]
        if(i == 1) df <- data
        if(i != 1) df <- merge(df, data,all=TRUE, by="Composite Element REF")
        setTxtProgressBar(pb, i)
    }
    close(pb)

    return(df)
}

readProteomeProfiling <- function(files,cases) {

    list.of.protein.df <- plyr::alply(files,1, function(f) {
        data <- readr::read_tsv(
            file = f,
            show_col_types = FALSE,
            col_names = TRUE,
            progress = FALSE
        )
        colnames(data)[ncol(data)] <- cases[which(f == files)]
        data
    }, .progress = "time")

    # Just check if the data is in the same order, since we will not merge
    # the data frames to save memory

    df <- tryCatch({
        stopifnot(all(unlist(list.of.protein.df %>% map(function(y){all(y[,5] ==  list.of.protein.df[[1]][,5])}) )))

        # need to check if it works in all cases
        # tested for HTSeq - FPKM-UQ and Counts only
        bind_cols(list.of.protein.df[[1]][,1:5],list.of.protein.df %>%  map_df(6))
    },error = function(e){
        message("Some files have a  different number of proteins, we will introduce NA for the missing values")
        plyr::join_all(dfs = list.of.protein.df ,type = "full",by = c("AGID","lab_id","catalog_number","set_id","peptide_target"))
    })

    if(!missing(cases))  colnames(df)[-c(1:5)] <- cases

    return(df)
}

makeSEfromProteomeProfiling <- function(){

}

makeSEfromTranscriptomeProfilingSTAR <- function(
        data,
        cases
){
    # How many cases do we have?
    # We wil consider col 1 is the ensemble gene id, other ones are data
    size <- ncol(data)
    # Prepare Patient table
    colData <-  colDataPrepare(cases)

    # one ensemblID can be mapped to multiple entrezgene ID
    gene.location <- get.GRCh.bioMart("hg38",as.granges = TRUE)

    metrics <- subset(data, !grepl("ENSG", data$gene_id))
    data <- subset(data, grepl("ENSG", data$gene_id))
    found.genes <- table(data$gene_id %in% gene.location$gene_id)

    if ("FALSE" %in% names(found.genes)){
        message(paste0("From the ", nrow(data), " genes we couldn't map ", found.genes[["FALSE"]]))
    }

    # Prepare data table
    # Remove the version from the ensembl gene id
    assays <- list(
        data.matrix(data[,grep("^unstranded",colnames(data)),with = FALSE]),
        data.matrix(data[,grep("stranded_first",colnames(data)),with = FALSE]),
        data.matrix(data[,grep("stranded_second",colnames(data)),with = FALSE]),
        data.matrix(data[,grep("tpm_unstrand",colnames(data)),with = FALSE]),
        data.matrix(data[,grep("fpkm_unstrand",colnames(data)),with = FALSE]),
        data.matrix(data[,grep("fpkm_uq_unstrand",colnames(data)),with = FALSE])
    )
    names(assays) <- c(
        "unstranded",
        "stranded_first",
        "stranded_second",
        "tpm_unstrand",
        "fpkm_unstrand",
        "fpkm_uq_unstrand"
    )
    assays <- lapply(assays, function(x){
        colnames(x) <- NULL
        rownames(x) <- NULL
        return(x)
    })

    # Prepare rowRanges
    rowRanges <- gene.location[match(data$gene_id, gene.location$gene_id),]
    names(rowRanges) <- as.character(data$gene_id)


    message("Available assays in SummarizedExperiment : \n  => ",paste(names(assays), collapse = "\n  => "))
    rse <- SummarizedExperiment(
        assays = assays,
        rowRanges = rowRanges,
        colData = colData
    )
    metadata(rse) <- metrics
    return(rse)
}


makeSEfromTranscriptomeProfiling <- function(data, cases, assay.list){
    # How many cases do we have?
    # We wil consider col 1 is the ensemble gene id, other ones are data
    size <- ncol(data)
    # Prepare Patient table
    colData <-  colDataPrepare(cases)

    # one ensemblID can be mapped to multiple entrezgene ID
    gene.location <- get.GRCh.bioMart("hg38")
    gene.location <- gene.location[!duplicated(gene.location$ensembl_gene_id),]

    data$ensembl_gene_id <- as.character(gsub("\\.[0-9]*","",data$X1))
    data <- subset(data, grepl("ENSG", data$ensembl_gene_id))
    found.genes <- table(data$ensembl_gene_id %in% gene.location$ensembl_gene_id)

    if("FALSE" %in% names(found.genes))
        message(paste0("From the ", nrow(data), " genes we couldn't map ", found.genes[["FALSE"]]))

    data <- merge(data, gene.location, by = "ensembl_gene_id")

    # Prepare data table
    # Remove the version from the ensembl gene id
    assays <- list(data.matrix(data[,2:size+1]))
    names(assays) <- assay.list
    assays <- lapply(assays, function(x){
        colnames(x) <- NULL
        rownames(x) <- NULL
        return(x)
    })

    # Prepare rowRanges
    rowRanges <- GRanges(
        seqnames = paste0("chr", data$chromosome_name),
        ranges = IRanges(
            start = data$start_position,
            end = data$end_position
        ),
        strand = data$strand,
        ensembl_gene_id = data$ensembl_gene_id,
        external_gene_name = data$external_gene_name,
        original_ensembl_gene_id = data$X1
    )
    names(rowRanges) <- as.character(data$ensembl_gene_id)
    message("Available assays in SummarizedExperiment : \n  => ",paste(names(assays), collapse = "\n  => "))
    rse <- SummarizedExperiment(
        assays = assays,
        rowRanges = rowRanges,
        colData = colData
    )

    return(rse)
}


#' @importFrom dplyr left_join
#' @importFrom plyr alply join_all
#' @importFrom purrr map_dfc map map_df
readTranscriptomeProfiling <- function(
        files,
        data.type,
        workflow.type,
        cases,
        summarizedExperiment
) {

    if(grepl("Gene Expression Quantification", data.type, ignore.case = TRUE)){
        # Status working for:
        #  - htseq
        #  - FPKM
        #  - FPKM-UQ
        if(grepl("HTSeq",workflow.type)){

            x <- plyr::alply(files,1, function(f) {
                readr::read_tsv(
                    file = f,
                    col_names = FALSE,
                    progress = FALSE,
                    col_types = c("cd")
                )
            }, .progress = "time")

            # Just check if the data is in the same order, since we will not merge
            # the data frames to save memory
            stopifnot(all(unlist(x %>% map(function(y){all(y[,1] ==  x[[1]][,1])}) )))

            # need to check if it works in all cases
            # tested for HTSeq - FPKM-UQ and Counts only
            df <- bind_cols(x[[1]][,1],x %>%  map_df(2))
            if(!missing(cases))  colnames(df)[-1] <- cases
            if(summarizedExperiment) df <- makeSEfromTranscriptomeProfiling(df,cases,workflow.type)
        } else  if(grepl("STAR",workflow.type)){

            # read files that has 4 not necessary rows, and has several columns
            # gene_id gene_name gene_type
            # unstranded stranded_first stranded_second tpm_unstranded fpkm_unstranded
            x <- plyr::alply(files,1, function(f) {
                data.table::fread(f)
            }, .progress = "time")

            df <- data.table::rbindlist(
                x, use.names = TRUE, idcol = "case_barcode"
            )

            # Exception to the code below: CPTAC-3
            # Sample barcode in CPTAC-3 does not handle duplicates
            # we will need to work with aliquots for it or remove duplicated
            # files. Example: C3N-02765-02

            if(!missing(cases))  {
                df$case_barcode <- factor(
                    cases[df$case_barcode %>% as.numeric()],
                    levels = unique(cases)
                )
            }

            # this part changes the cases order if not a factor
            df <- data.table::dcast(
                data = df,
                formula = gene_id + gene_name + gene_type ~ case_barcode,
                value.var = colnames(df)[-c(1:4)]
            )

            # Adding barcodes to columns names, if user wants a dataframe

            if(summarizedExperiment) {
                df <- makeSEfromTranscriptomeProfilingSTAR(
                    data = df,
                    cases = cases
                )
            }
        }
    } else if(grepl("miRNA", workflow.type, ignore.case = TRUE) & grepl("miRNA", data.type, ignore.case = TRUE)) {
        pb <- txtProgressBar(min = 0, max = length(files), style = 3)
        for (i in seq_along(files)) {
            data <- read_tsv(file = files[i], col_names = TRUE,col_types = "cidc")
            if(!missing(cases))
                colnames(data)[2:ncol(data)] <- paste0(colnames(data)[2:ncol(data)],"_",cases[i])

            if(i == 1) df <- data
            if(i != 1) df <- merge(df, data, by=colnames(df)[1],all = TRUE)
            setTxtProgressBar(pb, i)
        }
        close(pb)

    } else if(grepl("Isoform Expression Quantification", data.type, ignore.case = TRUE)){
        pb <- txtProgressBar(min = 0, max = length(files), style = 3)
        for (i in seq_along(files)) {
            data <- read_tsv(file = files[i], col_names = TRUE, col_types = c("ccidcc"))
            if(!missing(cases)) data$barcode <- cases[i] else data$file <- i
            if(i == 1) df <- data
            if(i != 1) df <- rbind(df,data)
            setTxtProgressBar(pb, i)
        }
        close(pb)
    }
    return(df)
}

read_gene_level_copy_number <- function(
        files,
        cases,
        summarizedExperiment = FALSE
){
    message("Reading Gene Level Copy Number files")
    gistic.df <- NULL
    gistic.list <- plyr::alply(files,1,.fun = function(file) {
        #message("Reading file: ", file)
        data <- read_tsv(
            file = file,
            col_names = TRUE,
            progress = TRUE,
            col_types = readr::cols()
        )
        colnames(data)[-c(1:5)] <- paste0(cases[match(file,files)],"_",  colnames(data)[-c(1:5)])

        return(data)
    })

    # Check if the data is in the same order
    stopifnot(all(unlist(gistic.list %>% map(function(y){all(y[,1:5] ==  gistic.list[[1]][,1:5])}) )))

    # need to check if it works in all cases
    # tested for HTSeq - FPKM-UQ and Counts only
    df <- bind_cols(
        gistic.list[[1]][,1:5], # gene info
        gistic.list %>%  map_dfc(.f = function(x) x[,6:8]) # copy number, min,max
    )

    if(summarizedExperiment) {
        se <- make_se_from_gene_level_copy_number(df, cases)
        return(se)
    }
    return(df)
}

make_se_from_gene_level_copy_number <- function(df, cases){
    message("Creating a SummarizedExperiment object")
    rowRanges <- GRanges(
        seqnames = df$chromosome,
        ranges = IRanges(start = df$start, end = df$end),
        gene_id = df$gene_id,
        gene_name = df$gene_name
    )

    names(rowRanges) <- as.character(df$gene_id)
    colData <-  colDataPrepare(cases)

    # We have three data columns for each files
    assays <- lapply(
        c("[^max|min]_copy_number","min_copy_number", "max_copy_number"),
        function(x){
            ret <- data.matrix(subset(df,select = grep(x,colnames(df))))
            colnames(ret) <- cases
            rownames(ret) <- NULL
            ret
        })
    names(assays) <- c("copy_number","min_copy_number", "max_copy_number")

    message("Available assays in SummarizedExperiment : \n  => ",paste(names(assays), collapse = "\n  => "))
    rse <- SummarizedExperiment(assays = assays, rowRanges = rowRanges, colData = colData)
    return(rse)
}


readGISTIC <- function(files, cases){
    message("Reading GISTIC file")
    gistic.df <- NULL
    gistic.list <- plyr::alply(files,1,.fun = function(file) {
        message("Reading file: ", file)
        data <- read_tsv(
            file = file,
            col_names = TRUE,
            progress = TRUE,
            col_types = readr::cols()
        )

        aliquot <- colnames(data)[-c(1:3)]
        info <- splitAPICall(
            FUN = getBarcodefromAliquot,
            step = 20,
            items = aliquot
        )

        barcode <- as.character(info$submitter_id)[match(aliquot,as.character(info$aliquot_id))]
        colnames(data)[-c(1:3)] <- barcode
        return(data)
    })
    gistic.df <- gistic.list %>%
        join_all(by =  c("Gene Symbol","Gene ID","Cytoband"), type='full')

    return(gistic.df)
}

# Reads Copy Number Variation files to a data frame, basically it will rbind it
#' @importFrom purrr map2_dfr
read_copy_number_variation <- function(files, cases){
    message("Reading copy number variation files")

    col_types <- ifelse(any(grepl('ascat2', files)),"ccnnnnn","ccnnnd")

    purrr::map2_dfr(
        .x = files,
        .y = cases,
        .f = function(file,case) {
            data <- readr::read_tsv(file, col_names = TRUE, col_types = col_types);
            if(!missing(case)) data$Sample <- case
            data
        })
}

# getBarcodeInfo(c("TCGA-A6-6650-01B"))
#  getBarcodeInfo(c("DLBCL10508-sample"))
addFFPE <- function(df) {
    message("Add FFPE information. More information at: \n=> https://cancergenome.nih.gov/cancersselected/biospeccriteria \n=> http://gdac.broadinstitute.org/runs/sampleReports/latest/FPPP_FFPE_Cases.html")
    barcode <- df$barcode
    patient <- df$patient

    ffpe.info <- NULL
    ffpe.info <- splitAPICall(
        FUN = getFFPE,
        step = 20,
        items = df$patient
    )

    df <- merge(df, ffpe.info,by.x = "sample", by.y = "submitter_id")
    df <- df[match(barcode,df$barcode),]
    return(df)
}

# getFFPE("TCGA-A6-6650")
#' @importFrom plyr rbind.fill
#' @importFrom httr content
getFFPE <- function(patient){
    baseURL <- "https://api.gdc.cancer.gov/cases/?"
    options.pretty <- "pretty=true"
    options.expand <- "expand=samples"
    option.size <- paste0("size=",length(patient))
    options.filter <- paste0(
        "filters=",
        URLencode('{"op":"and","content":[{"op":"in","content":{"field":"cases.submitter_id","value":['),
        paste0('"',paste(patient,collapse = '","')),
        URLencode('"]}}]}')
    )
    url <- paste0(baseURL,paste(options.pretty,options.expand, option.size, options.filter, sep = "&"))
    json  <- tryCatch(
        getURL(url,fromJSON,timeout(600),simplifyDataFrame = TRUE),
        error = function(e) {
            message(paste("Error: ", e, sep = " "))
            message("We will retry to access GDC again! URL:")
            #message(url)
            fromJSON(content(getURL(url,GET,timeout(600)), as = "text", encoding = "UTF-8"), simplifyDataFrame = TRUE)
        }
    )

    results <- json$data$hits
    results <- rbind.fill(results$samples)[,c("submitter_id","is_ffpe")]
    return(results)
}

getAliquot_ids <- function(barcode){
    baseURL <- "https://api.gdc.cancer.gov/cases/?"
    options.fields <- "fields=samples.portions.analytes.aliquots.aliquot_id,samples.portions.analytes.aliquots.submitter_id"
    options.pretty <- "pretty=true"
    option.size <- paste0("size=",length(barcode))
    #message(paste(barcode,collapse = '","'))
    #message(paste0('"',paste(barcode,collapse = '","')))
    options.filter <- paste0(
        "filters=",
        URLencode('{"op":"and","content":[{"op":"in","content":{"field":"cases.submitter_id","value":['),
        paste0('"',paste(barcode,collapse = '","')),
        URLencode('"]}}]}')
    )
    #message(paste0(baseURL,paste(options.pretty,options.expand, option.size, options.filter, sep = "&")))
    url <- paste0(baseURL,paste(options.pretty,options.fields, option.size, options.filter, sep = "&"))
    json  <- tryCatch(
        getURL(url,fromJSON,timeout(600),simplifyDataFrame = TRUE),
        error = function(e) {
            message(paste("Error: ", e, sep = " "))
            message("We will retry to access GDC again! URL:")
            #message(url)
            fromJSON(content(getURL(url,GET,timeout(600)), as = "text", encoding = "UTF-8"), simplifyDataFrame = TRUE)
        }
    )
    results <- unlist(json$data$hits$samples)
    results.barcode <- grep("TCGA",results,value = TRUE)
    results.aliquot <- grep("TCGA",results,value = TRUE,invert = TRUE)

    df <- data.frame(results.aliquot,results.barcode)
    colnames(df) <- c("aliquot_id","barcode")
    return(df)
}


# getBarcodeInfo(c("TCGA-OR-A5K3-01A","C3N-00321-01"))
# barcode is: sample_submitter_id
#' @importFrom dplyr bind_cols slice row_number
#'
getBarcodeInfo <- function(barcode) {
    baseURL <- "https://api.gdc.cancer.gov/cases/?"
    options.pretty <- "pretty=true"
    options.expand <- "expand=samples,follow_ups,project,diagnoses,diagnoses.treatments,annotations,family_histories,demographic,exposures"
    option.size <- paste0("size=",length(barcode))
    options.filter <- paste0("filters=",
                             URLencode('{"op":"or","content":[{"op":"in","content":{"field":"cases.submitter_id","value":['),
                             paste0('"',paste(barcode,collapse = '","')),
                             URLencode('"]}},'),
                             URLencode('{"op":"in","content":{"field":"submitter_sample_ids","value":['),
                             paste0('"',paste(barcode,collapse = '","')),
                             URLencode('"]}},'),
                             URLencode('{"op":"in","content":{"field":"submitter_aliquot_ids","value":['),
                             paste0('"',paste(barcode,collapse = '","')),
                             URLencode('"]}}'),
                             URLencode(']}')
    )
    url <- paste0(baseURL,paste(options.pretty,options.expand, option.size, options.filter, sep = "&"))
    #message(url)
    json  <- tryCatch(
        getURL(url,fromJSON,timeout(600),simplifyDataFrame = TRUE),
        error = function(e) {
            message(paste("Error: ", e, sep = " "))
            message("We will retry to access GDC again! URL:")
            #message(url)
            fromJSON(content(getURL(url,GET,timeout(600)), as = "text", encoding = "UTF-8"), simplifyDataFrame = TRUE)
        }
    )

    results <- json$data$hits
    saveRDS(results, file = "results.rds")
    # no results
    if(length(results) == 0){
        return(data.frame(barcode,stringsAsFactors = FALSE))
    }

    submitter_id <- results$submitter_id
    submitter_aliquot_ids <- results$submitter_aliquot_ids

    if(!is.null(results$samples)) {
        samples <- rbindlist(results$samples, fill = TRUE)
        samples <- samples[match(barcode,samples$submitter_id),]
        samples$sample_submitter_id <- str_extract_all(
            samples$submitter_id,paste(barcode,collapse = "|")) %>%
            unlist %>% as.character

        tryCatch({
            samples$submitter_id <-
                str_extract_all(
                    samples$submitter_id,
                    paste(c(submitter_id,barcode), collapse = "|"),
                    simplify = TRUE
                ) %>% as.character
        }, error = function(e){
            samples$submitter_id <- submitter_id
        })
        df <- samples[!is.na(samples$submitter_id),]
        suppressWarnings({
            df[,c("updated_datetime","created_datetime")] <- NULL
        })
    }


    # We dont have the same cols for TCGA and TARGET so we need to check them
    if(!is.null(results$diagnoses)) {
        diagnoses <- rbindlist(lapply(results$diagnoses, function(x) if(is.null(x)) data.frame(NA) else x),fill = TRUE)
        diagnoses[,c("updated_datetime","created_datetime","state","days_to_last_follow_up")] <- NULL
        if(any(grepl("submitter_id", colnames(diagnoses)))) {
            diagnoses$submitter_id <- gsub("-diagnosis|_diagnosis.*|-DIAG|diag-","", diagnoses$submitter_id)
        }  else {
            diagnoses$submitter_id <- submitter_id
        }

        # this is required since the sample might not have a diagnosis
        if(!any(df$submitter_id %in% diagnoses$submitter_id)){
            diagnoses$submitter_id <- NULL
            # The sample migth have different sample types
            # The diagnosis the same for each one of these samples
            # in that case we will have a 1 to mapping and binding will
            # not work. We need then to replicate diagnosis to each sample
            # and not each patient
            # Cases can be replicated with getBarcodeInfo(c("BA2691R","BA2577R","BA2748R"))
            if(nrow(diagnoses) <  nrow(df)){
                diagnoses <- plyr::ldply(
                    1:length(results$submitter_sample_ids),
                    .fun = function(x){
                        diagnoses[x] %>% # replicate diagnoses the number of samples
                            as.data.frame() %>%
                            dplyr::slice(rep(dplyr::row_number(), sum(results$submitter_sample_ids[[x]] %in% barcode)))})
            }

            df <- dplyr::bind_cols(df %>% as.data.frame,diagnoses %>% as.data.frame)
        } else {
            df <- left_join(df, diagnoses, by = "submitter_id")
        }
    }

    if (!is.null(results$exposures)) {
        exposures <- rbindlist(
            lapply(results$exposures, function(x) if(is.null(x)) data.frame(NA) else x),
            fill = TRUE
        )
        exposures[,c("updated_datetime","created_datetime","state")] <- NULL
        if (any(grepl("submitter_id", colnames(exposures)))) {
            exposures$submitter_id <- gsub("-exposure|_exposure.*|-EXP","", exposures$submitter_id)
        }  else {
            exposures$submitter_id <- submitter_id
        }
        if (!any(df$submitter_id %in% exposures$submitter_id)) {
            exposures$submitter_id <- NULL
            df <- dplyr::bind_cols(df,exposures)
        } else {
            df <- left_join(df, exposures, by = "submitter_id")
        }
    }

    if (!is.null(results$follow_ups)) {
        follow_ups <- rbindlist(
            lapply(results$follow_ups, function(x) if(is.null(x)) data.frame(NA) else x),
            fill = TRUE
        )
        follow_ups[,c("updated_datetime","created_datetime","state")] <- NULL
        if (any(grepl("submitter_id", colnames(follow_ups)))) {
            follow_ups$submitter_id <- gsub("_follow_up.*","", follow_ups$submitter_id)
            follow_ups_last <- follow_ups %>%
                dplyr::select(
                    c(
                        submitter_id,
                        days_to_follow_up,
                        disease_response
                    )
                ) %>%
                dplyr::filter(!is.na(submitter_id), !is.na(days_to_follow_up)) %>%
                dplyr::group_by(submitter_id) %>%
                dplyr::filter(dplyr::row_number() == which.max(days_to_follow_up)) %>%
                dplyr::ungroup()  %>%
                dplyr::rename_at(dplyr::vars(disease_response),.funs = function(x) paste0("follow_ups_",x)) %>%
                dplyr::rename(days_to_last_follow_up = days_to_follow_up)

            df <- dplyr::left_join(df, follow_ups_last, by = "submitter_id")
        }
    }


    if (!is.null(results$demographic)) {
        demographic <- results$demographic
        demographic[,c("updated_datetime","created_datetime","state")] <- NULL
        if(any(grepl("submitter_id", colnames(demographic)))) {
            demographic$submitter_id <- gsub(
                "-demographic|_demographic.*|-DEMO|demo-",
                "",
                results$demographic$submitter_id
            )
        } else {
            demographic$submitter_id <- submitter_id
        }

        if(!any(df$submitter_id %in% demographic$submitter_id)){
            demographic$submitter_id <- NULL
            demographic$updated_datetime  <- NULL
            demographic$created_datetime <- NULL
            # The sample migth have different sample types
            # The diagnosis the same for each one of these samples
            # in that case we will have a 1 to mapping and binding will
            # not work. We need then to replicate diagnosis to each sample
            # and not each patient
            # Cases can be replicated with getBarcodeInfo(c("BA2691R","BA2577R","BA2748R"))
            if(nrow(demographic) <  nrow(df)){
                demographic <- plyr::ldply(
                    1:length(results$submitter_sample_ids),
                    .fun = function(x){
                        demographic[x,] %>% # replicate diagnoses the number of samples
                            as.data.frame() %>%
                            dplyr::slice(
                                rep(dplyr::row_number(), sum(results$submitter_sample_ids[[x]] %in% barcode)))
                    })
            }

            df <- dplyr::bind_cols(df  %>% as.data.frame,demographic)
        } else {
            df <- left_join(df,demographic, by = "submitter_id")
        }
    }
    saveRDS(df, file = "df.rds")
    df$bcr_patient_barcode <- df$submitter_id %>% as.character()
    projects.info <- results$project
    projects.info <- results$project[,grep("state",colnames(projects.info),invert = TRUE)]

    if(any(submitter_id %in% df$submitter_id)){
        projects.info <-  cbind("submitter_id" = submitter_id, projects.info)

        suppressWarnings({
            df <- left_join(
                df,
                projects.info,
                by = "submitter_id"
            )
        })
    } else {

        if(nrow(projects.info) <  nrow(df)){
            projects.info <- plyr::ldply(
                1:length(results$submitter_sample_ids),
                .fun = function(x){
                    projects.info[x,] %>% # replicate diagnoses the number of samples
                        as.data.frame() %>%
                        dplyr::slice(
                            rep(dplyr::row_number(), sum(results$submitter_sample_ids[[x]] %in% barcode)))
                })
        }

        df <- dplyr::bind_cols(df,projects.info)
    }

    # Adding in the same order


    if(any(substr(barcode,1,str_length(df$submitter_id)) %in% df$submitter_id)){
        df <- df[match(substr(barcode,1,str_length(df$sample_submitter_id)),df$sample_submitter_id),]
        # This line should not exists, but some patients does not have clinical data
        # case: TCGA-R8-A6YH"
        # this has been reported to GDC, waiting answers
        # So we will remove this NA cases
        df <- df[!is.na(df$submitter_id),]
    } else {
        idx <- sapply(substr(barcode,1,str_length(df$submitter_aliquot_ids) %>% max),
                      FUN = function(x){
                          grep(x,df$submitter_aliquot_ids)
                      })
        df <- df[idx,]
    }

    # remove empty columns
    df <- df %>% as.data.frame() %>% dplyr::select(which(colSums(is.na(df)) < nrow(df)))
    return(df)
}

#' @title Prepare CEL files into an AffyBatch.
#' @description Prepare CEL files into an AffyBatch.
#' @param ClinData write
#' @param PathFolder write
#' @param TabCel write
#' @examples
#' \dontrun{
#' to add example
#' }
#' @export
#' @return Normalized Expression data from Affy eSets
TCGAprepare_Affy <- function(ClinData, PathFolder, TabCel){
    if (!requireNamespace("affy", quietly = TRUE)) {
        stop("affy package is needed for this function to work. Please install it.",
             call. = FALSE)
    }
    if (!requireNamespace("Biobase", quietly = TRUE)) {
        stop("affy package is needed for this function to work. Please install it.",
             call. = FALSE)
    }
    affy_batch <- affy::ReadAffy(filenames = as.character(paste(TabCel$samples, ".CEL", sep = "")))

    eset <- affy::rma(affy_batch)

    mat <- Biobase::exprs(eset)

    return(mat)

}

context("Download and prepare")

test_that("GDCdownload API method is working ", {
    skip_on_bioc()
    skip_if_offline()

    cases <- c(
        "TCGA-PA-A5YG-01A-11R-A29S-07",
        "TCGA-OR-A5JX-01A-11R-A29S-07",
        "TCGA-PK-A5HA-01A-11R-A29S-07",
        "TCGA-OR-A5KY-01A-11R-A29S-07"
    )

    acc <- GDCquery(
        project =  c("TCGA-ACC"),
        data.category = "Transcriptome Profiling",
        data.type = "Gene Expression Quantification",
        workflow.type = "STAR - Counts",
        barcode = substr(cases,1,12)
    )
    GDCdownload(acc, method = "api", directory = "ex")
    obj <- GDCprepare(acc,  directory = "ex",summarizedExperiment = TRUE)

    expect_true(all(substr(colnames(obj),1,12) == substr(cases,1,12)))
    expect_true(all(obj$barcode == cases))

    # Checking the data matches the file for a random gene
    expect_equal(assays(obj)$unstranded["ENSG00000003756.17","TCGA-PK-A5HA-01A-11R-A29S-07"], 3584)
    expect_equal(assays(obj)$stranded_first["ENSG00000003756.17","TCGA-PK-A5HA-01A-11R-A29S-07"], 2628)
    expect_equal(assays(obj)$stranded_second["ENSG00000003756.17","TCGA-PK-A5HA-01A-11R-A29S-07"], 2612)
    expect_equal(assays(obj)$tpm_unstrand["ENSG00000003756.17","TCGA-PK-A5HA-01A-11R-A29S-07"], 13.2758)
    expect_equal(assays(obj)$fpkm_unstrand["ENSG00000003756.17","TCGA-PK-A5HA-01A-11R-A29S-07"], 7.0563)
    expect_equal(assays(obj)$fpkm_uq_unstrand["ENSG00000003756.17","TCGA-PK-A5HA-01A-11R-A29S-07"], 9.8086)

    query <- GDCquery(
        project = "CPTAC-3",
        data.category = "Transcriptome Profiling",
        data.type = "Gene Expression Quantification",
        workflow.type = "STAR - Counts",
        barcode = c("CPT0010260013","CPT0000870008","CPT0105190006","CPT0077490006")
    )
    GDCdownload(query)
    data <- GDCprepare(query)
    expect_true(all(query$results[[1]]$sample.submitter_id == colnames(data)))
    expect_true(all(query$results[[1]]$sample.submitter_id == data$sample_submitter_id))
})

test_that("getBarcodeInfo works", {
    skip_on_bioc()
    skip_if_offline()

    cols <- c("gender","project_id","days_to_last_follow_up","alcohol_history")
    x <- getBarcodeInfo(c("TCGA-OR-A5LR-01A", "TCGA-OR-A5LJ-01A"))
    expect_true(all(cols %in% colnames(x)))

    cols <- c("gender","project_id")
    x <- getBarcodeInfo(c("TARGET-20-PARUDL-03A"))
    expect_true(all(cols %in% colnames(x)))

    samples <- c(
        "HCM-CSHL-0063-C18-85A",
        "HCM-CSHL-0065-C20-06A",
        "HCM-CSHL-0065-C20-85A",
        "HCM-CSHL-0063-C18-01A"
    )
    x <- colDataPrepare(samples)

    expect_true(all(rownames(x) == samples))
    expect_true(x[x$sample_submitter_id == "HCM-CSHL-0065-C20-06A","gender"] == "male")
    expect_true(x[x$sample_submitter_id == "HCM-CSHL-0065-C20-06A","tumor_grade"] == "G2")
    expect_true(x[x$sample_submitter_id == "HCM-CSHL-0065-C20-06A","ajcc_pathologic_stage"] == "Stage IVA")
    expect_true(x[x$sample_submitter_id == "HCM-CSHL-0065-C20-06A","sample_type"] == "Metastatic")
    expect_true(x[x$sample_submitter_id == "HCM-CSHL-0063-C18-85A","sample_type"] == "Next Generation Cancer Model")

    x <- getBarcodeInfo(
        c("HCM-CSHL-0063-C18-85A",
          "HCM-CSHL-0065-C20-06A",
          "HCM-CSHL-0065-C20-85A",
          "TARGET-20-PARUDL-03A",
          "TCGA-OR-A5LR-01A",
          "HCM-CSHL-0063-C18-01A")
    )
    expect_true(x[x$sample_submitter_id == "HCM-CSHL-0065-C20-06A","gender"] == "male")
    expect_true(x[x$sample_submitter_id == "HCM-CSHL-0065-C20-06A","tumor_grade"] == "G2")
    expect_true(x[x$sample_submitter_id == "HCM-CSHL-0065-C20-06A","ajcc_pathologic_stage"] == "Stage IVA")
    expect_true(x[x$sample_submitter_id == "HCM-CSHL-0065-C20-06A","sample_type"] == "Metastatic")
    expect_true(x[x$sample_submitter_id == "HCM-CSHL-0063-C18-85A","sample_type"] == "Next Generation Cancer Model")

})

test_that("colDataPrepare handle replicates", {
    skip_on_bioc()
    skip_if_offline()
    barcodes <- c("TCGA-06-0156-01A-02R-1849-01","TCGA-06-0156-01A-03R-1849-01")
    x <- colDataPrepare(barcodes)
    expect_true(nrow(x) == 2)
    expect_true(all(rownames(x) == c("TCGA-06-0156-01A-02R-1849-01","TCGA-06-0156-01A-03R-1849-01")))
    expect_true(all(x$barcode == c("TCGA-06-0156-01A-02R-1849-01","TCGA-06-0156-01A-03R-1849-01")))
})

test_that("GDCprepare accepts more than one project", {
    skip_on_bioc()
    skip_if_offline()
    cases <-  c(
        "TCGA-OR-A5JX-01A",
        "TCGA-OR-A5J3-01A",
        "TCGA-06-0680-11A",
        "TCGA-14-0871-01A"
    )
    expect_true(all(c("TCGA-ACC","TCGA-GBM") %in% colDataPrepare(cases)$project_id))
    query_acc_gbm <- GDCquery(
        project =  c("TCGA-ACC","TCGA-GBM"),
        data.category = "Transcriptome Profiling",
        data.type = "Gene Expression Quantification",
        workflow.type = "STAR - Counts",
        barcode = substr(cases, 1, 12)
    )
    GDCdownload(query_acc_gbm, method = "api", directory = "ex")
    obj <- GDCprepare(query_acc_gbm,  directory = "ex")
    expect_true(all(c("TCGA-ACC","TCGA-GBM") %in% SummarizedExperiment::colData(obj)$project_id))
})

test_that("Non TCGA data is processed", {
    skip_on_bioc()
    skip_if_offline()

    query <- GDCquery(
        project = "MMRF-COMMPASS",
        data.category = "Transcriptome Profiling",
        data.type = "Gene Expression Quantification",
        workflow.type = "STAR - Counts",
        barcode = c(
            "MMRF_2737_1_BM_CD138pos_T2_TSMRU_L14993",
            "MMRF_2739_1_BM_CD138pos_T2_TSMRU_L15000",
            "MMRF_1865_1_BM_CD138pos_T2_TSMRU_L05342"
        )
    )
    GDCdownload(query,directory = "ex")
    data <- GDCprepare(query,directory = "ex")
    expect_true(ncol(data) == 3)
    unlink("ex", recursive = TRUE, force = TRUE)
})

test_that("Gene Level Copy Number is being correctly prepare", {
    skip_on_bioc()
    skip_if_offline()

    query <- GDCquery(
        project = "TCGA-ACC",
        data.category = "Copy Number Variation",
        data.type = "Gene Level Copy Number",
        access = "open",
        barcode = c("TCGA-OR-A5JD","TCGA-OR-A5J7")
    )
    GDCdownload(query,directory = "ex")
    data <- GDCprepare(query,directory = "ex")

    expect_true(all(substr(colnames(data),1,12) == c("TCGA-OR-A5JD","TCGA-OR-A5J7")))
    expect_equal(data$days_to_last_follow_up,c(3038,NA))
    unlink("ex", recursive = TRUE, force = TRUE)
})

test_that("Gene Level Copy Number is being correctly prepare for CPTAC-3", {
    skip_on_bioc()
    skip_if_offline()

    query_CPTAC = GDCquery(
        project = "CPTAC-3",
        data.category = "Copy Number Variation",
        data.type = "Gene Level Copy Number",
        barcode = c("CPT0115240002","CPT0088960002")
    )

    GDCdownload(query_CPTAC,directory = "ex")
    data <- GDCprepare(query_CPTAC,directory = "ex")
    expect_true(ncol(data) == 2)
    expect_equal(data$submitter_id, c("C3L-02544","C3N-01179"))
    expect_equal(data$days_to_last_follow_up, c("889","1816"))
    unlink("ex", recursive = TRUE, force = TRUE)
})

test_that("DNAm files is processed correctly", {
    skip_on_bioc()
    skip_if_offline()

    query_met.hg38 <- GDCquery(
        project = "TCGA-BRCA",
        data.category = "DNA Methylation",
        data.type = "Methylation Beta Value",
        platform = "Illumina Human Methylation 27",
        barcode = c("TCGA-B6-A0IM","TCGA-A2-A0CL","TCGA-E2-A158","TCGA-AN-A0AR")
    )
    GDCdownload(query_met.hg38)
    data.hg38 <- GDCprepare(query_met.hg38)
    expect_lt(abs(assay(data.hg38)["cg16739396","TCGA-E2-A158-01A-11D-A12E-05"] - 0.0688655418909783),10^-10)
})

test_that("Prepare samples without clinical data", {
    skip_on_bioc()
    skip_if_offline()

    # x <-  GDCquery_clinic(project = "TCGA-LUAD", type = "clinical")
    # x[is.na(x$diagnosis_id),]
    x <- colDataPrepare(c("TCGA-80-5608-01A","TCGA-17-Z053-01A","TCGA-78-7158-01A"))
    expect_true(nrow(x) == 3)
})

test_that("Prepare multiple samples from the same patient", {
    skip_on_bioc()
    skip_if_offline()

    # https://portal.gdc.cancer.gov/cases/d7d3de82-802d-4664-8e42-d40408b129b0?bioId=548a300f-a7eb-4dc0-b9bc-5a643ef03d5d
    x <- colDataPrepare(c("BA2691R","BA2577R","BA2748R","BA2577D"))
    expect_true(nrow(x) == 4)
    expect_equal(x["BA2748R","sample_type"],"Primary Blood Derived Cancer - Bone Marrow")
    expect_equal(x["BA2577D","sample_type"],"Recurrent Blood Derived Cancer - Bone Marrow")
    expect_true("age_at_diagnosis" %in% colnames(x))
})

test_that("Preparing RRPA files with number of proteins works", {
    skip_on_bioc()
    skip_if_offline()

    query_rppa <- GDCquery(
        project = c("TCGA-COAD"),
        data.category = "Proteome Profiling",
        experimental.strategy = "Reverse Phase Protein Array",
        platform = "RPPA",
        barcode = c("TCGA-CM-6165-01A","TCGA-DM-A28M-01A"),
        data.type = "Protein Expression Quantification"
    )

    GDCdownload(query_rppa)

    expect_message(
        object = {
            data_rppa <- GDCprepare(query_rppa)
        },
        regexp = "Some files have a  different number of proteins, we will introduce NA for the missing values"
    )

    expect_true(is(data_rppa,"data.frame"))
})

test_that("GDCdownload works for files.per.chunk = 1", {
    skip_on_bioc()
    skip_if_offline()

    query <- GDCquery(
        project = "TCGA-ACC",
        data.category = "Copy Number Variation",
        data.type = "Copy Number Segment",
        barcode = c("TCGA-OR-A5L1")
    )
    expect_no_error({GDCdownload(query, files.per.chunk = 1)})

    expect_true(
        all(
            file.exists(
                file.path("GDCdata/TCGA-ACC/Copy_Number_Variation/Copy_Number_Segment",
                          query$results[[1]]$id,
                          query$results[[1]]$file_name))
        )
    )

    query2 <- GDCquery(
        project = "TCGA-ACC",
        data.category = "Copy Number Variation",
        data.type = "Copy Number Segment",
        barcode = c("TCGA-OR-A5JO")
    )
    expect_no_error({GDCdownload(query2, files.per.chunk = 2)})
    expect_true(
        all(
            file.exists(
                file.path("GDCdata/TCGA-ACC/Copy_Number_Variation/Copy_Number_Segment",
                          query2$results[[1]]$id,
                          query2$results[[1]]$file_name))
        )
    )

})


test_that("Works for TARGET-AML data", {
    skip_on_bioc()
    skip_if_offline()


    query <- GDCquery(
        project = "TARGET-AML",
        data.category = "Transcriptome Profiling",
        experimental.strategy = "RNA-Seq",
        workflow.type = "STAR - Counts",
        data.type = "Gene Expression Quantification",
        access = "open",
        barcode = c(
            "TARGET-20-PAYHMK-Sorted-leukemic",
            "TARGET-20-D7-Myeloid-mock3",
            "TARGET-20-TF1-50A",
            "TARGET-20-PAWUEX-EOI2-14A",
            "TARGET-20-PAWMII-14A"
        )
    )

    GDCdownload(query)
    expect_equal(nrow(query$results[[1]]),5)
    expect_no_error({
        data <- GDCprepare(query, summarizedExperiment = TRUE)
    })
    expect_equal(ncol(data),5)
})


test_that("Works for TARGET-AML data", {
    skip_on_bioc()
    skip_if_offline()


    query <- GDCquery(
        project = "TARGET-AML",
        data.category = "Transcriptome Profiling",
        experimental.strategy = "RNA-Seq",
        workflow.type = "STAR - Counts",
        data.type = "Gene Expression Quantification",
        access = "open",
        barcode = c(
            "TARGET-20-PAYHMK-Sorted-leukemic",
            "TARGET-20-D7-Myeloid-mock3",
            "TARGET-20-TF1-50A",
            "TARGET-20-PAWUEX-EOI2-14A",
            "TARGET-20-PAWMII-14A"
        )
    )

    GDCdownload(query)
    expect_equal(nrow(query$results[[1]]),5)
    expect_no_error({
        data <- GDCprepare(query, summarizedExperiment = TRUE)
    })
    expect_equal(ncol(data),5)
})



test_that("Works for TARGET-NBL data", {
    skip_on_bioc()
    skip_if_offline()


    query <- GDCquery(
        project = "TARGET-NBL",
        data.category = "Transcriptome Profiling",
        experimental.strategy = "RNA-Seq",
        workflow.type = "STAR - Counts",
        data.type = "Gene Expression Quantification",
        access = "open",
        barcode = c(
            "TARGET-30-PASYPX-01A-01R",
            "TARGET-30-PANKFE-01A-01R",
            "TARGET-30-PAIXIF-01A-01R",
            "TARGET-20-PAWUEX-EOI2-14A",
            "TARGET-30-PAPUAR-01A-01R",
            "TARGET-30-PASCFC-01A",
            "TARGET-30-PAPTFZ-01A"
        )
    )

    GDCdownload(query)
    expect_equal(nrow(query$results[[1]]),7)
    expect_no_error({
        data <- GDCprepare(query, summarizedExperiment = TRUE)
    })
    expect_equal(ncol(data),7)
})




test_that("Works for TARGET-ALL-P3 data", {
    skip_on_bioc()
    skip_if_offline()


    #"TARGET-ALL-P2",  no exceptions - working
    # "TARGET-WT", no exceptions - working
    # "TARGET-OS", , no exceptions - working
    # "TARGET-RT",  no exceptions - working
    # "TARGET-CCSK", no exceptions - working
    #"TARGET-ALL-P1" , no exceptions - working

    query <- GDCquery(
        project =  "TARGET-ALL-P3",
        data.category = "Transcriptome Profiling",
        experimental.strategy = "RNA-Seq",
        workflow.type = "STAR - Counts",
        data.type = "Gene Expression Quantification",
        access = "open",
        barcode = c(
            "TARGET-20-SJAML045737",
            "TARGET-15-PAVFTF-09B-01R",
            "TARGET-20-SJAML045741-09A-01R",
            "TARGET-15-SJMPAL017975-03B-01R",
            "TARGET-15-PASZVW-09B-01R"
        )
    )
    expect_equal(nrow(query$results[[1]]),5)
    GDCdownload(query)
    expect_no_error({
        data <- GDCprepare(query, summarizedExperiment = TRUE)
    })
})

#' @title Retrieve multiple tissue types not from the same patients.
#' @description
#'   TCGAquery_SampleTypes for a given list of samples and types,
#'    return the union of samples that are from theses type.
#' @param barcode is a list of samples as TCGA barcodes
#' @param typesample a character vector indicating tissue type to query.
#' Example:
#' \tabular{ll}{
#'TP \tab   PRIMARY SOLID TUMOR \cr
#'TR \tab   RECURRENT SOLID TUMOR \cr
#'TB \tab   Primary Blood Derived Cancer-Peripheral Blood \cr
#'TRBM \tab Recurrent Blood Derived Cancer-Bone Marrow \cr
#'TAP \tab  Additional-New Primary \cr
#'TM \tab   Metastatic \cr
#'TAM \tab  Additional Metastatic \cr
#'THOC \tab Human Tumor Original Cells \cr
#'TBM \tab  Primary Blood Derived Cancer-Bone Marrow \cr
#'NB \tab   Blood Derived Normal \cr
#'NT \tab   Solid Tissue Normal \cr
#'NBC \tab  Buccal Cell Normal \cr
#'NEBV \tab EBV Immortalized Normal \cr
#'NBM \tab  Bone Marrow Normal \cr
#'}
#' @export
#' @examples
#' # selection of normal samples "NT"
#' barcode <- c("TCGA-B0-4698-01Z-00-DX1","TCGA-CZ-4863-02Z-00-DX1")
#' # Returns the second barcode
#'  TCGAquery_SampleTypes(barcode,"TR")
#'  # Returns both barcode
#'  TCGAquery_SampleTypes(barcode,c("TR","TP"))
#'  barcode <- c("TARGET-20-PANSBH-14A-02D","TARGET-20-PANSBH-01A-02D",
#'               "TCGA-B0-4698-01Z-00-DX1","TCGA-CZ-4863-02Z-00-DX1")
#'   TCGAquery_SampleTypes(barcode,c("TR","TP"))
#' @return a list of samples / barcode filtered by type sample selected
TCGAquery_SampleTypes <- function(barcode,typesample){
    # Tumor AND Solid Tissue Normal NOT FROM THE SAME PATIENTS
    table.code <- c('01','02','03','04','05','06','07','08','09','10',
                    '11','12','13','14','20','40','50','60','61')
    names(table.code) <- c("TP","TR","TB","TRBM","TAP","TM","TAM","THOC",
                           "TBM","NB","NT","NBC","NEBV","NBM","CELLC","TRB",
                           "CELL","XP","XCL")

    if (sum(is.element(typesample,names(table.code))) == length(typesample)) {
        string <- sapply(barcode,function(x) substr(unlist(stringr::str_split(x,"-"))[4],1,2))

        barcode.all <- NULL
        for (sample.i in typesample) {
            barcode.all <- union(barcode.all,
                                 barcode[grep(table.code[sample.i], string)])
        }
        return(barcode.all)
    } else {
        return("Error message: one or more sample types do not exist")
    }
}

#' @title Retrieve multiple tissue types from the same patients.
#' @description
#'   TCGAquery_MatchedCoupledSampleTypes
#' @param barcode barcode
#' @param typesample typesample
#' @examples
#'  TCGAquery_MatchedCoupledSampleTypes(c("TCGA-B0-4698-01Z-00-DX1",
#'                              "TCGA-B0-4698-02Z-00-DX1"),
#'                              c("TP","TR"))
#'  barcode <- c("TARGET-20-PANSBH-02A-02D","TARGET-20-PANSBH-01A-02D",
#'               "TCGA-B0-4698-01Z-00-DX1","TCGA-CZ-4863-02Z-00-DX1",
#'               "TARGET-20-PANSZZ-02A-02D","TARGET-20-PANSZZ-11A-02D",
#'               "TCGA-B0-4699-01Z-00-DX1","TCGA-B0-4699-02Z-00-DX1"
#'               )
#'   TCGAquery_MatchedCoupledSampleTypes(barcode,c("TR","TP"))
#' @export
#' @return a list of samples / barcode filtered by type sample selected
TCGAquery_MatchedCoupledSampleTypes <- function(barcode,typesample){
    # Tumor AND Solid Tissue Normal FROM THE SAME PATIENTS
    table.code <- c('01','02','03','04','05','06','07','08','09','10',
                    '11','12','13','14','20','40','50','60','61')
    names(table.code) <- c("TP","TR","TB","TRBM","TAP","TM","TAM","THOC",
                           "TBM","NB","NT","NBC","NEBV","NBM","CELLC","TRB",
                           "CELL","XP","XCL")
    if(length(typesample)!=2){
        return("Error message: exactly two types need to be provided")
    }

    if(sum(is.element(typesample,names(table.code))) == length(typesample)) {

        string <- sapply(barcode,function(x) substr(unlist(stringr::str_split(x,"-"))[4],1,2))
        barcode.1 <- barcode[grep(table.code[typesample[1]], string)]
        barcode.2 <- barcode[grep(table.code[typesample[2]], string)]
        barcode.common <- intersect(sapply(barcode.1,function(x) paste(unlist(stringr::str_split(x,"-"))[1:3],collapse = "-")),
                                    sapply(barcode.2,function(x) paste(unlist(stringr::str_split(x,"-"))[1:3],collapse = "-")))
        if(length(barcode.common) > 0){
            idx1 <- unlist(lapply(barcode.common, function(x) grep(x,barcode.1)))
            idx2 <- unlist(lapply(barcode.common, function(x) grep(x,barcode.2)))
            return(union(barcode.1[idx1], barcode.2[idx2]))
        } else {
            return("Error message: there exist no matched samples")
        }
    } else {
        return("Error message: one or more sample types do not exist")
    }
}


#' @title Get GDC clinical data
#' @description
#' GDCquery_clinic will download all clinical information from the API
#' as the one with using the button from each project
#' @param project A valid project (see list with getGDCprojects()$project_id)]
#' \itemize{
#' \item{ BEATAML1.0-COHORT }
#' \item{ BEATAML1.0-CRENOLANIB }
#' \item{ CGCI-BLGSP }
#' \item{ CPTAC-2 }
#' \item{ CPTAC-3 }
#' \item{ CTSP-DLBCL1 }
#' \item{ FM-AD }
#' \item{ HCMI-CMDC }
#' \item{ MMRF-COMMPASS }
#' \item{ NCICCR-DLBCL }
#' \item{ OHSU-CNL }
#' \item{ ORGANOID-PANCREATIC }
#' \item{ TARGET-ALL-P1 }
#' \item{ TARGET-ALL-P2 }
#' \item{ TARGET-ALL-P3 }
#' \item{ TARGET-AML }
#' \item{ TARGET-CCSK }
#' \item{ TARGET-NBL }
#' \item{ TARGET-OS }
#' \item{ TARGET-RT }
#' \item{ TARGET-WT }
#' \item{ TCGA-ACC }
#' \item{ TCGA-BLCA }
#' \item{ TCGA-BRCA }
#' \item{ TCGA-CESC }
#' \item{ TCGA-CHOL }
#' \item{ TCGA-COAD }
#' \item{ TCGA-DLBC }
#' \item{ TCGA-ESCA }
#' \item{ TCGA-GBM }
#' \item{ TCGA-HNSC }
#' \item{ TCGA-KICH }
#' \item{ TCGA-KIRC }
#' \item{ TCGA-KIRP }
#' \item{ TCGA-LAML }
#' \item{ TCGA-LGG }
#' \item{ TCGA-LIHC }
#' \item{ TCGA-LUAD }
#' \item{ TCGA-LUSC }
#' \item{ TCGA-MESO }
#' \item{ TCGA-OV }
#' \item{ TCGA-PAAD }
#' \item{ TCGA-PCPG }
#' \item{ TCGA-PRAD }
#' \item{ TCGA-READ }
#' \item{ TCGA-SARC }
#' \item{ TCGA-SKCM }
#' \item{ TCGA-STAD }
#' \item{ TCGA-TGCT }
#' \item{ TCGA-THCA }
#' \item{ TCGA-THYM }
#' \item{ TCGA-UCEC }
#' \item{ TCGA-UCS }
#' \item{ TCGA-UVM }
#' \item{ VAREPOP-APOLLO }
#' }
#' @param type A valid type. Options "clinical", "Biospecimen"  (see list with getGDCprojects()$project_id)]
#' @param save.csv Write clinical information into a csv document
#' @export
#' @importFrom data.table rbindlist as.data.table
#' @importFrom jsonlite fromJSON
#' @importFrom dplyr summarise
#' @examples
#' clinical <- GDCquery_clinic(
#'    project = "TCGA-ACC",
#'    type = "clinical",
#'    save.csv = FALSE
#'  )
#' clinical <- GDCquery_clinic(
#'    project = "TCGA-ACC",
#'    type = "biospecimen",
#'    save.csv = FALSE
#' )
#' \dontrun{
#' clinical_cptac_3 <- GDCquery_clinic(
#'    project = "CPTAC-3",
#'    type = "clinical"
#' )
#' clinical_cptac_2 <- GDCquery_clinic(
#'    project = "CPTAC-2",
#'    type = "clinical"
#' )
#' clinical_HCMI_CMDC <- GDCquery_clinic(
#'    project = "HCMI-CMDC",
#'    type = "clinical"
#' )
#' clinical_GCI_HTMCP_CC <- GDCquery_clinic(
#'    project = "CGCI-HTMCP-CC",
#'    type = "clinical"
#' )
#' clinical <- GDCquery_clinic(
#'    project = "NCICCR-DLBCL",
#'    type = "clinical"
#' )
#' clinical <- GDCquery_clinic(
#'    project = "ORGANOID-PANCREATIC",
#'    type = "clinical"
#' )
#' }
#' @return A data frame with the clinical information
#' @author Tiago Chedraoui Silva
GDCquery_clinic <- function(
        project,
        type = "clinical",
        save.csv = FALSE
){
    checkProjectInput(project)

    if (length(project) > 1) {
        stop("Please, project should be only one valid project")
    }

    if (!grepl("clinical|Biospecimen",type,ignore.case = TRUE)) {
        stop("Type must be clinical or Biospecimen")
    }

    baseURL <- "https://api.gdc.cancer.gov/cases/?"
    options.pretty <- "pretty=true"

    if (grepl("clinical",type,ignore.case = TRUE)) {
        options.expand <- "expand=diagnoses,follow_ups,diagnoses.treatments,annotations,family_histories,demographic,exposures"
        option.size <- paste0("size=",getNbCases(project,"Clinical"))
        files.data_category <- "Clinical"
    } else {
        options.expand <- "expand=samples,samples.portions,samples.portions.analytes,samples.portions.analytes.aliquots"
        option.size <- paste0("size=",getNbCases(project,"Biospecimen"))
        files.data_category <- "Biospecimen"
    }

    if (grepl("TCGA",project)){
        options.filter <- paste0(
            "filters=",
            URLencode('{"op":"and","content":[{"op":"in","content":{"field":"cases.project.project_id","value":["'),
            project,
            URLencode('"]}},{"op":"in","content":{"field":"files.data_category","value":["'),
            files.data_category,
            URLencode('"]}}]}')
        )
    } else {
        options.filter <- paste0(
            "filters=",
            URLencode('{"op":"in","content":{"field":"cases.project.project_id","value":["'),
            project,
            URLencode('"]}}')
        )
    }
    url <- paste0(baseURL,paste(options.pretty,options.expand, option.size, options.filter,"format=json", sep = "&"))
    json  <- tryCatch(
        getURL(url,fromJSON,timeout(600),simplifyDataFrame = TRUE),
        error = function(e) {
            fromJSON(content(getURL(url,GET,timeout(600)), as = "text", encoding = "UTF-8"), simplifyDataFrame = TRUE)
        }
    )


    #message(paste0(baseURL,paste(options.pretty,options.expand, option.size, options.filter, sep = "&")))
    results <- json$data$hits

    if (grepl("clinical",type,ignore.case = TRUE)) {
        if (grepl("TCGA",project)) {
            df <- data.frame("submitter_id" = results$submitter_id)
            if ("diagnoses" %in% colnames(results)){
                diagnoses <- rbindlist(lapply(results$diagnoses, function(x) if(is.null(x)) data.frame(NA) else x),fill = T)
                diagnoses$submitter_id <- gsub("_diagnosis","", diagnoses$submitter_id)

                # we are getting more results than what we should
                diagnoses <- diagnoses[diagnoses$submitter_id %in% df$submitter_id,]
                diagnoses$days_to_last_follow_up <- NULL
                df <- merge(df,diagnoses, by="submitter_id", all = TRUE, sort = FALSE)
            }

            if ("exposures" %in% colnames(results)){
                exposures <- rbindlist(results$exposures, fill = TRUE)
                exposures <- exposures[,-c("updated_datetime","state","created_datetime")]
                exposures$submitter_id <- gsub("_exposure","", exposures$submitter_id)
                exposures <- exposures[exposures$submitter_id %in% df$submitter_id,]
                df <- merge(df, exposures, by = "submitter_id", all = TRUE, sort = FALSE)
            }

            if ("demographic" %in% colnames(results)){
                results$demographic$submitter_id <- gsub("_demographic","", results$demographic$submitter_id)
                demographic <- results$demographic[!is.na(results$demographic$submitter_id),]
                demographic <- demographic[demographic$submitter_id %in% df$submitter_id,]
                df <- merge(
                    df,
                    as.data.table(demographic)[,-c("updated_datetime","state","created_datetime")],
                    by = "submitter_id",
                    all = TRUE,
                    sort = FALSE
                )
            }

            if ("follow_ups" %in% colnames(results)){
                follow_ups <- rbindlist(lapply(results$follow_ups, function(x) if(is.null(x)) data.frame(NA) else x),fill = T)
                follow_ups$submitter_id <- gsub("_follow_up.*","", follow_ups$submitter_id)

                # we are getting more results than what we should
                follow_ups <- follow_ups[follow_ups$submitter_id %in% df$submitter_id,]

                follow_ups_last <- follow_ups %>%
                    dplyr::select(
                        c(
                            submitter_id,
                            days_to_follow_up,
                            #days_to_recurrence,
                            #progression_or_recurrence_type,
                            disease_response
                        )
                    ) %>%
                    dplyr::filter(!is.na(submitter_id), !is.na(days_to_follow_up)) %>%
                    dplyr::group_by(submitter_id) %>%
                    dplyr::filter(dplyr::row_number() == which.max(days_to_follow_up)) %>%
                    dplyr::ungroup()  %>%
                    dplyr::rename_at(dplyr::vars(disease_response),.funs = function(x) paste0("follow_ups_",x)) %>%
                    dplyr::rename(days_to_last_follow_up = days_to_follow_up)

                df <- dplyr::full_join(df, follow_ups_last, by = "submitter_id")

                # Keep all follow ups
                # follow_ups <- follow_ups %>%
                #    dplyr::select(
                #        c(
                #            submitter_id,
                #            days_to_follow_up,
                #            days_to_recurrence,
                #            progression_or_recurrence_type,
                #            disease_response
                #        )
                #    ) %>%
                #    dplyr::group_by(submitter_id) %>%
                #    dplyr::summarise(
                #        across(everything(),~ paste(., collapse = ";"))
                #    ) %>% dplyr::rename_at(-1,.funs = function(x) paste0("follow_ups_",x))
                #
                # df <- dplyr::full_join(df, follow_ups, by = "submitter_id")

            }

            if( "treatments" %in% colnames(df)) {

                treatments <- purrr::map_dfr(
                    df$treatments,
                    .f = function(row) {
                        if(is.data.frame(row)) {
                            return(row)
                        } else {
                            NULL
                        }
                    })

                df$treatments <- NULL

                # case where all treatments are NULL
                if (!nrow(treatments) == 0) {

                    treatments$submitter_id <- gsub("_treatment(_[0-9])?|_treatment([0-9])?","", treatments$submitter_id)
                    treatments <- treatments %>% dplyr::select(
                        !c("updated_datetime", "state", "created_datetime")
                    )
                    treatments <- treatments[treatments$submitter_id %in% df$submitter_id,]


                    # we have now two types of treatment
                    treatments.pharmaceutical <- treatments[grep("Pharmaceutical",treatments$treatment_type,ignore.case = TRUE),]
                    treatments.radiation <- treatments[grep("radiation",treatments$treatment_type,ignore.case = TRUE),]

                    # Adding a prefix
                    colnames(treatments.pharmaceutical) <- paste0("treatments_pharmaceutical_",colnames(treatments.pharmaceutical))
                    colnames(treatments.radiation) <- paste0("treatments_radiation_",colnames(treatments.radiation))
                    colnames(treatments.radiation)[grep("submitter",colnames(treatments.radiation))] <- "submitter_id"
                    colnames(treatments.pharmaceutical)[grep("submitter",colnames(treatments.pharmaceutical))] <- "submitter_id"

                    # If there are two rows for the same submitter_id
                    # we will collapse them into one single row
                    # concatenating all columns using ;
                    aux <- treatments.pharmaceutical %>% dplyr::group_by(submitter_id) %>%
                        dplyr::summarise(
                            across(everything(),~ paste(unique(.), collapse = ";"))
                        )
                    df <- merge(df, as.data.table(aux), by = "submitter_id",  all = TRUE, sort = FALSE)

                    # If there are two rows for the same submitter_id
                    # we will collapse them into one single row
                    # concatenating all columns using ;
                    aux <- treatments.radiation %>% dplyr::group_by(submitter_id) %>%
                        dplyr::summarise(
                            across(everything(),~ paste(unique(.), collapse = ";"))
                        )
                    df <- merge(df, as.data.table(aux), by = "submitter_id",  all = TRUE, sort = FALSE)
                }
            }

            df$bcr_patient_barcode <- df$submitter_id
            df$project <- project
            df <- df %>% dplyr::relocate(project)

        } else {

            # Although for TCGA and TARGET IDs from diagnosis, treatments, exposures etc are the same
            # for the other projects this might not be true!
            # example: ORGANOID-PANCREATIC
            # https://api.gdc.cancer.gov/cases/?pretty=true&expand=diagnoses,demographic&size=1&filters=%7B%22op%22:%22in%22,%22content%22:%7B%22field%22:%22cases.project.project_id%22,%22value%22:[%22ORGANOID-PANCREATIC%22]%7D%7D&format=json
            # DEMOGRAPHIC 48, while everything else is 42
            df <- data.frame("submitter_id" = results$submitter_id)

            if("disease_type" %in% colnames(results)){
                disease_type <- data.frame("disease_type" = results$disease_type)
                df <- cbind(df,disease_type)
            }
            if("primary_site" %in% colnames(results)){
                primary_site <- data.frame("primary_site" = results$primary_site)
                df <- cbind(df,primary_site)
            }

            if ("diagnoses" %in% colnames(results)) {
                diagnoses <- rbindlist(
                    lapply(
                        results$diagnoses,
                        function(x) {
                            if(is.null(x)) {
                                data.frame(NA)
                            } else {
                                # HTMCP-03-06-02061 has two diagnosis
                                x$submitter_id <- gsub("_diagnosis.*|-diagnosis.*","",x$submitter_id)
                                # If there are two rows for the same submitter_id
                                # we will collapse them into one single row
                                # concatenating all columns using ;
                                aux <- x %>% dplyr::group_by(submitter_id) %>%
                                    dplyr::summarise(
                                        across(everything(),~ paste(unique(.), collapse = ";"))
                                    )

                                aux$treatments <- list(dplyr::bind_rows(x$treatments))
                                aux
                            }
                        }
                    ), fill = TRUE
                )
                #df$submitter_id <- gsub("^d|_diagnosis|diag-|-DX|-DIAG|-diagnosis","", df$submitter_id)
                # ^d ORGANOID-PANCREATIC
                # -DX CPTAC-2
                # -DIAG CPTAC-3
                # -diagnosis NCICCR-DLBCL
                # _diagnosis HCMI-CMDC
                df <- cbind(df,diagnoses)
            }
            if("exposures" %in% colnames(results)){
                exposures <- rbindlist(lapply(results$exposures, function(x) if(is.null(x)) data.frame(NA) else x),fill = T)
                exposures <- exposures[,-c("updated_datetime","state","created_datetime")]
                df <- cbind(df,exposures)
            }
            if("treatments" %in% colnames(results)){
                treatments <- rbindlist(results$treatments, fill = TRUE)
                df$treatments <- NULL
                df <- cbind(df,treatments)
            }
            if("submitter_sample_ids" %in% colnames(results)){
                submitter_sample_ids <- lapply(
                    results$submitter_sample_ids,
                    function(x) {
                        paste(x,collapse = ",")
                    }
                ) %>% unlist
                df <- cbind(df,submitter_sample_ids)
            }

            # We do a merge because some cases might not have demographic information
            # DEMOGRAPHIC ORGANOID-PANCREATIC
            # -demographic NCICCR-DLBCL
            # _demographic HCMI-CMDC
            # -DG and -DM CPTAC-2
            # -DEMO CPTAC-3
            if("demographic" %in% colnames(results)){
                results$demographic$submitter_id <- gsub("_demographic|DEMOGRAPHIC|_demographic|demo-|-DG|-DM|-DEMO","", results$demographic$submitter_id)
                demographic <-  results$demographic %>% dplyr::select(-c("updated_datetime","state","created_datetime"))
                df <- cbind(df,demographic)
            }

            df$project <- project
            df <- df %>% dplyr::relocate(project)
        }

        if (nrow(results) != nrow(df)) {
            stop("Error: API returned more information")
        }

    } else {
        df <- rbindlist(results$samples,fill = TRUE)
    }

    if (save.csv) {
        if(grepl("biospecimen",type))  {
            df$portions <- NULL
            message("Portion column is a list, it will be removed. Please check object with save.csv argument as FALSE")
        }
        if (grepl("clinical",type))  {
            df$treatments <- NULL
            message("Treatments column is a list, it will be removed. Please check object with save.csv argument as FALSE")
        }
        write_csv(df,paste0(project,"_",type,".csv"))
    }
    setDF(df)
    return(df)
}

#' @title Parsing clinical xml files
#' @description
#' This function receives the query argument and parses the clinical xml files
#' based on the desired information
#' @param query Result from GDCquery, with data.category set to Clinical
#' @param clinical.info Which information should be retrieved.
#' Options Clinical: drug, admin, follow_up,radiation, patient, stage_event or new_tumor_event
#' Options Biospecimen: protocol, admin, aliquot, analyte, bio_patient, sample, portion, slide
#' @param directory Directory/Folder where the data was downloaded. Default: GDCdata
#' @importFrom xml2 read_xml xml_ns
#' @importFrom XML xmlParse getNodeSet xmlToDataFrame
#' @importFrom plyr rbind.fill
#' @importFrom dplyr mutate_all funs
#' @return A data frame with the parsed values from the XML
#' @export
#' @examples
#' query <- GDCquery(
#'   project = "TCGA-COAD",
#'   data.category = "Clinical",
#'   data.format = "bcr xml",
#'   barcode = c("TCGA-RU-A8FL","TCGA-AA-3972")
#' )
#' GDCdownload(query)
#' clinical <- GDCprepare_clinic(query,"patient")
#' clinical.drug <- GDCprepare_clinic(query,"drug")
#' clinical.radiation <- GDCprepare_clinic(query,"radiation")
#' clinical.admin <- GDCprepare_clinic(query,"admin")
#' \dontrun{
#' query <- GDCquery(
#'    project = "TCGA-COAD",
#'    data.category = "Biospecimen",
#'    data.format = "bcr xml",
#'    data.type = "Biospecimen Supplement",
#'    barcode = c("TCGA-RU-A8FL","TCGA-AA-3972")
#' )
#' GDCdownload(query)
#' clinical <- GDCprepare_clinic(query,"admin")
#' clinical.drug <- GDCprepare_clinic(query,"sample")
#' clinical.radiation <- GDCprepare_clinic(query,"portion")
#' clinical.admin <- GDCprepare_clinic(query,"slide")
#' }
GDCprepare_clinic <- function(
        query,
        clinical.info,
        directory = "GDCdata"
){

    if (unique(query$results[[1]]$data_category) == "Clinical") {
        valid.clinical.info <- c(
            "drug",
            "admin",
            "follow_up",
            "radiation",
            "patient",
            "stage_event",
            "new_tumor_event"
        )
    } else  if (unique(query$results[[1]]$data_category) == "Biospecimen" ) {
        valid.clinical.info <- c(
            "protocol",
            "admin",
            "aliquot",
            "analyte",
            "bio_patient",
            "sample",
            "portion",
            "slide"
        )
    } else  if (unique(query$results[[1]]$data_category) == "Other") {
        valid.clinical.info <- c("admin","msi")
    } else {
        stop("Data category should be Clinical or Biospecimen or Other (auxiliary files)")
    }

    if (missing(clinical.info) || !(clinical.info %in% valid.clinical.info)) {
        stop(
            "Please set clinical.info argument:\n=> ",
            paste(valid.clinical.info, collapse = "\n=> ")
        )
    }

    # Get all the clincal xml files

    files <- file.path(
        query$results[[1]]$project,
        gsub(" ","_",query$results[[1]]$data_category),
        gsub(" ","_",query$results[[1]]$data_type),
        gsub(" ","_",query$results[[1]]$file_id),
        gsub(" ","_",query$results[[1]]$file_name)
    )
    files <- file.path(directory, files)
    if(!all(file.exists(files))) {
        stop(
            "I couldn't find all the files from the query.",
            "Please check directory parameter right"
        )
    }

    xpath <- NULL

    disease <- tolower(gsub("TCGA-","",unlist(query$project)))
    if(tolower(clinical.info) == "drug") xpath <- "//rx:drug"
    else if(tolower(clinical.info) == "admin") xpath <- "//admin:admin"
    else if(tolower(clinical.info) == "radiation") xpath <- "//rad:radiation"
    else if(tolower(clinical.info) == "patient") xpath <- paste0("//",disease,":patient")
    else if(tolower(clinical.info) == "stage_event") xpath <- "//shared_stage:stage_event"
    else if(tolower(clinical.info) == "new_tumor_event") xpath <- paste0("//",disease,"_nte:new_tumor_event")
    # biospecimen xpaths
    else if(tolower(clinical.info) == "sample") xpath <- "//bio:sample"
    else if(tolower(clinical.info) == "bio_patient")  xpath <- "//bio:patient"
    else if(tolower(clinical.info) == "analyte") xpath <- "//bio:analyte"
    else if(tolower(clinical.info) == "aliquot") xpath <- "//bio:aliquot"
    else if(tolower(clinical.info) == "protocol") xpath <- "//bio:protocol"
    else if(tolower(clinical.info) == "portion") xpath <- "//bio:portion"
    else if(tolower(clinical.info) == "slide") xpath <- "//bio:slide"
    else if(tolower(clinical.info) == "msi") xpath <- "//auxiliary:microsatellite_instability_test_result"

    if (tolower(clinical.info) == "follow_up") {
        clin <- parseFollowup(files, xpath, clinical.info)
    } else {
        clin <- parseXML(files,xpath,clinical.info)
        if (is.null(clin)) return(NULL)
        clin <- merge(clin,getResults(query)[,c("project","cases")],by.x = c("bcr_patient_barcode"), by.y = "cases",all.x = TRUE)
    }

    if (tolower(clinical.info) == "patient") {
        composed.cols <- c("new_tumor_events","drugs","follow_ups","radiations")
        composed.cols <- composed.cols[composed.cols %in% colnames(clin)]
        message("To get the following information please change the clinical.info argument")
        message("=> new_tumor_events: new_tumor_event \n=> drugs: drug \n=> follow_ups: follow_up \n=> radiations: radiation")

        for (i in composed.cols) {
            clin[,i] <- as.character(clin[,i])
            clin[!clin[,i] %in%  c("","NO"),i] <- "YES"
            clin[clin[,i] %in% c("","NO"),i] <- "NO"

            if (i == "new_tumor_events") {
                followup <- parseFollowup(files,xpath,clinical.info)
                barcode <- followup$bcr_patient_barcode[!followup$new_tumor_events %in% c("","NO")]
                clin[clin$bcr_patient_barcode %in% barcode,i] <- "YES"
            }
            colnames(clin)[which(colnames(clin) == i)] <- paste0("has_",i,"_information")
        }

        if ("stage_event" %in% colnames(clin)) {
            message("Adding stage event information")
            aux <- parseXML(files,"//shared_stage:stage_event","stage_event")
            colnames(aux)[grep("bcr_patient_barcode",colnames(aux),invert = TRUE)] <- paste0("stage_event_",grep("bcr_patient_barcode",colnames(aux),invert = TRUE,value = TRUE))
            clin <- merge(clin, aux, by = "bcr_patient_barcode" , sort = FALSE, all.x = TRUE)
            clin$stage_event <- NULL
        }

        if ("primary_pathology" %in% colnames(clin)) {
            message("Adding primary pathology information")
            aux <- parseXML(files,paste0("//",disease,":primary_pathology"),"primary_pathology")
            # Last column is the idx to merge
            colnames(aux)[grep("bcr_patient_barcode",colnames(aux),invert = TRUE)] <- paste0("primary_pathology_",grep("bcr_patient_barcode",colnames(aux),invert = TRUE,value = TRUE))
            clin <- merge(clin, aux, by = "bcr_patient_barcode" , sort = FALSE, all.x = TRUE)
            clin$primary_pathology <- NULL
        }

        # Update clinical data with follow-ups: days_to_last_followup and vital_status
        message("Updating days_to_last_followup and vital_status from follow_up information using last entry")
        followup <- parseFollowup(files,xpath,clinical.info)

        if(nrow(followup) > 0){
            followup_last <- followup %>%
                dplyr::group_by(bcr_patient_barcode) %>%
                dplyr::summarise(
                    days_to_last_followup = ifelse(
                        all(is.na(as.numeric(days_to_last_followup))),
                        NA,
                        max(as.numeric(days_to_last_followup),na.rm = TRUE)
                    ),
                    vital_status = vital_status[
                        ifelse(
                            any(followup$days_to_last_followup %in% ""),
                            which(followup$days_to_last_followup %in% ""),
                            which.max(days_to_last_followup)
                        )
                    ]
                )
            clin$days_to_last_followup <- followup_last$days_to_last_followup[match(clin$bcr_patient_barcode,followup_last$bcr_patient_barcode)]
            clin$vital_status <- followup_last$vital_status[match(clin$bcr_patient_barcode,followup_last$bcr_patient_barcode)]
        }
    }

    if (tolower(clinical.info) == "sample") {
        clin$portions <- NULL
        clin$samples <- NULL
    }

    if (tolower(clinical.info) == "bio_patient") {
        clin$samples <- NULL
    }

    if (tolower(clinical.info) == "portion") {
        for (i in c("slides","analytes")) {
            clin[,i] <- as.character(clin[,i])
            clin[which(clin[,i] != ""),i] <- "YES"
            clin[which(clin[,i] == ""),i] <- "NO"
            colnames(clin)[which(colnames(clin) == i)] <- paste0("has_",i,"_information")
        }
    }

    if (is.null(clin)) {
        message("No information found")
        return(NULL)
    }

    # Converting factor to numeric and double
    out <- clin |> type.convert(as.is = TRUE, numerals = "warn.loss")

    # Change columns back to factor
    for (i in colnames(out)[!grepl("has_",colnames(out))]) {
        if (is(out[,i],"character") &  length(unique(out[,i])) < nrow(out)/2)
            out[,i] <-  as.factor(out[,i])
    }
    return(out)
}

parseFollowup <- function(files, xpath, clinical.info){
    follow_up_version <- files %>%
        sapply(function(x) {
            name <- names(xml_ns(read_xml(x)))
            name[grepl("follow_up",name)]
        }) %>% unlist() %>% unique() %>% sort()

    if (length(follow_up_version) > 1) {
        message("We found more than one follow up version!")
        message("We will parse all and add a collumn (follow_up_version) to identify each version")
    }

    clin <- plyr::adply(
        .data = follow_up_version,
        .margins =  1,
        .fun = function(x){
            message("Parsing follow up version: ", x)
            xpath <- paste0("//", x, ":follow_up")
            clin <- parseXML(files,xpath,clinical.info)
            clin$follow_up_version <- x
            return(clin)
        }, .id = "follow_up_version"
    )

    col_idx <- grep("follow_up_version", names(clin))
    clin <- clin[, c(col_idx, (1:ncol(clin))[-col_idx])]
}

parseXML <- function(files, xpath, clinical.info ){
    clin <- NULL

    pb <- txtProgressBar(min = 0, max = length(files), style = 3)

    for (i in seq_along(files)) {

        xmlfile <- files[i]
        xml <- read_xml(xmlfile)
        doc = xmlParse(xmlfile)

        patient <- str_extract(xmlfile,"[:alnum:]{4}-[:alnum:]{2}-[:alnum:]{4}")
        # Test if this xpath exists before parsing it
        for (xpath.it in xpath) {
            if (gsub("\\/\\/","", unlist(stringr::str_split(xpath.it,":"))[1]) %in% names(xml_ns(xml))){
                nodes <- getNodeSet(doc,xpath.it)
                if (length(nodes) == 0) next;
                df <- NULL
                for (j in 1:length(nodes)) {
                    df.aux <- xmlToDataFrame(nodes = nodes[j])
                    if (NA %in% colnames(df.aux)) df.aux <- df.aux[,!is.na(colnames(df.aux))]
                    if (nrow(df.aux) == 0) next

                    if (j == 1) {

                        df <- df.aux
                    } else {
                        df <- rbind.fill(df,df.aux)
                    }
                }

                df$bcr_patient_barcode <- patient
                if (i == 1) {
                    clin <- df
                } else {
                    clin <- rbind.fill(clin,df)
                }
                setTxtProgressBar(pb, i)
            }
        }
    }
    close(pb)
    return(clin)
}

#' @title Retrieve table with TCGA molecular subtypes
#' @description
#'   PanCancerAtlas_subtypes is a curated table with molecular subtypes for 24 TCGA cancer types
#' @export
#' @examples
#' molecular.subtypes <- PanCancerAtlas_subtypes()
#' @return a data.frame with barcode and molecular subtypes for 24 cancer types
PanCancerAtlas_subtypes <- function(){
    return(pancan2018)
}

#' @title Retrieve molecular subtypes for a given tumor
#' @description
#'   TCGAquery_subtype Retrieve molecular subtypes for a given tumor
#' @param tumor is a cancer Examples:
#' \tabular{lllll}{
#' lgg   \tab gbm \tab luad \tab stad \tab brca\cr
#' coad \tab read \tab  \tab  \tab
#'}
#' @export
#' @examples
#' dataSubt <- TCGAquery_subtype(tumor = "lgg")
#' @return a data.frame with barcode and molecular subtypes
TCGAquery_subtype <- function(tumor){
    available <- c("ACC",
                   "BRCA",
                   "BLCA",
                   "CESC",
                   "CHOL",
                   "COAD",
                   "ESCA",
                   "GBM",
                   "HNSC",
                   "KICH",
                   "KIRC",
                   "KIRP",
                   "LGG",
                   "LIHC",
                   "LUAD",
                   "LUSC",
                   "PAAD",
                   "PCPG",
                   "PRAD",
                   "READ",
                   "SKCM",
                   "SARC",
                   "STAD",
                   "THCA",
                   "UCEC",
                   "UCS",
                   "UVM"
    )
    if (
        grepl(
            paste(c(available,"all"),collapse = "|"), tumor,
            ignore.case = TRUE
        )
    ) {

        doi <- c(
            "acc"  = "doi:10.1016/j.ccell.2016.04.002",
            "aml"  = "doi:10.1056/NEJMoa1301689",
            "blca" = "doi:10.1016/j.cell.2017.09.007",
            "brca" = "doi.org/10.1016/j.ccell.2018.03.014",
            "cesc" = "doi:10.1038/nature21386",
            "chol" = "doi:10.1016/j.celrep.2017.02.033",
            "coad" = "doi:10.1038/nature11252",
            "esca" = "doi:10.1038/nature20805",
            "gbm"  = "doi:10.1016/j.cell.2015.12.028",
            "lgg"  = "doi:10.1016/j.cell.2015.12.028",
            "lihc"  = "https://doi.org/10.1016/j.cell.2017.05.046",
            "hnsc" = "doi:10.1038/nature14129",
            "kich" = "doi:10.1016/j.ccr.2014.07.014",
            "kirc" = "doi:10.1038/nature12222",
            "kirp" = "doi:10.1056/NEJMoa1505917",
            "lihc" = "doi:10.1016/j.cell.2017.05.046",
            "luad" = "doi:10.1038/nature13385",
            "lusc" = "doi:10.1038/nature11404",
            "paad"  = "doi:10.1016/j.ccell.2017.07.007",
            "ovca" = "doi:10.1038/nature10166",
            "pancan"="doi:10.1016/j.cell.2014.06.049",
            "pcpg" = "doi:10.1016/j.ccell.2017.01.001",
            "prad" = "doi:10.1016/j.cell.2015.10.025",
            "read" = "doi:10.1038/nature11252",
            "sarc" = "doi:10.1016/j.cell.2017.10.014",
            "skcm" = "doi:10.1016/j.cell.2015.05.044",
            "stad" = "doi:10.1038/nature13480",
            "thca" = "doi:10.1016/j.cell.2014.09.050",
            "ucec" = "doi:10.1038/nature12113",
            "ucs"  = "doi:10.1016/j.ccell.2017.02.010",
            "uvm"  = "doi:10.1016/j.ccell.2017.07.003"
        )
        if(tolower(tumor) != "all") {
            message(
                paste0(
                    tolower(tumor),
                    " subtype information from:",
                    doi[tolower(tumor)]
                )
            )
        }
        if(tolower(tumor) == "all") {
            all <- NULL
            for(i in available){
                try({
                    aux <- TCGAquery_subtype(i)
                    aux$Disease <- toupper(i)
                    aux$doi <- doi[i]
                    if(is.null(all)) all <- aux
                    else all <- plyr::rbind.fill(all,aux)
                })
            }
            idx <- which(colnames(all) == "doi")
            all <- all[, c(idx, (1:ncol(all))[-idx])]

            idx <- which(colnames(all) == "Disease")
            all <- all[, c(idx, (1:ncol(all))[-idx])]

            return(all)
        }

        # COAD and READ are in the same object
        if(tolower(tumor) == "read") tumor <- "coad"

        # The object with the gbm and lgg classification are the same
        # source: http://dx.doi.org/10.1016/j.cell.2015.12.028
        if(tolower(tumor) %in% c("lgg","gbm")) {
            aux <- get("lgg.gbm.subtype")
            if(tolower(tumor) == "gbm"){
                aux <- subset(aux,aux$Study == "Glioblastoma multiforme")
            } else {
                aux <- subset(aux,aux$Study != "Glioblastoma multiforme")
            }
            return (aux)
        }
        return(get(paste0(tolower(tumor),".subtype")))
    } else {
        stop("For the moment we have only subtype for:\no ", paste(available,collapse = "\no "))
    }
}


#' @title Retrieve molecular subtypes for given TCGA barcodes
#' @description
#'   TCGA_MolecularSubtype Retrieve molecular subtypes from TCGA consortium for a given set of barcodes
#' @param barcodes is a vector of TCGA barcodes
#' @export
#' @examples
#' TCGA_MolecularSubtype("TCGA-60-2721-01A-01R-0851-07")
#' @return List with $subtypes attribute as a dataframe with barcodes,
#' samples, subtypes, and colors. The $filtered attribute is returned as filtered samples with no subtype info
TCGA_MolecularSubtype <- function(barcodes){
    tabPanCancer <- as.data.frame(PanCancerAtlas_subtypes())
    tabSubtypeMergedNew <- subset(tabPanCancer, select = c("pan.samplesID",
                                                           "Subtype_Selected"))
    colnames(tabSubtypeMergedNew) <- c("samples", "subtype")
    rownames(tabSubtypeMergedNew) <- tabSubtypeMergedNew$samples
    tabSubtypeMergedNew <- cbind(tabSubtypeMergedNew, color = rep(0,
                                                                  nrow(tabSubtypeMergedNew)))
    TabSubtypesCol_merged <- TabSubtypesCol_merged[!duplicated(TabSubtypesCol_merged$samples),
    ]
    commonSamples <- intersect(tabSubtypeMergedNew$samples, TabSubtypesCol_merged$samples)
    rownames(TabSubtypesCol_merged) <- TabSubtypesCol_merged$samples
    tabSubtypeMergedNew[commonSamples, "color"] <- TabSubtypesCol_merged[commonSamples,
                                                                         "color"]
    dataTableSubt <- tabSubtypeMergedNew
    dataTableSubt$samples <- as.character(dataTableSubt$samples)
    dataTableSubt.samples.stripped <- sapply(as.character(dataTableSubt$samples), function(x) paste(unlist(stringr::str_split(x,
                                                                                                                              "-"))[1:3], collapse = "-"))
    dataTableSubt$patients<- dataTableSubt.samples.stripped

    barcodes <- as.character(barcodes)
    patients <- sapply(barcodes, function(x) paste(unlist(stringr::str_split(x,
                                                                             "-"))[1:3], collapse = "-"))

    #barcodes and patients with no subtype info
    filt.p <- c()
    filt.b <- c()

    df.barcodes_patID<-data.frame("barcodes"= barcodes, "patID"=unlist(patients),
                                  row.names = 1:length(barcodes), stringsAsFactors = FALSE)


    #View(df.barcodes_patID)

    for (p in patients) {

        if (p %in% unlist(dataTableSubt.samples.stripped) == FALSE){
            filt.p <- c(filt.p, p)
            #print(p)

            #filt.p is a vector containing patients with no subtype info
        }
    }

    for (b in barcodes) {

        if (b %in% unlist(dataTableSubt$samples) == FALSE){
            filt.b <- c(filt.b, b)
            #print(b)

            #filt.b is a vector containing samples with no subtype info
        }
    }

    if (length(filt.p) > 0) {
        message("the following TCGA barcodes/patients with no subtypes were filtered:")

        ###Keeping only patients/barcodes with available subtype info

        patients.with.sub <- unlist(patients[patients %in% filt.p ==
                                                 FALSE])

        idx.barcodes<-which(df.barcodes_patID$barcodes%in%filt.b ==FALSE)

        barcodes.with.sub<- df.barcodes_patID[idx.barcodes,]$barcodes

        ###indices of barcodes with available molecular subtype info
        ###if a patient Id is in filt.p and in filt.b
        idx.patient <- which(df.barcodes_patID$patID %in% filt.p ==FALSE)
        idx.barcodes <- which(df.barcodes_patID$barcodes %in% filt.b ==FALSE)
        idx.df<-intersect(idx.barcodes, idx.patient)

        ###dataframe with barcodes and patients IDs with available moolecular subtypes

        #df.barcodes_patID[idx.df,])

        idx1 <- which(dataTableSubt$samples %in% barcodes.with.sub)
        idx2 <- which(dataTableSubt$patients %in% patients.with.sub)
        idx<-intersect(idx1, idx2)

        Subtypes <- dataTableSubt[idx, ]

        #matching barcodes so they have the same order as they were provided in arguments
        Subtypes <- Subtypes[match(Subtypes$samples, df.barcodes_patID[idx.df,]$barcodes), ]

        filt <- setdiff(df.barcodes_patID$barcodes, Subtypes$samples)
        return(list(subtypes = Subtypes, filtered = filt))
    } else {
        message("All barcodes have available molecular subtype info")
        filt <- c()
        idx.patient <- which(dataTableSubt$samples %in% df.barcodes_patID$barcodes)
        Subtypes <- as.data.frame(dataTableSubt[idx.patient, ])
        Subtypes <- Subtypes[match(df.barcodes_patID$barcodes, Subtypes$samples), ]

        ##filt will be empty because all samples have molecular subtype info
        return(list(subtypes = Subtypes, filtered = filt))
    }
}

#' @title Filters TCGA barcodes according to purity parameters
#' @description
#'   TCGAtumor_purity Filters TCGA samples using 5 estimates from 5 methods as thresholds.
#' @param barcodes is a vector of TCGA barcodes
#' @param estimate uses gene expression profiles of 141 immune genes and 141 stromal genes
#' @param absolute which uses somatic copy-number data (estimations were available for only 11 cancer types)
#' @param lump (leukocytes unmethylation for purity), which averages 44 non-methylated immune-specific CpG sites
#' @param ihc as estimated by image analysis of haematoxylin and eosin stain slides produced by the Nationwide Childrens Hospital Biospecimen Core Resource
#' @param cpe CPE is a derived consensus measurement as the median purity level after normalizing levels from all methods to give them equal means and s.ds
#' @export
#' @examples
#' dataTableSubt <- TCGAtumor_purity("TCGA-60-2721-01A-01R-0851-07",
#'                           estimate = 0.6,
#'                           absolute = 0.6,
#'                           ihc = 0.8,
#'                           lump = 0.8,
#'                           cpe = 0.7)
#' @return List with $pure_barcodes attribute as a vector of pure samples and $filtered attribute as filtered samples with no purity info
TCGAtumor_purity <- function(barcodes, estimate, absolute, lump, ihc, cpe){

    Tumor.purity.L <- Tumor.purity
    barcodes <= as.character(barcodes)
    Tumor.purity.L$Sample.ID <- as.character(Tumor.purity$Sample.ID)
    Tumor.purity.L$ESTIMATE <- as.numeric(gsub(",", ".", Tumor.purity$ESTIMATE))
    Tumor.purity.L$ABSOLUTE <- as.numeric(gsub(",", ".", Tumor.purity$ABSOLUTE))
    Tumor.purity.L$LUMP <- as.numeric(gsub(",", ".", Tumor.purity$LUMP))
    Tumor.purity.L$IHC <- as.numeric(gsub(",", ".", Tumor.purity$IHC))
    Tumor.purity.L$CPE <- as.numeric(gsub(",", ".", Tumor.purity$CPE))

    #print(head(Tumor.purity.L))
    samples.id <- sapply(barcodes, function(x) paste(unlist(stringr::str_split(x, "-"))[1:4], collapse = "-"))

    df.barcodes_sampID <- data.frame(
        barcodes = barcodes,
        sampID = samples.id,
        row.names = 1:length(barcodes)
    )
    filt.s <- c()

    for(s in samples.id){
        if (s %in% Tumor.purity$Sample.ID == FALSE)
            filt.s <- c(filt.s, s)
    }

    if(length(filt.s)>0){
        message("the following TCGA barcodes do not have info on tumor purity:")
        filt <- as.character(df.barcodes_sampID[which(df.barcodes_sampID$sampID %in% filt.s),]$barcodes)
        print(filt)
    } else filt <- c()

    samples.filtered<-unlist(samples.id[samples.id %in% filt.s == FALSE])

    idx.samples <- which(
        Tumor.purity.L$Sample.ID %in% samples.filtered
        & (Tumor.purity.L$ESTIMATE >= estimate | Tumor.purity.L$ESTIMATE == 'NaN')
        & (Tumor.purity.L$ABSOLUTE >= absolute| Tumor.purity.L$ABSOLUTE == 'NaN')
        & (Tumor.purity.L$IHC >= ihc | Tumor.purity.L$IHC == 'NaN')
        & (Tumor.purity.L$LUMP >= lump | Tumor.purity.L$LUMP == 'NaN')
        & (Tumor.purity.L$CPE >= cpe | Tumor.purity.L$CPE == 'NaN')
    )


    df.purity <- Tumor.purity.L[idx.samples,]

    idx <- which(df.barcodes_sampID$sampID%in%df.purity$Sample.ID)

    filtered.barcodes <- as.character(df.barcodes_sampID[idx,]$barcodes)

    return(list(pure_barcodes = filtered.barcodes, filtered = filt))
}

context("query_clinical")

test_that("TCGAquery_SampleTypes returns the correct barcodes", {
    barcode <- c("TCGA-B0-4698-01Z-00-DX1","TCGA-CZ-4863-02Z-00-DX1")
    expect_equal(TCGAquery_SampleTypes(barcode,c("TR")),barcode[2])
    expect_equal(TCGAquery_SampleTypes(barcode,c("TP","TR")),barcode)
    expect_equal(TCGAquery_SampleTypes(barcode,c("TP")),barcode[1])
    expect_equal(TCGAquery_SampleTypes(barcode,c("TN")),"Error message: one or more sample types do not exist")
})


test_that("GDCquery_clinic populates correctly the data", {
    skip_on_bioc()
    results <- GDCquery_clinic(project = "BEATAML1.0-COHORT")
    results.2028 <- results[results$submitter_id == "2028",]
    expect_equal(results.2028$vital_status,"Alive")
    expect_true(
        all(c("BA2486D","BA2144D") %in%
                (str_split(results.2028$submitter_sample_ids,",") %>% unlist()))
    )
    expect_equal(results.2028$age_at_diagnosis %>% as.numeric() %% 365.25,134)
    expect_equal(as.integer(results.2028$age_at_diagnosis %>% as.numeric() / 365.25),56)

    results <- GDCquery_clinic(project = "ORGANOID-PANCREATIC", type = "clinical")
    results.42 <- results[results$submitter_id == "42",]
    expect_equal(results.42$ajcc_pathologic_stage,"Stage IIA")
    expect_equal(results.42$ethnicity,"not hispanic or latino")
    expect_equal(as.integer(results.2028$age_at_diagnosis %>% as.numeric() / 365.25),56)

    results <- GDCquery_clinic(project = "TCGA-LUAD")
    results.sample <- results[results$submitter_id == "TCGA-80-5608",]
    expect_equal(results.sample$vital_status,"Alive")
    expect_equal(results.sample$gender,"female")
    expect_equal(results.sample$ajcc_pathologic_stage,"Stage IA")

    # Sample without clinical data
    results.sample <- results[results$submitter_id == "TCGA-17-Z031",]
    expect_true(is.na(results.sample$vital_status))
    expect_true(is.na(results.sample$gender))
    expect_true(is.na(results.sample$ajcc_pathologic_stage))
})


test_that("TCGAquery_MatchedCoupledSampleTypes returns the correct barcodes", {
    barcode <- c(
        "TCGA-B0-4698-01Z-00-DX1",
        "TCGA-B0-4698-02Z-00-DX1",
        "TCGA-CD-4698-02Z-00-DX1",
        "TCGA-XO-4698-01Z-00-DX1",
        "TCGA-XO-4698-11Z-00-DX1"
    )

    expect_equal(TCGAquery_MatchedCoupledSampleTypes(barcode, c("TP","TR")),barcode[1:2])
    expect_equal(TCGAquery_MatchedCoupledSampleTypes(barcode, c("TP","NT")),barcode[4:5])
    expect_equal(TCGAquery_MatchedCoupledSampleTypes(barcode,c("TN","TP")),"Error message: one or more sample types do not exist")
    expect_equal(TCGAquery_MatchedCoupledSampleTypes(barcode,c("TN")),"Error message: exactly two types need to be provided")

})

test_that("TCGAquery_subtype returns the a data frame if exists data", {
    expect_equal(class(TCGAquery_subtype("lgg")),class(data.frame()))
    expect_equal(class(TCGAquery_subtype("all")),class(data.frame()))
    expect_error(TCGAquery_subtype("f"))
})


test_that("GDCprepare_clinic works if no follow up data is available", {

    skip_on_bioc()
    skip_if_offline()
    query <- GDCquery(
        project = "TCGA-LAML",
        data.category = "Clinical",
        data.format = "bcr xml"
    )

    GDCdownload(
        query = query,
        directory = "."
    )

    clinical <- GDCprepare_clinic(
        query = query,
        directory = ".",
        clinical.info = "patient"
    )

})

#' @title Download GDC data
#' @description
#'   Uses GDC API or GDC transfer tool to download gdc data
#'   The user can use query argument
#'   The data from query will be save in a folder: project/data.category
#' @param query A query for GDCquery function
#' @param token.file Token file to download controlled data (only for method = "client")
#' @param method Uses the API (POST method) or gdc client tool. Options "api", "client".
#' API is faster, but the data might get corrupted in the download, and it might need to be executed again
#' @param directory Directory/Folder where the data was downloaded. Default: GDCdata
#' @param files.per.chunk This will make the API method only download n (files.per.chunk) files at a time.
#' This may reduce the download problems when the data size is too large. Expected a integer number (example files.per.chunk = 6)
#' @importFrom tools md5sum
#' @importFrom utils untar
#' @import httr
#' @importFrom methods is
#' @export
#' @examples
#' \dontrun{
#' # Download clinical data from XML
#' query <- GDCquery(project = "TCGA-COAD", data.category = "Clinical")
#' GDCdownload(query, files.per.chunk = 200)
#' query <- GDCquery(
#'   project = "TARGET-AML",
#'   data.category = "Transcriptome Profiling",
#'   data.type = "miRNA Expression Quantification",
#'   workflow.type = "BCGSC miRNA Profiling",
#'   barcode = c("TARGET-20-PARUDL-03A-01R", "TARGET-20-PASRRB-03A-01R")
#' )
#' # data will be saved in:
#' # example_data_dir/TARGET-AML/harmonized/Transcriptome_Profiling/miRNA_Expression_Quantification
#' GDCdownload(query, method = "client", directory = "example_data_dir")
#' query_acc_gbm <- GDCquery(
#'   project = c("TCGA-ACC", "TCGA-GBM"),
#'   data.category = "Transcriptome Profiling",
#'   data.type = "Gene Expression Quantification",
#'   workflow.type = "STAR - Counts"
#' )
#' GDCdownload(
#'   query = query_acc_gbm,
#'   method = "api",
#'   directory = "example",
#'   files.per.chunk = 50
#' )
#' }
#' @return Shows the output from the GDC transfer tools
#' @author Tiago Chedraoui Silva
GDCdownload <- function(
        query,
        token.file,
        method = "api",
        directory = "GDCdata",
        files.per.chunk = NULL
) {
    isServeOK()
    if (missing(query)) stop("Please set query argument")

    if (!(method %in% c("api", "client"))) {
        stop("method arguments possible values are: 'api' or 'client'")
    }

    if (length(unique(getResults(query)$data_type)) > 1) {
        print(knitr::kable(sort(unique(getResults(query)$data_type)), col.names = "data_type in query"))
        stop("We can only download one data type. Please use data.type argument in GDCquery to filter results.")
    }

    dir.create(directory, showWarnings = FALSE, recursive = TRUE)
    for (proj in unique(unlist(query$project))) {
        message("Downloading data for project ", proj)
        query.aux <- query
        results <- getResults(query.aux)[getResults(query.aux)$project == proj, ]
        query.aux$results[[1]] <- results

        manifest <- getManifest(query.aux)

        path <- unique(
            file.path(
                proj,
                gsub(" ", "_", results$data_category),
                gsub(" ", "_", results$data_type)
            )
        )
        path <- file.path(directory, path)

        # Check if the files were already downloaded by this package
        manifest <- checkAlreadyDownloaded(path, manifest)

        # There is a bug in the API, if the files has the same name it will not download correctly
        # so method should be set to client if there are files with duplicated names
        # However for clinical XML recurrent and primary are the same file. So we will ignore that case
        if (nrow(manifest) > length(unique(manifest$filename))) method <- "client"

        if (nrow(manifest) != 0 & method == "client") {
            # There exists two options to download the data, using the query or using a manifest file
            # The second option was created to let users use legacy data or the API to search

            # This will find gdc clinet, if not installed it will install it
            gdc.client.bin <- GDCclientInstall()

            # Using the query argument we will organize the files to the user
            # Creates a file with the gdc manifest format
            readr::write_delim(manifest, "gdc_manifest.txt", delim = "\t")

            readr::write_delim(manifest, "gdc_client_configuration.dtt", delim = "\t")
            readr::write_lines(
                c("[download]", "retry_amount = 6", paste0("dir =", path)),
                file = "gdc_client_configuration.dtt"
            )
            cmd <- paste0(gdc.client.bin, " download -m gdc_manifest.txt --config gdc_client_configuration.dtt")

            dir.create(path, recursive = TRUE, showWarnings = FALSE)
            if (!missing(token.file)) cmd <- paste0(cmd, " -t ", token.file)

            # Download all the files in the manifest using gdc client
            message(paste0(
                "GDCdownload will download: ",
                humanReadableByteCount(sum(as.numeric(manifest$size)))
            ))
            message(paste0("Executing GDC client with the following command:\n", cmd))
            result <- tryCatch(
                {
                    system(cmd)
                },
                warning = function(w) {
                },
                error = function(e) {
                }
            )
        } else if (nrow(manifest) != 0 & method == "api") {
            if (nrow(manifest) > 1) {
                name <- paste0(gsub(" |:", "_", date()), ".tar.gz")
                unlink(name)
                message(
                    paste0(
                        "GDCdownload will download ", nrow(manifest), " files. A total of ",
                        humanReadableByteCount(sum(as.numeric(manifest$size)))
                    )
                )
            } else {
                # case with one file only. This is not at tar.gz
                name <- manifest$filename
                message(
                    paste0(
                        "GDCdownload will download: ",
                        humanReadableByteCount(sum(as.numeric(manifest$size)))
                    )
                )
            }

            server <- "https://api.gdc.cancer.gov/data/"

            if (is.null(files.per.chunk) & sum(as.numeric(manifest$size)) > 10^9) {
                message("The total size of files is big. We will download files in chunks")
                files.per.chunk <- floor(10^9 / mean(as.numeric(manifest$size)))
            }

            if (is.null(files.per.chunk)) {
                message(paste0("Downloading as: ", name))
                tryCatch(
                    {
                        GDCdownload.aux(server, manifest, name, path)
                    },
                    error = function(e) {
                        message("Download failed. We will retry with smaller chunks")
                        # split in groups of 100 MB
                        manifest <- checkAlreadyDownloaded(path, manifest)
                        step <- ceiling(100000000 / manifest$size[1])
                        if (step == 0) step <- 1
                        GDCdownload.by.chunk(server, manifest, name, path, step)
                    }
                )
            } else {
                step <- files.per.chunk
                # If error we will try another time.
                tryCatch(
                    {
                        GDCdownload.by.chunk(server, manifest, name, path, step)
                    },
                    error = function(e) {
                        message("At least one of the chunks download was not correct. We will retry")
                        manifest <- checkAlreadyDownloaded(path, manifest)
                        GDCdownload.by.chunk(server, manifest, name, path, step)
                    }
                )
            }
        } else {
            message("All samples have been already downloaded")
        }
    }
}

#' @title Get a Manifest from GDCquery output that can be used with GDC-client
#' @description
#' Get a Manifest from GDCquery output that can be used with GDC-client
#' @param query A query for GDCquery function
#' @param save Write Manifest to a txt file (tab separated)
#' @examples
#' query <- GDCquery(
#'   project = "TARGET-AML",
#'   data.category = "Transcriptome Profiling",
#'   data.type = "Gene Expression Quantification",
#'   workflow.type = "STAR - Counts",
#'   barcode = c("TARGET-20-PADZCG-04A-01R", "TARGET-20-PARJCR-09A-01R")
#' )
#' getManifest(query)
#' @export
getManifest <- function(query, save = FALSE) {
    manifest <- query$results[[1]][, c("file_id", "file_name", "md5sum", "file_size", "state")]
    colnames(manifest) <- c("id", "filename", "md5", "size", "state")
    if (save) {
        fname <- "gdc_manifest.txt"
        readr::write_delim(manifest, fname, delim = "\t")
        file <- file.path(getwd(), fname)
        message("Manifest saved as: ", file)
    }
    return(manifest)
}

GDCdownload.by.chunk <- function(
        server = "https://api.gdc.cancer.gov/data/",
        manifest,
        name = "TCGAbiolinks_download",
        path = ".",
        step = 1
) {
    for (idx in 0:ceiling(nrow(manifest) / step - 1)) {
        end <- ifelse(((idx + 1) * step) > nrow(manifest), nrow(manifest), ((idx + 1) * step))
        manifest.aux <- manifest[((idx * step) + 1):end, ]
        size <- humanReadableByteCount(sum(as.numeric(manifest.aux$size)))

        if (nrow(manifest.aux) > 1) {
            name.aux <- gsub("\\.tar", paste0("_", idx, ".tar"), name)
        } else {
            name.aux <- manifest.aux$filename
        }
        message(
            paste0(
                "Downloading chunk ", idx + 1, " of ", ceiling(nrow(manifest) / step),
                " (", nrow(manifest.aux), " files, size = ", size, ") ",
                "as ", name.aux
            )
        )
        repeat {
            ret <- GDCdownload.aux(server, manifest.aux, name.aux, path)
            if (ret == 1) break
        }
    }
}

GDCdownload.aux <- function(
        server = "https://api.gdc.cancer.gov/data/",
        manifest,
        name = "TCGAbiolinks_download",
        path = "."
) {
    result <- tryCatch(
        {
            bin <- getURL(
                server,
                POST,
                body = list(ids = list(manifest$id)),
                encode = "json",
                progress()
            )
            if (bin[[2]] == "405") {
                message("ERROR accessing GDC. Trying again...")
                bin <- getURL(
                    "https://api.gdc.cancer.gov/data/",
                    POST,
                    body = list(ids = list(manifest$id)),
                    encode = "json",
                    progress()
                )
            }
            writeBin(getURL(bin, content, as = "raw", encoding = "UTF-8"), name)

            if (nrow(manifest) > 1) {
                success <- untar(name)
                unlink(name) # remove tar
                if (success != 0) {
                    stop("There was an error in the download process, please execute it again")
                    return(-1)
                }
            }
            # moving to project/source/data_category/data_type/file_id
            for (i in seq_along(manifest$filename)) {
                if (nrow(manifest) > 1) file <- file.path(manifest$id[i], manifest$filename[i])
                if (nrow(manifest) == 1) file <- file.path(manifest$filename[i])
                id <- manifest$id[i]

                # Check status
                if (!(md5sum(file) == manifest$md5[i])) {
                    message(paste0("File corrupted:", file))
                    message("Run GDCdownload again to download it")
                    unlink(file)
                    next
                }
                if (nrow(manifest) > 1) {
                    move(file, file.path(path, file))
                }
                if (nrow(manifest) == 1) {
                    move(file, file.path(path, id, file))
                }
            }
            return(1)
        },
        warning = function(w) {
            return(1)
        },
        error = function(e) {
            unlink(name) # remove tar
            return(-1)
        }
    )

    if (result == -1) {
        stop(
            paste0(
                "There was an error in the download process (we might had a connection problem with GDC server).",
                "\nPlease run this function it again.",
                "\nTry using method = `client` or setting files.per.chunk to a small number."
            )
        )
    }
    message("Download completed")
}

humanReadableByteCount <- function(bytes) {
    unit <- 1000
    if (bytes < unit) {
        return(paste0(bytes + " B"))
    }
    exp <- floor(log(bytes) / log(unit))
    pre <- paste0(substr("KMGTPE", exp, exp))
    pre <- paste0(pre, "B")
    nb <- bytes / (unit^exp)
    return(paste(nb, pre))
}
GDCclientPath <- function() {
    global <- Sys.which("gdc-client")
    if (global != "") {
        return(global)
    }
    local <- dir(pattern = "gdc-client*[^zip]$")
    if (length(local) > 0) {
        return(dir(pattern = "gdc-client*[^zip]$", full.names = TRUE))
    }
    return("")
}

GDCclientExists <- function() {
    return(Sys.which("gdc-client.exe") != "" || Sys.which("gdc-client") != "" || length(dir(pattern = "gdc-client*[^zip]$") > 0))
}
#' @importFrom xml2 read_html
#' @importFrom downloader download
#' @importFrom rvest html_nodes html_attr %>%
GDCclientInstall <- function() {
    if (GDCclientExists()) {
        return(GDCclientPath())
    }

    links <- tryCatch(
        {
            read_html("https://gdc.cancer.gov/access-data/gdc-data-transfer-tool") %>%
                html_nodes("a") %>%
                html_attr("href")
        },
        error = function(e) {
            c(
                "https://gdc.cancer.gov/system/files/public/file/gdc-client_2.3_Ubuntu_x64-py3.8-ubuntu-20.04.zip",
                "https://gdc.cancer.gov/system/files/public/file/gdc-client_2.3_Windows_x64-py3.8-windows-2019.zip",
                "https://gdc.cancer.gov/system/files/public/file/gdc-client_2.3_OSX_x64-py3.8-macos-14.zip"
            )
        }
    )
    bin <- links[grep("public.*zip", links)]
    if (is.windows()) bin <- bin[grep("client*.*windows", bin, ignore.case = TRUE)]
    if (is.mac()) {
        if(Sys.info()["machine"] == "arm64"){
            bin <- bin[grep("client*.*OSX.*14", bin)]
        } else {
            bin <- bin[grep("client*.*OSX.*12", bin)]
        }
    }
    if (is.linux()) {
        if (grepl("ubuntu", Sys.info()["version"], ignore.case = TRUE)) {
            bin <- bin[grep("client*.*Ubuntu", bin)]
        } else {
            bin <- bin[grep("client*.*Cent", bin)]
        }
    }
    if (is.windows()) mode <- "wb" else mode <- "w"
    download(bin, basename(bin), mode = mode)
    unzip(basename(bin))
    if(is.mac()){
        unzip(gsub("-py3.8-macos-14|-py3.8-macos-12","",basename(bin)))
    }
    Sys.chmod("gdc-client")
    return(GDCclientPath())
}

checkAlreadyDownloaded <- function(path, manifest) {
    files2Download <- !(file.exists(file.path(path, manifest$id, manifest$filename)) | file.exists(file.path(path, manifest$filename)))
    if (any(files2Download == FALSE)) {
        message(
            "Of the ", nrow(manifest), " files for download ",
            table(files2Download)["FALSE"], " already exist."
        )
        if (any(files2Download == TRUE)) {
            message("We will download only those that are missing ones.")
        }
    }
    return(manifest[files2Download, ])
}

#' TCGA samples with their Pam50 subtypes
#'
#' A dataset containing the Sample Ids from TCGA and PAM50 subtyping attributes of 4768 tumor patients
#'
#' @format A data frame with 4768 rows and 3 variables:
#' \describe{
#'   \item{samples}{Sample ID from TCGA barcodes, character string}
#'   \item{subtype}{Pam50 classification, character string}
#'   \item{color}{color, character string}
#'   ...
#' }

"TabSubtypesCol_merged"

#' @title Survival analysis with univariate Cox regression package (dnet)
#' @description TCGAvisualize_SurvivalCoxNET can help an user to identify a group of survival genes that are
#' significant from univariate Kaplan Meier Analysis and also for Cox Regression.
#' It shows in the end a network build with community of genes with similar range of pvalues from
#' Cox regression (same color) and that interaction among those genes is already validated in
#' literatures using the STRING database (version 9.1).
#' TCGAvisualize_SurvivalCoxNET perform survival analysis with univariate Cox regression
#' and package (dnet) using following functions wrapping from these packages:
#' \enumerate{
#' \item survival::coxph
#' \item igraph::subgraph.edges
#' \item igraph::layout.fruchterman.reingold
#' \item igraph::spinglass.community
#' \item igraph::communities
#' \item dnet::dRDataLoader
#' \item dnet::dNetInduce
#' \item dnet::dNetPipeline
#' \item dnet::visNet
#' \item dnet::dCommSignif
#' }
#' @details TCGAvisualize_SurvivalCoxNET allow user to perform the complete workflow using coxph
#' and dnet package related to survival analysis with an identification of gene-active networks from
#' high-throughput omics data using gene expression and clinical data.
#' \enumerate{
#' \item Cox regression survival analysis to obtain hazard ratio (HR) and p-values
#' \item fit a Cox proportional hazards model and ANOVA (Chisq test)
#' \item Network comunites
#' \item An igraph object that contains a functional protein  association network in human.
#' The network is extracted from the STRING database (version 9.1).
#' Only those associations with medium confidence (score>=400) are retained.
#' \item restrict to those edges with high confidence (score>=700)
#' \item extract network that only contains genes in pvals
#' \item Identification of gene-active network
#' \item visualisation of the gene-active network itself
#' \item the layout of the network visualisation (fixed in different visuals)
#' \item color nodes according to communities (identified via a spin-glass model and simulated annealing)
#' \item node sizes according to degrees
#' \item highlight different communities
#' \item visualize the subnetwork
#' }
#' @param clinical_patient is a data.frame using function 'clinic' with information
#' related to barcode / samples such as bcr_patient_barcode, days_to_death ,
#' days_to_last_followup , vital_status, etc
#' @param dataGE is a matrix of Gene expression (genes in rows, samples in cols) from TCGAprepare
#' @param Genelist is a list of gene symbols where perform survival KM.
#' @param org.Hs.string an igraph object that contains a functional protein association network
#' in human. The network is extracted from the STRING database (version 10).
#' @param scoreConfidence restrict to those edges with high confidence (eg. score>=700)
#' @param titlePlot is the title to show in the final plot.
#' @return net IGRAPH with related Cox survival genes in community (same pval and color) and with
#' interactions from STRING database.
TCGAvisualize_SurvivalCoxNET <- function(
        clinical_patient,
        dataGE,
        Genelist,
        org.Hs.string,
        scoreConfidence = 700,
        titlePlot = "TCGAvisualize_SurvivalCoxNET Example"
){

    check_package("survival")
    check_package("dnet")
    check_package("igraph")

    combined_score <- NULL

    pdf("SurvivalCoxNETOutput.pdf", width = 15, height = 10)

    ## fit a Cox proportional hazards model for age, gender, tumor type
    cfu <- clinical_patient[clinical_patient[,"bcr_patient_barcode"] %in% substr(colnames(dataGE),1,12),]
    rownames(cfu) <- cfu$bcr_patient_barcode
    cfu <- cfu %>% dplyr::select(
        "bcr_patient_barcode",
        "days_to_last_follow_up",
        "days_to_death",
        "vital_status",
        "age_at_diagnosis",
        "gender"
    )

    rownames(cfu) <- cfu$bcr_patient_barcode
    cfu <- cfu[,-1]
    colnames(cfu)   <- c("time","timeDead","status","Age","Gender")

    cfu[which(cfu$status == "Alive"),"status"]<-0
    cfu[which(cfu$status == "Dead"),"time"]<- cfu[which(cfu$status=="Dead"),"timeDead"]
    cfu[which(cfu$status == "Dead"),"status"]<-1
    cfu$Gender <- tolower(cfu$Gender)
    cfu <- cfu[,-2]
    cfu <- as.data.frame(subset(cfu, select=c("time","status")))
    cfu$time <- as.numeric(cfu$time)
    cfu$status <- as.numeric(cfu$status)

    data <-as.data.frame(dataGE)
    colnames(data) <- substr(colnames(data),1,12)
    commonSamples <- intersect(rownames(cfu), colnames(data))

    data <- t(data)
    data <- data[commonSamples,Genelist]

    #rownames(tabSurvKMfilt) <- tabSurvKMfilt$mRNA
    #colnames(Cancer_rnaseqv2) <- substr(colnames(Cancer_rnaseqv2),1,12)
    #md_selected<-log2(Cancer_rnaseqv2[rownames(tabSurvKMfilt),rownames(cfu)])

    md_selected <- data
    pd <- cfu

    ## survival analysis to obtain hazard ratio (HR) and pvaules
    HR <- rep(1, ncol(md_selected))
    pvals <- rep(1, ncol(md_selected))
    for(i in 1:ncol(md_selected)){
        ## fit a Cox proportional hazards model
        data <- cbind(pd, gene = md_selected[,i])
        data <- data [which(data$gene !="-Inf"),]

        fit <- survival::coxph(formula=survival::Surv(time,status) ~., data=data)
        ## ANOVA (Chisq test)
        cox <- summary(fit)
        cat(paste( (ncol(md_selected)-i),".",sep=""))
        # res <- as.matrix(anova(fit, test="Chisq"))
        HR[i] <- as.numeric(cox$coefficients[2])
        pvals[i] <- as.numeric(cox$logtest[3])
    }

    names(HR) <- colnames(md_selected)
    names(pvals) <- colnames(md_selected)
    # Network comunites >>=

    # An igraph object that contains a functional protein association network
    # in human. The network is extracted from the STRING database (version 9.1).
    # Only those associations with medium confidence (score>=400) are retained.
    #  org.Hs.string <- dRDataLoader(RData='org.Hs.string')
    # restrict to those edges with high confidence (score>=700)
    # with(org.Hs.string,{
    #    network <- subgraph.edges(org.Hs.string, eids=E(org.Hs.string)[combined_score>=scoreConfidence])})
    #network
    network <- igraph::subgraph.edges(org.Hs.string, eids=igraph::E(org.Hs.string)[combined_score>=scoreConfidence])


    # extract network that only contains genes in pvals
    ind <- match(igraph::V(network)$symbol, names(pvals))
    ## for extracted graph
    nodes_mapped <- igraph::V(network)$name[!is.na(ind)]
    network <- dnet::dNetInduce(
        g = network,
        nodes_query = nodes_mapped,
        knn = 0,
        remove.loops = FALSE,
        largest.comp = TRUE
    )
    igraph::V(network)$name <- igraph::V(network)$symbol

    # Identification of gene-active network
    net <- dnet::dNetPipeline(
        g = network,
        pval = pvals,
        method = "customised",
        significance.threshold = 5e-02
    )
    # visualisation of the gene-active network itself
    ## the layout of the network visualisation (fixed in different visuals)
    glayout <- igraph::layout.fruchterman.reingold(net)
    ## color nodes according to communities (identified via a spin-glass model and simulated annealing)
    com <- igraph::spinglass.community(net, spins=25)
    com$csize <- sapply(1:length(com),function(x) sum(com$membership==x))
    vgroups <- com$membership
    # Suppose colormap is a list of colors, e.g.
    colormap <- c("yellow", "darkorange")
    palette.name <- colorRampPalette(colormap)
    mcolors <- palette.name(length(com))
    vcolors <- mcolors[vgroups]
    com$significance <- dnet::dCommSignif(net, com)
    ## node sizes according to degrees
    vdegrees <- igraph::degree(net)
    ## highlight different communities
    mark.groups <- igraph::communities(com)
    mark.col <- adjustcolor(mcolors, alpha.f = 0.2)
    mark.border <- adjustcolor(mcolors, alpha.f = 0.2)
    edge.color <- c("#C0C0C0", "#000000")[igraph::crossing(com,net)+1]
    edge.color <- adjustcolor(edge.color, alpha.f = 0.5)
    ## visualise the subnetwrok
    dnet::visNet(
        g = net,
        glayout = glayout,
        vertex.label = igraph::V(net)$geneSymbol,
        vertex.color = vcolors,
        vertex.frame.color = vcolors,
        vertex.shape = "sphere",
        mark.groups = mark.groups,
        mark.col = mark.col,
        mark.border = mark.border,
        mark.shape = 1,
        mark.expand = 10,
        edge.color = edge.color,
        newpage = FALSE,
        vertex.label.color = "blue",
        vertex.label.dist = 0.4,
        vertex.label.font = 2,
        main = titlePlot
    )
    legend_name <- paste("C",1:length(mcolors)," (n=",com$csize,", pval=",signif(com$significance,digits=2),")",sep='')
    legend("topleft", legend=legend_name, fill=mcolors, bty="n", cex=1.4)

    dev.off()

    return(net)

}

#' @title Principal components analysis (PCA) plot
#' @description
#'   TCGAvisualize_PCA performs a principal components analysis (PCA) on the given data matrix
#'   and returns the results as an object of class prcomp, and shows results in PCA level.
#' @param dataFilt A filtered dataframe or numeric matrix where each row represents a gene,
#' each column represents a sample from function TCGAanalyze_Filtering
#' @param dataDEGsFiltLevel table with DEGs, log Fold Change (FC), false discovery rate (FDR),
#' the gene expression level, etc, from function TCGAanalyze_LevelTab.
#' @param ntopgenes number of DEGs genes to plot in PCA
#' @param group1 a string containing the barcode list of the samples in in control group
#' @param group2 a string containing the barcode list of the samples in in disease group
#' the name of the group
#' @import ggplot2
#' @export
#' @return principal components analysis (PCA) plot of PC1 and PC2
#' @examples
#' # normalization of genes
#' dataNorm <- TCGAbiolinks::TCGAanalyze_Normalization(tabDF = dataBRCA, geneInfo = geneInfo,
#' method = "geneLength")
#' # quantile filter of genes
#' dataFilt <- TCGAanalyze_Filtering(tabDF = dataBRCA, method = "quantile", qnt.cut =  0.25)
#' # Principal Component Analysis plot for ntop selected DEGs
#'     # selection of normal samples "NT"
#'     group1 <- TCGAquery_SampleTypes(colnames(dataFilt), typesample = c("NT"))
#'     # selection of normal samples "TP"
#'     group2 <- TCGAquery_SampleTypes(colnames(dataFilt), typesample = c("TP"))
#' pca <- TCGAvisualize_PCA(dataFilt,dataDEGsFiltLevel, ntopgenes = 200, group1, group2)
TCGAvisualize_PCA <- function(
        dataFilt,dataDEGsFiltLevel,
        ntopgenes,group1, group2
) {

    ComparisonSelected <- "Normal vs Tumor"

    TitlePlot <- paste0(
        "PCA ", "top ", ntopgenes,
        " Up and down diff.expr genes between ",
        ComparisonSelected
    )

    dataFilt <- dataFilt[!duplicated(GenesCutID(rownames(dataFilt))),]
    rownames(dataFilt) <- GenesCutID(rownames(dataFilt))

    Genelist <- rownames(dataDEGsFiltLevel)[1:ntopgenes]
    commonGenes <- intersect(Genelist, rownames(dataFilt) )
    expr2 <- dataFilt[commonGenes,]
    color1 <- "blue"
    color2 <- "red"

    nsample1 <- length(group1)
    nsample2 <- length(group2)

    #sampleColors <- rep(c(color1,color2), c(nsample1, nsample2))
    #sampleColors <- rep(c("blue","red"), c(length(group1),
    #                     length(group2)))
    sampleColors <- c(
        rep("blue", length(group1)),
        rep("red", length(group2))
    )

    names(sampleColors) <- colnames(expr2)
    cancer.pca <- stats::prcomp(t(expr2))

    g <- ggbiplot(
        cancer.pca,
        obs.scale = 1,
        var.scale = 1,
        groups = sampleColors,
        ellipse = TRUE,
        circle = FALSE
    )

    g <- g + scale_colour_manual(
        name = "",
        values = c("blue" = "blue","red" = "red"
        ))

    g <- g + geom_point(aes(colour = sampleColors), size = 3)
    g <- g + theme(legend.direction = 'horizontal',  legend.position = 'top')
    g <- g + ggtitle(TitlePlot)
    print(g)

    return(cancer.pca)
}

#' @title barPlot for a complete Enrichment Analysis
#' @description
#' The figure shows canonical pathways significantly overrepresented (enriched) by the DEGs
#' (differentially expressed genes).
#' The most statistically significant canonical pathways identified
#' in DEGs list are listed according to their p value corrected FDR (-Log) (colored bars)
#' and the ratio of list genes found in each pathway over the total number of
#' genes in that pathway (Ratio, red line).
#' @param tf is a list of gene symbols
#' @param GOBPTab is results from TCGAanalyze_EAcomplete related to Biological Process (BP)
#' @param GOCCTab is results from TCGAanalyze_EAcomplete related to Cellular Component (CC)
#' @param GOMFTab is results from TCGAanalyze_EAcomplete related to Molecular Function (MF)
#' @param PathTab is results from TCGAanalyze_EAcomplete related to Pathways EA
#' @param nBar is the number of bar histogram selected to show (default = 10)
#' @param nRGTab is the gene signature list with gene symbols.
#' @param filename Name for the pdf. If null it will return the plot.
#' @param color A vector of colors for each barplot. Deafult:  c("orange", "cyan","green","yellow")
#' @param text.size Text size
#' @param xlim Upper limit of the x-axis.
#' @param mfrow Vector with number of rows/columns of the plot. Default  2 rows/2 columns "c(2,2)"
#' @param fig.width Default 30
#' @param fig.height Default 15
#' @export
#' @import graphics
#' @return Complete barPlot from Enrichment Analysis showing significant (default FDR < 0.01)
#' BP,CC,MF and pathways enriched by list of genes.
#' @examples
#' Genelist <- c("FN1","COL1A1")
#' ansEA <- TCGAanalyze_EAcomplete(TFname="DEA genes Normal Vs Tumor",Genelist)
#' TCGAvisualize_EAbarplot(tf = rownames(ansEA$ResBP),
#'          GOBPTab = ansEA$ResBP,
#'          GOCCTab = ansEA$ResCC,
#'          GOMFTab = ansEA$ResMF,
#'         PathTab = ansEA$ResPat,
#'          nRGTab = Genelist,
#'          nBar = 10,
#'          filename="a.pdf")
#' \dontrun{
#' Genelist <- rownames(dataDEGsFiltLevel)
#' system.time(ansEA <- TCGAanalyze_EAcomplete(TFname="DEA genes Normal Vs Tumor",Genelist))
#' # Enrichment Analysis EA (TCGAVisualize)
#' # Gene Ontology (GO) and Pathway enrichment barPlot
#' TCGAvisualize_EAbarplot(tf = rownames(ansEA$ResBP),
#'          GOBPTab = ansEA$ResBP,
#'          GOCCTab = ansEA$ResCC,
#'          GOMFTab = ansEA$ResMF,
#'         PathTab = ansEA$ResPat,
#'          nRGTab = Genelist,
#'          nBar = 10)
#'}
TCGAvisualize_EAbarplot <- function(
        tf,
        GOMFTab,
        GOBPTab,
        GOCCTab,
        PathTab,
        nBar,
        nRGTab,
        filename = "TCGAvisualize_EAbarplot_Output.pdf",
        text.size = 1.0,
        mfrow = c(2, 2),
        xlim = NULL,
        fig.width = 30,
        fig.height = 15,
        color = c("orange", "cyan","green","yellow")
){

    check_package("EDASeq")

    if(!is.null(filename)) {
        pdf(filename, width = fig.width, height = fig.height)
    }

    splitFun <- function(tf, Tab, nBar){
        tmp <- lapply(Tab[tf, ], function(x) strsplit(x, ";"))
        names(tmp) <- NULL
        tmp <- matrix(unlist(tmp), ncol = 4, byrow = TRUE)
        if (nrow(tmp) == 0 | tmp[1, 1] == "NA") return(matrix(0, ncol = 2))
        tmp <- tmp[tmp[, 1] != "NA", , drop = FALSE]
        tmp <- as.data.frame(tmp, stringsAsFactors = FALSE)
        tmp[, 2] <- as.numeric(sub(" FDR= ", "", tmp[, 2]))
        tmp[, 3] <- as.numeric(unlist(strsplit(matrix(unlist(strsplit(tmp[, 3],
                                                                      "=")), nrow = 2)[2, ], ")")))
        tmp[, 4] <- as.numeric(unlist(strsplit(matrix(unlist(strsplit(tmp[, 4],
                                                                      "=")), nrow = 2)[2, ], ")")))

        if (nrow(tmp) < nBar) nBar <- nrow(tmp)

        tmp[, 2] <- -log10(tmp[, 2])
        o <- order(tmp[, 2], decreasing = TRUE)
        toPlot <- tmp[o[nBar:1], 1:2]
        toPlot[, 1] <- paste0(toPlot[, 1], " (n=", tmp[o[nBar:1], 4], ")")
        toPlot[, 3] <- tmp[o[nBar:1], 4]/tmp[o[nBar:1], 3]

        return(toPlot)
    }
    par(mfrow = mfrow)

    if(!missing(GOBPTab)){
        if(!is.null(GOBPTab) & !all(is.na(GOBPTab))){
            # Plotting GOBPTab
            toPlot <- splitFun(tf, GOBPTab, nBar)
            xAxis <- EDASeq::barplot(toPlot[, 2], horiz = TRUE, col = color[1],
                                     main = "GO:Biological Process", xlab = "-log10(FDR)",xlim = xlim)
            labs <- matrix(unlist(strsplit(toPlot[, 1], "~")), nrow = 2)[2, ]
            text(x = 1, y = xAxis, labs, pos = 4, cex = text.size)
            lines(x = toPlot[, 3], y = xAxis, col = "red")
            points(x = toPlot[, 3], y = xAxis, col = "red")
            axis(side = 3, at = pretty(range(0:1)), col = "red")
        }
    }
    if(!missing(GOCCTab)){
        if(!is.null(GOCCTab) & !all(is.na(GOCCTab))){
            # Plotting GOCCTab
            toPlot <- splitFun(tf, GOCCTab, nBar)
            xAxis <- EDASeq::barplot(toPlot[, 2], horiz = TRUE, col = color[2],
                                     main = "GO:Cellular Component", xlab = "-log10(FDR)",xlim = xlim)
            labs <- matrix(unlist(strsplit(toPlot[, 1], "~")), nrow = 2)[2, ]
            text(x = 1, y = xAxis, labs, pos = 4, cex = text.size)
            lines(x = toPlot[, 3], y = xAxis, col = "red")
            points(x = toPlot[, 3], y = xAxis, col = "red")
            axis(side = 3, at = pretty(range(0:1)), col = "red")
        }
    }
    if(!missing(GOMFTab)){
        if(!is.null(GOMFTab) & !all(is.na(GOMFTab))){
            # Plotting GOMFTab
            toPlot <- splitFun(tf, GOMFTab, nBar)
            xAxis <- EDASeq::barplot(toPlot[, 2], horiz = TRUE, col = color[3],
                                     main = "GO:Molecular Function", xlab = "-log10(FDR)",xlim = xlim)
            labs <- matrix(unlist(strsplit(toPlot[, 1], "~")), nrow = 2)[2, ]
            text(x = 1, y = xAxis, labs, pos = 4, cex = text.size)
            lines(x = toPlot[, 3], y = xAxis, col = "red")
            points(x = toPlot[, 3], y = xAxis, col = "red")
            axis(side = 3, at = pretty(range(0:1)), col = "red")
        }
    }
    if(!missing(PathTab)){
        if(!is.null(PathTab) & !all(is.na(PathTab))){
            # Plotting PathTab
            toPlot <- splitFun(tf, PathTab, nBar)
            xAxis <- EDASeq::barplot(toPlot[, 2], horiz = TRUE, col = color[4],
                                     main = "Pathways", xlab = "-log10(FDR)",xlim = xlim)
            labs <- toPlot[, 1]
            text(x = 1, y = xAxis, labs, pos = 4, cex = text.size)
            lines(x = toPlot[, 3], y = xAxis, col = "red")
            points(x = toPlot[, 3], y = xAxis, col = "red")
            #axis(side = 1, at = pretty(range(0:1)), col = "red", line = 2.5)
            axis(side = 3, at = pretty(range(0:1)), col = "red")
        }
    }
    #par(new = TRUE)
    #plot(toPlot[, 3], xAxis, axes = FALSE, bty = "n", xlab = "",
    # ylab = "", col = "blue")
    #par(new = TRUE)
    #plot(toPlot[, 3], xAxis, type = "l", axes = FALSE, bty = "n", xlab = "",
    # ylab = "", col = "blue")
    #axis(side = 2, at = pretty(range(xAxis)))
    #axis(side = 1, at = pretty(range(toPlot[, 3])), col = "red", line=2.5)
    #axis(side = 3, at = pretty(range(toPlot[, 3])), col = "red")

    if (is.null(nrow(nRGTab))) {
        nRG <- length(nRGTab)
    } else {
        nRG <- nRGTab[tf, "RegSizeTF"]
    }

    mainLab <- paste(tf, " (nRG = ", nRG, ")", sep = "")
    mtext(mainLab, side = 3, line = -1, outer = TRUE, font = 2)

    if(!is.null(filename)) dev.off()
}

#' @title Barplot of subtypes and clinical info in groups of gene expression clustered.
#' @description
#'   Barplot of subtypes and clinical info in groups of gene expression clustered.
#' @param DFfilt write
#' @param DFclin write
#' @param DFsubt write
#' @param data_Hc2 write
#' @param Subtype write
#' @param cbPalette Define the colors of the bar.
#' @param filename The name of the pdf file
#' @param width Image width
#' @param height Image height
#' @param dpi Image dpi
#' @import ggplot2
#' @export
#' @return barplot image in pdf or png file
TCGAvisualize_BarPlot <- function(DFfilt,
                                  DFclin,
                                  DFsubt,
                                  data_Hc2,
                                  Subtype,
                                  cbPalette,
                                  filename,
                                  width,
                                  height,
                                  dpi){

    if(Subtype =="AGE"){
        dataClinNew <- dataClin
        colnames(dataClin)[which(colnames(dataClin) == "age_at_initial_pathologic_diagnosis")] <- "AGE"
        dataClin$AGE <- as.numeric(as.character(dataClin$AGE))
        dataClin <- cbind(dataClin, AGE2 = matrix(0,nrow(dataClin),1))
        dataClin[ dataClin$AGE <= 32, "AGE2"] <- "<=32 yr"
        dataClin[ dataClin$AGE >= 41, "AGE2"] <- ">=41 yr"
        dataClin[ dataClin$AGE2 == 0, "AGE2"] <- "33-40 yr"
        dataClin$AGE <- as.character(dataClin$AGE2)
        DFclin <- dataClin
    }

    ans <- hclust(ddist <- dist(DFfilt), method = "ward.D2")
    hhc <- data_Hc2[[4]]$consensusTree
    consensusClusters<-data_Hc2[[4]]$consensusClass
    sampleOrder <- consensusClusters[hhc$order]

    consensusClusters <- as.factor(data_Hc2[[4]]$clrs[[1]])
    names(consensusClusters) <- attr(ddist, "Labels")
    names(consensusClusters) <- substr(names(consensusClusters),1,12)

    # adding information about gropus from consensus Cluster in clinical data
    DFclin <- cbind(DFclin, groupsHC = matrix(0,nrow(DFclin),1))
    rownames(DFclin) <- DFclin$bcr_patient_barcode

    for( i in 1: nrow(DFclin)){
        currSmp <- DFclin$bcr_patient_barcode[i]
        DFclin[currSmp,"groupsHC"] <- as.character(consensusClusters[currSmp])
    }

    DFclin_filt <- DFclin[DFclin$bcr_patient_barcode %in% DFsubt$patient,]
    DFclin_filt <- DFclin_filt[order(DFclin_filt$bcr_patient_barcode),]
    DFsubt <- DFsubt[order(DFsubt$patient),]
    DFclin_merged <- cbind(DFclin_filt,DFsubt)

    subtype_sel <- colnames(DFclin_merged) == Subtype
    DFclin_merged[,Subtype] <- as.character(DFclin_merged[,Subtype])
    DFclin_merged <- DFclin_merged[!(is.na(DFclin_merged[,Subtype])),]
    DFclin_merged <- DFclin_merged[DFclin_merged[,Subtype] !="NA",]

    groupsColors <-  levels(as.factor(DFclin_merged$groupsHC))
    for(j in 1:length(table(DFclin_merged$groupsHC))){
        curCol <- groupsColors[j]
        DFclin_merged[DFclin_merged$groupsHC == curCol,"groupsHC"]<-paste0("EC",j)
    }

    subtypeCluster <- factor(DFclin_merged[,Subtype])
    pplot <- qplot(factor(DFclin_merged$groupsHC),
                   data=DFclin_merged, geom="bar",
                   fill=subtypeCluster , xlab="Expression group") +
        theme_bw()  +
        theme(panel.border = element_blank(),
              panel.grid.major = element_blank(),
              panel.grid.minor = element_blank(),
              axis.line = element_line(colour = "black")) +
        guides(fill=guide_legend(title=Subtype))  +
        theme(legend.position="top",
              legend.text = element_text(size = 18),
              legend.title = element_text(size=18, face="bold")) +
        theme( legend.text = element_text(size = 18),
               legend.title = element_text(size = 18),
               axis.text= element_text(size = 30),
               axis.title.x= element_text(size = 22),
               axis.title.y= element_text(size = 30))   +
        scale_fill_manual(values=cbPalette)

    ggsave(pplot, filename = filename, width = width, height = height, dpi = dpi)
    message(paste("Plot saved in: ", file.path(getwd(),filename)))
}


#' @title Heatmap with more sensible behavior using heatmap.plus
#' @description Heatmap with more sensible behavior using heatmap.plus
#' @param data The object to with the heatmap data (expression, methylation)
#' @param col.metadata Metadata for the columns (samples). It should have on of the following columns:
#' barcode (28 characters)  column to match with the samples. It will also work with
#' "bcr_patient_barcode"(12 chars),"patient"(12 chars),"sample"(16 chars) columns but as one patient might
#' have more than one sample, this coul lead to errors in the annotation.
#' The code will throw a warning in case two samples are from the same patient.
#' @param row.metadata  Metadata for the rows  genes (expression) or probes (methylation)
#' @param col.colors A list of names colors
#' @param row.colors A list of named colors
#' @param type Select the colors of the heatmap values. Possible values are
#'  "expression" (default), "methylation"
#' @param show_column_names  Show column names names? Default: FALSE
#' @param show_row_names Show row names? Default: FALSE
#' @param cluster_rows Cluster rows ? Default: FALSE
#' @param cluster_columns Cluster columns ? Default: FALSE
#' @param filename Filename to save the heatmap. Default: heatmap.png
#' @param width figure width
#' @param height figure height
#' @param sortCol Name of the column to be used to sort the columns
#' @param title Title of the plot
#' @param rownames.size Rownames size
#' @param color.levels A vector with the colors (low level, middle level, high level)
#' @param extremes Extremes of colors (vector of 3 values)
#' @param values.label Text of the levels in the heatmap
#' @param heatmap.legend.color.bar Heatmap legends values type.
#' Options: "continuous", "discrete"
#' @param scale Use z-score to make the heatmap?
#' If we want to show differences between genes, it is good to make Z-score by samples
#' (force each sample to have zero mean and standard deviation=1).
#' If we want to show differences between samples, it is good to make Z-score by genes
#' (force each gene to have zero mean and standard deviation=1).
#' Possibilities: "row", "col". Default "none"
#' @examples
#'  row.mdat <- matrix(c("FALSE","FALSE",
#'                      "TRUE","TRUE",
#'                      "FALSE","FALSE",
#'                      "TRUE","FALSE",
#'                      "FALSE","TRUE"
#'                 ),
#'               nrow = 5, ncol = 2, byrow = TRUE,
#'               dimnames = list(
#'                   c("probe1", "probe2","probe3","probe4","probe5"),
#'                   c("duplicated", "Enhancer region")))
#' dat <- matrix(c(0.3,0.2,0.3,1,1,0.1,1,1,0, 0.8,1,0.7,0.7,0.3,1),
#'              nrow = 5, ncol = 3, byrow = TRUE,
#'                dimnames = list(
#'                c("probe1", "probe2","probe3","probe4","probe5"),
#'                c("TCGA-DU-6410",
#'                  "TCGA-DU-A5TS",
#'                  "TCGA-HT-7688")))
#'
#' mdat <- data.frame(patient=c("TCGA-DU-6410","TCGA-DU-A5TS","TCGA-HT-7688"),
#'                    Sex=c("Male","Female","Male"),
#'                    COCCluster=c("coc1","coc1","coc1"),
#'                    IDHtype=c("IDHwt","IDHMut-cod","IDHMut-noncod"))
#'
#'TCGAvisualize_Heatmap(dat,
#'                     col.metadata = mdat,
#'                     row.metadata = row.mdat,
#'                     row.colors = list(duplicated = c("FALSE" = "pink",
#'                                                      "TRUE"="green"),
#'                                      "Enhancer region" = c("FALSE" = "purple",
#'                                                             "TRUE"="grey")),
#'                     col.colors = list(Sex = c("Male" = "blue", "Female"="red"),
#'                                       COCCluster=c("coc1"="grey"),
#'                                       IDHtype=c("IDHwt"="cyan",
#'                                       "IDHMut-cod"="tomato"
#'                                       ,"IDHMut-noncod"="gold")),
#'                     type = "methylation",
#'                     show_row_names=TRUE)
#' @export
#' @return Heatmap plotted in the device
TCGAvisualize_Heatmap <- function(
        data,
        col.metadata,
        row.metadata,
        col.colors = NULL,
        row.colors = NULL,
        show_column_names = FALSE,
        show_row_names = FALSE,
        cluster_rows = FALSE,
        cluster_columns = FALSE,
        sortCol,
        extremes = NULL,
        rownames.size = 12,
        title = NULL,
        color.levels = NULL,
        values.label = NULL,
        filename = "heatmap.pdf",
        width = 10,
        height = 10,
        type = "expression",
        scale = "none",
        heatmap.legend.color.bar = "continuous"){

    check_package("ComplexHeatmap")
    check_package("circlize")
    # STEP 1 add columns labels (top of heatmap)
    ha <-  NULL
    if(!missing(col.metadata)) {
        if(!is.null(col.metadata)) {
            id <- NULL
            if("patient"  %in% colnames(col.metadata)) {
                id <- "patient"
                size <- 12
            }
            if("barcode"  %in% colnames(col.metadata)) {
                id <- "barcode"
                stopifnot(nchar(col.metadata[,id])[1] == 28)
                size <- 28
            }
            if("bcr_patient_barcode"  %in% colnames(col.metadata)) {
                id <- "bcr_patient_barcode"
                stopifnot(nchar(col.metadata[,id])[1] == 12)
                size <- 12
            }
            if("sample"  %in% colnames(col.metadata)) {
                id <- "sample"
                stopifnot(nchar(col.metadata[,id])[1] == 16)
                size <- 16
            }

            if(is.null(id)) {
                message("=============== INNPUT ERROR =================")
                message("I'm expecting one of these columns:")
                message(" => barcode")
                message("    Has the complete barcode (TCGA-AA-3833-01A-01D-0904-05)")
                message(" => bcr_patient_barcode")
                message("    Has the patient barcode (TCGA-AA-3833)")
                message(" => patient")
                message("    Has the patient barcode (TCGA-AA-3833)")
                message(" => sample")
                message("    Has the sample barcode (TCGA-AA-3833-01A)")
                message("-----------------------------------------------")
                message("Obs: The complete barcode is the recommended one, as the others might lead to errors")
                return(NULL)
            }
            stopifnot(nchar(as.character(col.metadata[,id])[1]) == size)
            message(paste0("Reorganizing: col.metadata order should be the same of the data object"))
            df <- col.metadata[match(substr(colnames(data),1,size), col.metadata[,id]),]
            df[,id] <- NULL

            duplicated.samples <- any(sapply(col.metadata[,id],
                                             function(x) {length(grep(x,col.metadata[,id])) > 1 }))
            if(duplicated.samples){
                warning("Some samples are from the same patient, this might lead to the wrong upper annotation")
            }

            if (!missing(sortCol)) {
                message(paste0("Sorting columns based on column: ",
                               sortCol))
                column_order <- order(df[,sortCol])
            }
            if(is.null(col.colors)) {
                ha <- ComplexHeatmap::HeatmapAnnotation(df = df)
            } else {
                ha <- ComplexHeatmap::HeatmapAnnotation(df = df,
                                                        col = col.colors)
            }
        }
    }
    # STEP 2 Create heatmap
    if(is.null(color.levels)) {
        if (type == "expression") color.levels <-  c("green", "white", "red")
        if (type == "methylation") color.levels <-  c("blue", "white", "red")
    }


    # If we want to show differences between genes, it is good to make Z-score by samples
    # (force each sample to have zero mean and standard deviation=1).
    # If we want to show differences between samples, it is good to make Z-score by genes
    # (force each gene to have zero mean and standard deviation=1).
    if(scale == "row"){
        message("Calculating z-scores for the rows....")
        data <- t(scale(t(data)))
        all.na <- apply(data,1, function(x) all(is.na(x)))
        data <- data[!all.na,]
    } else if(scale == "col"){
        message("Calculiating z-scores for the columns....")
        data <- scale(data)
    }

    if(is.null(extremes)) {
        if(min(data,na.rm = TRUE) < 0) {
            extremes <- c(min(data,na.rm = TRUE), (max(data,na.rm = TRUE) + min(data,na.rm = TRUE))/2, max(data,na.rm = TRUE))
        } else {
            extremes <- c(0, max(data,na.rm = TRUE)/2, max(data,na.rm = TRUE))
        }
    }
    if (type == "expression") color <- circlize::colorRamp2(extremes, color.levels)
    if (type == "methylation") color <- circlize::colorRamp2(extremes, color.levels)

    # Creating plot title
    if(is.null(title)) {
        if(type == "methylation") title <- "DNA methylation heatmap"
        if(type == "expression") title <- "Expression heatmap"
    }
    # Change label type
    heatmap_legend_param <- list()
    if(heatmap.legend.color.bar == "continuous" && type == "methylation"){
        heatmap_legend_param <- c(list(color_bar = "continuous"),heatmap_legend_param)
        if(!scale %in% c("row","col")) heatmap_legend_param <- list(color_bar = "continuous", at = c(0,0.2,0.4,0.6,0.8, 1), legend_height = unit(3, "cm"), labels = c("0.0 (hypomethylated)",0.2,0.4,0.6,0.8,"1.0 (hypermethylated)"))
    }
    if(heatmap.legend.color.bar == "continuous" && type == "expression"){
        heatmap_legend_param <- c(list(color_bar = "continuous"),heatmap_legend_param)
    }
    # Change label reference
    if(is.null(values.label)){
        if(type == "methylation") values.label <- "DNA methylation level"
        if(type == "expression") {
            values.label <- "Expression"
            if(scale != "none") values.label <- paste0(values.label, "(z-score)")
        }
    }
    if(!missing(sortCol) & heatmap.legend.color.bar == "continuous"){
        heatmap  <- ComplexHeatmap::Heatmap(
            data,
            name = values.label,
            top_annotation = ha,
            col = color,
            row_names_gp =  grid::gpar(fontsize = rownames.size),
            show_row_names = show_row_names,
            cluster_rows = cluster_rows,
            cluster_columns = cluster_columns,
            show_column_names = show_column_names,
            column_order = column_order,
            column_title = title,
            heatmap_legend_param = heatmap_legend_param)
    } else if(missing(sortCol) & heatmap.legend.color.bar == "continuous"){
        heatmap  <- ComplexHeatmap::Heatmap(
            data,
            name = values.label,
            top_annotation = ha,
            col = color,
            show_row_names = show_row_names,
            row_names_gp =  grid::gpar(fontsize = rownames.size),
            cluster_rows = cluster_rows,
            cluster_columns = cluster_columns,
            show_column_names = show_column_names,
            column_title = title,
            heatmap_legend_param = heatmap_legend_param)
    }  else if(!missing(sortCol)){
        heatmap  <- ComplexHeatmap::Heatmap(
            data,
            name = values.label,
            top_annotation = ha,
            col = color,
            row_names_gp =  grid::gpar(fontsize = rownames.size),
            show_row_names = show_row_names,
            cluster_rows = cluster_rows,
            cluster_columns = cluster_columns,
            show_column_names = show_column_names,
            column_order = column_order,
            column_title = title)
    } else {
        heatmap  <- ComplexHeatmap::Heatmap(
            data,
            name = values.label,
            top_annotation = ha,
            col = color,
            row_names_gp =  grid::gpar(fontsize = rownames.size),
            show_row_names = show_row_names,
            cluster_rows = cluster_rows,
            cluster_columns = cluster_columns,
            show_column_names = show_column_names,
            column_title = title,
            heatmap_legend_param = heatmap_legend_param)
    }

    # STEP 3 row labels (right side)
    if (!missing(row.metadata)) {
        if (!is.null(row.metadata)) {
            for (i in 1:ncol(row.metadata)) {
                if (!missing(row.colors) && !is.null(row.colors[[colnames(row.metadata)[i]]])) {
                    color <- row.colors[[colnames(row.metadata)[i]]]
                    x = ComplexHeatmap::Heatmap(
                        row.metadata[,i] ,
                        name = colnames(row.metadata)[i],
                        width = unit(0.5, "cm"),
                        show_row_names = FALSE, col = color )
                } else {
                    x = ComplexHeatmap::Heatmap(
                        row.metadata[,i] ,
                        name = colnames(row.metadata)[i],
                        width = unit(0.5, "cm"),
                        show_row_names = FALSE)
                }
                heatmap <- ComplexHeatmap::add_heatmap(heatmap,x)
            }
        }
    }
    if(!is.null(filename)){
        if(tools::file_ext(filename) == "png") png(filename, width = width, height = height )
        if(tools::file_ext(filename) == "pdf") pdf(filename, width = width, height = height )
        ComplexHeatmap::draw(heatmap)
        dev.off()
    } else {
        ComplexHeatmap::draw(heatmap)
    }
}


# unlist labels
# Help function that unlists a list into a vector
unlistlabels <- function(lab) {
    dummy <- unlist(lab)
    labels <- c()
    labels <- c(labels, as.character(dummy))
    return(labels)
}


#' Creating a oncoprint
#' @param mut A dataframe from the mutation annotation file (see TCGAquery_maf from TCGAbiolinks)
#' @param genes Gene list
#' @param filename name of the pdf
#' @param color named vector for the plot
#' @param height pdf height
#' @param width pdf width
#' @param rm.empty.columns If there is no alteration in that sample, whether remove it on the oncoprint
#' @param show.row.barplot  Show barplot annotation on rows?
#' @param show.column.names Show column names? Default: FALSE
#' @param rows.font.size Size of the fonts
#' @param column.names.size Size of the fonts of the columns names
#' @param dist.col distance between columns in the plot
#' @param dist.row distance between rows in the plot
#' @param label.font.size Size of the fonts
#' @param row.order Order the genes (rows) Default:TRUE. Genes with more mutations will be in the first rows
#' @param col.order Order columns. Default:TRUE.
#' @param annotation Matrix or data frame with the annotation.
#' Should have a column bcr_patient_barcode with the same ID of the mutation object
#' @param annotation.position Position of the annotation "bottom" or "top"
#' @param label.title Title of the label
#' @param annotation.legend.side Position of the annotation legend
#' @param heatmap.legend.side Position of the heatmap legend
#' @param information Which column to use as information from MAF.
#' Options: 1) "Variant_Classification" (The information will be "Frame_Shift_Del", "Frame_Shift_Ins",
#'         "In_Frame_Del", "In_Frame_Ins", "Missense_Mutation",  "Nonsense_Mutation",
#'              "Nonstop_Mutation",  "RNA",  "Silent" ,  "Splice_Site",  "Targeted_Region",  "Translation_Start_Site")
#' 2) "Variant_Type" (The information will be INS,DEL,SNP)
#' @importFrom data.table dcast setDT setDF :=
#' @examples
#' \dontrun{
#' library(dplyr)
#' query <- GDCquery(
#'    project = "TCGA-CHOL",
#'    data.category = "Simple Nucleotide Variation",
#'    access = "open",
#'    legacy = FALSE,
#'    data.type = "Masked Somatic Mutation",
#'    workflow.type = "Aliquot Ensemble Somatic Variant Merging and Masking"
#')
#' GDCdownload(query)
#' mut <- GDCprepare(query)
#' TCGAvisualize_oncoprint(mut = mut, genes = mut$Hugo_Symbol[1:10], rm.empty.columns = TRUE)
#' TCGAvisualize_oncoprint(
#'   mut = mut, genes = mut$Hugo_Symbol[1:10],
#'   filename = "onco.pdf",
#'   color = c("background"="#CCCCCC","DEL"="purple","INS"="yellow","SNP"="brown")
#' )
#' clin <- GDCquery_clinic("TCGA-ACC","clinical")
#' clin <- clin[,c("bcr_patient_barcode","disease","gender","tumor_stage","race","vital_status")]
#' TCGAvisualize_oncoprint(
#'    mut = mut, genes = mut$Hugo_Symbol[1:20],
#'    filename = "onco.pdf",
#'    annotation = clin,
#'    color=c("background"="#CCCCCC","DEL"="purple","INS"="yellow","SNP"="brown"),
#'    rows.font.size=10,
#'    heatmap.legend.side = "right",
#'    dist.col = 0,
#'    label.font.size = 10
#' )
#' }
#' @export
#' @return A oncoprint plot
TCGAvisualize_oncoprint <- function(
        mut,
        genes,
        filename,
        color,
        annotation.position = "bottom",
        annotation,
        height,
        width = 10,
        rm.empty.columns = FALSE,
        show.column.names = FALSE,
        show.row.barplot = TRUE,
        label.title = "Mutation",
        column.names.size = 8,
        label.font.size = 16,
        rows.font.size = 16,
        dist.col = 0.5,
        dist.row = 0.5,
        information = "Variant_Type",
        row.order = TRUE,
        col.order = TRUE,
        heatmap.legend.side = "bottom",
        annotation.legend.side = "bottom"
){

    check_package("ComplexHeatmap")
    check_package("circlize")
    check_package("grid")

    if(missing(mut)) stop("Missing mut argument")
    mut <- setDT(mut)
    mut$value <- 1
    if(rm.empty.columns == FALSE) all.samples <- unique(mut$Tumor_Sample_Barcode)

    mut$Hugo_Symbol <- as.character(mut$Hugo_Symbol)
    if(!missing(genes) & !is.null(genes)) mut <- subset(mut, mut$Hugo_Symbol %in% genes)

    if(!rm.empty.columns){
        formula <- paste0("Tumor_Sample_Barcode + Hugo_Symbol ~ ", information)
        suppressMessages({mat <- dcast(mut, as.formula(formula),value.var = "value",fill = 0,drop = FALSE)})
    } else {
        formula <- paste0("Tumor_Sample_Barcode + Hugo_Symbol ~ ", information)
        suppressMessages({mat <- dcast(mut, as.formula(formula),value.var = "value",fill = 0,drop = TRUE)})
    }

    # mutation in the file
    columns <- colnames(mat)[-c(1:2)]

    # value will be a collum with all the mutations
    mat$value <- ""

    for ( i in columns){
        mat[,i] <-  replace(mat[,i,with = FALSE],mat[,i,with = FALSE]>0,paste0(i,";"))
        mat[,i] <-  replace(mat[,i,with = FALSE],mat[,i,with = FALSE]==0,"")
        mat[,value:=paste0(value,get(i))]
    }

    # After the gene selection, some of the mutation might not exist
    # we will remove them to make the oncoprint work
    mutation.type <- c()
    for (i in columns){
        if(length(grep(i,mat$value)) > 0) mutation.type <- c(mutation.type,i)
    }

    # now we have a matrix with pairs samples/genes mutations
    # we want a matrix with samples vs genes mutations with the content being the value
    mat <- setDF(dcast(mat, Tumor_Sample_Barcode~Hugo_Symbol, value.var="value",fill=""))
    rownames(mat) <- mat[,1]
    mat <- mat[,-1]

    if(rm.empty.columns == FALSE) {
        aux <- data.frame(row.names = all.samples[!all.samples %in% rownames(mat)])
        if(nrow(aux) > 0) {
            aux[,colnames(mat)] <- ""
            mat <- rbind(mat,aux)
        }
    }



    alter_fun = function(x, y, w, h, v) {
        n = sum(v)
        h = h * 0.9
        # use `names(which(v))` to correctly map between `v` and `col`

        # Oncoprint with one value does not have names in v
        if(is.null(names(v))){
            if(v){
                grid::grid.rect(
                    x,
                    y - h * 0.5 + 1:n / n * h,
                    w - unit(dist.col, "mm"),
                    1 / n * h,
                    gp = grid::gpar(fill = setdiff(color,color["background"]), col = NA),
                    just = "top"
                )
            } else {
                grid::grid.rect(
                    x,
                    y,
                    w - unit(dist.col, "mm"),
                    h - unit(dist.row, "mm"),
                    gp = grid::gpar(fill = color["background"], col = NA)
                )
            }
        } else {
            if (length(names(which(v)))) {
                grid::grid.rect(
                    x,
                    y - h * 0.5 + 1:n / n * h,
                    w - unit(dist.col, "mm"),
                    1 / n * h,
                    gp = grid::gpar(fill = color[names(which(v))], col = NA),
                    just = "top"
                )
            } else {
                grid::grid.rect(
                    x,
                    y,
                    w - unit(dist.col, "mm"),
                    h - unit(dist.row, "mm"),
                    gp = grid::gpar(fill = color["background"], col = NA)
                )
            }
        }
    }

    # get only the colors to the mutations
    # otherwise it gives errors
    if(missing(color)){
        check_package("grDevices")
        color <- c(grDevices::rainbow(length(mutation.type)), "#CCCCCC")
        names(color) <- c(mutation.type,"background")
    } else{
        if("background" %in% names(color)) {
            color <- color[c(mutation.type,"background")]
        } else {
            color <- c(color[mutation.type],"background"= "#CCCCCC")
        }
    }
    print(color)
    # header are samples, rows genes
    mat <- t(mat)

    if(!missing(height)) height <- length(genes)/2
    if(!missing(filename)) pdf(filename,width = width,height = height)

    if(missing(annotation)) annotation <- NULL
    if(!is.null(annotation)){
        if(!"bcr_patient_barcode" %in% colnames(annotation))
            stop("bcr_patient_barcode column should be in the annotation")
        idx <- match(substr(colnames(mat),1,12),annotation$bcr_patient_barcode)
        if(all(is.na(idx)))
            stop(" We couldn't match the columns names with the bcr_patient_barcode column in the annotation object")
        annotation <- annotation[idx,]

        annotation$bcr_patient_barcode <- NULL

        n.col <- sum(sapply(colnames(annotation), function(x) {
            length(unique(annotation[,x]))
        }))

        # add automatic colors: not working

        get.color <- function(df,col){
            idx <- which(colnames(df) == col)
            start <- 1
            if(idx != 1) start <- length(na.omit(unique(unlist(c(df[,1:(idx-1)]))))) + 1
            end <- start + length(na.omit(unique(df[,col]))) -1
            diff.colors <- c("purple","thistle","deeppink3","magenta4","lightsteelblue1","black",
                             "chartreuse","lightgreen","maroon4","darkslategray",
                             "lightyellow3","darkslateblue","firebrick1","aquamarine",
                             "dodgerblue4","bisque4","moccasin","indianred1",
                             "yellow","gray93","cyan","darkseagreen4",
                             "lightgoldenrodyellow","lightpink","sienna1",
                             "darkred","palevioletred","tomato4","blue",
                             "mediumorchid4","royalblue1","magenta2","darkgoldenrod1")
            return(diff.colors[start:end])
        }
        col.annot <- lapply(colnames(annotation), function(x) {
            #idx <- which(colnames(annotation) == x) - 1
            #print(idx/n.col)
            ret <- get.color(annotation,x)
            #ret <- rainbow(length(unique(annotation[,x])),start = idx/n.col,alpha=0.5)
            names(ret) <- as.character(na.omit(unique(annotation[,x])))
            return(ret)
        })
        names(col.annot) <-  colnames(annotation)


        annotHeatmap <-
            ComplexHeatmap::HeatmapAnnotation(
                df = annotation,
                col = col.annot,
                annotation_legend_param = list(
                    title_gp = grid::gpar(fontsize = label.font.size,
                                          fontface =
                                              "bold"),
                    labels_gp =
                        grid::gpar(fontsize = label.font.size),
                    #sizelabels
                    grid_height =
                        unit(8, "mm")
                )
            )
    }
    if(heatmap.legend.side == "bottom") {
        nrow <- 1
        title_position <- "leftcenter"
    } else {
        nrow <- 10
        title_position <- "topcenter"
    }

    if(is.null(annotation) & !row.order & !col.order){
        p <- ComplexHeatmap::oncoPrint(mat, get_type = function(x) strsplit(x, ";")[[1]],
                                       row_order = NULL,
                                       remove_empty_columns = FALSE,
                                       show_column_names = show.column.names,
                                       column_order = NULL, # Do not sort the columns
                                       alter_fun = alter_fun, col = color,
                                       column_names_gp = grid::gpar(fontsize = column.names.size),
                                       row_names_gp = grid::gpar(fontsize = rows.font.size),  # set size for row names
                                       pct_gp = grid::gpar(fontsize = rows.font.size), # set size for percentage labels
                                       #column_title = "OncoPrint for TCGA LGG, genes in Glioma signaling",
                                       #column_title_gp = grid::gpar(fontsize = 11),
                                       heatmap_legend_param = list(title = label.title, at = names(color),
                                                                   labels = names(color),
                                                                   title_gp = grid::gpar(fontsize = label.font.size, fontface = "bold"),
                                                                   labels_gp = grid::gpar(fontsize = label.font.size), # size labels
                                                                   grid_height = unit(8, "mm"), # vertical distance labels
                                                                   nrow = nrow, title_position = title_position
                                       )
        )
    } else if(!is.null(annotation) & annotation.position == "bottom" & !row.order & !col.order){

        p <- ComplexHeatmap::oncoPrint(mat, get_type = function(x) strsplit(x, ";")[[1]],
                                       row_order = NULL,
                                       remove_empty_columns = FALSE,
                                       column_names_gp = grid::gpar(fontsize = column.names.size),
                                       show_column_names = show.column.names,
                                       column_order = NULL, # Do not sort the columns
                                       alter_fun = alter_fun, col = color,
                                       row_names_gp = grid::gpar(fontsize = rows.font.size),  # set size for row names
                                       pct_gp = grid::gpar(fontsize = rows.font.size), # set size for percentage labels
                                       #column_title = "OncoPrint for TCGA LGG, genes in Glioma signaling",
                                       #column_title_gp = grid::gpar(fontsize = 11),
                                       bottom_annotation = annotHeatmap,
                                       heatmap_legend_param = list(title = label.title, at = names(color),
                                                                   labels = names(color),
                                                                   title_gp = grid::gpar(fontsize = label.font.size, fontface = "bold"),
                                                                   labels_gp = grid::gpar(fontsize = label.font.size), # size labels
                                                                   grid_height = unit(8, "mm"), # vertical distance labels
                                                                   nrow = nrow, title_position = title_position
                                       )
        )

    } else if(!is.null(annotation) & annotation.position == "top" & !row.order  & !col.order){
        p <- ComplexHeatmap::oncoPrint(mat, get_type = function(x) strsplit(x, ";")[[1]],
                                       row_order = NULL,
                                       remove_empty_columns = FALSE,
                                       column_names_gp = grid::gpar(fontsize = column.names.size),
                                       show_column_names = show.column.names,
                                       column_order = NULL, # Do not sort the columns
                                       alter_fun = alter_fun, col = color,
                                       row_names_gp = grid::gpar(fontsize = rows.font.size),  # set size for row names
                                       pct_gp = grid::gpar(fontsize = rows.font.size), # set size for percentage labels
                                       #column_title = "OncoPrint for TCGA LGG, genes in Glioma signaling",
                                       #column_title_gp = grid::gpar(fontsize = 11),
                                       top_annotation = annotHeatmap,
                                       heatmap_legend_param = list(title = label.title, at = names(color),
                                                                   labels = names(color),
                                                                   title_gp = grid::gpar(fontsize = label.font.size, fontface = "bold"),
                                                                   labels_gp = grid::gpar(fontsize = label.font.size), # size labels
                                                                   grid_height = unit(8, "mm"),  # vertical distance labels
                                                                   nrow = nrow, title_position = title_position
                                       )
        )
    }  else if(is.null(annotation) & row.order  & !col.order){
        p <- ComplexHeatmap::oncoPrint(mat, get_type = function(x) strsplit(x, ";")[[1]],
                                       remove_empty_columns = FALSE,
                                       show_column_names = show.column.names,
                                       column_order = NULL, # Do not sort the columns
                                       alter_fun = alter_fun, col = color,
                                       column_names_gp = grid::gpar(fontsize = column.names.size),
                                       row_names_gp = grid::gpar(fontsize = rows.font.size),  # set size for row names
                                       pct_gp = grid::gpar(fontsize = rows.font.size), # set size for percentage labels
                                       #column_title = "OncoPrint for TCGA LGG, genes in Glioma signaling",
                                       #column_title_gp = grid::gpar(fontsize = 11),
                                       heatmap_legend_param = list(title = label.title, at = names(color),
                                                                   labels = names(color),
                                                                   title_gp = grid::gpar(fontsize = label.font.size, fontface = "bold"),
                                                                   labels_gp = grid::gpar(fontsize = label.font.size), # size labels
                                                                   grid_height = unit(8, "mm"), # vertical distance labels
                                                                   nrow = nrow, title_position = title_position
                                       )
        )
    } else if(!is.null(annotation) & annotation.position == "bottom" & row.order & !col.order){

        p <- ComplexHeatmap::oncoPrint(mat, get_type = function(x) strsplit(x, ";")[[1]],
                                       remove_empty_columns = FALSE,
                                       column_names_gp = grid::gpar(fontsize = column.names.size),
                                       show_column_names = show.column.names,
                                       column_order = NULL, # Do not sort the columns
                                       alter_fun = alter_fun, col = color,
                                       row_names_gp = grid::gpar(fontsize = rows.font.size),  # set size for row names
                                       pct_gp = grid::gpar(fontsize = rows.font.size), # set size for percentage labels
                                       #column_title = "OncoPrint for TCGA LGG, genes in Glioma signaling",
                                       #column_title_gp = grid::gpar(fontsize = 11),
                                       bottom_annotation = annotHeatmap,
                                       heatmap_legend_param = list(title = label.title, at = names(color),
                                                                   labels = names(color),
                                                                   title_gp = grid::gpar(fontsize = label.font.size, fontface = "bold"),
                                                                   labels_gp = grid::gpar(fontsize = label.font.size), # size labels
                                                                   grid_height = unit(8, "mm"), # vertical distance labels
                                                                   nrow = nrow, title_position = title_position
                                       )
        )

    } else if(!is.null(annotation) & annotation.position == "top" & row.order & !col.order){
        p <- ComplexHeatmap::oncoPrint(mat, get_type = function(x) strsplit(x, ";")[[1]],
                                       remove_empty_columns = FALSE,
                                       show_column_names = show.column.names,
                                       column_order = NULL, # Do not sort the columns
                                       alter_fun = alter_fun, col = color,
                                       column_names_gp = grid::gpar(fontsize = column.names.size),
                                       row_names_gp = grid::gpar(fontsize = rows.font.size),  # set size for row names
                                       pct_gp = grid::gpar(fontsize = rows.font.size), # set size for percentage labels
                                       #column_title = "OncoPrint for TCGA LGG, genes in Glioma signaling",
                                       #column_title_gp = grid::gpar(fontsize = 11),
                                       top_annotation = annotHeatmap,
                                       heatmap_legend_param = list(title = label.title, at = names(color),
                                                                   labels = names(color),
                                                                   title_gp = grid::gpar(fontsize = label.font.size, fontface = "bold"),
                                                                   labels_gp = grid::gpar(fontsize = label.font.size), # size labels
                                                                   grid_height = unit(8, "mm"),  # vertical distance labels
                                                                   nrow = nrow, title_position = title_position
                                       )
        )
    } else if(is.null(annotation) & !row.order & col.order){
        p <- ComplexHeatmap::oncoPrint(mat, get_type = function(x) strsplit(x, ";")[[1]],
                                       row_order = NULL,
                                       remove_empty_columns = FALSE,
                                       show_column_names = show.column.names,
                                       alter_fun = alter_fun, col = color,
                                       column_names_gp = grid::gpar(fontsize = column.names.size),
                                       row_names_gp = grid::gpar(fontsize = rows.font.size),  # set size for row names
                                       pct_gp = grid::gpar(fontsize = rows.font.size), # set size for percentage labels
                                       #column_title = "OncoPrint for TCGA LGG, genes in Glioma signaling",
                                       #column_title_gp = grid::gpar(fontsize = 11),
                                       heatmap_legend_param = list(title = label.title, at = names(color),
                                                                   labels = names(color),
                                                                   title_gp = grid::gpar(fontsize = label.font.size, fontface = "bold"),
                                                                   labels_gp = grid::gpar(fontsize = label.font.size), # size labels
                                                                   grid_height = unit(8, "mm"), # vertical distance labels
                                                                   nrow = nrow, title_position = title_position
                                       )
        )
    } else if(!is.null(annotation) & annotation.position == "bottom" & !row.order & col.order){

        p <- ComplexHeatmap::oncoPrint(mat, get_type = function(x) strsplit(x, ";")[[1]],
                                       row_order = NULL,
                                       remove_empty_columns = FALSE,
                                       column_names_gp = grid::gpar(fontsize = column.names.size),
                                       show_column_names = show.column.names,
                                       alter_fun = alter_fun, col = color,
                                       row_names_gp = grid::gpar(fontsize = rows.font.size),  # set size for row names
                                       pct_gp = grid::gpar(fontsize = rows.font.size), # set size for percentage labels
                                       #column_title = "OncoPrint for TCGA LGG, genes in Glioma signaling",
                                       #column_title_gp = grid::gpar(fontsize = 11),
                                       bottom_annotation = annotHeatmap,
                                       heatmap_legend_param = list(title = label.title, at = names(color),
                                                                   labels = names(color),
                                                                   title_gp = grid::gpar(fontsize = label.font.size, fontface = "bold"),
                                                                   labels_gp = grid::gpar(fontsize = label.font.size), # size labels
                                                                   grid_height = unit(8, "mm"), # vertical distance labels
                                                                   nrow = nrow, title_position = title_position
                                       )
        )

    } else if(!is.null(annotation) & annotation.position == "top" & !row.order & col.order){
        p <- ComplexHeatmap::oncoPrint(mat, get_type = function(x) strsplit(x, ";")[[1]],
                                       row_order = NULL,
                                       remove_empty_columns = FALSE,
                                       column_names_gp = grid::gpar(fontsize = column.names.size),
                                       show_column_names = show.column.names,
                                       alter_fun = alter_fun, col = color,
                                       row_names_gp = grid::gpar(fontsize = rows.font.size),  # set size for row names
                                       pct_gp = grid::gpar(fontsize = rows.font.size), # set size for percentage labels
                                       #column_title = "OncoPrint for TCGA LGG, genes in Glioma signaling",
                                       #column_title_gp = grid::gpar(fontsize = 11),
                                       top_annotation = annotHeatmap,
                                       heatmap_legend_param = list(title = label.title, at = names(color),
                                                                   labels = names(color),
                                                                   title_gp = grid::gpar(fontsize = label.font.size, fontface = "bold"),
                                                                   labels_gp = grid::gpar(fontsize = label.font.size), # size labels
                                                                   grid_height = unit(8, "mm"),  # vertical distance labels
                                                                   nrow = nrow, title_position = title_position
                                       )
        )
    }  else if(is.null(annotation) & row.order & col.order){
        save(mat,color,alter_fun,file = "test.rda")
        p <- ComplexHeatmap::oncoPrint(mat, get_type = function(x) strsplit(x, ";")[[1]],
                                       remove_empty_columns = FALSE,
                                       show_column_names = show.column.names,

                                       alter_fun = alter_fun,
                                       col = color,
                                       column_names_gp = grid::gpar(fontsize = column.names.size),
                                       row_names_gp = grid::gpar(fontsize = rows.font.size),  # set size for row names
                                       pct_gp = grid::gpar(fontsize = rows.font.size), # set size for percentage labels
                                       #column_title = "OncoPrint for TCGA LGG, genes in Glioma signaling",
                                       #column_title_gp = grid::gpar(fontsize = 11),
                                       heatmap_legend_param = list(title = label.title, at = names(color),
                                                                   labels = names(color),
                                                                   title_gp = grid::gpar(fontsize = label.font.size, fontface = "bold"),
                                                                   labels_gp = grid::gpar(fontsize = label.font.size), # size labels
                                                                   grid_height = unit(8, "mm"), # vertical distance labels
                                                                   nrow = nrow, title_position = title_position
                                       )
        )
    } else if(!is.null(annotation) & annotation.position == "bottom" & row.order & col.order){


        p <- ComplexHeatmap::oncoPrint(
            mat, get_type = function(x) strsplit(x, ";")[[1]],
            remove_empty_columns = FALSE,
            column_names_gp = grid::gpar(fontsize = column.names.size),
            #show_row_barplot = show.row.barplot,
            show_column_names = show.column.names,
            alter_fun = alter_fun, col = color,
            row_names_gp = grid::gpar(fontsize = rows.font.size),  # set size for row names
            pct_gp = grid::gpar(fontsize = rows.font.size), # set size for percentage labels
            #axis_gp = grid::gpar(fontsize = rows.font.size),# size of axis
            #column_title = "OncoPrint for TCGA LGG, genes in Glioma signaling",
            #column_title_gp = grid::gpar(fontsize = 11),
            #row_barplot_width = unit(2, "cm"), #size barplot
            bottom_annotation = annotHeatmap,
            heatmap_legend_param = list(
                title = label.title, at = names(color),
                labels = names(color),
                title_gp = grid::gpar(fontsize = label.font.size, fontface = "bold"),
                labels_gp = grid::gpar(fontsize = label.font.size), # size labels
                grid_height = unit(8, "mm"), # vertical distance labels
                nrow = nrow,
                title_position = title_position
            )
        )

    } else if(!is.null(annotation) & annotation.position == "top" & row.order & col.order){
        p <- ComplexHeatmap::oncoPrint(
            mat, get_type = function(x) strsplit(x, ";")[[1]],
            remove_empty_columns = FALSE,
            show_column_names = show.column.names,
            alter_fun = alter_fun, col = color,
            column_names_gp = grid::gpar(fontsize = column.names.size),
            row_names_gp = grid::gpar(fontsize = rows.font.size),  # set size for row names
            pct_gp = grid::gpar(fontsize = rows.font.size), # set size for percentage labels
            #column_title = "OncoPrint for TCGA LGG, genes in Glioma signaling",
            #column_title_gp = grid::gpar(fontsize = 11),
            top_annotation = annotHeatmap,
            heatmap_legend_param = list(
                title = label.title, at = names(color),
                labels = names(color),
                title_gp = grid::gpar(fontsize = label.font.size, fontface = "bold"),
                labels_gp = grid::gpar(fontsize = label.font.size), # size labels
                grid_height = unit(8, "mm"),  # vertical distance labels
                nrow = nrow, title_position = title_position
            )
        )
    }

    ComplexHeatmap::draw(p, heatmap_legend_side = heatmap.legend.side,
                         annotation_legend_side = annotation.legend.side)

    if(!missing(filename)) {
        dev.off()
        message(paste0("File saved as: ", filename ))
    }

}

#' @title Creates a volcano plot for DNA methylation or gene expression
#' @description Creates a volcano plot from the
#' gene expression and DNA methylation analysis.
#' @details
#'    Creates a volcano plot from the gene expression and DNA methylation analysis.
#'    Please see the vignette for more information
#' @param x x-axis data (i.e. Diff mean beta-values or Log2FC).
#' @param y FDR adjusted p-value (q-value). This data will be transformed to -log10 values.
#' @param y.cut q-values threshold (i.e. 0.01, 10^-10)
#' @param x.cut  x-axis threshold. Default: 0.0 If you give only one number (e.g. 0.2) the cut-offs will be
#'  -0.2 and 0.2. Or you can give different cut-offs as a vector (e.g. c(-0.3,0.4))
#' @param filename File name: volcano.pdf, volcano.svg, volcano.png. If NULL returns
#' the ggplot object.
#' @param legend Legend title
#' @param color vector of colors to be used in graph
#' @param title main title. If not specified it will be
#' "Volcano plot (group1 vs group2)
#' @param ylab y axis text. Default: -Log10 FDR corrected P-values
#' @param xlab x axis text. Default: No text. Examples of input:
#' expression(paste(Log[2], "FoldChange"))
#' @param xlim x limits to cut image (i.e. c(-4,4))
#' @param ylim y limits to cut image (i.e. c(-1,10))
#' @param height Figure height
#' @param width Figure width
#' @param names Names to be plotted if significant.
#' Should be the same size of x and y
#' @param names.fill Names should be filled in a color box?  Default: TRUE
#' @param names.size Size of the names text
#' @param dpi Figure dpi
#' @param label vector of labels to be used in the figure.
#' Example: c("Not Significant","Hypermethylated in group1",
#' "Hypomethylated in group1"))#'
#' @param highlight List of genes/probes to be highlighted. It should be in the names argument.
#' @param highlight.color Color of the points highlighted
#' @param show.names What names will be showed? Possibilities: "both", "significant", "highlighted"
#' @export
#' @return Saves the volcano plot in the current folder
#' @examples
#' log2_foldchange <- runif(200, -2, 2)
#' fdr <- runif(200, 0.01, 1)
#' TCGAVisualize_volcano(
#'     x = log2_foldchange,
#'     y = fdr,
#'     x.cut = 1.5,
#'     y.cut = 0.01,
#'     title = "Title example",
#'     xlab = expression(paste(Log[2], "FoldChange"))
#' )
#' \dontrun{
#' beta_diff <- runif(200, -1, 1)
#' fdr <- runif(200, 0.01, 1)
#' TCGAVisualize_volcano(
#'     x = beta_diff,
#'     y = fdr,
#'     x.cut = 1.5,
#'     y.cut = 0.01,
#'     title = "Title example",
#'     xlab = expression(paste("DNA Methylation difference (", beta, "-values)"))
#' )
#' TCGAVisualize_volcano(
#'   x,
#'   y,
#'   filename = NULL,
#'   y.cut = 10000000,
#'   x.cut=0.8,
#'    names = rep("AAAA",length(x)),
#'    legend = "Status",
#'    names.fill = FALSE
#' )
#'
#' TCGAVisualize_volcano(
#'   x,
#'   y,
#'   filename = NULL,
#'   y.cut = 10000000,
#'   x.cut = 0.8,
#'    names = as.character(1:length(x)),
#'    legend = "Status",
#'    names.fill = TRUE, highlight = c("1","2"),
#'    show = "both"
#' )
#' TCGAVisualize_volcano(
#'   x,
#'   y,
#'   filename = NULL,
#'   y.cut = 10000000,
#'   x.cut = c(-0.3,0.8),
#'   names = as.character(1:length(x)),
#'   legend = "Status",
#'   names.fill = TRUE,
#'   highlight = c("1","2"),
#'   show = "both"
#' )
#' }
#' while (!(is.null(dev.list()["RStudioGD"]))){dev.off()}
TCGAVisualize_volcano <- function(
        x,
        y,
        filename = "volcano.pdf",
        ylab =  expression(paste(-Log[10]," (FDR corrected P-values)")),
        xlab = NULL,
        title = "Volcano plot",
        legend = NULL,
        label = NULL,
        xlim = NULL,
        ylim = NULL,
        color = c("black", "red", "green"),
        names = NULL,
        names.fill = TRUE,
        show.names = "significant",
        x.cut = 0,
        y.cut = 0.01,
        height = 5,
        width = 10,
        highlight = NULL,
        highlight.color = "orange",
        names.size = 4,
        dpi = 300)
{
    if (!is.null(names)) {
        if (all(grepl("\\|", names))) {
            names <- strsplit(names, "\\|")
            names <- unlist(lapply(names, function(x)
                x[1]))
        }
    }
    .e <- environment()
    threshold <- rep("1", length(x))
    names(color) <- as.character(1:3)

    if (is.null(label)) {
        label = c(
            "1" = "Not Significant",
            "2" = "Up regulated",
            "3" = "Down regulated"
        )
    } else  {
        names(label) <- as.character(1:3)
    }
    # get significant data
    sig <-  y < y.cut
    sig[is.na(sig)] <- FALSE

    # If x.cut
    if (length(x.cut) == 1) {
        x.cut.min <- -1 * x.cut
        x.cut.max <- x.cut
    }
    if (length(x.cut) == 2) {
        x.cut.min <- x.cut[1]
        x.cut.max <- x.cut[2]
    }

    # hypermethylated/up regulated samples compared to old state
    up <- x  > x.cut.max
    up[is.na(up)] <- FALSE
    if (any(up & sig)) threshold[up & sig] <- "2"

    # hypomethylated/ down regulated samples compared to old state
    down <-  x < x.cut.min
    down[is.na(down)] <- FALSE
    if (any(down & sig)) threshold[down & sig] <- "3"

    if (!is.null(highlight)) {
        idx <- which(names %in% highlight)
        if (length(idx) > 0) {
            threshold[which(names %in% highlight)]  <- "4"
            color <- c(color, highlight.color)
            names(color) <- as.character(1:4)
        }
    }

    df <- data.frame(
        x = x,
        y = y,
        threshold = threshold
    )

    # As last color should be the highlighthed, we need to order all the vectors
    if (!is.null(highlight)) {
        order.idx <-  order(df$threshold)
        down <- down[order.idx]
        sig <- sig[order.idx]
        up <- up[order.idx]
        df <- df[order.idx,]
        names <- names[order.idx]
    }

    # Plot a volcano plot
    p <- ggplot(
        data = df,
        aes(
            x = x ,
            y = -1 * log10(y),
            colour = threshold
        ),
        environment = .e
    ) +
        geom_point() +
        ggtitle(title) + ylab(ylab) + xlab(xlab) +
        geom_vline(aes(xintercept = x.cut.min),
                   colour = "black",
                   linetype = "dashed") +
        geom_vline(aes(xintercept = x.cut.max),
                   colour = "black",
                   linetype = "dashed") +
        geom_hline(aes(yintercept = -1 * log10(y.cut)),
                   colour = "black",
                   linetype = "dashed") +
        scale_color_manual(
            breaks = as.numeric(names(label)),
            values = color,
            labels = label,
            name = legend
        ) +
        theme_bw() + theme(
            panel.border = element_blank(),
            panel.grid.major = element_blank(),
            panel.grid.minor = element_blank(),
            legend.text = element_text(size = 10),
            plot.title = element_text(hjust = 0.5),
            axis.line.x = element_line(colour = "black"),
            axis.line.y = element_line(colour = "black"),
            legend.position = "top",
            legend.key = element_rect(colour = 'white')
        )

    # Label points with the textxy function from the calibrate plot
    if (!is.null(names)) {
        # With the names the user can highlight the significant genes, up and down
        # or the ones highlighted
        if (show.names == "significant") {
            idx <- (up & sig) | (down & sig)
            important <- c("2", "3")
        } else if (show.names == "highlighted") {
            if (!is.null(highlight)) {
                idx <- (names %in% highlight)
                important <- c("4")
            } else {
                message("Missing highlight argument")
                return(NULL)
            }
        } else if (show.names == "both") {
            if (!is.null(highlight)) {
                idx <- (up & sig) | (down & sig) |  (names %in% highlight)
                important <- c("2", "3", "4")
            } else {
                message("Missing highlight argument")
                return(NULL)
            }
        } else {
            message("Wrong highlight argument")
            return(NULL)
        }

        if (any(threshold %in% important)) {
            check_package("ggrepel")
            if (names.fill) {
                p <- p + ggrepel::geom_label_repel(
                    data = subset(df, threshold %in% important),
                    aes(label = names[idx], fill = threshold),
                    size = names.size,
                    show.legend = FALSE,
                    fontface = 'bold',
                    color = 'white',
                    box.padding = unit(0.35, "lines"),
                    segment.colour = "grey",
                    point.padding = unit(0.3, "lines")
                ) +   scale_fill_manual(values = color[as.numeric(important)])
            }  else {
                p <- p + ggrepel::geom_text_repel(
                    data = subset(df, threshold %in% important),
                    aes(label = names[idx]),
                    size = names.size,
                    show.legend = FALSE,
                    segment.colour = "grey",
                    fontface = 'bold',
                    color = 'black',
                    point.padding = unit(0.3, "lines"),
                    box.padding = unit(0.5, 'lines')
                )
            }
        }
    }

    if(!is.null(xlim)) {
        p <- p + xlim(xlim)
    }

    if(!is.null(ylim)) {
        p <- p + ylim(ylim)
    }

    if (!is.null(filename)) {
        message("Saving file as: ", filename)
        ggsave(
            p,
            filename = filename,
            width = width,
            height = height,
            dpi = dpi
        )
    } else {
        return(p)
    }
}

context("Visualize")

test_that("EAbarplot works", {
    Genelist <- c("FN1","COL1A1")
    ansEA <- TCGAanalyze_EAcomplete(TFname = "DEA genes Normal Vs Tumor",Genelist)
    TCGAvisualize_EAbarplot(
        tf = rownames(ansEA$ResBP),
        GOBPTab = ansEA$ResBP,
        GOCCTab = ansEA$ResCC,
        GOMFTab = ansEA$ResMF,
        PathTab = ansEA$ResPat,
        nRGTab = Genelist,
        nBar = 10,
        filename = "a.pdf")
    expect_true(file.exists("a.pdf"))
    unlink("a.pdf")
})

#' TCGA samples with their Tumor Purity measures
#'
#' A dataset containing the Sample Ids from TCGA tumor purity measured according to 4 estimates attributes of 9364 tumor patients
#'
#' @format A data frame with 9364 rows and 7 variables:
#' \describe{
#'   \item{Sample.ID}{Sample ID from TCGA barcodes, character string}
#'   \item{Cancer.type}{Cancer type, character string}
#'   \item{ESTIMATE}{uses gene expression profiles of 141 immune genes and 141 stromal genes, 0-1 value}
#'   \item{ABSOLUTE}{uses somatic copy-number data (estimations were available for only 11 cancer types), 0-1 value}
#'   \item{LUMP}{(leukocytes unmethylation for purity), which averages 44 non-methylated immune-specific CpG sites, 
#' 0-1value}
#'   \item{IHC}{as estimated by image analysis of haematoxylin and eosin stain slides produced by the Nationwide 
#' Childrens Hospital Biospecimen Core Resource, 0-1 value}
#'   \item{CPE}{derived consensus measurement as the median purity level after normalizing levels from all methods to 
#' give them equal means and s.ds, 0-1 value}
#'   ...
#' }
#' @source \url{https://images.nature.com/original/nature-assets/ncomms/2015/151204/ncomms9971/extref/ncomms9971-s2.xlsx}

"Tumor.purity"

#' @title Hierarchical cluster analysis
#' @description Hierarchical cluster analysis using several methods such as
#'  ward.D", "ward.D2", "single", "complete", "average" (= UPGMA),
#'  "mcquitty" (= WPGMA), "median" (= WPGMC) or "centroid" (= UPGMC).
#' @param tabDF is a dataframe or numeric matrix, each row represents a gene,
#' each column represents a sample come from TCGAPrepare.
#' @param method is method to be used for generic cluster such as 'hclust'
#' or 'consensus'
#' @param methodHC is method to be used for Hierarchical cluster.
#' @import stats
#' @export
#' @return object of class hclust if method selected is 'hclust'.
#' If method selected is 'Consensus' returns a list of length maxK
#' (maximum cluster number to evaluate.). Each element is a list containing
#' consensusMatrix (numerical matrix), consensusTree (hclust), consensusClass
#' (consensus class assignments). ConsensusClusterPlus also produces images.
TCGAanalyze_Clustering <- function(
        tabDF,
        method,
        methodHC = "ward.D2"
) {

    if (!requireNamespace("ConsensusClusterPlus", quietly = TRUE)) {
        stop("ConsensusClusterPlus is needed. Please install it.", call. = FALSE)
    }

    if (method == "hclust") {
        ans <- hclust(ddist <- dist(tabDF), method = methodHC)
    }

    if (method == "consensus") {
        sHc <- hclust(ddist <- dist(tabDF), method = methodHC)
        ans <- ConsensusClusterPlus::ConsensusClusterPlus(
            ddist,
            maxK = 7,
            pItem = 0.9,
            reps = 1000,
            title = "mc_consensus_k7_1000",
            clusterAlg = "hc",
            innerLinkage = "ward.D2",
            finalLinkage = "complete",
            plot = 'pdf',
            writeTable = TRUE
        )
    }

    return(ans)
}


#' @title Array Array Intensity correlation (AAIC) and correlation boxplot to define outlier
#' @description TCGAanalyze_Preprocessing perform Array Array Intensity correlation (AAIC).
#' It defines a square symmetric matrix of spearman correlation among samples.
#' According this matrix and boxplot of correlation samples by samples it is possible
#' to find samples with low correlation that can be identified as possible outliers.
#' @param object gene expression of class RangedSummarizedExperiment from TCGAprepare
#' @param cor.cut is a threshold to filter samples according their spearman correlation in
#' samples by samples. default cor.cut is 0
#' @param filename Filename of the image file
#' @param width Image width
#' @param height Image height
#' @param datatype is a string from RangedSummarizedExperiment assay
#' @importFrom grDevices dev.list
#' @importFrom SummarizedExperiment assays
#' @export
#' @return Plot with array array intensity correlation and boxplot of correlation samples by samples
TCGAanalyze_Preprocessing <- function(
        object,
        cor.cut = 0,
        datatype = names(assays(object))[1],
        filename = NULL,
        width = 1000,
        height = 1000
) {
    # This is a work around for raw_counts and raw_count
    if(missing(object))
        stop("Please set object argument")

    if(!is(object,"RangedSummarizedExperiment"))
        stop("Input object should be a RangedSummarizedExperiment")

    if (grepl("raw_counts", datatype) & any(grepl("raw_counts", names(assays(object)))))
        datatype <- names(assays(object))[grepl("raw_counts", names(assays(object)))]

    if (!any(grepl(datatype, names(assays(object)))))
        stop(
            paste0(
                datatype,
                " not found in the assay list: ",
                paste(names(assays(object)), collapse = ", "),
                "\n  Please set the correct datatype argument."
            )
        )


    if (!(is.null(dev.list()["RStudioGD"]))) {
        dev.off()
    }
    if (is.null(filename)) filename <- "PreprocessingOutput.png"

    png(filename, width = width, height = height)
    par(oma = c(10, 10, 10, 10))
    ArrayIndex <-  as.character(1:length(colData(object)$barcode))

    pmat_new <- matrix(0, length(ArrayIndex), 4)
    colnames(pmat_new) <- c("Disease", "platform", "SampleID", "Study")
    rownames(pmat_new) <- as.character(colData(object)$barcode)
    pmat_new <- as.data.frame(pmat_new)
    pmat_new$Disease <- as.character(colData(object)$definition)
    pmat_new$platform <- "platform"
    pmat_new$SampleID <- as.character(colData(object)$barcode)
    pmat_new$Study <- "study"

    tabGroupCol <- cbind(pmat_new, Color = matrix(0, nrow(pmat_new), 1))

    for (i in seq_along(unique(tabGroupCol$Disease))) {
        tabGroupCol[which(tabGroupCol$Disease == tabGroupCol$Disease[i]), "Color"] <-
            rainbow(length(unique(tabGroupCol$Disease)))[i]
    }
    pmat <- pmat_new
    phenodepth <- min(ncol(pmat), 3)
    order <- switch(
        phenodepth + 1,
        ArrayIndex,
        order(pmat[, 1]),
        order(pmat[, 1], pmat[, 2]),
        order(pmat[, 1], pmat[, 2], pmat[, 3])
    )
    arraypos <-  (1:length(ArrayIndex)) * (1 / (length(ArrayIndex) - 1)) - (1 / (length(ArrayIndex) - 1))
    arraypos2 = seq(1:length(ArrayIndex) - 1)

    for (i in 2:length(ArrayIndex)) {
        arraypos2[i - 1] <- (arraypos[i] + arraypos[i - 1]) / 2
    }
    layout(matrix(c(1, 1, 1, 2, 1, 1, 1, 2, 1, 1, 1, 2, 3, 3, 3, 4), 4, 4, byrow = TRUE))

    c <- cor(assay(object, datatype)[, order], method = "spearman")

    image(c,
          xaxt = "n",
          yaxt = "n",
          #xlab = "Array Samples",
          #ylab = "Array Samples",
          main = "Array-Array Intensity Correlation after RMA"
    )

    for (i in 1:length(names(table(tabGroupCol$Color)))) {
        currentCol <- names(table(tabGroupCol$Color))[i]
        pos.col <- arraypos[which(tabGroupCol$Color == currentCol)]
        lab.col <- colnames(c)[which(tabGroupCol$Color == currentCol)]
        #axis(1, labels = lab.col , at = pos.col, col = currentCol,lwd = 6,las = 2)
        axis(
            2,
            labels = lab.col ,
            at = pos.col,
            col = currentCol,
            lwd = 6,
            las = 2
        )
    }

    m <- matrix(pretty(c, 10), nrow = 1, ncol = length(pretty(c, 10)))

    image(
        m,
        xaxt = "n",
        yaxt = "n",
        ylab = "Correlation Coefficient"
    )

    axis(2,
         labels = as.list(pretty(c, 10)),
         at = seq(0, 1, by = (1 / (
             length(pretty(c,  10)) - 1
         ))))

    abline(
        h = seq(
            (1 / ( length(pretty(c, 10)) - 1)) / 2,
            1 - (1 / ( length(pretty(c, 10)) - 1)),
            by = (1 / ( length(pretty(c, 10)) - 1))
        )
    )
    box()
    boxplot(
        c,
        outline = FALSE,
        las = 2,
        lwd = 6,
        # names = NULL,
        col = tabGroupCol$Color,
        main = "Boxplot of correlation samples by samples after normalization"
    )
    dev.off()

    samplesCor <- rowMeans(c)

    message("Number of outliers: ", sum(samplesCor < cor.cut))
    objectWO <-  assay(object, datatype)[, names(samplesCor)[samplesCor > cor.cut]]

    return(objectWO)
}

#' @title survival analysis (SA) univariate with Kaplan-Meier (KM) method.
#' @description TCGAanalyze_SurvivalKM perform an univariate Kaplan-Meier (KM) survival analysis (SA).
#' It performed Kaplan-Meier survival univariate using complete follow up with all days
#' taking one gene a time from Genelist of gene symbols.
#' For each gene according its level of mean expression in cancer samples,
#' defining two thresholds for quantile
#' expression of that gene in all samples (default ThreshTop=0.67,ThreshDown=0.33) it is possible
#' to define a threshold of intensity of gene expression to divide the samples in 3 groups
#' (High, intermediate, low).
#' TCGAanalyze_SurvivalKM performs SA between High and low groups using following functions
#' from survival package
#' \enumerate{
#' \item survival::Surv
#' \item survival::survdiff
#' \item survival::survfit
#' }
#' @param clinical_patient is a data.frame using function 'clinic' with information
#' related to barcode / samples such as bcr_patient_barcode, days_to_death ,
#' days_to_last_follow_up , vital_status, etc
#' @param dataGE is a matrix of Gene expression (genes in rows, samples in cols) from TCGAprepare
#' @param Genelist is a list of gene symbols where perform survival KM.
#' @param Survresult is a parameter (default = FALSE) if is TRUE will show KM plot and results.
#' @param ThreshTop is a quantile threshold to identify samples with high expression of a gene
#' @param ThreshDown is a quantile threshold to identify samples with low expression of a gene
#' @param p.cut p.values threshold. Default: 0.05
#' @param group1 a string containing the barcode list of the samples in in control group
#' @param group2 a string containing the barcode list of the samples in in disease group
#' @export
#' @return table with survival genes pvalues from KM.
#' @examples
#'  # Selecting only 20 genes for example
#'  dataBRCAcomplete <- log2(dataBRCA[1:20,] + 1)
#'
#'  # clinical_patient_Cancer <- GDCquery_clinic("TCGA-BRCA","clinical")
#'  clinical_patient_Cancer <- data.frame(
#'       bcr_patient_barcode = substr(colnames(dataBRCAcomplete),1,12),
#'       vital_status = c(rep("alive",3),"dead",rep("alive",2),rep(c("dead","alive"),2)),
#'       days_to_death = c(NA,NA,NA,172,NA,NA,3472,NA,786,NA),
#'       days_to_last_follow_up = c(3011,965,718,NA,1914,423,NA,5,656,1417)
#'  )
#'
#'  group1 <- TCGAquery_SampleTypes(colnames(dataBRCAcomplete), typesample = c("NT"))
#'  group2 <- TCGAquery_SampleTypes(colnames(dataBRCAcomplete), typesample = c("TP"))
#'
#'  tabSurvKM <- TCGAanalyze_SurvivalKM(
#'     clinical_patient = clinical_patient_Cancer,
#'     dataGE = dataBRCAcomplete,
#'     Genelist = rownames(dataBRCAcomplete),
#'     Survresult = FALSE,
#'     p.cut = 0.4,
#'     ThreshTop = 0.67,
#'     ThreshDown = 0.33,
#'     group1 = group1, # Control group
#'     group2 = group2
#'   ) # Disease group
#'
#'  # If the groups are not specified group1 == group2 and all samples are used
#'  \dontrun{
#'  tabSurvKM <- TCGAanalyze_SurvivalKM(
#'    clinical_patient_Cancer,
#'    dataBRCAcomplete,
#'    Genelist = rownames(dataBRCAcomplete),
#'    Survresult = TRUE,
#'    p.cut = 0.2,
#'     ThreshTop = 0.67,
#'     ThreshDown = 0.33
#'   )
#' }
TCGAanalyze_SurvivalKM <- function(
        clinical_patient,
        dataGE,
        Genelist,
        Survresult = FALSE,
        ThreshTop = 0.67,
        ThreshDown = 0.33,
        p.cut = 0.05,
        group1,
        group2
) {

    check_package("survival")
    # Check which genes we really have in the matrix
    Genelist <- intersect(rownames(dataGE), Genelist)

    # Split gene expression matrix btw the groups
    dataCancer <- dataGE[Genelist, group2, drop = FALSE]
    dataNormal <- dataGE[Genelist, group1, drop = FALSE]
    colnames(dataCancer)  <- substr(colnames(dataCancer), 1, 12)

    cfu <- clinical_patient[clinical_patient[, "bcr_patient_barcode"] %in% substr(colnames(dataCancer), 1, 12), ]

    if ("days_to_last_followup" %in% colnames(cfu))
        colnames(cfu)[grep("days_to_last_followup", colnames(cfu))] <- "days_to_last_follow_up"

    cfu <-  as.data.frame(
        subset(
            cfu,
            select = c(
                "bcr_patient_barcode",
                "days_to_death",
                "days_to_last_follow_up",
                "vital_status"
            )
        ))

    # Set alive death to inf
    if (length(grep("alive", cfu$vital_status, ignore.case = TRUE)) > 0)
        cfu[grep("alive", cfu$vital_status, ignore.case = TRUE), "days_to_death"] <- "-Inf"

    # Set dead follow up to inf
    if (length(grep("dead", cfu$vital_status, ignore.case = TRUE)) > 0)
        cfu[grep("dead", cfu$vital_status, ignore.case = TRUE), "days_to_last_follow_up"] <- "-Inf"

    cfu <- cfu[!(is.na(cfu[, "days_to_last_follow_up"])), ]
    cfu <- cfu[!(is.na(cfu[, "days_to_death"])), ]

    followUpLevel <- FALSE

    cfu$days_to_death <- as.numeric(as.character(cfu$days_to_death))
    cfu$days_to_last_follow_up <- as.numeric(as.character(cfu$days_to_last_follow_up))
    rownames(cfu) <- cfu[, "bcr_patient_barcode"] #mod1

    cfu <- cfu[!(is.na(cfu[, "days_to_last_follow_up"])), ]
    cfu <- cfu[!(is.na(cfu[, "days_to_death"])), ]

    cfu_complete <- cfu
    ngenes <- nrow(as.matrix(rownames(dataNormal)))

    # Evaluate each gene
    tabSurv_Matrix <- plyr::adply(
        .data = 1:length(rownames(dataNormal)),
        .margins = 1,
        .fun = function(i){

            mRNAselected <- as.matrix(rownames(dataNormal))[i]
            mRNAselected_values <-  dataCancer %>% dplyr::filter(rownames(dataCancer) == mRNAselected) %>% as.numeric
            mRNAselected_values_normal <- dataNormal %>% dplyr::filter(rownames(dataNormal) == mRNAselected) %>% as.numeric
            if (all(mRNAselected_values == 0))  return(NULL) # All genes are 0
            tabSurv_Matrix <- data.frame("mRNA" = mRNAselected)

            # Get Thresh values for cancer expression
            mRNAselected_values_ordered <- sort(mRNAselected_values, decreasing = TRUE)
            mRNAselected_values_ordered_top <- as.numeric(quantile(as.numeric(mRNAselected_values_ordered), ThreshTop)[1])
            mRNAselected_values_ordered_down <- as.numeric(quantile(as.numeric(mRNAselected_values_ordered), ThreshDown)[1])

            mRNAselected_values_newvector <- mRNAselected_values

            if (!is.na(mRNAselected_values_ordered_top)) {
                # How many samples do we have
                numberOfSamples <- length(mRNAselected_values_ordered)

                # High group (above ThreshTop)
                lastelementTOP <- max(which(
                    mRNAselected_values_ordered > mRNAselected_values_ordered_top
                ))

                # Low group (below ThreshDown)
                firstelementDOWN <-  min(
                    which(
                        mRNAselected_values_ordered <= mRNAselected_values_ordered_down
                    )
                )

                samples_top_mRNA_selected <- names(mRNAselected_values_ordered[1:lastelementTOP])
                samples_down_mRNA_selected <- names(mRNAselected_values_ordered[firstelementDOWN:numberOfSamples])

                # Which samples are in the intermediate group (above ThreshLow and below ThreshTop)
                samples_UNCHANGED_mRNA_selected <- names(mRNAselected_values_newvector[
                    which((mRNAselected_values_newvector) > mRNAselected_values_ordered_down &  mRNAselected_values_newvector < mRNAselected_values_ordered_top
                    )])

                cfu_onlyTOP <- cfu_complete[cfu_complete[, "bcr_patient_barcode"] %in% samples_top_mRNA_selected, ]
                cfu_onlyDOWN <- cfu_complete[cfu_complete[, "bcr_patient_barcode"] %in% samples_down_mRNA_selected, ]
                cfu_onlyUNCHANGED <- cfu_complete[cfu_complete[, "bcr_patient_barcode"] %in% samples_UNCHANGED_mRNA_selected, ]

                cfu_ordered <- NULL
                cfu_ordered <- rbind(cfu_onlyTOP, cfu_onlyDOWN)
                cfu <- cfu_ordered

                ttime <- as.numeric(cfu[, "days_to_death"])

                sum(status <- ttime > 0) # morti
                deads_complete <- sum(status <- ttime > 0)

                ttime_only_top <- cfu_onlyTOP[, "days_to_death"]
                deads_top <- sum(ttime_only_top > 0)

                if (dim(cfu_onlyDOWN)[1] >= 1) {
                    ttime_only_down <- cfu_onlyDOWN[, "days_to_death"]
                    deads_down <- sum(ttime_only_down > 0)
                } else {
                    deads_down <- 0
                }

                tabSurv_Matrix[1, "Cancer Deaths"] <- deads_complete
                tabSurv_Matrix[1, "Cancer Deaths with Top"] <- deads_top
                tabSurv_Matrix[1, "Cancer Deaths with Down"] <- deads_down
                tabSurv_Matrix[1, "Mean Normal"] <- mean(as.numeric(mRNAselected_values_normal))
                dataCancer_onlyTop_sample <- dataCancer[, samples_top_mRNA_selected, drop = FALSE]
                dataCancer_onlyTop_sample_mRNASelected <- dataCancer_onlyTop_sample[rownames(dataCancer_onlyTop_sample) == mRNAselected, ]
                dataCancer_onlyDown_sample <- dataCancer[, samples_down_mRNA_selected, drop = FALSE]
                dataCancer_onlyDown_sample_mRNASelected <- dataCancer_onlyDown_sample[rownames(dataCancer_onlyDown_sample) == mRNAselected, ]
                tabSurv_Matrix[1, "Mean Tumor Top"] <- mean(as.numeric(dataCancer_onlyTop_sample_mRNASelected))
                tabSurv_Matrix[1, "Mean Tumor Down"] <- mean(as.numeric(dataCancer_onlyDown_sample_mRNASelected))

                ttime[!status] <- as.numeric(cfu[!status, "days_to_last_follow_up"])
                ttime[which(ttime == -Inf)] <- 0

                ttime <- survival::Surv(ttime, status)
                rownames(ttime) <- rownames(cfu)
                legendHigh <- paste(mRNAselected, "High")
                legendLow  <- paste(mRNAselected, "Low")

                tabSurv_pvalue <- tryCatch({
                    tabSurv <- survival::survdiff(ttime  ~ c(rep(
                        "top", nrow(cfu_onlyTOP)
                    ), rep(
                        "down", nrow(cfu_onlyDOWN)
                    )))
                    tabSurv_chis <- unlist(tabSurv)$chisq
                    tabSurv_pvalue <-
                        as.numeric(1 - pchisq(abs(tabSurv$chisq), df = 1))
                }, error = function(e) {
                    return(Inf)
                })
                tabSurv_Matrix[1, "pvalue"] <- tabSurv_pvalue

                if (Survresult == TRUE) {
                    titlePlot <- paste("Kaplan-Meier Survival analysis, pvalue = ",tabSurv_pvalue)
                    plot(
                        survival::survfit(ttime ~ c(
                            rep("low", nrow(cfu_onlyTOP)), rep("high", nrow(cfu_onlyDOWN))
                        )),
                        col = c("green", "red"),
                        main = titlePlot,
                        xlab = "Days",
                        ylab = "Survival"
                    )
                    legend(
                        100,
                        1,
                        legend = c(legendLow, legendHigh),
                        col = c("green", "red"),
                        text.col = c("green", "red"),
                        pch = 15
                    )
                    print(tabSurv)
                }
            } #end if
            tabSurv_Matrix
        },.progress = "time") #end for

    tabSurv_Matrix[tabSurv_Matrix == "-Inf"] <- 0

    tabSurvKM <- tabSurv_Matrix

    # Filtering by selected pvalue < 0.01
    tabSurvKM <- tabSurvKM[tabSurvKM$mRNA != 0, ]
    tabSurvKM <- tabSurvKM[tabSurvKM$pvalue < p.cut, ]
    tabSurvKM <- tabSurvKM[!duplicated(tabSurvKM$mRNA), ]
    rownames(tabSurvKM) <- tabSurvKM$mRNA
    tabSurvKM <- tabSurvKM[, -1]
    tabSurvKM <- tabSurvKM[order(tabSurvKM$pvalue, decreasing = FALSE), ]

    colnames(tabSurvKM) <- gsub("Cancer", "Group2", colnames(tabSurvKM))
    colnames(tabSurvKM) <- gsub("Tumor", "Group2", colnames(tabSurvKM))
    colnames(tabSurvKM) <- gsub("Normal", "Group1", colnames(tabSurvKM))

    return(tabSurvKM)
}


#' @title Filtering mRNA transcripts and miRNA selecting a threshold.
#' @description
#'    TCGAanalyze_Filtering allows user to filter mRNA transcripts and miRNA,
#'    samples, higher than the threshold defined quantile mean across all samples.
#' @param tabDF is a dataframe or numeric matrix, each row represents a gene,
#' each column represents a sample come from TCGAPrepare
#' @param method is method of filtering such as 'quantile', 'varFilter', 'filter1', 'filter2'
#' @param qnt.cut is threshold selected as mean for filtering
#' @param var.func is function used as the per-feature filtering statistic.
#' See genefilter documentation
#' @param var.cutoff is a numeric value. See genefilter documentation
#' @param eta is a parameter for filter1. default eta = 0.05.
#' @param foldChange is a parameter for filter2. default foldChange = 1.
#' @export
#' @return A filtered dataframe or numeric matrix where each row represents a gene,
#' each column represents a sample
#' @examples
#' dataNorm <- TCGAbiolinks::TCGAanalyze_Normalization(dataBRCA, geneInfo)
#' dataNorm <- TCGAanalyze_Normalization(tabDF = dataBRCA,
#' geneInfo = geneInfo,
#' method = "geneLength")
#' dataFilt <- TCGAanalyze_Filtering(tabDF = dataNorm, method = "quantile", qnt.cut = 0.25)
TCGAanalyze_Filtering <- function(
        tabDF,
        method,
        qnt.cut = 0.25,
        var.func = IQR,
        var.cutoff = 0.75,
        eta = 0.05,
        foldChange = 1
) {
    if (method == "quantile") {
        GeneThresh <- as.numeric(quantile(rowMeans(tabDF,na.rm = TRUE), qnt.cut))
        geneFiltered <- names(which(rowMeans(tabDF) > GeneThresh))
        tabDF_Filt <- tabDF[geneFiltered,]
    }

    if (method == "varFilter") {
        check_package("genefilter")
        tabDF_Filt <- genefilter::varFilter(
            tabDF,
            var.func = IQR,
            var.cutoff = 0.75,
            filterByQuantile = TRUE
        )
    }

    if (method == "filter1") {
        normCounts <- tabDF
        geData <- t(log(1 + normCounts, 2))
        filter <-
            apply(geData, 2, function(x)
                sum(quantile(x, probs = c(1 - eta, eta)) * c(1, -1)))
        tabDF_Filt <- geData[, which(filter > foldChange)]
    }

    if (method == "filter2") {
        geData <- tabDF
        filter <-
            apply(geData, 2, function(x)
                prod(quantile(x, probs =  c(1 - eta, eta)) - 10) < 0)
        tabDF_Filt <- geData[, which(filter)]
    }


    return(tabDF_Filt)
}

#' @title normalization mRNA transcripts and miRNA using EDASeq package.
#' @description
#'   TCGAanalyze_Normalization allows user to normalize mRNA transcripts and miRNA,
#'    using EDASeq package.
#'
#'    Normalization for RNA-Seq Numerical and graphical
#'     summaries of RNA-Seq read data. Within-lane normalization procedures
#'    to adjust for GC-content effect (or other gene-level effects) on read counts:
#'    loess robust local regression, global-scaling, and full-quantile normalization
#'    (Risso et al., 2011). Between-lane normalization procedures to adjust for
#'    distributional differences between lanes (e.g., sequencing depth):
#'    global-scaling and full-quantile normalization (Bullard et al., 2010).
#'
#'    For istance returns all mRNA or miRNA with mean across all
#'    samples, higher than the threshold defined quantile mean across all samples.
#'
#'    TCGAanalyze_Normalization performs normalization using following functions
#'    from EDASeq
#'    \enumerate{
#'    \item  EDASeq::newSeqExpressionSet
#'    \item  EDASeq::withinLaneNormalization
#'    \item  EDASeq::betweenLaneNormalization
#'    \item  EDASeq::counts
#'    }
#' @param tabDF Rnaseq numeric matrix, each row represents a gene,
#' each column represents a sample
#' @param geneInfo Information matrix of 20531 genes about geneLength and gcContent.
#' Two objects are provided: TCGAbiolinks::geneInfoHT,TCGAbiolinks::geneInfo
#' @param method is method of normalization such as 'gcContent' or 'geneLength'
#' @export
#' @return Rnaseq matrix normalized with counts slot holds the count data as a matrix
#' of non-negative integer count values, one row for each observational unit (gene or the like),
#' and one column for each sample.
#' @examples
#' dataNorm <- TCGAbiolinks::TCGAanalyze_Normalization(dataBRCA, geneInfo)
TCGAanalyze_Normalization <- function(
        tabDF,
        geneInfo,
        method = "geneLength"
) {

    check_package("EDASeq")

    # Check if we have a SE, we need a gene expression matrix
    if (is(tabDF, "SummarizedExperiment")) tabDF <- assay(tabDF)

    geneInfo <- geneInfo[!is.na(geneInfo[, 1]), ]
    geneInfo <- as.data.frame(geneInfo)
    geneInfo$geneLength <- as.numeric(as.character(geneInfo$geneLength))
    geneInfo$gcContent <- as.numeric(as.character(geneInfo$gcContent))


    if(any(grepl("\\|",rownames(tabDF)))){
        tmp <- as.character(rownames(tabDF))
        geneNames <- stringr::str_split(tmp, "\\|",simplify = T)
        tmp <- which(geneNames[, 1] == "?")
        geneNames[tmp, 1] <- geneNames[tmp, 2]
        tmp <- table(geneNames[, 1])
        tmp <- which(geneNames[, 1] %in% names(tmp[which(tmp > 1)]))
        geneNames[tmp, 1] <- paste(geneNames[tmp, 1], geneNames[tmp, 2], sep = ".")
        tmp <- table(geneNames[, 1])
        rownames(tabDF) <- geneNames[, 1]
    } else if(any(grepl("ENSG",rownames(tabDF)))){
        rownames(tabDF) <- gsub("\\.[0-9]*","",rownames(tabDF))
    }


    if (method == "gcContent") {
        rawCounts <- tabDF
        commonGenes <-  intersect(rownames(geneInfo), rownames(rawCounts))

        geneInfo <- geneInfo[commonGenes, ]
        rawCounts <- rawCounts[commonGenes, ]

        timeEstimated <- format(ncol(tabDF) * nrow(tabDF) / 80000, digits = 2)
        message(
            messageEstimation <- paste(
                "I Need about ",
                timeEstimated,
                "seconds for this Complete Normalization Upper Quantile",
                " [Processing 80k elements /s]  "
            )
        )

        ffData  <- as.data.frame(geneInfo)
        rawCounts <- floor(rawCounts)

        message("Step 1 of 4: newSeqExpressionSet ...")
        tmp <- EDASeq::newSeqExpressionSet(as.matrix(rawCounts), featureData = ffData)

        #fData(tmp)[, "gcContent"] <- as.numeric(geneInfo[, "gcContent"])

        message("Step 2 of 4: withinLaneNormalization ...")
        tmp <- EDASeq::withinLaneNormalization(
            tmp, "gcContent",
            which = "upper",
            offset = TRUE
        )

        message("Step 3 of 4: betweenLaneNormalization ...")
        if(any(is.na(EDASeq::normCounts(tmp)))) {
            tmp <- tmp[rowSums(is.na(EDASeq::normCounts(tmp))) == 0,]
        }
        tmp <- EDASeq::betweenLaneNormalization(
            tmp,
            which = "upper",
            offset = TRUE
        )
        normCounts <-  log(rawCounts[rownames(tmp),] + .1) + EDASeq::offst(tmp)
        normCounts <-  floor(exp(normCounts) - .1)

        message("Step 4 of 4: .quantileNormalization ...")
        tmp <- t(.quantileNormalization(t(normCounts)))
        tabDF_norm <- floor(tmp)
    }

    if (method == "geneLength") {
        tabDF <- tabDF[!duplicated(rownames(tabDF)), !duplicated(colnames(tabDF))]
        tabDF <- tabDF[rownames(tabDF) %in% rownames(geneInfo), ]
        #tabDF <- tabDF[rowMeans(tabDF) > 1,]
        tabDF <- tabDF[which(rowSums(tabDF == 0) < ncol(tabDF)),]
        tabDF <- as.matrix(tabDF)

        geneInfo <-  geneInfo[rownames(geneInfo) %in% rownames(tabDF),]
        geneInfo <- geneInfo[!duplicated(rownames(geneInfo)),]
        toKeep <- which(geneInfo[, "geneLength"] != 0)
        geneInfo <- geneInfo[toKeep,]
        tabDF <- tabDF[toKeep,]
        geneInfo <- as.data.frame(geneInfo)
        tabDF <- round(tabDF)
        commonGenes <- intersect(rownames(tabDF), rownames(geneInfo))

        tabDF <- tabDF[commonGenes, ]
        geneInfo <- geneInfo[commonGenes, ]

        timeEstimated <-  format(ncol(tabDF) * nrow(tabDF) / 80000, digits = 2)
        message(
            messageEstimation <- paste(
                "I Need about ",
                timeEstimated,
                "seconds for this Complete Normalization Upper Quantile",
                " [Processing 80k elements /s]  "
            )
        )

        message("Step 1 of 4: newSeqExpressionSet ...")

        tabDF_norm <- EDASeq::newSeqExpressionSet(
            tabDF,
            featureData = geneInfo
        )
        message("Step 2 of 4: withinLaneNormalization ...")

        tabDF_norm <-  EDASeq::withinLaneNormalization(
            tabDF_norm,
            "geneLength",
            which = "upper",
            offset = FALSE
        )

        message("Step 3 of 4: betweenLaneNormalization ...")
        if(any(is.na(EDASeq::normCounts(tabDF_norm)))) {
            tabDF_norm <- tabDF_norm[rowSums(is.na(EDASeq::normCounts(tabDF_norm))) == 0,]
        }

        tabDF_norm <- EDASeq::betweenLaneNormalization(
            tabDF_norm,
            which = "upper",
            offset = FALSE
        )

        message("Step 4 of 4: exprs ...")
        tabDF_norm <- EDASeq::counts(tabDF_norm)
    }

    # In case NA's were produced to all rows
    if(any(rowSums(is.na(tabDF_norm)) == ncol(tabDF_norm))){
        tabDF_norm <- tabDF_norm[rowSums(is.na(tabDF_norm)) != ncol(tabDF_norm),]
    }

    return(tabDF_norm)
}


#' @title Differential expression analysis (DEA) using edgeR or limma package.
#' @description
#'    TCGAanalyze_DEA allows user to perform Differentially expression analysis (DEA),
#'    using edgeR package or limma to identify differentially expressed genes (DEGs).
#'     It is possible to do a two-class analysis.
#'
#'     TCGAanalyze_DEA performs DEA using following functions from edgeR:
#'     \enumerate{
#'     \item edgeR::DGEList converts the count matrix into an edgeR object.
#'     \item edgeR::estimateCommonDisp each gene gets assigned the same dispersion estimate.
#'     \item edgeR::exactTest performs pair-wise tests for differential expression between two groups.
#'     \item edgeR::topTags takes the output from exactTest(), adjusts the raw p-values using the
#'     False Discovery Rate (FDR) correction, and returns the top differentially expressed genes.
#'     }
#'     TCGAanalyze_DEA performs DEA using following functions from limma:
#'     \enumerate{
#'     \item limma::makeContrasts construct matrix of custom contrasts.
#'     \item limma::lmFit Fit linear model for each gene given a series of arrays.
#'     \item limma::contrasts.fit Given a linear model fit to microarray data, compute estimated coefficients and standard errors for a given set of contrasts.
#'     \item limma::eBayes Given a microarray linear model fit, compute moderated t-statistics, moderated F-statistic, and log-odds of differential expression by empirical Bayes moderation of the standard errors towards a common value.
#'     \item limma::toptable Extract a table of the top-ranked genes from a linear model fit.
#'     }
#' @param mat1 numeric matrix, each row represents a gene,
#' each column represents a sample with Cond1type
#' @param mat2 numeric matrix, each row represents a gene,
#' each column represents a sample with Cond2type
#' @param metadata Add metadata
#' @param Cond1type a string containing the class label of the samples in mat1
#'  (e.g., control group)
#' @param Cond2type a string containing the class label of the samples in mat2
#' (e.g., case group)
#' @param pipeline a string to specify which package to use ("limma" or "edgeR")
#' @param method is 'glmLRT' (1) or 'exactTest' (2) used for edgeR
#' (1) Fit a negative binomial generalized log-linear model to
#' the read counts for each gene
#' (2) Compute genewise exact tests for differences in the means between
#' two groups of negative-binomially distributed counts.
#' @param fdr.cut is a threshold to filter DEGs according their p-value corrected
#' @param logFC.cut is a threshold to filter DEGs according their logFC
#' @param batch.factors a vector containing strings to specify options for batch correction. Options are "Plate", "TSS", "Year", "Portion", "Center", and "Patients"
#' @param ClinicalDF a dataframe returned by GDCquery_clinic() to be used to extract year data
#' @param paired boolean to account for paired or non-paired samples. Set to TRUE for paired case
#' @param log.trans boolean to perform log cpm transformation. Set to TRUE for log transformation
#' @param trend boolean to perform limma-trend pipeline. Set to TRUE to go through limma-trend
#' @param MAT matrix containing expression set as all samples in columns and genes as rows. Do not provide if mat1 and mat2 are used
#' @param contrast.formula string input to determine coefficients and to design contrasts in a customized way
#' @param Condtypes vector of grouping for samples in MAT
#' @param voom boolean to perform voom transformation for limma-voom pipeline. Set to TRUE for voom transformation
#' @export
#' @examples
#' dataNorm <- TCGAbiolinks::TCGAanalyze_Normalization(dataBRCA, geneInfo)
#' dataFilt <- TCGAanalyze_Filtering(tabDF = dataBRCA, method = "quantile", qnt.cut =  0.25)
#' samplesNT <- TCGAquery_SampleTypes(colnames(dataFilt), typesample = c("NT"))
#' samplesTP <- TCGAquery_SampleTypes(colnames(dataFilt), typesample = c("TP"))
#' dataDEGs <- TCGAanalyze_DEA(
#'    mat1 = dataFilt[,samplesNT],
#'    mat2 = dataFilt[,samplesTP],
#'    Cond1type = "Normal",
#'    Cond2type = "Tumor"
#' )
#'
#' @return table with DEGs containing for each gene logFC, logCPM, pValue,and FDR, also for each contrast
TCGAanalyze_DEA <- function (
        mat1,
        mat2,
        metadata = TRUE,
        Cond1type,
        Cond2type,
        pipeline = "edgeR",
        method = "exactTest",
        fdr.cut = 1,
        logFC.cut = 0,
        batch.factors = NULL,
        ClinicalDF = data.frame(),
        paired = FALSE,
        log.trans = FALSE,
        voom = FALSE,
        trend = FALSE,
        MAT = data.frame(),
        contrast.formula = "",
        Condtypes = c()
){

    if(pipeline == "limma")  check_package("limma")
    if(pipeline == "edgeR")  check_package("edgeR")

    table.code <- c(
        "TP",
        "TR",
        "TB",
        "TRBM",
        "TAP",
        "TM",
        "TAM",
        "THOC",
        "TBM",
        "NB",
        "NT",
        "NBC",
        "NEBV",
        "NBM",
        "CELLC",
        "TRB",
        "CELL",
        "XP",
        "XCL"
    )
    names(table.code) <- c(
        "01",
        "02",
        "03",
        "04",
        "05",
        "06",
        "07",
        "08",
        "09",
        "10",
        "11",
        "12",
        "13",
        "14",
        "20",
        "40",
        "50",
        "60",
        "61"
    )
    if (nrow(MAT) == 0) {
        TOC <- cbind(mat1, mat2)
        Cond1num <- ncol(mat1)
        Cond2num <- ncol(mat2)
    }  else {
        TOC <- MAT
    }

    if (metadata == TRUE & all(grepl("TCGA",colnames(TOC)))){
        my_IDs <- get_IDs(TOC)
        Plate <- factor(my_IDs$plate)
        Condition <- factor(my_IDs$condition)
        TSS <- factor(my_IDs$tss)
        Portion <- factor(my_IDs$portion)
        Center <- factor(my_IDs$center)
        Patients <- factor(my_IDs$patient)
    }


    # this makes non-sense for non-TCGA data
    if (paired == TRUE) {
        matched.query <- TCGAquery_MatchedCoupledSampleTypes(
            my_IDs$barcode,
            table.code[unique(my_IDs$sample)]
        )
        my_IDs <- subset(my_IDs, barcode == matched.query)
        TOC <- TOC[, (names(TOC) %in% matched.query)]
    }

    if (nrow(ClinicalDF) > 0) {
        names(ClinicalDF)[names(ClinicalDF) == "bcr_patient_barcode"] <- "patient"
        ClinicalDF$age_at_diag_year <-  floor(clinical$age_at_diagnosis / 365)
        ClinicalDF$diag_year <- ClinicalDF$age_at_diag_year + clinical$year_of_birth
        diag_yearDF <- ClinicalDF[, c("patient", "diag_year")]
        my_IDs <- merge(my_IDs, ClinicalDF, by = "patient")
        Year <- as.factor(my_IDs$diag_year)
    }

    options <- c("Plate", "TSS", "Year", "Portion", "Center",  "Patients")
    if (length(batch.factors) == 0) {
        message("Batch correction skipped since no factors provided")
    } else {
        for (o in batch.factors) {
            if (o %in% options == FALSE)
                stop(paste0(o, " is not a valid batch correction factor"))
            if (o == "Year" & nrow(ClinicalDF) == 0)
                stop(
                    "batch correction using diagnosis year needs clinical info. Provide Clinical Data in arguments"
                )
        }
    }
    additiveformula <- paste(batch.factors, collapse = "+")

    message("----------------------- DEA -------------------------------")
    if (nrow(MAT) == 0) {
        message("o ",Cond1num," samples in Cond1type ",Cond1type)
        message("o ",Cond2num," samples in Cond2type ",Cond2type)
        message("o ", nrow(TOC), " features as miRNA or genes ")
    } else {
        message("o ", nrow(TOC), " features as miRNA or genes ")
    }
    message("This may take some minutes...")

    colnames(TOC) <- paste0("s", 1:ncol(TOC))

    if (length(Condtypes) > 0) {
        tumorType <- factor(x = Condtypes, levels = unique(Condtypes))
    } else {
        tumorType <- factor(
            x = rep(c(Cond1type, Cond2type), c(Cond1num, Cond2num)),
            levels = c(Cond1type, Cond2type)
        )
    }

    if (length(batch.factors) == 0 & length(Condtypes) > 0) {
        if (pipeline == "edgeR")
            design <- model.matrix( ~ tumorType)
        else
            design <- model.matrix( ~ 0 + tumorType)
    } else if (length(batch.factors) == 0 & length(Condtypes) == 0) {
        if (pipeline == "edgeR")
            design <- model.matrix( ~ tumorType)
        else
            design <- model.matrix( ~ 0 + tumorType)
    } else if (length(batch.factors) > 0 & length(Condtypes) == 0) {
        if (pipeline == "edgeR")
            formula <- paste0("~tumorType+", additiveformula)
        else
            formula <- paste0("~0+tumorType+", additiveformula)
        design <- model.matrix(eval(parse(text = formula)))
    } else if (length(batch.factors) > 0 & length(Condtypes) > 0) {
        if (pipeline == "edgeR") {
            formula <- paste0("~tumorType+", additiveformula)
            if (length(Condtypes) > 2)
                formula <- paste0("~0+tumorType+", additiveformula)
        } else {
            formula <- paste0("~0+tumorType+", additiveformula)
        }
        design <- model.matrix(eval(parse(text = formula)))
    }

    if (pipeline == "edgeR") {
        if (method == "exactTest") {
            DGE <- edgeR::DGEList(TOC, group = rep(c(Cond1type, Cond2type), c(Cond1num, Cond2num)))
            disp <- edgeR::estimateCommonDisp(DGE)
            tested <- edgeR::exactTest(disp, pair = c(Cond1type,  Cond2type))
            logFC_table <- tested$table
            tableDEA <- edgeR::topTags(tested, n = nrow(tested$table))$table
            tableDEA <- tableDEA[tableDEA$FDR <= fdr.cut,]
            tableDEA <- tableDEA[abs(tableDEA$logFC) >= logFC.cut,]
        }
        else if (method == "glmLRT") {
            if (length(unique(tumorType)) == 2) {
                aDGEList <- edgeR::DGEList(counts = TOC, group = tumorType)
                aDGEList <- edgeR::estimateGLMCommonDisp(aDGEList, design)
                aDGEList <- edgeR::estimateGLMTagwiseDisp(aDGEList, design)
                aGlmFit <- edgeR::glmFit(
                    aDGEList,
                    design,
                    dispersion = aDGEList$tagwise.dispersion,
                    prior.count.total = 0
                )

                aGlmLRT <- edgeR::glmLRT(aGlmFit, coef = 2)
                tableDEA <-  cbind(aGlmLRT$table, FDR = p.adjust(aGlmLRT$table$PValue, "fdr"))
                tableDEA <- tableDEA[tableDEA$FDR < fdr.cut, ]
                tableDEA <- tableDEA[abs(tableDEA$logFC) > logFC.cut, ]

                if (all(grepl("ENSG", rownames(tableDEA)))){
                    tableDEA <- cbind(tableDEA, map.ensg(genes = rownames(tableDEA))[, c("gene_name","gene_type")])
                }
            } else if (length(unique(tumorType)) > 2) {
                aDGEList <- edgeR::DGEList(counts = TOC, group = tumorType)
                colnames(design)[1:length(levels(tumorType))] <- levels(tumorType)
                prestr = "makeContrasts("
                poststr = ",levels=design)"
                commandstr = paste(prestr, contrast.formula,  poststr, sep = "")
                commandstr = paste0("limma::", commandstr)
                cont.matrix <- eval(parse(text = commandstr))
                aDGEList <- edgeR::estimateGLMCommonDisp(aDGEList, design)
                aDGEList <- edgeR::estimateGLMTagwiseDisp(aDGEList,  design)

                aGlmFit <- edgeR::glmFit(
                    aDGEList,
                    design,
                    dispersion = aDGEList$tagwise.dispersion,
                    prior.count.total = 0
                )

                tableDEA <- list()
                for (mycoef in colnames(cont.matrix)) {
                    message(paste0("DEA for", " :", mycoef))
                    aGlmLRT <- edgeR::glmLRT(aGlmFit, contrast = cont.matrix[, mycoef])
                    tt <- aGlmLRT$table
                    tt <-  cbind(tt, FDR = p.adjust(aGlmLRT$table$PValue,"fdr"))
                    tt <- tt[(tt$FDR < fdr.cut & abs(as.numeric(tt$logFC)) > logFC.cut),]
                    tableDEA[[as.character(mycoef)]] <- tt
                    if (all(grepl("ENSG", rownames(tableDEA[[as.character(mycoef)]]))))
                        tableDEA[[as.character(mycoef)]] <-
                        cbind(tableDEA[[as.character(mycoef)]],
                              map.ensg(genes = rownames(tableDEA[[as.character(mycoef)]]))[,2:3])
                }
            }
        } else {
            stop(
                paste0(
                    method,
                    " is not a valid DEA method option. Choose 'exactTest' or 'glmLRT' "
                )
            )
        }
    } else if (pipeline == "limma") {
        if (log.trans == TRUE){
            logCPM <- edgeR::cpm(TOC, log = TRUE, prior.count = 3)
        } else {
            logCPM <- TOC
        }

        if (voom == TRUE) {
            message("Voom Transformation...")
            logCPM <- limma::voom(logCPM, design)
        }

        if (length(unique(tumorType)) == 2) {
            colnames(design)[1:2] <- c(Cond1type, Cond2type)
            contr <- paste0(Cond2type, "-", Cond1type)
            cont.matrix <- limma::makeContrasts(contrasts = contr, levels = design)
            fit <- limma::lmFit(logCPM, design)
            fit <- limma::contrasts.fit(fit, cont.matrix)

            if (trend == TRUE) {
                fit <- limma::eBayes(fit, trend = TRUE)
            } else {
                fit <- limma::eBayes(fit, trend = FALSE)
            }
            tableDEA <- limma::topTable(
                fit,
                coef = 1,
                adjust.method = "fdr",
                number = nrow(TOC)
            )
            limma::volcanoplot(fit, highlight = 10)
            index <- which(tableDEA[, 4] < fdr.cut)
            tableDEA <- tableDEA[index,]
            neg_logFC.cut <- -1 * logFC.cut
            index <- which(abs(as.numeric(tableDEA$logFC)) > logFC.cut)
            tableDEA <- tableDEA[index,]
        }
        else if (length(unique(tumorType)) > 2) {
            DGE <- edgeR::DGEList(TOC, group = tumorType)
            colnames(design)[1:length(levels(tumorType))] <- levels(tumorType)
            prestr = "makeContrasts("
            poststr = ",levels=colnames(design))"
            commandstr = paste(prestr, contrast.formula, poststr, sep = "")
            commandstr = paste0("limma::", commandstr)
            cont.matrix <- eval(parse(text = commandstr))
            fit <- limma::lmFit(logCPM, design)
            fit <- limma::contrasts.fit(fit, cont.matrix)
            if (trend == TRUE){
                fit <- limma::eBayes(fit, trend = TRUE)
            } else {
                fit <- limma::eBayes(fit, trend = FALSE)
            }

            tableDEA <- list()
            for (mycoef in colnames(cont.matrix)) {
                tableDEA[[as.character(mycoef)]] <- limma::topTable(
                    fit,
                    coef = mycoef,
                    adjust.method = "fdr",
                    number = nrow(MAT)
                )
                message(paste0("DEA for", " :", mycoef))
                tempDEA <- tableDEA[[as.character(mycoef)]]
                index.up <- which(tempDEA$adj.P.Val < fdr.cut & abs(as.numeric(tempDEA$logFC)) > logFC.cut)
                tableDEA[[as.character(mycoef)]] <- tempDEA[index.up,]
                if (all(grepl("ENSG", rownames(tableDEA[[as.character(mycoef)]]))))
                    tableDEA[[as.character(mycoef)]] <-
                    cbind(tableDEA[[as.character(mycoef)]],
                          map.ensg(genes = rownames(tableDEA[[as.character(mycoef)]]))[,  2:3])
            }
        }
    }  else {
        stop(paste0(
            pipeline,
            " is not a valid pipeline option. Choose 'edgeR' or 'limma'"
        ))
    }
    message("----------------------- END DEA -------------------------------")
    return(tableDEA)
}


#' @title Batch correction using ComBat and Voom transformation using limma package.
#' @description
#'    TCGAbatch_correction allows user to perform a Voom correction on gene expression data and have it ready for DEA.
#'    One can also use ComBat for batch correction for exploratory analysis. If batch.factor or adjustment argument is "Year"
#'  please provide clinical data. If no batch factor is provided, the data will be voom corrected only
#'
#'     TCGAanalyze_DEA performs DEA using following functions from sva and limma:
#'     \enumerate{
#'     \item limma::voom Transform RNA-Seq Data Ready for Linear Modelling.
#'     \item sva::ComBat Adjust for batch effects using an empirical Bayes framework.
#'     }
#' @param tabDF numeric matrix, each row represents a gene,
#' each column represents a sample
#' @param batch.factor a string containing the batch factor to use for correction.
#'  Options are "Plate", "TSS", "Year", "Portion", "Center"
#' @param adjustment vector containing strings for factors to adjust for using ComBat.
#' Options are "Plate", "TSS", "Year", "Portion", "Center"
#' @param UnpublishedData if TRUE perform a batch correction after adding new data
#' @param ClinicalDF a dataframe returned by GDCquery_clinic() to be used to extract year data
#' @param AnnotationDF a dataframe with column Batch indicating different batches of the samples in the tabDF
#' @export
#' @return data frame with ComBat batch correction applied
TCGAbatch_Correction <- function (
        tabDF,
        batch.factor = NULL,
        adjustment = NULL,
        ClinicalDF = data.frame(),
        UnpublishedData = FALSE,
        AnnotationDF = data.frame()
){
    check_package("sva")

    # code for non-TCGA samples
    if (UnpublishedData == TRUE) {
        if(!"Batch" %in% colnames(AnnotationDF)) {
            stop("AnnotationDF should have a Batch column")
        } else {
            batch.factor <- as.factor(AnnotationDF$Batch)
        }

        if(!"Condition" %in% colnames(AnnotationDF)) {
            mod <- model.matrix(~as.factor(Condition),data = AnnotationDF)
        } else {
            mod <- NULL
        }

        batch_corr <- sva::ComBat(
            dat = tabDF,
            batch = batch.factor,
            mod = mod,
            par.prior = TRUE,
            prior.plots = TRUE
        )
    }

    if (UnpublishedData == FALSE) {
        if (length(batch.factor) == 0 & length(adjustment) == 0)
            message("batch correction will be skipped")
        else if (batch.factor %in% adjustment) {
            stop(paste0("Cannot adjust and correct for the same factor|"))
        }
        my_IDs <- get_IDs(tabDF)
        if (length(batch.factor) > 0 || length(adjustment) > 0)
            if ((nrow(ClinicalDF) > 0 & batch.factor == "Year") ||
                ("Year" %in% adjustment == TRUE & nrow(ClinicalDF) >
                 0)) {
                names(ClinicalDF)[names(ClinicalDF) == "bcr_patient_barcode"] <-
                    "patient"
                ClinicalDF$age_at_diag_year <-
                    floor(ClinicalDF$age_at_diagnosis / 365)
                ClinicalDF$diag_year <-
                    ClinicalDF$age_at_diag_year +
                    ClinicalDF$year_of_birth
                diag_yearDF <- ClinicalDF[, c("patient", "diag_year")]
                Year <- merge(my_IDs, diag_yearDF, by = "patient")
                Year <- Year$diag_year
                Year <- as.factor(Year)
            }
        else if (nrow(ClinicalDF) == 0 & batch.factor == "Year") {
            stop("Cannot extract Year data. Clinical data was not provided")
        }
        Plate <- as.factor(my_IDs$plate)
        Condition <- as.factor(my_IDs$condition)
        TSS <- as.factor(my_IDs$tss)
        Portion <- as.factor(my_IDs$portion)
        Sequencing.Center <- as.factor(my_IDs$center)
        design.mod.combat <- model.matrix( ~ Condition)
        options <- c("Plate", "TSS", "Year", "Portion", "Sequencing Center")

        if (length(batch.factor) > 1)
            stop("Combat can only correct for one batch variable. Provide one batch factor")
        if (batch.factor %in% options == FALSE)
            stop(paste0(o, " is not a valid batch correction factor"))

        for (o in adjustment) {
            if (o %in% options == FALSE)
                stop(paste0(o, " is not a valid adjustment factor"))

        }
        adjustment.data <- c()
        for (a in adjustment) {
            if (a == "Sequencing Center")
                a <- Sequencing.Center
            adjustment.data <-
                cbind(eval(parse(text = a)), adjustment.data)
        }
        if (batch.factor == "Sequencing Center")
            batch.factor <- Sequencing.Center
        batchCombat <- eval(parse(text = batch.factor))
        if (length(adjustment) > 0) {
            adjustment.formula <- paste(adjustment, collapse = "+")
            adjustment.formula <- paste0("+", adjustment.formula)
            adjustment.formula <- paste0("~Condition", adjustment.formula)
            print(adjustment.formula)
            model <- data.frame(batchCombat, row.names = colnames(tabDF))
            design.mod.combat <-  model.matrix(
                eval(parse(text = adjustment.formula)),
                data = model
            )
        }
        print(unique(batchCombat))
        batch_corr <- sva::ComBat(
            dat = tabDF,
            batch = batchCombat,
            mod = design.mod.combat,
            par.prior = TRUE,
            prior.plots = TRUE
        )
    }

    return(batch_corr)
}

##Function to take raw counts by removing rows filtered after norm and filter process###

#' @title Use raw count from the DataPrep object which genes are removed by normalization and filtering steps.
#' @description function to keep raw counts after filtering and/or normalizing.
#' @param DataPrep DataPrep object returned by TCGAanalyze_Preprocessing()
#' @param DataFilt Filtered data frame containing samples in columns and genes in rows after normalization and/or filtering steps
#' @examples
#' \dontrun{
#'   dataPrep_raw <- UseRaw_afterFilter(dataPrep, dataFilt)
#' }
#' @export
#' @return Filtered return object similar to DataPrep with genes removed after normalization and filtering process.
UseRaw_afterFilter <- function(DataPrep, DataFilt) {
    rownames(DataPrep) <-
        lapply(rownames(DataPrep), function(x)
            gsub("[[:punct:]]\\d*", "", x))
    filtered.list <- setdiff(rownames(DataPrep), rownames(DataFilt))
    Res <- DataPrep[!rownames(DataPrep) %in% filtered.list,]
    return(Res)
}

#' @title Adding information related to DEGs genes from DEA as mean values in two conditions.
#' @description
#'    TCGAanalyze_LevelTab allows user to add information related to DEGs genes from
#'    Differentially expression analysis (DEA) such as mean values and in two conditions.
#' @param FC_FDR_table_mRNA Output of dataDEGs filter by abs(LogFC) >=1
#' @param typeCond1 a string containing the class label of the samples
#'  in TableCond1  (e.g., control group)
#' @param typeCond2 a string containing the class label of the samples
#' in TableCond2  (e.g., case group)
#' @param TableCond1 numeric matrix, each row represents a gene, each column
#'  represents a sample with Cond1type
#' @param TableCond2 numeric matrix, each row represents a gene, each column
#' represents a sample with Cond2type
#' @param typeOrder typeOrder
#' @export
#' @return table with DEGs, log Fold Change (FC), false discovery rate (FDR),
#' the gene expression level
#' for samples in  Cond1type, and Cond2type, and Delta value (the difference
#' of gene expression between the two
#' conditions multiplied logFC)
#' @examples
#' dataNorm <- TCGAbiolinks::TCGAanalyze_Normalization(dataBRCA, geneInfo)
#' dataFilt <- TCGAanalyze_Filtering(tabDF = dataBRCA, method = "quantile", qnt.cut =  0.25)
#' samplesNT <- TCGAquery_SampleTypes(colnames(dataFilt), typesample = c("NT"))
#' samplesTP <- TCGAquery_SampleTypes(colnames(dataFilt), typesample = c("TP"))
#' dataDEGs <- TCGAanalyze_DEA(
#'   dataFilt[,samplesNT],
#'   dataFilt[,samplesTP],
#'   Cond1type = "Normal",
#'   Cond2type = "Tumor"
#' )
#' dataDEGsFilt <- dataDEGs[abs(dataDEGs$logFC) >= 1,]
#' dataTP <- dataFilt[,samplesTP]
#' dataTN <- dataFilt[,samplesNT]
#' dataDEGsFiltLevel <- TCGAanalyze_LevelTab(
#'   FC_FDR_table_mRNA = dataDEGsFilt,
#'   typeCond1 = "Tumor",
#'   typeCond2 = "Normal",
#'   TableCond1 = dataTP,
#'   TableCond2 = dataTN
#' )
TCGAanalyze_LevelTab <- function(
        FC_FDR_table_mRNA,
        typeCond1,
        typeCond2,
        TableCond1,
        TableCond2,
        typeOrder = TRUE
) {
    TableLevel <- data.frame(
        "mRNA" = rownames(FC_FDR_table_mRNA),
        "logFC" = FC_FDR_table_mRNA$logFC,
        "FDR" = FC_FDR_table_mRNA$FDR,
        "Delta" =  FC_FDR_table_mRNA$logFC * rowMeans(TableCond1[rownames(FC_FDR_table_mRNA),],na.rm = TRUE)
    )
    TableLevel[[typeCond1]] <- rowMeans(TableCond1[TableLevel$mRNA,],na.rm = TRUE)
    TableLevel[[typeCond2]] <- rowMeans(TableCond2[TableLevel$mRNA,],na.rm = TRUE)

    TableLevel <- TableLevel[order(as.numeric(TableLevel[, "Delta"]), decreasing = typeOrder),]
    rownames(TableLevel) <-  TableLevel[, "mRNA"]

    if (all(grepl("ENSG", rownames(TableLevel))))
        TableLevel <- cbind(TableLevel, map.ensg(genes = rownames(TableLevel))[, 2:3])

    return(TableLevel)
}

#' @title Enrichment analysis for Gene Ontology (GO) [BP,MF,CC] and Pathways
#' @description
#'   Researchers, in order to better understand the underlying biological
#'   processes, often want to retrieve a functional profile of a set of genes
#'   that might have an important role. This can be done by performing an
#'   enrichment analysis.
#'
#'We will perform an enrichment analysis on gene sets using the TCGAanalyze_EAcomplete
#'function. Given a set of genes that are
#'up-regulated under certain conditions, an enrichment analysis will find
#'identify classes of genes or proteins that are #'over-represented using
#'annotations for that gene set.
#' @param TFname is the name of the list of genes or TF's regulon.
#' @param RegulonList List of genes such as TF's regulon or DEGs where to find enrichment.
#' @export
#' @return Enrichment analysis GO[BP,MF,CC] and Pathways complete table enriched by genelist.
#' @examples
#' Genelist <- c("FN1","COL1A1")
#' ansEA <- TCGAanalyze_EAcomplete(TFname="DEA genes Normal Vs Tumor",Genelist)
#' \dontrun{
#' Genelist <- rownames(dataDEGsFiltLevel)
#' system.time(ansEA <- TCGAanalyze_EAcomplete(TFname="DEA genes Normal Vs Tumor",Genelist))
#' }
TCGAanalyze_EAcomplete <- function(TFname, RegulonList) {
    # This is a verification of the input
    # in case the List is like Gene|ID
    # we will get only the Gene
    if (all(grepl("\\|", RegulonList))) {
        RegulonList <- strsplit(RegulonList, "\\|")
        RegulonList <- unlist(lapply(RegulonList, function(x)
            x[1]))
    }

    print(
        paste(
            "I need about ",
            "1 minute to finish complete ",
            "Enrichment analysis GO[BP,MF,CC] and Pathways... "
        )
    )

    ResBP <- TCGAanalyze_EA(TFname, RegulonList, DAVID_BP_matrix,
                            EAGenes, GOtype = "DavidBP")
    print("GO Enrichment Analysis BP completed....done")
    ResMF <- TCGAanalyze_EA(TFname, RegulonList, DAVID_MF_matrix,
                            EAGenes, GOtype = "DavidMF")
    print("GO Enrichment Analysis MF completed....done")
    ResCC <- TCGAanalyze_EA(TFname, RegulonList, DAVID_CC_matrix,
                            EAGenes, GOtype = "DavidCC")
    print("GO Enrichment Analysis CC completed....done")
    ResPat <- TCGAanalyze_EA(TFname, RegulonList, listEA_pathways,
                             EAGenes, GOtype = "Pathway")
    print("Pathway Enrichment Analysis completed....done")

    ans <-
        list(
            ResBP = ResBP,
            ResMF = ResMF,
            ResCC = ResCC,
            ResPat = ResPat
        )
    return(ans)
}

#' @title Enrichment analysis of a gene-set with GO [BP,MF,CC]  and pathways.
#' @description
#' The rational behind a enrichment analysis ( gene-set, pathway etc) is to compute
#' statistics of whether the overlap between the focus list (signature) and the gene-set
#' is significant. ie the confidence that overlap between the list is not due to chance.
#'  The Gene Ontology project describes genes (gene products) using terms from
#'  three structured vocabularies: biological process, cellular component and molecular function.
#'  The Gene Ontology Enrichment component, also referred to as the GO Terms" component, allows
#'  the genes in any such "changed-gene" list to be characterized using the Gene Ontology terms
#'  annotated to them. It asks, whether for any particular GO term, the fraction of genes
#'  assigned to it in the "changed-gene" list is higher than expected by chance
#'  (is over-represented), relative to the fraction of genes assigned to that term in the
#'  reference set.
#'  In statistical terms it perform the analysis tests the null hypothesis that,
#'  for any particular ontology term, there is no difference in the proportion of genes
#'  annotated to it in the reference list and the proportion annotated to it in the test list.
#'  We adopted a Fisher Exact Test to perform the EA.
#' @param GeneName is the name of gene signatures list
#' @param TableEnrichment is a table related to annotations of gene symbols such as
#' GO[BP,MF,CC] and Pathways. It was created from DAVID gene ontology on-line.
#' @param RegulonList is a gene signature (lisf of genes) in which perform EA.
#' @param GOtype is type of gene ontology Biological process (BP), Molecular Function (MF),
#' Cellular componet (CC)
#' @param FDRThresh pvalue corrected (FDR) as threshold to selected significant
#' BP, MF,CC, or pathways. (default FDR < 0.01)
#' @param EAGenes is a table with informations about genes
#' such as ID, Gene, Description, Location and Family.
#' @param GeneSymbolsTable if it is TRUE will return a table with GeneSymbols in common GO or pathways.
# @export
#' @import stats
#' @return Table with enriched GO or pathways by selected gene signature.
#' @examples
#' \dontrun{
#' EAGenes <- get("EAGenes")
#' RegulonList <- rownames(dataDEGsFiltLevel)
#' ResBP <- TCGAanalyze_EA(
#'   GeneName="DEA genes Normal Vs Tumor",
#'   RegulonList = RegulonList,
#'   TableEnrichment = DAVID_BP_matrix,
#'    EAGenes = EAGenes,
#'    GOtype = "DavidBP"
#'  )
#'}
TCGAanalyze_EA <- function (
        GeneName,
        RegulonList,
        TableEnrichment,
        EAGenes,
        GOtype,
        FDRThresh = 0.01,
        GeneSymbolsTable = FALSE
) {
    topPathways <- nrow(TableEnrichment)
    topPathways_tab <- matrix(0, 1, topPathways)
    topPathways_tab <- as.matrix(topPathways_tab)
    rownames(topPathways_tab) <- GeneName
    rownames(EAGenes) <- toupper(rownames(EAGenes))
    EAGenes <- EAGenes[!duplicated(EAGenes[, "ID"]),]
    rownames(EAGenes) <- EAGenes[, "ID"]
    allgene <- EAGenes[, "ID"]
    current_pathway_from_EA <- as.matrix(TableEnrichment[, GOtype])
    TableNames <- gsub("David",
                       "",
                       paste("Top ", GOtype, " n. ",
                             1:topPathways, " of ", topPathways, sep = ""))
    colnames(topPathways_tab) <- TableNames
    topPathways_tab <- as.data.frame(topPathways_tab)
    table_pathway_enriched <-  matrix(1, nrow(current_pathway_from_EA),  8)
    colnames(table_pathway_enriched) <- c(
        "Pathway",
        "GenesInPathway",
        "Pvalue",
        "FDR",
        "CommonGenesPathway",
        "PercentPathway",
        "PercentRegulon",
        "CommonGeneSymbols"
    )
    table_pathway_enriched <- as.data.frame(table_pathway_enriched)
    for (i in 1:nrow(current_pathway_from_EA)) {
        table_pathway_enriched[i, "Pathway"] <-
            as.character(current_pathway_from_EA[i,])
        if (nrow(TableEnrichment) == 589) {
            genes_from_current_pathway_from_EA <-
                GeneSplitRegulon(TableEnrichment[TableEnrichment[GOtype] ==
                                                     as.character(current_pathway_from_EA[i,]),][,
                                                                                                 "Molecules"], ",")
        }
        else {
            genes_from_current_pathway_from_EA <-
                GeneSplitRegulon(TableEnrichment[TableEnrichment[GOtype] ==
                                                     as.character(current_pathway_from_EA[i,]),][,
                                                                                                 "Molecules"], ", ")
        }
        genes_common_pathway_TFregulon <-  as.matrix(intersect(
            toupper(RegulonList),
            toupper(genes_from_current_pathway_from_EA)
        ))
        if (length(genes_common_pathway_TFregulon) != 0) {
            current_pathway_commongenes_num <-
                length(genes_common_pathway_TFregulon)
            seta <- allgene %in% RegulonList
            setb <- allgene %in% genes_from_current_pathway_from_EA
            ft <- fisher.test(seta, setb)
            FisherpvalueTF <- ft$p.value
            table_pathway_enriched[i, "Pvalue"] <-
                as.numeric(FisherpvalueTF)
            if (FisherpvalueTF < 0.01) {
                current_pathway_commongenes_percent <- paste(
                    "(",
                    format((
                        current_pathway_commongenes_num / length(genes_from_current_pathway_from_EA)
                    ) *
                        100,
                    digits = 2
                    ), "%)"
                )
                current_pathway_commongenes_num_with_percent <-
                    gsub(
                        " ",
                        "",
                        paste(
                            current_pathway_commongenes_num,
                            current_pathway_commongenes_percent,
                            "pv=",
                            format(FisherpvalueTF, digits = 2)
                        )
                    )
                table_pathway_enriched[i, "CommonGenesPathway"] <-
                    length(genes_common_pathway_TFregulon)
                table_pathway_enriched[i, "CommonGeneSymbols"] <-
                    paste0(genes_common_pathway_TFregulon, collapse = ";")
                table_pathway_enriched[i, "GenesInPathway"] <-
                    length(genes_from_current_pathway_from_EA)
                table_pathway_enriched[i, "PercentPathway"] <-
                    as.numeric(table_pathway_enriched[i,
                                                      "CommonGenesPathway"]) /
                    as.numeric(table_pathway_enriched[i,
                                                      "GenesInPathway"]) * 100
                table_pathway_enriched[i, "PercentRegulon"] <-
                    as.numeric(table_pathway_enriched[i,
                                                      "CommonGenesPathway"]) /
                    length(RegulonList) *
                    100
            }
        }
    }
    table_pathway_enriched <-
        table_pathway_enriched[order(table_pathway_enriched[,
                                                            "Pvalue"], decreasing = FALSE),]
    table_pathway_enriched <-
        table_pathway_enriched[table_pathway_enriched[,
                                                      "Pvalue"] < 0.01,]
    table_pathway_enriched[, "FDR"] <-
        p.adjust(table_pathway_enriched[,
                                        "Pvalue"], method = "fdr")
    table_pathway_enriched <-
        table_pathway_enriched[table_pathway_enriched[,
                                                      "FDR"] < FDRThresh,]
    table_pathway_enriched <-
        table_pathway_enriched[order(table_pathway_enriched[,
                                                            "FDR"], decreasing = FALSE),]

    table_pathway_enriched_filt <-
        table_pathway_enriched[table_pathway_enriched$FDR < FDRThresh, ]

    if (nrow(table_pathway_enriched) > 0) {
        tmp <- table_pathway_enriched
        tmp <- paste(
            tmp[, "Pathway"],
            "; FDR= ",
            format(tmp[,
                       "FDR"], digits = 3),
            "; (ng=",
            round(tmp[, "GenesInPathway"]),
            "); (ncommon=",
            format(tmp[, "CommonGenesPathway"],
                   digits = 2),
            ")",
            sep = ""
        )
        tmp <- as.matrix(tmp)
        topPathways_tab <-
            topPathways_tab[, 1:nrow(table_pathway_enriched),
                            drop = FALSE]
        topPathways_tab[1,] <- tmp
    }
    else {
        topPathways_tab <- NA
    }

    if (GeneSymbolsTable == FALSE) {
        return(topPathways_tab)
    }

    if (GeneSymbolsTable == TRUE) {
        return(table_pathway_enriched_filt)
    }
}

#' @title Differentially expression analysis (DEA) using limma package.
#' @description Differentially expression analysis (DEA) using limma package.
#' @param FC.cut write
#' @param AffySet A matrix-like data object containing log-ratios or log-expression values
#' for a series of arrays, with rows corresponding to genes and columns to samples
#' @examples
#' \dontrun{
#' to add example
#' }
#' @export
#' @return List of list with tables in 2 by 2 comparison
#' of the top-ranked genes from a linear model fitted by DEA's limma
TCGAanalyze_DEA_Affy <- function(AffySet, FC.cut = 0.01) {
    if (!requireNamespace("Biobase", quietly = TRUE)) {
        stop("Biobase package is needed for this function to work. Please install it.",
             call. = FALSE)
    }
    if (!requireNamespace("limma", quietly = TRUE)) {
        stop("limma package is needed for this function to work. Please install it.",
             call. = FALSE)
    }
    Pdatatable <- Biobase::phenoData(AffySet)

    f <- factor(Pdatatable$Disease)
    groupColors <- names(table(f))

    tmp <- matrix(0, length(groupColors), length(groupColors))
    colnames(tmp) <- groupColors
    rownames(tmp) <- groupColors
    tmp[upper.tri(tmp)] <- 1


    sample_tab <- Pdatatable
    f <- factor(Pdatatable$Disease)
    design <- model.matrix( ~ 0 + f)
    colnames(design) <- levels(f)
    fit <- limma::lmFit(AffySet, design) ## fit is an object of class MArrayLM.

    groupColors <- names(table(Pdatatable$Disease))

    CompleteList <- vector("list", sum(tmp))

    k <- 1

    for (i in 1:length(groupColors)) {
        col1 <- colnames(tmp)[i]
        for (j in 1:length(groupColors)) {
            col2 <- rownames(tmp)[j]

            if (i != j) {
                if (tmp[i, j] != 0) {
                    Comparison <- paste(col2, "-", col1, sep = "")

                    if (i == 4 &&
                        j == 6) {
                        Comparison <- paste(col1, "-", col2, sep = "")
                    }
                    if (i == 5 &&
                        j == 6) {
                        Comparison <- paste(col1, "-", col2, sep = "")
                    }

                    print(paste(i, j, Comparison, "to do..."))

                    cont.matrix <- limma::makeContrasts(I = Comparison, levels = design)

                    fit2 <- limma::contrasts.fit(fit, cont.matrix)
                    fit2 <- limma::eBayes(fit2)



                    sigI <-  limma::topTable(
                        fit2,
                        coef = 1,
                        adjust.method = "BH",
                        sort.by = "B",
                        p.value = 0.05,
                        lfc = FC.cut,
                        number = 50000
                    )

                    sigIbis <-   sigI[order(abs(as.numeric(sigI$logFC)), decreasing = TRUE), ]
                    names(CompleteList)[k] <- gsub("-", "_", Comparison)
                    CompleteList[[k]] <- sigIbis
                    k <- k + 1
                }
            }
        }

    }

    return(CompleteList)
}


#' @title Generate network
#' @description TCGAanalyze_analyseGRN perform gene regulatory network.
#' @param TFs a vector of genes.
#' @param normCounts is a matrix of gene expression with genes in rows and samples in columns.
#' @param kNum the number of nearest neighbors to consider to estimate the mutual information.
#' Must be less than the number of columns of normCounts.
#' @export
#' @return an adjacent matrix
TCGAanalyze_analyseGRN <- function(TFs, normCounts, kNum) {

    if (!requireNamespace("parmigene", quietly = TRUE)) {
        stop(
            "parmigene package is needed for this function to work. Please install it.",
            call. = FALSE
        )
    }
    MRcandidates <- intersect(rownames(normCounts), TFs)

    # Mutual information between TF and genes
    sampleNames <- colnames(normCounts)
    geneNames <- rownames(normCounts)

    messageMI_TFgenes <-  paste(
        "Estimation of MI among [",
        length(MRcandidates),
        " TRs and ",
        nrow(normCounts),
        " genes].....",
        sep = ""
    )
    timeEstimatedMI_TFgenes1 <- length(MRcandidates) * nrow(normCounts) / 1000
    timeEstimatedMI_TFgenes <-  format(timeEstimatedMI_TFgenes1 * ncol(normCounts) / 17000, digits = 2)
    messageEstimation <- print(
        paste(
            "I Need about ",
            timeEstimatedMI_TFgenes,
            "seconds for this MI estimation. [Processing 17000k elements /s]  "
        )
    )

    miTFGenes <- parmigene::knnmi.cross(normCounts[MRcandidates,], normCounts, k = kNum)

    return(miTFGenes)

}

#' @title Generate pathview graph
#' @description TCGAanalyze_Pathview pathway based data integration and visualization.
#' @param dataDEGs dataDEGs
#' @param pathwayKEGG pathwayKEGG
#' @export
#' @return an adjacent matrix
#' @examples
#' \dontrun{
#'   dataDEGs <- data.frame(mRNA = c("TP53","TP63","TP73"), logFC = c(1,2,3))
#'   TCGAanalyze_Pathview(dataDEGs)
#' }
TCGAanalyze_Pathview <-
    function(dataDEGs, pathwayKEGG = "hsa05200") {
        if (!requireNamespace("clusterProfiler", quietly = TRUE)) {
            stop("clusterProfiler needed for this function to work. Please install it.",
                 call. = FALSE)
        }
        if (!requireNamespace("pathview", quietly = TRUE)) {
            stop("pathview needed for this function to work. Please install it.",
                 call. = FALSE)
        }
        # Converting Gene symbol to gene ID
        eg = as.data.frame(
            clusterProfiler::bitr(
                dataDEGs$mRNA,
                fromType = "SYMBOL",
                toType = "ENTREZID",
                OrgDb = "org.Hs.eg.db"
            )
        )
        eg <- eg[!duplicated(eg$SYMBOL), ]
        dataDEGs <- dataDEGs[dataDEGs$mRNA %in% eg$SYMBOL, ]
        dataDEGs <- dataDEGs[order(dataDEGs$mRNA, decreasing = FALSE), ]
        eg <- eg[order(eg$SYMBOL, decreasing = FALSE), ]
        dataDEGs$GeneID <- eg$ENTREZID
        dataDEGsFiltLevel_sub <-
            subset(dataDEGs, select = c("GeneID", "logFC"))
        genelistDEGs <- as.numeric(dataDEGsFiltLevel_sub$logFC)
        names(genelistDEGs) <- dataDEGsFiltLevel_sub$GeneID

        hsa05200 <- pathview::pathview(
            gene.data  = genelistDEGs,
            pathway.id = pathwayKEGG,
            species    = "hsa",
            limit      = list(gene = as.integer(max(
                abs(genelistDEGs)
            )))
        )

    }


#' @title infer gene regulatory networks
#' @description TCGAanalyze_networkInference taking expression data as input,
#' this will return an adjacency matrix of interactions
#' @param data expression data, genes in columns, samples in rows
#' @param optionMethod inference method, chose from aracne, c3net, clr and mrnet
#' @export
#' @return an adjacent matrix
TCGAanalyze_networkInference <-
    function(data, optionMethod = "clr") {
        # Converting Gene symbol to gene ID
        if (optionMethod == "c3net") {
            if (!requireNamespace("c3net", quietly = TRUE)) {
                stop(
                    "c3net package is needed for this function to work. Please install it.",
                    call. = FALSE
                )
            }

            net <- c3net::c3net(t(data))
        } else {
            if (!requireNamespace("minet", quietly = TRUE)) {
                stop(
                    "minet package is needed for this function to work. Please install it.",
                    call. = FALSE
                )
            }
            net <- minet::minet(data, method = optionMethod)
        }
        return(net)

    }


#' Creates a plot for GAIA output (all significant aberrant regions.)
#' @description
#' This function is a auxiliary function to visualize GAIA output
#' (all significant aberrant regions.)
#' @param calls A matrix with the following columns: Chromossome, Aberration Kind
#' Region Start, Region End, Region Size and score
#' @param threshold Score threshold (orange horizontal line in the plot)
#' @export
#' @importFrom graphics abline axis legend plot points
#' @return A plot with all significant aberrant regions.
#' @examples
#' call <- data.frame("Chromossome" = rep(9,100),
#'                    "Aberration Kind" = rep(c(-2,-1,0,1,2),20),
#'                    "Region Start [bp]" = 18259823:18259922,
#'                    "Region End [bp]" = 18259823:18259922,
#'                    "score" = rep(c(1,2,3,4),25))
#'  gaiaCNVplot(call,threshold = 0.01)
#'  call <- data.frame("Chromossome" = rep(c(1,9),50),
#'                     "Aberration Kind" = rep(c(-2,-1,0,1,2),20),
#'                     "Region Start [bp]" = 18259823:18259922,
#'                     "Region End [bp]" = 18259823:18259922,
#'                     "score" = rep(c(1,2,3,4),25))
#'  gaiaCNVplot(call,threshold = 0.01)
gaiaCNVplot <- function (calls,  threshold = 0.01) {
    Calls <-  calls[order(calls[, grep("start", colnames(calls), ignore.case = TRUE)]), ]
    Calls <- Calls[order(Calls[, grep("chr", colnames(calls), ignore.case = TRUE)]), ]
    rownames(Calls) <- NULL
    Chromo <- Calls[, grep("chr", colnames(calls), ignore.case = TRUE)]
    Gains <- apply(Calls, 1, function(x)
        ifelse(x[grep("aberration", colnames(calls), ignore.case = TRUE)] == 1, x["score"], 0))
    Losses <- apply(Calls, 1, function(x)
        ifelse(x[grep("aberration", colnames(calls), ignore.case = TRUE)] == 0, x["score"], 0))
    plot(
        Gains,
        ylim = c(-max(Calls[, "score"] + 2), max(Calls[, "score"] + 2)),
        type = "h",
        col = "red",
        xlab = "Chromosome",
        ylab = "Score",
        xaxt = "n"
    )
    points(-(Losses), type = "h", col = "blue")
    # Draw origin line
    abline(h = 0, cex = 4)
    # Draw threshold lines
    abline(
        h = -log10(threshold),
        col = "orange",
        cex = 4,
        main = "test"
    )
    abline(
        h = log10(threshold),
        col = "orange",
        cex = 4,
        main = "test"
    )

    uni.chr <- unique(Chromo)
    temp <- rep(0, length(uni.chr))
    for (i in 1:length(uni.chr)) {
        temp[i] <- max(which(uni.chr[i] == Chromo))
    }
    for (i in 1:length(temp)) {
        abline(v = temp[i],
               col = "black",
               lty = "dashed")
    }
    nChroms <- length(uni.chr)
    begin <- c()
    for (d in 1:nChroms) {
        chrom <- sum(Chromo == uni.chr[d])
        begin <- append(begin, chrom)
    }
    temp2 <- rep(0, nChroms)
    for (i in 1:nChroms) {
        if (i == 1) {
            temp2[1] <- (begin[1] * 0.5)
        }
        else if (i > 1) {
            temp2[i] <- temp[i - 1] + (begin[i] * 0.5)
        }
    }
    uni.chr[uni.chr == 23] <- "X"
    uni.chr[uni.chr == 24] <- "Y"
    for (i in 1:length(temp)) {
        axis(1,
             at = temp2[i],
             labels = uni.chr[i],
             cex.axis = 1)
    }
    legend(
        x = 1,
        y = max(Calls[, "score"] + 2),
        y.intersp = 0.8,
        c("Amp"),
        pch = 15,
        col = c("red"),
        text.font = 3
    )
    legend(
        x = 1,
        y = -max(Calls[, "score"] + 0.5),
        y.intersp = 0.8,
        c("Del"),
        pch = 15,
        col = c("blue"),
        text.font = 3
    )
}

#' Get a matrix of interactions of genes from biogrid
#' @description
#' Using biogrid database, it will create a matrix of gene interactions.
#' If columns A and row B has value 1, it means the gene A and gene B interacts.
#' @param tmp.biogrid Biogrid table
#' @export
#' @param names.genes List of genes to filter from output. Default: consider all genes
#' @return A matrix with 1 for genes that interacts, 0 for no interaction.
#' @examples
#' names.genes.de <- c("PLCB1","MCL1","PRDX4","TTF2","TACC3", "PARP4","LSM1")
#' tmp.biogrid <- data.frame("Official.Symbol.Interactor.A" = names.genes.de,
#'                           "Official.Symbol.Interactor.B" = rev(names.genes.de))
#' net.biogrid.de <- getAdjacencyBiogrid(tmp.biogrid, names.genes.de)
#' \dontrun{
#'   file <- paste0("http://thebiogrid.org/downloads/archives/",
#'                  "Release%20Archive/BIOGRID-3.4.133/BIOGRID-ALL-3.4.133.tab2.zip")
#'   downloader::download(file,basename(file))
#'   unzip(basename(file),junkpaths =TRUE)
#'   tmp.biogrid <- read.csv(gsub("zip","txt",basename(file)),
#'                           header=TRUE, sep="\t", stringsAsFactors=FALSE)
#'   names.genes.de <- c("PLCB1","MCL1","PRDX4","TTF2","TACC3", "PARP4","LSM1")
#'   net.biogrid.de <- getAdjacencyBiogrid(tmp.biogrid, names.genes.de)
#' }
getAdjacencyBiogrid <- function(tmp.biogrid, names.genes = NULL) {
    it.a <- grep("Symbol", colnames(tmp.biogrid), value = TRUE)[1]
    it.b <- grep("Symbol", colnames(tmp.biogrid), value = TRUE)[2]

    if (is.null(names.genes)) {
        names.genes <-
            sort(union(unique(tmp.biogrid[, it.a]), unique(tmp.biogrid[, it.b])))
        ind <- seq(1, nrow(tmp.biogrid))
    } else {
        ind.A <- which(tmp.biogrid[, it.a] %in% names.genes)
        ind.B <- which(tmp.biogrid[, it.b] %in% names.genes)
        ind <- intersect(ind.A, ind.B)
    }

    mat.biogrid <- matrix(
        0,
        nrow = length(names.genes),
        ncol = length(names.genes),
        dimnames = list(names.genes, names.genes)
    )

    for (i in ind) {
        mat.biogrid[tmp.biogrid[i, it.a], tmp.biogrid[i, it.b]] <-
            mat.biogrid[tmp.biogrid[i, it.b], tmp.biogrid[i, it.a]] <- 1
    }
    diag(mat.biogrid) <- 0

    return(mat.biogrid)
}

#' @title Get GDC primary tumors samples with both DNA methylation (HM450K) and Gene expression data
#' @description
#' For a given TCGA project it gets the  primary tumors samples (barcode) with both
#' DNA methylation and Gene expression data from GDC database
#' @param project A GDC project
#' @param n Number of samples to return. If NULL return all (default)
#' @return A vector of barcodes
#' @export
#' @examples
#' # Get ACC samples with both  DNA methylation (HM450K) and gene expression aligned to hg19
#' samples <- matchedMetExp("TCGA-UCS")
matchedMetExp <- function(
        project,
        n = NULL
) {

    # get primary solid tumor samples: DNA methylation
    message("Download DNA methylation information")
    met450k <- GDCquery(
        project = project,
        data.category = "DNA Methylation",
        platform = "Illumina Human Methylation 450",
        sample.type = c("Primary Tumor")
    )

    # get primary solid tumor samples: RNAseq
    message("Download gene expression information")
    exp <- GDCquery(
        project = project,
        data.category = "Transcriptome Profiling",
        data.type = "Gene Expression Quantification",
        workflow.type = "STAR - Counts"
    )

    # Get patients with samples in both platforms
    met450k_tp <- met450k$results[[1]]$cases
    exp_tp <- exp$results[[1]]$cases

    patients <-
        substr(exp_tp, 1, 15)[
            substr(exp_tp, 1, 15) %in% substr(met450k_tp, 1, 15)
        ] |> unique()

    if (!is.null(n)) {
        patients <- patients[1:n] # get only n samples
    }

    return(patients)
}

context("Analyse")

test_that("TCGAanalyze_survival creates pdf", {
    clin <- data.frame(
        vital_status = c(
            "alive",
            "alive",
            "alive",
            "dead",
            "alive",
            "alive",
            "dead",
            "alive",
            "dead",
            "alive"
        ),
        days_to_death = c(NA, NA, NA, 172, NA, NA, 3472, NA, 786, NA),
        days_to_last_follow_up = c(3011, 965, 718, NA, 1914, 423, NA, 5, 656, 1417),
        gender = c(rep("male", 5), rep("female", 5))
    )
    TCGAanalyze_survival(clin, clusterCol = "gender", filename = "test.pdf")
    expect_true(file.exists("test.pdf"))
    unlink("test.pdf")
})


test_that("TCGAanalyze_DMC ask for the missing parameters", {
    nrows <- 2
    ncols <- 20
    counts <- matrix(c(rep(0.9, 20), rep(0.1, 20)), nrows)
    rowRanges <- GenomicRanges::GRanges(
        (rep("chr1", 2)),
        IRanges::IRanges(c(2000, 2000), width =
                             100),
        strand = c("+", "-"),
        feature_id = sprintf("ID%03d", 1:2)
    )

    colData <-
        S4Vectors::DataFrame(
            Treatment = rep(c("ChIP", "Input"), 5),
            row.names = LETTERS[1:20],
            group = rep(c(
                "group1", "group2", "group3", "group4"
            ), c(5, 5, 5, 5))
        )

    data <- SummarizedExperiment::SummarizedExperiment(
        assays = S4Vectors::SimpleList(counts = counts),
        rowRanges = rowRanges,
        colData = colData
    )

    expect_null(TCGAanalyze_DMC(data, p.cut = 0.85))
    expect_message(TCGAanalyze_DMC(data, p.cut = 0.85),
                   "Please, set the groupCol parameter")
    expect_null(TCGAanalyze_DMC(data, p.cut = 0.85, "group"))
    expect_message(
        TCGAanalyze_DMC(data, p.cut = 0.85, "group"),
        "Please, set the group1 and group2 parameters"
    )
})

test_that("TCGAanalyze_DMC is handling NAs correctly", {
    nrows <- 2
    ncols <- 20
    counts <- matrix(c(rep(0.9, 20), rep(0.1, 20)), nrows)
    counts[1, 1] <- NA
    rowRanges <- GenomicRanges::GRanges(
        (rep("chr1", 2)),
        IRanges::IRanges(c(2000, 2000), width = 100),
        strand = c("+", "-"),
        feature_id = sprintf("ID%03d", 1:2)
    )

    colData <-
        S4Vectors::DataFrame(
            Treatment = rep(c("ChIP", "Input"), 5),
            row.names = LETTERS[1:20],
            group = rep(c("group1", "group2"), c(10, 10))
        )

    data <- SummarizedExperiment::SummarizedExperiment(
        assays = S4Vectors::SimpleList(counts = counts),
        rowRanges = rowRanges,
        colData = colData
    )
    SummarizedExperiment::colData(data)$group <- c(rep("group1", 10),  rep("group2", 10))
    hypo.hyper <- TCGAanalyze_DMC(data, p.cut = 0.85, "group", "group1", "group2")
    result <- hypo.hyper[1,]
    expect_equal(result$mean.group1, 0.9)
    expect_equal(result$mean.group2, 0.1)
    expect_equal(result$mean.group1.minus.mean.group2 , 0.8)
    expect_equal(result$status , "Hypermethylated in group1")

    counts[1, ] <- NA
    data <- SummarizedExperiment::SummarizedExperiment(
        assays = S4Vectors::SimpleList(counts = counts),
        rowRanges = rowRanges,
        colData = colData
    )
    expect_error(
        TCGAanalyze_DMC(data, p.cut = 0.85, "group", "group1", "group2"),
        "Sorry, but we found some probes with NA for all samples in your data, please either remove/or replace them"
    )
})

test_that(
    "Results of TCGAanalyze_DEA inverting groups changes signal and order of the signals are right",
    {
        dataNorm <-  TCGAbiolinks::TCGAanalyze_Normalization(dataBRCA, geneInfo)
        dataFilt <-
            TCGAanalyze_Filtering(
                tabDF = dataBRCA,
                method = "quantile",
                qnt.cut =  0.25
            )

        # 5 samples
        samplesNT <- TCGAquery_SampleTypes(colnames(dataFilt), typesample = c("NT"))

        # 5 samples
        samplesTP <- TCGAquery_SampleTypes(colnames(dataFilt), typesample = c("TP"))

        # Get one line for example
        A <- rowMeans(dataFilt["CLDN6|9074", samplesNT])
        B <- rowMeans(dataFilt["CLDN6|9074", samplesTP])

        # Should give the same signal as  dataDEGs["CLDN6|9074",]
        log2FC <- log2(B) - log2(A)

        # Should give the same signal as  dataDEGs.inv["CLDN6|9074",]
        log2FC.inv <- log2(A) - log2(B)

        suppressMessages({
            dataDEGs <- TCGAanalyze_DEA(
                mat1 = dataFilt[, samplesNT],
                mat2 = dataFilt[, samplesTP],
                Cond1type = "Normal",
                Cond2type =  "Tumor"
            )
        })
        expect_equal(dataDEGs["CLDN6|9074", ]$logFC > 0, (log2FC > 0)[[1]])

        suppressMessages({
            dataDEGs.inv <- TCGAanalyze_DEA(
                mat1 = dataFilt[, samplesTP],
                mat2 = dataFilt[, samplesNT],
                Cond1type =  "Tumor",
                Cond2type = "Normal"
            )
        })
        expect_equal(dataDEGs$logFC, -1 * dataDEGs.inv$logFC)
        expect_equal(dataDEGs.inv["CLDN6|9074", ]$logFC > 0, (log2FC.inv > 0)[[1]])
        suppressMessages({
            dataDEGs <- TCGAanalyze_DEA(
                mat1 = dataFilt[, samplesNT],
                mat2 = dataFilt[, samplesTP],
                Cond1type = "Normal",
                Cond2type =  "Tumor",
                method = "glmLRT"
            )
        })
        expect_equal(dataDEGs["CLDN6|9074", ]$logFC > 0, (log2FC > 0)[[1]])

        suppressMessages({
            dataDEGs.inv <- TCGAanalyze_DEA(
                mat1 = dataFilt[, samplesTP],
                mat2 = dataFilt[, samplesNT],
                Cond1type =  "Tumor",
                Cond2type = "Normal",
                method = "glmLRT"
            )
        })
        expect_equal(dataDEGs$logFC, -1 * dataDEGs.inv[rownames(dataDEGs),]$logFC)
        expect_equal(dataDEGs.inv["CLDN6|9074", ]$logFC > 0, (log2FC.inv > 0)[[1]])

    }
)

test_that("Results from TCGAanalyze_DMC are correct", {
    nrows <- 2
    ncols <- 20
    counts <- matrix(
        c(rep(0.9, 20), rep(0.1, 20)), nrows,
        dimnames = list(paste0("cg", 1:2), LETTERS[1:20])
    )

    rowRanges <- GenomicRanges::GRanges(
        (rep("chr1", 2)),
        IRanges::IRanges(c(2000, 2000), width = 100),
        strand = c("+", "-"),
        feature_id = sprintf("ID%03d", 1:2)
    )
    colData <-
        S4Vectors::DataFrame(
            Treatment = rep(c("ChIP", "Input"), 5),
            row.names = LETTERS[1:20],
            group = rep(c("group1", "group2"), c(10, 10))
        )

    data <- SummarizedExperiment::SummarizedExperiment(
        assays = S4Vectors::SimpleList(counts = counts),
        rowRanges = rowRanges,
        colData = colData
    )

    SummarizedExperiment::colData(data)$group <-
        c(rep("group1", 10),  rep("group2", 10))
    hypo.hyper <- TCGAanalyze_DMC(data, p.cut = 0.85, "group", "group1", "group2")
    result <- hypo.hyper[1,]
    expect_equal(result$mean.group1, 0.9)
    expect_equal(result$mean.group2, 0.1)
    expect_equal(result$mean.group1.minus.mean.group2 , 0.8)
    expect_equal(result$status, "Hypermethylated in group1")
})

#' @title Retrieve summary of files per sample in a project
#' @description
#'  Retrieve the numner of files under each
#'   data_category + data_type + experimental_strategy + platform
#'   Almost like https://portal.gdc.cancer.gov/exploration
#' @param project A GDC project
#' @param files.access Filter by file access ("open" or "controlled").
#' Default: no filter
#' @export
#' @examples
#'    summary <- getSampleFilesSummary("TCGA-UCS")
#' \dontrun{
#'    summary <- getSampleFilesSummary(c("TCGA-OV","TCGA-ACC"))
#' }
#' @return A data frame with the maf file information
#' @importFrom tidyr spread unite
#' @importFrom plyr ldply count
#' @author Tiago Chedraoui Silva
getSampleFilesSummary <- function(
        project,
        files.access = NA
) {
    out <- NULL

    for(proj in project){
        checkProjectInput(proj)
        message("Accessing information for project: ", proj)
        url <- getSampleSummaryUrl(proj)
        x <- getURL(url,fromJSON,simplifyDataFrame = TRUE)
        y <- x$data$hits$files
        names(y) <- x$data$hits$submitter_id
        df <- ldply(y, data.frame)

        df <- df %>%
            unite("type",
                  "data_category",
                  "data_type",
                  "experimental_strategy",
                  "platform",
                  na.rm = TRUE) %>%
            plyr::count(c(".id","type")) %>%
            tidyr::spread("type", "freq")
        df$project <- proj
        df[is.na(df)] <- 0
        out <- rbind.fill(out,df)
    }
    return(out)
}

getSampleSummaryUrl <- function(
        project,
        files.access = NA
){
    # Get manifest using the API
    baseURL <- "https://api.gdc.cancer.gov/cases/?"

    options.pretty <- "pretty=true"
    options.expand <- "expand=summary,summary.data_categories,files"
    option.size <- paste0("size=",1000)
    option.format <- paste0("format=JSON")

    options.filter <- paste0(
        "filters=",
        URLencode('{"op":"and","content":['),  # Start json request
        URLencode('{"op":"in","content":{"field":"cases.project.project_id","value":["'),
        project,
        URLencode('"]}}')
    )

    if(!any(is.na(files.access))) {
        options.filter <- paste0(options.filter,addFilter("files.access", files.access))
    }
    # Close json request
    options.filter <- paste0(options.filter, URLencode(']}'))
    url <- paste0(
        baseURL,
        paste(options.pretty,
              options.expand,
              option.size,
              options.filter,
              option.format,
              sep = "&"
        )
    )
    return(url)
}



getSubmitterIDUrl <- function(
        project,
        files.access = NA
){
    # Get manifest using the API
    baseURL <- "https://api.gdc.cancer.gov/cases/?"

    options.pretty <- "pretty=true"
    options.expand <- "expand=files.access"
    option.fields = "fields=submitter_id"
    option.size <- paste0("size=",1000)
    option.format <- paste0("format=JSON")

    options.filter <- paste0(
        "filters=",
        URLencode('{"op":"and","content":['),  # Start json request
        URLencode('{"op":"in","content":{"field":"cases.project.project_id","value":["'),
        project,
        URLencode('"]}}')
    )

    if(!any(is.na(files.access))) {
        options.filter <- paste0(options.filter,addFilter("files.access", files.access))
    }
    # Close json request
    options.filter <- paste0(options.filter, URLencode(']}'))
    url <- paste0(
        baseURL,
        paste(
            options.pretty,
            options.expand,
            option.fields,
            option.size,
            options.filter,
            option.format,
            sep = "&"
        )
    )
    return(url)
}

# getSubmitterID("TCGA-BRCA")
# getSubmitterID("MMRF-COMPASS")
getSubmitterID <- function(
        project,
        files.access = NA
){

    url <- getSubmitterIDUrl(project,files.access)

    json  <- tryCatch(
        getURL(url,fromJSON,timeout(600),simplifyDataFrame = TRUE),
        error = function(e) {
            message(paste("Error: ", e, sep = " "))
            message("We will retry to access GDC!")
            fromJSON(content(getURL(url,GET,timeout(600)), as = "text", encoding = "UTF-8"), simplifyDataFrame = TRUE)
        }
    )
    return(unique(json$data$hits$submitter_id))



}

# getBarcodefromAliquot(c("4e06e279-5f0d-4bf5-8659-67b8069050b8","bb6e1801-b08a-49b1-bc4b-205fdefb035b"))
#' @importFrom dplyr bind_rows
getBarcodefromAliquot <- function(aliquot){
    baseURL <- "https://api.gdc.cancer.gov/cases/?"
    options.fields <- "fields=samples.portions.analytes.aliquots.aliquot_id,samples.portions.analytes.aliquots.submitter_id"
    options.pretty <- "pretty=true"
    option.size <- paste0("size=",length(aliquot))
    #message(paste(barcode,collapse = '","'))
    #message(paste0('"',paste(barcode,collapse = '","')))
    options.filter <- paste0("filters=",
                             URLencode('{"op":"and","content":[{"op":"in","content":{"field":"samples.portions.analytes.aliquots.aliquot_id","value":['),
                             paste0('"',paste(aliquot,collapse = '","')),
                             URLencode('"]}}]}'))
    #message(paste0(baseURL,paste(options.pretty,options.expand, option.size, options.filter, sep = "&")))
    url <- paste0(baseURL,paste(options.pretty,options.fields, option.size, options.filter, sep = "&"))
    #message(url)
    json  <- tryCatch(
        getURL(url,fromJSON,timeout(600),simplifyDataFrame = TRUE),
        error = function(e) {
            message(paste("Error: ", e, sep = " "))
            message("We will retry to access GDC again! URL:")
            #message(url)
            fromJSON(content(getURL(url,GET,timeout(600)), as = "text", encoding = "UTF-8"), simplifyDataFrame = TRUE)
        }
    )
    results <- json$data$hits
    if(length(results) == 0){
        message("aliquot_id not found")
        return(NULL)
    }

    results <- plyr::ldply(results$samples,.fun = function(x){
        plyr::ldply(x$portions,.fun = function(y){
            plyr::ldply(y$analytes,.fun = function(z){
                z$aliquots %>% bind_rows()
            })
        })
    })

    idx <- is.na(match(aliquot,results$aliquot_id))
    if(any(idx)){
        message("Some aliquot IDs were not found:",aliquot[idx])
    }
    results <- results[match(aliquot,results$aliquot_id),] %>% na.omit()

    return(results)
}

#' internal function to break a huge API call into smaller ones
#' so it repects the max character limit of a string
#' @param items vector of items to be using within the function
#' (list of barcodes, aliquot ids, etc)
#' @param step How many items to be evaluated per API call
#' @param FUN function that calls the API
#' @author Tiago Chedraoui Silva
splitAPICall <- function(FUN, step = 20, items){
    info <- NULL
    info <- tryCatch({
        for(i in 0:(ceiling(length(items)/step) - 1)){
            start <- 1 + step * i
            end <- ifelse(((i + 1) * step) > length(items), length(items),((i + 1) * step))
            if(is.null(info)) {
                info <- FUN(items[start:end])
            } else {
                info <- plyr::rbind.fill(info, FUN(items[start:end]))
            }
        }
        info
    }, error = function(e) {
        step <- 2
        for(i in 0:(ceiling(length(items)/step) - 1)){
            start <- 1 + step * i
            end <- ifelse(((i + 1) * step) > length(items), length(items),((i + 1) * step))
            if(is.null(info)) {
                info <- FUN(items[start:end])
            } else {
                info <- plyr::rbind.fill(info, FUN(items[start:end]))
            }
        }
    })
    info
}


#' Create a Summary table for each sample in a project saying if it contains
#' or not files for a certain data category
#' @description
#' Create a Summary table for each sample in a project saying if it contains
#' or not files for a certain data category
#' @param project A GDC project
#' @return A data frame
#' @export
#' @importFrom stats xtabs
#' @examples
#' summary <- getDataCategorySummary("TCGA-ACC")
#' @author Tiago Chedraoui Silva
getDataCategorySummary <- function(project){
    baseURL <- "https://api.gdc.cancer.gov/files/?"
    url <- paste0(
        baseURL,"&expand=cases&size=100000&fields=cases.submitter_id,data_category&filters=",
        URLencode('{"op":"and","content":[{"op":"in","content":{"field":"cases.project.project_id","value":["'),
        URLencode(project),
        URLencode('"]}}]}')
    )

    json  <- tryCatch(
        getURL(url,fromJSON,timeout(600),simplifyDataFrame = TRUE),
        error = function(e) {
            fromJSON(
                content(getURL(url,GET,timeout(600)), as = "text", encoding = "UTF-8"),
                simplifyDataFrame = TRUE
            )
        }
    )
    json <- json$data$hits
    json$submitter_id <- unlist(lapply(json$cases, function(x) paste0(x$submitter_id,collapse = ",")))
    json$cases <- NULL
    json <- json[!duplicated(json),]
    json <- json[stringr::str_length(json$submitter_id) == 12,]
    ret <- as.data.frame.matrix(xtabs(~ submitter_id + data_category , json))
    return(ret)
}

#' @title Get Project Summary from GDC
#' @param project A  GDC project
#' @examples
#' getProjectSummary("TCGA-ACC")
#' \dontrun{
#' getProjectSummary("CPTAC-2")
#' }
#' @export
#' @author Tiago Chedraoui Silva
getProjectSummary <- function(project){
    checkProjectInput(project)
    baseURL <- "https://api.gdc.cancer.gov/projects/"
    url <- paste0(baseURL, project,"?expand=summary,summary.data_categories&pretty=true")
    return(fromJSON(url,simplifyDataFrame = TRUE)$data$summary)
}

#' @title Get Number of cases in GDC for a project
#' @param project A  GDC project
#' @param data.category A  GDC project data category
#' @examples
#' \dontrun{
#' getNbCases("TCGA-ACC","Clinical")
#' getNbCases("CPTAC-2","Clinical")
#' }
#' @author Tiago Chedraoui Silva
getNbCases <- function(
        project,
        data.category
){
    summary <- getProjectSummary(project)
    if(data.category %in% summary$data_categories$data_category){
        summary <- getProjectSummary(project)$data_categories
        nb <- summary[summary$data_category == data.category,"case_count"]
    } else {
        nb <- summary$case_count
    }
    return(nb)
}

#' @title Get Number of files in GDC for a project
#' @param project A  GDC project
#' @param data.category A  GDC project data category
#' @examples
#' \dontrun{
#' getNbFiles("TCGA-ACC","Clinical")
#' getNbFiles("CPTAC-2","Clinical")
#' }
#' @author Tiago Chedraoui Silva
getNbFiles <- function(project, data.category){
    summary <- getProjectSummary(project)
    if(data.category %in% summary$data_categories$data_category){
        summary <- getProjectSummary(project)$data_categories
        nb <- summary[summary$data_category == data.category,"file_count"]
    } else {
        nb <- summary$file_count
    }
    return(nb)
}

context("Query")


test_that("GDCquery can filter by data.category", {
    skip_on_bioc()
    skip_if_offline()

    query <- GDCquery(project = "TCGA-ACC",data.category = "Copy Number Variation")
    expect_equal(unique(query$results[[1]]$data_category),"Copy Number Variation")
    query <- GDCquery(project = "TCGA-ACC",data.category = "Copy Number Variation", data.type = "Copy Number Segment")
    expect_equal(unique(query$results[[1]]$data_type),"Copy Number Segment")
})

test_that("GDCquery accepts more than one project", {
    skip_on_bioc()
    skip_if_offline()

    acc <- GDCquery(
        project = "TCGA-ACC",
        data.category = "Copy Number Variation",
        data.type = "Copy Number Segment"
    )

    gbm <- GDCquery(
        project = "TCGA-GBM",
        data.category = "Copy Number Variation",
        data.type = "Copy Number Segment"
    )

    acc.gbm <- GDCquery(
        project =  c("TCGA-ACC","TCGA-GBM"),
        data.category = "Copy Number Variation",
        data.type = "Copy Number Segment"
    )

    expect_equal(unique(acc.gbm$results[[1]]$data_type),"Copy Number Segment")
    expect_equal(nrow(acc.gbm$results[[1]]), sum(nrow(acc$results[[1]]),nrow(gbm$results[[1]])))
    expect_true(nrow(dplyr::anti_join(acc$results[[1]],acc.gbm$results[[1]], by = "file_id")) == 0)
    expect_true(nrow(dplyr::anti_join(gbm$results[[1]],acc.gbm$results[[1]], by = "file_id")) == 0)
    expect_true(nrow(dplyr::anti_join(acc.gbm$results[[1]],acc$results[[1]], by = "file_id")) == nrow(gbm$results[[1]]))
})

test_that("GDCquery can filter by sample.type", {
    skip_on_bioc()
    skip_if_offline()

    sample.type <- "Primary Tumor"
    query <- GDCquery(
        project = "TCGA-ACC",
        data.category =  "Copy Number Variation",
        data.type = "Masked Copy Number Segment",
        sample.type = sample.type
    )
    expect_equal(as.character(unique(query$results[[1]]$sample_type)),sample.type)

    sample.type <- "Solid Tissue Normal"
    query <- GDCquery(
        project = "TCGA-ACC",
        data.category =  "Copy Number Variation",
        data.type = "Masked Copy Number Segment",
        sample.type = sample.type
    )
    expect_equal(as.character(unique(query$results[[1]]$sample_type)),sample.type)

    sample.type <- "Solid Tissue Normal"
    query <- GDCquery(
        project =  c("TCGA-COAD"),
        data.category = "Transcriptome Profiling",
        data.type = "Gene Expression Quantification",
        workflow.type = "STAR - Counts",
        sample.type = sample.type
    )
    expect_equal(as.character(unique(query$results[[1]]$sample_type)),sample.type)

    sample.type <- c("Solid Tissue Normal", "Primary Tumor")
    query <- GDCquery(
        project = "TCGA-ACC",
        data.category =  "Copy Number Variation",
        data.type = "Masked Copy Number Segment",
        sample.type = sample.type
    )
    expect_true(all(sample.type %in% unique(query$results[[1]]$sample_type)))
})

test_that("GDCquery can filter by barcode", {
    skip_on_bioc()
    skip_if_offline()

    barcode <- c("TARGET-20-PADZCG-04A-01R","TARGET-20-PARJCR-09A-01R")
    query <- GDCquery(
        project = "TARGET-AML",
        data.category = "Transcriptome Profiling",
        data.type = "Gene Expression Quantification",
        workflow.type = "STAR - Counts",
        barcode = barcode
    )
    expect_true(all(sort(barcode) == sort(unique(query$results[[1]]$cases))))
    barcode <- c( "TCGA-OR-A5KU-01A-11D-A29H-01", "TCGA-OR-A5JK-01A-11D-A29H-01")
    query <- GDCquery(
        project = "TCGA-ACC",
        data.category = "Copy Number Variation",
        data.type = "Copy Number Segment",
        barcode = barcode
    )
    expect_true(all(sort(barcode) == sort(unique(query$results[[1]]$cases))))
    barcode <- c("TCGA-OR-A5KU", "TCGA-OR-A5JK")
    query <- GDCquery(
        project = "TCGA-ACC",
        data.category = "Clinical",
        data.format = "bcr xml",
        barcode = barcode
    )
    expect_true(all(sort(barcode) == sort(unique(query$results[[1]]$cases))))

    # Will work if barcode was not found
    query <- GDCquery(
        project = "TCGA-BRCA",
        data.category = "Clinical",
        data.format = "bcr xml",
        barcode = c("TCGA-3C-AALK","TCGA-A2-A04Q","TCGA-A4-A04Q")
    )
    expect_true(!all(c("TCGA-3C-AALK","TCGA-A2-A04Q","TCGA-A4-A04Q") %in% query$results[[1]]$cases))
})


test_that("GDCquery can filter by access level", {
    skip_on_bioc()
    skip_if_offline()

    query <- GDCquery(
        project = "TCGA-KIRP",
        data.category = "Simple Nucleotide Variation",
        access = "open"
    )
    expect_equal(unique(query$results[[1]]$access),"open")

    query <- GDCquery(
        project = "TCGA-KIRP",
        data.category = "Simple Nucleotide Variation",
        data.type = "Raw Simple Somatic Mutation",
        access = "controlled"
    )
    expect_equal(unique(query$results[[1]]$access),"controlled")
})

test_that("getNbFiles and getNbCases works", {
    skip_on_bioc()
    skip_if_offline()

    aux <- getProjectSummary(project = "TCGA-LUAD")
    files <- getNbFiles("TCGA-LUAD","Raw microarray data")
    cases <- getNbCases("TCGA-LUAD","Raw microarray data")
    expect_true(cases < files)
})

#' The aim of TCGAbiolinks is : i) facilitate the TCGA open-access data retrieval,
#' ii) prepare the data using the appropriate pre-processing strategies,
#'  iii) provide the means to carry out different standard analyses and
#'  iv) allow the user to download a specific version of the data and thus to easily reproduce earlier research results.
#'   In more detail, the package provides multiple methods for analysis
#' (e.g., differential expression analysis, identifying differentially methylated regions)
#' and methods for visualization (e.g., survival plots, volcano plots, starburst plots) in order to easily develop complete analysis pipelines.
#'
#' The functions you're likely to need from \pkg{TCGAbiolinks} is
#' \code{\link{GDCdownload}}, \code{\link{GDCquery}}.
#' Otherwise refer to the vignettes to see
#' how to format the documentation.
#' @keywords internal
"_PACKAGE"

## usethis namespace: start
## usethis namespace: end
NULL

#' @title Gliomar classifier
#' @description Classify DNA methylation gliomas using data from
#' https://doi.org/10.1016/j.cell.2015.12.028
#' @param data DNA methylation matrix or Summarized Experiments with samples on columns
#' and probes on the rows
#' @export
#' @return A list of 3 data frames:
#' 1) Sample final classification
#' 2) Each model final classification
#' 3) Each class probability of classification
#' @examples
#' \dontrun{
#' query <- GDCquery(
#'    project= "TCGA-GBM",
#'    data.category = "DNA methylation",
#'    barcode = c("TCGA-06-0122","TCGA-14-1456"),
#'    platform = "Illumina Human Methylation 27",
#'    legacy = TRUE
#' )
#' GDCdownload(query)
#' data.hg19 <- GDCprepare(query)
#' classification <- gliomaClassifier(data.hg19)
#'
#' # Comparing reslts
#' TCGAquery_subtype("GBM") %>%
#' dplyr::filter(patient %in% c("TCGA-06-0122","TCGA-14-1456")) %>%
#' dplyr::select("patient","Supervised.DNA.Methylation.Cluster")
#' }
#' @author Tiago Chedraoui Silva, Tathiane Malta, Houtan Noushmehr
gliomaClassifier <- function(data){

    if (!requireNamespace("TCGAbiolinksGUI.data", quietly = TRUE)) {
        stop("TCGAbiolinksGUI.data package is needed for this function to work. Please install it.",
             call. = FALSE)
    }

    message("Plese cite https://doi.org/10.1016/j.cell.2015.12.028")
    message("Training model described at https://bioconductor.org/packages/TCGAbiolinksGUI.data/")

    if(is(data, "RangedSummarizedExperiment")) {
        met <- assay(data) %>% as.matrix  %>% t
    } else {
        met <- data %>% as.matrix  %>% t
    }


    df.all <- NULL
    env <- new.env()
    models <- c("idh","gcimp","idhwt","idhmut")
    models <- paste("glioma",models,"model",sep = ".")
    data(list = models, package = "TCGAbiolinksGUI.data",envir = env)

    for(i in models){
        message("------------------------------------------------------")
        message("Model: ",i)
        model <- get(i, envir = env)
        # If it is a Summarized Experiment object

        # keep only probes used in the model
        aux <- met[,colnames(met) %in% colnames(model$trainingData),drop = FALSE]
        # This should not happen!
        if(any(apply(aux,2,function(x) all(is.na(x))))) {
            message("o Probes has NA value for all samples. Setting to 0.5 since model does not accept NA")
            aux[,apply(aux,2,function(x) all(is.na(x)))] <- 0.5
        }

        if(any(apply(aux,2,function(x) any(is.na(x))))) {
            message("o Probes has NA values for some samples. Setting values a the median of the sample since model does not accept NA ")
            colMedians <- colMedians(aux,na.rm = TRUE)
            x <- which(is.na(aux),arr.ind = TRUE)
            for(l in 1:nrow(x)){
                aux[x[l,1],x[l,2]] <- colMedians[x[l,2]]
            }
        }

        # For missing probes add values to 0.5
        missing_probes <- setdiff(colnames(model$trainingData), colnames(met))
        if(length(missing_probes) > 0) {
            message("o Probes are missing. Setting dummy probes to matrix with 0.5 value to all samples.")
            missing_probes_matrix <- matrix(rep(0.5, nrow(met) * length(missing_probes)),nrow = nrow(met))
            colnames(missing_probes_matrix) <- missing_probes
            aux <- bind_cols(aux,missing_probes_matrix)
        }

        pred <- predict(model, aux)
        pred.prob <- predict(model, aux, type = "prob")
        colnames(pred.prob) <- paste0(i,"_", colnames(pred.prob))
        pred.prob$samples <- rownames(pred.prob)
        df <- data.frame(samples = rownames(aux),
                         groups.classified = pred,
                         stringsAsFactors = FALSE)
        colnames(df)[2] <- paste0(i,"_groups.classified")

        if(is.null(df.all)) {
            df.all <- df
            df.prob <- pred.prob
        } else {
            df.all <- merge(df.all,df, by = "samples")
            df.prob <- merge(df.prob,pred.prob,by = "samples")
        }
    }
    colnames(df.all) <- c("samples",models)
    fctr.cols <- sapply(df.all, is.factor)
    df.all[, fctr.cols] <- sapply(df.all[, fctr.cols], as.character)
    df.all[grep("6|5|4",df.all$glioma.idh.model),c("glioma.gcimp.model","glioma.idhmut.model")]  <- NA
    df.all[grep("3|2|1",df.all$glioma.idh.model),c("glioma.idhwt.model")]  <- NA
    df.all[grep("3",df.all$glioma.idhmut.model),c("glioma.gcimp.model")]  <- "Codel"
    df.all[grep("1",df.all$glioma.idhwt.model),c("glioma.idhwt.model")]  <- "Classic-like"
    df.all[grep("2",df.all$glioma.idhwt.model),c("glioma.idhwt.model")]  <- "Mesenchymal-like"
    df.all[grep("3",df.all$glioma.idhwt.model),c("glioma.idhwt.model")]  <- "PA-like"

    # Final column with results
    df.all$glioma.DNAmethylation.subtype <- NA
    df.all$glioma.DNAmethylation.subtype <- df.all$glioma.idhwt.model
    idx <- which(is.na(df.all$glioma.DNAmethylation.subtype))
    df.all$glioma.DNAmethylation.subtype[idx] <- df.all$glioma.gcimp.model[idx]

    return(
        list(
            final.classification = data.frame(
                Sample = df.all$samples,
                Final_classification = df.all$glioma.DNAmethylation.subtype
            ),
            model.classifications = df.all,
            model.probabilities = df.prob
        )
    )
}

#' @title Query GDC data
#' @description
#'   Uses GDC API to search for search, it searches for both controlled and
#'   open-access data.
#'   For GDC data arguments project, data.category, data.type and workflow.type should be used
#'   Please, see the vignette for a table with the possibilities.
#' @param project A list of valid project (see list with TCGAbiolinks:::getGDCprojects()$project_id)]
#' \itemize{
#' \item{ BEATAML1.0-COHORT }
#' \item{ BEATAML1.0-CRENOLANIB }
#' \item{ CGCI-BLGSP }
#' \item{ CPTAC-2 }
#' \item{ CPTAC-3 }
#' \item{ CTSP-DLBCL1 }
#' \item{ FM-AD }
#' \item{ HCMI-CMDC }
#' \item{ MMRF-COMMPASS }
#' \item{ NCICCR-DLBCL }
#' \item{ OHSU-CNL }
#' \item{ ORGANOID-PANCREATIC }
#' \item{ TARGET-ALL-P1 }
#' \item{ TARGET-ALL-P2 }
#' \item{ TARGET-ALL-P3 }
#' \item{ TARGET-AML }
#' \item{ TARGET-CCSK }
#' \item{ TARGET-NBL }
#' \item{ TARGET-OS }
#' \item{ TARGET-RT }
#' \item{ TARGET-WT }
#' \item{ TCGA-ACC }
#' \item{ TCGA-BLCA }
#' \item{ TCGA-BRCA }
#' \item{ TCGA-CESC }
#' \item{ TCGA-CHOL }
#' \item{ TCGA-COAD }
#' \item{ TCGA-DLBC }
#' \item{ TCGA-ESCA }
#' \item{ TCGA-GBM }
#' \item{ TCGA-HNSC }
#' \item{ TCGA-KICH }
#' \item{ TCGA-KIRC }
#' \item{ TCGA-KIRP }
#' \item{ TCGA-LAML }
#' \item{ TCGA-LGG }
#' \item{ TCGA-LIHC }
#' \item{ TCGA-LUAD }
#' \item{ TCGA-LUSC }
#' \item{ TCGA-MESO }
#' \item{ TCGA-OV }
#' \item{ TCGA-PAAD }
#' \item{ TCGA-PCPG }
#' \item{ TCGA-PRAD }
#' \item{ TCGA-READ }
#' \item{ TCGA-SARC }
#' \item{ TCGA-SKCM }
#' \item{ TCGA-STAD }
#' \item{ TCGA-TGCT }
#' \item{ TCGA-THCA }
#' \item{ TCGA-THYM }
#' \item{ TCGA-UCEC }
#' \item{ TCGA-UCS }
#' \item{ TCGA-UVM }
#' \item{ VAREPOP-APOLLO }
#' }
#' @param data.category A valid project (see list with TCGAbiolinks:::getProjectSummary(project))
#' For the complete list please check the vignette.
#' List for harmonized database:
#' \itemize{
#' \item{ Biospecimen }
#' \item{ Clinical }
#' \item{ Copy Number Variation }
#' \item{ DNA Methylation }
#' \item{ Sequencing Reads }
#' \item{ Simple Nucleotide Variation }
#' \item{ Transcriptome Profiling }
#' }
#' @param data.type A data type to filter the files to download
#' For the complete list please check the vignette.
#' @param sample.type A sample type to filter the files to download
#' @param barcode A list of barcodes to filter the files to download
#' @param data.format Data format filter ("VCF", "TXT", "BAM","SVS","BCR XML","BCR SSF XML",
#' "TSV", "BCR Auxiliary XML", "BCR OMF XML", "BCR Biotab", "MAF", "BCR PPS XML", "XLSX")
#' @param workflow.type GDC workflow type
#' @param experimental.strategy Filter to experimental strategy.
#' Harmonized: WXS, RNA-Seq, miRNA-Seq, Genotyping Array.
#' @param access Filter by access type. Possible values: controlled, open
#' @param platform Example:
#' \tabular{ll}{
#'CGH- 1x1M_G4447A                   \tab IlluminaGA_RNASeqV2   \cr
#'AgilentG4502A_07                  \tab IlluminaGA_mRNA_DGE    \cr
#'Human1MDuo                        \tab HumanMethylation450    \cr
#'HG-CGH-415K_G4124A                \tab IlluminaGA_miRNASeq    \cr
#'HumanHap550                       \tab IlluminaHiSeq_miRNASeq \cr
#'ABI                               \tab H-miRNA_8x15K  \cr
#'HG-CGH-244A                       \tab SOLiD_DNASeq                \cr
#'IlluminaDNAMethylation_OMA003_CPI \tab IlluminaGA_DNASeq_automated   \cr
#'IlluminaDNAMethylation_OMA002_CPI \tab HG-U133_Plus_2                 \cr
#'HuEx- 1_0-st-v2 \tab Mixed_DNASeq                  \cr
#'H-miRNA_8x15Kv2 \tab IlluminaGA_DNASeq_curated      \cr
#'MDA_RPPA_Core   \tab IlluminaHiSeq_TotalRNASeqV2    \cr
#'HT_HG-U133A     \tab IlluminaHiSeq_DNASeq_automated \cr
#'diagnostic_images                 \tab microsat_i                     \cr
#'IlluminaHiSeq_RNASeq              \tab SOLiD_DNASeq_curated           \cr
#'IlluminaHiSeq_DNASeqC             \tab Mixed_DNASeq_curated           \cr
#'IlluminaGA_RNASeq                 \tab IlluminaGA_DNASeq_Cont_automated  \cr
#'IlluminaGA_DNASeq                 \tab IlluminaHiSeq_WGBS             \cr
#'pathology_reports                 \tab IlluminaHiSeq_DNASeq_Cont_automated\cr
#'Genome_Wide_SNP_6                 \tab bio                            \cr
#'tissue_images                     \tab Mixed_DNASeq_automated         \cr
#'HumanMethylation27                \tab Mixed_DNASeq_Cont_curated      \cr
#'IlluminaHiSeq_RNASeqV2            \tab Mixed_DNASeq_Cont
#'}
#' @export
#' @examples
#' query <- GDCquery(
#'    project = "TCGA-ACC",
#'    data.category = "Copy Number Variation",
#'    data.type = "Copy Number Segment"
#' )
#' \dontrun{
#' query <- GDCquery(
#'   project = "TARGET-AML",
#'   data.category = "Transcriptome Profiling",
#'   data.type = "miRNA Expression Quantification",
#'   workflow.type = "BCGSC miRNA Profiling",
#'   barcode = c("TARGET-20-PARUDL-03A-01R","TARGET-20-PASRRB-03A-01R")
#' )
#' query <- GDCquery(
#'    project = "TARGET-AML",
#'    data.category = "Transcriptome Profiling",
#'    data.type = "Gene Expression Quantification",
#'    workflow.type = "STAR - Counts",
#'    barcode = c("TARGET-20-PADZCG-04A-01R","TARGET-20-PARJCR-09A-01R")
#' )
#' query <- GDCquery(
#'    project = "TCGA-ACC",
#'    data.category =  "Copy Number Variation",
#'    data.type = "Masked Copy Number Segment",
#'    sample.type = c("Primary Tumor")
#' )
#' }
#' @return A data frame with the results and the parameters used
#' @importFrom jsonlite fromJSON
#' @importFrom knitr kable
#' @importFrom httr timeout
#' @importFrom dplyr pull
#' @importFrom tidyr contains
#' @author Tiago Chedraoui Silva
GDCquery <- function(
        project,
        data.category,
        data.type,
        workflow.type,
        access,
        platform,
        barcode,
        data.format,
        experimental.strategy,
        sample.type
){

    isServeOK()
    suppressWarnings({
        # prepare output
        if(missing(sample.type)) {
            sample.type <- NA
        } else if(all(sample.type == FALSE)) {
            sample.type <- NA
        }

        if(missing(data.type)) {
            data.type <- NA
        } else if(data.type == FALSE) {
            data.type <- NA
        }

        if(missing(barcode)) {
            barcode <- NA
        } else if(length(barcode) == 1) {
            if(barcode == FALSE) barcode <- NA
        }

        if(missing(platform)) {
            platform <- NA
        } else if(any(platform == FALSE)) {
            platform <- NA
        }

        if(missing(workflow.type)) {
            workflow.type <- NA
        } else if(workflow.type == FALSE) {
            workflow.type <- NA
        }

        if(missing(experimental.strategy)) {
            experimental.strategy <- NA
        } else if(experimental.strategy == FALSE) {
            experimental.strategy <- NA
        }
        if(missing(access)) {
            access <- NA
        } else if(access == FALSE) {
            access <- NA
        }

        if(missing(data.format)) {
            data.format <- NA
        } else if(data.format == FALSE) {
            data.format <- NA
        }
    })
    print.header("GDCquery: Searching in GDC database","section")
    message("Genome of reference: hg38")
    # Check arguments
    checkProjectInput(project)
    checkDataCategoriesInput(project, data.category)
    if(!is.na(data.type)) checkDataTypeInput(data.type = data.type)
    if(!any(is.na(sample.type))) checkBarcodeDefinition(sample.type)

    results <- NULL
    print.header("Accessing GDC. This might take a while...","subsection")
    for(proj in project){
        url <- getGDCquery(
            project = proj,
            data.category = data.category,
            data.type = data.type,
            workflow.type = workflow.type,
            platform = platform,
            files.access = access,
            experimental.strategy = experimental.strategy,
            sample.type = sample.type
        )
        message("ooo Project: ", proj)
        original_timeout <- getOption('timeout')
        options(timeout=600)
        json  <- tryCatch(
            getURL(url,fromJSON,timeout(600),simplifyDataFrame = TRUE),
            error = function(e) {
                message(paste("Error: ", e, sep = " "))
                message("We will retry to access GDC!")
                fromJSON(
                    content(
                        getURL(url,GET,timeout(600)),
                        as = "text",
                        encoding = "UTF-8"
                    ), simplifyDataFrame = TRUE
                )
            }
        )
        if(json$data$pagination$count == 0) {
            url <- getGDCquery(
                project = proj,
                data.category = data.category,
                data.type = data.type,
                workflow.type = NA,
                platform = NA,
                experimental.strategy = experimental.strategy,
                files.access = access,
                sample.type = sample.type
            )
            json  <- tryCatch(
                fromJSON(content(getURL(url,GET,timeout(600)), as = "text", encoding = "UTF-8"), simplifyDataFrame = TRUE),
                error = function(e) {
                    message(paste("Error: ", e, sep = " "))
                    message("We will retry to access GDC!")
                    getURL(url,fromJSON,timeout(600),simplifyDataFrame = TRUE)
                }
            )
        }
        options(timeout=original_timeout)


        json$data$hits$acl <- NULL
        json$data$hits$project <- proj

        if ("archive" %in% colnames(json$data$hits)) {
            if (is.data.frame(json$data$hits$archive)) {
                archive <- json$data$hits$archive
                colnames(archive)[1:ncol(archive)] <- paste0("archive_", colnames(archive)[1:ncol(archive)])
                json$data$hits$archive <- NULL
                json$data$hits <- cbind(json$data$hits, archive)
            }
        }

        if ("analysis" %in% colnames(json$data$hits)){
            if (is.data.frame(json$data$hits$analysis)){
                analysis <- json$data$hits$analysis
                # Columns
                # "analysis_id"
                # "created_datetime"
                # "state"
                # "submitter_id"
                # "updated_datetime"
                # "workflow_link"
                # "workflow_type"
                # "workflow_version"
                analysis <- analysis[,order(colnames(analysis))]
                analysis <- analysis %>% dplyr::select(!contains("datetime"))
                idx <- which(colnames(analysis) != "analysis_id")
                colnames(analysis)[idx] <- paste0("analysis_", colnames(analysis)[idx])
                json$data$hits$analysis <- NULL
                json$data$hits <- cbind(json$data$hits, analysis)
            }
        }
        if("center" %in% colnames(json$data$hits)){
            if(is.data.frame(json$data$hits$center)){
                center <- json$data$hits$center
                center <- center[,order(colnames(center))]
                colnames(center)[2:ncol(center)] <- paste0("center_", colnames(center)[2:ncol(center)])
                json$data$hits$center <- NULL
                json$data$hits <- cbind(json$data$hits, center)
            }
        }

        results <-  plyr::rbind.fill(as.data.frame(results),as.data.frame(json$data$hits))

    }
    if(ncol(results) == 1) {
        message("Sorry! There is no result for your query. Please check in GDC the data available or if there is no error in your query.")
        return (NULL)
    }
    print.header("Filtering results","subsection")
    if(!any(is.na(platform))){
        if(!(all(platform %in% results$platform))){
            stop("Please set a valid platform argument from the list below:\n  => ", paste(unique(results$platform), collapse = "\n  => "))
        }
        message("ooo By platform")
        results <- results[tolower(results$platform) %in% tolower(platform),]
    }

    # Filter by access
    if(!is.na(access)) {
        message("ooo By access")
        results <- results[grepl(access,results$access,ignore.case = TRUE),]
    }
    # Filter by experimental strategy
    if(!is.na(experimental.strategy)) {
        if(all(tolower(experimental.strategy) %in%  tolower(results$experimental_strategy))) {
            message("ooo By experimental.strategy")
            results <- results[tolower(results$experimental_strategy) %in% tolower(experimental.strategy),]
        } else {
            message(
                paste0(
                    "The argument experimental_strategy does not match any of the results.\nPossible values:",
                    paste(unique(results$experimental_strategy),collapse = "\n=>")
                )
            )
        }
    }

    if(!is.na(data.format)) {
        if(all(tolower(data.format) %in%  tolower(results$data_format))) {
            message("ooo By data.format")
            results <- results[tolower(results$data_format) %in% tolower(data.format),]
        } else {
            message(
                paste0(
                    "The argument experimental_strategy does not match any of the results.\nPossible values:",
                    paste(unique(results$data_format),collapse = "\n=>")
                )
            )
        }
    }

    # Filter by data.type
    if(!is.na(data.type)) {
        if(!(tolower(data.type) %in% tolower(results$data_type))) {
            stop("Please set a valid data.type argument from the list below:\n  => ",
                 paste(unique(results$data_type), collapse = "\n  => "))
        }
        message("ooo By data.type")
        results <- results[tolower(results$data_type) %in% tolower(data.type),]
    }

    # Filter by workflow.type
    if(!is.na(workflow.type)) {
        if(!(workflow.type %in% results$analysis_workflow_type)) {
            stop("Please set a valid workflow.type argument from the list below:\n  => ",
                 paste(unique(results$analysis_workflow_type), collapse = "\n  => "))
        }
        message("ooo By workflow.type")
        results <- results[results$analysis_workflow_type %in% workflow.type,]
    }

    # get barcode of the samples
    # 1) Normally for each sample we will have only single information
    # however the mutation call uses both normal and tumor which are both
    # reported by the API
    if(!data.category %in% c(
        "Clinical",
        "Biospecimen",
        "Other",
        "Simple Nucleotide Variation",
        "Simple nucleotide variation",
        "Protein expression")
    ){

        # we also need to deal with pooled samples (mixed from different patients)
        # example CPT0000870008

        if("portions" %in% (results$cases[[1]]$samples[[1]] %>% names)) {
            aux <- plyr::laply(results$cases,
                               function(x) {
                                   plyr::summarize(
                                       rbindlist(x$samples),
                                       submitter_id = paste(submitter_id,collapse = ";"),
                                       is_ffpe = ifelse("is_ffpe" %in% colnames(x),any(is_ffpe),NA),
                                       sample_type =  paste(sample_type,collapse = ";"),
                                       aliquot.submiter.id = paste(unlist(rbindlist(x$samples))[grep("portions.analytes.aliquots.submitter_id",names(unlist(rbindlist(x$samples))))],collapse = ";")
                                   )
                               }) %>% as.data.frame
        } else {
            aux <- plyr::laply(results$cases,
                               function(x) {
                                   plyr::summarize(
                                       rbindlist(x$samples),
                                       submitter_id = paste(submitter_id,collapse = ";"),
                                       is_ffpe = ifelse("is_ffpe" %in% colnames(x),any(is_ffpe),NA),
                                       sample_type =  paste(sample_type,collapse = ";"))
                               }) %>% as.data.frame

        }
        results$sample_type <- aux$sample_type %>% as.character()
        results$is_ffpe <- aux$is_ffpe %>% as.logical

        if("submitter_id" %in% names(unlist(results$cases))) {
            results$cases.submitter_id <- plyr::laply(
                results$cases,
                function(x) {
                    paste(x$submitter_id,collapse = ";")
                }
            )  %>% as.character()
        }

        # ORGANOID-PANCREATIC does not have aliquots
        if("aliquot.submiter.id" %in% colnames(aux)){
            results$cases <- aux$aliquot.submiter.id  %>% as.character()
            results$sample.submitter_id <- aux$submitter_id  %>% as.character()
        } else{
            results$cases <- aux$submitter_id  %>% as.character()

            if("submitter_id" %in% names(unlist(results$cases))) {
                results$cases.submitter_id <- results$cases[[1]]$submitter_id  %>% as.character()
            }

            results$sample.submitter_id <- aux$submitter_id  %>% as.character()
        }

    } else  if(data.category %in% c("Clinical")){
        # Clinical has another structure
        aux <- plyr::laply(results$cases,
                           function(x) {
                               unlist(x,recursive = T)[c("submitter_id")]
                           }) %>% as.data.frame
        results$cases <- aux  %>% dplyr::pull(1) %>% as.character()

    } else  if(data.category %in% c("Biospecimen")){
        # Biospecimen has another structure
        aux <- plyr::laply(results$cases,
                           function(x) {
                               paste(x$submitter_id,collapse = ",")
                           })
        results$cases <- aux
    }  else  if(data.category == "Other"){
        # Auxiliary test files does not have information linked toit.
        # get frm file names
        results$cases <- str_extract_all(results$file_name,"TCGA-[:alnum:]{2}-[:alnum:]{4}") %>% unlist
    } else if(
        data.category %in% c(
            "Simple nucleotide variation",
            "Simple Nucleotide Variation"
        )
    ) {
        cases <- plyr::laply(
            .data = results$cases,
            .fun =  function(x) {
                lapply(x$samples,FUN = function(y)  {
                    aux <- unlist(y$portions)
                    sort(aux[grep("analytes.aliquots.submitter_id",names(aux))])
                }) %>%
                    unlist %>%
                    na.omit %>%
                    paste(collapse = ",")
            }) %>% as.data.frame %>% dplyr::pull(1) %>% as.character()

        sample_type <- plyr::laply(
            .data = results$cases,
            .fun =  function(x) {
                lapply(x$samples,FUN = function(y)  {
                    sample <- unlist(y,recursive = T)
                    sort(sample[grep("sample_type[0-9]{0}$",names(sample))],decreasing = T)
                }) %>%
                    unlist %>%
                    na.omit %>%
                    paste(collapse = ",")
            }) %>% as.data.frame %>% dplyr::pull(1) %>% as.character()
        results$sample_type <- sample_type
        results$cases <- cases
    } else  if(data.category %in% c("Protein expression")) {
        aux <- plyr::laply(
            .data = results$cases,
            .fun = function(x) {
                summarize(x$samples[[1]]$portions[[1]],
                          submitter_id = paste(submitter_id,collapse = ";"),
                          is_ffpe = any(is_ffpe))
            }) %>% as.data.frame

        results$is_ffpe <- aux$is_ffpe %>% unlist() %>% as.logical
        results$cases <- aux$submitter_id %>% unlist
    } else if(data.category == "Simple Nucleotide Variation"){

        if(data.type %in% "Masked Somatic Mutation"){
            # MAF files are one single file for all samples
            aux <- plyr::laply(
                .data = results$cases[[1]]$samples,
                .fun =  function(x) {
                    unlist(x,recursive = T)[c("portions.analytes.aliquots.submitter_id","sample_type1","sample_type2","is_ffpe1","is_ffpe2")]
                }) %>% as.data.frame

            results$cases <- aux$portions.analytes.aliquots.submitter_id  %>% as.character() %>% paste(collapse = ",")
            if(!is.na(sample.type)) sample.type <- NA # ensure no filtering will be applied

        } else {
            # TODO: Add commentary with case
            aux <- plyr::laply(.data = results$cases,
                               .fun = function(x) {
                                   unlist(x$samples[[1]],recursive = T)[c("portions.analytes.aliquots.submitter_id","sample_type1","sample_type2","is_ffpe1","is_ffpe2")]
                               }) %>% as.data.frame
            results$sample_type1 <- aux$sample_type1 %>% as.character()
            results$sample_type2 <- aux$sample_type2 %>% as.character()
            results$is_ffpe1 <- aux$is_ffpe1 %>% as.logical
            results$is_ffpe2 <- aux$is_ffpe2 %>% as.logical
            results$cases <- aux$portions.analytes.aliquots.submitter_id  %>% as.character()
            if(!is.na(sample.type)) sample.type <- NA # ensure no filtering will be applied
        }
    }
    # Filter by barcode
    if(!any(is.na(barcode))) {
        message("ooo By barcode")
        idx <- unique(unlist(sapply(barcode, function(x) grep(x, results$cases,ignore.case = TRUE))))
        if(length(idx) == 0)  {
            print(knitr::kable(results$cases,col.names = "Available barcodes"))
            stop("None of the barcodes were matched. Available barcodes are above")
        }

        results <- results[idx,]
    }

    # Filter by sample.type
    if(!any(is.na(sample.type))) {
        if(!any(tolower(results$sample_type) %in% tolower(sample.type))) {
            aux <- as.data.frame(table(results$sample_type))
            aux <- aux[aux$Freq > 0,]
            print(kable(aux,row.names = FALSE,col.names = c("sample.type","Number of samples")))
            stop("Please set a valid sample.type argument from the list above.")
        }
        message("ooo By sample.type")
        results <- results[tolower(results$sample_type) %in% tolower(sample.type),]
    }
    print.header("Checking data","subsection")

    message("ooo Checking if there are duplicated cases")
    if (any(duplicated(results$cases))) {
        message("Warning: There are more than one file for the same case. Please verify query results. You can use the command View(getResults(query)) in rstudio")
    }

    message("ooo Checking if there are results for the query")
    if (nrow(results) == 0) stop("Sorry, no results were found for this query")

    # Try ordering (needs dplyr 1.0 - still not published)
    results <- tryCatch({
        results
        #    results %>% relocate("project") %>%
        #        relocate(contains("type"), .after = project) %>%
        #        relocate(contains("category"), .after = project) %>%
        #        relocate(contains("experimental_strategy"), .after = project) %>%
        #        relocate(contains("submitter_id"), .after = project) %>%
        #        relocate(contains("sample_type"), .before = experimental_strategy) %>%
        #        relocate(access,.after = last_col())  %>%
        #        relocate(starts_with("analysis"), .before = access) %>%
        #        relocate(contains("datetime"),.after = last_col())
    },error = function(e){
        results
    })


    print.header("Preparing output","section")
    ret <- data.frame(
        results = I(list(results)),
        project = I(list(project)),
        data.category = data.category,
        data.type = data.type,
        access = I(list(access)),
        experimental.strategy =  I(list(experimental.strategy)),
        platform = I(list(platform)),
        sample.type = I(list(sample.type)),
        barcode = I(list(barcode)),
        workflow.type = workflow.type
    )
    return(ret)
}

getGDCquery <- function(
        project,
        data.category,
        data.type,
        workflow.type,
        platform,
        files.access,
        sample.type,
        experimental.strategy
){
    # Get manifest using the API
    baseURL <- "https://api.gdc.cancer.gov/files/?"
    options.pretty <- "pretty=true"
    if(data.category %in% c("Clinical","Biospecimen")) {
        options.expand <- "expand=cases,cases.project,center,analysis"
    } else {
        options.expand <- "expand=cases,cases.samples.portions.analytes.aliquots,cases.project,center,analysis,cases.samples"
    }
    option.size <- paste0("size=",getNbFiles(project,data.category))
    option.format <- paste0("format=JSON")

    options.filter <- paste0(
        "filters=",
        URLencode('{"op":"and","content":['),  # Start json request
        URLencode('{"op":"in","content":{"field":"cases.project.project_id","value":["'),
        project,
        URLencode('"]}}')
    )

    if(!is.na(experimental.strategy)) options.filter <- paste0(options.filter,addFilter("files.experimental_strategy", experimental.strategy))
    if(!is.na(data.category))  options.filter <- paste0(options.filter,addFilter("files.data_category", data.category))
    if(!is.na(data.type))  options.filter <- paste0(options.filter,addFilter("files.data_type", data.type))
    if(!is.na(workflow.type))  options.filter <- paste0(options.filter,addFilter("files.analysis.workflow_type", workflow.type))
    if(!any(is.na(platform))) options.filter <- paste0(options.filter,addFilter("files.platform", platform))
    if(!any(is.na(files.access))) {
        options.filter <- paste0(options.filter,addFilter("files.access", files.access))
    }
    if(!any(is.na(sample.type))) {
        if("Primary solid Tumor" %in% sample.type) sample.type[sample.type == "Primary solid Tumor"] <- "Primary Tumor"
        if("Recurrent Solid Tumor" %in% sample.type) sample.type[sample.type == "Recurrent Solid Tumor"] <- "Recurrent Tumor"
        options.filter <- paste0(options.filter,addFilter("cases.samples.sample_type", sample.type))
    }

    # Close json request
    options.filter <- paste0(options.filter, URLencode(']}'))
    url <- paste0(
        baseURL,
        paste(
            options.pretty,
            options.expand,
            option.size,
            options.filter,
            option.format,
            sep = "&"
        )
    )
    return(url)
}

addFilter <- function(field, values){
    ret <- paste0(
        URLencode(',{"op":"in","content":{"field":"'),
        URLencode(field),
        URLencode('","value":["'),
        URLencode(paste0(values, collapse = '","')),
        URLencode('"]}}')
    )
    return(ret)
}

expandBarcodeInfo <- function(barcode){
    if(any(grepl("TARGET",barcode))) {
        ret <- DataFrame(
            barcode = barcode,
            code = substr(barcode, 8, 9),
            case.unique.id = substr(barcode, 11, 16),
            tissue.code = substr(barcode, 18, 19),
            nucleic.acid.code = substr(barcode, 24, 24)
        )
        ret <- merge(ret,getBarcodeDefinition(), by = "tissue.code", sort = FALSE, all.x = TRUE)
        ret <- ret[match(barcode,ret$barcode),]
    }
    if(any(grepl("TCGA",barcode))) {
        ret <- data.frame(
            barcode = barcode,
            patient = substr(barcode, 1, 12),
            sample = substr(barcode, 1, 16),
            tissue.code = substr(barcode, 14, 15)
        )
        ret <- merge(
            ret,
            getBarcodeDefinition(),
            by = "tissue.code",
            sort = FALSE,
            all.x = TRUE
        )
        ret <- ret[match(barcode,ret$barcode),]
    }
    return(ret)
}


getBarcodeDefinition <- function(type = "TCGA"){
    if(type == "TCGA"){
        tissue.code <- c(
            '01','02','03','04','05','06','07','08','09','10','11',
            '12','13','14','20','40','50','60','61'
        )
        shortLetterCode <- c(
            "TP","TR","TB","TRBM","TAP","TM","TAM","THOC",
            "TBM","NB","NT","NBC","NEBV","NBM","CELLC","TRB",
            "CELL","XP","XCL"
        )

        tissue.definition <- c(
            "Primary Tumor",
            "Recurrent Tumor",
            "Primary Blood Derived Cancer - Peripheral Blood",
            "Recurrent Blood Derived Cancer - Bone Marrow",
            "Additional - New Primary",
            "Metastatic",
            "Additional Metastatic",
            "Human Tumor Original Cells",
            "Primary Blood Derived Cancer - Bone Marrow",
            "Blood Derived Normal",
            "Solid Tissue Normal",
            "Buccal Cell Normal",
            "EBV Immortalized Normal",
            "Bone Marrow Normal",
            "Control Analyte",
            "Recurrent Blood Derived Cancer - Peripheral Blood",
            "Cell Lines",
            "Primary Xenograft Tissue",
            "Cell Line Derived Xenograft Tissue")
        aux <- data.frame(
            tissue.code = tissue.code,
            shortLetterCode,
            tissue.definition
        )
    } else {

        tissue.code <- c(
            '01','02','03','04','05','06','07','08','09','10','11',
            '12','13','14','15','16','17','20','40','41','42','50','60','61','99'
        )

        tissue.definition <- c(
            "Primary Tumor", # 01
            "Recurrent Tumor", # 02
            "Primary Blood Derived Cancer - Peripheral Blood", # 03
            "Recurrent Blood Derived Cancer - Bone Marrow", # 04
            "Additional - New Primary", # 05
            "Metastatic", # 06
            "Additional Metastatic", # 07
            "Tissue disease-specific post-adjuvant therapy", # 08
            "Primary Blood Derived Cancer - Bone Marrow", # 09
            "Blood Derived Normal", # 10
            "Solid Tissue Normal",  # 11
            "Buccal Cell Normal",   # 12
            "EBV Immortalized Normal", # 13
            "Bone Marrow Normal", # 14
            "Fibroblasts from Bone Marrow Normal", # 15
            "Mononuclear Cells from Bone Marrow Normal", # 16
            "Lymphatic Tissue Normal (including centroblasts)", # 17
            "Control Analyte", # 20
            "Recurrent Blood Derived Cancer - Peripheral Blood", # 40
            "Blood Derived Cancer- Bone Marrow, Post-treatment", # 41
            "Blood Derived Cancer- Peripheral Blood, Post-treatment", # 42
            "Cell line from patient tumor", # 50
            "Xenograft from patient not grown as intermediate on plastic tissue culture dish", # 60
            "Xenograft grown in mice from established cell lines", #61
            "Granulocytes after a Ficoll separation"
        ) # 99
        aux <- DataFrame(tissue.code = tissue.code, tissue.definition)

    }
    return(aux)
}


#' @title Retrieve open access mc3 MAF file from GDC server
#' @description
#'   Download data from https://gdc.cancer.gov/about-data/publications/mc3-2017
#'   https://gdc-docs.nci.nih.gov/Data/Release_Notes/Data_Release_Notes/
#' @examples
#' \dontrun{
#'    maf <- getMC3MAF()
#' }
#' @return A data frame with the MAF file information from https://gdc.cancer.gov/about-data/publications/mc3-2017
#' @export
getMC3MAF <- function(){
    fout <- "mc3.v0.2.8.PUBLIC.maf.gz"
    fpath <- "https://api.gdc.cancer.gov/data/1c8cfe5f-e52d-41ba-94da-f15ea1337efc"
    if(is.windows()) mode <- "wb" else  mode <- "w"
    message(rep("-",100))
    options(timeout = 1000) # set 1000 second to download the file, default is 60 seconds
    message("o Starting to download Public MAF from GDC")
    message("o More information at: https://gdc.cancer.gov/about-data/publications/mc3-2017")
    message("o Please, cite: Cell Systems. Volume 6 Issue 3: p271-281.e7, 28 March 2018 10.1016/j.cels.2018.03.002")
    if(!file.exists(gsub("\\.gz", "", fout))){
        download(fpath, fout, mode = mode)
        message("o Uncompressing file")
        R.utils::gunzip(fout, remove = FALSE)
    }
    message("o Reading MAF")
    maf <- readr::read_tsv(gsub("\\.gz", "", fout),progress = TRUE, col_types = readr::cols())
    message("o Adding project_id information")
    project <- grep("TCGA",sort(getGDCprojects()$project_id),value = TRUE)
    df <- plyr::adply(
        project,
        .margins = 1,
        .fun = function(proj) {
            samples <- getSubmitterID(proj)
            return(data.frame(proj,samples))
        }
    )
    maf$project_id <- df$proj[match(substr(maf$Tumor_Sample_Barcode,1,12),df$samples)] %>% as.character
    message(rep("-",100))
    return(maf)
}


#' @title Query gene counts of TCGA and GTEx data from the Recount2 project
#' @description
#'   TCGArecount2_query queries and downloads data produced by the Recount2 project. User can specify which project and which tissue to query
#' @param project is a string denoting which project the user wants. Options are "tcga" and "gtex"
#' @param tissue a vector of tissue(s) to download. Options are "adipose tissue", "adrenal gland", "bladder","blood", "blood vessel", "bone marrow", "brain", "breast","cervix uteri", "colon", "esophagus", "fallopian tube","heart", "kidney", "liver", "lung", "muscle", "nerve", "ovary","pancreas", "pituitary", "prostate", "salivary gland", "skin", "small intestine", "spleen", "stomach", "testis", "thyroid", "uterus", "vagina"
#' @export
#' @examples
#' \dontrun{
#'  brain.rec<-TCGAquery_recount2(project = "gtex", tissue = "brain")
#' }
#' @return List with $subtypes attribute as a dataframe with barcodes, samples, subtypes, and colors. The $filtered attribute is returned as filtered samples with no subtype info
TCGAquery_recount2<-function(project, tissue=c()){
    tissuesGTEx <- c(
        "adipose_tissue",
        "adrenal_gland",
        "bladder",
        "blood",
        "blood_vessel",
        "bone_marrow",
        "brain",
        "breast",
        "cervix_uteri",
        "colon",
        "esophagus",
        "fallopian_tube",
        "heart",
        "kidney",
        "liver",
        "lung",
        "muscle",
        "nerve",
        "ovary",
        "pancreas",
        "pituitary",
        "prostate",
        "salivary_gland",
        "skin",
        "small_intestine",
        "spleen",
        "stomach",
        "testis",
        "thyroid",
        "uterus",
        "vagina"
    )

    tissuesTCGA <- c(
        "adrenal_gland",
        "bile_duct",
        "bladder",
        "bone_marrow",
        "brain",
        "breast",
        "cervix",
        "colorectal",
        "esophagus",
        "eye",
        "head_and_neck",
        "kidney",
        "liver",
        "lung",
        "lymph_nodes",
        "ovary",
        "pancreas",
        "pleura",
        "prostate",
        "skin",
        "soft_tissue",
        "stomach",
        "testis",
        "thymus",
        "thyroid",
        "uterus")


    tissue<-unlist(lapply(strsplit(tissue, " "), function(x) paste(x, collapse = "_")))
    Res<-list()

    if (tolower(project) == "gtex"){
        for (t_i in tissue){
            if(t_i%in%tissuesGTEx){
                con<-"http://duffel.rail.bio/recount/v2/SRP012682/rse_gene_"
                con<-paste0(con,t_i,".Rdata")

                message(paste0("downloading Range Summarized Experiment for: ", t_i))
                load(url(con))
                Res[[paste0(project,"_", t_i)]]<-rse_gene
            }
            else stop(paste0(t_i, " is not an available tissue on Recount2"))
        }
        return(Res)
    }
    else if(tolower(project)=="tcga"){
        for(t_i in tissue){
            if(t_i%in%tissuesTCGA){
                con<-"http://duffel.rail.bio/recount/v2/TCGA/rse_gene_"
                con<-paste0(con,t_i,".Rdata")
                message(paste0("downloading Range Summarized Experiment for: ", t_i))
                load(url(con))
                Res[[paste0(project,"_", t_i)]]<-rse_gene

            }
            else stop(paste0(t_i, " is not an available tissue on Recount2"))
        }
        return(Res)
    }
    else stop(paste0(project, " is not a valid project"))

}

#' @title Retrieve open access ATAC-seq files from GDC server
#' @description
#'   Retrieve open access ATAC-seq files from GDC server
#'  https://gdc.cancer.gov/about-data/publications/ATACseq-AWG
#'  Manifest available at: https://gdc.cancer.gov/system/files/public/file/ATACseq-AWG_Open_GDC-Manifest.txt
#' @param tumor a valid tumor
#' @param file.type Write maf file into a csv document
#' @export
#' @examples
#'  query <- GDCquery_ATAC_seq(file.type = "txt")
#' \dontrun{
#'    GDCdownload(query)
#' }
#' query <- GDCquery_ATAC_seq(tumor = "BRCA",file.type = "bigWigs")
#' \dontrun{
#'    GDCdownload(query,method = "client")
#' }
#' @return A data frame with the maf file information
GDCquery_ATAC_seq <- function(
        tumor = NULL,
        file.type = NULL
) {
    isServeOK()
    results <- readr::read_tsv("https://gdc.cancer.gov/system/files/public/file/ATACseq-AWG_Open_GDC-Manifest.txt")

    if(!is.null(tumor)) results <- results[grep(tumor,results$filename,ignore.case = TRUE),]
    if(!is.null(file.type))  results <- results[grep(file.type,results$filename,ignore.case = TRUE),]

    colnames(results) <- c("file_id", "file_name", "md5sum", "file_size")
    results$state <- "released"
    results$data_type <- "ATAC-seq"
    results$data_category <- "ATAC-seq"
    results$project <- "ATAC-seq"
    ret <- data.frame(
        results = I(list(results)),
        tumor = I(list(tumor)),
        project = I(list("ATAC-seq")),
        data.type = I(list("ATAC-seq")),
        data.category = I(list("ATAC-seq"))
    )

    return(ret)
}

#' @title Get hg19 gene annotation or hg38 (gencode v36)
#' @description Get hg19 (from biomart) or hg38 (gencode v36) gene annotation
#' @param genome hg38 or hg19
#' @param as.granges Output as GRanges or data.frame
#' @import TCGAbiolinksGUI.data
#' @export
get.GRCh.bioMart <- function(
    genome = c("hg19", "hg38"),
    as.granges = FALSE
) {

    genome <- match.arg(genome)
    # Since the amount of users complaining about the access we
    # also added the data into a data package
    check_package("TCGAbiolinksGUI.data")
    if (genome == "hg19") {
        gene.location <- get(
            data("gene.location.hg19",
                 package = "TCGAbiolinksGUI.data",
                 envir = environment())
        )

        if (as.granges) {
            gene.location$strand[gene.location$strand == 1] <- "+"
            gene.location$strand[gene.location$strand == -1] <- "-"
            gene.location$chromosome_name <- paste0("chr",gene.location$chromosome_name)
            gene.location <- makeGRangesFromDataFrame(
                gene.location, seqnames.field = "chromosome_name",
                start.field = "start_position",
                end.field = "end_position",
                keep.extra.columns = TRUE
            )
        }
    } else {
        gene.location <- get(
            data(
                "gencode.v36.annotation.genes",
                package = "TCGAbiolinksGUI.data",
                envir = environment()
            )
        )
        if(!as.granges) gene.location <- as.data.frame(gene.location)
    }

    return(gene.location)
}

#' @noRd
map.ensg <- function(genome = "hg38", genes) {
    gene.location <- get.GRCh.bioMart(genome)
    gene.location <- gene.location[match(genes, gsub("\\.[0-9]*","",gene.location$gene_id)), ]
    return(gene.location)
}



#' getTSS to fetch GENCODE gene annotation (transcripts level) from Bioconductor package biomaRt
#' If upstream and downstream are specified in TSS list, promoter regions of GENCODE gene will be generated.
#' @description
#' getTSS to fetch GENCODE gene annotation (transcripts level) from Bioconductor package biomaRt
#' If upstream and downstream are specified in TSS list, promoter regions of GENCODE gene will be generated.
#' @param TSS A list. Contains upstream and downstream like TSS=list(upstream, downstream).
#'  When upstream and downstream is specified, coordinates of promoter regions with gene annotation will be generated.
#' @param genome Which genome build will be used: hg38 (default) or hg19.
#' @return GENCODE gene annotation if TSS is not specified. Coordinates of GENCODE gene promoter regions if TSS is specified.
#' @examples
#' # get GENCODE gene annotation (transcripts level)
#' \dontrun{
#'     getTSS <- getTSS()
#'     getTSS <- getTSS(genome.build = "hg38", TSS=list(upstream=1000, downstream=1000))
#' }
#' @importFrom GenomicRanges makeGRangesFromDataFrame promoters
#' @importFrom biomaRt useEnsembl listDatasets getBM
getTSS <- function(
    genome = c("hg38","hg19"),
    TSS = list(upstream = NULL, downstream = NULL)
) {
    genome <- match.arg(genome)

    host <- ifelse(genome == "hg19",  "grch37.ensembl.org", "www.ensembl.org")
    ensembl <- tryCatch({
        useEnsembl("ensembl", dataset = "hsapiens_gene_ensembl", host =  host)
    },  error = function(e) {
        useEnsembl(
            "ensembl",
            dataset = "hsapiens_gene_ensembl",
            mirror = "uswest",
            host =  host
        )
    })
    attributes <- c(
        "chromosome_name",
        "start_position",
        "end_position",
        "strand",
        "transcript_start",
        "transcription_start_site",
        "transcript_end",
        "ensembl_transcript_id",
        "ensembl_gene_id",
        "entrezgene_id",
        "external_gene_name"
    )

    chrom <- c(1:22, "X", "Y", "M", "*")
    db.datasets <- listDatasets(ensembl)
    description <- db.datasets[db.datasets$dataset == "hsapiens_gene_ensembl", ]$description
    message(paste0("Downloading transcripts information. Using: ", description))

    tss <- getBM(
        attributes = attributes,
        filters = c("chromosome_name"),
        values = list(chrom),
        mart = ensembl
    )
    tss <- tss[!duplicated(tss$ensembl_transcript_id), ]
    if (genome == "hg19") tss$external_gene_name <- tss$external_gene_id
    tss$chromosome_name <-  paste0("chr", tss$chromosome_name)
    tss$strand[tss$strand == 1] <- "+"
    tss$strand[tss$strand == -1] <- "-"

    tss <- makeGRangesFromDataFrame(
        tss,
        start.field = "transcript_start",
        end.field = "transcript_end",
        keep.extra.columns = TRUE
    )

    if (!is.null(TSS$upstream) & !is.null(TSS$downstream)) {
        tss <- promoters(
            tss,
            upstream = TSS$upstream,
            downstream = TSS$downstream
        )
    }

    return(tss)
}

#' @title Creates survival analysis
#' @description Creates a survival plot from TCGA patient clinical data
#' using survival library. It uses the fields days_to_death and vital, plus a
#' columns for groups.
#'
#' @param data TCGA Clinical patient with the information days_to_death
#' @param clusterCol Column with groups to plot. This is a mandatory field, the
#' caption will be based in this column
#' @param legend Legend title of the figure
#' @param xlim x axis limits e.g. xlim = c(0, 1000). Present narrower X axis, but not affect survival estimates.
#' @param main main title of the plot
#' @param labels labels of the plot
#' @param ylab y axis text of the plot
#' @param xlab x axis text of the plot
#' @param filename The name of the pdf file.
#' @param color Define the colors/Pallete for lines.
#' @param risk.table show or not the risk table
#' @param width Image width
#' @param height Image height
#' @param pvalue show p-value of log-rank test
#' @param conf.int  show confidence intervals for point estimates of survival curves.
#' @param ... Further arguments passed to \link[survminer]{ggsurvplot}.
#' @param dpi Figure quality
#' @export
#' @return Survival plot
#' @examples
#'  # clin <- GDCquery_clinic("TCGA-BRCA","clinical")
#'  clin <- data.frame(
#'       vital_status = c("alive","alive","alive","dead","alive",
#'                        "alive","dead","alive","dead","alive"),
#'       days_to_death = c(NA,NA,NA,172,NA,NA,3472,NA,786,NA),
#'       days_to_last_follow_up = c(3011,965,718,NA,1914,423,NA,5,656,1417),
#'       gender = c(rep("male",5),rep("female",5))
#'  )
#' TCGAanalyze_survival(clin, clusterCol="gender")
#' TCGAanalyze_survival(clin, clusterCol="gender", xlim = 1000)
#' TCGAanalyze_survival(clin,
#'                      clusterCol="gender",
#'                      risk.table = FALSE,
#'                      conf.int = FALSE,
#'                      color = c("pink","blue"))
#' TCGAanalyze_survival(clin,
#'                      clusterCol="gender",
#'                      risk.table = FALSE,
#'                      xlim = c(100,1000),
#'                      conf.int = FALSE,
#'                      color = c("Dark2"))
TCGAanalyze_survival <- function(
        data,
        clusterCol = NULL,
        legend = "Legend",
        labels = NULL,
        risk.table = TRUE,
        xlim = NULL,
        main = "Kaplan-Meier Overall Survival Curves",
        ylab = "Probability of survival",
        xlab = "Time since diagnosis (days)",
        filename = "survival.pdf",
        color = NULL,
        height = 8,
        width = 12,
        dpi = 300,
        pvalue = TRUE,
        conf.int = TRUE,
        ...) {
    .e <- environment()

    check_package("survminer")
    check_package("survival")
    check_package("gridExtra")

    if (!all(
        c(
            "vital_status",
            "days_to_death",
            "days_to_last_follow_up"
        ) %in% colnames(data)
    ))
        stop(
            "Columns vital_status, days_to_death and  days_to_last_follow_up should be in data frame"
        )

    if (is.null(color)) {
        color <- rainbow(length(unique(data[, clusterCol])))
    }

    group <- NULL
    if (is.null(clusterCol)) {
        stop("Please provide the clusterCol argument")
    } else if (length(unique(data[, clusterCol])) == 1) {
        stop(
            paste0(
                "Sorry, but I'm expecting at least two groups\n",
                "  Only this group found: ",
                unique(data[, clusterCol])
            )
        )
    }
    notDead <- is.na(data$days_to_death)

    if (any(notDead == TRUE)) {
        data[notDead, "days_to_death"] <-
            data[notDead, "days_to_last_follow_up"]
    }
    if (length(data[which((data[, "days_to_death"] < 0) == T), "sample"]) > 0 &
        "sample" %in% colnames(data)) {
        message(
            "Incosistencies in the data were found. The following samples have a negative days_to_death value:"
        )
        message(paste(data[which((data[, "days_to_death"] < 0) == T), "sample"], collapse = ", "))
    }
    if (any(is.na(data[, "days_to_death"])) &
        "sample" %in% colnames(data)) {
        message(
            "Incosistencies in the data were found. The following samples have a NA days_to_death value:"
        )
        message(paste(data[is.na(data[, "days_to_death"]), "sample"], collapse = ", "))
    }

    # create a column to be used with survival package, info need
    # to be TRUE(DEAD)/FALSE (ALIVE)
    data$s <- grepl("dead|deceased", data$vital_status, ignore.case = TRUE)

    # Column with groups
    data$type <- as.factor(data[, clusterCol])
    data <-  data[, c("days_to_death", "s", "type")]
    # create the formula for survival analysis
    f.m <-
        formula(survival::Surv(as.numeric(data$days_to_death), event = data$s) ~ data$type)
    fit <- do.call(survival::survfit, list(formula = f.m, data = data))

    label.add.n <- function(x) {
        na.idx <- is.na(data[, "days_to_death"])
        negative.idx <- data[, "days_to_death"] < 0
        idx <- !(na.idx | negative.idx)
        return(paste0(x, " (n = ",
                      sum(data[idx, "type"] == x), ")"))
    }

    if (is.null(labels)) {
        d <- survminer::surv_summary(fit, data = data)
        order <-
            unname(sapply(levels(d$strata), function(x)
                unlist(str_split(x, "="))[2]))
        labels <- sapply(order, label.add.n)
    }
    if (length(xlim) == 1) {
        xlim <- c(0, xlim)
    }
    suppressWarnings({
        surv <- survminer::ggsurvplot(
            fit,
            # survfit object with calculated statistics.
            risk.table = risk.table,
            # show risk table.
            pval = pvalue,
            # show p-value of log-rank test.
            conf.int = conf.int,
            # show confidence intervals for point estimaes of survival curves.
            xlim = xlim,
            # present narrower X axis, but not affect survival estimates.
            main = main,
            # Title
            xlab = xlab,
            # customize X axis label.
            legend.title = legend,
            # Legend title
            legend.labs = labels,
            # change legend labels.
            palette =  color,
            # custom color palettes.
            ...
        )
    })


    if (!is.null(filename)) {
        ggsave(
            surv$plot,
            filename = filename,
            width = width,
            height = height,
            dpi = dpi
        )
        message(paste0("File saved as: ", filename))
        if (risk.table) {
            g1 <- ggplotGrob(surv$plot)
            g2 <- ggplotGrob(surv$table)
            min_ncol <- min(ncol(g2), ncol(g1))
            g <-
                gridExtra::gtable_rbind(g1[, 1:min_ncol], g2[, 1:min_ncol], size = "last")
            ggsave(
                g,
                filename = filename,
                width = width,
                height = height,
                dpi = dpi
            )
        }
    } else {
        return(surv)
    }
}
#' @title Mean methylation boxplot
#' @description
#'   Creates a mean methylation boxplot for groups (groupCol),
#'   subgroups will be highlighted as shapes if the subgroupCol was set.
#'
#'   Observation: Data is a summarizedExperiment.
#'
#' @param data SummarizedExperiment object obtained from TCGAPrepare
#' @param groupCol Columns in colData(data) that defines the groups. If no
#' columns defined a columns called "Patients" will be used
#' @param subgroupCol Columns in colData(data) that defines the subgroups.
#' @param shapes Shape vector of the subgroups. It must have the size of the levels
#' of the subgroups. Example: shapes = c(21,23) if for two levels
#' @param filename The name of the pdf that will be saved
#' @param subgroup.legend Name of the subgroup legend. DEFAULT: subgroupCol
#' @param group.legend Name of the group legend. DEFAULT: groupCol
#' @param color vector of colors to be used in graph
#' @param title main title in the plot
#' @param ylab y axis text in the plot
#' @param print.pvalue Print p-value for two groups
#' @param xlab x axis text in the plot
#' @param labels Labels of the groups
#' @param sort Sort boxplot by mean or median.
#' Possible values: mean.asc, mean.desc, median.asc, median.desc
#' @param plot.jitter Plot jitter? Default TRUE
#' @param jitter.size Plot jitter size? Default 3
#' @param height Plot height default:10
#' @param width Plot width default:10
#' @param dpi Pdf dpi default:600
#' @param order Order of the boxplots
#' @param axis.text.x.angle Angle of text in the x axis
#' @param y.limits Change lower/upper y-axis limit
#' @param legend.position Legend position ("top", "right","left","bottom")
#' @param legend.title.position  Legend title position ("top", "right","left","bottom")
#' @param legend.ncols Number of columns of the legend
#' @param add.axis.x.text Add text to x-axis? Default: FALSE
#' @import ggplot2 stats
#' @importFrom SummarizedExperiment colData rowRanges assay
#' @importFrom grDevices rainbow
# ' @importFrom gtools combinations
#' @importFrom plyr ddply . summarize
#' @importFrom knitr kable
#' @export
#' @return Save the pdf survival plot
#' @examples
#' nrows <- 200; ncols <- 21
#' counts <- matrix(runif(nrows * ncols, 0, 1), nrows)
#' rowRanges <- GenomicRanges::GRanges(rep(c("chr1", "chr2"), c(50, 150)),
#'                    IRanges::IRanges(floor(runif(200, 1e5, 1e6)), width=100),
#'                     strand=sample(c("+", "-"), 200, TRUE),
#'                     feature_id=sprintf("ID%03d", 1:200))
#'colData <- S4Vectors::DataFrame(Treatment=rep(c("ChIP", "Input","Other"), 7),
#'                     row.names=LETTERS[1:21],
#'                     group=rep(c("group1","group2","group3"),c(7,7,7)),
#'                     subgroup=rep(c("subgroup1","subgroup2","subgroup3"),7))
#'data <- SummarizedExperiment::SummarizedExperiment(
#'          assays=S4Vectors::SimpleList(counts=counts),
#'          rowRanges=rowRanges,
#'          colData=colData)
#' TCGAvisualize_meanMethylation(data,groupCol  = "group")
#' # change lower/upper y-axis limit
#' TCGAvisualize_meanMethylation(data,groupCol  = "group", y.limits = c(0,1))
#' # change lower y-axis limit
#' TCGAvisualize_meanMethylation(data,groupCol  = "group", y.limits = 0)
#' TCGAvisualize_meanMethylation(data,groupCol  = "group", subgroupCol="subgroup")
#' TCGAvisualize_meanMethylation(data,groupCol  = "group")
#' TCGAvisualize_meanMethylation(data,groupCol  = "group",sort="mean.desc",filename="meandesc.pdf")
#' TCGAvisualize_meanMethylation(data,groupCol  = "group",sort="mean.asc",filename="meanasc.pdf")
#' TCGAvisualize_meanMethylation(data,groupCol  = "group",sort="median.asc",filename="medianasc.pdf")
#' TCGAvisualize_meanMethylation(data,groupCol  = "group",sort="median.desc",filename="mediandesc.pdf")
TCGAvisualize_meanMethylation <- function(
        data,
        groupCol = NULL,
        subgroupCol = NULL,
        shapes = NULL,
        print.pvalue = FALSE,
        plot.jitter = TRUE,
        jitter.size = 3,
        filename = "groupMeanMet.pdf",
        ylab = expression(paste("Mean DNA methylation (",
                                beta, "-values)")),
        xlab = NULL,
        title = "Mean DNA methylation",
        labels = NULL,
        group.legend = NULL,
        subgroup.legend = NULL,
        color = NULL,
        y.limits = NULL,
        sort,
        order,
        legend.position = "top",
        legend.title.position = "top",
        legend.ncols = 3,
        add.axis.x.text = TRUE,
        width = 10,
        height = 10,
        dpi = 600,
        axis.text.x.angle = 90) {
    .e <- environment()
    mean <- colMeans(assay(data), na.rm = TRUE)

    if (is.null(groupCol)) {
        groups <- rep("Patient", length(mean))
    } else {
        if (!(groupCol %in% colnames(colData(data))))
            stop("groupCol not found in the object")
        groups <- colData(data)[, groupCol]
    }

    if (is.null(subgroupCol)) {
        subgroups <- NULL
    } else {
        if (!(subgroupCol %in% colnames(colData(data))))
            stop("subgroupCol not found in the object")
        subgroups <- colData(data)[, subgroupCol]
    }

    if (!is.null(subgroupCol)) {
        df <-
            data.frame(
                mean = mean,
                groups = groups,
                subgroups = subgroups,
                samples = colnames(data)
            )
    } else {
        df <-
            data.frame(mean = mean,
                       groups = groups,
                       samples = colnames(data))
    }
    message("==================== DATA Summary ====================")
    data.summary <- ddply(
        df,
        .(groups),
        summarize,
        Mean = mean(mean),
        Median = median(mean),
        Max = max(mean),
        Min = min(mean)
    )
    print(data.summary)
    message("==================== END DATA Summary ====================")

    groups <- unique(df$groups)
    mat.pvalue <- matrix(
        ncol = length(groups),
        nrow = length(groups),
        dimnames = list(groups, groups)
    )

    if (length(groups) > 1) {
        comb2by2 <- t(combn(unique(df$groups), 2))

        for (i in 1:nrow(comb2by2)) {
            try({
                aux <- t.test(mean ~ groups,
                              data = subset(df, subset = df$groups %in% comb2by2[i, ]))$p.value

                mat.pvalue[comb2by2[i, 1], comb2by2[i, 2]] <- aux
                mat.pvalue[comb2by2[i, 2], comb2by2[i, 1]] <- aux
            },
            silent = TRUE)
        }
        message("==================== T test results ====================")
        print(mat.pvalue)
        message("==================== END T test results ====================")

    }
    if (print.pvalue & length(unique(df$groups)) == 2) {
        pvalue <- t.test(mean ~ groups, data = df)$p.value
    } else {
        print.pvalue <- FALSE
    }
    # Plot for methylation analysis Axis x: LGm clusters Axis y:
    # mean methylation
    label.add.n <- function(x) {
        paste0(x, " (n = ",
               nrow(subset(df, subset = (
                   df$groups == x
               ))), ")")
    }
    if (is.null(group.legend)) {
        group.legend <- groupCol
    }
    if (is.null(subgroup.legend)) {
        subgroup.legend <- subgroupCol
    }

    if (missing(sort)) {
        if (missing(order)) {
            x <- factor(df$groups)
        } else {
            x <- factor(df$groups, levels = order)
        }
    } else if (sort == "mean.asc") {
        x <- reorder(df$groups, df$mean, FUN = "mean")
    } else  if (sort == "mean.desc") {
        x <- reorder(df$groups, -df$mean, FUN = "mean")
    } else if (sort == "median.asc") {
        x <- reorder(df$groups, df$mean, FUN = "median")
    } else if (sort == "median.desc") {
        x <- reorder(df$groups, -df$mean, FUN = "median")
    }
    x <- as.character(x)
    if (is.null(labels)) {
        labels <- unique(x)
        labels <- sapply(labels, label.add.n)
    }

    if (is.null(color)) {
        color <- rainbow(length(labels))
        color <-
            color[(match(unique(x), unique(as.character(df$groups))))]
    }
    print(x)
    print(df$groups)
    print(color)
    p <- ggplot(df, aes(x, df$mean),
                environment = .e) +
        geom_boxplot(aes(fill = x),
                     notchwidth = 0.25,
                     outlier.shape = NA)

    if (plot.jitter) {
        if (!is.null(subgroupCol)) {
            p <- p + geom_jitter(
                aes(shape = subgroups,
                    size =  subgroups),
                position = position_jitter(width = 0.1),
                size = jitter.size
            )
        } else {
            p <- p + geom_jitter(position = position_jitter(width = 0.1),
                                 size = jitter.size)
        }
    }
    if (add.axis.x.text) {
        axis.text.x <- element_text(angle = axis.text.x.angle,
                                    vjust = 0.5)
    } else {
        axis.text.x <-  element_blank()
    }
    p <- p + scale_fill_manual(
        values = color,
        labels = labels,
        name = group.legend
    )
    p <- p + scale_x_discrete(limits = levels(x))
    p <- p + ylab(ylab) + xlab(xlab) + labs(title = title) +
        labs(shape = subgroup.legend, color = group.legend) +
        theme_minimal() +
        theme(
            axis.text.x = axis.text.x,
            plot.title = element_text(face = "bold", hjust = 0.5),
            legend.position = legend.position,
            legend.key = element_rect(colour = 'white')
        ) +
        guides(
            fill = guide_legend(
                ncol = legend.ncols,
                title.position = legend.title.position,
                title.hjust = 0.5
            )
        )

    if (!is.null(shapes)) {
        p <- p + scale_shape_manual(values = shapes)
    }

    if (print.pvalue) {
        p <- p + annotate(
            "text",
            x = -Inf,
            y = -Inf,
            hjust = -0.1,
            vjust = -1.0,
            size = 5,
            label = paste0("P-value = ",
                           format(
                               pvalue, scientific = TRUE,
                               digits = 2
                           ))
        )
    }
    if (!is.null(y.limits)) {
        p <- p + expand_limits(y = y.limits)
    }

    # saving box plot to analyse it
    if (!is.null(filename)) {
        ggsave(
            p,
            filename = filename,
            width = width,
            height = height,
            dpi = dpi
        )
        message(paste("Plot saved in: ", file.path(getwd(), filename)))
    } else {
        return(p)
    }
}

#' @title Calculate pvalues
#' @description Calculate pvalues using wilcoxon test
#' @details
#'    Verify if the data is significant between two groups. For the methylation
#'    we search for probes that have a difference in the mean methylation and
#'    also a significant value.
#'    Input: A SummarizedExperiment object that will be used to
#'    compared two groups with wilcoxon test, a boolean value to do a
#'    paired or non-paired test
#'    Output: p-values (non-adj/adj) histograms, p-values (non-adj/adj)
#' @param data  SummarizedExperiment obtained from the TCGAPrepare
#' @param groupCol  Columns with the groups inside the SummarizedExperiment
#'  object. (This will be obtained by the function colData(data))
#' @param group1 In case our object has more than 2 groups, you should set the
#'  groups
#' @param group2 In case our object has more than 2 groups, you should set the
#'  groups
#' @param paired  Do a paired wilcoxon test? Default: True
#' @param adj.method P-value adjustment method. Default:"BH" Benjamini-Hochberg
#' @param alternative wilcoxon test alternative
#' @param cores Number of cores to be used
#' @return Data frame with cols p values/p values adjusted
#' @import graphics
#' @importFrom grDevices png dev.off pdf
#' @import stats
#' @importFrom SummarizedExperiment colData rowRanges rowRanges<- colData<-
#' @return Data frame with two cols
#'         p-values/p-values adjusted
#' @examples
#' nrows <- 200; ncols <- 20
#'  counts <- matrix(runif(nrows * ncols, 1, 1e4), nrows,
#'            dimnames = list(paste0("cg",1:200),LETTERS[1:20]))
#' rowRanges <- GenomicRanges::GRanges(rep(c("chr1", "chr2"), c(50, 150)),
#'                    IRanges::IRanges(floor(runif(200, 1e5, 1e6)), width=100),
#'                     strand=sample(c("+", "-"), 200, TRUE),
#'                     feature_id=sprintf("ID%03d", 1:200))
#' colData <- S4Vectors::DataFrame(Treatment=rep(c("ChIP", "Input"), 10),
#'                     row.names=LETTERS[1:20],
#'                     group=rep(c("group1","group2"),c(10,10)))
#' data <- SummarizedExperiment::SummarizedExperiment(
#'          assays=S4Vectors::SimpleList(counts=counts),
#'          rowRanges=rowRanges,
#'          colData=colData)
#' results <- TCGAbiolinks:::dmc.non.parametric.se(data,"group")
#' @importFrom plyr adply
#' @importFrom stats wilcox.test
#' @keywords internal
dmc.non.parametric.se <- function(
        data,
        groupCol = NULL,
        group1 = NULL,
        group2 = NULL,
        paired = FALSE,
        adj.method = "BH",
        alternative = "two.sided",
        cores = 1
) {

    if (is.null(groupCol)) {
        message("Please, set the groupCol parameter")
        return(NULL)
    }

    # Can we define group1 and group2 automatically
    if(is.null(group1) & is.null(group2)){
        if(length(unique(colData(data)[, groupCol])) == 2){
            message("Defining groups")
            group1 <- unique(colData(data)[, groupCol])[1]
            group2 <- unique(colData(data)[, groupCol])[2]
        } else {
            message("Please, set the group1 and group2 parameters")
            return(NULL)
        }
    }

    message("Calculating the p-values of each probe...")
    # Apply Wilcoxon test in order to calculate the p-values
    idx1 <- which(colData(data)[, groupCol] == group1)
    idx2 <- which(colData(data)[, groupCol] == group2)

    if (!is.factor(colData(data)[, groupCol])) {
        colData(data)[, groupCol] <- factor(colData(data)[, groupCol])
    }
    m <- assay(data)
    df <- dmc.non.parametric(
        matrix = m,
        idx1 = idx1,
        idx2 =  idx2,
        paired = paired,
        adj.method = adj.method,
        alternative =  alternative,
        cores =  cores
    )

    group1.col <- gsub("[[:punct:]]| ", ".", group1)
    group2.col <- gsub("[[:punct:]]| ", ".", group2)
    colp <- paste("p.value",  group1.col,  group2.col, sep = ".")
    coladj <- paste("p.value.adj", group1.col,  group2.col, sep = ".")
    coldiffmean <- paste("mean", group1.col, "minus.mean", group2.col, sep = ".")
    colmeang1 <- paste("mean", group1.col, sep = ".")
    colmeang2 <- paste("mean", group2.col, sep = ".")

    colnames(df) <- c(colmeang1, colmeang2, coldiffmean, colp, coladj)
    return(df)
}

#' @title Perform non-parametrix wilcoxon test
#' @description Perform non-parametrix wilcoxon test
#' @param matrix  A matrix
#' @param idx1  Index columns group1
#' @param idx2  Index columns group2
#' @param paired  Do a paired wilcoxon test? Default: True
#' @param adj.method P-value adjustment method. Default:"BH" Benjamini-Hochberg
#' @param alternative wilcoxon test alternative
#' @param cores Number of cores to be used
#' @return Data frame with p-values and diff mean
#' @import stats
#' @examples
#'  nrows <- 200; ncols <- 20
#'  counts <- matrix(
#'    runif(nrows * ncols, 1, 1e4), nrows,
#'    dimnames = list(paste0("cg",1:200),paste0("S",1:20))
#'  )
#'  TCGAbiolinks:::dmc.non.parametric(counts,1:10,11:20)
dmc.non.parametric <-  function(
        matrix,
        idx1 = NULL,
        idx2 = NULL,
        paired = FALSE,
        adj.method = "BH",
        alternative = "two.sided",
        cores = 1)
{
    parallel <- set_cores(cores)

    p.value <- plyr::adply(
        .data = matrix,
        .margins =  1,
        .fun = function(x) {
            suppressMessages({
                suppressWarnings({
                wilcox.test(
                    x[idx1],
                    x[idx2],
                    paired = paired,
                    alternative = alternative)$p.value
            })
            })
    }, .progress = "time", .parallel = parallel)

    p.value <- p.value[, 2]
    p.value.adj <- p.adjust(p.value, method = adj.method)
    mean.g1 <- rowMeans(matrix[, idx1, drop = FALSE], na.rm = TRUE)
    mean.g2 <- rowMeans(matrix[, idx2, drop = FALSE], na.rm = TRUE)
    mean.g1_minus_mean.g2 <- mean.g1 - mean.g2

    return(
        data.frame(
            mean.g1,
            mean.g2,
            mean.g1_minus_mean.g2,
            p.value,
            p.value.adj
        )
    )
}



#' @title Differentially methylated regions Analysis
#' @description
#'   This function will search for differentially methylated CpG sites,
#'   which are regarded as possible functional regions involved
#'   in gene transcriptional regulation.
#'
#'   In order to find these regions we use the beta-values (methylation values
#'   ranging from 0.0 to 1.0) to compare two groups.
#'
#'   Firstly, it calculates the difference between the mean methylation of each
#'   group for each probes. Secondly, it calculates the p-value using the
#'   wilcoxon test using the Benjamini-Hochberg adjustment method.
#'   The default parameters will require a minimum absolute beta values delta
#'   of 0.2 and a false discovery rate (FDR)-adjusted Wilcoxon rank-sum P-value
#'   of < 0.01 for the difference.
#'
#'   After these analysis, we save a volcano plot (x-axis:diff mean methylation,
#'   y-axis: significance) that will help the user identify the differentially
#'   methylated CpG sites and return the object with the calculus in the rowRanges.
#'
#'   If the calculus already exists in the object it will not recalculated.
#'   You should set overwrite parameter to TRUE to force it, or remove the
#'   columns with the results from the object.
#'
#' @param data  SummarizedExperiment obtained from the TCGAPrepare
#' @param groupCol  Columns with the groups inside the SummarizedExperiment
#'  object. (This will be obtained by the function colData(data))
#' @param group1 In case our object has more than 2 groups, you should set
#' the name of the group
#' @param group2 In case our object has more than 2 groups, you should set
#' the name of the group
#' @param plot.filename Filename. Default: volcano.pdf, volcano.svg, volcano.png. If set to FALSE, there will be no plot.
#' @param legend Legend title
#' @param color vector of colors to be used in graph
#' @param title main title. If not specified it will be
#' "Volcano plot (group1 vs group2)
#' @param ylab y axis text
#' @param xlab x axis text
#' @param xlim x limits to cut image
#' @param ylim y limits to cut image
#' @param label vector of labels to be used in the figure.
#' Example: c("Not Significant","Hypermethylated in group1",
#' "Hypomethylated in group1"))
#' @param p.cut p values threshold. Default: 0.01
#' @param probe.names is probe.names
#' @param diffmean.cut diffmean threshold. Default: 0.2
#' @param adj.method Adjusted method for the p-value calculation
#' @param paired Wilcoxon paired parameter. Default: FALSE
#' @param alternative wilcoxon test alternative
#' @param save Save object with results? Default: TRUE
#' @param save.directory Directory to save the files. Default: working directory
#' @param filename Name of the file to save the object.
#' @param cores Number of cores to be used in the non-parametric test
#' Default = groupCol.group1.group2.rda
#' @import ggplot2
#' @importFrom SummarizedExperiment colData rowRanges assay rowRanges<- values<- SummarizedExperiment metadata<-
#' @importFrom S4Vectors metadata
#' @importFrom dplyr data_frame
#' @importFrom methods as
#' @import readr
#' @import utils
#' @export
#' @return Volcano plot saved and the given data with the results
#' (diffmean.group1.group2,p.value.group1.group2,
#' p.value.adj.group1.group2,status.group1.group2)
#' in the rowRanges where group1 and group2 are the names of the groups
#' @examples
#' nrows <- 200; ncols <- 20
#'  counts <- matrix(
#'    runif(nrows * ncols, 1, 1e4), nrows,
#'    dimnames = list(paste0("cg",1:200),paste0("S",1:20))
#' )
#' rowRanges <- GenomicRanges::GRanges(
#'   rep(c("chr1", "chr2"), c(50, 150)),
#'   IRanges::IRanges(floor(runif(200, 1e5, 1e6)), width = 100),
#'   strand = sample(c("+", "-"), 200, TRUE),
#'   feature_id = sprintf("ID%03d", 1:200)
#' )
#' names(rowRanges) <-  paste0("cg",1:200)
#' colData <- S4Vectors::DataFrame(
#'   Treatment = rep(c("ChIP", "Input"), 5),
#'   row.names = paste0("S",1:20),
#'   group = rep(c("group1","group2"),c(10,10))
#' )
#'data <- SummarizedExperiment::SummarizedExperiment(
#'          assays=S4Vectors::SimpleList(counts=counts),
#'          rowRanges = rowRanges,
#'          colData = colData
#' )
#' SummarizedExperiment::colData(data)$group <- c(rep("group 1",ncol(data)/2),
#'                          rep("group 2",ncol(data)/2))
#' hypo.hyper <- TCGAanalyze_DMC(data, p.cut = 0.85,"group","group 1","group 2")
#' SummarizedExperiment::colData(data)$group2 <- c(rep("group_1",ncol(data)/2),
#'                          rep("group_2",ncol(data)/2))
#' hypo.hyper <- TCGAanalyze_DMC(
#'   data = data,
#'   p.cut = 0.85,
#'   groupCol = "group2",
#'   group1 = "group_1",
#'   group2 = "group_2"
#' )
TCGAanalyze_DMC <- function(
        data,
        groupCol = NULL,
        group1 = NULL,
        group2 = NULL,
        alternative = "two.sided",
        diffmean.cut = 0.2,
        paired = FALSE,
        adj.method = "BH",
        plot.filename = "methylation_volcano.pdf",
        ylab =  expression(paste(-Log[10], " (FDR corrected P-values)")),
        xlab =  expression(paste("DNA Methylation difference (", beta, "-values)")),
        title = NULL,
        legend = "Legend",
        color = c("black",  "red", "darkgreen"),
        label = NULL,
        xlim = NULL,
        ylim = NULL,
        p.cut = 0.01,
        probe.names = FALSE,
        cores = 1,
        save = TRUE,
        save.directory = ".",
        filename = NULL)
{
    names(color) <- as.character(1:3)
    # Check if object is a summarized Experiment
    if (!is(data, "RangedSummarizedExperiment")) {
        stop(
            paste0(
                "Sorry, but I'm expecting a Summarized Experiment object, but I got a: ",
                class(data)
            )
        )
    }

    # Check if object has NAs for all samples
    if (any(rowSums(!is.na(assay(data))) == 0)) {
        stop(
            paste0(
                "Sorry, but we found some probes with NA ",
                "for all samples in your data, please either ",
                "remove/or replace them"
            )
        )
    }

    if (is.null(groupCol)) {
        message("Please, set the groupCol parameter")
        return(NULL)
    }

    if (!(groupCol %in% colnames(colData(data)))) {
        stop(paste0("column ", groupCol, " not found in the object"))
    }

    if (length(unique(colData(data)[, groupCol])) != 2 &&
        is.null(group1) && is.null(group2)) {
        message("Please, set the group1 and group2 parameters")
        return(NULL)
    } else if (length(unique(colData(data)[, groupCol])) == 2  &&
               (is.null(group1) || is.null(group2)))
    {
        group1 <- unique(colData(data)[, groupCol])[1]
        group2 <- unique(colData(data)[, groupCol])[2]
    } else {
        message(paste0("Group1:", group1))
        message(paste0("Group2:", group2))
    }

    # Check if groups has at least one sample
    if (!any(colData(data)[, groupCol] == group1, na.rm = TRUE)) {
        stop(paste0("Sorry, but ", group1, " has no samples"))
    }
    if (!any(colData(data)[, groupCol] == group2, na.rm = TRUE)) {
        stop(paste0("Sorry, but ", group2, " has no samples"))
    }

    results <- dmc.non.parametric.se(
        data = data,
        groupCol = groupCol,
        group1 = group1,
        group2 = group2,
        paired = paired,
        adj.method = adj.method,
        alternative = alternative,
        cores = cores
    )

    # defining title and label if not specified by the user
    if (is.null(title)) {
        title <- paste("Volcano plot", "(", group1, "vs", group2, ")")
    }

    if (is.null(label)) {
        label <- c(
            "Not Significant",
            "Hypermethylated",
            "Hypomethylated"
        )
        label[2:3] <-  paste(label[2:3], "in", group1)
    }

    group1.col <- gsub("[[:punct:]]| ", ".", group1)
    group2.col <- gsub("[[:punct:]]| ", ".", group2)

    # get significant data
    results$status <- "Not Significant"
    sig <- which(results[, grep("p.value.adj", colnames(results))] < p.cut)
    hyper <- which(results[, grep("minus", colnames(results))] > diffmean.cut)
    hypo <- which(results[, grep("minus", colnames(results))] < -diffmean.cut)
    hyper.sig <- intersect(hyper, sig)
    hypo.sig <- intersect(hypo, sig)

    if (length(hyper.sig))
        results[hyper.sig, "status"] <- paste0("Hypermethylated in ", group1)

    if (length(hypo.sig))
        results[hypo.sig, "status"] <-  paste0("Hypomethylated in ", group1)

    # Plot a volcano plot
    names <- NULL
    if (probe.names)
        names <- rownames(results)

    if (!is.null(plot.filename)) {
        message("Saving volcano plot as: ", plot.filename)
        TCGAVisualize_volcano(
            x = results[, grep("minus", colnames(results))],
            y = results[, grep("p.value.adj", colnames(results))],
            filename = plot.filename,
            ylab =  ylab,
            xlab = xlab,
            title = title,
            legend = legend,
            label = label,
            names = names,
            x.cut = diffmean.cut,
            y.cut = p.cut
        )
    }

    if (save) {
        # saving results into a csv file
        csv <- paste0(
            paste(
                "DMR_results",
                gsub("_", ".", groupCol),
                group1.col,
                group2.col,
                "pcut",
                p.cut,
                "meancut",
                diffmean.cut,
                sep = "_"
            ),
            ".csv"
        )
        dir.create(save.directory,
                   showWarnings = FALSE,
                   recursive = TRUE)
        csv <- file.path(save.directory, csv)
        message(paste0("Saving the results also in a csv file: "), csv)
        write.csv(results, csv)
    }
    return(results)
}

#' @title Create starburst plot
#'
#' @description
#'   Create Starburst plot for comparison of DNA methylation and gene expression.
#'    The log10 (FDR-corrected P value) is plotted for beta value for DNA
#'    methylation (x axis) and gene expression (y axis) for each gene.
#'
#'    The black dashed line shows the FDR-adjusted P value of 0.01.
#'
#'    You can set names to TRUE to get the names of the significant genes.
#'
#'    Candidate biologically significant genes will be circled in the plot.
#'
#'    Candidate biologically significant are the genes that respect the
#'    expression (logFC.cut), DNA methylation (diffmean.cut) and
#'    significance thresholds (exp.p.cut, met.p.cut)
#'
#' @details
#'    Input: data with gene expression/methylation expression
#'    Output: starburst plot
#'
#' @param met A SummarizedExperiment with methylation data obtained from the
#' TCGAPrepare or Data frame from DMR_results file. Expected colData columns: diffmean,  p.value.adj  and p.value
#' Execute volcanoPlot function in order to obtain these values for the object.
#' @param exp Object obtained by DEArnaSEQ function
#' @param filename The filename of the file (it can be pdf, svg, png, etc)
#' @param met.platform DNA methylation platform  "Illumina Human Methylation 450",
#' "Illumina Human Methylation 27", "Illumina Methylation Epic"
#' @param genome Genome of reference ("hg38" or "hg19") used to identify nearest probes TSS
#' @param legend legend title
#' @param color vector of colors to be used in graph
#' @param label vector of labels to be used in graph
#' @param title main title
#' @param names Add the names of the significant genes? Default: FALSE
#' @param names.fill Names should be filled in a color box?  Default: TRUE
#' @param ylab y axis text
#' @param xlab x axis text
#' @param xlim x limits to cut image
#' @param ylim y limits to cut image
#' @param met.p.cut methylation p value cut-off
#' @param exp.p.cut expression p value cut-off
#' @param diffmean.cut If set, the probes with diffmean higher
#' than methylation cut-off will be
#'  highlighted in the plot. And the data frame return will be subseted.
#' @param logFC.cut If set, the probes with expression fold
#' change higher than methylation cut-off will be
#'  highlighted in the plot. And the data frame return will be subseted.
#' @param group1 The name of the group 1
#' Obs: Column p.value.adj.group1.group2 should exist
#' @param group2 The name of the group 2.
#' Obs: Column p.value.adj.group1.group2 should exist
#' @param return.plot If true only plot object will be returned (pdf will not be created)
#' @param height Figure height
#' @param width Figure width
#' @param dpi Figure dpi
#' @import ggplot2
#' @importFrom GenomicRanges distanceToNearest
#' @importFrom SummarizedExperiment rowRanges rowRanges<- values<-
#' @importFrom S4Vectors subjectHits queryHits
#' @export
#' @return Save a starburst plot
#' @examples
#' \dontrun{
#' library(SummarizedExperiment)
#' met <- TCGAbiolinks:::getMetPlatInfo(
#'    genome = "hg38",
#'    platform = "Illumina Human Methylation 27"
#'  )
#' values(met) <- NULL
#' met$probeID <- names(met)
#' nrows <- length(met); ncols <- 20
#' counts <- matrix(runif(nrows * ncols, 1, 1e4), nrows)
#' colData <- S4Vectors::DataFrame(
#'   Treatment = rep(c("ChIP", "Input"), 5),
#'   row.names = LETTERS[1:20],
#'   group = rep(c("group1","group2"),c(10,10))
#' )
#' met <- SummarizedExperiment::SummarizedExperiment(
#'          assays = S4Vectors::SimpleList(counts=counts),
#'          rowRanges = met,
#'          colData = colData
#' )
#' rowRanges(met)$diffmean.g1.g2 <- c(runif(nrows, -0.1, 0.1))
#' rowRanges(met)$diffmean.g2.g1 <- -1*(rowRanges(met)$diffmean.g1.g2)
#' rowRanges(met)$p.value.g1.g2 <- c(runif(nrows, 0, 1))
#' rowRanges(met)$p.value.adj.g1.g2 <- c(runif(nrows, 0, 1))
#' exp <- TCGAbiolinks:::get.GRCh.bioMart("hg38")
#' exp$logFC <- runif(nrow(exp), -5, 5)
#' exp$FDR <- runif(nrow(exp), 0.01, 1)
#'
#' result <- TCGAvisualize_starburst(
#'   met,
#'   exp,
#'   exp.p.cut = 0.05,
#'   met.p.cut = 0.05,
#'   logFC.cut = 2,
#'   group1 = "g1",
#'   group2 = "g2",
#'   genome = "hg38",
#'   met.platform = "27k",
#'   diffmean.cut = 0.0,
#'   names  = TRUE
#' )
#' }
TCGAvisualize_starburst <- function(
        met,
        exp,
        group1 = NULL,
        group2 = NULL,
        exp.p.cut = 0.01,
        met.p.cut = 0.01,
        diffmean.cut = 0,
        logFC.cut = 0,
        met.platform = c(
            "Illumina Human Methylation 450",
            "Illumina Human Methylation 27",
            "Illumina Methylation Epic"
        ),
        genome,
        names = FALSE,
        names.fill = TRUE,
        filename = "starburst.png",
        return.plot = FALSE,
        ylab = expression(atop("Gene Expression",
                               paste(-Log[10],
                                     " (FDR corrected P values)"))),
        xlab = expression(atop("DNA Methylation",
                               paste(-Log[10],
                                     " (FDR corrected P values)"))),
        title = "Starburst Plot",
        legend = "DNA Methylation/Expression Relation",
        color = NULL,
        label = c(
            "Not Significant",
            "Up regulated & Hypo methylated",
            "Down regulated & Hypo methylated",
            "hypo methylated",
            "hyper methylated",
            "Up regulated",
            "Down regulated",
            "Up regulated & Hyper methylated",
            "Down regulated & Hyper methylated"
        ),
        xlim = NULL,
        ylim = NULL,
        height = 10,
        width = 20,
        dpi = 600
) {
    if (missing(genome)) stop("Please set genome (hg19 or hg38)")
    if (missing(met.platform)) stop("Please set met.platform (EPIC, 450k or 27k)")

    met.platform <- match.arg(met.platform)

    .e <- environment()

    group1.col <- gsub("[[:punct:]]| ", ".", group1)
    group2.col <- gsub("[[:punct:]]| ", ".", group2)

    if (title == "Starburst Plot") {
        if (diffmean.cut != 0 & logFC.cut == 0) {
            title <- bquote(atop("Starburst Plot", scriptstyle((
                list(
                    Delta ~ bar(beta) >= .(diffmean.cut),
                    FDR[expression]  <=  .(exp.p.cut),
                    FDR[DNAmethylation]  <=  .(met.p.cut)
                )
            ))))
        } else if (logFC.cut != 0 & diffmean.cut == 0) {
            title <- bquote(atop("Starburst Plot", scriptstyle((
                list(
                    group("|", logFC, "|")  >=  .(logFC.cut),
                    FDR[expression]  <=  .(exp.p.cut),
                    FDR[DNAmethylation]  <=  .(met.p.cut)
                )
            ))))
        } else if (logFC.cut != 0 & diffmean.cut != 0) {
            title <- bquote(atop("Starburst Plot", scriptstyle((
                list(
                    Delta,
                    bar(beta)  >=  .(diffmean.cut),
                    group("|", logFC, "|")  >=  .(logFC.cut),
                    FDR[expression]  <=  .(exp.p.cut),
                    FDR[DNAmethylation]  <=  .(met.p.cut)
                )
            ))))
        }
    }

    if (is.null(color))
        color <- c(
            "#000000",
            "#E69F00",
            "#56B4E9",
            "#009E73",
            "red",
            "#0072B2",
            "#D55E00",
            "#CC79A7",
            "purple"
        )
    names(color) <- as.character(1:9)
    names(label) <- as.character(1:9)
    names.color <- color
    names(names.color) <- label

    if (is.null(group1) || is.null(group2)) {
        message("Please, set the group1 and group2 parameters")
        return(NULL)
    }

    if (class(met) == class(as(SummarizedExperiment(), "RangedSummarizedExperiment"))) {
        met <- SummarizedExperiment::values(met)
    }

    # Preparing methylation
    pcol <-gsub("[[:punct:]]| ", ".", paste("p.value.adj", group1, group2, sep = "."))

    if (!(pcol %in%  colnames(met))) {
        pcol <-gsub("[[:punct:]]| ",  ".",  paste("p.value.adj", group2, group1, sep = "."))
    }
    if (!(pcol %in%  colnames(met))) {
        stop("Error! p-values adjusted not found. Please, run TCGAanalyze_DMR")
    }

    # Transform factor coluns to characters
    fctr.cols <- sapply(exp, is.factor)
    exp[, fctr.cols] <- sapply(exp[, fctr.cols], as.character)
    # Methylation matrix and expression matrix should have the same name column for merge
    idx <- grep("ENSG", exp[1, ])
    if (length(idx) > 0) {
        colnames(exp)[idx] <- "ensembl_gene_id"
    } else {
        # it is in the row names ?
        if (grepl("ENSG", rownames(exp)[1])) {
            exp$ensembl_gene_id <- rownames(exp)
        } else {
            stop("rownames or first column must be gene ensembl IDs")
        }
    }

    if (!"probeID" %in% colnames(met)){
        met$probeID <- met$Composite.Element.REF
    }

    # Check if gene symbol columns exists
    if (!"ensembl_gene_id" %in% colnames(exp)) {
        stop("Column ensembl_gene_id was not found")
    }

    # Correlate gene expression with DNA methylation levels
    # Step 1: identify nearest TSS for each probe
    # Step 2: create a table with probe, gene, transcript, distance.TSS and merge with
    #         the met (by probe name) and gene expression (by gene name) results
    message("o Fetching auxiliary information")
    message("oo Fetching probes genomic information")
    met.info <- getMetPlatInfo(genome = genome, platform = met.platform)
    cpg.target.gene <- data.frame("probeID" = names(met.info),"gene_name" = met.info$gene_HGNC) %>%
        tidyr::separate_rows(gene_name,sep = ";") %>% na.omit()

    message("o Mapping results information")
    volcano <- cpg.target.gene %>%
        dplyr::inner_join(exp[,c("gene_name","logFC","FDR")], by = "gene_name") %>%
        dplyr::inner_join(met %>% tibble::as_tibble(), by = "probeID")

    volcano$ID <- paste(volcano$gene_name, volcano$probeID, sep = ".")
    volcano <- volcano[!is.na(volcano$FDR), ] # Some genes have no values
    # Preparing gene expression
    volcano$geFDR <- -1 * log10(volcano$FDR)
    volcano$geFDR2 <- volcano$geFDR


    volcano[volcano$logFC > 0, "geFDR2"] <- -1 * volcano[volcano$logFC > 0, "geFDR"]

    # Preparing DNA methylation
    diffcol <- gsub(
        "[[:punct:]]| ",
        ".",
        paste("diffmean", group1, group2, sep = ".")
    )
    volcano$meFDR <- -1 * log10(volcano[, pcol,drop =T])
    volcano$meFDR2 <- volcano$meFDR
    idx <- volcano[, diffcol] > 0
    idx[is.na(idx)] <- FALSE # handling NAs
    volcano[idx, "meFDR2"] <- -1 * volcano[idx, "meFDR"]

    label[2:9] <-  paste(label[2:9], "in", group2)

    # subseting by regulation (geFDR) and methylation level
    # (meFDR) down regulated up regulated lowerthr
    # |||||||||||||||| upperthr hypomethylated hypermethylated
    met.lowerthr <- log10(met.p.cut)
    met.upperthr <- (-met.lowerthr)

    exp.lowerthr <- log10(exp.p.cut)
    exp.upperthr <- (-exp.lowerthr)
    volcano <- suppressWarnings(tibble::as.tibble(volcano))

    # Group 2:up regulated and hypomethylated
    a <- volcano %>% dplyr::filter(
        geFDR2 > exp.upperthr &
            logFC > logFC.cut &
            meFDR2 < met.lowerthr &
            abs(!!as.name(diffcol)) > diffmean.cut
    )

    # Group 3: down regulated and hypomethylated
    b <- volcano %>% dplyr::filter(
        geFDR2 < exp.lowerthr &
            logFC > logFC.cut &
            meFDR2 < met.lowerthr &
            abs(!!as.name(diffcol)) > diffmean.cut
    )


    # Group 4: hypomethylated
    c <- volcano %>% dplyr::filter(
        geFDR2 > exp.lowerthr &
            geFDR2 < exp.upperthr &
            meFDR2 < met.lowerthr &
            abs(!!as.name(diffcol)) > diffmean.cut
    )

    # Group 5: hypermethylated
    d <- volcano %>% dplyr::filter(
        geFDR2 > exp.lowerthr &
            geFDR2 < exp.upperthr &
            meFDR2 > met.upperthr &
            abs(!!as.name(diffcol)) > diffmean.cut
    )

    # Group 6: upregulated
    e <- volcano %>% dplyr::filter(
        geFDR2 > exp.upperthr &
            meFDR2 < met.upperthr &
            meFDR2 > met.lowerthr &
            logFC > logFC.cut
    )

    # Group 7: downregulated
    f <- volcano %>% dplyr::filter(
        geFDR2 < exp.lowerthr &
            abs(logFC) > logFC.cut &
            meFDR2 < met.upperthr &
            meFDR2 > met.lowerthr
    )

    # Group 8: upregulated and hypermethylated
    g <- volcano %>% dplyr::filter(
        geFDR2 > exp.upperthr &
            logFC > logFC.cut &
            meFDR2 > met.upperthr &
            abs(!!as.name(diffcol)) > diffmean.cut
    )

    # Group 9: downregulated and hypermethylated in group 2
    h <-  volcano %>% dplyr::filter(
        geFDR2 < exp.lowerthr &
            logFC > logFC.cut &
            meFDR2 > met.upperthr &
            abs(!!as.name(diffcol)) > diffmean.cut
    )


    groups <- as.character(seq(2, 9))

    # return methylation < 0, expression > 0
    volcano$starburst.status  <-  "Not Significant"
    volcano$shape <- "1"
    volcano$threshold.starburst <- "1"
    volcano$threshold.size <- "1"

    state <- c(
        "Up regulated & Hypo methylated",
        # a
        "Down regulated & Hypo methylated",
        # b
        "hypo methylated",
        # c
        "hyper methylated",
        # d
        "Up regulated",
        # e
        "Down regulated",
        # f
        "Up regulated & Hyper methylated",
        # g
        "Down regulated & Hyper methylated"
    ) # h

    s <- list(a, b, c, d, e, f, g, h)
    for (i in seq_along(s)) {
        idx <- s[[i]]$ID
        if (length(idx) > 0) {
            volcano[volcano$ID %in% idx, "threshold.starburst"] <- groups[i]
            volcano[volcano$ID %in% idx, "starburst.status"] <-
                state[i]
        }
    }

    s <- list(a, b, g, h)
    significant <- NULL
    for (i in seq_along(s)) {
        idx <- s[[i]]$ID
        if (length(idx) > 0) {
            significant <-  rbind(significant, volcano[volcano$ID %in% idx, ])
        }
    }
    message("o Plotting figure")
    volcano.aux <- volcano # we need an auxiliry data if dats is returned
    ## starburst plot
    p <- ggplot(
        data = volcano.aux,
        environment = .e,
        aes(
            x = meFDR2,
            y = geFDR2,
            colour = threshold.starburst
        )
    ) + geom_point()

    if (names == TRUE & !is.null(significant)) {
        check_package("ggrepel")
        message("oo Adding names to genes")
        if (names.fill) {
            p <- p + ggrepel::geom_label_repel(
                data = significant,
                aes(
                    x = meFDR2,
                    y =  geFDR2,
                    label = gene_name,
                    fill = as.factor(starburst.status)
                ),
                size = 4,
                show.legend = FALSE,
                fontface = 'bold',
                color = 'black',
                box.padding = unit(0.35, "lines"),
                point.padding = unit(0.3, "lines")
            ) + scale_fill_manual(values = names.color)
        }  else {
            p <- p + ggrepel::geom_text_repel(
                data = significant,
                aes(
                    x = meFDR2,
                    y =  geFDR2,
                    label = gene_name,
                    fill = starburst.status
                ),
                size = 4,
                show.legend = FALSE,
                fontface = 'bold',
                color = 'black',
                point.padding = unit(0.3, "lines"),
                box.padding = unit(0.5, 'lines')
            )
        }
    }


    if (!is.null(xlim)) {
        p <- p + xlim(xlim)
    }
    if (!is.null(ylim)) {
        p <- p + ylim(ylim)
    }
    p <- p + ggtitle(title) + ylab(ylab) + xlab(xlab) + guides(size = FALSE)
    p <- p + scale_color_manual(values = color, labels = label, name = legend) +
        guides(col = guide_legend(nrow = 3))

    p <- p + geom_hline(aes(yintercept = exp.lowerthr),
                        colour = "black",
                        linetype = "dashed"
    ) +
        geom_hline(aes(yintercept = exp.upperthr),
                   colour = "black",
                   linetype = "dashed"
        ) +
        geom_vline(aes(xintercept = met.lowerthr),
                   colour = "black",
                   linetype = "dashed"
        ) +
        geom_vline(aes(xintercept = met.upperthr),
                   colour = "black",
                   linetype = "dashed"
        )  +
        theme_bw() +
        theme(
            panel.border = element_blank(),
            panel.grid.major = element_blank(),
            panel.grid.minor = element_blank(),
            axis.line.x = element_line(colour = "black"),
            axis.line.y = element_line(colour = "black"),
            legend.position = "top",
            legend.key = element_rect(colour = 'white'),
            plot.title = element_text(
                face = "bold",
                size = 16,
                hjust = 0.5
            ),
            legend.text = element_text(size = 14),
            legend.title = element_text(size = 14),
            axis.text = element_text(size = 14),
            axis.title.x = element_text(face = "bold", size = 14),
            axis.text.x = element_text(vjust = 0.5,
                                       size = 14),
            axis.title.y = element_text(face = "bold",
                                        size = 14),
            axis.text.y = element_text(size = 14)
        )
    if (!return.plot){
        message("Saving figure as ", filename)
        ggsave(
            filename = filename,
            width = width,
            height = height,
            dpi = dpi
        )
    }
    volcano$shape <- NULL
    volcano$threshold.starburst <- NULL
    volcano$threshold.size <- NULL

    volcano <- dplyr::filter(
        volcano,
        volcano$geFDR <= exp.lowerthr &
            volcano$meFDR <= met.lowerthr
    )

    if (diffmean.cut != 0) {
        volcano <-
            dplyr::filter(volcano, abs(volcano[, diffcol]) > diffmean.cut)
    }
    if (logFC.cut != 0) {
        volcano <- dplyr::filter(volcano, abs(volcano$logFC) >= logFC.cut)
    }

    message("o Saving results")
    message("oo Saving significant results as: starburst_results.csv")
    message(
        "oo It contains pair with changes both in the expression level of the nearest gene and  in the DNA methylation level"
    )
    readr::write_csv(x = volcano, file = "starburst_results.csv")

    if (return.plot) {
        return(list(plot = p, starburst = volcano))
    }

    return(volcano)
}


#' @title Get DNA methylation array metadata from SesameData
#' @noRd
#' @importFrom stringr str_c
getMetPlatInfo <- function(
        genome = c("hg38","hg19"),
        platform = c(
            "Illumina Human Methylation 450",
            "Illumina Human Methylation 27",
            "Illumina Methylation Epic"
        )
){
    genome <- match.arg(genome)
    arrayType <- match.arg(platform)

    check_package("sesameData")
    check_package("sesame")
    check_package("AnnotationHub")
    check_package("ExperimentHub")

    if(arrayType == "Illumina Human Methylation 450") arrayType <- "HM450"
    if(arrayType == "Illumina Human Methylation 27") arrayType <- "HM27"
    if(arrayType == "Illumina Methylation Epic") arrayType <- "EPIC"

    message("Accessing DNAm annotation from sesame package for: ", genome, " - ",arrayType)
    manifest <-  str_c(
        arrayType,
        ".",
        genome,
        ".manifest"
    )
    ehub <- ExperimentHub::ExperimentHub()
    query <- AnnotationHub::query(ehub, c("sesameData",manifest))
    query <- query[query$title == manifest,]
    ah_id <- query$ah_id[query$rdatadateadded == max(as.Date(query$rdatadateadded))]
    ehub[[ah_id]]
}

# @title .onAttach
# @description  Load required data into gloval enviroment
# @keywords internal
.onAttach <- function (libname, pkgname){

    if (!interactive() || stats::runif(1) > 0.1) return()
    welcome.message <- paste0(
        " =============================================================\n",
        " ______  ___  ____   ___                                        \n",
        "   ||   |    |      |   | |    o  __  |   o  _         __         \n",
        "   ||   |    | ___  |___| |__  | |  | |   | | | | |_/ |__         \n",
        "   ||   |___ |____| |   | |__| | |__| |__ | | |_| | \\  __|       \n",
        " ------------------------------------------------------------\n",
        " Query, download & analyze - GDC                  \n",
        " Version:",utils::packageVersion("TCGAbiolinks"),"\n",
        " ==============================================================\n"
    )
    packageStartupMessage(welcome.message)

}

#' @title Check GDC server status is OK
#' @description
#'   Check GDC server status using the api
#'   https://api.gdc.cancer.gov/status
#' @export
#' @importFrom jsonlite fromJSON
#' @examples
#' status <- isServeOK()
#' @return Return true if status is ok
isServeOK <- function(){
    tryCatch({
        status <- getGDCInfo()$status
        if(status != "OK") stop("GDC server down, try to use this package later")
    },error = function(e) stop("GDC server down, try to use this package later"))
    return(TRUE)
}

#' @title Check GDC server status
#' @description
#'   Check GDC server status using the api
#'   https://api.gdc.cancer.gov/status
#' @export
#' @importFrom jsonlite fromJSON
#' @examples
#' info <- getGDCInfo()
#' @return Return true all status
getGDCInfo <- function(){
    status <- fromJSON("https://api.gdc.cancer.gov/status",simplifyDataFrame = TRUE)
    return(status)
}

checkProjectInput <- function(project){

    projects <- getGDCprojects()

    if(missing(project)) {
        print(knitr::kable(projects[,c("id","name")]))
        stop("Please set a project argument from the column id above")
    }

    for(proj in project) {
        if( !(proj %in% projects$project_id)) {
            print(knitr::kable(projects[,c("id","name")]))
            stop("Please set a valid project argument from the column id above. Project ", proj, " was not found.")
        }
    }
}

checkDataTypeInput <- function(data.type){

    harmonized.data.type <- c(
        "Aggregated Somatic Mutation",
        "Aligned Reads",
        "Gene Expression Quantification",
        "Raw CGI Variant",
        "Methylation Beta Value",
        "Differential Gene Expression",
        "Splice Junction Quantification",
        "Protein Expression Quantification",
        "Annotated Somatic Mutation",
        "Raw Simple Somatic Mutation",
        "Masked Somatic Mutation",
        "Copy Number Segment",
        "Masked Intensities",
        "Allele-specific Copy Number Segment",
        "Masked Copy Number Segment",
        "Isoform Expression Quantification",
        "miRNA Expression Quantification",
        "Gene Level Copy Number",
        "Biospecimen Supplement",
        "Gene Level Copy Number Scores",
        "Protein Expression Quantification",
        "Clinical Supplement",
        "Single Cell Analysis",
        "Masked Somatic Mutation",
        "Slide Image"
    )

    if (!data.type %in% harmonized.data.type) {
        print(knitr::kable(as.data.frame(sort(harmonized.data.type))))
        stop("Please set a data.type argument from the column harmonized.data.type above")
    }
}

checkDataCategoriesInput <- function(project,data.category){

    for(proj in project){

        project.summary <- getProjectSummary(proj)
        if(missing(data.category)) {
            print(knitr::kable(project.summary$data_categories))
            stop("Please set a data.category argument from the column data_category above")
        }

        if(!(data.category %in% project.summary$data_categories$data_category)) {
            print(knitr::kable(project.summary$data_categories))
            stop("Please set a valid data.category argument from the column data_category above. We could not validade the data.category for project ", proj)
        }
    }
}

checkBarcodeDefinition <- function(definition){
    for(i in definition){
        if(!(i %in% getBarcodeDefinition()$tissue.definition)){
            print(knitr::kable(getBarcodeDefinition()))
            stop(i, " was not found. Please select a difinition from the table above ")
        }
    }
}

#' @title Retrieve all GDC projects
#' @description
#'   getGDCprojects uses the following api to get projects
#'   https://api.gdc.cancer.gov/projects
#' @export
#' @import readr stringr
#' @examples
#' projects <- getGDCprojects()
#' @return A data frame with last GDC projects
getGDCprojects <- function(){
    url <- "https://api.gdc.cancer.gov/projects?size=1000&format=json"
    json <- fromJSON(content(GET(url), as = "text", encoding = "UTF-8"), simplifyDataFrame = TRUE)
    projects <- json$data$hits
    projects$tumor <- unlist(lapply(projects$project_id, function(x){unlist(str_split(x,"-"))[2]}))
    if(nrow(projects) == 0) stop("I couldn't access GDC API. Please, check if it is not down.")
    return(projects)
}

# Source: https://stackoverflow.com/questions/10266963/moving-files-between-folders
move <- function(from, to, keep.copy = FALSE) {
    if(file.exists(from)){
        if(R.utils::isDirectory(from)) {
            todir <- dirname(to)
            dir.create(to, recursive=TRUE,showWarnings = FALSE)
            tryCatch(file.copy(from = from,  to = todir, recursive = TRUE), warning = function(w) print(w),error = function(e) print(e))
        } else {
            todir <- dirname(to)
            dir.create(todir, recursive=TRUE,showWarnings = FALSE)
            tryCatch(file.copy(from = from,  to = to), warning = function(w) print(w),error = function(e) print(e))
        }
        if(!keep.copy){
            if(dirname(from) != ".") {
                unlink(dirname(from),recursive=TRUE,force = TRUE)
            } else {
                unlink(from, recursive =  R.utils::isDirectory(from))
            }
        }
    } else {
        stop(paste0("I could not find the file: ", from))
    }
}

.quantileNormalization <-
    function(wd, distribution) {
        n <- nrow(wd)
        m <- ncol(wd)
        if(!missing(distribution))
            if(m != length(distribution))
                stop("The reference distribution has length
                 different from the col dimension of the data matrix.") else
                     distribution  <-  sort(distribution)

        o <- matrix(0, n, m)
        for(i in 1:n)
            o[i,] <- order(wd[i,])

        j <- 1
        tmp <- rep(0, n)

        while(j <= m) {
            if(missing(distribution)) {
                for(i in 1:n)
                    tmp[i] <- wd[i,o[i,j]]
                value <- mean(tmp)
            } else value  <- distribution[j]
            for(i in 1:n)
                wd[i,o[i,j]] <- value
            j <- j + 1
        }
        return(wd)
    }

is.windows <- function() {
    Sys.info()["sysname"] == "Windows"
}

is.mac <- function() {
    Sys.info()["sysname"] == "Darwin"
}

is.linux <- function() {
    Sys.info()["sysname"] == "Linux"
}

#
#  ggbiplot.r
#
#  Copyright 2011 Vincent Q. Vu.
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#

#' Biplot for Principal Components using ggplot2
#'
#' @param pcobj           an object returned by prcomp() or princomp()
#' @param choices         which PCs to plot
#' @param scale           covariance biplot (scale = 1), form biplot (scale = 0).
#'                         When scale = 1, the inner product between the variables
#'                         approximates the covariance and the distance between
#'                         the points approximates the Mahalanobis distance.
#' @param obs.scale       scale factor to apply to observations
#' @param var.scale       scale factor to apply to variables
#' @param pc.biplot       for compatibility with biplot.princomp()
#' @param groups          optional factor variable indicating the groups that
#'                         the observations belong to. If provided the points
#'                         will be colored according to groups
#' @param ellipse         draw a normal data ellipse for each group?
#' @param ellipse.prob    size of the ellipse in Normal probability
#' @param labels          optional vector of labels for the observations
#' @param labels.size     size of the text used for the labels
#' @param alpha           alpha transparency value for the points
#'                        (0 = transparent, 1 = opaque)
#' @param circle          draw a correlation circle?
#'                        (only applies when prcomp was called with scale = TRUE
#'                        and when var.scale = 1)
#' @param circle.prob     definition of circle.prob
#' @param var.axes        draw arrows for the variables?
#' @param varname.size    size of the text for variable names
#' @param varname.adjust  adjustment factor the placement of the variable names,
#'                         >= 1 means farther from the arrow
#' @param varname.abbrev  whether or not to abbreviate the variable names
#' @import ggplot2
#' @importFrom plyr ddply
#' @import stats
#' @keywords internal
#' @return A ggplot2 plot
#' @author Vincent Q. Vu.
# @examples
# data(iris)
# iris.pca <- prcomp(iris[,1:4], scale. = TRUE)
# print(ggbiplot(iris.pca, obs.scale = 1, var.scale = 1, groups = iris[,5],
# ellipse = TRUE, circle = TRUE))
ggbiplot <- function(pcobj, choices = 1:2, scale = 1, pc.biplot = TRUE,
                     obs.scale = 1 - scale, var.scale = scale,
                     groups = NULL, ellipse = FALSE, ellipse.prob = 0.68,
                     labels = NULL, labels.size = 3, alpha = 1,
                     var.axes = TRUE,
                     circle = FALSE, circle.prob = 0.69,
                     varname.size = 3, varname.adjust = 1.5,
                     varname.abbrev = FALSE)
{
    xvar <- NULL
    yvar <- NULL
    varname <-  NULL
    angle <- NULL
    hjust <- NULL

    stopifnot(length(choices) == 2)
    check_package("scales")
    # Recover the SVD
    if(inherits(pcobj, 'prcomp')){
        nobs.factor <- sqrt(nrow(pcobj$x) - 1)
        d <- pcobj$sdev
        u <- sweep(pcobj$x, 2, 1 / (d * nobs.factor), FUN = '*')
        v <- pcobj$rotation
    } else if(inherits(pcobj, 'princomp')) {
        nobs.factor <- sqrt(pcobj$n.obs)
        d <- pcobj$sdev
        u <- sweep(pcobj$scores, 2, 1 / (d * nobs.factor), FUN = '*')
        v <- pcobj$loadings
    } else if(inherits(pcobj, 'PCA')) {
        nobs.factor <- sqrt(nrow(pcobj$call$X))
        d <- unlist(sqrt(pcobj$eig)[1])
        u <- sweep(pcobj$ind$coord, 2, 1 / (d * nobs.factor), FUN = '*')
        v <- sweep(pcobj$var$coord,2,sqrt(pcobj$eig[1:ncol(pcobj$var$coord),1]),FUN="/")
    } else if(inherits(pcobj, "lda")) {
        nobs.factor <- sqrt(pcobj$N)
        d <- pcobj$svd
        u <- predict(pcobj)$x/nobs.factor
        v <- pcobj$scaling
        d.total <- sum(d^2)
    } else {
        stop('Expected a object of class prcomp, princomp, PCA, or lda')
    }

    # Scores
    choices <- pmin(choices, ncol(u))
    df.u <- as.data.frame(sweep(u[,choices], 2, d[choices]^obs.scale, FUN='*'))

    # Directions
    v <- sweep(v, 2, d^var.scale, FUN='*')
    df.v <- as.data.frame(v[, choices])

    names(df.u) <- c('xvar', 'yvar')
    names(df.v) <- names(df.u)

    if(pc.biplot) {
        df.u <- df.u * nobs.factor
    }

    # Scale the radius of the correlation circle so that it corresponds to
    # a data ellipse for the standardized PC scores
    r <- sqrt(qchisq(circle.prob, df = 2)) * prod(colMeans(df.u^2))^(1/4)

    # Scale directions
    v.scale <- rowSums(v^2)
    df.v <- r * df.v / sqrt(max(v.scale))

    # Change the labels for the axes
    if(obs.scale == 0) {
        u.axis.labs <- paste('standardized PC', choices, sep='')
    } else {
        u.axis.labs <- paste('PC', choices, sep='')
    }

    # Append the proportion of explained variance to the axis labels
    u.axis.labs <- paste(u.axis.labs,
                         sprintf('(%0.1f%% explained var.)',
                                 100 * pcobj$sdev[choices]^2/sum(pcobj$sdev^2)))

    # Score Labels
    if(!is.null(labels)) {
        df.u$labels <- labels
    }

    # Grouping variable
    if(!is.null(groups)) {
        df.u$groups <- groups
    }

    # Variable Names
    if(varname.abbrev) {
        df.v$varname <- abbreviate(rownames(v))
    } else {
        df.v$varname <- rownames(v)
    }

    # Variables for text label placement
    df.v$angle <- with(df.v, (180/pi) * atan(yvar / xvar))
    df.v$hjust = with(df.v, (1 - varname.adjust * sign(xvar)) / 2)

    # Base plot
    g <- ggplot(data = df.u, aes(x = xvar, y = yvar)) +
        xlab(u.axis.labs[1]) + ylab(u.axis.labs[2]) + coord_equal()

    if(var.axes) {
        # Draw circle
        if(circle)
        {
            theta <- c(seq(-pi, pi, length = 50), seq(pi, -pi, length = 50))
            circle <- data.frame(xvar = r * cos(theta), yvar = r * sin(theta))
            g <- g + geom_path(data = circle, color = scales::muted('white'),
                               size = 1/2, alpha = 1/3)
        }

        # Draw directions
        g <- g +
            geom_segment(data = df.v,
                         aes(x = 0, y = 0, xend = xvar, yend = yvar),
                         arrow = arrow(length = unit(1/2, 'picas')),
                         color = scales::muted('red'))
    }

    # Draw either labels or points
    if(!is.null(df.u$labels)) {
        if(!is.null(df.u$groups)) {
            g <- g + geom_text(aes(label = labels, color = groups),
                               size = labels.size)
        } else {
            g <- g + geom_text(aes(label = labels), size = labels.size)
        }
    } else {
        if(!is.null(df.u$groups)) {
            g <- g + geom_point(aes(color = groups), alpha = alpha)
        } else {
            g <- g + geom_point(alpha = alpha)
        }
    }

    # Overlay a concentration ellipse if there are groups
    if(!is.null(df.u$groups) && ellipse) {
        theta <- c(seq(-pi, pi, length = 50), seq(pi, -pi, length = 50))
        circle <- cbind(cos(theta), sin(theta))

        ell <- ddply(df.u, 'groups', function(x) {
            if(nrow(x) <= 2) {
                return(NULL)
            }
            sigma <- var(cbind(x$xvar, x$yvar))
            mu <- c(mean(x$xvar), mean(x$yvar))
            ed <- sqrt(qchisq(ellipse.prob, df = 2))
            data.frame(sweep(circle %*% chol(sigma) * ed, 2, mu, FUN = '+'),
                       groups = x$groups[1])
        })
        names(ell)[1:2] <- c('xvar', 'yvar')
        g <- g + geom_path(data = ell, aes(color = groups, group = groups))
    }

    # Label the variable axes
    if(var.axes) {
        g <- g +
            geom_text(data = df.v,
                      aes(label = varname, x = xvar, y = yvar,
                          angle = angle, hjust = hjust),
                      color = 'darkred', size = varname.size)
    }
    # Change the name of the legend for groups
    # if(!is.null(groups)) {
    #   g <- g + scale_color_brewer(name = deparse(substitute(groups)),
    #                               palette = 'Dark2')
    # }

    # TODO: Add a second set of axes

    return(g)
}

#' @title GenesCutID
#' @description
#'   GenesCutID
#' @param GeneList GeneList
#' @return list of gene symbol without IDs
# @examples
# GenesCutID(c("CRKL|1399","TADA2A|6871","KRT76|51350"))
#' @keywords internal
GenesCutID <- function(GeneList){
    GeneListCutID <- as.matrix(matrix(unlist(strsplit(as.character(GeneList),
                                                      "|",fixed = TRUE)),length(GeneList),2,byrow = TRUE))[,1]
    return(as.matrix(GeneListCutID))
}

#' @title GeneSplitRegulon
#' @description
#'   GeneSplitRegulon
#' @param Genelist Genelist
#' @param Sep Sep
#' @keywords internal
#' @return GeneSplitRegulon
# @examples
# GeneSplitRegulon("CRKL;TADA2A;KRT76",Sep =";")
GeneSplitRegulon <- function(Genelist,Sep){
    RegSplitted <- as.matrix(unlist(strsplit(as.character(Genelist), Sep)))

    return(RegSplitted)
}

#' @title Download GISTIC data from firehose
#' @description
#' Download GISTIC data from firehose from
#' http://gdac.broadinstitute.org/runs/analyses__latest/data/
#' @param disease TCGA disease. Option available in
#' http://gdac.broadinstitute.org/runs/analyses__latest/data/
#' @param type Results type: thresholded or data
#' @export
getGistic <- function(disease, type = "thresholded") {
    if(type == "thresholded") {
        file.type <- "all_thresholded.by_genes.txt"
    } else {
        file.type <- "all_data_by_genes.txt"
    }
    base <- paste0("http://gdac.broadinstitute.org/runs/analyses__latest/data/", disease)
    x <- tryCatch({
        read_html(base)  %>% html_nodes("a") %>% html_attr("href")
    }, error = function(e) {
        return(NULL)
    })
    if(is.null(x)) {
        message("No GISTIC file found")
        return(NULL)
    }
    base <- file.path(base,tail(x,n=1))
    x <- read_html(base)  %>% html_nodes("a") %>% html_attr("href")
    x <- x[grep("CopyNumber_Gistic2.Level_4",x)]

    if(!file.exists(x[1])) {
        if(Sys.info()["sysname"] == "Windows") mode <- "wb" else  mode <- "w"
        downloader::download(file.path(base,x[1]),x[1], mode = mode)
    }
    # Check if download was not corrupted
    md5 <- readr::read_table(
        file.path(base,x[2]),
        col_names = FALSE,
        progress = FALSE,
        col_types = "cc")$X1

    if(tools::md5sum(x[1]) != md5) stop("Error while downloading CNV data")
    file <- paste0(gsub(".tar.gz","",x[1]),"/",file.type)
    if(!file.exists(file)) {
        compressed.files <- untar(x[1], list = TRUE)
        compressed.files <- compressed.files[grepl(file.type, compressed.files)]
        untar(x[1],files = compressed.files )
    }
    ret <- tryCatch({
        fread(file, data.table = FALSE, colClasses = "character")
    }, error = function(e) {
        file <- dir(pattern = file.type, recursive = TRUE, full.names = TRUE)
        file <- file[grep(disease,file,ignore.case = TRUE)]
        fread(file, data.table = FALSE, colClasses = "character")
    })
    return(ret)
}

get.cnv <- function(project, genes){
    if(missing(project)) stop("Argument project is missing")
    if(missing(genes)) stop("Argument genes is missing")

    gistic <- getGistic(gsub("TCGA-","",project))
    cnv.annotation <- t(gistic[tolower(gistic[,1]) %in% tolower(genes),-c(2:3)])
    colnames(cnv.annotation) <- paste0("gistic2_hg19_",cnv.annotation[1,])
    cnv.annotation <- cnv.annotation[-1,, drop = FALSE]
    rownames(cnv.annotation) <- substr(gsub("\\.","-",rownames(cnv.annotation)),1,15)
    return(cnv.annotation)
}

get.mutation <- function(
        project,
        genes,
        mutant_variant_classification = c(
            "Frame_Shift_Del",
            "Frame_Shift_Ins",
            "Missense_Mutation",
            "Nonsense_Mutation",
            "Splice_Site",
            "In_Frame_Del",
            "In_Frame_Ins",
            "Translation_Start_Site",
            "Nonstop_Mutation"
        )){
    if(missing(project)) stop("Argument project is missing")
    if(missing(genes)) stop("Argument genes is missing")

    # Get mutation annotation file
    query <- GDCquery(
        project = project,
        data.category = "Simple Nucleotide Variation",
        access = "open",
        data.type = "Masked Somatic Mutation",
        workflow.type = "Aliquot Ensemble Somatic Variant Merging and Masking"
    )
    GDCdownload(query)
    maf <- GDCprepare(query)

    message(paste0("Consindering only the mutant_variant_classification mutations: \n o ",
                   paste(mutant_variant_classification, collapse = "\n o ")))
    # We will select only genes with mutation in the exon
    idx <- unique(
        unlist(
            sapply(
                mutant_variant_classification,
                function(x) {
                    grep(x,maf$Variant_Classification,ignore.case = TRUE)
                }
            )
        )
    )
    maf <- maf[idx,]

    mut <- NULL
    for(i in genes) {
        if(!i %in% maf$Hugo_Symbol) next
        aux <- data.frame(
            patient = substr(unique(maf[i == maf$Hugo_Symbol,]$Tumor_Sample_Barcode),1,15),
            mut = TRUE
        )
        colnames(aux)[2] <- paste0("mut_hg38_",i)
        if(is.null(mut)) {
            mut <- aux
        } else {
            mut <- merge(mut, aux, by = "patient", all = TRUE)
        }
    }
    if(is.null(mut)) return(NULL)

    rownames(mut) <- mut$patient; mut$patient <- NULL

    # Lets replaces NA to FALSE
    # TRUE: has mutation
    # FALSE: has no mutation
    mut <- !is.na(mut)

    return(mut)
}

get.mut.gistc <- function(
        project,
        genes,
        mutant_variant_classification
) {

    if(missing(project)) stop("Argument project is missing")
    if(missing(genes)) stop("Argument genes is missing")
    mut <- get.mutation(
        project,
        genes,
        mutant_variant_classification =  mutant_variant_classification
    )
    cnv <- get.cnv(project, genes)
    if(!is.null(mut) & !is.null(cnv)) {
        annotation <- merge(mut, cnv, by = 0 , sort = FALSE,all=TRUE)
        mut.idx <- grep("mut_hg38_",colnames(annotation))
        annotation[,mut.idx] <- !is.na(annotation[,mut.idx]) & annotation[,mut.idx] != FALSE
        rownames(annotation) <- annotation$Row.names
        annotation$Row.names <- NULL
        return(annotation)
    } else if(!is.null(mut) & is.null(cnv)) {
        return(mut)
    } else if(is.null(mut) & !is.null(cnv)) {
        return(cnv)
    }

    return(NULL)
}
get.mut.gistc.information <- function(
        df,
        project,
        genes,
        mutant_variant_classification = c(
            "Frame_Shift_Del",
            "Frame_Shift_Ins",
            "Missense_Mutation",
            "Nonsense_Mutation",
            "Splice_Site",
            "In_Frame_Del",
            "In_Frame_Ins",
            "Translation_Start_Site",
            "Nonstop_Mutation"
        )
) {
    order <- rownames(df)
    for(i in genes) if(!tolower(i) %in% tolower(EAGenes$Gene)) message(paste("Gene not found:", i))
    info <- as.data.frame(
        get.mut.gistc(
            project,
            genes,
            mutant_variant_classification = mutant_variant_classification
        )
    )
    if(is.null(info)) return(df)
    info$aux <- rownames(info)
    df$aux <- substr(df$barcode,1,15)
    df <- merge(df,info,by = "aux", all.x = TRUE, sort = FALSE)
    df$aux <- NULL
    mut.idx <- grep("mut_hg38_",colnames(df))
    # NA should be set to FALSE as the sample has no information found
    if(length(mut.idx) > 0) {
        for(idx in mut.idx) {
            df[,idx] <-  !is.na(df[,idx]) & df[,idx] != FALSE
        }
    }
    for(i in paste0("mut_hg38_",genes)){
        if(!i %in% colnames(df)) {
            df$aux <- FALSE
            colnames(df)[grep("aux",colnames(df))] <- i
        }
    }
    rownames(df) <- df$barcode
    df <- DataFrame(df[order,])
    return(df)
}

#' @export
print.header <- function(text, type ="section"){
    message(paste(rep("-",nchar(text) + 3),collapse = ""))
    message(paste(ifelse(type=="section","o","oo"),text))
    message(paste(rep("-",nchar(text)+ 3),collapse = ""))
}

#' @title Get the results table from query
#' @description
#' Get the results table from query, it can select columns with cols argument
#' and return a number of rows using rows argument.
#' @param query A object from GDCquery
#' @param rows Rows identifiers (row numbers)
#' @param cols Columns identifiers (col names)
#' @export
#' @return Table with query results
#' @examples
#' query <- GDCquery(
#'   project = "TCGA-GBM",
#'   data.category = "Transcriptome Profiling",
#'   data.type = "Gene Expression Quantification",
#'   workflow.type = "STAR - Counts",
#'   barcode = c("TCGA-14-0736-02A-01R-2005-01", "TCGA-06-0211-02A-02R-2005-01")
#' )
#' results <- getResults(query)
getResults <- function(query, rows, cols){
    if(missing(cols) & missing(rows)) return(query$results[[1]])
    if(missing(cols) & !missing(rows)) return(query$results[[1]][rows,])
    if(!missing(cols) & missing(rows)) return(query$results[[1]][,cols])
    if(!missing(cols) & !missing(rows)) return(query$results[[1]][rows,cols])
}


getURL <- function(URL, FUN, ..., N.TRIES=3L) {
    N.TRIES <- as.integer(N.TRIES)
    stopifnot(length(N.TRIES) == 1L, !is.na(N.TRIES))

    while (N.TRIES > 0L) {
        result <- tryCatch(FUN(URL, ...), error=identity)
        if (!inherits(result, "error"))
            break
        N.TRIES <- N.TRIES - 1L
    }

    if (N.TRIES == 0L) {
        stop("'getURL()' failed:",
             "\n  URL: ", URL,
             "\n  error: ", conditionMessage(result))
    }

    result
}

#' @title Extract information from TCGA barcodes.
#' @description
#'    get_IDs allows user to extract metadata from barcodes. The dataframe returned has columns for
#'  'project', 'tss','participant', 'sample', "portion", "plate", and "center"
#' @param data numeric matrix, each row represents a gene, each column represents a sample
#' @export
#' @return data frame with columns 'project', 'tss','participant', 'sample', "portion", "plate", "center", "condition"
get_IDs <- function(data) {
    IDs <- strsplit(c(colnames(data)), "-")
    IDs <- plyr::ldply(IDs, rbind)
    colnames(IDs) <- c('project', 'tss','participant', 'sample', "portion", "plate", "center")
    cols <- c("project", "tss", "participant")
    IDs$patient <- apply(IDs[,cols],1,paste,collapse = "-" )
    barcode <- colnames(data)
    IDs <- cbind(IDs, barcode)
    condition <- gsub("11+[[:alpha:]]", "normal", as.character(IDs$sample))
    condition  <- gsub("01+[[:alpha:]]", "cancer", condition)
    IDs$condition <- condition
    IDs$myorder  <- 1:nrow(IDs)
    return(IDs)
}


#' @title register cores
#' @param package Package name
#' @noRd
check_package <- function(package){
    if (!requireNamespace(package, quietly = TRUE)) {
        stop(package, " package is needed for this function to work. Please install it.",
             call. = FALSE)
    }
}

#' @title register cores
#' @param package Package name
#' @noRd
set_cores <- function(cores){
    parallel <- FALSE
    if (cores > 1) {
        check_package("parallel")
        check_package("doParallel")
        if (is.windows()) {
            if (cores > parallel::detectCores())
                cores <- parallel::detectCores()
            doParallel::registerDoParallel(cores)
            parallel = TRUE
        } else {
            if (cores > parallel::detectCores())
                cores <- parallel::detectCores()
            doParallel::registerDoParallel(cores)
            parallel = TRUE
        }
    }
    return(parallel)
}

#' Clinical data TCGA BRCA
#' @docType data
#' @keywords internal
#' @name clinBRCA
#' @format A data frame with 1061 rows and 109 variables
NULL

#' tabSurvKMcompleteDEGs
#' @docType data
#' @keywords internal
#' @name tabSurvKMcompleteDEGs
#' @format A data frame with 200 rows and 7 variables
NULL



#' TCGA data matrix BRCA
#' @docType data
#' @keywords internal
#' @name dataBRCA
#' @format A data frame with 20531 rows (genes) and 50 variables (samples)
NULL

#' TCGA data SummarizedExperiment READ
#' @docType data
#' @keywords internal
#' @name dataREAD
#' @format A SummarizedExperiment of READ with 2 samples
NULL

#' TCGA data matrix READ
#' @docType data
#' @keywords internal
#' @name dataREAD_df
#' @format A data frame with 20531 rows (genes) and 2 variables (samples)
NULL

#' TCGA data matrix BRCA DEGs
#' @docType data
#' @keywords internal
#' @name dataDEGsFiltLevel
#' @format A data frame with 3649 rows and 6 variables
NULL

#' geneInfo for normalization of RNAseq data
#' @docType data
#' @keywords internal
#' @name geneInfo
#' @format A data frame with 20531 rows and 2 variables
NULL

#' geneInfoHT for normalization of HTseq data
#' @description
#' Code to generate the data in examples
#' @examples
#' \dontrun{
#' library(EDASeq)
#' library(biomaRt)
#' #get ensembl gene IDs for hg38
#' ensembl <- useMart("ensembl", dataset = "hsapiens_gene_ensembl")
#' biomart_getID <- getBM(attributes = c("ensembl_gene_id"), mart = ensembl)
#' #get gene length and GC content for all IDs
#'
#' step <- 500
#' geneInfoHT <- plyr::adply(
#' seq(1,length(biomart_getID$ensembl_gene_id),step),
#' .margins = 1,.fun = function(x){
#'     begin <- x
#'     end <- x + step
#'     if(end > length(biomart_getID$ensembl_gene_id)) {
#'       end <- length(biomart_getID$ensembl_gene_id)
#'     }
#'     file <- paste0("geneInfoHT_from_",begin,"_to_",end,".rda")
#'     if(!file.exists(file)){
#'         df <- getGeneLengthAndGCContent(
#'             biomart_getID$ensembl_gene_id[begin:end] ,
#'             org = "hsa",
#'             mode = c("biomart")
#'         )
#'         save(df,file = file)
#'     } else {
#'         df <- get(load(file))
#'     }
#'     df
#' },.progress = "time")
#' saveRDS(getdata, file = "getGLGC_download.RDS")a
#' save(getdata, file = "getGLGC_download.rda")
#' #Save output as data frame with correct header names
#' geneInfoHT <- data.frame(
#'     geneLength = getdata[,1] ,
#'     gcContent = getdata[,2]
#' )
#' #Save final table
#' save(geneInfoHT, file = "data/geneInfoHT.rda")
#' }
#' @docType data
#' @keywords internal
#' @name geneInfoHT
#' @format A data frame with 23486 rows and 2 variables
NULL

#' TCGA batch information from Biospecimen Metadata Browser
#' @docType data
#' @keywords internal
#' @name batch.info
#' @format A data frame with 11382 rows and 3 variables
NULL

#' TCGA CHOL MAF transformed to maftools object
#' @docType data
#' @keywords internal
#' @name chol_maf
#' @format An object of class  MAF
NULL

#' TCGA CHOL MAF
#' @docType data
#' @keywords internal
#' @name bcgsc.ca_CHOL.IlluminaHiSeq_DNASeq.1.somatic.maf
#' @format A tibble: 3,555 x 34
NULL

#' MSI data for two samples
#' @docType data
#' @keywords internal
#' @name msi_results
#' @format A data frame: 2 rows, 4 columns
NULL

#' A RangedSummarizedExperiment two samples with gene expression data from vignette
#' aligned against hg38
#' @docType data
#' @keywords internal
#' @name gbm.exp.harmonized
#' @format A RangedSummarizedExperiment: 56963 genes, 2 samples
NULL

#' A RangedSummarizedExperiment two samples with gene expression data from vignette
#' aligned against hg19
#' @docType data
#' @keywords internal
#' @name gbm.exp.legacy
#' @format A RangedSummarizedExperiment: 21022 genes, 2 samples
NULL

#' A DNA methylation RangedSummarizedExperiment for 8 samples (only first 20 probes)
#' aligned against hg19
#' @docType data
#' @keywords internal
#' @name met.gbm.27k
#' @format A RangedSummarizedExperiment: 20 probes, 8 samples
NULL

#' A list of data frames with clinical data parsed from XML (code in vignettes)
#' @docType data
#' @keywords internal
#' @name clinical.biotab
#' @format A list with 7 elements
NULL

#' A data frame with all TCGA molecular subtypes
#' @docType data
#' @keywords internal
#' @name pancan2018
#' @format A data frame with 7,734 lines and 10 columns
NULL

#' A numeric vector with stem cell-like signature trained on PCBC's dataset
#' @docType data
#' @keywords internal
#' @name SC_PCBC_stemSig
#' @format A numeric vector with 12956 genes
NULL

#' A numeric vector with SC-derived mesoderm (MESO) signature trained on PCBC's dataset
#' @docType data
#' @keywords internal
#' @name MESO_PCBC_stemSig
#' @format A numeric vector with 12956 genes
NULL


#' A numeric vector with SC-derived ectoderm (ECTO) signature trained on PCBC's dataset
#' @docType data
#' @keywords internal
#' @name ECTO_PCBC_stemSig
#' @format A numeric vector with 12956 genes
NULL


#' A numeric vector with SC-derived definitive endoderm (DE) signature trained on PCBC's dataset
#' @docType data
#' @keywords internal
#' @name DE_PCBC_stemSig
#' @format A numeric vector with 12956 genes
NULL

#' A numeric vector with stem cell (SC)-derived embryoid bodies (EB) signature trained on PCBC's dataset
#' @docType data
#' @keywords internal
#' @name EB_PCBC_stemSig
#' @format A numeric vector with 12956 genes
NULL

#' Result of gliomaclassifier function
#' @docType data
#' @keywords internal
#' @name classification
#' @format A list of data frames
NULL

#' @title Retrieve linkedOmics data
#' @description Retrieve linkedOmics data from http://linkedomics.org/
#' @param project A linkedOmics project:
#' \itemize{
#' \item{TCGA-ACC}
#' \item{TCGA-BLCA}
#' \item{TCGA-BRCA}
#' \item{TCGA-CESC}
#' \item{TCGA-CHOL}
#' \item{TCGA-COADREAD}
#' \item{TCGA-DLBC}
#' \item{TCGA-ESCA}
#' \item{TCGA-GBM}
#' \item{TCGA-GBMLGG}
#' \item{TCGA-HNSC}
#' \item{TCGA-KICH}
#' \item{TCGA-KIPAN}
#' \item{TCGA-KIRC}
#' \item{TCGA-KIRP}
#' \item{TCGA-LAML}
#' \item{TCGA-LGG}
#' \item{TCGA-LIHC}
#' \item{TCGA-LUAD}
#' \item{TCGA-LUSC}
#' \item{TCGA-MESO}
#' \item{TCGA-OV}
#' \item{TCGA-PAAD}
#' \item{TCGA-PCPG}
#' \item{TCGA-PRAD}
#' \item{TCGA-SARC}
#' \item{TCGA-SKCM}
#' \item{TCGA-STAD}
#' \item{TCGA-STES}
#' \item{TCGA-TGCT}
#' \item{TCGA-THCA}
#' \item{TCGA-THYM}
#' \item{TCGA-UCEC}
#' \item{TCGA-UCS}
#' \item{TCGA-UVM}
#' \item{CPTAC-COAD}
#' }
#' @param dataset A dataset from the list below
#' \itemize{
#' \item{ Annotated mutation }
#' \item{ Clinical }
#' \item{ Glycoproteome (Gene level) }
#' \item{ Glycoproteome (Site level) }
#' \item{ Methylation (CpG-site level, HM27) }
#' \item{ Methylation (CpG-site level, HM450K) }
#' \item{ Methylation (Gene level, HM27) }
#' \item{ Methylation (Gene level, HM450K) }
#' \item{ miRNA (GA, Gene level) }
#' \item{ miRNA (GA, Isoform level) }
#' \item{ miRNA (GA, miRgene level) }
#' \item{ miRNA (Gene level) }
#' \item{ miRNA (HiSeq, Gene level) }
#' \item{ miRNA (HiSeq, miRgene level) }
#' \item{ miRNA (isoform level) }
#' \item{ miRNA (miRgene level) }
#' \item{ Mutation (Gene level) }
#' \item{ Mutation (Site level) }
#' \item{ Mutation raw file (Somatic and MSIndel) }
#' \item{ Phosphoproteome (Gene level) }
#' \item{ Phosphoproteome (Site level) }
#' \item{ Phosphoproteomics (Normal) }
#' \item{ Phosphoproteomics (Tumor) }
#' \item{ Proteome (Gene level) }
#' \item{ Proteome (Gene Level) }
#' \item{ Proteome (JHU, Gene level) }
#' \item{ Proteome (PNNL, Gene level, Normal TMT Unshared Log Ratio) }
#' \item{ Proteome (PNNL, Gene level, Tumor TMT Unshared Log Ratio) }
#' \item{ Proteome (PNNL, Gene level) }
#' \item{ Proteome (VU, Gene level, Label-free Unshared Counts) }
#' \item{ RNAseq (GA, Gene level) }
#' \item{ RNAseq (HiSeq, Gene level) }
#' \item{ RPPA (Analyte level) }
#' \item{ RPPA (Analyte Level) }
#' \item{ RPPA (Gene level) }
#' \item{ RPPA (Gene Level) }
#' \item{ SCNV (Focal level, log-ratio) }
#' \item{ SCNV (Focal level, Thresholded) }
#' \item{ SCNV (Gene level, log ratio) }
#' \item{ SCNV (Gene level, log-ratio) }
#' \item{ SCNV (Gene level, Thresholded) }
#' \item{ SCNV (Segment level) }
#' }
#' @export
#' @return A matrix with the data
#' @examples
#' \dontrun{
#' TCGA_COAD_protein <- getLinkedOmicsData(
#'   project = "TCGA-COADREAD",
#'   dataset = "Proteome (Gene level)"
#' )
#' TCGA_COAD_RNASeq_hiseq <- getLinkedOmicsData(
#'   project = "TCGA-COADREAD",
#'   dataset = "RNAseq (HiSeq, Gene level)"
#' )
#' TCGA_COAD_RNASeq_ga <- getLinkedOmicsData(
#'   project = "TCGA-COADREAD",
#'   dataset = "RNAseq (GA, Gene level)"
#' )
#' TCGA_COAD_RPPA <- getLinkedOmicsData(
#'   project = "TCGA-COADREAD",
#'   dataset = "RPPA (Gene level)"
#' )
#' }
getLinkedOmicsData <- function(project, dataset){

    tab <- get(data("linkedOmics.data",package = "TCGAbiolinksGUI.data", envir = environment()))

    if(missing(project) || !project %in% tab$project){
        print(knitr::kable(data.frame("Avail projects" = tab$project %>% unique())))
        stop("Project not found! Possible list is above")
    }
    tab <- tab %>% dplyr::filter(.data$project == !!project)

    if(missing(dataset) || !dataset %in% tab$`OMICS Dataset`){
        print(knitr::kable(data.frame("Avail dataset" = tab$`OMICS Dataset` %>% unique())))
        stop("dataset not found! Possible list is above")
    }
    tab <- tab %>% dplyr::filter(.data$`OMICS Dataset` == !!dataset)
    url <- tab %>% pull("url")
    readr::read_tsv(url,col_types = readr::cols())
}

#' @title Generate Stemness Score based on RNASeq (mRNAsi stemness index) Malta et al., Cell, 2018
#' @description TCGAanalyze_Stemness generate the mRNAsi score
#' @param stemSig is a vector of the stemness Signature generated using gelnet package.
#' Please check the data from https://www.ncbi.nlm.nih.gov/pmc/articles/PMC5902191/
#' \itemize{
#' \item \link[TCGAbiolinks]{SC_PCBC_stemSig} - Stemness Score
#' \item \link[TCGAbiolinks]{DE_PCBC_stemSig} - endoderm score
#' \item \link[TCGAbiolinks]{EB_PCBC_stemSig} -  embryoid bodies score
#' \item \link[TCGAbiolinks]{ECTO_PCBC_stemSig} - ectoderm score
#' \item \link[TCGAbiolinks]{MESO_PCBC_stemSig} - mesoderm score
#' }
#' @param dataGE is a matrix of Gene expression (genes in rows, samples in cols) from TCGAprepare
#' @param colname.score Column name of the output. Default "stemness_score"
#' @export
#' @return table with samples and selected score
#' @examples
#'  # Selecting TCGA breast cancer (10 samples) for example stored in dataBRCA
#'  dataNorm <- TCGAanalyze_Normalization(
#'      tabDF = dataBRCA,
#'      geneInfo =  geneInfo
#'  )
#'
#'  # quantile filter of genes
#'  dataFilt <- TCGAanalyze_Filtering(
#'    tabDF = dataNorm,
#'    method = "quantile",
#'    qnt.cut =  0.25
#'  )
#'  Stemness_score <- TCGAanalyze_Stemness(
#'      stemSig = SC_PCBC_stemSig,
#'      dataGE = dataFilt,
#'      colname.score = "SC_PCBC_stem_score"
#'   )
#'  ECTO_score <- TCGAanalyze_Stemness(
#'      stemSig = ECTO_PCBC_stemSig,
#'      dataGE = dataFilt,
#'      colname.score = "ECTO_PCBC_stem_score"
#'   )
#'   MESO_score <- TCGAanalyze_Stemness(
#'      stemSig = MESO_PCBC_stemSig,
#'      dataGE = dataFilt,
#'      colname.score = "MESO_PCBC_stem_score"
#'   )
TCGAanalyze_Stemness <- function(
    stemSig,
    dataGE,
    colname.score = "stemness_score"
) {
    reads <- dataGE
    X <- reads
    w <- stemSig
    commonStemsigGenes <- intersect(names(w), rownames(X))

    X <- X[commonStemsigGenes, ]
    w <- w[rownames(X)]

    # Score the Matrix X using Spearman correlation.

    s <- apply(X, 2, function(z) {
            cor(z, w, method = "sp", use = "complete.obs")
        })

    ## Scale the scores to be between 0 and 1
    s <- s - min(s)
    s <- s / max(s)

    dataSce_stemness <- cbind(s)

    score <- data.frame("Sample" = colnames(reads))
    rownames(score) <- colnames(reads)

    score[[colname.score]] <- 0
    score[rownames(dataSce_stemness), colname.score] <- as.numeric(dataSce_stemness)

    return(score)
}

## ----setup, include=FALSE-----------------------------------------------------
knitr::opts_chunk$set(dpi = 300)
knitr::opts_chunk$set(cache=FALSE)

## ----echo = FALSE,hide=TRUE, message=FALSE,warning=FALSE----------------------
devtools::load_all(".")

## ----message=FALSE, warning=FALSE, include=FALSE------------------------------
library(SummarizedExperiment)
library(dplyr)
library(DT)

## ----eval = FALSE-------------------------------------------------------------
# # You can define a list of samples to query and download providing relative TCGA barcodes.
# listSamples <- c(
#     "TCGA-E9-A1NG-11A-52R-A14M-07","TCGA-BH-A1FC-11A-32R-A13Q-07",
#     "TCGA-A7-A13G-11A-51R-A13Q-07","TCGA-BH-A0DK-11A-13R-A089-07",
#     "TCGA-E9-A1RH-11A-34R-A169-07","TCGA-BH-A0AU-01A-11R-A12P-07",
#     "TCGA-C8-A1HJ-01A-11R-A13Q-07","TCGA-A7-A13D-01A-13R-A12P-07",
#     "TCGA-A2-A0CV-01A-31R-A115-07","TCGA-AQ-A0Y5-01A-11R-A14M-07"
# )
# 
# # Query platform Illumina HiSeq with a list of barcode
# query <- GDCquery(
#     project = "TCGA-BRCA",
#     data.category = "Transcriptome Profiling",
#     data.type = "Gene Expression Quantification",
#     barcode = listSamples
# )
# 
# # Download a list of barcodes with platform IlluminaHiSeq_RNASeqV2
# GDCdownload(query)
# 
# # Prepare expression matrix with geneID in the rows and samples (barcode) in the columns
# # rsem.genes.results as values
# BRCA.Rnaseq.SE <- GDCprepare(query)
# 
# BRCAMatrix <- assay(BRCA.Rnaseq.SE,"unstranded")
# # For gene expression if you need to see a boxplot correlation and AAIC plot to define outliers you can run
# BRCA.RNAseq_CorOutliers <- TCGAanalyze_Preprocessing(BRCA.Rnaseq.SE)

## ----eval = TRUE, echo = FALSE,size = 8---------------------------------------
library(TCGAbiolinks)
dataGE <- dataBRCA[sample(rownames(dataBRCA),10),sample(colnames(dataBRCA),7)]

knitr::kable(
    dataGE[1:10,2:3], digits = 2, 
    caption = "Example of a matrix of gene expression (10 genes in rows and 2 samples in columns)",
    row.names = TRUE
)

## ----fig.width=6, fig.height=4, echo=FALSE, fig.align="center"----------------
library(png)
library(grid)
img <- readPNG("PreprocessingOutput.png")
grid.raster(img)

## ----eval = FALSE-------------------------------------------------------------
# library(TCGAbiolinks)
# 
# # normalization of genes
# dataNorm <- TCGAanalyze_Normalization(
#     tabDF = BRCA.RNAseq_CorOutliers,
#     geneInfo =  geneInfoHT
# )
# 
# # quantile filter of genes
# dataFilt <- TCGAanalyze_Filtering(
#     tabDF = dataNorm,
#     method = "quantile",
#     qnt.cut =  0.25
# )
# 
# # selection of normal samples "NT"
# samplesNT <- TCGAquery_SampleTypes(
#     barcode = colnames(dataFilt),
#     typesample = c("NT")
# )
# 
# # selection of tumor samples "TP"
# samplesTP <- TCGAquery_SampleTypes(
#     barcode = colnames(dataFilt),
#     typesample = c("TP")
# )
# 
# # Diff.expr.analysis (DEA)
# dataDEGs <- TCGAanalyze_DEA(
#     mat1 = dataFilt[,samplesNT],
#     mat2 = dataFilt[,samplesTP],
#     Cond1type = "Normal",
#     Cond2type = "Tumor",
#     fdr.cut = 0.01 ,
#     logFC.cut = 1,
#     method = "glmLRT"
# )
# 
# # DEGs table with expression values in normal and tumor samples
# dataDEGsFiltLevel <- TCGAanalyze_LevelTab(
#     FC_FDR_table_mRNA = dataDEGs,
#     typeCond1 = "Tumor",
#     typeCond2 = "Normal",
#     TableCond1 = dataFilt[,samplesTP],
#     TableCond2 = dataFilt[,samplesNT]
# )
# 

## ----eval = TRUE, echo = FALSE------------------------------------------------
library(TCGAbiolinks)
dataDEGsFiltLevel$FDR <- format(dataDEGsFiltLevel$FDR, scientific = TRUE)
knitr::kable(
    dataDEGsFiltLevel[1:10,], digits = 2,
    caption = "Table of DEGs after DEA", row.names = FALSE
)

## ----eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE-------------------------
# 
# query <- GDCquery(
#     project = "TCGA-BRCA",
#     data.category = "Transcriptome Profiling",
#     data.type = "Gene Expression Quantification",
#     workflow.type = "STAR - Counts"
# )
# 
# samplesDown <- getResults(query,cols=c("cases"))
# 
# dataSmTP <- TCGAquery_SampleTypes(
#     barcode = samplesDown,
#     typesample = "TP"
# )
# 
# dataSmNT <- TCGAquery_SampleTypes(
#     barcode = samplesDown,
#     typesample = "NT"
# )
# dataSmTP_short <- dataSmTP[1:10]
# dataSmNT_short <- dataSmNT[1:10]
# 
# query.selected.samples <- GDCquery(
#     project = "TCGA-BRCA",
#     data.category = "Transcriptome Profiling",
#     data.type = "Gene Expression Quantification",
#     workflow.type = "STAR - Counts",
#     barcode = c(dataSmTP_short, dataSmNT_short)
# )
# 
# GDCdownload(
#     query = query.selected.samples
# )
# 
# dataPrep <- GDCprepare(
#     query = query.selected.samples,
#     save = TRUE
# )
# 
# dataPrep <- TCGAanalyze_Preprocessing(
#     object = dataPrep,
#     cor.cut = 0.6,
#     datatype = "HTSeq - Counts"
# )
# 
# dataNorm <- TCGAanalyze_Normalization(
#     tabDF = dataPrep,
#     geneInfo = geneInfoHT,
#     method = "gcContent"
# )
# 
# boxplot(dataPrep, outline = FALSE)
# 
# boxplot(dataNorm, outline = FALSE)
# 
# dataFilt <- TCGAanalyze_Filtering(
#     tabDF = dataNorm,
#     method = "quantile",
#     qnt.cut =  0.25
# )
# 
# dataDEGs <- TCGAanalyze_DEA(
#     mat1 = dataFilt[,dataSmTP_short],
#     mat2 = dataFilt[,dataSmNT_short],
#     Cond1type = "Normal",
#     Cond2type = "Tumor",
#     fdr.cut = 0.01 ,
#     logFC.cut = 1,
#     method = "glmLRT"
# )
# 

## ----eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE-------------------------
# require(TCGAbiolinks)
# 
# query.miRNA <- GDCquery(
#     project = "TCGA-BRCA",
#     experimental.strategy = "miRNA-Seq",
#     data.category = "Transcriptome Profiling",
#     data.type = "miRNA Expression Quantification"
# )
# 
# GDCdownload(query = query.miRNA)
# 
# dataAssy.miR <- GDCprepare(
#     query = query.miRNA
# )
# rownames(dataAssy.miR) <- dataAssy.miR$miRNA_ID
# 
# # using read_count's data
# read_countData <-  colnames(dataAssy.miR)[grep("count", colnames(dataAssy.miR))]
# dataAssy.miR <- dataAssy.miR[,read_countData]
# colnames(dataAssy.miR) <- gsub("read_count_","", colnames(dataAssy.miR))
# 
# dataFilt <- TCGAanalyze_Filtering(
#     tabDF = dataAssy.miR,
#     method = "quantile",
#     qnt.cut =  0.25
# )
# 
# dataDEGs <- TCGAanalyze_DEA(
#     mat1 = dataFilt[,dataSmNT_short.miR],
#     mat2 = dataFilt[,dataSmTP_short.miR],
#     Cond1type = "Normal",
#     Cond2type = "Tumor",
#     fdr.cut = 0.01 ,
#     logFC.cut = 1,
#     method = "glmLRT"
# )
# 

## ----eval = FALSE-------------------------------------------------------------
# library(TCGAbiolinks)
# # Enrichment Analysis EA
# # Gene Ontology (GO) and Pathway enrichment by DEGs list
# Genelist <- rownames(dataDEGsFiltLevel)
# 
# ansEA <- TCGAanalyze_EAcomplete(
#     TFname = "DEA genes Normal Vs Tumor",
#     RegulonList = Genelist
# )
# 
# # Enrichment Analysis EA (TCGAVisualize)
# # Gene Ontology (GO) and Pathway enrichment barPlot
# 
# TCGAvisualize_EAbarplot(
#     tf = rownames(ansEA$ResBP),
#     GOBPTab = ansEA$ResBP,
#     GOCCTab = ansEA$ResCC,
#     GOMFTab = ansEA$ResMF,
#     PathTab = ansEA$ResPat,
#     nRGTab = Genelist,
#     nBar = 10
# )
# 

## ----fig.width=6, fig.height=4, echo=FALSE, fig.align="center"----------------
library(png)
library(grid)
img <- readPNG("EAplot.png")
grid.raster(img)

## ----eval = FALSE-------------------------------------------------------------
# clin.gbm <- GDCquery_clinic("TCGA-GBM", "clinical")
# TCGAanalyze_survival(
#     data = clin.gbm,
#     clusterCol = "gender",
#     main = "TCGA Set\n GBM",
#     height = 10,
#     width=10
# )

## ----fig.width=6, fig.height=4, echo = FALSE, fig.align="center",hide=TRUE, message=FALSE,warning=FALSE----
library(png)
library(grid)
img <- readPNG("case2_surv.png")
grid.raster(img)

## ----eval = FALSE-------------------------------------------------------------
# library(TCGAbiolinks)
# # Survival Analysis SA
# 
# clinical_patient_Cancer <- GDCquery_clinic("TCGA-BRCA","clinical")
# dataBRCAcomplete <- log2(BRCA_rnaseqv2)
# 
# tokenStop <- 1
# 
# tabSurvKMcomplete <- NULL
# 
# for( i in 1: round(nrow(dataBRCAcomplete)/100)){
#     message( paste( i, "of ", round(nrow(dataBRCAcomplete)/100)))
#     tokenStart <- tokenStop
#     tokenStop <- 100 * i
#     tabSurvKM <- TCGAanalyze_SurvivalKM(
#         clinical_patient_Cancer,
#         dataBRCAcomplete,
#         Genelist = rownames(dataBRCAcomplete)[tokenStart:tokenStop],
#         Survresult = F,
#         ThreshTop = 0.67,
#         ThreshDown = 0.33
#     )
# 
#     tabSurvKMcomplete <- rbind(tabSurvKMcomplete,tabSurvKM)
# }
# 
# tabSurvKMcomplete <- tabSurvKMcomplete[tabSurvKMcomplete$pvalue < 0.01,]
# tabSurvKMcomplete <- tabSurvKMcomplete[order(tabSurvKMcomplete$pvalue, decreasing=F),]
# 
# tabSurvKMcompleteDEGs <- tabSurvKMcomplete[
#     rownames(tabSurvKMcomplete) %in% dataDEGsFiltLevel$mRNA,
# ]

## ----fig.width=6, fig.height=4, echo=FALSE, fig.align="center"----------------
tabSurvKMcompleteDEGs$pvalue <- format(tabSurvKMcompleteDEGs$pvalue, scientific = TRUE)
knitr::kable(tabSurvKMcompleteDEGs[1:5,1:4], 
             digits = 2,
             caption = "Table KM-survival genes after SA",
             row.names = TRUE)
knitr::kable(tabSurvKMcompleteDEGs[1:5,5:7], 
             digits = 2,
             row.names = TRUE)

## ----eval = FALSE-------------------------------------------------------------
# data <- TCGAanalyze_DMC(
#     data = data,
#     groupCol = "methylation_subtype",
#     group1 = "CIMP.H",
#     group2 = "CIMP.L",
#     p.cut = 10^-5,
#     diffmean.cut = 0.25,
#     legend = "State",
#     plot.filename = "coad_CIMPHvsCIMPL_metvolcano.png"
# )

## ----fig.width=6, fig.height=4, echo = FALSE, fig.align="center",hide=TRUE, message=FALSE,warning=FALSE----
library(png)
library(grid)
img <- readPNG("figure5met.png")
grid.raster(img)

## ----fig.width=6, fig.height=4, echo = FALSE, fig.align="center",hide=TRUE, message=FALSE,warning=FALSE----
library(jpeg)
library(grid)
img <- readJPEG("case2_Heatmap.jpg")
grid.raster(img)

## ----eval = FALSE-------------------------------------------------------------
# # normalization of genes
# dataNorm <- TCGAbiolinks::TCGAanalyze_Normalization(dataBRCA, geneInfo)
# 
# # quantile filter of genes
# dataFilt <- TCGAanalyze_Filtering(
#     tabDF = dataNorm,
#     method = "quantile",
#     qnt.cut =  0.25
# )
# 
# # selection of normal samples "NT"
# group1 <- TCGAquery_SampleTypes(colnames(dataFilt), typesample = c("NT"))
# # selection of normal samples "TP"
# group2 <- TCGAquery_SampleTypes(colnames(dataFilt), typesample = c("TP"))
# 
# # Principal Component Analysis plot for ntop selected DEGs
# pca <- TCGAvisualize_PCA(
#     dataFilt = dataFilt,
#     dataDEGsFiltLevel = dataDEGsFiltLevel,
#     ntopgenes = 200,
#     group1 = group1,
#     group2 =  group2
# )

## ----fig.width=6, fig.height=4, echo=FALSE, fig.align="center"----------------
library(png)
library(grid)
img <- readPNG("PCAtop200DEGs.png")
grid.raster(img)

## ----include=FALSE,echo=FALSE, fig.height=5, message=FALSE, warning=FALSE,eval=FALSE----
# query <- GDCquery(
#     project = "TCGA-GBM",
#     data.category = "DNA Methylation",
#     platform = "Illumina Human Methylation 27",
#     barcode = c(
#         "TCGA-02-0058-01A-01D-0186-05", "TCGA-12-1597-01B-01D-0915-05",
#         "TCGA-12-0829-01A-01D-0392-05", "TCGA-06-0155-01B-01D-0521-05",
#         "TCGA-02-0099-01A-01D-0199-05", "TCGA-19-4068-01A-01D-1228-05",
#         "TCGA-19-1788-01A-01D-0595-05", "TCGA-16-0848-01A-01D-0392-05"
#     )
# )
# GDCdownload(query, method = "api")
# data <- GDCprepare(query)
# 

## ----eval=FALSE, echo=TRUE, fig.height=5, message=FALSE, warning=FALSE--------
# query <- GDCquery(
#     project = "TCGA-GBM",
#     data.category = "DNA methylation",
#     platform = "Illumina Human Methylation 27",
#     barcode = c(
#         "TCGA-02-0058-01A-01D-0186-05", "TCGA-12-1597-01B-01D-0915-05",
#         "TCGA-12-0829-01A-01D-0392-05", "TCGA-06-0155-01B-01D-0521-05",
#         "TCGA-02-0099-01A-01D-0199-05", "TCGA-19-4068-01A-01D-1228-05",
#         "TCGA-19-1788-01A-01D-0595-05", "TCGA-16-0848-01A-01D-0392-05"
#     )
# )
# GDCdownload(query, method = "api")
# data <- GDCprepare(query)

## ----eval = FALSE-------------------------------------------------------------
# starburst <- TCGAvisualize_starburst(
#     met = coad.SummarizeExperiment,
#     exp = different.experssion.analysis.data,
#     group1 = "CIMP.H",
#     group2 = "CIMP.L",
#     met.platform = "450K",
#     genome = "hg19",
#     met.p.cut = 10^-5,
#     exp.p.cut = 10^-5,
#     names = TRUE
# )

## ----fig.width=6, fig.height=4, echo = FALSE, fig.align="center",hide=TRUE, message=FALSE,warning=FALSE----
library(png)
library(grid)
img <- readPNG("figure5star.png")
grid.raster(img)

## ----sessionInfo--------------------------------------------------------------
sessionInfo()

#' @title Prepare GDC data
#' @description
#'   Reads the data downloaded and prepare it into an R object
#' @param query A query for GDCquery function
#' @param save Save result as RData object?
#' @param save.filename Name of the file to be save if empty an automatic will be created
#' @param directory Directory/Folder where the data was downloaded. Default: GDCdata
#' @param summarizedExperiment Create a summarizedExperiment? Default TRUE (if possible)
#' @param remove.files.prepared Remove the files read? Default: FALSE
#' This argument will be considered only if save argument is set to true
#' @param add.gistic2.mut If a list of genes (gene symbol) is given, columns with gistic2 results from GDAC firehose (hg19)
#' and a column indicating if there is or not mutation in that gene (hg38)
#' (TRUE or FALSE - use the MAF file for more information)
#' will be added to the sample matrix in the summarized Experiment object.
#' @param mutant_variant_classification List of mutant_variant_classification that will be
#' consider a sample mutant or not. Default: "Frame_Shift_Del", "Frame_Shift_Ins",
#' "Missense_Mutation", "Nonsense_Mutation", "Splice_Site", "In_Frame_Del",
#' "In_Frame_Ins", "Translation_Start_Site", "Nonstop_Mutation"
#' @export
#' @examples
#' \dontrun{
#' query <- GDCquery(
#'   project = "TCGA-KIRP",
#'   data.category = "Simple Nucleotide Variation",
#'   data.type = "Masked Somatic Mutation"
#' )
#' GDCdownload(query, method = "api", directory = "maf")
#' maf <- GDCprepare(query, directory = "maf")
#'
#' }
#' @return A summarizedExperiment or a data.frame
#' @importFrom  S4Vectors DataFrame
#' @importFrom SummarizedExperiment metadata<-
#' @importFrom data.table setcolorder setnames
#' @importFrom GenomicRanges GRanges
#' @importFrom IRanges IRanges
#' @importFrom purrr map_chr
#' @author Tiago Chedraoui Silva
GDCprepare <- function(
        query,
        save = FALSE,
        save.filename,
        directory = "GDCdata",
        summarizedExperiment = TRUE,
        remove.files.prepared = FALSE,
        add.gistic2.mut = NULL,
        mutant_variant_classification = c(
            "Frame_Shift_Del",
            "Frame_Shift_Ins",
            "Missense_Mutation",
            "Nonsense_Mutation",
            "Splice_Site",
            "In_Frame_Del",
            "In_Frame_Ins",
            "Translation_Start_Site",
            "Nonstop_Mutation"
        )
){

    isServeOK()
    if(missing(query)) stop("Please set query parameter")

    test.duplicated.cases <- (
        any(
            duplicated(query$results[[1]]$cases)) & # any duplicated
            !(query$data.type %in% c(
                "Clinical data",
                "Protein expression quantification",
                "Raw intensities",
                "Masked Intensities",
                "Clinical Supplement",
                "Masked Somatic Mutation",
                "Biospecimen Supplement"
            )
            )
    )


    if(test.duplicated.cases) {
        dup <- query$results[[1]]$cases[duplicated(query$results[[1]]$cases)]
        cols <- c("tags","cases","experimental_strategy","analysis_workflow_type")
        cols <- cols[cols %in% colnames(query$results[[1]])]
        dup <- query$results[[1]][query$results[[1]]$cases %in% dup,cols]
        dup <- dup[order(dup$cases),]
        print(knitr::kable(dup))
        stop("There are samples duplicated. We will not be able to prepare it")
    }

    if (!save & remove.files.prepared) {
        stop("To remove the files, please set save to TRUE. Otherwise, the data will be lost")
    }

    # We save the files in project/data.category/data.type/file_id/file_name
    files <- file.path(
        query$results[[1]]$project,
        gsub(" ","_",query$results[[1]]$data_category),
        gsub(" ","_",query$results[[1]]$data_type),
        gsub(" ","_",query$results[[1]]$file_id),
        gsub(" ","_",query$results[[1]]$file_name)
    )

    files <- file.path(directory, files)

    # For IDAT prepare since we need to put all IDATs in the same folder the code below will not work
    # a second run
    if (!all(file.exists(files))) {
        # We have to check we moved the files
        if (
            unique(query$results[[1]]$data_type) == "Masked Intensities" |
            unique(query$results[[1]]$data_category) == "Raw microarray data"
        ){

            files.idat <- file.path(
                query$results[[1]]$project,
                gsub(" ","_",query$results[[1]]$data_category),
                gsub(" ","_",query$results[[1]]$data_type),
                gsub(" ","_",query$results[[1]]$file_name)
            )

            files.idat <- file.path(directory, files.idat)
            if (!all(file.exists(files) | file.exists(files.idat))) {
                stop(
                    paste0(
                        "I couldn't find all the files from the query. ",
                        "Please check if the directory parameter is right ",
                        "or `GDCdownload` downloaded the samples."
                    )
                )
            }
        } else {
            stop(
                paste0(
                    "I couldn't find all the files from the query. ",
                    "Please check if the directory parameter is right ",
                    "or `GDCdownload` downloaded the samples."
                )
            )
        }
    }

    cases <- ifelse(
        grepl("TCGA|TARGET|CGCI-HTMCP-CC|CPTAC-2|BEATAML1.0-COHORT",query$results[[1]]$project %>% unlist()),
        query$results[[1]]$cases,
        query$results[[1]]$sample.submitter_id
    )

    if (grepl("Transcriptome Profiling", query$data.category, ignore.case = TRUE)){

        if(unique(query$results[[1]]$experimental_strategy) == "scRNA-Seq"){
            #if (grepl("Single Cell Analysis", unique(query$results[[1]]$data_type), ignore.case = TRUE)){

            data <- readSingleCellAnalysis(
                files = files,
                data_format = unique(query$results[[1]]$data_format),
                workflow.type = unique(query$results[[1]]$analysis_workflow_type),
                cases = cases
            )
            return(data)
        } else {
            data <- readTranscriptomeProfiling(
                files = files,
                data.type = ifelse(!is.na(query$data.type),  as.character(query$data.type),  unique(query$results[[1]]$data_type)),
                workflow.type = unique(query$results[[1]]$analysis_workflow_type),
                cases = cases,
                summarizedExperiment
            )
        }
    } else if(grepl("Copy Number Variation",query$data.category,ignore.case = TRUE)) {
        if (unique(query$results[[1]]$data_type) == "Gene Level Copy Number Scores") {
            data <- readGISTIC(files, query$results[[1]]$cases)
        } else if (unique(query$results[[1]]$data_type) == "Gene Level Copy Number") {
            data <- read_gene_level_copy_number(
                files = files,
                cases = query$results[[1]]$sample.submitter_id,
                summarizedExperiment = summarizedExperiment
            )
        } else {
            data <- read_copy_number_variation(
                files = files, cases = query$results[[1]]$cases
            )
        }
    }  else if (grepl("Methylation Beta Value",unique(query$results[[1]]$data_type), ignore.case = TRUE)) {
        data <- readDNAmethylation(
            files = files,
            cases = cases,
            summarizedExperiment = summarizedExperiment,
            platform =  unique(query$results[[1]]$platform)
        )
    }  else if (grepl("Raw intensities|Masked Intensities",query$data.type, ignore.case = TRUE)) {
        # preparing IDAT files
        data <- readIDATDNAmethylation(
            files = files,
            barcode = cases,
            summarizedExperiment = summarizedExperiment,
            platform =  unique(query$results[[1]]$platform)
        )
    } else if (grepl("Proteome Profiling",query$data.category,ignore.case = TRUE)) {

        data <- readProteomeProfiling(files, cases = cases)

    } else if (grepl("Protein expression",query$data.category,ignore.case = TRUE)) {

        data <- readProteinExpression(files, cases = cases)

        if (summarizedExperiment) {
            message("SummarizedExperiment not implemented, if you need samples metadata use the function TCGAbiolinks:::colDataPrepare")
        }

    }  else if (grepl("Simple Nucleotide Variation",query$data.category,ignore.case = TRUE)) {

        if (grepl("Masked Somatic Mutation",query$results[[1]]$data_type[1],ignore.case = TRUE)){
            data <- readSimpleNucleotideVariationMaf(files)
        }

    }  else if (grepl("Clinical|Biospecimen", query$data.category, ignore.case = TRUE)){
        data <- read_clinical(files, query$data.type, cases = cases)
        summarizedExperiment <- FALSE
    } else if (grepl("Gene expression",query$data.category,ignore.case = TRUE)) {
        if (query$data.type == "Gene expression quantification")
            data <- read_gene_expression_quantification(
                files = files,
                cases = cases,
                summarizedExperiment = summarizedExperiment,
                genome = "hg38",
                experimental.strategy = unique(query$results[[1]]$experimental_strategy)
            )

        if (query$data.type == "miRNA gene quantification")
            data <- read_gene_expression_quantification(
                files = files,
                cases = cases,
                summarizedExperiment = FALSE,
                genome = "hg38",
                experimental.strategy = unique(query$results[[1]]$experimental_strategy)
            )

        if (query$data.type == "miRNA isoform quantification")
            data <- readmiRNAIsoformQuantification(
                files = files,
                cases = query$results[[1]]$cases
            )

        if (query$data.type == "Isoform expression quantification")
            data <- readIsoformExpressionQuantification(files = files, cases = cases)

        if (query$data.type == "Exon quantification")
            data <- readExonQuantification(
                files = files,
                cases = cases,
                summarizedExperiment = summarizedExperiment
            )

    }
    # Add data release to object
    if (summarizedExperiment & !is.data.frame(data)) {
        metadata(data) <- list("data_release" = getGDCInfo()$data_release)
    }


    if ((!is.null(add.gistic2.mut)) & summarizedExperiment) {
        message("=> Adding GISTIC2 and mutation information....")
        genes <- tolower(levels(EAGenes$Gene))
        if (!all(tolower(add.gistic2.mut) %in% genes)) {
            message(
                paste("These genes were not found:\n",
                      paste(add.gistic2.mut[! tolower(add.gistic2.mut) %in% genes],collapse = "\n=> ")
                )
            )
        }
        add.gistic2.mut <- add.gistic2.mut[tolower(add.gistic2.mut) %in% tolower(genes)]
        if (length(add.gistic2.mut) > 0){
            info <- colData(data)
            for(i in unlist(query$project)){
                info <- get.mut.gistc.information(
                    info,
                    i,
                    add.gistic2.mut,
                    mutant_variant_classification = mutant_variant_classification
                )
            }
            colData(data) <- info
        }
    }
    if("samples" %in% colnames(data)){
        if(any(duplicated(data$sample))) {
            message("Replicates found.")
            if(any(data$is_ffpe)) message("FFPE should be removed. You can modify the data with the following command:\ndata <- data[,!data$is_ffpe]")
            print(as.data.frame(colData(data)[data$sample %in% data$sample[duplicated(data$sample)],c("is_ffpe"),drop = FALSE]))
        }
    }


    if(save){
        if(missing(save.filename) & !missing(query)) save.filename <- paste0(query$project,gsub(" ","_", query$data.category),gsub(" ","_",date()),".RData")
        message(paste0("=> Saving file: ",save.filename))
        save(data, file = save.filename)
        message("=> File saved")

        # save is true, due to the check in the beggining of the code
        if(remove.files.prepared){
            # removes files and empty directories
            remove_files_recursively(files)
        }
    }

    return(data)
}

remove_files_recursively <- function(files){
    files2rm <- dirname(files)
    unlink(files2rm,recursive = TRUE)
    files2rm <- dirname(files2rm) # data category
    if(length(list.files(files2rm)) == 0) remove_files_recursively(files2rm)
}


read_clinical <- function(files, data.type, cases){
    if(data.type == "Clinical data"){
        suppressMessages({
            ret <- plyr::alply(files,.margins = 1,readr::read_tsv, .progress = "text")
        })
        names(ret) <- gsub("nationwidechildrens.org_","",gsub(".txt","",basename(files)))
    } else if(data.type %in% c("Clinical Supplement","Biospecimen Supplement")){
        ret <- plyr::alply(files,.margins = 1,function(f) {
            readr::read_tsv(f,col_types = readr::cols())
        }, .progress = "text")
        names(ret) <- gsub("nationwidechildrens.org_","",gsub(".txt","",basename(files)))
    }
    return(ret)
}


readSingleCellAnalysis <- function(
        files = files,
        data_format = NULL,
        workflow.type = NULL,
        cases = cases
) {

    if(data_format == "MEX" & workflow.type == "CellRanger - 10x Filtered Counts"){
        check_package("Seurat")
        ret <- plyr::llply(files,.fun = function(f){
            untar(tarfile = f,exdir = dirname(f))
            Seurat::Read10X(data.dir = gsub("\\.tar\\.gz","",f))
        },.progress = "time")
        names(ret) <- cases
    }

    if(data_format == "MEX" & workflow.type == "CellRanger - 10x Raw Counts"){
        ret <- plyr::llply(files,.fun = function(f){
            # uncompress raw file
            untar(tarfile = f,exdir = dirname(f))
            Read10X(data.dir = gsub("\\.tar\\.gz","",f))
        },.progress = "time")
        names(ret) <- cases
    }
    # TSV files
    if(data_format == "TSV"){
        ret <- plyr::llply(files,.fun = function(f){
            readr::read_tsv(f)
        },.progress = "time")
        names(ret) <- cases
    }

    if(data_format == "HDF5"){

        stop("We are not preparing loom files")
        # check_package("SeuratDisk")
        # check_package("Seurat")
        # ret <- SeuratDisk::Connect(filename = files, mode = "r")
        # ret <- Seurat::as.Seurat(ret)
        print(files)
    }

    # HDF5
    return(ret)
}

#' @importFrom tidyr separate
readExonQuantification <- function (
        files,
        cases,
        summarizedExperiment = TRUE
){
    pb <- txtProgressBar(min = 0, max = length(files), style = 3)
    assay.list <- NULL

    for (i in seq_along(files)) {
        data <- fread(files[i], header = TRUE, sep = "\t", stringsAsFactors = FALSE)

        if(!missing(cases)) {
            assay.list <- gsub(" |\\(|\\)|\\/","_",colnames(data)[2:ncol(data)])
            # We will use this because there might be more than one col for each samples
            setnames(data,colnames(data)[2:ncol(data)],
                     paste0(gsub(" |\\(|\\)|\\/","_",colnames(data)[2:ncol(data)]),"_",cases[i]))
        }
        if (i == 1) {
            df <- data
        } else {
            df <- merge(df, data, by=colnames(data)[1], all = TRUE)
        }

        setTxtProgressBar(pb, i)
    }
    setDF(df)
    rownames(df) <- df[,1]
    df <- df %>% separate(exon,into = c("seqnames","coordinates","strand"),sep = ":") %>%
        separate(coordinates,into = c("start","end"),sep = "-")

    if(summarizedExperiment) {
        suppressWarnings({
            assays <- lapply(assay.list, function (x) {
                return(data.matrix(subset(df, select = grep(x,colnames(df),ignore.case = TRUE))))
            })
        })
        names(assays) <- assay.list
        regex <- paste0(
            "[:alnum:]{4}-[:alnum:]{2}-[:alnum:]{4}",
            "-[:alnum:]{3}-[:alnum:]{3}-[:alnum:]{4}-[:alnum:]{2}"
        )
        samples <- na.omit(unique(str_match(colnames(df),regex)[,1]))
        colData <-  colDataPrepare(samples)
        assays <- lapply(assays, function(x){
            colnames(x) <- NULL
            rownames(x) <- NULL
            return(x)
        })
        rowRanges <- makeGRangesFromDataFrame(df)
        message("Available assays in SummarizedExperiment : \n  => ",paste(names(assays), collapse = "\n  => "))
        rse <- SummarizedExperiment(
            assays = assays,
            rowRanges = rowRanges,
            colData = colData
        )
        return(rse)
    }
    return(df)

}
readIsoformExpressionQuantification <- function (files, cases){
    pb <- txtProgressBar(min = 0, max = length(files), style = 3)

    for (i in seq_along(files)) {
        data <- fread(files[i], header = TRUE, sep = "\t", stringsAsFactors = FALSE)

        if(!missing(cases)) {
            assay.list <- gsub(" |\\(|\\)|\\/","_",colnames(data)[2:ncol(data)])
            # We will use this because there might be more than one col for each samples
            setnames(data,colnames(data)[2:ncol(data)],
                     paste0(gsub(" |\\(|\\)|\\/","_",colnames(data)[2:ncol(data)]),"_",cases[i]))
        }
        if (i == 1) {
            df <- data
        } else {
            df <- merge(df, data, by=colnames(data)[1], all = TRUE)
        }
        setTxtProgressBar(pb, i)
    }
    setDF(df)
    rownames(df) <- df[,1]
    df[,1] <- NULL
    return(df)

}
readmiRNAIsoformQuantification <- function (files, cases){
    pb <- txtProgressBar(min = 0, max = length(files), style = 3)

    for (i in seq_along(files)) {
        data <- fread(files[i], header = TRUE, sep = "\t", stringsAsFactors = FALSE)
        data$barcode <- cases[i]
        if (i == 1) {
            df <- data
        } else {
            df <- rbind(df, data)
        }
        setTxtProgressBar(pb, i)
    }
    setDF(df)

}

readSimpleNucleotideVariationMaf <- function(files){

    ret <- files |>
        purrr::map_dfr(.f = function(x) {
            tab <- readr::read_tsv(
                x,
                show_col_types = FALSE,
                comment = "#",
                col_types = readr::cols(
                    SOMATIC =  col_character(),
                    PUBMED = col_character(),
                    miRNA = col_character(),
                    HGVS_OFFSET = col_integer(),
                    PHENO = col_character(),
                    Entrez_Gene_Id = col_integer(),
                    Start_Position = col_integer(),
                    End_Position = col_integer(),
                    t_depth = col_integer(),
                    t_ref_count = col_integer(),
                    t_alt_count = col_integer(),
                    n_depth = col_integer(),
                    TRANSCRIPT_STRAND = col_integer(),
                    PICK = col_integer(),
                    TSL = col_integer(),
                    Allele =  col_character(),
                    Tumor_Seq_Allele1 =  col_character(),
                    Reference_Allele = col_character(),
                    Tumor_Seq_Allele2 = col_character(),
                    DISTANCE = col_integer()
                ))

            # empty MAF file
            # https://portal.gdc.cancer.gov/files/7917fcbe-cb66-447d-8ea8-3a324feee3fa
            if(nrow(tab) == 0) {return (NULL)}
            tab
        })

    return(ret)
}

read_gene_expression_quantification <- function(
        files,
        cases,
        genome = "hg19",
        summarizedExperiment = TRUE,
        experimental.strategy,
        platform
){
    skip <- unique((ifelse(experimental.strategy == "Gene expression array",1,0)))

    if(length(skip) > 1) stop("It is not possible to handle those different platforms together")

    print.header(paste0("Reading ", length(files)," files"),"subsection")
    ret <- plyr::alply(
        .data = seq_along(files),
        .margins = 1,
        .fun = function(i,cases){

            data <- fread(
                input = files[i],
                header = TRUE,
                sep = "\t",
                stringsAsFactors = FALSE,
                skip = skip
            )

            if(!missing(cases)) {
                assay.list <<- gsub(" |\\(|\\)|\\/","_",colnames(data)[2:ncol(data)])
                # We will use this because there might be more than one col for each samples
                setnames(
                    data,
                    colnames(data)[2:ncol(data)],
                    paste0(gsub(" |\\(|\\)|\\/","_",colnames(data)[2:ncol(data)]),"_",cases[i])
                )
            }
            data
        },.progress = "time",cases = cases)

    print.header(paste0("Merging ", length(files)," files"),"subsection")

    # Just check if the data is in the same order, since we will not merge
    # the data frames to save memory
    stopifnot(all(unlist(ret %>% map(function(y){all(y[,1] ==  ret[[1]][,1])}) )))

    # need to check if it works in all cases
    df <- ret %>% map( ~ (.x %>% dplyr::select(-1))) %>% bind_cols()
    df <- bind_cols(ret[[1]][,1],df)

    if (summarizedExperiment) {
        df <- make_se_from_gene_exoression_quantification(df, assay.list, genome = genome)
    } else {
        rownames(df) <- df$gene_id
        df$gene_id <- NULL
    }
    return(df)
}


make_se_from_gene_exoression_quantification <- function(
        df,
        assay.list,
        genome = "hg19"
){

    # Access genome information to create SE
    gene.location <- get.GRCh.bioMart(genome)

    if(all(grepl("\\|",df[[1]]))){
        aux <- strsplit(df$gene_id,"\\|")
        GeneID <- unlist(lapply(aux,function(x) x[2]))
        df$entrezgene_id <- as.numeric(GeneID)
        gene.location <- gene.location[!duplicated(gene.location$entrezgene_id),]
        df <- merge(df, gene.location, by = "entrezgene_id")
    } else {
        df$external_gene_name <- as.character(df[[1]])
        df <- merge(df, gene.location, by = "external_gene_name")
    }


    if("transcript_id" %in% assay.list){
        rowRanges <- GRanges(
            seqnames = paste0("chr", df$chromosome_name),
            ranges = IRanges(start = df$start_position,
                             end = df$end_position),
            strand = df$strand,
            gene_id = df$external_gene_name,
            entrezgene = df$entrezgene_id,
            ensembl_gene_id = df$ensembl_gene_id,
            transcript_id = subset(df, select = 5)
        )
        names(rowRanges) <- as.character(df$gene_id)
        assay.list <- assay.list[which(assay.list != "transcript_id")]
    } else {
        rowRanges <- GRanges(
            seqnames = paste0("chr", df$chromosome_name),
            ranges = IRanges(
                start = df$start_position,
                end = df$end_position
            ),
            strand = df$strand,
            gene_id = df$external_gene_name,
            entrezgene = df$entrezgene_id,
            ensembl_gene_id = df$ensembl_gene_id
        )
        names(rowRanges) <- as.character(df$external_gene_name)
    }

    suppressWarnings({
        assays <- lapply(assay.list, function(x) {
            return(
                data.matrix(
                    subset(df, select = grep(x,colnames(df),ignore.case = TRUE))
                )
            )
        })
    })

    names(assays) <- assay.list
    regex <- paste0("[:alnum:]{4}-[:alnum:]{2}-[:alnum:]{4}",
                    "-[:alnum:]{3}-[:alnum:]{3}-[:alnum:]{4}-[:alnum:]{2}")
    samples <- na.omit(unique(str_match(colnames(df),regex)[,1]))
    colData <-  colDataPrepare(samples)

    assays <- lapply(assays, function(x){
        colnames(x) <- NULL
        rownames(x) <- NULL
        return(x)
    })

    message("Available assays in SummarizedExperiment : \n  => ",paste(names(assays), collapse = "\n  => "))
    rse <- SummarizedExperiment(
        assays = assays,
        rowRanges = rowRanges,
        colData = colData
    )
    return(rse)
}


#' @importFrom downloader download
#' @importFrom S4Vectors DataFrame
makeSEFromDNAMethylationMatrix <- function(
        betas,
        genome = "hg38",
        met.platform = c(
            "Illumina Human Methylation 450",
            "Illumina Human Methylation 27",
            "Illumina Methylation Epic"
        )
) {
    message("=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-")
    message("Creating a SummarizedExperiment from DNA methylation input")

    # Instead of looking on the size, it is better to set it as a argument as the annotation is different
    annotation <-   getMetPlatInfo(platform = met.platform, genome = genome)

    rowRanges <- annotation[names(annotation) %in% rownames(betas),,drop = FALSE]

    colData <- tryCatch({
        colDataPrepare(colnames(betas))
    }, error = function(e){
        DataFrame(samples = colnames(betas))
    })
    betas <- betas[rownames(betas) %in% names(rowRanges),,drop = FALSE]
    betas <- betas[names(rowRanges),,drop = FALSE]
    assay <- data.matrix(betas)

    betas <- SummarizedExperiment(
        assays = assay,
        rowRanges = rowRanges,
        colData = colData
    )
    return(betas)
}

makeSEfromDNAmethylation <- function(df, probeInfo = NULL){
    if(is.null(probeInfo)) {
        rowRanges <- GRanges(
            seqnames = paste0("chr", df$Chromosome),
            ranges = IRanges(start = df$Genomic_Coordinate,
                             end = df$Genomic_Coordinate),
            probeID = df$Composite.Element.REF,
            Gene_Symbol = df$Gene_Symbol
        )

        names(rowRanges) <- as.character(df$Composite.Element.REF)
        colData <-  colDataPrepare(colnames(df)[5:ncol(df)])
        assay <- data.matrix(subset(df,select = c(5:ncol(df))))
    } else {
        rowRanges <- makeGRangesFromDataFrame(probeInfo, keep.extra.columns = TRUE)
        colData <-  colDataPrepare(colnames(df)[(ncol(probeInfo) + 1):ncol(df)])
        assay <- data.matrix(subset(df,select = c((ncol(probeInfo) + 1):ncol(df))))
    }
    colnames(assay) <- rownames(colData)
    rownames(assay) <- as.character(df$Composite.Element.REF)
    rse <- SummarizedExperiment(assays = assay, rowRanges = rowRanges, colData = colData)
}

readIDATDNAmethylation <- function(
        files,
        barcode,
        summarizedExperiment,
        platform
) {

    check_package("sesame")

    # Check if moved files would be moved outside of scope folder, if so, path doesn't change
    moved.files <- sapply(files,USE.NAMES = FALSE,function(x){
        if (grepl("Raw_intensities|Masked_Intensities",dirname(dirname(x)))) {
            return(file.path(dirname(dirname(x)), basename(x)))
        }
        return(x)
    })

    # for each file move it to upper parent folder if necessary
    plyr::a_ply(files, 1,function(x){
        if (grepl("Raw_intensities|Masked_Intensities",dirname(dirname(x)))) {
            tryCatch(
                move(x,
                     file.path(dirname(dirname(x)), basename(x)),
                     keep.copy = FALSE
                ),
                error = function(e){
                })
        }
    })

    samples <- unique(gsub("_Grn.idat|_Red.idat","",moved.files))
    message("Processing  IDATs with Sesame - http://bioconductor.org/packages/sesame/")
    message("Running opensesame - applying quality masking and nondetection masking (threshold P-value 0.05)")
    message("Please cite: doi: 10.1093/nar/gky691 and 10.1093/nar/gkt090")
    message("This might take a while....")
    betas <- sesame::openSesame(samples)  %>% as.matrix
    barcode <- unique(data.frame("file" = gsub("_Grn.idat|_Red.idat","",basename(moved.files)), "barcode" = barcode))
    colnames(betas) <- barcode$barcode[match(basename(samples),barcode$file)]

    if (summarizedExperiment) {

        betas <- makeSEFromDNAMethylationMatrix(
            betas = betas,
            genome ="hg38",
            met.platform = platform
        )
        colData(betas) <- DataFrame(colDataPrepare(colnames(betas)))
    }
    return(betas)

}

# We will try to make this function easier to use this function in its own data
# In case it is not TCGA I should not consider that there is a barcode in the header
# Instead the user should be able to add the names to his data
# The only problem is that the data from the user will not have all the columns
# TODO: Improve this function to be more generic as possible
#' @importFrom GenomicRanges makeGRangesFromDataFrame
#' @importFrom tibble as_data_frame
#' @importFrom data.table fread
readDNAmethylation <- function(
        files,
        cases,
        summarizedExperiment = TRUE,
        platform
){
    if(length(platform) > 1){

        print(knitr::kable(platform))
        stop("More than one DNA methylation platform found. Only one is accepted")
    }
    if (missing(cases)) cases <- NULL


    if (grepl("OMA00",platform)) {
        pb <- txtProgressBar(min = 0, max = length(files), style = 3)
        for (i in seq_along(files)) {
            data <- fread(
                files[i],
                header = TRUE,
                sep = "\t",
                stringsAsFactors = FALSE,
                skip = 1,
                na.strings = "N/A",
                colClasses = c(
                    "character", # Composite Element REF
                    "numeric" # # beta value
                )
            )
            setnames(data,gsub(" ", "\\.", colnames(data)))
            if (!is.null(cases)) setnames(data,2,cases[i])
            if (i == 1) {
                df <- data
            } else {
                df <- merge(df, data, by = "Composite.Element.REF")
            }
            setTxtProgressBar(pb, i)
        }
        setDF(df)
        rownames(df) <- df$Composite.Element.REF
        df$Composite.Element.REF <- NULL
    } else if (all(grepl("methylation_array.sesame.level3betas", files))){
        # methylation_array.sesame.level3betas has only two columns with not header
        print.header(paste0("Reading ", length(files)," files"),"subsection")

        x <- plyr::alply(files,1, function(f) {
            data <- fread(
                f,
                header = FALSE,
                sep = "\t",
                stringsAsFactors = FALSE,
                skip = 0,
                colClasses = c(
                    "character", # CpG
                    "numeric" # beta value
                )
            )
            setnames(data,gsub(" ", "\\.", colnames(data)))
            if (!is.null(cases)) setnames(data,2,cases[which(f == files)])
        }, .progress = "time")

        print.header(paste0("Merging ", length(files)," files"),"subsection")

        # Just check if the data is in the same order, since we will not merge
        # the data frames to save memory
        # C3N-01362-01 has less probes than C3L-00913-03 due to version of the array
        # CPTAC cohort: 55 samples with EPIC v1 and 1808  with EPIC V2
        # EPIC v1 has less probes than EPIC V2

        # In case we have multiple versions of the array we will
        # 1. Check the names of all of the same nrow
        # 2. Bind the ones with same nrow
        # 3. Full join the two objects
        nrow_vec <- purrr::map_int(x,nrow) # number of rows each file
        nrow_vec_numbers <- nrow_vec %>% unique # unique number of rows

        for(nb_rows in nrow_vec_numbers){
            aux <- x[which(nrow_vec == nb_rows)]
            stopifnot(all(unlist(aux %>% map(function(y){all(y[,1]$V1 ==  aux[[1]][,1]$V1)}) )))
        }

        df <- map(nrow_vec_numbers,.f = function(nb_rows){
            file_equal_probes <- x[which(nrow_vec == nb_rows)]
            df <- file_equal_probes %>% map_df(2)
            colnames(df) <- file_equal_probes %>% map_chr(.f = function(y) colnames(y)[2])
            df$V1 <- file_equal_probes[[1]]$V1
            if (any(duplicated(colnames(df)))){
                message("oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo")
                message("Duplicated samples names were found. Adding _rep suffix to name")
                message("oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo")
            }
            colnames(df)[duplicated(colnames(df))] <- paste0(colnames(df)[duplicated(colnames(df))],"_rep")
            df
        }) %>% purrr::reduce(dplyr::full_join,by = "V1") %>% as.data.frame()
        rownames(df) <- df$V1
        df$V1 <- NULL
        df <- data.matrix(df)

        if (summarizedExperiment) {

            df <- makeSEFromDNAMethylationMatrix(
                betas = df,
                genome = "hg38",
                met.platform = platform
            )
        }

    } else {
        skip <- ifelse(all(grepl("hg38",files)), 0,1)
        colClasses <- NULL
        if (!all(grepl("hg38",files))) {
            colClasses <- c(
                "character", # Composite Element REF
                "numeric",   # beta value
                "character", # Gene symbol
                "character", # Chromosome
                "integer"
            )
        }


        x <- plyr::alply(files,1, function(f) {
            data <- fread(
                f,
                header = TRUE,
                sep = "\t",
                stringsAsFactors = FALSE,
                skip = skip,
                colClasses = colClasses
            )
            setnames(data,gsub(" ", "\\.", colnames(data)))
            if (!is.null(cases)) setnames(data,2,cases[which(f == files)])
            setcolorder(data,c(1, 3:ncol(data), 2))
        }, .progress = "time")


        print.header(paste0("Merging ", length(files)," files"),"subsection")

        # Just check if the data is in the same order, since we will not merge
        # the data frames to save memory
        stopifnot(all(unlist(x %>% map(function(y){all(y[,1] ==  x[[1]][,1])}) )))

        # if hg38 we have 10 columns with probe metadata
        # if hg19 we have 4 columns with probe metadata
        idx.dnam <- grep("TCGA",colnames(x[[1]]))
        df <- x %>%  map_df(idx.dnam)
        colnames(df) <- x %>%  map_chr(.f = function(y) colnames(y)[idx.dnam])
        df <- bind_cols(x[[1]][,1:(idx.dnam-1)],df)

        if (summarizedExperiment) {
            if(skip == 0) {
                df <- makeSEfromDNAmethylation(
                    df,
                    probeInfo = data.frame(df)[,grep("TCGA",colnames(df),invert = TRUE)]
                )
            } else {
                df <- makeSEfromDNAmethylation(df)
            }
        } else {
            setDF(df)
            rownames(df) <- df$Composite.Element.REF
            df$Composite.Element.REF <- NULL
        }
    }
    return(df)
}

# Barcode example MMRF_1358_1_BM_CD138pos_T1_TSMRU_L02337
colDataPrepareMMRF <- function(
        barcode
){
    DataFrame(
        barcode = barcode,
        sample = barcode,
        patient = substr(barcode,1,9)
    )
}

colDataPrepareTARGET <- function(
        barcode
){

    message("Adding description to TARGET samples")
    tissue.code <- c(
        '01',
        '02',
        '03',
        '04',
        '05',
        '06',
        '07',
        '08',
        '09',
        '10',
        '11',
        '12',
        '13',
        '14',
        '15',
        '16',
        '17',
        '20',
        '40',
        '41',
        '42',
        '50',
        '60',
        '61',
        '85',
        '99'
    )

    definition <- c(
        "Primary solid Tumor", # 01
        "Recurrent Solid Tumor", # 02
        "Primary Blood Derived Cancer - Peripheral Blood", # 03
        "Recurrent Blood Derived Cancer - Bone Marrow", # 04
        "Additional - New Primary", # 05
        "Metastatic", # 06
        "Additional Metastatic", # 07
        "Tissue disease-specific post-adjuvant therapy", # 08
        "Primary Blood Derived Cancer - Bone Marrow", # 09
        "Blood Derived Normal", # 10
        "Solid Tissue Normal",  # 11
        "Buccal Cell Normal",   # 12
        "EBV Immortalized Normal", # 13
        "Bone Marrow Normal", # 14
        "Fibroblasts from Bone Marrow Normal", # 15
        "Mononuclear Cells from Bone Marrow Normal", # 16
        "Lymphatic Tissue Normal (including centroblasts)", # 17
        "Control Analyte", # 20
        "Recurrent Blood Derived Cancer - Peripheral Blood", # 40
        "Blood Derived Cancer- Bone Marrow, Post-treatment", # 41
        "Blood Derived Cancer- Peripheral Blood, Post-treatment", # 42
        "Cell line from patient tumor", # 50
        "Xenograft from patient not grown as intermediate on plastic tissue culture dish", # 60
        "Xenograft grown in mice from established cell lines", #61
        "Next Generation Cancer Model", # 85
        "Granulocytes after a Ficoll separation"
    ) # 99
    aux <- data.frame(tissue.code = tissue.code,definition)

    # Exceptions: TARGET-AML
    # "TARGET-20-PAYKXV-Sorted-CD34neg-Lymphoid-09A" 727f5e27-09e9-425f-9757-81da66c054bd
    # "TARGET-20-PAWUEX-EOI2-14A"  11fb7cce-06ad-445b-b09f-9dc1050e4cd4
    # "TARGET-20-PAUSTZ-EOI1-14A" 3ad6dfa7-734d-41b0-ad66-15f0cff630d0
    # "TARGET-20-PAYHMK-Sorted-leukemic-09A" f5bd72ae-919f-481c-8203-f878ee1c651a
    # "TARGET-20-D7-Myeloid-mock3-85" 88712125-67e5-4e47-a413-e55b522a641c
    # Normal case: TARGET-20-PANLXK-09A-03R
    # in case multiple equal barcode
    #regex <- paste0("[:alnum:]{6}-[:alnum:]{2}-[:alnum:]{6}",
    #                "-[:alnum:]{3}-[:alnum:]{3}")
    #samples <- str_match(barcode,regex)[,1]

    # this breaks for the exceptions
    if(!any(grepl(";",barcode))){
        ret <- data.frame(
            barcode = barcode,
            tumor.code = stringr::str_extract(pattern = "TARGET-[[:alnum:]]{2}",barcode) %>% gsub(pattern = "TARGET-","",.),
            sample = gsub(pattern = "-[[:alnum:]]{3}$","",barcode),
            patient = gsub(pattern = "-[[:alnum:]]{2,3}-[[:alnum:]]{3}$","",barcode),
            case.unique.id = gsub(pattern = "-[[:alnum:]]{2,3}-[[:alnum:]]{3}$","",barcode) %>%  gsub(pattern = "TARGET-[[:alnum:]]{2}-","",.),
            tissue.code = barcode %>% stringr::str_extract("[[:alnum:]]{2,3}-[[:alnum:]]{3}$") %>% stringr::str_extract("[[:alnum:]]{2,3}") %>% stringr::str_sub(1,2),
            nucleic.acid.code = barcode %>% stringr::str_extract("[[:alnum:]]{3}$")  %>% stringr::str_sub(3,3)
        )
    } else {
        # mixed samples case
        ret <- purrr::map_dfr(.x = barcode,.f = function(b){
            data.frame(
                barcode = b,
                tumor.code = stringr::str_extract(pattern = "TARGET-[[:alnum:]]{2}",b) %>% gsub(pattern = "TARGET-","",.),
                sample = b %>% stringr::str_split(";") %>% unlist %>% sapply(FUN = function(y) gsub(pattern = "-[[:alnum:]]{3}$","",y)) %>% paste0(collapse = ";"),
                patient = b %>% stringr::str_split(";") %>% unlist %>% sapply(FUN = function(y)  gsub(pattern = "-[[:alnum:]]{2,3}-[[:alnum:]]{3}$","",y)) %>% paste0(collapse = ";"),
                case.unique.id = b %>% stringr::str_split(";") %>% unlist %>% sapply(FUN = function(y)  gsub(pattern = "-[[:alnum:]]{2,3}-[[:alnum:]]{3}$","",y)  %>%  gsub(pattern = "TARGET-[[:alnum:]]{2}-","",.) %>% paste0(collapse = ";")),
                tissue.code = b %>% stringr::str_extract("[[:alnum:]]{2,3}-[[:alnum:]]{3}$") %>% stringr::str_extract("[[:alnum:]]{2,3}") %>% stringr::str_sub(1,2),
                nucleic.acid.code = b %>% stringr::str_extract("[[:alnum:]]{3}$")  %>% stringr::str_sub(3,3)
            )
        })
    }
    ret <-  ret %>% dplyr::left_join(aux, by = "tissue.code")

    tumor.code <- c('00','01','02','03','04','10','15','20','21','30','40',
                    '41','50','51','52','60','61','62','63','64','65','70','71','80','81')

    tumor.definition <- c(
        "Non-cancerous tissue", # 00
        "Diffuse Large B-Cell Lymphoma (DLBCL)", # 01
        "Lung Cancer (all types)", # 02
        "Cervical Cancer (all types)", # 03
        "Anal Cancer (all types)", # 04
        "Acute lymphoblastic leukemia (ALL)", # 10
        "Mixed phenotype acute leukemia (MPAL)", # 15
        "Acute myeloid leukemia (AML)", # 20
        "Induction Failure AML (AML-IF)", # 21
        "Neuroblastoma (NBL)", # 30
        "Osteosarcoma (OS)",  # 40
        "Ewing sarcoma",   # 41
        "Wilms tumor (WT)", # 50
        "Clear cell sarcoma of the kidney (CCSK)", # 51
        "Rhabdoid tumor (kidney) (RT)", # 52
        "CNS, ependymoma", # 60
        "CNS, glioblastoma (GBM)", # 61
        "CNS, rhabdoid tumor", # 62
        "CNS, low grade glioma (LGG)", # 63
        "CNS, medulloblastoma", # 64
        "CNS, other", # 65
        "NHL, anaplastic large cell lymphoma", # 70
        "NHL, Burkitt lymphoma (BL)", # 71
        "Rhabdomyosarcoma", #80
        "Soft tissue sarcoma, non-rhabdomyosarcoma"
    ) # 81
    aux <- data.frame(tumor.code = tumor.code,tumor.definition)
    ret <- ret %>% dplyr::left_join(aux, by = "tumor.code")

    nucleic.acid.code <- c('D','E','W','X','Y','R','S')
    nucleic.acid.description <-  c(
        "DNA, unamplified, from the first isolation of a tissue",
        "DNA, unamplified, from the first isolation of a tissue embedded in FFPE",
        "DNA, whole genome amplified by Qiagen (one independent reaction)",
        "DNA, whole genome amplified by Qiagen (a second, separate independent reaction)",
        "DNA, whole genome amplified by Qiagen (pool of 'W' and 'X' aliquots)",
        "RNA, from the first isolation of a tissue",
        "RNA, from the first isolation of a tissue embedded in FFPE"
    )
    aux <- data.frame(nucleic.acid.code = nucleic.acid.code,nucleic.acid.description)
    ret <- ret %>% dplyr::left_join(aux, by = "nucleic.acid.code")

    ret <- ret[match(barcode,ret$barcode),]
    rownames(ret) <- gsub("\\.","-",make.names(ret$barcode,unique=TRUE))
    ret$code <- NULL
    return(DataFrame(ret))
}

colDataPrepareTCGA <- function(barcode){
    # For the moment this will work only for TCGA Data
    # We should search what TARGET data means

    code <- c(
        '01','02','03','04','05','06','07','08','09','10','11',
        '12','13','14','20','40','50','60','61'
    )
    shortLetterCode <- c(
        "TP","TR","TB","TRBM","TAP","TM","TAM","THOC",
        "TBM","NB","NT","NBC","NEBV","NBM","CELLC","TRB",
        "CELL","XP","XCL"
    )

    definition <- c(
        "Primary solid Tumor", # 01
        "Recurrent Solid Tumor", # 02
        "Primary Blood Derived Cancer - Peripheral Blood", # 03
        "Recurrent Blood Derived Cancer - Bone Marrow", # 04
        "Additional - New Primary", # 05
        "Metastatic", # 06
        "Additional Metastatic", # 07
        "Human Tumor Original Cells", # 08
        "Primary Blood Derived Cancer - Bone Marrow", # 09
        "Blood Derived Normal", # 10
        "Solid Tissue Normal",  # 11
        "Buccal Cell Normal",   # 12
        "EBV Immortalized Normal", # 13
        "Bone Marrow Normal", # 14
        "Control Analyte", # 20
        "Recurrent Blood Derived Cancer - Peripheral Blood", # 40
        "Cell Lines", # 50
        "Primary Xenograft Tissue", # 60
        "Cell Line Derived Xenograft Tissue"
    ) # 61
    aux <- DataFrame(code = code,shortLetterCode,definition)

    # in case multiple equal barcode
    regex <- paste0("[:alnum:]{4}-[:alnum:]{2}-[:alnum:]{4}",
                    "-[:alnum:]{3}-[:alnum:]{3}-[:alnum:]{4}-[:alnum:]{2}")
    samples <- str_match(barcode,regex)[,1]

    ret <- DataFrame(
        barcode = barcode,
        patient = substr(barcode, 1, 12),
        sample = substr(barcode, 1, 16),
        code = substr(barcode, 14, 15)
    )
    ret <- merge(ret,aux, by = "code", sort = FALSE)
    ret <- ret[match(barcode,ret$barcode),]
    rownames(ret) <- gsub("\\.","-",make.names(ret$barcode,unique=TRUE))
    ret$code <- NULL
    return(DataFrame(ret))
}

#' @title Create samples information matrix for GDC samples
#' @description Create samples information matrix for GDC samples add subtype information
#' @param barcode TCGA or TARGET barcode
#' @importFrom plyr rbind.fill
#' @importFrom dplyr left_join
#' @examples
#'  metadata <- colDataPrepare(c("TCGA-OR-A5K3-01A","C3N-00321-01"))
#'  metadata <- colDataPrepare(c("BLGSP-71-06-00157-01A",
#'                               "BLGSP-71-22-00332-01A"))
#' @export
colDataPrepare <- function(barcode){
    # For the moment this will work only for TCGA Data
    # We should search what TARGET data means
    message("Starting to add information to samples")
    ret <- NULL

    if(all(grepl("TARGET",barcode))) ret <- colDataPrepareTARGET(barcode)
    if(all(grepl("TCGA",barcode))) ret <- colDataPrepareTCGA(barcode)
    if(all(grepl("MMRF",barcode))) ret <- colDataPrepareMMRF(barcode)

    # How to deal with mixed samples "C3N-02003-01;C3N-02003-021" ?
    # Check if this breaks the package
    if(any(grepl("C3N-|C3L-",barcode))) {
        ret <- data.frame(
            sample = map(barcode,.f = function(x) stringr::str_split(x,";") %>% unlist) %>% unlist()
        )
    }

    if(is.null(ret)) {
        ret <- data.frame(
            sample = barcode %>% unique,
            stringsAsFactors = FALSE
        )
    }

    message(" => Add clinical information to samples")
    # There is a limitation on the size of the string, so this step will be splited in cases of 100
    patient.info <- NULL

    patient.info <- splitAPICall(
        FUN = getBarcodeInfo,
        step = 10,
        items = ret$sample
    )

    if(!is.null(patient.info)) {
        ret$sample_submitter_id <- ret$sample %>% as.character()
        ret <- left_join(ret %>% as.data.frame, patient.info %>% unique, by = "sample_submitter_id")
    }
    ret$bcr_patient_barcode <- ret$sample %>% as.character()
    ret$sample_submitter_id <- ret$sample %>% as.character()
    if(!"project_id" %in% colnames(ret)) {
        if("disease_type" %in% colnames(ret)){
            aux <- getGDCprojects()[,c(5,7)]
            aux <- aux[aux$disease_type == unique(ret$disease_type),2]
            ret$project_id <- as.character(aux)
        }
    }
    # There is no subtype info for target, return as it is
    if(any(grepl("TCGA",barcode))) {
        ret <- addSubtypeInfo(ret)
    }

    # na.omit should not be here, exceptional case
    if(is.null(ret)) {
        return(
            data.frame(
                row.names = barcode,
                barcode,
                stringsAsFactors = FALSE
            )
        )
    }

    # Add purity information from http://www.nature.com/articles/ncomms9971
    # purity  <- getPurityinfo()
    # ret <- merge(ret, purity, by = "sample", all.x = TRUE, sort = FALSE)

    # Put data in the right order
    ret <- ret[!duplicated(ret$bcr_patient_barcode),]

    # This part might not work with multiple projects
    idx <- sapply(
        X = substr(barcode,1,min(stringr::str_length(ret$bcr_patient_barcode))),
        FUN =  function(x) {
            grep(x,ret$bcr_patient_barcode)
        }
    )
    # the code above does not work, since the projects have different string lengths
    if(all(na.omit(ret$project_id) %in% c("TARGET-ALL-P3","TARGET-AML"))) {
        idx <- sapply(gsub("-[[:alnum:]]{3}$","",barcode), function(x) {
            grep(x,ret$bcr_patient_barcode)
        })
    }

    if(any(ret$project_id == "CPTAC-3",na.rm = T)) {

        # only merge mixed samples
        mixed_samples <- grep(";",barcode,value = T)
        if(length(mixed_samples) > 0){
            mixed_samples <- mixed_samples %>% str_split(";") %>% unlist %>% unique

            ret_mixed_samples <- ret %>% dplyr::filter(sample_submitter_id %in% mixed_samples) %>%
                dplyr::group_by(submitter_id) %>%
                dplyr::summarise_all(~trimws(paste(unique(.), collapse = ';'))) %>%
                as.data.frame()
            ret <- rbind(ret_mixed_samples,ret)
        }
        idx <- match(barcode,ret$bcr_patient_barcode)

        #idx <- sapply(gsub("-[[:alnum:]]{3}$","",barcode), function(x) {
        #    if(grepl(";",x = x)) x <- stringr::str_split(x[1],";")[[1]][1] # mixed samples
        #    grep(x,ret$bcr_patient_barcode)
        #})

    }

    if(any(ret$project_id %in% c("CMI-MBC","TARGET-NBL"),na.rm = T)) {
        idx <- match(barcode,ret$bcr_patient_barcode)
        # Workaround for the moment, still need to understand the barcode (cases)
        # is TARGET-30-PAPKXS-01A-01D and not TARGET-30-PAPKXS-01A
        if(all(is.na(idx))){
            idx <- match(
                stringr::str_sub(barcode,1,min(stringr::str_length(ret$bcr_patient_barcode))),
                ret$bcr_patient_barcode
            )
        }
    }


    if(is.list(idx)){
        stop(
            "Prepare will not be possible.
            \nIf you are trying to prepare more than
             one different project at a time, please do it separately"
        )
    }


    ret <- ret[idx,]

    if("barcode" %in% colnames(ret)) ret$barcode <- barcode

    rownames(ret) <- barcode
    return(ret)
}

addSubtypeInfo <- function(ret){
    out <- NULL
    message(" => Adding TCGA molecular information from marker papers")
    message(" => Information will have prefix 'paper_' ")

    for(proj in na.omit(unique(ret$project_id))){
        if(grepl("TCGA",proj,ignore.case = TRUE)) {
            # remove letter from 01A 01B etc
            ret$sample.aux <- substr(ret$sample,1,15)

            tumor <- gsub("TCGA-","",proj)
            available <- c(
                "ACC",
                "BRCA",
                "BLCA",
                "CESC",
                "CHOL",
                "COAD",
                "ESCA",
                "GBM",
                "HNSC",
                "KICH",
                "KIRC",
                "KIRP",
                "LGG",
                "LUAD",
                "LUSC",
                "PAAD",
                "PCPG",
                "PRAD",
                "READ",
                "SKCM",
                "SARC",
                "STAD",
                "THCA",
                "UCEC",
                "UCS",
                "UVM"
            )
            if (grepl(paste(c(available,"all"),collapse = "|"),tumor,ignore.case = TRUE)) {
                subtype <- TCGAquery_subtype(tumor)
                colnames(subtype) <- paste0("paper_", colnames(subtype))

                if(all(str_length(subtype$paper_patient) == 12)){
                    # Subtype information were to primary tumor in priority
                    subtype$sample.aux <- paste0(subtype$paper_patient,"-01")
                }
                ret.aux <- ret[ret$sample.aux %in% subtype$sample.aux,]
                ret.aux <- merge(ret.aux,subtype, by = "sample.aux", all.x = TRUE)
                out <- rbind.fill(as.data.frame(out),as.data.frame(ret.aux))
            }
        }
    }
    if(is.null(out)) return(ret)

    # We need to put together the samples with subtypes with samples without subytpes
    ret.aux <- ret[!ret$sample %in% out$sample,]
    ret <- rbind.fill(as.data.frame(out),as.data.frame(ret.aux))
    ret$sample.aux <- NULL

    return(ret)
}

readProteinExpression <- function(files,cases) {
    pb <- txtProgressBar(min = 0, max = length(files), style = 3)
    for (i in seq_along(files)) {
        data <- read_tsv(file = files[i], col_names = TRUE,skip = 1, col_types = c("cn"))
        if(!missing(cases))  colnames(data)[2] <- cases[i]
        if(i == 1) df <- data
        if(i != 1) df <- merge(df, data,all=TRUE, by="Composite Element REF")
        setTxtProgressBar(pb, i)
    }
    close(pb)

    return(df)
}

readProteomeProfiling <- function(files,cases) {

    list.of.protein.df <- plyr::alply(files,1, function(f) {
        data <- readr::read_tsv(
            file = f,
            show_col_types = FALSE,
            col_names = TRUE,
            progress = FALSE
        )
        colnames(data)[ncol(data)] <- cases[which(f == files)]
        data
    }, .progress = "time")

    # Just check if the data is in the same order, since we will not merge
    # the data frames to save memory

    df <- tryCatch({
        stopifnot(all(unlist(list.of.protein.df %>% map(function(y){all(y[,5] ==  list.of.protein.df[[1]][,5])}) )))

        # need to check if it works in all cases
        # tested for HTSeq - FPKM-UQ and Counts only
        bind_cols(list.of.protein.df[[1]][,1:5],list.of.protein.df %>%  map_df(6))
    },error = function(e){
        message("Some files have a  different number of proteins, we will introduce NA for the missing values")
        plyr::join_all(dfs = list.of.protein.df ,type = "full",by = c("AGID","lab_id","catalog_number","set_id","peptide_target"))
    })

    if(!missing(cases))  colnames(df)[-c(1:5)] <- cases

    return(df)
}

makeSEfromProteomeProfiling <- function(){

}

makeSEfromTranscriptomeProfilingSTAR <- function(
        data,
        cases
){
    # How many cases do we have?
    # We wil consider col 1 is the ensemble gene id, other ones are data
    size <- ncol(data)
    # Prepare Patient table
    colData <-  colDataPrepare(cases)

    # one ensemblID can be mapped to multiple entrezgene ID
    gene.location <- get.GRCh.bioMart("hg38",as.granges = TRUE)

    metrics <- subset(data, !grepl("ENSG", data$gene_id))
    data <- subset(data, grepl("ENSG", data$gene_id))
    found.genes <- table(data$gene_id %in% gene.location$gene_id)

    if ("FALSE" %in% names(found.genes)){
        message(paste0("From the ", nrow(data), " genes we couldn't map ", found.genes[["FALSE"]]))
    }

    # Prepare data table
    # Remove the version from the ensembl gene id
    assays <- list(
        data.matrix(data[,grep("^unstranded",colnames(data)),with = FALSE]),
        data.matrix(data[,grep("stranded_first",colnames(data)),with = FALSE]),
        data.matrix(data[,grep("stranded_second",colnames(data)),with = FALSE]),
        data.matrix(data[,grep("tpm_unstrand",colnames(data)),with = FALSE]),
        data.matrix(data[,grep("fpkm_unstrand",colnames(data)),with = FALSE]),
        data.matrix(data[,grep("fpkm_uq_unstrand",colnames(data)),with = FALSE])
    )
    names(assays) <- c(
        "unstranded",
        "stranded_first",
        "stranded_second",
        "tpm_unstrand",
        "fpkm_unstrand",
        "fpkm_uq_unstrand"
    )
    assays <- lapply(assays, function(x){
        colnames(x) <- NULL
        rownames(x) <- NULL
        return(x)
    })

    # Prepare rowRanges
    rowRanges <- gene.location[match(data$gene_id, gene.location$gene_id),]
    names(rowRanges) <- as.character(data$gene_id)


    message("Available assays in SummarizedExperiment : \n  => ",paste(names(assays), collapse = "\n  => "))
    rse <- SummarizedExperiment(
        assays = assays,
        rowRanges = rowRanges,
        colData = colData
    )
    metadata(rse) <- metrics
    return(rse)
}


makeSEfromTranscriptomeProfiling <- function(data, cases, assay.list){
    # How many cases do we have?
    # We wil consider col 1 is the ensemble gene id, other ones are data
    size <- ncol(data)
    # Prepare Patient table
    colData <-  colDataPrepare(cases)

    # one ensemblID can be mapped to multiple entrezgene ID
    gene.location <- get.GRCh.bioMart("hg38")
    gene.location <- gene.location[!duplicated(gene.location$ensembl_gene_id),]

    data$ensembl_gene_id <- as.character(gsub("\\.[0-9]*","",data$X1))
    data <- subset(data, grepl("ENSG", data$ensembl_gene_id))
    found.genes <- table(data$ensembl_gene_id %in% gene.location$ensembl_gene_id)

    if("FALSE" %in% names(found.genes))
        message(paste0("From the ", nrow(data), " genes we couldn't map ", found.genes[["FALSE"]]))

    data <- merge(data, gene.location, by = "ensembl_gene_id")

    # Prepare data table
    # Remove the version from the ensembl gene id
    assays <- list(data.matrix(data[,2:size+1]))
    names(assays) <- assay.list
    assays <- lapply(assays, function(x){
        colnames(x) <- NULL
        rownames(x) <- NULL
        return(x)
    })

    # Prepare rowRanges
    rowRanges <- GRanges(
        seqnames = paste0("chr", data$chromosome_name),
        ranges = IRanges(
            start = data$start_position,
            end = data$end_position
        ),
        strand = data$strand,
        ensembl_gene_id = data$ensembl_gene_id,
        external_gene_name = data$external_gene_name,
        original_ensembl_gene_id = data$X1
    )
    names(rowRanges) <- as.character(data$ensembl_gene_id)
    message("Available assays in SummarizedExperiment : \n  => ",paste(names(assays), collapse = "\n  => "))
    rse <- SummarizedExperiment(
        assays = assays,
        rowRanges = rowRanges,
        colData = colData
    )

    return(rse)
}


#' @importFrom dplyr left_join
#' @importFrom plyr alply join_all
#' @importFrom purrr map_dfc map map_df
readTranscriptomeProfiling <- function(
        files,
        data.type,
        workflow.type,
        cases,
        summarizedExperiment
) {

    if(grepl("Gene Expression Quantification", data.type, ignore.case = TRUE)){
        # Status working for:
        #  - htseq
        #  - FPKM
        #  - FPKM-UQ
        if(grepl("HTSeq",workflow.type)){

            x <- plyr::alply(files,1, function(f) {
                readr::read_tsv(
                    file = f,
                    col_names = FALSE,
                    progress = FALSE,
                    col_types = c("cd")
                )
            }, .progress = "time")

            # Just check if the data is in the same order, since we will not merge
            # the data frames to save memory
            stopifnot(all(unlist(x %>% map(function(y){all(y[,1] ==  x[[1]][,1])}) )))

            # need to check if it works in all cases
            # tested for HTSeq - FPKM-UQ and Counts only
            df <- bind_cols(x[[1]][,1],x %>%  map_df(2))
            if(!missing(cases))  colnames(df)[-1] <- cases
            if(summarizedExperiment) df <- makeSEfromTranscriptomeProfiling(df,cases,workflow.type)
        } else  if(grepl("STAR",workflow.type)){

            # read files that has 4 not necessary rows, and has several columns
            # gene_id gene_name gene_type
            # unstranded stranded_first stranded_second tpm_unstranded fpkm_unstranded
            x <- plyr::alply(files,1, function(f) {
                data.table::fread(f)
            }, .progress = "time")

            df <- data.table::rbindlist(
                x, use.names = TRUE, idcol = "case_barcode"
            )

            # Exception to the code below: CPTAC-3
            # Sample barcode in CPTAC-3 does not handle duplicates
            # we will need to work with aliquots for it or remove duplicated
            # files. Example: C3N-02765-02

            if(!missing(cases))  {
                df$case_barcode <- factor(
                    cases[df$case_barcode %>% as.numeric()],
                    levels = unique(cases)
                )
            }

            # this part changes the cases order if not a factor
            df <- data.table::dcast(
                data = df,
                formula = gene_id + gene_name + gene_type ~ case_barcode,
                value.var = colnames(df)[-c(1:4)]
            )

            # Adding barcodes to columns names, if user wants a dataframe

            if(summarizedExperiment) {
                df <- makeSEfromTranscriptomeProfilingSTAR(
                    data = df,
                    cases = cases
                )
            }
        }
    } else if(grepl("miRNA", workflow.type, ignore.case = TRUE) & grepl("miRNA", data.type, ignore.case = TRUE)) {
        pb <- txtProgressBar(min = 0, max = length(files), style = 3)
        for (i in seq_along(files)) {
            data <- read_tsv(file = files[i], col_names = TRUE,col_types = "cidc")
            if(!missing(cases))
                colnames(data)[2:ncol(data)] <- paste0(colnames(data)[2:ncol(data)],"_",cases[i])

            if(i == 1) df <- data
            if(i != 1) df <- merge(df, data, by=colnames(df)[1],all = TRUE)
            setTxtProgressBar(pb, i)
        }
        close(pb)

    } else if(grepl("Isoform Expression Quantification", data.type, ignore.case = TRUE)){
        pb <- txtProgressBar(min = 0, max = length(files), style = 3)
        for (i in seq_along(files)) {
            data <- read_tsv(file = files[i], col_names = TRUE, col_types = c("ccidcc"))
            if(!missing(cases)) data$barcode <- cases[i] else data$file <- i
            if(i == 1) df <- data
            if(i != 1) df <- rbind(df,data)
            setTxtProgressBar(pb, i)
        }
        close(pb)
    }
    return(df)
}

read_gene_level_copy_number <- function(
        files,
        cases,
        summarizedExperiment = FALSE
){
    message("Reading Gene Level Copy Number files")
    gistic.df <- NULL
    gistic.list <- plyr::alply(files,1,.fun = function(file) {
        #message("Reading file: ", file)
        data <- read_tsv(
            file = file,
            col_names = TRUE,
            progress = TRUE,
            col_types = readr::cols()
        )
        colnames(data)[-c(1:5)] <- paste0(cases[match(file,files)],"_",  colnames(data)[-c(1:5)])

        return(data)
    })

    # Check if the data is in the same order
    stopifnot(all(unlist(gistic.list %>% map(function(y){all(y[,1:5] ==  gistic.list[[1]][,1:5])}) )))

    # need to check if it works in all cases
    # tested for HTSeq - FPKM-UQ and Counts only
    df <- bind_cols(
        gistic.list[[1]][,1:5], # gene info
        gistic.list %>%  map_dfc(.f = function(x) x[,6:8]) # copy number, min,max
    )

    if(summarizedExperiment) {
        se <- make_se_from_gene_level_copy_number(df, cases)
        return(se)
    }
    return(df)
}

make_se_from_gene_level_copy_number <- function(df, cases){
    message("Creating a SummarizedExperiment object")
    rowRanges <- GRanges(
        seqnames = df$chromosome,
        ranges = IRanges(start = df$start, end = df$end),
        gene_id = df$gene_id,
        gene_name = df$gene_name
    )

    names(rowRanges) <- as.character(df$gene_id)
    colData <-  colDataPrepare(cases)

    # We have three data columns for each files
    assays <- lapply(
        c("[^max|min]_copy_number","min_copy_number", "max_copy_number"),
        function(x){
            ret <- data.matrix(subset(df,select = grep(x,colnames(df))))
            colnames(ret) <- cases
            rownames(ret) <- NULL
            ret
        })
    names(assays) <- c("copy_number","min_copy_number", "max_copy_number")

    message("Available assays in SummarizedExperiment : \n  => ",paste(names(assays), collapse = "\n  => "))
    rse <- SummarizedExperiment(assays = assays, rowRanges = rowRanges, colData = colData)
    return(rse)
}


readGISTIC <- function(files, cases){
    message("Reading GISTIC file")
    gistic.df <- NULL
    gistic.list <- plyr::alply(files,1,.fun = function(file) {
        message("Reading file: ", file)
        data <- read_tsv(
            file = file,
            col_names = TRUE,
            progress = TRUE,
            col_types = readr::cols()
        )

        aliquot <- colnames(data)[-c(1:3)]
        info <- splitAPICall(
            FUN = getBarcodefromAliquot,
            step = 20,
            items = aliquot
        )

        barcode <- as.character(info$submitter_id)[match(aliquot,as.character(info$aliquot_id))]
        colnames(data)[-c(1:3)] <- barcode
        return(data)
    })
    gistic.df <- gistic.list %>%
        join_all(by =  c("Gene Symbol","Gene ID","Cytoband"), type='full')

    return(gistic.df)
}

# Reads Copy Number Variation files to a data frame, basically it will rbind it
#' @importFrom purrr map2_dfr
read_copy_number_variation <- function(files, cases){
    message("Reading copy number variation files")

    col_types <- ifelse(any(grepl('ascat2', files)),"ccnnnnn","ccnnnd")

    purrr::map2_dfr(
        .x = files,
        .y = cases,
        .f = function(file,case) {
            data <- readr::read_tsv(file, col_names = TRUE, col_types = col_types);
            if(!missing(case)) data$Sample <- case
            data
        })
}

# getBarcodeInfo(c("TCGA-A6-6650-01B"))
#  getBarcodeInfo(c("DLBCL10508-sample"))
addFFPE <- function(df) {
    message("Add FFPE information. More information at: \n=> https://cancergenome.nih.gov/cancersselected/biospeccriteria \n=> http://gdac.broadinstitute.org/runs/sampleReports/latest/FPPP_FFPE_Cases.html")
    barcode <- df$barcode
    patient <- df$patient

    ffpe.info <- NULL
    ffpe.info <- splitAPICall(FUN = getFFPE,
                              step = 20,
                              items = df$patient)

    df <- merge(df, ffpe.info,by.x = "sample", by.y = "submitter_id")
    df <- df[match(barcode,df$barcode),]
    return(df)
}

# getFFPE("TCGA-A6-6650")
#' @importFrom plyr rbind.fill
#' @importFrom httr content
getFFPE <- function(patient){
    baseURL <- "https://api.gdc.cancer.gov/cases/?"
    options.pretty <- "pretty=true"
    options.expand <- "expand=samples"
    option.size <- paste0("size=",length(patient))
    options.filter <- paste0(
        "filters=",
        URLencode('{"op":"and","content":[{"op":"in","content":{"field":"cases.submitter_id","value":['),
        paste0('"',paste(patient,collapse = '","')),
        URLencode('"]}}]}')
    )
    url <- paste0(baseURL,paste(options.pretty,options.expand, option.size, options.filter, sep = "&"))
    json  <- tryCatch(
        getURL(url,fromJSON,timeout(600),simplifyDataFrame = TRUE),
        error = function(e) {
            message(paste("Error: ", e, sep = " "))
            message("We will retry to access GDC again! URL:")
            #message(url)
            fromJSON(content(getURL(url,GET,timeout(600)), as = "text", encoding = "UTF-8"), simplifyDataFrame = TRUE)
        }
    )

    results <- json$data$hits
    results <- rbind.fill(results$samples)[,c("submitter_id","is_ffpe")]
    return(results)
}

getAliquot_ids <- function(barcode){
    baseURL <- "https://api.gdc.cancer.gov/cases/?"
    options.fields <- "fields=samples.portions.analytes.aliquots.aliquot_id,samples.portions.analytes.aliquots.submitter_id"
    options.pretty <- "pretty=true"
    option.size <- paste0("size=",length(barcode))
    #message(paste(barcode,collapse = '","'))
    #message(paste0('"',paste(barcode,collapse = '","')))
    options.filter <- paste0(
        "filters=",
        URLencode('{"op":"and","content":[{"op":"in","content":{"field":"cases.submitter_id","value":['),
        paste0('"',paste(barcode,collapse = '","')),
        URLencode('"]}}]}')
    )
    #message(paste0(baseURL,paste(options.pretty,options.expand, option.size, options.filter, sep = "&")))
    url <- paste0(baseURL,paste(options.pretty,options.fields, option.size, options.filter, sep = "&"))
    json  <- tryCatch(
        getURL(url,fromJSON,timeout(600),simplifyDataFrame = TRUE),
        error = function(e) {
            message(paste("Error: ", e, sep = " "))
            message("We will retry to access GDC again! URL:")
            #message(url)
            fromJSON(content(getURL(url,GET,timeout(600)), as = "text", encoding = "UTF-8"), simplifyDataFrame = TRUE)
        }
    )
    results <- unlist(json$data$hits$samples)
    results.barcode <- grep("TCGA",results,value = TRUE)
    results.aliquot <- grep("TCGA",results,value = TRUE,invert = TRUE)

    df <- data.frame(results.aliquot,results.barcode)
    colnames(df) <- c("aliquot_id","barcode")
    return(df)
}


# getBarcodeInfo(c("TCGA-OR-A5K3-01A","C3N-00321-01"))
# barcode is: sample_submitter_id
#' @importFrom dplyr bind_cols slice row_number
#'
getBarcodeInfo <- function(barcode) {
    baseURL <- "https://api.gdc.cancer.gov/cases/?"
    options.pretty <- "pretty=true"
    options.expand <- "expand=samples,project,diagnoses,diagnoses.treatments,annotations,family_histories,demographic,exposures"
    option.size <- paste0("size=",length(barcode))
    options.filter <- paste0("filters=",
                             URLencode('{"op":"or","content":[{"op":"in","content":{"field":"cases.submitter_id","value":['),
                             paste0('"',paste(barcode,collapse = '","')),
                             URLencode('"]}},'),
                             URLencode('{"op":"in","content":{"field":"submitter_sample_ids","value":['),
                             paste0('"',paste(barcode,collapse = '","')),
                             URLencode('"]}},'),
                             URLencode('{"op":"in","content":{"field":"submitter_aliquot_ids","value":['),
                             paste0('"',paste(barcode,collapse = '","')),
                             URLencode('"]}}'),
                             URLencode(']}')
    )
    url <- paste0(baseURL,paste(options.pretty,options.expand, option.size, options.filter, sep = "&"))
    #message(url)
    json  <- tryCatch(
        getURL(url,fromJSON,timeout(600),simplifyDataFrame = TRUE),
        error = function(e) {
            message(paste("Error: ", e, sep = " "))
            message("We will retry to access GDC again! URL:")
            #message(url)
            fromJSON(content(getURL(url,GET,timeout(600)), as = "text", encoding = "UTF-8"), simplifyDataFrame = TRUE)
        }
    )

    results <- json$data$hits

    # no results
    if(length(results) == 0){
        return(data.frame(barcode,stringsAsFactors = FALSE))
    }

    submitter_id <- results$submitter_id
    submitter_aliquot_ids <- results$submitter_aliquot_ids

    if(!is.null(results$samples)) {
        samples <- rbindlist(results$samples, fill = TRUE)
        samples <- samples[match(barcode,samples$submitter_id),]
        samples$sample_submitter_id <- str_extract_all(
            samples$submitter_id,paste(barcode,collapse = "|")) %>%
            unlist %>% as.character

        tryCatch({
            samples$submitter_id <-
                str_extract_all(
                    samples$submitter_id,
                    paste(c(submitter_id,barcode), collapse = "|"),
                    simplify = TRUE
                ) %>% as.character
        }, error = function(e){
            samples$submitter_id <- submitter_id
        })
        df <- samples[!is.na(samples$submitter_id),]
        suppressWarnings({
            df[,c("updated_datetime","created_datetime")] <- NULL
        })
    }


    # We dont have the same cols for TCGA and TARGET so we need to check them
    if(!is.null(results$diagnoses)) {
        diagnoses <- rbindlist(lapply(results$diagnoses, function(x) if(is.null(x)) data.frame(NA) else x),fill = TRUE)
        diagnoses[,c("updated_datetime","created_datetime","state")] <- NULL
        if(any(grepl("submitter_id", colnames(diagnoses)))) {
            diagnoses$submitter_id <- gsub("-diagnosis|_diagnosis.*|-DIAG|diag-","", diagnoses$submitter_id)
        }  else {
            diagnoses$submitter_id <- submitter_id
        }
        # this is required since the sample might not have a diagnosis
        if(!any(df$submitter_id %in% diagnoses$submitter_id)){
            diagnoses$submitter_id <- NULL
            # The sample migth have different sample types
            # The diagnosis the same for each one of these samples
            # in that case we will have a 1 to mapping and binding will
            # not work. We need then to replicate diagnosis to each sample
            # and not each patient
            # Cases can be replicated with getBarcodeInfo(c("BA2691R","BA2577R","BA2748R"))
            if(nrow(diagnoses) <  nrow(df)){
                diagnoses <- plyr::ldply(
                    1:length(results$submitter_sample_ids),
                    .fun = function(x){
                        diagnoses[x] %>% # replicate diagnoses the number of samples
                            as.data.frame() %>%
                            dplyr::slice(rep(dplyr::row_number(), sum(results$submitter_sample_ids[[x]] %in% barcode)))})
            }

            df <- dplyr::bind_cols(df %>% as.data.frame,diagnoses %>% as.data.frame)
        } else {
            df <- left_join(df, diagnoses, by = "submitter_id")
        }
    }
    if(!is.null(results$exposures)) {
        exposures <- rbindlist(
            lapply(results$exposures, function(x) if(is.null(x)) data.frame(NA) else x),
            fill = TRUE
        )
        exposures[,c("updated_datetime","created_datetime","state")] <- NULL
        if(any(grepl("submitter_id", colnames(exposures)))) {
            exposures$submitter_id <- gsub("-exposure|_exposure.*|-EXP","", exposures$submitter_id)
        }  else {
            exposures$submitter_id <- submitter_id
        }
        if(!any(df$submitter_id %in% exposures$submitter_id)){
            exposures$submitter_id <- NULL
            df <- dplyr::bind_cols(df,exposures)
        } else {
            df <- left_join(df, exposures, by = "submitter_id")
        }
    }


    if(!is.null(results$demographic)) {
        demographic <- results$demographic
        demographic[,c("updated_datetime","created_datetime","state")] <- NULL
        if(any(grepl("submitter_id", colnames(demographic)))) {
            demographic$submitter_id <- gsub(
                "-demographic|_demographic.*|-DEMO|demo-",
                "",
                results$demographic$submitter_id
            )
        } else {
            demographic$submitter_id <- submitter_id
        }

        if(!any(df$submitter_id %in% demographic$submitter_id)){
            demographic$submitter_id <- NULL
            demographic$updated_datetime  <- NULL
            demographic$created_datetime <- NULL
            # The sample migth have different sample types
            # The diagnosis the same for each one of these samples
            # in that case we will have a 1 to mapping and binding will
            # not work. We need then to replicate diagnosis to each sample
            # and not each patient
            # Cases can be replicated with getBarcodeInfo(c("BA2691R","BA2577R","BA2748R"))
            if(nrow(demographic) <  nrow(df)){
                demographic <- plyr::ldply(
                    1:length(results$submitter_sample_ids),
                    .fun = function(x){
                        demographic[x,] %>% # replicate diagnoses the number of samples
                            as.data.frame() %>%
                            dplyr::slice(
                                rep(dplyr::row_number(), sum(results$submitter_sample_ids[[x]] %in% barcode)))
                    })
            }

            df <- dplyr::bind_cols(df  %>% as.data.frame,demographic)
        } else {
            df <- left_join(df,demographic, by = "submitter_id")
        }
    }

    df$bcr_patient_barcode <- df$submitter_id %>% as.character()
    projects.info <- results$project
    projects.info <- results$project[,grep("state",colnames(projects.info),invert = TRUE)]

    if(any(submitter_id %in% df$submitter_id)){
        projects.info <-  cbind("submitter_id" = submitter_id, projects.info)

        suppressWarnings({
            df <- left_join(
                df,
                projects.info,
                by = "submitter_id"
            )
        })
    } else {

        if(nrow(projects.info) <  nrow(df)){
            projects.info <- plyr::ldply(
                1:length(results$submitter_sample_ids),
                .fun = function(x){
                    projects.info[x,] %>% # replicate diagnoses the number of samples
                        as.data.frame() %>%
                        dplyr::slice(
                            rep(dplyr::row_number(), sum(results$submitter_sample_ids[[x]] %in% barcode)))
                })
        }

        df <- dplyr::bind_cols(df,projects.info)
    }

    # Adding in the same order


    if(any(substr(barcode,1,str_length(df$submitter_id)) %in% df$submitter_id)){
        df <- df[match(substr(barcode,1,str_length(df$sample_submitter_id)),df$sample_submitter_id),]
        # This line should not exists, but some patients does not have clinical data
        # case: TCGA-R8-A6YH"
        # this has been reported to GDC, waiting answers
        # So we will remove this NA cases
        df <- df[!is.na(df$submitter_id),]
    } else {
        idx <- sapply(substr(barcode,1,str_length(df$submitter_aliquot_ids) %>% max),
                      FUN = function(x){
                          grep(x,df$submitter_aliquot_ids)
                      })
        df <- df[idx,]
    }

    # remove empty columns
    df <- df %>% as.data.frame() %>% dplyr::select(which(colSums(is.na(df)) < nrow(df)))
    return(df)
}

#' @title Prepare CEL files into an AffyBatch.
#' @description Prepare CEL files into an AffyBatch.
#' @param ClinData write
#' @param PathFolder write
#' @param TabCel write
#' @examples
#' \dontrun{
#' to add example
#' }
#' @export
#' @return Normalized Expression data from Affy eSets
TCGAprepare_Affy <- function(ClinData, PathFolder, TabCel){
    if (!requireNamespace("affy", quietly = TRUE)) {
        stop("affy package is needed for this function to work. Please install it.",
             call. = FALSE)
    }
    if (!requireNamespace("Biobase", quietly = TRUE)) {
        stop("affy package is needed for this function to work. Please install it.",
             call. = FALSE)
    }
    affy_batch <- affy::ReadAffy(filenames = as.character(paste(TabCel$samples, ".CEL", sep = "")))

    eset <- affy::rma(affy_batch)

    mat <- Biobase::exprs(eset)

    return(mat)

}

#' @title Retrieve multiple tissue types not from the same patients.
#' @description
#'   TCGAquery_SampleTypes for a given list of samples and types,
#'    return the union of samples that are from theses type.
#' @param barcode is a list of samples as TCGA barcodes
#' @param typesample a character vector indicating tissue type to query.
#' Example:
#' \tabular{ll}{
#'TP \tab   PRIMARY SOLID TUMOR \cr
#'TR \tab   RECURRENT SOLID TUMOR \cr
#'TB \tab   Primary Blood Derived Cancer-Peripheral Blood \cr
#'TRBM \tab Recurrent Blood Derived Cancer-Bone Marrow \cr
#'TAP \tab  Additional-New Primary \cr
#'TM \tab   Metastatic \cr
#'TAM \tab  Additional Metastatic \cr
#'THOC \tab Human Tumor Original Cells \cr
#'TBM \tab  Primary Blood Derived Cancer-Bone Marrow \cr
#'NB \tab   Blood Derived Normal \cr
#'NT \tab   Solid Tissue Normal \cr
#'NBC \tab  Buccal Cell Normal \cr
#'NEBV \tab EBV Immortalized Normal \cr
#'NBM \tab  Bone Marrow Normal \cr
#'}
#' @export
#' @examples
#' # selection of normal samples "NT"
#' barcode <- c("TCGA-B0-4698-01Z-00-DX1","TCGA-CZ-4863-02Z-00-DX1")
#' # Returns the second barcode
#'  TCGAquery_SampleTypes(barcode,"TR")
#'  # Returns both barcode
#'  TCGAquery_SampleTypes(barcode,c("TR","TP"))
#'  barcode <- c("TARGET-20-PANSBH-14A-02D","TARGET-20-PANSBH-01A-02D",
#'               "TCGA-B0-4698-01Z-00-DX1","TCGA-CZ-4863-02Z-00-DX1")
#'   TCGAquery_SampleTypes(barcode,c("TR","TP"))
#' @return a list of samples / barcode filtered by type sample selected
TCGAquery_SampleTypes <- function(barcode,typesample){
    # Tumor AND Solid Tissue Normal NOT FROM THE SAME PATIENTS
    table.code <- c('01','02','03','04','05','06','07','08','09','10',
                    '11','12','13','14','20','40','50','60','61')
    names(table.code) <- c("TP","TR","TB","TRBM","TAP","TM","TAM","THOC",
                           "TBM","NB","NT","NBC","NEBV","NBM","CELLC","TRB",
                           "CELL","XP","XCL")

    if (sum(is.element(typesample,names(table.code))) == length(typesample)) {
        string <- sapply(barcode,function(x) substr(unlist(stringr::str_split(x,"-"))[4],1,2))

        barcode.all <- NULL
        for (sample.i in typesample) {
            barcode.all <- union(barcode.all,
                                 barcode[grep(table.code[sample.i], string)])
        }
        return(barcode.all)
    } else {
        return("Error message: one or more sample types do not exist")
    }
}

#' @title Retrieve multiple tissue types from the same patients.
#' @description
#'   TCGAquery_MatchedCoupledSampleTypes
#' @param barcode barcode
#' @param typesample typesample
#' @examples
#'  TCGAquery_MatchedCoupledSampleTypes(c("TCGA-B0-4698-01Z-00-DX1",
#'                              "TCGA-B0-4698-02Z-00-DX1"),
#'                              c("TP","TR"))
#'  barcode <- c("TARGET-20-PANSBH-02A-02D","TARGET-20-PANSBH-01A-02D",
#'               "TCGA-B0-4698-01Z-00-DX1","TCGA-CZ-4863-02Z-00-DX1",
#'               "TARGET-20-PANSZZ-02A-02D","TARGET-20-PANSZZ-11A-02D",
#'               "TCGA-B0-4699-01Z-00-DX1","TCGA-B0-4699-02Z-00-DX1"
#'               )
#'   TCGAquery_MatchedCoupledSampleTypes(barcode,c("TR","TP"))
#' @export
#' @return a list of samples / barcode filtered by type sample selected
TCGAquery_MatchedCoupledSampleTypes <- function(barcode,typesample){
    # Tumor AND Solid Tissue Normal FROM THE SAME PATIENTS
    table.code <- c('01','02','03','04','05','06','07','08','09','10',
                    '11','12','13','14','20','40','50','60','61')
    names(table.code) <- c("TP","TR","TB","TRBM","TAP","TM","TAM","THOC",
                           "TBM","NB","NT","NBC","NEBV","NBM","CELLC","TRB",
                           "CELL","XP","XCL")
    if(length(typesample)!=2){
        return("Error message: exactly two types need to be provided")
    }

    if(sum(is.element(typesample,names(table.code))) == length(typesample)) {

        string <- sapply(barcode,function(x) substr(unlist(stringr::str_split(x,"-"))[4],1,2))
        barcode.1 <- barcode[grep(table.code[typesample[1]], string)]
        barcode.2 <- barcode[grep(table.code[typesample[2]], string)]
        barcode.common <- intersect(sapply(barcode.1,function(x) paste(unlist(stringr::str_split(x,"-"))[1:3],collapse = "-")),
                                    sapply(barcode.2,function(x) paste(unlist(stringr::str_split(x,"-"))[1:3],collapse = "-")))
        if(length(barcode.common) > 0){
            idx1 <- unlist(lapply(barcode.common, function(x) grep(x,barcode.1)))
            idx2 <- unlist(lapply(barcode.common, function(x) grep(x,barcode.2)))
            return(union(barcode.1[idx1], barcode.2[idx2]))
        } else {
            return("Error message: there exist no matched samples")
        }
    } else {
        return("Error message: one or more sample types do not exist")
    }
}


#' @title Get GDC clinical data
#' @description
#' GDCquery_clinic will download all clinical information from the API
#' as the one with using the button from each project
#' @param project A valid project (see list with getGDCprojects()$project_id)]
#' \itemize{
#' \item{ BEATAML1.0-COHORT }
#' \item{ BEATAML1.0-CRENOLANIB }
#' \item{ CGCI-BLGSP }
#' \item{ CPTAC-2 }
#' \item{ CPTAC-3 }
#' \item{ CTSP-DLBCL1 }
#' \item{ FM-AD }
#' \item{ HCMI-CMDC }
#' \item{ MMRF-COMMPASS }
#' \item{ NCICCR-DLBCL }
#' \item{ OHSU-CNL }
#' \item{ ORGANOID-PANCREATIC }
#' \item{ TARGET-ALL-P1 }
#' \item{ TARGET-ALL-P2 }
#' \item{ TARGET-ALL-P3 }
#' \item{ TARGET-AML }
#' \item{ TARGET-CCSK }
#' \item{ TARGET-NBL }
#' \item{ TARGET-OS }
#' \item{ TARGET-RT }
#' \item{ TARGET-WT }
#' \item{ TCGA-ACC }
#' \item{ TCGA-BLCA }
#' \item{ TCGA-BRCA }
#' \item{ TCGA-CESC }
#' \item{ TCGA-CHOL }
#' \item{ TCGA-COAD }
#' \item{ TCGA-DLBC }
#' \item{ TCGA-ESCA }
#' \item{ TCGA-GBM }
#' \item{ TCGA-HNSC }
#' \item{ TCGA-KICH }
#' \item{ TCGA-KIRC }
#' \item{ TCGA-KIRP }
#' \item{ TCGA-LAML }
#' \item{ TCGA-LGG }
#' \item{ TCGA-LIHC }
#' \item{ TCGA-LUAD }
#' \item{ TCGA-LUSC }
#' \item{ TCGA-MESO }
#' \item{ TCGA-OV }
#' \item{ TCGA-PAAD }
#' \item{ TCGA-PCPG }
#' \item{ TCGA-PRAD }
#' \item{ TCGA-READ }
#' \item{ TCGA-SARC }
#' \item{ TCGA-SKCM }
#' \item{ TCGA-STAD }
#' \item{ TCGA-TGCT }
#' \item{ TCGA-THCA }
#' \item{ TCGA-THYM }
#' \item{ TCGA-UCEC }
#' \item{ TCGA-UCS }
#' \item{ TCGA-UVM }
#' \item{ VAREPOP-APOLLO }
#' }
#' @param type A valid type. Options "clinical", "Biospecimen"  (see list with getGDCprojects()$project_id)]
#' @param save.csv Write clinical information into a csv document
#' @export
#' @importFrom data.table rbindlist as.data.table
#' @importFrom jsonlite fromJSON
#' @importFrom dplyr summarise
#' @examples
#' clinical <- GDCquery_clinic(
#'    project = "TCGA-ACC",
#'    type = "clinical",
#'    save.csv = FALSE
#'  )
#' clinical <- GDCquery_clinic(
#'    project = "TCGA-ACC",
#'    type = "biospecimen",
#'    save.csv = FALSE
#' )
#' \dontrun{
#' clinical_cptac_3 <- GDCquery_clinic(
#'    project = "CPTAC-3",
#'    type = "clinical"
#' )
#' clinical_cptac_2 <- GDCquery_clinic(
#'    project = "CPTAC-2",
#'    type = "clinical"
#' )
#' clinical_HCMI_CMDC <- GDCquery_clinic(
#'    project = "HCMI-CMDC",
#'    type = "clinical"
#' )
#' clinical_GCI_HTMCP_CC <- GDCquery_clinic(
#'    project = "CGCI-HTMCP-CC",
#'    type = "clinical"
#' )
#' clinical <- GDCquery_clinic(
#'    project = "NCICCR-DLBCL",
#'    type = "clinical"
#' )
#' clinical <- GDCquery_clinic(
#'    project = "ORGANOID-PANCREATIC",
#'    type = "clinical"
#' )
#' }
#' @return A data frame with the clinical information
#' @author Tiago Chedraoui Silva
GDCquery_clinic <- function(
        project,
        type = "clinical",
        save.csv = FALSE
){
    checkProjectInput(project)

    if (length(project) > 1) {
        stop("Please, project should be only one valid project")
    }

    if (!grepl("clinical|Biospecimen",type,ignore.case = TRUE)) {
        stop("Type must be clinical or Biospecimen")
    }

    baseURL <- "https://api.gdc.cancer.gov/cases/?"
    options.pretty <- "pretty=true"

    if (grepl("clinical",type,ignore.case = TRUE)) {
        options.expand <- "expand=diagnoses,diagnoses.treatments,annotations,family_histories,demographic,exposures"
        option.size <- paste0("size=",getNbCases(project,"Clinical"))
        files.data_category <- "Clinical"
    } else {
        options.expand <- "expand=samples,samples.portions,samples.portions.analytes,samples.portions.analytes.aliquots"
        option.size <- paste0("size=",getNbCases(project,"Biospecimen"))
        files.data_category <- "Biospecimen"
    }

    if (grepl("TCGA",project)){
        options.filter <- paste0(
            "filters=",
            URLencode('{"op":"and","content":[{"op":"in","content":{"field":"cases.project.project_id","value":["'),
            project,
            URLencode('"]}},{"op":"in","content":{"field":"files.data_category","value":["'),
            files.data_category,
            URLencode('"]}}]}')
        )
    } else {
        options.filter <- paste0(
            "filters=",
            URLencode('{"op":"in","content":{"field":"cases.project.project_id","value":["'),
            project,
            URLencode('"]}}')
        )
    }
    url <- paste0(baseURL,paste(options.pretty,options.expand, option.size, options.filter,"format=json", sep = "&"))
    json  <- tryCatch(
        getURL(url,fromJSON,timeout(600),simplifyDataFrame = TRUE),
        error = function(e) {
            fromJSON(content(getURL(url,GET,timeout(600)), as = "text", encoding = "UTF-8"), simplifyDataFrame = TRUE)
        }
    )


    #message(paste0(baseURL,paste(options.pretty,options.expand, option.size, options.filter, sep = "&")))
    results <- json$data$hits

    if (grepl("clinical",type,ignore.case = TRUE)) {
        if (grepl("TCGA",project)) {
            df <- data.frame("submitter_id" = results$submitter_id)
            if ("diagnoses" %in% colnames(results)){
                diagnoses <- rbindlist(lapply(results$diagnoses, function(x) if(is.null(x)) data.frame(NA) else x),fill = T)
                diagnoses$submitter_id <- gsub("_diagnosis","", diagnoses$submitter_id)

                # we are getting more results than what we should
                diagnoses <- diagnoses[diagnoses$submitter_id %in% df$submitter_id,]
                df <- merge(df,diagnoses, by="submitter_id", all = TRUE, sort = FALSE)
            }

            if ("exposures" %in% colnames(results)){
                exposures <- rbindlist(results$exposures, fill = TRUE)
                exposures <- exposures[,-c("updated_datetime","state","created_datetime")]
                exposures$submitter_id <- gsub("_exposure","", exposures$submitter_id)
                exposures <- exposures[exposures$submitter_id %in% df$submitter_id,]
                df <- merge(df, exposures, by = "submitter_id", all = TRUE, sort = FALSE)
            }

            if ("demographic" %in% colnames(results)){
                results$demographic$submitter_id <- gsub("_demographic","", results$demographic$submitter_id)
                demographic <- results$demographic[!is.na(results$demographic$submitter_id),]
                demographic <- demographic[demographic$submitter_id %in% df$submitter_id,]
                df <- merge(
                    df,
                    as.data.table(demographic)[,-c("updated_datetime","state","created_datetime")],
                    by = "submitter_id",
                    all = TRUE,
                    sort = FALSE
                )
            }

            if( "treatments" %in% colnames(df)) {

                treatments <- purrr::map_dfr(
                    df$treatments,
                    .f = function(row) {
                        if(is.data.frame(row)) {
                            return(row)
                        } else {
                            NULL
                        }
                    })

                df$treatments <- NULL

                # case where all treatments are NULL
                if (!nrow(treatments) == 0) {

                    treatments$submitter_id <- gsub("_treatment(_[0-9])?|_treatment([0-9])?","", treatments$submitter_id)
                    treatments <- treatments %>% dplyr::select(
                        !c("updated_datetime", "state", "created_datetime")
                    )
                    treatments <- treatments[treatments$submitter_id %in% df$submitter_id,]


                    # we have now two types of treatment
                    treatments.pharmaceutical <- treatments[grep("Pharmaceutical",treatments$treatment_type,ignore.case = TRUE),]
                    treatments.radiation <- treatments[grep("radiation",treatments$treatment_type,ignore.case = TRUE),]

                    # Adding a prefix
                    colnames(treatments.pharmaceutical) <- paste0("treatments_pharmaceutical_",colnames(treatments.pharmaceutical))
                    colnames(treatments.radiation) <- paste0("treatments_radiation_",colnames(treatments.radiation))
                    colnames(treatments.radiation)[grep("submitter",colnames(treatments.radiation))] <- "submitter_id"
                    colnames(treatments.pharmaceutical)[grep("submitter",colnames(treatments.pharmaceutical))] <- "submitter_id"

                    # If there are two rows for the same submitter_id
                    # we will collapse them into one single row
                    # concatenating all columns using ;
                    aux <- treatments.pharmaceutical %>% dplyr::group_by(submitter_id) %>%
                        dplyr::summarise(
                            across(everything(),~ paste(unique(.), collapse = ";"))
                        )
                    df <- merge(df, as.data.table(aux), by = "submitter_id",  all = TRUE, sort = FALSE)

                    # If there are two rows for the same submitter_id
                    # we will collapse them into one single row
                    # concatenating all columns using ;
                    aux <- treatments.radiation %>% dplyr::group_by(submitter_id) %>%
                        dplyr::summarise(
                            across(everything(),~ paste(unique(.), collapse = ";"))
                        )
                    df <- merge(df, as.data.table(aux), by = "submitter_id",  all = TRUE, sort = FALSE)
                }
            }

            df$bcr_patient_barcode <- df$submitter_id
            df$project <- project
            df <- df %>% dplyr::relocate(project)

        } else {

            # Although for TCGA and TARGET IDs from diagnosis, treatments, exposures etc are the same
            # for the other projects this might not be true!
            # example: ORGANOID-PANCREATIC
            # https://api.gdc.cancer.gov/cases/?pretty=true&expand=diagnoses,demographic&size=1&filters=%7B%22op%22:%22in%22,%22content%22:%7B%22field%22:%22cases.project.project_id%22,%22value%22:[%22ORGANOID-PANCREATIC%22]%7D%7D&format=json
            # DEMOGRAPHIC 48, while everything else is 42
            df <- data.frame("submitter_id" = results$submitter_id)

            if("disease_type" %in% colnames(results)){
                disease_type <- data.frame("disease_type" = results$disease_type)
                df <- cbind(df,disease_type)
            }
            if("primary_site" %in% colnames(results)){
                primary_site <- data.frame("primary_site" = results$primary_site)
                df <- cbind(df,primary_site)
            }

            if ("diagnoses" %in% colnames(results)) {
                diagnoses <- rbindlist(
                    lapply(
                        results$diagnoses,
                        function(x) {
                            if(is.null(x)) {
                                data.frame(NA)
                            } else {
                                # HTMCP-03-06-02061 has two diagnosis
                                x$submitter_id <- gsub("_diagnosis.*|-diagnosis.*","",x$submitter_id)
                                # If there are two rows for the same submitter_id
                                # we will collapse them into one single row
                                # concatenating all columns using ;
                                aux <- x %>% dplyr::group_by(submitter_id) %>%
                                    dplyr::summarise(
                                        across(everything(),~ paste(unique(.), collapse = ";"))
                                    )

                                aux$treatments <- list(dplyr::bind_rows(x$treatments))
                                aux
                            }
                        }
                    ), fill = TRUE
                )
                #df$submitter_id <- gsub("^d|_diagnosis|diag-|-DX|-DIAG|-diagnosis","", df$submitter_id)
                # ^d ORGANOID-PANCREATIC
                # -DX CPTAC-2
                # -DIAG CPTAC-3
                # -diagnosis NCICCR-DLBCL
                # _diagnosis HCMI-CMDC
                df <- cbind(df,diagnoses)
            }
            if("exposures" %in% colnames(results)){
                exposures <- rbindlist(lapply(results$exposures, function(x) if(is.null(x)) data.frame(NA) else x),fill = T)
                exposures <- exposures[,-c("updated_datetime","state","created_datetime")]
                df <- cbind(df,exposures)
            }
            if("treatments" %in% colnames(results)){
                treatments <- rbindlist(results$treatments, fill = TRUE)
                df$treatments <- NULL
                df <- cbind(df,treatments)
            }
            if("submitter_sample_ids" %in% colnames(results)){
                submitter_sample_ids <- lapply(
                    results$submitter_sample_ids,
                    function(x) {
                        paste(x,collapse = ",")
                    }
                ) %>% unlist
                df <- cbind(df,submitter_sample_ids)
            }

            # We do a merge because some cases might not have demographic information
            # DEMOGRAPHIC ORGANOID-PANCREATIC
            # -demographic NCICCR-DLBCL
            # _demographic HCMI-CMDC
            # -DG and -DM CPTAC-2
            # -DEMO CPTAC-3
            if("demographic" %in% colnames(results)){
                results$demographic$submitter_id <- gsub("_demographic|DEMOGRAPHIC|_demographic|demo-|-DG|-DM|-DEMO","", results$demographic$submitter_id)
                demographic <-  results$demographic %>% dplyr::select(-c("updated_datetime","state","created_datetime"))
                df <- cbind(df,demographic)
            }

            df$project <- project
            df <- df %>% dplyr::relocate(project)
        }

        if (nrow(results) != nrow(df)) {
            stop("Error: API returned more information")
        }

    } else {
        df <- rbindlist(results$samples,fill = TRUE)
    }

    if (save.csv) {
        if(grepl("biospecimen",type))  {
            df$portions <- NULL
            message("Portion column is a list, it will be removed. Please check object with save.csv argument as FALSE")
        }
        if (grepl("clinical",type))  {
            df$treatments <- NULL
            message("Treatments column is a list, it will be removed. Please check object with save.csv argument as FALSE")
        }
        write_csv(df,paste0(project,"_",type,".csv"))
    }
    setDF(df)
    return(df)
}

#' @title Parsing clinical xml files
#' @description
#' This function receives the query argument and parses the clinical xml files
#' based on the desired information
#' @param query Result from GDCquery, with data.category set to Clinical
#' @param clinical.info Which information should be retrieved.
#' Options Clinical: drug, admin, follow_up,radiation, patient, stage_event or new_tumor_event
#' Options Biospecimen: protocol, admin, aliquot, analyte, bio_patient, sample, portion, slide
#' @param directory Directory/Folder where the data was downloaded. Default: GDCdata
#' @importFrom xml2 read_xml xml_ns
#' @importFrom XML xmlParse getNodeSet xmlToDataFrame
#' @importFrom plyr rbind.fill
#' @importFrom dplyr mutate_all funs
#' @return A data frame with the parsed values from the XML
#' @export
#' @examples
#' query <- GDCquery(
#'   project = "TCGA-COAD",
#'   data.category = "Clinical",
#'   data.format = "bcr xml",
#'   barcode = c("TCGA-RU-A8FL","TCGA-AA-3972")
#' )
#' GDCdownload(query)
#' clinical <- GDCprepare_clinic(query,"patient")
#' clinical.drug <- GDCprepare_clinic(query,"drug")
#' clinical.radiation <- GDCprepare_clinic(query,"radiation")
#' clinical.admin <- GDCprepare_clinic(query,"admin")
#' \dontrun{
#' query <- GDCquery(
#'    project = "TCGA-COAD",
#'    data.category = "Biospecimen",
#'    data.format = "bcr xml",
#'    data.type = "Biospecimen Supplement",
#'    barcode = c("TCGA-RU-A8FL","TCGA-AA-3972")
#' )
#' GDCdownload(query)
#' clinical <- GDCprepare_clinic(query,"admin")
#' clinical.drug <- GDCprepare_clinic(query,"sample")
#' clinical.radiation <- GDCprepare_clinic(query,"portion")
#' clinical.admin <- GDCprepare_clinic(query,"slide")
#' }
GDCprepare_clinic <- function(
        query,
        clinical.info,
        directory = "GDCdata"
){

    if (unique(query$results[[1]]$data_category) == "Clinical") {
        valid.clinical.info <- c(
            "drug",
            "admin",
            "follow_up",
            "radiation",
            "patient",
            "stage_event",
            "new_tumor_event"
        )
    } else  if (unique(query$results[[1]]$data_category) == "Biospecimen" ) {
        valid.clinical.info <- c(
            "protocol",
            "admin",
            "aliquot",
            "analyte",
            "bio_patient",
            "sample",
            "portion",
            "slide"
        )
    } else  if (unique(query$results[[1]]$data_category) == "Other") {
        valid.clinical.info <- c("admin","msi")
    } else {
        stop("Data category should be Clinical or Biospecimen or Other (auxiliary files)")
    }

    if (missing(clinical.info) || !(clinical.info %in% valid.clinical.info)) {
        stop(
            "Please set clinical.info argument:\n=> ",
            paste(valid.clinical.info, collapse = "\n=> ")
        )
    }

    # Get all the clincal xml files

    files <- file.path(
        query$results[[1]]$project,
        gsub(" ","_",query$results[[1]]$data_category),
        gsub(" ","_",query$results[[1]]$data_type),
        gsub(" ","_",query$results[[1]]$file_id),
        gsub(" ","_",query$results[[1]]$file_name)
    )
    files <- file.path(directory, files)
    if(!all(file.exists(files))) {
        stop(
            "I couldn't find all the files from the query.",
            "Please check directory parameter right"
        )
    }

    xpath <- NULL

    disease <- tolower(gsub("TCGA-","",unlist(query$project)))
    if(tolower(clinical.info) == "drug") xpath <- "//rx:drug"
    else if(tolower(clinical.info) == "admin") xpath <- "//admin:admin"
    else if(tolower(clinical.info) == "radiation") xpath <- "//rad:radiation"
    else if(tolower(clinical.info) == "patient") xpath <- paste0("//",disease,":patient")
    else if(tolower(clinical.info) == "stage_event") xpath <- "//shared_stage:stage_event"
    else if(tolower(clinical.info) == "new_tumor_event") xpath <- paste0("//",disease,"_nte:new_tumor_event")
    # biospecimen xpaths
    else if(tolower(clinical.info) == "sample") xpath <- "//bio:sample"
    else if(tolower(clinical.info) == "bio_patient")  xpath <- "//bio:patient"
    else if(tolower(clinical.info) == "analyte") xpath <- "//bio:analyte"
    else if(tolower(clinical.info) == "aliquot") xpath <- "//bio:aliquot"
    else if(tolower(clinical.info) == "protocol") xpath <- "//bio:protocol"
    else if(tolower(clinical.info) == "portion") xpath <- "//bio:portion"
    else if(tolower(clinical.info) == "slide") xpath <- "//bio:slide"
    else if(tolower(clinical.info) == "msi") xpath <- "//auxiliary:microsatellite_instability_test_result"

    if (tolower(clinical.info) == "follow_up") {
        clin <- parseFollowup(files, xpath, clinical.info)
    } else {
        clin <- parseXML(files,xpath,clinical.info)
        if (is.null(clin)) return(NULL)
        clin <- merge(clin,getResults(query)[,c("project","cases")],by.x = c("bcr_patient_barcode"), by.y = "cases",all.x = TRUE)
    }

    if (tolower(clinical.info) == "patient") {
        composed.cols <- c("new_tumor_events","drugs","follow_ups","radiations")
        composed.cols <- composed.cols[composed.cols %in% colnames(clin)]
        message("To get the following information please change the clinical.info argument")
        message("=> new_tumor_events: new_tumor_event \n=> drugs: drug \n=> follow_ups: follow_up \n=> radiations: radiation")

        for (i in composed.cols) {
            clin[,i] <- as.character(clin[,i])
            clin[!clin[,i] %in%  c("","NO"),i] <- "YES"
            clin[clin[,i] %in% c("","NO"),i] <- "NO"

            if (i == "new_tumor_events") {
                followup <- parseFollowup(files,xpath,clinical.info)
                barcode <- followup$bcr_patient_barcode[!followup$new_tumor_events %in% c("","NO")]
                clin[clin$bcr_patient_barcode %in% barcode,i] <- "YES"
            }
            colnames(clin)[which(colnames(clin) == i)] <- paste0("has_",i,"_information")
        }

        if ("stage_event" %in% colnames(clin)) {
            message("Adding stage event information")
            aux <- parseXML(files,"//shared_stage:stage_event","stage_event")
            colnames(aux)[grep("bcr_patient_barcode",colnames(aux),invert = TRUE)] <- paste0("stage_event_",grep("bcr_patient_barcode",colnames(aux),invert = TRUE,value = TRUE))
            clin <- merge(clin, aux, by = "bcr_patient_barcode" , sort = FALSE, all.x = TRUE)
            clin$stage_event <- NULL
        }

        if ("primary_pathology" %in% colnames(clin)) {
            message("Adding primary pathology information")
            aux <- parseXML(files,paste0("//",disease,":primary_pathology"),"primary_pathology")
            # Last column is the idx to merge
            colnames(aux)[grep("bcr_patient_barcode",colnames(aux),invert = TRUE)] <- paste0("primary_pathology_",grep("bcr_patient_barcode",colnames(aux),invert = TRUE,value = TRUE))
            clin <- merge(clin, aux, by = "bcr_patient_barcode" , sort = FALSE, all.x = TRUE)
            clin$primary_pathology <- NULL
        }

        # Update clinical data with follow-ups: days_to_last_followup and vital_status
        message("Updating days_to_last_followup and vital_status from follow_up information using last entry")
        followup <- parseFollowup(files,xpath,clinical.info)

        if(nrow(followup) > 0){
            followup_last <- followup %>%
                dplyr::group_by(bcr_patient_barcode) %>%
                dplyr::summarise(
                    days_to_last_followup = ifelse(
                        all(is.na(as.numeric(days_to_last_followup))),
                        NA,
                        max(as.numeric(days_to_last_followup),na.rm = TRUE)
                    ),
                    vital_status = vital_status[
                        ifelse(
                            any(followup$days_to_last_followup %in% ""),
                            which(followup$days_to_last_followup %in% ""),
                            which.max(days_to_last_followup)
                        )
                    ]
                )
            clin$days_to_last_followup <- followup_last$days_to_last_followup[match(clin$bcr_patient_barcode,followup_last$bcr_patient_barcode)]
            clin$vital_status <- followup_last$vital_status[match(clin$bcr_patient_barcode,followup_last$bcr_patient_barcode)]
        }
    }

    if (tolower(clinical.info) == "sample") {
        clin$portions <- NULL
        clin$samples <- NULL
    }

    if (tolower(clinical.info) == "bio_patient") {
        clin$samples <- NULL
    }

    if (tolower(clinical.info) == "portion") {
        for (i in c("slides","analytes")) {
            clin[,i] <- as.character(clin[,i])
            clin[which(clin[,i] != ""),i] <- "YES"
            clin[which(clin[,i] == ""),i] <- "NO"
            colnames(clin)[which(colnames(clin) == i)] <- paste0("has_",i,"_information")
        }
    }

    if (is.null(clin)) {
        message("No information found")
        return(NULL)
    }

    # Converting factor to numeric and double
    out <- clin |> type.convert(as.is = TRUE, numerals = "warn.loss")

    # Change columns back to factor
    for (i in colnames(out)[!grepl("has_",colnames(out))]) {
        if (is(out[,i],"character") &  length(unique(out[,i])) < nrow(out)/2)
            out[,i] <-  as.factor(out[,i])
    }
    return(out)
}

parseFollowup <- function(files, xpath, clinical.info){
    follow_up_version <- files %>%
        sapply(function(x) {
            name <- names(xml_ns(read_xml(x)))
            name[grepl("follow_up",name)]
        }) %>% unlist() %>% unique() %>% sort()

    if (length(follow_up_version) > 1) {
        message("We found more than one follow up version!")
        message("We will parse all and add a collumn (follow_up_version) to identify each version")
    }

    clin <- plyr::adply(
        .data = follow_up_version,
        .margins =  1,
        .fun = function(x){
            message("Parsing follow up version: ", x)
            xpath <- paste0("//", x, ":follow_up")
            clin <- parseXML(files,xpath,clinical.info)
            clin$follow_up_version <- x
            return(clin)
        }, .id = "follow_up_version"
    )

    col_idx <- grep("follow_up_version", names(clin))
    clin <- clin[, c(col_idx, (1:ncol(clin))[-col_idx])]
}

parseXML <- function(files, xpath, clinical.info ){
    clin <- NULL

    pb <- txtProgressBar(min = 0, max = length(files), style = 3)

    for (i in seq_along(files)) {

        xmlfile <- files[i]
        xml <- read_xml(xmlfile)
        doc = xmlParse(xmlfile)

        patient <- str_extract(xmlfile,"[:alnum:]{4}-[:alnum:]{2}-[:alnum:]{4}")
        # Test if this xpath exists before parsing it
        for (xpath.it in xpath) {
            if (gsub("\\/\\/","", unlist(stringr::str_split(xpath.it,":"))[1]) %in% names(xml_ns(xml))){
                nodes <- getNodeSet(doc,xpath.it)
                if (length(nodes) == 0) next;
                df <- NULL
                for (j in 1:length(nodes)) {
                    df.aux <- xmlToDataFrame(nodes = nodes[j])
                    if (NA %in% colnames(df.aux)) df.aux <- df.aux[,!is.na(colnames(df.aux))]
                    if (nrow(df.aux) == 0) next

                    if (j == 1) {

                        df <- df.aux
                    } else {
                        df <- rbind.fill(df,df.aux)
                    }
                }

                df$bcr_patient_barcode <- patient
                if (i == 1) {
                    clin <- df
                } else {
                    clin <- rbind.fill(clin,df)
                }
                setTxtProgressBar(pb, i)
            }
        }
    }
    close(pb)
    return(clin)
}

#' @title Retrieve table with TCGA molecular subtypes
#' @description
#'   PanCancerAtlas_subtypes is a curated table with molecular subtypes for 24 TCGA cancer types
#' @export
#' @examples
#' molecular.subtypes <- PanCancerAtlas_subtypes()
#' @return a data.frame with barcode and molecular subtypes for 24 cancer types
PanCancerAtlas_subtypes <- function(){
    return(pancan2018)
}

#' @title Retrieve molecular subtypes for a given tumor
#' @description
#'   TCGAquery_subtype Retrieve molecular subtypes for a given tumor
#' @param tumor is a cancer Examples:
#' \tabular{lllll}{
#' lgg   \tab gbm \tab luad \tab stad \tab brca\cr
#' coad \tab read \tab  \tab  \tab
#'}
#' @export
#' @examples
#' dataSubt <- TCGAquery_subtype(tumor = "lgg")
#' @return a data.frame with barcode and molecular subtypes
TCGAquery_subtype <- function(tumor){
    available <- c("ACC",
                   "BRCA",
                   "BLCA",
                   "CESC",
                   "CHOL",
                   "COAD",
                   "ESCA",
                   "GBM",
                   "HNSC",
                   "KICH",
                   "KIRC",
                   "KIRP",
                   "LGG",
                   "LIHC",
                   "LUAD",
                   "LUSC",
                   "PAAD",
                   "PCPG",
                   "PRAD",
                   "READ",
                   "SKCM",
                   "SARC",
                   "STAD",
                   "THCA",
                   "UCEC",
                   "UCS",
                   "UVM"
    )
    if (
        grepl(
            paste(c(available,"all"),collapse = "|"), tumor,
            ignore.case = TRUE
        )
    ) {

        doi <- c(
            "acc"  = "doi:10.1016/j.ccell.2016.04.002",
            "aml"  = "doi:10.1056/NEJMoa1301689",
            "blca" = "doi:10.1016/j.cell.2017.09.007",
            "brca" = "doi.org/10.1016/j.ccell.2018.03.014",
            "cesc" = "doi:10.1038/nature21386",
            "chol" = "doi:10.1016/j.celrep.2017.02.033",
            "coad" = "doi:10.1038/nature11252",
            "esca" = "doi:10.1038/nature20805",
            "gbm"  = "doi:10.1016/j.cell.2015.12.028",
            "lgg"  = "doi:10.1016/j.cell.2015.12.028",
            "lihc"  = "https://doi.org/10.1016/j.cell.2017.05.046",
            "hnsc" = "doi:10.1038/nature14129",
            "kich" = "doi:10.1016/j.ccr.2014.07.014",
            "kirc" = "doi:10.1038/nature12222",
            "kirp" = "doi:10.1056/NEJMoa1505917",
            "lihc" = "doi:10.1016/j.cell.2017.05.046",
            "luad" = "doi:10.1038/nature13385",
            "lusc" = "doi:10.1038/nature11404",
            "paad"  = "doi:10.1016/j.ccell.2017.07.007",
            "ovca" = "doi:10.1038/nature10166",
            "pancan"="doi:10.1016/j.cell.2014.06.049",
            "pcpg" = "doi:10.1016/j.ccell.2017.01.001",
            "prad" = "doi:10.1016/j.cell.2015.10.025",
            "read" = "doi:10.1038/nature11252",
            "sarc" = "doi:10.1016/j.cell.2017.10.014",
            "skcm" = "doi:10.1016/j.cell.2015.05.044",
            "stad" = "doi:10.1038/nature13480",
            "thca" = "doi:10.1016/j.cell.2014.09.050",
            "ucec" = "doi:10.1038/nature12113",
            "ucs"  = "doi:10.1016/j.ccell.2017.02.010",
            "uvm"  = "doi:10.1016/j.ccell.2017.07.003"
        )
        if(tolower(tumor) != "all") {
            message(
                paste0(
                    tolower(tumor),
                    " subtype information from:",
                    doi[tolower(tumor)]
                )
            )
        }
        if(tolower(tumor) == "all") {
            all <- NULL
            for(i in available){
                try({
                    aux <- TCGAquery_subtype(i)
                    aux$Disease <- toupper(i)
                    aux$doi <- doi[i]
                    if(is.null(all)) all <- aux
                    else all <- plyr::rbind.fill(all,aux)
                })
            }
            idx <- which(colnames(all) == "doi")
            all <- all[, c(idx, (1:ncol(all))[-idx])]

            idx <- which(colnames(all) == "Disease")
            all <- all[, c(idx, (1:ncol(all))[-idx])]

            return(all)
        }

        # COAD and READ are in the same object
        if(tolower(tumor) == "read") tumor <- "coad"

        # The object with the gbm and lgg classification are the same
        # source: http://dx.doi.org/10.1016/j.cell.2015.12.028
        if(tolower(tumor) %in% c("lgg","gbm")) {
            aux <- get("lgg.gbm.subtype")
            if(tolower(tumor) == "gbm"){
                aux <- subset(aux,aux$Study == "Glioblastoma multiforme")
            } else {
                aux <- subset(aux,aux$Study != "Glioblastoma multiforme")
            }
            return (aux)
        }
        return(get(paste0(tolower(tumor),".subtype")))
    } else {
        stop("For the moment we have only subtype for:\no ", paste(available,collapse = "\no "))
    }
}


#' @title Retrieve molecular subtypes for given TCGA barcodes
#' @description
#'   TCGA_MolecularSubtype Retrieve molecular subtypes from TCGA consortium for a given set of barcodes
#' @param barcodes is a vector of TCGA barcodes
#' @export
#' @examples
#' TCGA_MolecularSubtype("TCGA-60-2721-01A-01R-0851-07")
#' @return List with $subtypes attribute as a dataframe with barcodes,
#' samples, subtypes, and colors. The $filtered attribute is returned as filtered samples with no subtype info
TCGA_MolecularSubtype <- function(barcodes){
    tabPanCancer <- as.data.frame(PanCancerAtlas_subtypes())
    tabSubtypeMergedNew <- subset(tabPanCancer, select = c("pan.samplesID",
                                                           "Subtype_Selected"))
    colnames(tabSubtypeMergedNew) <- c("samples", "subtype")
    rownames(tabSubtypeMergedNew) <- tabSubtypeMergedNew$samples
    tabSubtypeMergedNew <- cbind(tabSubtypeMergedNew, color = rep(0,
                                                                  nrow(tabSubtypeMergedNew)))
    TabSubtypesCol_merged <- TabSubtypesCol_merged[!duplicated(TabSubtypesCol_merged$samples),
    ]
    commonSamples <- intersect(tabSubtypeMergedNew$samples, TabSubtypesCol_merged$samples)
    rownames(TabSubtypesCol_merged) <- TabSubtypesCol_merged$samples
    tabSubtypeMergedNew[commonSamples, "color"] <- TabSubtypesCol_merged[commonSamples,
                                                                         "color"]
    dataTableSubt <- tabSubtypeMergedNew
    dataTableSubt$samples <- as.character(dataTableSubt$samples)
    dataTableSubt.samples.stripped <- sapply(as.character(dataTableSubt$samples), function(x) paste(unlist(stringr::str_split(x,
                                                                                                                              "-"))[1:3], collapse = "-"))
    dataTableSubt$patients<- dataTableSubt.samples.stripped

    barcodes <- as.character(barcodes)
    patients <- sapply(barcodes, function(x) paste(unlist(stringr::str_split(x,
                                                                             "-"))[1:3], collapse = "-"))

    #barcodes and patients with no subtype info
    filt.p <- c()
    filt.b <- c()

    df.barcodes_patID<-data.frame("barcodes"= barcodes, "patID"=unlist(patients),
                                  row.names = 1:length(barcodes), stringsAsFactors = FALSE)


    #View(df.barcodes_patID)

    for (p in patients) {

        if (p %in% unlist(dataTableSubt.samples.stripped) == FALSE){
            filt.p <- c(filt.p, p)
            #print(p)

            #filt.p is a vector containing patients with no subtype info
        }
    }

    for (b in barcodes) {

        if (b %in% unlist(dataTableSubt$samples) == FALSE){
            filt.b <- c(filt.b, b)
            #print(b)

            #filt.b is a vector containing samples with no subtype info
        }
    }

    if (length(filt.p) > 0) {
        message("the following TCGA barcodes/patients with no subtypes were filtered:")

        ###Keeping only patients/barcodes with available subtype info

        patients.with.sub <- unlist(patients[patients %in% filt.p ==
                                                 FALSE])

        idx.barcodes<-which(df.barcodes_patID$barcodes%in%filt.b ==FALSE)

        barcodes.with.sub<- df.barcodes_patID[idx.barcodes,]$barcodes

        ###indices of barcodes with available molecular subtype info
        ###if a patient Id is in filt.p and in filt.b
        idx.patient <- which(df.barcodes_patID$patID %in% filt.p ==FALSE)
        idx.barcodes <- which(df.barcodes_patID$barcodes %in% filt.b ==FALSE)
        idx.df<-intersect(idx.barcodes, idx.patient)

        ###dataframe with barcodes and patients IDs with available moolecular subtypes

        #df.barcodes_patID[idx.df,])

        idx1 <- which(dataTableSubt$samples %in% barcodes.with.sub)
        idx2 <- which(dataTableSubt$patients %in% patients.with.sub)
        idx<-intersect(idx1, idx2)

        Subtypes <- dataTableSubt[idx, ]

        #matching barcodes so they have the same order as they were provided in arguments
        Subtypes <- Subtypes[match(Subtypes$samples, df.barcodes_patID[idx.df,]$barcodes), ]

        filt <- setdiff(df.barcodes_patID$barcodes, Subtypes$samples)
        return(list(subtypes = Subtypes, filtered = filt))
    } else {
        message("All barcodes have available molecular subtype info")
        filt <- c()
        idx.patient <- which(dataTableSubt$samples %in% df.barcodes_patID$barcodes)
        Subtypes <- as.data.frame(dataTableSubt[idx.patient, ])
        Subtypes <- Subtypes[match(df.barcodes_patID$barcodes, Subtypes$samples), ]

        ##filt will be empty because all samples have molecular subtype info
        return(list(subtypes = Subtypes, filtered = filt))
    }
}

#' @title Filters TCGA barcodes according to purity parameters
#' @description
#'   TCGAtumor_purity Filters TCGA samples using 5 estimates from 5 methods as thresholds.
#' @param barcodes is a vector of TCGA barcodes
#' @param estimate uses gene expression profiles of 141 immune genes and 141 stromal genes
#' @param absolute which uses somatic copy-number data (estimations were available for only 11 cancer types)
#' @param lump (leukocytes unmethylation for purity), which averages 44 non-methylated immune-specific CpG sites
#' @param ihc as estimated by image analysis of haematoxylin and eosin stain slides produced by the Nationwide Childrens Hospital Biospecimen Core Resource
#' @param cpe CPE is a derived consensus measurement as the median purity level after normalizing levels from all methods to give them equal means and s.ds
#' @export
#' @examples
#' dataTableSubt <- TCGAtumor_purity("TCGA-60-2721-01A-01R-0851-07",
#'                           estimate = 0.6,
#'                           absolute = 0.6,
#'                           ihc = 0.8,
#'                           lump = 0.8,
#'                           cpe = 0.7)
#' @return List with $pure_barcodes attribute as a vector of pure samples and $filtered attribute as filtered samples with no purity info
TCGAtumor_purity <- function(barcodes, estimate, absolute, lump, ihc, cpe){

    Tumor.purity.L <- Tumor.purity
    barcodes <= as.character(barcodes)
    Tumor.purity.L$Sample.ID <- as.character(Tumor.purity$Sample.ID)
    Tumor.purity.L$ESTIMATE <- as.numeric(gsub(",", ".", Tumor.purity$ESTIMATE))
    Tumor.purity.L$ABSOLUTE <- as.numeric(gsub(",", ".", Tumor.purity$ABSOLUTE))
    Tumor.purity.L$LUMP <- as.numeric(gsub(",", ".", Tumor.purity$LUMP))
    Tumor.purity.L$IHC <- as.numeric(gsub(",", ".", Tumor.purity$IHC))
    Tumor.purity.L$CPE <- as.numeric(gsub(",", ".", Tumor.purity$CPE))

    #print(head(Tumor.purity.L))
    samples.id <- sapply(barcodes, function(x) paste(unlist(stringr::str_split(x, "-"))[1:4], collapse = "-"))

    df.barcodes_sampID <- data.frame(
        barcodes = barcodes,
        sampID = samples.id,
        row.names = 1:length(barcodes)
    )
    filt.s <- c()

    for(s in samples.id){
        if (s %in% Tumor.purity$Sample.ID == FALSE)
            filt.s <- c(filt.s, s)
    }

    if(length(filt.s)>0){
        message("the following TCGA barcodes do not have info on tumor purity:")
        filt <- as.character(df.barcodes_sampID[which(df.barcodes_sampID$sampID %in% filt.s),]$barcodes)
        print(filt)
    } else filt <- c()

    samples.filtered<-unlist(samples.id[samples.id %in% filt.s == FALSE])

    idx.samples <- which(
        Tumor.purity.L$Sample.ID %in% samples.filtered
        & (Tumor.purity.L$ESTIMATE >= estimate | Tumor.purity.L$ESTIMATE == 'NaN')
        & (Tumor.purity.L$ABSOLUTE >= absolute| Tumor.purity.L$ABSOLUTE == 'NaN')
        & (Tumor.purity.L$IHC >= ihc | Tumor.purity.L$IHC == 'NaN')
        & (Tumor.purity.L$LUMP >= lump | Tumor.purity.L$LUMP == 'NaN')
        & (Tumor.purity.L$CPE >= cpe | Tumor.purity.L$CPE == 'NaN')
    )


    df.purity <- Tumor.purity.L[idx.samples,]

    idx <- which(df.barcodes_sampID$sampID%in%df.purity$Sample.ID)

    filtered.barcodes <- as.character(df.barcodes_sampID[idx,]$barcodes)

    return(list(pure_barcodes = filtered.barcodes, filtered = filt))
}

#' @title Download GDC data
#' @description
#'   Uses GDC API or GDC transfer tool to download gdc data
#'   The user can use query argument
#'   The data from query will be save in a folder: project/data.category
#' @param query A query for GDCquery function
#' @param token.file Token file to download controlled data (only for method = "client")
#' @param method Uses the API (POST method) or gdc client tool. Options "api", "client".
#' API is faster, but the data might get corrupted in the download, and it might need to be executed again
#' @param directory Directory/Folder where the data was downloaded. Default: GDCdata
#' @param files.per.chunk This will make the API method only download n (files.per.chunk) files at a time.
#' This may reduce the download problems when the data size is too large. Expected a integer number (example files.per.chunk = 6)
#' @importFrom tools md5sum
#' @importFrom utils untar
#' @import httr
#' @importFrom methods is
#' @export
#' @examples
#' query <- GDCquery(project = "TCGA-ACC",
#'                  data.category =  "Copy number variation",
#'                  legacy = TRUE,
#'                  file.type = "hg19.seg",
#'                  barcode = c("TCGA-OR-A5LR-01A-11D-A29H-01", "TCGA-OR-A5LJ-10A-01D-A29K-01"))
#' # data will be saved in  GDCdata/TCGA-ACC/legacy/Copy_number_variation/Copy_number_segmentation
#' GDCdownload(query, method = "api")
#' \dontrun{
#'     # Download clinical data from XML
#'     query <- GDCquery(project = "TCGA-COAD", data.category = "Clinical")
#'     GDCdownload(query, files.per.chunk = 200)
#'     query <- GDCquery(
#'         project = "TARGET-AML",
#'         data.category = "Transcriptome Profiling",
#'         data.type = "miRNA Expression Quantification",
#'         workflow.type = "BCGSC miRNA Profiling",
#'         barcode = c("TARGET-20-PARUDL-03A-01R","TARGET-20-PASRRB-03A-01R")
#'     )
#'     # data will be saved in:
#'     # example_data_dir/TARGET-AML/harmonized/Transcriptome_Profiling/miRNA_Expression_Quantification
#'     GDCdownload(query, method = "client", directory = "example_data_dir")
#'     acc.gbm <- GDCquery(
#'         project =  c("TCGA-ACC","TCGA-GBM"),
#'         data.category = "Transcriptome Profiling",
#'         data.type = "Gene Expression Quantification",
#'         workflow.type = "STAR - Counts"
#'     )
#'     GDCdownload(
#'        query = acc.gbm,
#'        method = "api",
#'        directory = "example",
#'        files.per.chunk = 50
#'    )
#' }
#' @return Shows the output from the GDC transfer tools
#' @author Tiago Chedraoui Silva
GDCdownload <- function(
    query,
    token.file,
    method = "api",
    directory = "GDCdata",
    files.per.chunk = NULL
) {
    isServeOK()
    if (missing(query)) stop("Please set query argument")

    if (!(method %in% c("api","client"))) {
        stop("method arguments possible values are: 'api' or 'client'")
    }

    if (length(unique(getResults(query)$data_type)) > 1) {
        print(knitr::kable(sort(unique(getResults(query)$data_type)),col.names = "data_type in query"))
        stop("We can only download one data type. Please use data.type argument in GDCquery to filter results.")
    }

    source <- ifelse(query$legacy,"legacy","harmonized")

    dir.create(directory, showWarnings = FALSE, recursive = TRUE)
    for(proj in unique(unlist(query$project))){
        message("Downloading data for project ", proj)
        query.aux <- query
        results <- getResults(query.aux)[getResults(query.aux)$project == proj,]
        query.aux$results[[1]] <- results

        manifest <- getManifest(query.aux)

        path <- unique(
            file.path(
                proj, source,
                gsub(" ","_", results$data_category),
                gsub(" ","_",results$data_type))
        )
        path <- file.path(directory, path)

        # Check if the files were already downloaded by this package
        manifest <- checkAlreadyDownloaded(path,manifest)

        # There is a bug in the API, if the files has the same name it will not download correctly
        # so method should be set to client if there are files with duplicated names
        # However for clinical XML recurrent and primary are the same file. So we will ignore that case
        if (nrow(manifest) > length(unique(manifest$filename))) method <- "client"

        if (nrow(manifest) != 0 & method == "client") {
            # There exists two options to download the data, using the query or using a manifest file
            # The second option was created to let users use legacy data or the API to search

            # This will find gdc clinet, if not installed it will install it
            gdc.client.bin <- GDCclientInstall()

            # Using the query argument we will organize the files to the user
            # Creates a file with the gdc manifest format
            readr::write_delim(manifest,"gdc_manifest.txt",delim = "\t")

            readr::write_delim(manifest,"gdc_client_configuration.dtt",delim = "\t")
            readr::write_lines(
                c("[download]","retry_amount = 6",paste0("dir =",path)),
                file = "gdc_client_configuration.dtt"
            )
            cmd <- paste0(gdc.client.bin, " download -m gdc_manifest.txt --config gdc_client_configuration.dtt")

            dir.create(path,recursive = TRUE,showWarnings = FALSE)
            if(!missing(token.file)) cmd <- paste0(cmd," -t ", token.file)

            # Download all the files in the manifest using gdc client
            message(paste0("GDCdownload will download: ",
                           humanReadableByteCount(sum(as.numeric(manifest$size)))))
            message(paste0("Executing GDC client with the following command:\n",cmd))
            result = tryCatch({
                system(cmd)
            }, warning = function(w) {
            }, error = function(e) {
            })

        } else if (nrow(manifest) != 0 & method =="api"){
            if(nrow(manifest) > 1) {
                name <- paste0(gsub(" |:","_",date()),".tar.gz")
                unlink(name)
                message(
                    paste0(
                        "GDCdownload will download ", nrow(manifest), " files. A total of " ,
                        humanReadableByteCount(sum(as.numeric(manifest$size)))
                    )
                )
            } else {
                # case with one file only. This is not at tar.gz
                name <- manifest$filename
                message(
                    paste0(
                        "GDCdownload will download: ",
                        humanReadableByteCount(sum(as.numeric(manifest$size)))
                    )
                )
            }

            server <- ifelse(
                query$legacy,
                "https://api.gdc.cancer.gov/legacy/data/",
                "https://api.gdc.cancer.gov/data/"
            )

            if (is.null(files.per.chunk) & sum(as.numeric(manifest$size)) > 10^9) {
                message("The total size of files is big. We will download files in chunks")
                files.per.chunk <- floor(10^9 / mean(as.numeric(manifest$size)))
            }

            if(is.null(files.per.chunk)) {
                message(paste0("Downloading as: ", name))
                tryCatch({
                    GDCdownload.aux(server, manifest, name, path)
                }, error = function(e) {
                    message("Download failed. We will retry with smaller chunks")
                    # split in groups of 100 MB
                    manifest <- checkAlreadyDownloaded(path,manifest)
                    step <- ceiling(100000000/manifest$size[1])
                    if(step == 0) step <- 1
                    GDCdownload.by.chunk(server, manifest, name, path, step)
                })
            } else {
                step <- files.per.chunk
                # If error we will try another time.
                tryCatch({
                    GDCdownload.by.chunk(server, manifest, name, path, step)
                }, error = function(e) {
                    message("At least one of the chunks download was not correct. We will retry")
                    manifest <- checkAlreadyDownloaded(path,manifest)
                    GDCdownload.by.chunk(server, manifest, name, path, step)
                })
            }
        } else {
            message("All samples have been already downloaded")
        }
    }
}

#' @title Get a Manifest from GDCquery output that can be used with GDC-client
#' @description
#' Get a Manifest from GDCquery output that can be used with GDC-client
#' @param query A query for GDCquery function
#' @param save Write Manifest to a txt file (tab separated)
#' @examples
#' query <- GDCquery(
#'   project = "TARGET-AML",
#'   data.category = "Transcriptome Profiling",
#'   data.type = "Gene Expression Quantification",
#'   workflow.type = "STAR - Counts",
#'   barcode = c("TARGET-20-PADZCG-04A-01R","TARGET-20-PARJCR-09A-01R")
#'  )
#' getManifest(query)
#' @export
getManifest <- function(query, save = FALSE) {

    manifest <- query$results[[1]][,c("file_id","file_name","md5sum","file_size","state")]
    colnames(manifest) <- c("id","filename","md5","size","state")
    if(save)  {
        fname <- "gdc_manifest.txt"
        readr::write_delim(manifest,fname,delim = "\t")
        file <- file.path(getwd(),fname)
        message("Manifest saved as: ", file)
    }
    return(manifest)
}

GDCdownload.by.chunk <- function(
    server = "https://api.gdc.cancer.gov/data/",
    manifest,
    name = "TCGAbiolinks_download",
    path = ".",
    step = 1
){
    for(idx in 0:ceiling(nrow(manifest)/step - 1)){
        end <- ifelse(((idx + 1) * step) > nrow(manifest), nrow(manifest),((idx + 1) * step))
        manifest.aux <- manifest[((idx * step) + 1):end,]
        size <- humanReadableByteCount(sum(as.numeric(manifest.aux$size)))
        name.aux <- gsub("\\.tar",paste0("_",idx,".tar"),name)
        message(
            paste0(
                "Downloading chunk ", idx + 1, " of ", ceiling(nrow(manifest)/step) ,
                " (", nrow(manifest.aux)," files, size = ", size,") ",
                "as ", name.aux
            )
        )
        repeat {
            ret <- GDCdownload.aux(server, manifest.aux, name.aux, path)
            if(ret == 1) break
        }
    }
}

GDCdownload.aux <- function(
    server = "https://api.gdc.cancer.gov/data/",
    manifest,
    name = "TCGAbiolinks_download",
    path = "."
){
    result = tryCatch({
        bin <- getURL(
            server,
            POST,
            body =  list(ids=list(manifest$id)),
            encode = "json",
            progress()
        )
        if(bin[[2]] == "405"){
            message("ERROR accessing GDC. Trying again...")
            bin <- getURL("https://api.gdc.cancer.gov/data/",
                          POST,
                          body =  list(ids=list(manifest$id)),
                          encode = "json",
                          progress()
            )
        }
        writeBin(getURL(bin,content, as = "raw",encoding = "UTF-8"), name)

        if(nrow(manifest) > 1) {
            success <- untar(name)
            unlink(name) # remove tar
            if(success != 0){
                stop("There was an error in the download process, please execute it again")
                return(-1)
            }
        }
        # moving to project/source/data_category/data_type/file_id
        for(i in seq_along(manifest$filename)) {
            if(nrow(manifest) > 1) file <- file.path(manifest$id[i], manifest$filename[i])
            if(nrow(manifest) == 1) file <- file.path(manifest$filename[i])
            id <- manifest$id[i]

            # Check status
            if(!(md5sum(file) == manifest$md5[i])){
                message(paste0("File corrupted:", file))
                message("Run GDCdownload again to download it")
                unlink(file)
                next
            }
            if(nrow(manifest) > 1) {
                move(file,file.path(path,file))
            }
            if(nrow(manifest) == 1) {
                move(file,file.path(path,id,file))
            }
        }
        return(1)
    }, warning = function(w) {
        return(1)
    }, error = function(e) {
        unlink(name) # remove tar
        return(-1)
    })
    if(result == -1) {
        stop(
            paste0(
                "There was an error in the download process (we might had a connection problem with GDC server).",
                "\nPlease run this function it again.",
                "\nTry using method = `client` or setting files.per.chunk to a small number.")
        )
    }
    message("Download completed")
}

humanReadableByteCount <- function(bytes) {
    unit <- 1000
    if (bytes < unit) return (paste0(bytes + " B"))
    exp <- floor(log(bytes) / log(unit))
    pre <- paste0(substr("KMGTPE",exp,exp))
    pre <- paste0(pre,"B")
    nb <- bytes / (unit ^ exp)
    return (paste(nb, pre))
}
GDCclientPath <- function(){
    global <- Sys.which("gdc-client")
    if (global != "") return(global)
    local <- dir(pattern = "gdc-client*[^zip]$")
    if (length(local) > 0) return(dir(pattern = "gdc-client*[^zip]$", full.names = TRUE))
    return("")
}

GDCclientExists <- function(){
    return(Sys.which("gdc-client.exe") != "" || Sys.which("gdc-client") != "" || length(dir(pattern = "gdc-client*[^zip]$") > 0))
}
#' @importFrom xml2 read_html
#' @importFrom downloader download
#' @importFrom rvest html_nodes html_attr %>%
GDCclientInstall <- function(){
    if (GDCclientExists()) return(GDCclientPath())

    links = tryCatch({
        read_html("https://gdc.cancer.gov/access-data/gdc-data-transfer-tool")  %>% html_nodes("a") %>% html_attr("href")
    }, error = function(e) {
        c("https://gdc.cancer.gov/system/files/authenticated%20user/0/gdc-client_v1.4.0_Windows_x64.zip",
          "https://gdc.cancer.gov/system/files/authenticated%20user/0/gdc-client_v1.4.0_Ubuntu_x64.zip",
          "https://gdc.cancer.gov/system/files/authenticated%20user/0/gdc-client_v1.4.0_OSX_x64_10.12.6.zip")
    })
    bin <- links[grep("public.*zip",links)]
    if (is.windows()) bin <- bin[grep("client*.*windows", bin,ignore.case = TRUE)]
    if (is.mac()) bin <- bin[grep("client*.*OSX", bin)]
    if (is.linux()) {
        if (grepl("ubuntu",Sys.info()["version"],ignore.case = TRUE)){
            bin <- bin[grep("client*.*Ubuntu", bin)]
        } else {
            bin <- bin[grep("client*.*Cent", bin)]
        }
    }
    if (is.windows()) mode <- "wb" else  mode <- "w"
    download(bin, basename(bin), mode = mode)
    unzip(basename(bin))
    Sys.chmod("gdc-client")
    return(GDCclientPath())
}

checkAlreadyDownloaded <- function(path,manifest){
    files2Download <- !(file.exists(file.path(path,manifest$id,manifest$filename)) | file.exists(file.path(path,manifest$filename)))
    if (any(files2Download == FALSE)) {
        message(
            "Of the ", nrow(manifest), " files for download ",
            table(files2Download)["FALSE"] , " already exist."
        )
        if (any(files2Download == TRUE)) message("We will download only those that are missing ones.")
    }
    return(manifest[files2Download,])
}

#' @title Survival analysis with univariate Cox regression package (dnet)
#' @description TCGAvisualize_SurvivalCoxNET can help an user to identify a group of survival genes that are
#' significant from univariate Kaplan Meier Analysis and also for Cox Regression.
#' It shows in the end a network build with community of genes with similar range of pvalues from
#' Cox regression (same color) and that interaction among those genes is already validated in
#' literatures using the STRING database (version 9.1).
#' TCGAvisualize_SurvivalCoxNET perform survival analysis with univariate Cox regression
#' and package (dnet) using following functions wrapping from these packages:
#' \enumerate{
#' \item survival::coxph
#' \item igraph::subgraph.edges
#' \item igraph::layout.fruchterman.reingold
#' \item igraph::spinglass.community
#' \item igraph::communities
#' \item dnet::dRDataLoader
#' \item dnet::dNetInduce
#' \item dnet::dNetPipeline
#' \item dnet::visNet
#' \item dnet::dCommSignif
#' }
#' @details TCGAvisualize_SurvivalCoxNET allow user to perform the complete workflow using coxph
#' and dnet package related to survival analysis with an identification of gene-active networks from
#' high-throughput omics data using gene expression and clinical data.
#' \enumerate{
#' \item Cox regression survival analysis to obtain hazard ratio (HR) and p-values
#' \item fit a Cox proportional hazards model and ANOVA (Chisq test)
#' \item Network comunites
#' \item An igraph object that contains a functional protein  association network in human.
#' The network is extracted from the STRING database (version 9.1).
#' Only those associations with medium confidence (score>=400) are retained.
#' \item restrict to those edges with high confidence (score>=700)
#' \item extract network that only contains genes in pvals
#' \item Identification of gene-active network
#' \item visualisation of the gene-active network itself
#' \item the layout of the network visualisation (fixed in different visuals)
#' \item color nodes according to communities (identified via a spin-glass model and simulated annealing)
#' \item node sizes according to degrees
#' \item highlight different communities
#' \item visualize the subnetwork
#' }
#' @param clinical_patient is a data.frame using function 'clinic' with information
#' related to barcode / samples such as bcr_patient_barcode, days_to_death ,
#' days_to_last_followup , vital_status, etc
#' @param dataGE is a matrix of Gene expression (genes in rows, samples in cols) from TCGAprepare
#' @param Genelist is a list of gene symbols where perform survival KM.
#' @param org.Hs.string an igraph object that contains a functional protein association network
#' in human. The network is extracted from the STRING database (version 10).
#' @param scoreConfidence restrict to those edges with high confidence (eg. score>=700)
#' @param titlePlot is the title to show in the final plot.
#' @return net IGRAPH with related Cox survival genes in community (same pval and color) and with
#' interactions from STRING database.
TCGAvisualize_SurvivalCoxNET <- function(
        clinical_patient,
        dataGE,
        Genelist,
        org.Hs.string,
        scoreConfidence = 700,
        titlePlot = "TCGAvisualize_SurvivalCoxNET Example"
){

    check_package("survival")
    check_package("dnet")
    check_package("igraph")

    combined_score <- NULL

    pdf("SurvivalCoxNETOutput.pdf", width = 15, height = 10)

    ## fit a Cox proportional hazards model for age, gender, tumor type
    cfu <- clinical_patient[clinical_patient[,"bcr_patient_barcode"] %in% substr(colnames(dataGE),1,12),]
    rownames(cfu) <- cfu$bcr_patient_barcode
    cfu <- cfu %>% dplyr::select(
        "bcr_patient_barcode",
        "days_to_last_follow_up",
        "days_to_death",
        "vital_status",
        "age_at_diagnosis",
        "gender"
    )

    rownames(cfu) <- cfu$bcr_patient_barcode
    cfu <- cfu[,-1]
    colnames(cfu)   <- c("time","timeDead","status","Age","Gender")

    cfu[which(cfu$status == "Alive"),"status"]<-0
    cfu[which(cfu$status == "Dead"),"time"]<- cfu[which(cfu$status=="Dead"),"timeDead"]
    cfu[which(cfu$status == "Dead"),"status"]<-1
    cfu$Gender <- tolower(cfu$Gender)
    cfu <- cfu[,-2]
    cfu <- as.data.frame(subset(cfu, select=c("time","status")))
    cfu$time <- as.numeric(cfu$time)
    cfu$status <- as.numeric(cfu$status)

    data <-as.data.frame(dataGE)
    colnames(data) <- substr(colnames(data),1,12)
    commonSamples <- intersect(rownames(cfu), colnames(data))

    data <- t(data)
    data <- data[commonSamples,Genelist]

    #rownames(tabSurvKMfilt) <- tabSurvKMfilt$mRNA
    #colnames(Cancer_rnaseqv2) <- substr(colnames(Cancer_rnaseqv2),1,12)
    #md_selected<-log2(Cancer_rnaseqv2[rownames(tabSurvKMfilt),rownames(cfu)])

    md_selected <- data
    pd <- cfu

    ## survival analysis to obtain hazard ratio (HR) and pvaules
    HR <- rep(1, ncol(md_selected))
    pvals <- rep(1, ncol(md_selected))
    for(i in 1:ncol(md_selected)){
        ## fit a Cox proportional hazards model
        data <- cbind(pd, gene = md_selected[,i])
        data <- data [which(data$gene !="-Inf"),]

        fit <- survival::coxph(formula=survival::Surv(time,status) ~., data=data)
        ## ANOVA (Chisq test)
        cox <- summary(fit)
        cat(paste( (ncol(md_selected)-i),".",sep=""))
        # res <- as.matrix(anova(fit, test="Chisq"))
        HR[i] <- as.numeric(cox$coefficients[2])
        pvals[i] <- as.numeric(cox$logtest[3])
    }

    names(HR) <- colnames(md_selected)
    names(pvals) <- colnames(md_selected)
    # Network comunites >>=

    # An igraph object that contains a functional protein association network
    # in human. The network is extracted from the STRING database (version 9.1).
    # Only those associations with medium confidence (score>=400) are retained.
    #  org.Hs.string <- dRDataLoader(RData='org.Hs.string')
    # restrict to those edges with high confidence (score>=700)
    # with(org.Hs.string,{
    #    network <- subgraph.edges(org.Hs.string, eids=E(org.Hs.string)[combined_score>=scoreConfidence])})
    #network
    network <- igraph::subgraph.edges(org.Hs.string, eids=igraph::E(org.Hs.string)[combined_score>=scoreConfidence])


    # extract network that only contains genes in pvals
    ind <- match(igraph::V(network)$symbol, names(pvals))
    ## for extracted graph
    nodes_mapped <- igraph::V(network)$name[!is.na(ind)]
    network <- dnet::dNetInduce(
        g = network,
        nodes_query = nodes_mapped,
        knn = 0,
        remove.loops = FALSE,
        largest.comp = TRUE
    )
    igraph::V(network)$name <- igraph::V(network)$symbol

    # Identification of gene-active network
    net <- dnet::dNetPipeline(
        g = network,
        pval = pvals,
        method = "customised",
        significance.threshold = 5e-02
    )
    # visualisation of the gene-active network itself
    ## the layout of the network visualisation (fixed in different visuals)
    glayout <- igraph::layout.fruchterman.reingold(net)
    ## color nodes according to communities (identified via a spin-glass model and simulated annealing)
    com <- igraph::spinglass.community(net, spins=25)
    com$csize <- sapply(1:length(com),function(x) sum(com$membership==x))
    vgroups <- com$membership
    colormap <- "yellow-darkorange"
    palette.name <- supraHex::visColormap(colormap=colormap)
    mcolors <- palette.name(length(com))
    vcolors <- mcolors[vgroups]
    com$significance <- dnet::dCommSignif(net, com)
    ## node sizes according to degrees
    vdegrees <- igraph::degree(net)
    ## highlight different communities
    mark.groups <- igraph::communities(com)
    mark.col <- supraHex::visColoralpha(mcolors, alpha=0.2)
    mark.border <- supraHex::visColoralpha(mcolors, alpha=0.2)
    edge.color <- c("#C0C0C0", "#000000")[igraph::crossing(com,net)+1]
    edge.color <- supraHex::visColoralpha(edge.color, alpha=0.5)
    ## visualise the subnetwrok
    dnet::visNet(
        g = net,
        glayout = glayout,
        vertex.label = igraph::V(net)$geneSymbol,
        vertex.color = vcolors,
        vertex.frame.color = vcolors,
        vertex.shape = "sphere",
        mark.groups = mark.groups,
        mark.col = mark.col,
        mark.border = mark.border,
        mark.shape = 1,
        mark.expand = 10,
        edge.color = edge.color,
        newpage = FALSE,
        vertex.label.color = "blue",
        vertex.label.dist = 0.4,
        vertex.label.font = 2,
        main = titlePlot
    )
    legend_name <- paste("C",1:length(mcolors)," (n=",com$csize,", pval=",signif(com$significance,digits=2),")",sep='')
    legend("topleft", legend=legend_name, fill=mcolors, bty="n", cex=1.4)

    dev.off()

    return(net)

}

#' @title Principal components analysis (PCA) plot
#' @description
#'   TCGAvisualize_PCA performs a principal components analysis (PCA) on the given data matrix
#'   and returns the results as an object of class prcomp, and shows results in PCA level.
#' @param dataFilt A filtered dataframe or numeric matrix where each row represents a gene,
#' each column represents a sample from function TCGAanalyze_Filtering
#' @param dataDEGsFiltLevel table with DEGs, log Fold Change (FC), false discovery rate (FDR),
#' the gene expression level, etc, from function TCGAanalyze_LevelTab.
#' @param ntopgenes number of DEGs genes to plot in PCA
#' @param group1 a string containing the barcode list of the samples in in control group
#' @param group2 a string containing the barcode list of the samples in in disease group
#' the name of the group
#' @import ggplot2
#' @export
#' @return principal components analysis (PCA) plot of PC1 and PC2
#' @examples
#' # normalization of genes
#' dataNorm <- TCGAbiolinks::TCGAanalyze_Normalization(tabDF = dataBRCA, geneInfo = geneInfo,
#' method = "geneLength")
#' # quantile filter of genes
#' dataFilt <- TCGAanalyze_Filtering(tabDF = dataBRCA, method = "quantile", qnt.cut =  0.25)
#' # Principal Component Analysis plot for ntop selected DEGs
#'     # selection of normal samples "NT"
#'     group1 <- TCGAquery_SampleTypes(colnames(dataFilt), typesample = c("NT"))
#'     # selection of normal samples "TP"
#'     group2 <- TCGAquery_SampleTypes(colnames(dataFilt), typesample = c("TP"))
#' pca <- TCGAvisualize_PCA(dataFilt,dataDEGsFiltLevel, ntopgenes = 200, group1, group2)
TCGAvisualize_PCA <- function(dataFilt,dataDEGsFiltLevel ,ntopgenes,group1, group2) {
    ComparisonSelected <- "Normal vs Tumor"
    TitlePlot <- paste0("PCA ", "top ", ntopgenes,
                        " Up and down diff.expr genes between ",
                        ComparisonSelected)

    dataFilt <- dataFilt[!duplicated(GenesCutID(rownames(dataFilt))),]
    rownames(dataFilt) <- GenesCutID(rownames(dataFilt))

    Genelist <- rownames(dataDEGsFiltLevel)[1:ntopgenes]
    commonGenes <- intersect(Genelist, rownames(dataFilt) )
    expr2 <- dataFilt[commonGenes,]
    color1 <- "blue"
    color2 <- "red"

    nsample1 <- length(group1)
    nsample2 <- length(group2)

    #sampleColors <- rep(c(color1,color2), c(nsample1, nsample2))
    #sampleColors <- rep(c("blue","red"), c(length(group1),
    #                     length(group2)))
    sampleColors <- c(rep("blue", length(group1)),
                      rep("red", length(group2)))


    names(sampleColors) <- colnames(expr2)
    cancer.pca <- stats::prcomp(t(expr2),cor = TRUE)


    g <- ggbiplot(cancer.pca, obs.scale = 1, var.scale = 1,
                  groups = sampleColors, ellipse = TRUE, circle = FALSE)
    g <- g + scale_colour_manual(name = "",
                                 values = c("blue" = "blue","red" = "red"))
    with(g,
         g <- g + geom_point(aes(colour = sampleColors), size = 3)
    )
    #shape = tabClusterNew$Study)
    g <- g + theme(legend.direction = 'horizontal',  legend.position = 'top')
    g <- g + ggtitle(TitlePlot)
    print(g)
    return(cancer.pca)
}

#' @title barPlot for a complete Enrichment Analysis
#' @description
#' The figure shows canonical pathways significantly overrepresented (enriched) by the DEGs
#' (differentially expressed genes).
#' The most statistically significant canonical pathways identified
#' in DEGs list are listed according to their p value corrected FDR (-Log) (colored bars)
#' and the ratio of list genes found in each pathway over the total number of
#' genes in that pathway (Ratio, red line).
#' @param tf is a list of gene symbols
#' @param GOBPTab is results from TCGAanalyze_EAcomplete related to Biological Process (BP)
#' @param GOCCTab is results from TCGAanalyze_EAcomplete related to Cellular Component (CC)
#' @param GOMFTab is results from TCGAanalyze_EAcomplete related to Molecular Function (MF)
#' @param PathTab is results from TCGAanalyze_EAcomplete related to Pathways EA
#' @param nBar is the number of bar histogram selected to show (default = 10)
#' @param nRGTab is the gene signature list with gene symbols.
#' @param filename Name for the pdf. If null it will return the plot.
#' @param color A vector of colors for each barplot. Deafult:  c("orange", "cyan","green","yellow")
#' @param text.size Text size
#' @param xlim Upper limit of the x-axis.
#' @param mfrow Vector with number of rows/columns of the plot. Default  2 rows/2 columns "c(2,2)"
#' @param fig.width Default 30
#' @param fig.height Default 15
#' @export
#' @import graphics
#' @return Complete barPlot from Enrichment Analysis showing significant (default FDR < 0.01)
#' BP,CC,MF and pathways enriched by list of genes.
#' @examples
#' Genelist <- c("FN1","COL1A1")
#' ansEA <- TCGAanalyze_EAcomplete(TFname="DEA genes Normal Vs Tumor",Genelist)
#' TCGAvisualize_EAbarplot(tf = rownames(ansEA$ResBP),
#'          GOBPTab = ansEA$ResBP,
#'          GOCCTab = ansEA$ResCC,
#'          GOMFTab = ansEA$ResMF,
#'         PathTab = ansEA$ResPat,
#'          nRGTab = Genelist,
#'          nBar = 10,
#'          filename="a.pdf")
#' \dontrun{
#' Genelist <- rownames(dataDEGsFiltLevel)
#' system.time(ansEA <- TCGAanalyze_EAcomplete(TFname="DEA genes Normal Vs Tumor",Genelist))
#' # Enrichment Analysis EA (TCGAVisualize)
#' # Gene Ontology (GO) and Pathway enrichment barPlot
#' TCGAvisualize_EAbarplot(tf = rownames(ansEA$ResBP),
#'          GOBPTab = ansEA$ResBP,
#'          GOCCTab = ansEA$ResCC,
#'          GOMFTab = ansEA$ResMF,
#'         PathTab = ansEA$ResPat,
#'          nRGTab = Genelist,
#'          nBar = 10)
#'}
TCGAvisualize_EAbarplot <- function(
        tf,
        GOMFTab,
        GOBPTab,
        GOCCTab,
        PathTab,
        nBar,
        nRGTab,
        filename = "TCGAvisualize_EAbarplot_Output.pdf",
        text.size = 1.0,
        mfrow = c(2, 2),
        xlim = NULL,
        fig.width = 30,
        fig.height = 15,
        color = c("orange", "cyan","green","yellow")
){

    check_package("EDASeq")

    if(!is.null(filename)) {
        pdf(filename, width = fig.width, height = fig.height)
    }

    splitFun <- function(tf, Tab, nBar){
        tmp <- lapply(Tab[tf, ], function(x) strsplit(x, ";"))
        names(tmp) <- NULL
        tmp <- matrix(unlist(tmp), ncol = 4, byrow = TRUE)
        if (nrow(tmp) == 0 | tmp[1, 1] == "NA") return(matrix(0, ncol = 2))
        tmp <- tmp[tmp[, 1] != "NA", , drop = FALSE]
        tmp <- as.data.frame(tmp, stringsAsFactors = FALSE)
        tmp[, 2] <- as.numeric(sub(" FDR= ", "", tmp[, 2]))
        tmp[, 3] <- as.numeric(unlist(strsplit(matrix(unlist(strsplit(tmp[, 3],
                                                                      "=")), nrow = 2)[2, ], ")")))
        tmp[, 4] <- as.numeric(unlist(strsplit(matrix(unlist(strsplit(tmp[, 4],
                                                                      "=")), nrow = 2)[2, ], ")")))

        if (nrow(tmp) < nBar) nBar <- nrow(tmp)

        tmp[, 2] <- -log10(tmp[, 2])
        o <- order(tmp[, 2], decreasing = TRUE)
        toPlot <- tmp[o[nBar:1], 1:2]
        toPlot[, 1] <- paste0(toPlot[, 1], " (n=", tmp[o[nBar:1], 4], ")")
        toPlot[, 3] <- tmp[o[nBar:1], 4]/tmp[o[nBar:1], 3]

        return(toPlot)
    }
    par(mfrow = mfrow)

    if(!missing(GOBPTab)){
        if(!is.null(GOBPTab) & !all(is.na(GOBPTab))){
            # Plotting GOBPTab
            toPlot <- splitFun(tf, GOBPTab, nBar)
            xAxis <- EDASeq::barplot(toPlot[, 2], horiz = TRUE, col = color[1],
                                     main = "GO:Biological Process", xlab = "-log10(FDR)",xlim = xlim)
            labs <- matrix(unlist(strsplit(toPlot[, 1], "~")), nrow = 2)[2, ]
            text(x = 1, y = xAxis, labs, pos = 4, cex = text.size)
            lines(x = toPlot[, 3], y = xAxis, col = "red")
            points(x = toPlot[, 3], y = xAxis, col = "red")
            axis(side = 3, at = pretty(range(0:1)), col = "red")
        }
    }
    if(!missing(GOCCTab)){
        if(!is.null(GOCCTab) & !all(is.na(GOCCTab))){
            # Plotting GOCCTab
            toPlot <- splitFun(tf, GOCCTab, nBar)
            xAxis <- EDASeq::barplot(toPlot[, 2], horiz = TRUE, col = color[2],
                                     main = "GO:Cellular Component", xlab = "-log10(FDR)",xlim = xlim)
            labs <- matrix(unlist(strsplit(toPlot[, 1], "~")), nrow = 2)[2, ]
            text(x = 1, y = xAxis, labs, pos = 4, cex = text.size)
            lines(x = toPlot[, 3], y = xAxis, col = "red")
            points(x = toPlot[, 3], y = xAxis, col = "red")
            axis(side = 3, at = pretty(range(0:1)), col = "red")
        }
    }
    if(!missing(GOMFTab)){
        if(!is.null(GOMFTab) & !all(is.na(GOMFTab))){
            # Plotting GOMFTab
            toPlot <- splitFun(tf, GOMFTab, nBar)
            xAxis <- EDASeq::barplot(toPlot[, 2], horiz = TRUE, col = color[3],
                                     main = "GO:Molecular Function", xlab = "-log10(FDR)",xlim = xlim)
            labs <- matrix(unlist(strsplit(toPlot[, 1], "~")), nrow = 2)[2, ]
            text(x = 1, y = xAxis, labs, pos = 4, cex = text.size)
            lines(x = toPlot[, 3], y = xAxis, col = "red")
            points(x = toPlot[, 3], y = xAxis, col = "red")
            axis(side = 3, at = pretty(range(0:1)), col = "red")
        }
    }
    if(!missing(PathTab)){
        if(!is.null(PathTab) & !all(is.na(PathTab))){
            # Plotting PathTab
            toPlot <- splitFun(tf, PathTab, nBar)
            xAxis <- EDASeq::barplot(toPlot[, 2], horiz = TRUE, col = color[4],
                                     main = "Pathways", xlab = "-log10(FDR)",xlim = xlim)
            labs <- toPlot[, 1]
            text(x = 1, y = xAxis, labs, pos = 4, cex = text.size)
            lines(x = toPlot[, 3], y = xAxis, col = "red")
            points(x = toPlot[, 3], y = xAxis, col = "red")
            #axis(side = 1, at = pretty(range(0:1)), col = "red", line = 2.5)
            axis(side = 3, at = pretty(range(0:1)), col = "red")
        }
    }
    #par(new = TRUE)
    #plot(toPlot[, 3], xAxis, axes = FALSE, bty = "n", xlab = "",
    # ylab = "", col = "blue")
    #par(new = TRUE)
    #plot(toPlot[, 3], xAxis, type = "l", axes = FALSE, bty = "n", xlab = "",
    # ylab = "", col = "blue")
    #axis(side = 2, at = pretty(range(xAxis)))
    #axis(side = 1, at = pretty(range(toPlot[, 3])), col = "red", line=2.5)
    #axis(side = 3, at = pretty(range(toPlot[, 3])), col = "red")

    if (is.null(nrow(nRGTab))) {
        nRG <- length(nRGTab)
    } else {
        nRG <- nRGTab[tf, "RegSizeTF"]
    }

    mainLab <- paste(tf, " (nRG = ", nRG, ")", sep = "")
    mtext(mainLab, side = 3, line = -1, outer = TRUE, font = 2)

    if(!is.null(filename)) dev.off()
}

#' @title Barplot of subtypes and clinical info in groups of gene expression clustered.
#' @description
#'   Barplot of subtypes and clinical info in groups of gene expression clustered.
#' @param DFfilt write
#' @param DFclin write
#' @param DFsubt write
#' @param data_Hc2 write
#' @param Subtype write
#' @param cbPalette Define the colors of the bar.
#' @param filename The name of the pdf file
#' @param width Image width
#' @param height Image height
#' @param dpi Image dpi
#' @import ggplot2
#' @export
#' @return barplot image in pdf or png file
TCGAvisualize_BarPlot <- function(DFfilt,
                                  DFclin,
                                  DFsubt,
                                  data_Hc2,
                                  Subtype,
                                  cbPalette,
                                  filename,
                                  width,
                                  height,
                                  dpi){

    if(Subtype =="AGE"){
        dataClinNew <- dataClin
        colnames(dataClin)[which(colnames(dataClin) == "age_at_initial_pathologic_diagnosis")] <- "AGE"
        dataClin$AGE <- as.numeric(as.character(dataClin$AGE))
        dataClin <- cbind(dataClin, AGE2 = matrix(0,nrow(dataClin),1))
        dataClin[ dataClin$AGE <= 32, "AGE2"] <- "<=32 yr"
        dataClin[ dataClin$AGE >= 41, "AGE2"] <- ">=41 yr"
        dataClin[ dataClin$AGE2 == 0, "AGE2"] <- "33-40 yr"
        dataClin$AGE <- as.character(dataClin$AGE2)
        DFclin <- dataClin
    }

    ans <- hclust(ddist <- dist(DFfilt), method = "ward.D2")
    hhc <- data_Hc2[[4]]$consensusTree
    consensusClusters<-data_Hc2[[4]]$consensusClass
    sampleOrder <- consensusClusters[hhc$order]

    consensusClusters <- as.factor(data_Hc2[[4]]$clrs[[1]])
    names(consensusClusters) <- attr(ddist, "Labels")
    names(consensusClusters) <- substr(names(consensusClusters),1,12)

    # adding information about gropus from consensus Cluster in clinical data
    DFclin <- cbind(DFclin, groupsHC = matrix(0,nrow(DFclin),1))
    rownames(DFclin) <- DFclin$bcr_patient_barcode

    for( i in 1: nrow(DFclin)){
        currSmp <- DFclin$bcr_patient_barcode[i]
        DFclin[currSmp,"groupsHC"] <- as.character(consensusClusters[currSmp])
    }

    DFclin_filt <- DFclin[DFclin$bcr_patient_barcode %in% DFsubt$patient,]
    DFclin_filt <- DFclin_filt[order(DFclin_filt$bcr_patient_barcode),]
    DFsubt <- DFsubt[order(DFsubt$patient),]
    DFclin_merged <- cbind(DFclin_filt,DFsubt)

    subtype_sel <- colnames(DFclin_merged) == Subtype
    DFclin_merged[,Subtype] <- as.character(DFclin_merged[,Subtype])
    DFclin_merged <- DFclin_merged[!(is.na(DFclin_merged[,Subtype])),]
    DFclin_merged <- DFclin_merged[DFclin_merged[,Subtype] !="NA",]

    groupsColors <-  levels(as.factor(DFclin_merged$groupsHC))
    for(j in 1:length(table(DFclin_merged$groupsHC))){
        curCol <- groupsColors[j]
        DFclin_merged[DFclin_merged$groupsHC == curCol,"groupsHC"]<-paste0("EC",j)
    }

    subtypeCluster <- factor(DFclin_merged[,Subtype])
    pplot <- qplot(factor(DFclin_merged$groupsHC),
                   data=DFclin_merged, geom="bar",
                   fill=subtypeCluster , xlab="Expression group") +
        theme_bw()  +
        theme(panel.border = element_blank(),
              panel.grid.major = element_blank(),
              panel.grid.minor = element_blank(),
              axis.line = element_line(colour = "black")) +
        guides(fill=guide_legend(title=Subtype))  +
        theme(legend.position="top",
              legend.text = element_text(size = 18),
              legend.title = element_text(size=18, face="bold")) +
        theme( legend.text = element_text(size = 18),
               legend.title = element_text(size = 18),
               axis.text= element_text(size = 30),
               axis.title.x= element_text(size = 22),
               axis.title.y= element_text(size = 30))   +
        scale_fill_manual(values=cbPalette)

    ggsave(pplot, filename = filename, width = width, height = height, dpi = dpi)
    message(paste("Plot saved in: ", file.path(getwd(),filename)))
}


#' @title Heatmap with more sensible behavior using heatmap.plus
#' @description Heatmap with more sensible behavior using heatmap.plus
#' @param data The object to with the heatmap data (expression, methylation)
#' @param col.metadata Metadata for the columns (samples). It should have on of the following columns:
#' barcode (28 characters)  column to match with the samples. It will also work with
#' "bcr_patient_barcode"(12 chars),"patient"(12 chars),"sample"(16 chars) columns but as one patient might
#' have more than one sample, this coul lead to errors in the annotation.
#' The code will throw a warning in case two samples are from the same patient.
#' @param row.metadata  Metadata for the rows  genes (expression) or probes (methylation)
#' @param col.colors A list of names colors
#' @param row.colors A list of named colors
#' @param type Select the colors of the heatmap values. Possible values are
#'  "expression" (default), "methylation"
#' @param show_column_names  Show column names names? Default: FALSE
#' @param show_row_names Show row names? Default: FALSE
#' @param cluster_rows Cluster rows ? Default: FALSE
#' @param cluster_columns Cluster columns ? Default: FALSE
#' @param filename Filename to save the heatmap. Default: heatmap.png
#' @param width figure width
#' @param height figure height
#' @param sortCol Name of the column to be used to sort the columns
#' @param title Title of the plot
#' @param rownames.size Rownames size
#' @param color.levels A vector with the colors (low level, middle level, high level)
#' @param extremes Extremes of colors (vector of 3 values)
#' @param values.label Text of the levels in the heatmap
#' @param heatmap.legend.color.bar Heatmap legends values type.
#' Options: "continuous", "discrete"
#' @param scale Use z-score to make the heatmap?
#' If we want to show differences between genes, it is good to make Z-score by samples
#' (force each sample to have zero mean and standard deviation=1).
#' If we want to show differences between samples, it is good to make Z-score by genes
#' (force each gene to have zero mean and standard deviation=1).
#' Possibilities: "row", "col". Default "none"
#' @examples
#'  row.mdat <- matrix(c("FALSE","FALSE",
#'                      "TRUE","TRUE",
#'                      "FALSE","FALSE",
#'                      "TRUE","FALSE",
#'                      "FALSE","TRUE"
#'                 ),
#'               nrow = 5, ncol = 2, byrow = TRUE,
#'               dimnames = list(
#'                   c("probe1", "probe2","probe3","probe4","probe5"),
#'                   c("duplicated", "Enhancer region")))
#' dat <- matrix(c(0.3,0.2,0.3,1,1,0.1,1,1,0, 0.8,1,0.7,0.7,0.3,1),
#'              nrow = 5, ncol = 3, byrow = TRUE,
#'                dimnames = list(
#'                c("probe1", "probe2","probe3","probe4","probe5"),
#'                c("TCGA-DU-6410",
#'                  "TCGA-DU-A5TS",
#'                  "TCGA-HT-7688")))
#'
#' mdat <- data.frame(patient=c("TCGA-DU-6410","TCGA-DU-A5TS","TCGA-HT-7688"),
#'                    Sex=c("Male","Female","Male"),
#'                    COCCluster=c("coc1","coc1","coc1"),
#'                    IDHtype=c("IDHwt","IDHMut-cod","IDHMut-noncod"))
#'
#'TCGAvisualize_Heatmap(dat,
#'                     col.metadata = mdat,
#'                     row.metadata = row.mdat,
#'                     row.colors = list(duplicated = c("FALSE" = "pink",
#'                                                      "TRUE"="green"),
#'                                      "Enhancer region" = c("FALSE" = "purple",
#'                                                             "TRUE"="grey")),
#'                     col.colors = list(Sex = c("Male" = "blue", "Female"="red"),
#'                                       COCCluster=c("coc1"="grey"),
#'                                       IDHtype=c("IDHwt"="cyan",
#'                                       "IDHMut-cod"="tomato"
#'                                       ,"IDHMut-noncod"="gold")),
#'                     type = "methylation",
#'                     show_row_names=TRUE)
#' @export
#' @return Heatmap plotted in the device
TCGAvisualize_Heatmap <- function(
        data,
        col.metadata,
        row.metadata,
        col.colors = NULL,
        row.colors = NULL,
        show_column_names = FALSE,
        show_row_names = FALSE,
        cluster_rows = FALSE,
        cluster_columns = FALSE,
        sortCol,
        extremes = NULL,
        rownames.size = 12,
        title = NULL,
        color.levels = NULL,
        values.label = NULL,
        filename = "heatmap.pdf",
        width = 10,
        height = 10,
        type = "expression",
        scale = "none",
        heatmap.legend.color.bar = "continuous"){

    check_package("ComplexHeatmap")
    check_package("circlize")
    # STEP 1 add columns labels (top of heatmap)
    ha <-  NULL
    if(!missing(col.metadata)) {
        if(!is.null(col.metadata)) {
            id <- NULL
            if("patient"  %in% colnames(col.metadata)) {
                id <- "patient"
                size <- 12
            }
            if("barcode"  %in% colnames(col.metadata)) {
                id <- "barcode"
                stopifnot(nchar(col.metadata[,id])[1] == 28)
                size <- 28
            }
            if("bcr_patient_barcode"  %in% colnames(col.metadata)) {
                id <- "bcr_patient_barcode"
                stopifnot(nchar(col.metadata[,id])[1] == 12)
                size <- 12
            }
            if("sample"  %in% colnames(col.metadata)) {
                id <- "sample"
                stopifnot(nchar(col.metadata[,id])[1] == 16)
                size <- 16
            }

            if(is.null(id)) {
                message("=============== INNPUT ERROR =================")
                message("I'm expecting one of these columns:")
                message(" => barcode")
                message("    Has the complete barcode (TCGA-AA-3833-01A-01D-0904-05)")
                message(" => bcr_patient_barcode")
                message("    Has the patient barcode (TCGA-AA-3833)")
                message(" => patient")
                message("    Has the patient barcode (TCGA-AA-3833)")
                message(" => sample")
                message("    Has the sample barcode (TCGA-AA-3833-01A)")
                message("-----------------------------------------------")
                message("Obs: The complete barcode is the recommended one, as the others might lead to errors")
                return(NULL)
            }
            stopifnot(nchar(as.character(col.metadata[,id])[1]) == size)
            message(paste0("Reorganizing: col.metadata order should be the same of the data object"))
            df <- col.metadata[match(substr(colnames(data),1,size), col.metadata[,id]),]
            df[,id] <- NULL

            duplicated.samples <- any(sapply(col.metadata[,id],
                                             function(x) {length(grep(x,col.metadata[,id])) > 1 }))
            if(duplicated.samples){
                warning("Some samples are from the same patient, this might lead to the wrong upper annotation")
            }

            if (!missing(sortCol)) {
                message(paste0("Sorting columns based on column: ",
                               sortCol))
                column_order <- order(df[,sortCol])
            }
            if(is.null(col.colors)) {
                ha <- ComplexHeatmap::HeatmapAnnotation(df = df)
            } else {
                ha <- ComplexHeatmap::HeatmapAnnotation(df = df,
                                                        col = col.colors)
            }
        }
    }
    # STEP 2 Create heatmap
    if(is.null(color.levels)) {
        if (type == "expression") color.levels <-  c("green", "white", "red")
        if (type == "methylation") color.levels <-  c("blue", "white", "red")
    }


    # If we want to show differences between genes, it is good to make Z-score by samples
    # (force each sample to have zero mean and standard deviation=1).
    # If we want to show differences between samples, it is good to make Z-score by genes
    # (force each gene to have zero mean and standard deviation=1).
    if(scale == "row"){
        message("Calculating z-scores for the rows....")
        data <- t(scale(t(data)))
        all.na <- apply(data,1, function(x) all(is.na(x)))
        data <- data[!all.na,]
    } else if(scale == "col"){
        message("Calculiating z-scores for the columns....")
        data <- scale(data)
    }

    if(is.null(extremes)) {
        if(min(data,na.rm = TRUE) < 0) {
            extremes <- c(min(data,na.rm = TRUE), (max(data,na.rm = TRUE) + min(data,na.rm = TRUE))/2, max(data,na.rm = TRUE))
        } else {
            extremes <- c(0, max(data,na.rm = TRUE)/2, max(data,na.rm = TRUE))
        }
    }
    if (type == "expression") color <- circlize::colorRamp2(extremes, color.levels)
    if (type == "methylation") color <- circlize::colorRamp2(extremes, color.levels)

    # Creating plot title
    if(is.null(title)) {
        if(type == "methylation") title <- "DNA methylation heatmap"
        if(type == "expression") title <- "Expression heatmap"
    }
    # Change label type
    heatmap_legend_param <- list()
    if(heatmap.legend.color.bar == "continuous" && type == "methylation"){
        heatmap_legend_param <- c(list(color_bar = "continuous"),heatmap_legend_param)
        if(!scale %in% c("row","col")) heatmap_legend_param <- list(color_bar = "continuous", at = c(0,0.2,0.4,0.6,0.8, 1), legend_height = unit(3, "cm"), labels = c("0.0 (hypomethylated)",0.2,0.4,0.6,0.8,"1.0 (hypermethylated)"))
    }
    if(heatmap.legend.color.bar == "continuous" && type == "expression"){
        heatmap_legend_param <- c(list(color_bar = "continuous"),heatmap_legend_param)
    }
    # Change label reference
    if(is.null(values.label)){
        if(type == "methylation") values.label <- "DNA methylation level"
        if(type == "expression") {
            values.label <- "Expression"
            if(scale != "none") values.label <- paste0(values.label, "(z-score)")
        }
    }
    if(!missing(sortCol) & heatmap.legend.color.bar == "continuous"){
        heatmap  <- ComplexHeatmap::Heatmap(
            data,
            name = values.label,
            top_annotation = ha,
            col = color,
            row_names_gp =  grid::gpar(fontsize = rownames.size),
            show_row_names = show_row_names,
            cluster_rows = cluster_rows,
            cluster_columns = cluster_columns,
            show_column_names = show_column_names,
            column_order = column_order,
            column_title = title,
            heatmap_legend_param = heatmap_legend_param)
    } else if(missing(sortCol) & heatmap.legend.color.bar == "continuous"){
        heatmap  <- ComplexHeatmap::Heatmap(
            data,
            name = values.label,
            top_annotation = ha,
            col = color,
            show_row_names = show_row_names,
            row_names_gp =  grid::gpar(fontsize = rownames.size),
            cluster_rows = cluster_rows,
            cluster_columns = cluster_columns,
            show_column_names = show_column_names,
            column_title = title,
            heatmap_legend_param = heatmap_legend_param)
    }  else if(!missing(sortCol)){
        heatmap  <- ComplexHeatmap::Heatmap(
            data,
            name = values.label,
            top_annotation = ha,
            col = color,
            row_names_gp =  grid::gpar(fontsize = rownames.size),
            show_row_names = show_row_names,
            cluster_rows = cluster_rows,
            cluster_columns = cluster_columns,
            show_column_names = show_column_names,
            column_order = column_order,
            column_title = title)
    } else {
        heatmap  <- ComplexHeatmap::Heatmap(
            data,
            name = values.label,
            top_annotation = ha,
            col = color,
            row_names_gp =  grid::gpar(fontsize = rownames.size),
            show_row_names = show_row_names,
            cluster_rows = cluster_rows,
            cluster_columns = cluster_columns,
            show_column_names = show_column_names,
            column_title = title,
            heatmap_legend_param = heatmap_legend_param)
    }

    # STEP 3 row labels (right side)
    if (!missing(row.metadata)) {
        if (!is.null(row.metadata)) {
            for (i in 1:ncol(row.metadata)) {
                if (!missing(row.colors) && !is.null(row.colors[[colnames(row.metadata)[i]]])) {
                    color <- row.colors[[colnames(row.metadata)[i]]]
                    x = ComplexHeatmap::Heatmap(
                        row.metadata[,i] ,
                        name = colnames(row.metadata)[i],
                        width = unit(0.5, "cm"),
                        show_row_names = FALSE, col = color )
                } else {
                    x = ComplexHeatmap::Heatmap(
                        row.metadata[,i] ,
                        name = colnames(row.metadata)[i],
                        width = unit(0.5, "cm"),
                        show_row_names = FALSE)
                }
                heatmap <- ComplexHeatmap::add_heatmap(heatmap,x)
            }
        }
    }
    if(!is.null(filename)){
        if(tools::file_ext(filename) == "png") png(filename, width = width, height = height )
        if(tools::file_ext(filename) == "pdf") pdf(filename, width = width, height = height )
        ComplexHeatmap::draw(heatmap)
        dev.off()
    } else {
        ComplexHeatmap::draw(heatmap)
    }
}


# unlist labels
# Help function that unlists a list into a vector
unlistlabels <- function(lab) {
    dummy <- unlist(lab)
    labels <- c()
    labels <- c(labels, as.character(dummy))
    return(labels)
}


#' Creating a oncoprint
#' @param mut A dataframe from the mutation annotation file (see TCGAquery_maf from TCGAbiolinks)
#' @param genes Gene list
#' @param filename name of the pdf
#' @param color named vector for the plot
#' @param height pdf height
#' @param width pdf width
#' @param rm.empty.columns If there is no alteration in that sample, whether remove it on the oncoprint
#' @param show.row.barplot  Show barplot annotation on rows?
#' @param show.column.names Show column names? Default: FALSE
#' @param rows.font.size Size of the fonts
#' @param column.names.size Size of the fonts of the columns names
#' @param dist.col distance between columns in the plot
#' @param dist.row distance between rows in the plot
#' @param label.font.size Size of the fonts
#' @param row.order Order the genes (rows) Default:TRUE. Genes with more mutations will be in the first rows
#' @param col.order Order columns. Default:TRUE.
#' @param annotation Matrix or data frame with the annotation.
#' Should have a column bcr_patient_barcode with the same ID of the mutation object
#' @param annotation.position Position of the annotation "bottom" or "top"
#' @param label.title Title of the label
#' @param annotation.legend.side Position of the annotation legend
#' @param heatmap.legend.side Position of the heatmap legend
#' @param information Which column to use as information from MAF.
#' Options: 1) "Variant_Classification" (The information will be "Frame_Shift_Del", "Frame_Shift_Ins",
#'         "In_Frame_Del", "In_Frame_Ins", "Missense_Mutation",  "Nonsense_Mutation",
#'              "Nonstop_Mutation",  "RNA",  "Silent" ,  "Splice_Site",  "Targeted_Region",  "Translation_Start_Site")
#' 2) "Variant_Type" (The information will be INS,DEL,SNP)
#' @importFrom data.table dcast setDT setDF :=
#' @examples
#' \dontrun{
#' library(dplyr)
#' query <- GDCquery(
#'    project = "TCGA-CHOL",
#'    data.category = "Simple Nucleotide Variation",
#'    access = "open",
#'    legacy = FALSE,
#'    data.type = "Masked Somatic Mutation",
#'    workflow.type = "Aliquot Ensemble Somatic Variant Merging and Masking"
#')
#' GDCdownload(query)
#' mut <- GDCprepare(query)
#' TCGAvisualize_oncoprint(mut = mut, genes = mut$Hugo_Symbol[1:10], rm.empty.columns = TRUE)
#' TCGAvisualize_oncoprint(
#'   mut = mut, genes = mut$Hugo_Symbol[1:10],
#'   filename = "onco.pdf",
#'   color = c("background"="#CCCCCC","DEL"="purple","INS"="yellow","SNP"="brown")
#' )
#' clin <- GDCquery_clinic("TCGA-ACC","clinical")
#' clin <- clin[,c("bcr_patient_barcode","disease","gender","tumor_stage","race","vital_status")]
#' TCGAvisualize_oncoprint(
#'    mut = mut, genes = mut$Hugo_Symbol[1:20],
#'    filename = "onco.pdf",
#'    annotation = clin,
#'    color=c("background"="#CCCCCC","DEL"="purple","INS"="yellow","SNP"="brown"),
#'    rows.font.size=10,
#'    heatmap.legend.side = "right",
#'    dist.col = 0,
#'    label.font.size = 10
#' )
#' }
#' @export
#' @return A oncoprint plot
TCGAvisualize_oncoprint <- function(
        mut,
        genes,
        filename,
        color,
        annotation.position = "bottom",
        annotation,
        height,
        width = 10,
        rm.empty.columns = FALSE,
        show.column.names = FALSE,
        show.row.barplot = TRUE,
        label.title = "Mutation",
        column.names.size = 8,
        label.font.size = 16,
        rows.font.size = 16,
        dist.col = 0.5,
        dist.row = 0.5,
        information = "Variant_Type",
        row.order = TRUE,
        col.order = TRUE,
        heatmap.legend.side = "bottom",
        annotation.legend.side = "bottom"
){

    check_package("ComplexHeatmap")
    check_package("circlize")
    check_package("grid")

    if(missing(mut)) stop("Missing mut argument")
    mut <- setDT(mut)
    mut$value <- 1
    if(rm.empty.columns == FALSE) all.samples <- unique(mut$Tumor_Sample_Barcode)

    mut$Hugo_Symbol <- as.character(mut$Hugo_Symbol)
    if(!missing(genes) & !is.null(genes)) mut <- subset(mut, mut$Hugo_Symbol %in% genes)

    if(!rm.empty.columns){
        formula <- paste0("Tumor_Sample_Barcode + Hugo_Symbol ~ ", information)
        suppressMessages({mat <- dcast(mut, as.formula(formula),value.var = "value",fill = 0,drop = FALSE)})
    } else {
        formula <- paste0("Tumor_Sample_Barcode + Hugo_Symbol ~ ", information)
        suppressMessages({mat <- dcast(mut, as.formula(formula),value.var = "value",fill = 0,drop = TRUE)})
    }

    # mutation in the file
    columns <- colnames(mat)[-c(1:2)]

    # value will be a collum with all the mutations
    mat$value <- ""

    for ( i in columns){
        mat[,i] <-  replace(mat[,i,with = FALSE],mat[,i,with = FALSE]>0,paste0(i,";"))
        mat[,i] <-  replace(mat[,i,with = FALSE],mat[,i,with = FALSE]==0,"")
        mat[,value:=paste0(value,get(i))]
    }

    # After the gene selection, some of the mutation might not exist
    # we will remove them to make the oncoprint work
    mutation.type <- c()
    for (i in columns){
        if(length(grep(i,mat$value)) > 0) mutation.type <- c(mutation.type,i)
    }

    # now we have a matrix with pairs samples/genes mutations
    # we want a matrix with samples vs genes mutations with the content being the value
    mat <- setDF(dcast(mat, Tumor_Sample_Barcode~Hugo_Symbol, value.var="value",fill=""))
    rownames(mat) <- mat[,1]
    mat <- mat[,-1]

    if(rm.empty.columns == FALSE) {
        aux <- data.frame(row.names = all.samples[!all.samples %in% rownames(mat)])
        if(nrow(aux) > 0) {
            aux[,colnames(mat)] <- ""
            mat <- rbind(mat,aux)
        }
    }



    alter_fun = function(x, y, w, h, v) {
        n = sum(v)
        h = h * 0.9
        # use `names(which(v))` to correctly map between `v` and `col`

        # Oncoprint with one value does not have names in v
        if(is.null(names(v))){
            if(v){
                grid::grid.rect(
                    x,
                    y - h * 0.5 + 1:n / n * h,
                    w - unit(dist.col, "mm"),
                    1 / n * h,
                    gp = grid::gpar(fill = setdiff(color,color["background"]), col = NA),
                    just = "top"
                )
            } else {
                grid::grid.rect(
                    x,
                    y,
                    w - unit(dist.col, "mm"),
                    h - unit(dist.row, "mm"),
                    gp = grid::gpar(fill = color["background"], col = NA)
                )
            }
        } else {
            if (length(names(which(v)))) {
                grid::grid.rect(
                    x,
                    y - h * 0.5 + 1:n / n * h,
                    w - unit(dist.col, "mm"),
                    1 / n * h,
                    gp = grid::gpar(fill = color[names(which(v))], col = NA),
                    just = "top"
                )
            } else {
                grid::grid.rect(
                    x,
                    y,
                    w - unit(dist.col, "mm"),
                    h - unit(dist.row, "mm"),
                    gp = grid::gpar(fill = color["background"], col = NA)
                )
            }
        }
    }

    # get only the colors to the mutations
    # otherwise it gives errors
    if(missing(color)){
        check_package("grDevices")
        color <- c(grDevices::rainbow(length(mutation.type)), "#CCCCCC")
        names(color) <- c(mutation.type,"background")
    } else{
        if("background" %in% names(color)) {
            color <- color[c(mutation.type,"background")]
        } else {
            color <- c(color[mutation.type],"background"= "#CCCCCC")
        }
    }
    print(color)
    # header are samples, rows genes
    mat <- t(mat)

    if(!missing(height)) height <- length(genes)/2
    if(!missing(filename)) pdf(filename,width = width,height = height)

    if(missing(annotation)) annotation <- NULL
    if(!is.null(annotation)){
        if(!"bcr_patient_barcode" %in% colnames(annotation))
            stop("bcr_patient_barcode column should be in the annotation")
        idx <- match(substr(colnames(mat),1,12),annotation$bcr_patient_barcode)
        if(all(is.na(idx)))
            stop(" We couldn't match the columns names with the bcr_patient_barcode column in the annotation object")
        annotation <- annotation[idx,]

        annotation$bcr_patient_barcode <- NULL

        n.col <- sum(sapply(colnames(annotation), function(x) {
            length(unique(annotation[,x]))
        }))

        # add automatic colors: not working

        get.color <- function(df,col){
            idx <- which(colnames(df) == col)
            start <- 1
            if(idx != 1) start <- length(na.omit(unique(unlist(c(df[,1:(idx-1)]))))) + 1
            end <- start + length(na.omit(unique(df[,col]))) -1
            diff.colors <- c("purple","thistle","deeppink3","magenta4","lightsteelblue1","black",
                             "chartreuse","lightgreen","maroon4","darkslategray",
                             "lightyellow3","darkslateblue","firebrick1","aquamarine",
                             "dodgerblue4","bisque4","moccasin","indianred1",
                             "yellow","gray93","cyan","darkseagreen4",
                             "lightgoldenrodyellow","lightpink","sienna1",
                             "darkred","palevioletred","tomato4","blue",
                             "mediumorchid4","royalblue1","magenta2","darkgoldenrod1")
            return(diff.colors[start:end])
        }
        col.annot <- lapply(colnames(annotation), function(x) {
            #idx <- which(colnames(annotation) == x) - 1
            #print(idx/n.col)
            ret <- get.color(annotation,x)
            #ret <- rainbow(length(unique(annotation[,x])),start = idx/n.col,alpha=0.5)
            names(ret) <- as.character(na.omit(unique(annotation[,x])))
            return(ret)
        })
        names(col.annot) <-  colnames(annotation)


        annotHeatmap <-
            ComplexHeatmap::HeatmapAnnotation(
                df = annotation,
                col = col.annot,
                annotation_legend_param = list(
                    title_gp = grid::gpar(fontsize = label.font.size,
                                          fontface =
                                              "bold"),
                    labels_gp =
                        grid::gpar(fontsize = label.font.size),
                    #sizelabels
                    grid_height =
                        unit(8, "mm")
                )
            )
    }
    if(heatmap.legend.side == "bottom") {
        nrow <- 1
        title_position <- "leftcenter"
    } else {
        nrow <- 10
        title_position <- "topcenter"
    }

    if(is.null(annotation) & !row.order & !col.order){
        p <- ComplexHeatmap::oncoPrint(mat, get_type = function(x) strsplit(x, ";")[[1]],
                                       row_order = NULL,
                                       remove_empty_columns = FALSE,
                                       show_column_names = show.column.names,
                                       column_order = NULL, # Do not sort the columns
                                       alter_fun = alter_fun, col = color,
                                       column_names_gp = grid::gpar(fontsize = column.names.size),
                                       row_names_gp = grid::gpar(fontsize = rows.font.size),  # set size for row names
                                       pct_gp = grid::gpar(fontsize = rows.font.size), # set size for percentage labels
                                       #column_title = "OncoPrint for TCGA LGG, genes in Glioma signaling",
                                       #column_title_gp = grid::gpar(fontsize = 11),
                                       heatmap_legend_param = list(title = label.title, at = names(color),
                                                                   labels = names(color),
                                                                   title_gp = grid::gpar(fontsize = label.font.size, fontface = "bold"),
                                                                   labels_gp = grid::gpar(fontsize = label.font.size), # size labels
                                                                   grid_height = unit(8, "mm"), # vertical distance labels
                                                                   nrow = nrow, title_position = title_position
                                       )
        )
    } else if(!is.null(annotation) & annotation.position == "bottom" & !row.order & !col.order){

        p <- ComplexHeatmap::oncoPrint(mat, get_type = function(x) strsplit(x, ";")[[1]],
                                       row_order = NULL,
                                       remove_empty_columns = FALSE,
                                       column_names_gp = grid::gpar(fontsize = column.names.size),
                                       show_column_names = show.column.names,
                                       column_order = NULL, # Do not sort the columns
                                       alter_fun = alter_fun, col = color,
                                       row_names_gp = grid::gpar(fontsize = rows.font.size),  # set size for row names
                                       pct_gp = grid::gpar(fontsize = rows.font.size), # set size for percentage labels
                                       #column_title = "OncoPrint for TCGA LGG, genes in Glioma signaling",
                                       #column_title_gp = grid::gpar(fontsize = 11),
                                       bottom_annotation = annotHeatmap,
                                       heatmap_legend_param = list(title = label.title, at = names(color),
                                                                   labels = names(color),
                                                                   title_gp = grid::gpar(fontsize = label.font.size, fontface = "bold"),
                                                                   labels_gp = grid::gpar(fontsize = label.font.size), # size labels
                                                                   grid_height = unit(8, "mm"), # vertical distance labels
                                                                   nrow = nrow, title_position = title_position
                                       )
        )

    } else if(!is.null(annotation) & annotation.position == "top" & !row.order  & !col.order){
        p <- ComplexHeatmap::oncoPrint(mat, get_type = function(x) strsplit(x, ";")[[1]],
                                       row_order = NULL,
                                       remove_empty_columns = FALSE,
                                       column_names_gp = grid::gpar(fontsize = column.names.size),
                                       show_column_names = show.column.names,
                                       column_order = NULL, # Do not sort the columns
                                       alter_fun = alter_fun, col = color,
                                       row_names_gp = grid::gpar(fontsize = rows.font.size),  # set size for row names
                                       pct_gp = grid::gpar(fontsize = rows.font.size), # set size for percentage labels
                                       #column_title = "OncoPrint for TCGA LGG, genes in Glioma signaling",
                                       #column_title_gp = grid::gpar(fontsize = 11),
                                       top_annotation = annotHeatmap,
                                       heatmap_legend_param = list(title = label.title, at = names(color),
                                                                   labels = names(color),
                                                                   title_gp = grid::gpar(fontsize = label.font.size, fontface = "bold"),
                                                                   labels_gp = grid::gpar(fontsize = label.font.size), # size labels
                                                                   grid_height = unit(8, "mm"),  # vertical distance labels
                                                                   nrow = nrow, title_position = title_position
                                       )
        )
    }  else if(is.null(annotation) & row.order  & !col.order){
        p <- ComplexHeatmap::oncoPrint(mat, get_type = function(x) strsplit(x, ";")[[1]],
                                       remove_empty_columns = FALSE,
                                       show_column_names = show.column.names,
                                       column_order = NULL, # Do not sort the columns
                                       alter_fun = alter_fun, col = color,
                                       column_names_gp = grid::gpar(fontsize = column.names.size),
                                       row_names_gp = grid::gpar(fontsize = rows.font.size),  # set size for row names
                                       pct_gp = grid::gpar(fontsize = rows.font.size), # set size for percentage labels
                                       #column_title = "OncoPrint for TCGA LGG, genes in Glioma signaling",
                                       #column_title_gp = grid::gpar(fontsize = 11),
                                       heatmap_legend_param = list(title = label.title, at = names(color),
                                                                   labels = names(color),
                                                                   title_gp = grid::gpar(fontsize = label.font.size, fontface = "bold"),
                                                                   labels_gp = grid::gpar(fontsize = label.font.size), # size labels
                                                                   grid_height = unit(8, "mm"), # vertical distance labels
                                                                   nrow = nrow, title_position = title_position
                                       )
        )
    } else if(!is.null(annotation) & annotation.position == "bottom" & row.order & !col.order){

        p <- ComplexHeatmap::oncoPrint(mat, get_type = function(x) strsplit(x, ";")[[1]],
                                       remove_empty_columns = FALSE,
                                       column_names_gp = grid::gpar(fontsize = column.names.size),
                                       show_column_names = show.column.names,
                                       column_order = NULL, # Do not sort the columns
                                       alter_fun = alter_fun, col = color,
                                       row_names_gp = grid::gpar(fontsize = rows.font.size),  # set size for row names
                                       pct_gp = grid::gpar(fontsize = rows.font.size), # set size for percentage labels
                                       #column_title = "OncoPrint for TCGA LGG, genes in Glioma signaling",
                                       #column_title_gp = grid::gpar(fontsize = 11),
                                       bottom_annotation = annotHeatmap,
                                       heatmap_legend_param = list(title = label.title, at = names(color),
                                                                   labels = names(color),
                                                                   title_gp = grid::gpar(fontsize = label.font.size, fontface = "bold"),
                                                                   labels_gp = grid::gpar(fontsize = label.font.size), # size labels
                                                                   grid_height = unit(8, "mm"), # vertical distance labels
                                                                   nrow = nrow, title_position = title_position
                                       )
        )

    } else if(!is.null(annotation) & annotation.position == "top" & row.order & !col.order){
        p <- ComplexHeatmap::oncoPrint(mat, get_type = function(x) strsplit(x, ";")[[1]],
                                       remove_empty_columns = FALSE,
                                       show_column_names = show.column.names,
                                       column_order = NULL, # Do not sort the columns
                                       alter_fun = alter_fun, col = color,
                                       column_names_gp = grid::gpar(fontsize = column.names.size),
                                       row_names_gp = grid::gpar(fontsize = rows.font.size),  # set size for row names
                                       pct_gp = grid::gpar(fontsize = rows.font.size), # set size for percentage labels
                                       #column_title = "OncoPrint for TCGA LGG, genes in Glioma signaling",
                                       #column_title_gp = grid::gpar(fontsize = 11),
                                       top_annotation = annotHeatmap,
                                       heatmap_legend_param = list(title = label.title, at = names(color),
                                                                   labels = names(color),
                                                                   title_gp = grid::gpar(fontsize = label.font.size, fontface = "bold"),
                                                                   labels_gp = grid::gpar(fontsize = label.font.size), # size labels
                                                                   grid_height = unit(8, "mm"),  # vertical distance labels
                                                                   nrow = nrow, title_position = title_position
                                       )
        )
    } else if(is.null(annotation) & !row.order & col.order){
        p <- ComplexHeatmap::oncoPrint(mat, get_type = function(x) strsplit(x, ";")[[1]],
                                       row_order = NULL,
                                       remove_empty_columns = FALSE,
                                       show_column_names = show.column.names,
                                       alter_fun = alter_fun, col = color,
                                       column_names_gp = grid::gpar(fontsize = column.names.size),
                                       row_names_gp = grid::gpar(fontsize = rows.font.size),  # set size for row names
                                       pct_gp = grid::gpar(fontsize = rows.font.size), # set size for percentage labels
                                       #column_title = "OncoPrint for TCGA LGG, genes in Glioma signaling",
                                       #column_title_gp = grid::gpar(fontsize = 11),
                                       heatmap_legend_param = list(title = label.title, at = names(color),
                                                                   labels = names(color),
                                                                   title_gp = grid::gpar(fontsize = label.font.size, fontface = "bold"),
                                                                   labels_gp = grid::gpar(fontsize = label.font.size), # size labels
                                                                   grid_height = unit(8, "mm"), # vertical distance labels
                                                                   nrow = nrow, title_position = title_position
                                       )
        )
    } else if(!is.null(annotation) & annotation.position == "bottom" & !row.order & col.order){

        p <- ComplexHeatmap::oncoPrint(mat, get_type = function(x) strsplit(x, ";")[[1]],
                                       row_order = NULL,
                                       remove_empty_columns = FALSE,
                                       column_names_gp = grid::gpar(fontsize = column.names.size),
                                       show_column_names = show.column.names,
                                       alter_fun = alter_fun, col = color,
                                       row_names_gp = grid::gpar(fontsize = rows.font.size),  # set size for row names
                                       pct_gp = grid::gpar(fontsize = rows.font.size), # set size for percentage labels
                                       #column_title = "OncoPrint for TCGA LGG, genes in Glioma signaling",
                                       #column_title_gp = grid::gpar(fontsize = 11),
                                       bottom_annotation = annotHeatmap,
                                       heatmap_legend_param = list(title = label.title, at = names(color),
                                                                   labels = names(color),
                                                                   title_gp = grid::gpar(fontsize = label.font.size, fontface = "bold"),
                                                                   labels_gp = grid::gpar(fontsize = label.font.size), # size labels
                                                                   grid_height = unit(8, "mm"), # vertical distance labels
                                                                   nrow = nrow, title_position = title_position
                                       )
        )

    } else if(!is.null(annotation) & annotation.position == "top" & !row.order & col.order){
        p <- ComplexHeatmap::oncoPrint(mat, get_type = function(x) strsplit(x, ";")[[1]],
                                       row_order = NULL,
                                       remove_empty_columns = FALSE,
                                       column_names_gp = grid::gpar(fontsize = column.names.size),
                                       show_column_names = show.column.names,
                                       alter_fun = alter_fun, col = color,
                                       row_names_gp = grid::gpar(fontsize = rows.font.size),  # set size for row names
                                       pct_gp = grid::gpar(fontsize = rows.font.size), # set size for percentage labels
                                       #column_title = "OncoPrint for TCGA LGG, genes in Glioma signaling",
                                       #column_title_gp = grid::gpar(fontsize = 11),
                                       top_annotation = annotHeatmap,
                                       heatmap_legend_param = list(title = label.title, at = names(color),
                                                                   labels = names(color),
                                                                   title_gp = grid::gpar(fontsize = label.font.size, fontface = "bold"),
                                                                   labels_gp = grid::gpar(fontsize = label.font.size), # size labels
                                                                   grid_height = unit(8, "mm"),  # vertical distance labels
                                                                   nrow = nrow, title_position = title_position
                                       )
        )
    }  else if(is.null(annotation) & row.order & col.order){
        save(mat,color,alter_fun,file = "test.rda")
        p <- ComplexHeatmap::oncoPrint(mat, get_type = function(x) strsplit(x, ";")[[1]],
                                       remove_empty_columns = FALSE,
                                       show_column_names = show.column.names,

                                       alter_fun = alter_fun,
                                       col = color,
                                       column_names_gp = grid::gpar(fontsize = column.names.size),
                                       row_names_gp = grid::gpar(fontsize = rows.font.size),  # set size for row names
                                       pct_gp = grid::gpar(fontsize = rows.font.size), # set size for percentage labels
                                       #column_title = "OncoPrint for TCGA LGG, genes in Glioma signaling",
                                       #column_title_gp = grid::gpar(fontsize = 11),
                                       heatmap_legend_param = list(title = label.title, at = names(color),
                                                                   labels = names(color),
                                                                   title_gp = grid::gpar(fontsize = label.font.size, fontface = "bold"),
                                                                   labels_gp = grid::gpar(fontsize = label.font.size), # size labels
                                                                   grid_height = unit(8, "mm"), # vertical distance labels
                                                                   nrow = nrow, title_position = title_position
                                       )
        )
    } else if(!is.null(annotation) & annotation.position == "bottom" & row.order & col.order){


        p <- ComplexHeatmap::oncoPrint(
            mat, get_type = function(x) strsplit(x, ";")[[1]],
            remove_empty_columns = FALSE,
            column_names_gp = grid::gpar(fontsize = column.names.size),
            #show_row_barplot = show.row.barplot,
            show_column_names = show.column.names,
            alter_fun = alter_fun, col = color,
            row_names_gp = grid::gpar(fontsize = rows.font.size),  # set size for row names
            pct_gp = grid::gpar(fontsize = rows.font.size), # set size for percentage labels
            #axis_gp = grid::gpar(fontsize = rows.font.size),# size of axis
            #column_title = "OncoPrint for TCGA LGG, genes in Glioma signaling",
            #column_title_gp = grid::gpar(fontsize = 11),
            #row_barplot_width = unit(2, "cm"), #size barplot
            bottom_annotation = annotHeatmap,
            heatmap_legend_param = list(
                title = label.title, at = names(color),
                labels = names(color),
                title_gp = grid::gpar(fontsize = label.font.size, fontface = "bold"),
                labels_gp = grid::gpar(fontsize = label.font.size), # size labels
                grid_height = unit(8, "mm"), # vertical distance labels
                nrow = nrow,
                title_position = title_position
            )
        )

    } else if(!is.null(annotation) & annotation.position == "top" & row.order & col.order){
        p <- ComplexHeatmap::oncoPrint(
            mat, get_type = function(x) strsplit(x, ";")[[1]],
            remove_empty_columns = FALSE,
            show_column_names = show.column.names,
            alter_fun = alter_fun, col = color,
            column_names_gp = grid::gpar(fontsize = column.names.size),
            row_names_gp = grid::gpar(fontsize = rows.font.size),  # set size for row names
            pct_gp = grid::gpar(fontsize = rows.font.size), # set size for percentage labels
            #column_title = "OncoPrint for TCGA LGG, genes in Glioma signaling",
            #column_title_gp = grid::gpar(fontsize = 11),
            top_annotation = annotHeatmap,
            heatmap_legend_param = list(
                title = label.title, at = names(color),
                labels = names(color),
                title_gp = grid::gpar(fontsize = label.font.size, fontface = "bold"),
                labels_gp = grid::gpar(fontsize = label.font.size), # size labels
                grid_height = unit(8, "mm"),  # vertical distance labels
                nrow = nrow, title_position = title_position
            )
        )
    }

    ComplexHeatmap::draw(p, heatmap_legend_side = heatmap.legend.side,
                         annotation_legend_side = annotation.legend.side)

    if(!missing(filename)) {
        dev.off()
        message(paste0("File saved as: ", filename ))
    }

}

#' @title Creates a volcano plot for DNA methylation or gene expression
#' @description Creates a volcano plot from the
#' gene expression and DNA methylation analysis.
#' @details
#'    Creates a volcano plot from the gene expression and DNA methylation analysis.
#'    Please see the vignette for more information
#' @param x x-axis data (i.e. Diff mean beta-values or Log2FC).
#' @param y FDR adjusted p-value (q-value). This data will be transformed to -log10 values.
#' @param y.cut q-values threshold (i.e. 0.01, 10^-10)
#' @param x.cut  x-axis threshold. Default: 0.0 If you give only one number (e.g. 0.2) the cut-offs will be
#'  -0.2 and 0.2. Or you can give different cut-offs as a vector (e.g. c(-0.3,0.4))
#' @param filename File name: volcano.pdf, volcano.svg, volcano.png. If NULL returns
#' the ggplot object.
#' @param legend Legend title
#' @param color vector of colors to be used in graph
#' @param title main title. If not specified it will be
#' "Volcano plot (group1 vs group2)
#' @param ylab y axis text. Default: -Log10 FDR corrected P-values
#' @param xlab x axis text. Default: No text. Examples of input:
#' expression(paste(Log[2], "FoldChange"))
#' @param xlim x limits to cut image (i.e. c(-4,4))
#' @param ylim y limits to cut image (i.e. c(-1,10))
#' @param height Figure height
#' @param width Figure width
#' @param names Names to be plotted if significant.
#' Should be the same size of x and y
#' @param names.fill Names should be filled in a color box?  Default: TRUE
#' @param names.size Size of the names text
#' @param dpi Figure dpi
#' @param label vector of labels to be used in the figure.
#' Example: c("Not Significant","Hypermethylated in group1",
#' "Hypomethylated in group1"))#'
#' @param highlight List of genes/probes to be highlighted. It should be in the names argument.
#' @param highlight.color Color of the points highlighted
#' @param show.names What names will be showed? Possibilities: "both", "significant", "highlighted"
#' @export
#' @return Saves the volcano plot in the current folder
#' @examples
#' log2_foldchange <- runif(200, -2, 2)
#' fdr <- runif(200, 0.01, 1)
#' TCGAVisualize_volcano(
#'     x = log2_foldchange,
#'     y = fdr,
#'     x.cut = 1.5,
#'     y.cut = 0.01,
#'     title = "Title example",
#'     xlab = expression(paste(Log[2], "FoldChange"))
#' )
#' \dontrun{
#' beta_diff <- runif(200, -1, 1)
#' fdr <- runif(200, 0.01, 1)
#' TCGAVisualize_volcano(
#'     x = beta_diff,
#'     y = fdr,
#'     x.cut = 1.5,
#'     y.cut = 0.01,
#'     title = "Title example",
#'     xlab = expression(paste("DNA Methylation difference (", beta, "-values)"))
#' )
#' TCGAVisualize_volcano(
#'   x,
#'   y,
#'   filename = NULL,
#'   y.cut = 10000000,
#'   x.cut=0.8,
#'    names = rep("AAAA",length(x)),
#'    legend = "Status",
#'    names.fill = FALSE
#' )
#'
#' TCGAVisualize_volcano(
#'   x,
#'   y,
#'   filename = NULL,
#'   y.cut = 10000000,
#'   x.cut = 0.8,
#'    names = as.character(1:length(x)),
#'    legend = "Status",
#'    names.fill = TRUE, highlight = c("1","2"),
#'    show = "both"
#' )
#' TCGAVisualize_volcano(
#'   x,
#'   y,
#'   filename = NULL,
#'   y.cut = 10000000,
#'   x.cut = c(-0.3,0.8),
#'   names = as.character(1:length(x)),
#'   legend = "Status",
#'   names.fill = TRUE,
#'   highlight = c("1","2"),
#'   show = "both"
#' )
#' }
#' while (!(is.null(dev.list()["RStudioGD"]))){dev.off()}
TCGAVisualize_volcano <- function(
        x,
        y,
        filename = "volcano.pdf",
        ylab =  expression(paste(-Log[10]," (FDR corrected P-values)")),
        xlab = NULL,
        title = "Volcano plot",
        legend = NULL,
        label = NULL,
        xlim = NULL,
        ylim = NULL,
        color = c("black", "red", "green"),
        names = NULL,
        names.fill = TRUE,
        show.names = "significant",
        x.cut = 0,
        y.cut = 0.01,
        height = 5,
        width = 10,
        highlight = NULL,
        highlight.color = "orange",
        names.size = 4,
        dpi = 300)
{
    if (!is.null(names)) {
        if (all(grepl("\\|", names))) {
            names <- strsplit(names, "\\|")
            names <- unlist(lapply(names, function(x)
                x[1]))
        }
    }
    .e <- environment()
    threshold <- rep("1", length(x))
    names(color) <- as.character(1:3)

    if (is.null(label)) {
        label = c(
            "1" = "Not Significant",
            "2" = "Up regulated",
            "3" = "Down regulated"
        )
    } else  {
        names(label) <- as.character(1:3)
    }
    # get significant data
    sig <-  y < y.cut
    sig[is.na(sig)] <- FALSE

    # If x.cut
    if (length(x.cut) == 1) {
        x.cut.min <- -1 * x.cut
        x.cut.max <- x.cut
    }
    if (length(x.cut) == 2) {
        x.cut.min <- x.cut[1]
        x.cut.max <- x.cut[2]
    }

    # hypermethylated/up regulated samples compared to old state
    up <- x  > x.cut.max
    up[is.na(up)] <- FALSE
    if (any(up & sig)) threshold[up & sig] <- "2"

    # hypomethylated/ down regulated samples compared to old state
    down <-  x < x.cut.min
    down[is.na(down)] <- FALSE
    if (any(down & sig)) threshold[down & sig] <- "3"

    if (!is.null(highlight)) {
        idx <- which(names %in% highlight)
        if (length(idx) > 0) {
            threshold[which(names %in% highlight)]  <- "4"
            color <- c(color, highlight.color)
            names(color) <- as.character(1:4)
        }
    }

    df <- data.frame(
        x = x,
        y = y,
        threshold = threshold
    )

    # As last color should be the highlighthed, we need to order all the vectors
    if (!is.null(highlight)) {
        order.idx <-  order(df$threshold)
        down <- down[order.idx]
        sig <- sig[order.idx]
        up <- up[order.idx]
        df <- df[order.idx,]
        names <- names[order.idx]
    }

    # Plot a volcano plot
    p <- ggplot(
        data = df,
        aes(
            x = x ,
            y = -1 * log10(y),
            colour = threshold
        ),
        environment = .e
    ) +
        geom_point() +
        ggtitle(title) + ylab(ylab) + xlab(xlab) +
        geom_vline(aes(xintercept = x.cut.min),
                   colour = "black",
                   linetype = "dashed") +
        geom_vline(aes(xintercept = x.cut.max),
                   colour = "black",
                   linetype = "dashed") +
        geom_hline(aes(yintercept = -1 * log10(y.cut)),
                   colour = "black",
                   linetype = "dashed") +
        scale_color_manual(
            breaks = as.numeric(names(label)),
            values = color,
            labels = label,
            name = legend
        ) +
        theme_bw() + theme(
            panel.border = element_blank(),
            panel.grid.major = element_blank(),
            panel.grid.minor = element_blank(),
            legend.text = element_text(size = 10),
            plot.title = element_text(hjust = 0.5),
            axis.line.x = element_line(colour = "black"),
            axis.line.y = element_line(colour = "black"),
            legend.position = "top",
            legend.key = element_rect(colour = 'white')
        )

    # Label points with the textxy function from the calibrate plot
    if (!is.null(names)) {
        # With the names the user can highlight the significant genes, up and down
        # or the ones highlighted
        if (show.names == "significant") {
            idx <- (up & sig) | (down & sig)
            important <- c("2", "3")
        } else if (show.names == "highlighted") {
            if (!is.null(highlight)) {
                idx <- (names %in% highlight)
                important <- c("4")
            } else {
                message("Missing highlight argument")
                return(NULL)
            }
        } else if (show.names == "both") {
            if (!is.null(highlight)) {
                idx <- (up & sig) | (down & sig) |  (names %in% highlight)
                important <- c("2", "3", "4")
            } else {
                message("Missing highlight argument")
                return(NULL)
            }
        } else {
            message("Wrong highlight argument")
            return(NULL)
        }

        if (any(threshold %in% important)) {
            check_package("ggrepel")
            if (names.fill) {
                p <- p + ggrepel::geom_label_repel(
                    data = subset(df, threshold %in% important),
                    aes(label = names[idx], fill = threshold),
                    size = names.size,
                    show.legend = FALSE,
                    fontface = 'bold',
                    color = 'white',
                    box.padding = unit(0.35, "lines"),
                    segment.colour = "grey",
                    point.padding = unit(0.3, "lines")
                ) +   scale_fill_manual(values = color[as.numeric(important)])
            }  else {
                p <- p + ggrepel::geom_text_repel(
                    data = subset(df, threshold %in% important),
                    aes(label = names[idx]),
                    size = names.size,
                    show.legend = FALSE,
                    segment.colour = "grey",
                    fontface = 'bold',
                    color = 'black',
                    point.padding = unit(0.3, "lines"),
                    box.padding = unit(0.5, 'lines')
                )
            }
        }
    }

    if(!is.null(xlim)) {
        p <- p + xlim(xlim)
    }

    if(!is.null(ylim)) {
        p <- p + ylim(ylim)
    }

    if (!is.null(filename)) {
        message("Saving file as: ", filename)
        ggsave(
            p,
            filename = filename,
            width = width,
            height = height,
            dpi = dpi
        )
    } else {
        return(p)
    }
}

## ----setup, include=FALSE-----------------------------------------------------
knitr::opts_chunk$set(dpi = 300)
knitr::opts_chunk$set(cache = FALSE)

## ----echo = FALSE,hide=TRUE, message=FALSE,warning=FALSE----------------------
library(TCGAbiolinks)

## ----message=FALSE, warning=FALSE, include=FALSE------------------------------
library(SummarizedExperiment)
library(dplyr)
library(DT)

## ----eval = TRUE, message = FALSE, results = "hide"---------------------------
# Selecting TCGA breast cancer (10 samples) for example stored in dataBRCA
dataNorm <- TCGAanalyze_Normalization(
    tabDF = dataBRCA, 
    geneInfo =  geneInfo
)

# quantile filter of genes
dataFilt <- TCGAanalyze_Filtering(
  tabDF = dataNorm,
  method = "quantile",
  qnt.cut =  0.25
)

data(SC_PCBC_stemSig)
Stemness_score <- TCGAanalyze_Stemness(
  stemSig = SC_PCBC_stemSig,
  dataGE = dataFilt
)
data(ECTO_PCBC_stemSig)
ECTO_score <- TCGAanalyze_Stemness(
  stemSig = ECTO_PCBC_stemSig,
  dataGE = dataFilt,
  colname.score = "ECTO_PCBC_stem_score"
)

data(MESO_PCBC_stemSig)
MESO_score <- TCGAanalyze_Stemness(
  stemSig = MESO_PCBC_stemSig,
  dataGE = dataFilt,
  colname.score = "MESO_PCBC_stem_score"
)

## ----eval = T-----------------------------------------------------------------
head(Stemness_score)
head(ECTO_score)
head(MESO_score)

## ----setup, include=FALSE-----------------------------------------------------
knitr::opts_chunk$set(dpi = 300)
knitr::opts_chunk$set(cache = FALSE)

## ----echo = FALSE,hide=TRUE, message=FALSE,warning=FALSE----------------------
library(TCGAbiolinks)

## ----message=FALSE, warning=FALSE, include=FALSE------------------------------
library(SummarizedExperiment)
library(dplyr)
library(DT)

## ----eval = FALSE, message = FALSE, results = "hide"--------------------------
# query <- GDCquery(
#     project = "TCGA-GBM",
#     data.category = "DNA Methylation",
#     barcode = c("TCGA-06-0122","TCGA-14-1456"),
#     platform = "Illumina Human Methylation 27",
#     data.type = "Methylation Beta Value"
# )
# GDCdownload(query)
# dnam <- GDCprepare(query)

## ----eval = FALSE-------------------------------------------------------------
# assay(dnam)[1:5,1:2]

## ----eval = FALSE-------------------------------------------------------------
# classification <- gliomaClassifier(dnam)

## ----eval = FALSE-------------------------------------------------------------
# names(classification)
# classification$final.classification
# classification$model.classifications
# classification$model.probabilities

## -----------------------------------------------------------------------------
TCGAquery_subtype("GBM") %>%
 dplyr::filter(patient %in% c("TCGA-06-0122","TCGA-14-1456")) %>%
 dplyr::select("patient","Supervised.DNA.Methylation.Cluster")

## ----setup, include=FALSE-----------------------------------------------------
knitr::opts_chunk$set(echo = TRUE)
knitr::opts_knit$set(progress = FALSE)

## ----message=FALSE, warning=FALSE, include=FALSE------------------------------
library(TCGAbiolinks)
library(SummarizedExperiment)
library(dplyr)
library(DT)

## ----results = 'hide', echo=TRUE, message=FALSE, warning=FALSE,eval=F---------
# query <- GDCquery(
#     project = "TCGA-CHOL",
#     data.category = "Simple Nucleotide Variation",
#     access = "open",
#     data.type = "Masked Somatic Mutation",
#     workflow.type = "Aliquot Ensemble Somatic Variant Merging and Masking"
# )
# GDCdownload(query)
# maf <- GDCprepare(query)

## ----results = 'hide', echo=TRUE, message=FALSE, warning=FALSE,eval=T,include=F----
maf <- chol_maf@data

## ----echo = TRUE, message = FALSE, warning = FALSE----------------------------
# Only first 50 to make render faster
datatable(maf[1:20,],
          filter = 'top',
          options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
          rownames = FALSE)

## ----results = 'hide', echo=TRUE, message=FALSE, warning=FALSE,eval=FALSE-----
# maf <- getMC3MAF()

## ----results = "hide",echo = TRUE, message = FALSE, warning = FALSE, eval=FALSE----
# library(maftools)
# library(dplyr)
# query <- GDCquery(
#     project = "TCGA-CHOL",
#     data.category = "Simple Nucleotide Variation",
#     access = "open",
#     data.type = "Masked Somatic Mutation",
#     workflow.type = "Aliquot Ensemble Somatic Variant Merging and Masking"
# )
# GDCdownload(query)
# maf <- GDCprepare(query)
# 
# maf <- maf %>% maftools::read.maf

## ----message=FALSE, warning=FALSE, include=FALSE------------------------------
library(maftools)
library(dplyr)
maf <- chol_maf

## ----results = "hide",echo = TRUE, message = FALSE, warning = FALSE-----------
datatable(getSampleSummary(maf),
          filter = 'top',
          options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
          rownames = FALSE)
plotmafSummary(maf = maf, rmOutlier = TRUE, addStat = 'median', dashboard = TRUE)

## ----echo = TRUE, message = FALSE,eval = FALSE, warning = FALSE---------------
# oncoplot(maf = maf, top = 10, removeNonMutated = TRUE)
# titv = titv(maf = maf, plot = FALSE, useSyn = TRUE)
# #plot titv summary
# plotTiTv(res = titv)

## ----setup, include=FALSE-----------------------------------------------------
knitr::opts_chunk$set(dpi = 300)
knitr::opts_chunk$set(cache=FALSE)

## ----message=FALSE, warning=FALSE, include=FALSE------------------------------
library(TCGAbiolinks)
library(SummarizedExperiment)
library(dplyr)
library(DT)

## ----message=FALSE, warning=FALSE---------------------------------------------
subtypes <- PanCancerAtlas_subtypes()
DT::datatable(
    data = subtypes,
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5),
    rownames = FALSE
)

## ----eval = TRUE--------------------------------------------------------------
lgg.gbm.subtype <- TCGAquery_subtype(tumor = "lgg")

## ----eval = TRUE, echo = FALSE------------------------------------------------
datatable(
    lgg.gbm.subtype[1:10,],
    caption = "Table with LGG molecular subtypes from TCGAquery_subtype",
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
    rownames = FALSE
)

## ----sessionInfo--------------------------------------------------------------
sessionInfo()

#' @title Hierarchical cluster analysis
#' @description Hierarchical cluster analysis using several methods such as
#'  ward.D", "ward.D2", "single", "complete", "average" (= UPGMA),
#'  "mcquitty" (= WPGMA), "median" (= WPGMC) or "centroid" (= UPGMC).
#' @param tabDF is a dataframe or numeric matrix, each row represents a gene,
#' each column represents a sample come from TCGAPrepare.
#' @param method is method to be used for generic cluster such as 'hclust'
#' or 'consensus'
#' @param methodHC is method to be used for Hierarchical cluster.
#' @import stats
#' @export
#' @return object of class hclust if method selected is 'hclust'.
#' If method selected is 'Consensus' returns a list of length maxK
#' (maximum cluster number to evaluate.). Each element is a list containing
#' consensusMatrix (numerical matrix), consensusTree (hclust), consensusClass
#' (consensus class assignments). ConsensusClusterPlus also produces images.
TCGAanalyze_Clustering <-
    function(tabDF, method,  methodHC = "ward.D2") {
        if (!requireNamespace("ConsensusClusterPlus", quietly = TRUE)) {
            stop("ConsensusClusterPlus is needed. Please install it.",
                 call. = FALSE)
        }

        if (method == "hclust") {
            ans <- hclust(ddist <- dist(tabDF), method = methodHC)
        }

        if (method == "consensus") {
            sHc <- hclust(ddist <- dist(tabDF), method = methodHC)
            ans <-
                ConsensusClusterPlus::ConsensusClusterPlus(
                    ddist,
                    maxK = 7,
                    pItem = 0.9,
                    reps = 1000,
                    title = "mc_consensus_k7_1000",
                    clusterAlg = "hc",
                    innerLinkage = "ward.D2",
                    finalLinkage = "complete",
                    plot = 'pdf',
                    writeTable = TRUE
                )
        }

        return(ans)
    }


#' @title Array Array Intensity correlation (AAIC) and correlation boxplot to define outlier
#' @description TCGAanalyze_Preprocessing perform Array Array Intensity correlation (AAIC).
#' It defines a square symmetric matrix of spearman correlation among samples.
#' According this matrix and boxplot of correlation samples by samples it is possible
#' to find samples with low correlation that can be identified as possible outliers.
#' @param object of gene expression of class RangedSummarizedExperiment from TCGAprepare
#' @param cor.cut is a threshold to filter samples according their spearman correlation in
#' samples by samples. default cor.cut is 0
#' @param filename Filename of the image file
#' @param width Image width
#' @param height Image height
#' @param datatype is a string from RangedSummarizedExperiment assay
#' @importFrom grDevices dev.list
#' @importFrom SummarizedExperiment assays
#' @export
#' @return Plot with array array intensity correlation and boxplot of correlation samples by samples
TCGAanalyze_Preprocessing <- function(object,
                                      cor.cut = 0,
                                      filename = NULL,
                                      width = 1000,
                                      height = 1000,
                                      datatype = names(assays(object))[1]) {
    # This is a work around for raw_counts and raw_count
    if (grepl("raw_count", datatype) &
        any(grepl("raw_count", names(assays(object)))))
        datatype <-
            names(assays(object))[grepl("raw_count", names(assays(object)))]

    if (!any(grepl(datatype, names(assays(object)))))
        stop(
            paste0(
                datatype,
                " not found in the assay list: ",
                paste(names(assays(object)), collapse = ", "),
                "\n  Please set the correct datatype argument."
            )
        )

    if (!(is.null(dev.list()["RStudioGD"]))) {
        dev.off()
    }
    if (is.null(filename))
        filename <- "PreprocessingOutput.png"
    png(filename, width = width, height = height)
    par(oma = c(10, 10, 10, 10))
    ArrayIndex <-  as.character(1:length(colData(object)$barcode))

    pmat_new <- matrix(0, length(ArrayIndex), 4)
    colnames(pmat_new) <- c("Disease", "platform", "SampleID", "Study")
    rownames(pmat_new) <- as.character(colData(object)$barcode)
    pmat_new <- as.data.frame(pmat_new)
    pmat_new$Disease <- as.character(colData(object)$definition)
    pmat_new$platform <- "platform"
    pmat_new$SampleID <- as.character(colData(object)$barcode)
    pmat_new$Study <- "study"

    tabGroupCol <-
        cbind(pmat_new, Color = matrix(0, nrow(pmat_new), 1))
    for (i in seq_along(unique(tabGroupCol$Disease))) {
        tabGroupCol[which(tabGroupCol$Disease == tabGroupCol$Disease[i]), "Color"] <-
            rainbow(length(unique(tabGroupCol$Disease)))[i]
    }

    #    pmat <- as.matrix(pData(phenoData(object)))
    pmat <- pmat_new
    phenodepth <- min(ncol(pmat), 3)
    order <- switch(
        phenodepth + 1,
        ArrayIndex,
        order(pmat[, 1]),
        order(pmat[, 1], pmat[, 2]),
        order(pmat[, 1],
              pmat[, 2], pmat[, 3])
    )
    arraypos <-
        (1:length(ArrayIndex)) * (1 / (length(ArrayIndex) - 1)) - (1 / (length(ArrayIndex) - 1))
    arraypos2 = seq(1:length(ArrayIndex) - 1)
    for (i in 2:length(ArrayIndex)) {
        arraypos2[i - 1] <- (arraypos[i] + arraypos[i - 1]) / 2
    }
    layout(matrix(c(1, 1, 1, 2, 1, 1, 1, 2, 1, 1, 1, 2, 3, 3, 3, 4), 4, 4, byrow = TRUE))

    c <- cor(assay(object, datatype)[, order], method = "spearman")

    image(c,
          xaxt = "n",
          yaxt = "n",
          #xlab = "Array Samples",
          #ylab = "Array Samples",
          main = "Array-Array Intensity Correlation after RMA")

    for (i in 1:length(names(table(tabGroupCol$Color)))) {
        currentCol <- names(table(tabGroupCol$Color))[i]
        pos.col <- arraypos[which(tabGroupCol$Color == currentCol)]
        lab.col <-
            colnames(c)[which(tabGroupCol$Color == currentCol)]
        #axis(1, labels = lab.col , at = pos.col, col = currentCol,lwd = 6,las = 2)
        axis(
            2,
            labels = lab.col ,
            at = pos.col,
            col = currentCol,
            lwd = 6,
            las = 2
        )
    }

    m <-
        matrix(pretty(c, 10), nrow = 1, ncol = length(pretty(c, 10)))

    image(m,
          xaxt = "n",
          yaxt = "n",
          ylab = "Correlation Coefficient")

    axis(2,
         labels = as.list(pretty(c, 10)),
         at = seq(0, 1, by = (1 / (
             length(pretty(c,  10)) - 1
         ))))

    abline(h = seq((1 / (
        length(pretty(c, 10)) - 1
    )) / 2,
    1 - (1 / (
        length(pretty(c, 10)) - 1
    )),
    by = (1 / (
        length(pretty(c, 10)) - 1
    ))))
    box()
    boxplot(
        c,
        outline = FALSE,
        las = 2,
        lwd = 6,
        # names = NULL,
        col = tabGroupCol$Color,
        main = "Boxplot of correlation samples by samples after normalization"
    )
    dev.off()

    samplesCor <- rowMeans(c)
    objectWO <-  assay(object, datatype)[, samplesCor > cor.cut]
    colnames(objectWO) <- colnames(object)[samplesCor > cor.cut]

    return(objectWO)
}

#' @title survival analysis (SA) univariate with Kaplan-Meier (KM) method.
#' @description TCGAanalyze_SurvivalKM perform an univariate Kaplan-Meier (KM) survival analysis (SA).
#' It performed Kaplan-Meier survival univariate using complete follow up with all days
#' taking one gene a time from Genelist of gene symbols.
#' For each gene according its level of mean expression in cancer samples,
#' defining two thresholds for quantile
#' expression of that gene in all samples (default ThreshTop=0.67,ThreshDown=0.33) it is possible
#' to define a threshold of intensity of gene expression to divide the samples in 3 groups
#' (High, intermediate, low).
#' TCGAanalyze_SurvivalKM performs SA between High and low groups using following functions
#' from survival package
#' \enumerate{
#' \item survival::Surv
#' \item survival::survdiff
#' \item survival::survfit
#' }
#' @param clinical_patient is a data.frame using function 'clinic' with information
#' related to barcode / samples such as bcr_patient_barcode, days_to_death ,
#' days_to_last_follow_up , vital_status, etc
#' @param dataGE is a matrix of Gene expression (genes in rows, samples in cols) from TCGAprepare
#' @param Genelist is a list of gene symbols where perform survival KM.
#' @param Survresult is a parameter (default = FALSE) if is TRUE will show KM plot and results.
#' @param ThreshTop is a quantile threshold to identify samples with high expression of a gene
#' @param ThreshDown is a quantile threshold to identify samples with low expression of a gene
#' @param p.cut p.values threshold. Default: 0.05
#' @param group1 a string containing the barcode list of the samples in in control group
#' @param group2 a string containing the barcode list of the samples in in disease group
#' @export
#' @return table with survival genes pvalues from KM.
#' @examples
#'  # Selecting only 20 genes for example
#'  dataBRCAcomplete <- log2(dataBRCA[1:20,] + 1)
#'
#'  # clinical_patient_Cancer <- GDCquery_clinic("TCGA-BRCA","clinical")
#'  clinical_patient_Cancer <- data.frame(
#'       bcr_patient_barcode = substr(colnames(dataBRCAcomplete),1,12),
#'       vital_status = c(rep("alive",3),"dead",rep("alive",2),rep(c("dead","alive"),2)),
#'       days_to_death = c(NA,NA,NA,172,NA,NA,3472,NA,786,NA),
#'       days_to_last_follow_up = c(3011,965,718,NA,1914,423,NA,5,656,1417)
#'  )
#'
#'  group1 <- TCGAquery_SampleTypes(colnames(dataBRCAcomplete), typesample = c("NT"))
#'  group2 <- TCGAquery_SampleTypes(colnames(dataBRCAcomplete), typesample = c("TP"))
#'
#'  tabSurvKM <- TCGAanalyze_SurvivalKM(clinical_patient_Cancer,
#'                                      dataBRCAcomplete,
#'                                      Genelist = rownames(dataBRCAcomplete),
#'                                      Survresult = FALSE,
#'                                      p.cut = 0.4,
#'                                      ThreshTop = 0.67,
#'                                      ThreshDown = 0.33,
#'                                      group1 = group1, # Control group
#'                                      group2 = group2) # Disease group
#'
#'  # If the groups are not specified group1 == group2 and all samples are used
#'  \dontrun{
#'  tabSurvKM <- TCGAanalyze_SurvivalKM(clinical_patient_Cancer,
#'                                      dataBRCAcomplete,
#'                                      Genelist = rownames(dataBRCAcomplete),
#'                                      Survresult = TRUE,
#'                                      p.cut = 0.2,
#'                                      ThreshTop = 0.67,
#'                                      ThreshDown = 0.33)
#' }
TCGAanalyze_SurvivalKM <- function(
    clinical_patient,
    dataGE,
    Genelist,
    Survresult = FALSE,
    ThreshTop = 0.67,
    ThreshDown = 0.33,
    p.cut = 0.05,
    group1,
    group2
) {

    check_package("survival")
    # Check which genes we really have in the matrix
    Genelist <- intersect(rownames(dataGE), Genelist)

    # Split gene expression matrix btw the groups
    dataCancer <- dataGE[Genelist, group2, drop = FALSE]
    dataNormal <- dataGE[Genelist, group1, drop = FALSE]
    colnames(dataCancer)  <- substr(colnames(dataCancer), 1, 12)

    cfu <-
        clinical_patient[clinical_patient[, "bcr_patient_barcode"] %in% substr(colnames(dataCancer), 1, 12), ]
    if ("days_to_last_followup" %in% colnames(cfu))
        colnames(cfu)[grep("days_to_last_followup", colnames(cfu))] <-
        "days_to_last_follow_up"
    cfu <-
        as.data.frame(subset(
            cfu,
            select = c(
                "bcr_patient_barcode",
                "days_to_death",
                "days_to_last_follow_up",
                "vital_status"
            )
        ))

    # Set alive death to inf
    if (length(grep("alive", cfu$vital_status, ignore.case = TRUE)) > 0)
        cfu[grep("alive", cfu$vital_status, ignore.case = TRUE), "days_to_death"] <-
        "-Inf"

    # Set dead follow up to inf
    if (length(grep("dead", cfu$vital_status, ignore.case = TRUE)) > 0)
        cfu[grep("dead", cfu$vital_status, ignore.case = TRUE), "days_to_last_follow_up"] <-
        "-Inf"

    cfu <- cfu[!(is.na(cfu[, "days_to_last_follow_up"])), ]
    cfu <- cfu[!(is.na(cfu[, "days_to_death"])), ]

    followUpLevel <- FALSE

    #FC_FDR_table_mRNA
    tabSurv_Matrix <-
        matrix(0, nrow(as.matrix(rownames(dataNormal))), 8)
    colnames(tabSurv_Matrix) <- c(
        "mRNA",
        "pvalue",
        "Cancer Deaths",
        "Cancer Deaths with Top",
        "Cancer Deaths with Down",
        "Mean Tumor Top",
        "Mean Tumor Down",
        "Mean Normal"
    )

    tabSurv_Matrix <- as.data.frame(tabSurv_Matrix)

    cfu$days_to_death <- as.numeric(as.character(cfu$days_to_death))
    cfu$days_to_last_follow_up <-
        as.numeric(as.character(cfu$days_to_last_follow_up))
    rownames(cfu) <- cfu[, "bcr_patient_barcode"] #mod1

    cfu <- cfu[!(is.na(cfu[, "days_to_last_follow_up"])), ]
    cfu <- cfu[!(is.na(cfu[, "days_to_death"])), ]

    cfu_complete <- cfu
    ngenes <- nrow(as.matrix(rownames(dataNormal)))

    # Evaluate each gene
    for (i in 1:nrow(as.matrix(rownames(dataNormal))))  {
        cat(paste0((ngenes - i), "."))
        mRNAselected <- as.matrix(rownames(dataNormal))[i]
        mRNAselected_values <-
            dataCancer[rownames(dataCancer) == mRNAselected, ]
        mRNAselected_values_normal <-
            dataNormal[rownames(dataNormal) == mRNAselected, ]
        if (all(mRNAselected_values == 0))
            next # All genes are 0
        tabSurv_Matrix[i, "mRNA"] <- mRNAselected


        # Get Thresh values for cancer expression
        mRNAselected_values_ordered <-
            sort(mRNAselected_values, decreasing = TRUE)
        mRNAselected_values_ordered_top <-
            as.numeric(quantile(as.numeric(mRNAselected_values_ordered), ThreshTop)[1])
        mRNAselected_values_ordered_down <-
            as.numeric(quantile(as.numeric(mRNAselected_values_ordered), ThreshDown)[1])

        mRNAselected_values_newvector <- mRNAselected_values


        if (!is.na(mRNAselected_values_ordered_top)) {
            # How many samples do we have
            numberOfSamples <- length(mRNAselected_values_ordered)

            # High group (above ThreshTop)
            lastelementTOP <-
                max(which(
                    mRNAselected_values_ordered > mRNAselected_values_ordered_top
                ))

            # Low group (below ThreshDown)
            firstelementDOWN <-
                min(
                    which(
                        mRNAselected_values_ordered <= mRNAselected_values_ordered_down
                    )
                )

            samples_top_mRNA_selected <-
                names(mRNAselected_values_ordered[1:lastelementTOP])
            samples_down_mRNA_selected <-
                names(mRNAselected_values_ordered[firstelementDOWN:numberOfSamples])

            # Which samples are in the intermediate group (above ThreshLow and below ThreshTop)
            samples_UNCHANGED_mRNA_selected <-
                names(mRNAselected_values_newvector[which((mRNAselected_values_newvector) > mRNAselected_values_ordered_down &
                                                              mRNAselected_values_newvector < mRNAselected_values_ordered_top
                )])

            cfu_onlyTOP <-
                cfu_complete[cfu_complete[, "bcr_patient_barcode"] %in% samples_top_mRNA_selected, ]
            cfu_onlyDOWN <-
                cfu_complete[cfu_complete[, "bcr_patient_barcode"] %in% samples_down_mRNA_selected, ]
            cfu_onlyUNCHANGED <-
                cfu_complete[cfu_complete[, "bcr_patient_barcode"] %in% samples_UNCHANGED_mRNA_selected, ]

            cfu_ordered <- NULL
            cfu_ordered <- rbind(cfu_onlyTOP, cfu_onlyDOWN)
            cfu <- cfu_ordered

            ttime <- as.numeric(cfu[, "days_to_death"])

            sum(status <- ttime > 0) # morti
            deads_complete <- sum(status <- ttime > 0)

            ttime_only_top <- cfu_onlyTOP[, "days_to_death"]
            deads_top <- sum(ttime_only_top > 0)

            if (dim(cfu_onlyDOWN)[1] >= 1) {
                ttime_only_down <- cfu_onlyDOWN[, "days_to_death"]
                deads_down <- sum(ttime_only_down > 0)
            } else {
                deads_down <- 0
            }

            tabSurv_Matrix[i, "Cancer Deaths"] <- deads_complete
            tabSurv_Matrix[i, "Cancer Deaths with Top"] <- deads_top
            tabSurv_Matrix[i, "Cancer Deaths with Down"] <-
                deads_down
            tabSurv_Matrix[i, "Mean Normal"] <-
                mean(as.numeric(mRNAselected_values_normal))
            dataCancer_onlyTop_sample <-
                dataCancer[, samples_top_mRNA_selected, drop = FALSE]
            dataCancer_onlyTop_sample_mRNASelected <-
                dataCancer_onlyTop_sample[rownames(dataCancer_onlyTop_sample) == mRNAselected, ]
            dataCancer_onlyDown_sample <-
                dataCancer[, samples_down_mRNA_selected, drop = FALSE]
            dataCancer_onlyDown_sample_mRNASelected <-
                dataCancer_onlyDown_sample[rownames(dataCancer_onlyDown_sample) == mRNAselected, ]
            tabSurv_Matrix[i, "Mean Tumor Top"] <-
                mean(as.numeric(dataCancer_onlyTop_sample_mRNASelected))
            tabSurv_Matrix[i, "Mean Tumor Down"] <-
                mean(as.numeric(dataCancer_onlyDown_sample_mRNASelected))

            ttime[!status] <-
                as.numeric(cfu[!status, "days_to_last_follow_up"])
            ttime[which(ttime == -Inf)] <- 0

            ttime <- survival::Surv(ttime, status)
            rownames(ttime) <- rownames(cfu)
            legendHigh <- paste(mRNAselected, "High")
            legendLow  <- paste(mRNAselected, "Low")

            tabSurv_pvalue <- tryCatch({
                tabSurv <-
                    survival::survdiff(ttime  ~ c(rep(
                        "top", nrow(cfu_onlyTOP)
                    ), rep(
                        "down", nrow(cfu_onlyDOWN)
                    )))
                tabSurv_chis <- unlist(tabSurv)$chisq
                tabSurv_pvalue <-
                    as.numeric(1 - pchisq(abs(tabSurv$chisq), df = 1))
            }, error = function(e) {
                return(Inf)
            })
            tabSurv_Matrix[i, "pvalue"] <- tabSurv_pvalue

            if (Survresult == TRUE) {
                titlePlot <-
                    paste("Kaplan-Meier Survival analysis, pvalue=",
                          tabSurv_pvalue)
                plot(
                    survival::survfit(ttime ~ c(
                        rep("low", nrow(cfu_onlyTOP)), rep("high", nrow(cfu_onlyDOWN))
                    )),
                    col = c("green", "red"),
                    main = titlePlot,
                    xlab = "Days",
                    ylab = "Survival"
                )
                legend(
                    100,
                    1,
                    legend = c(legendLow, legendHigh),
                    col = c("green", "red"),
                    text.col = c("green", "red"),
                    pch = 15
                )
                print(tabSurv)
            }
        } #end if

    } #end for

    tabSurv_Matrix[tabSurv_Matrix == "-Inf"] <- 0

    tabSurvKM <- tabSurv_Matrix

    # Filtering by selected pvalue < 0.01
    tabSurvKM <- tabSurvKM[tabSurvKM$mRNA != 0, ]
    tabSurvKM <- tabSurvKM[tabSurvKM$pvalue < p.cut, ]
    tabSurvKM <- tabSurvKM[!duplicated(tabSurvKM$mRNA), ]
    rownames(tabSurvKM) <- tabSurvKM$mRNA
    tabSurvKM <- tabSurvKM[, -1]
    tabSurvKM <-
        tabSurvKM[order(tabSurvKM$pvalue, decreasing = FALSE), ]

    colnames(tabSurvKM) <-
        gsub("Cancer", "Group2", colnames(tabSurvKM))
    colnames(tabSurvKM) <-
        gsub("Tumor", "Group2", colnames(tabSurvKM))
    colnames(tabSurvKM) <-
        gsub("Normal", "Group1", colnames(tabSurvKM))


    return(tabSurvKM)
}


#' @title Filtering mRNA transcripts and miRNA selecting a threshold.
#' @description
#'    TCGAanalyze_Filtering allows user to filter mRNA transcripts and miRNA,
#'    samples, higher than the threshold defined quantile mean across all samples.
#' @param tabDF is a dataframe or numeric matrix, each row represents a gene,
#' each column represents a sample come from TCGAPrepare
#' @param method is method of filtering such as 'quantile', 'varFilter', 'filter1', 'filter2'
#' @param qnt.cut is threshold selected as mean for filtering
#' @param var.func is function used as the per-feature filtering statistic.
#' See genefilter documentation
#' @param var.cutoff is a numeric value. See genefilter documentation
#' @param eta is a parameter for filter1. default eta = 0.05.
#' @param foldChange is a parameter for filter2. default foldChange = 1.
#' @export
#' @return A filtered dataframe or numeric matrix where each row represents a gene,
#' each column represents a sample
#' @examples
#' dataNorm <- TCGAbiolinks::TCGAanalyze_Normalization(dataBRCA, geneInfo)
#' dataNorm <- TCGAanalyze_Normalization(tabDF = dataBRCA,
#' geneInfo = geneInfo,
#' method = "geneLength")
#' dataFilt <- TCGAanalyze_Filtering(tabDF = dataNorm, method = "quantile", qnt.cut = 0.25)
TCGAanalyze_Filtering <- function(tabDF,
                                  method,
                                  qnt.cut = 0.25,
                                  var.func = IQR,
                                  var.cutoff = 0.75,
                                  eta = 0.05,
                                  foldChange = 1) {
    if (method == "quantile") {
        GeneThresh <- as.numeric(quantile(rowMeans(tabDF), qnt.cut))
        geneFiltered <- names(which(rowMeans(tabDF) > GeneThresh))
        tabDF_Filt <- tabDF[geneFiltered,]
    }

    if (method == "varFilter") {
        check_package("genefilter")
        tabDF_Filt <- genefilter::varFilter(
            tabDF,
            var.func = IQR,
            var.cutoff = 0.75,
            filterByQuantile = TRUE
        )
    }

    if (method == "filter1") {
        normCounts <- tabDF
        geData <- t(log(1 + normCounts, 2))
        filter <-
            apply(geData, 2, function(x)
                sum(quantile(x, probs = c(1 - eta, eta)) * c(1, -1)))
        tabDF_Filt <- geData[, which(filter > foldChange)]
    }

    if (method == "filter2") {
        geData <- tabDF
        filter <-
            apply(geData, 2, function(x)
                prod(quantile(x, probs =  c(1 - eta, eta)) - 10) < 0)
        tabDF_Filt <- geData[, which(filter)]
    }

    return(tabDF_Filt)
}

#' @title normalization mRNA transcripts and miRNA using EDASeq package.
#' @description
#'   TCGAanalyze_Normalization allows user to normalize mRNA transcripts and miRNA,
#'    using EDASeq package.
#'
#'    Normalization for RNA-Seq Numerical and graphical
#'     summaries of RNA-Seq read data. Within-lane normalization procedures
#'    to adjust for GC-content effect (or other gene-level effects) on read counts:
#'    loess robust local regression, global-scaling, and full-quantile normalization
#'    (Risso et al., 2011). Between-lane normalization procedures to adjust for
#'    distributional differences between lanes (e.g., sequencing depth):
#'    global-scaling and full-quantile normalization (Bullard et al., 2010).
#'
#'    For istance returns all mRNA or miRNA with mean across all
#'    samples, higher than the threshold defined quantile mean across all samples.
#'
#'    TCGAanalyze_Normalization performs normalization using following functions
#'    from EDASeq
#'    \enumerate{
#'    \item  EDASeq::newSeqExpressionSet
#'    \item  EDASeq::withinLaneNormalization
#'    \item  EDASeq::betweenLaneNormalization
#'    \item  EDASeq::counts
#'    }
#' @param tabDF Rnaseq numeric matrix, each row represents a gene,
#' each column represents a sample
#' @param geneInfo Information matrix of 20531 genes about geneLength and gcContent.
#' Two objects are provided: TCGAbiolinks::geneInfoHT,TCGAbiolinks::geneInfo
#' @param method is method of normalization such as 'gcContent' or 'geneLength'
#' @export
#' @return Rnaseq matrix normalized with counts slot holds the count data as a matrix
#' of non-negative integer count values, one row for each observational unit (gene or the like),
#' and one column for each sample.
#' @examples
#' dataNorm <- TCGAbiolinks::TCGAanalyze_Normalization(dataBRCA, geneInfo)
TCGAanalyze_Normalization <-
    function(tabDF, geneInfo, method = "geneLength") {

        check_package("EDASeq")

        # Check if we have a SE, we need a gene expression matrix
        if (is(tabDF, "SummarizedExperiment")) tabDF <- assay(tabDF)

        geneInfo <- geneInfo[!is.na(geneInfo[, 1]), ]
        geneInfo <- as.data.frame(geneInfo)
        geneInfo$geneLength <-
            as.numeric(as.character(geneInfo$geneLength))
        geneInfo$gcContent <- as.numeric(as.character(geneInfo$gcContent))


        if (method == "gcContent") {
            tmp <- as.character(rownames(tabDF))
            tmp <- strsplit(tmp, "\\|")
            geneNames <- matrix("", ncol = 2, nrow = length(tmp))
            j <- 1
            while (j <= length(tmp)) {
                geneNames[j, 1] <- tmp[[j]][1]
                geneNames[j, 2] <- tmp[[j]][2]
                j <- j + 1
            }
            tmp <- which(geneNames[, 1] == "?")
            geneNames[tmp, 1] <- geneNames[tmp, 2]
            tmp <- table(geneNames[, 1])
            tmp <- which(geneNames[, 1] %in% names(tmp[which(tmp > 1)]))
            geneNames[tmp, 1] <- paste(geneNames[tmp, 1], geneNames[tmp, 2], sep = ".")
            tmp <- table(geneNames[, 1])
            rownames(tabDF) <- geneNames[, 1]

            rawCounts <- tabDF
            commonGenes <-  intersect(rownames(geneInfo), rownames(rawCounts))
            geneInfo <- geneInfo[commonGenes, ]
            rawCounts <- rawCounts[commonGenes, ]

            timeEstimated <- format(ncol(tabDF) * nrow(tabDF) / 80000, digits = 2)
            message(
                messageEstimation <- paste(
                    "I Need about ",
                    timeEstimated,
                    "seconds for this Complete Normalization Upper Quantile",
                    " [Processing 80k elements /s]  "
                )
            )

            ffData  <- as.data.frame(geneInfo)
            rawCounts <- floor(rawCounts)

            message("Step 1 of 4: newSeqExpressionSet ...")
            tmp <- EDASeq::newSeqExpressionSet(as.matrix(rawCounts), featureData = ffData)

            #fData(tmp)[, "gcContent"] <- as.numeric(geneInfo[, "gcContent"])

            message("Step 2 of 4: withinLaneNormalization ...")
            tmp <- EDASeq::withinLaneNormalization(
                tmp, "gcContent",
                which = "upper",
                offset = TRUE
            )

            message("Step 3 of 4: betweenLaneNormalization ...")
            tmp <- EDASeq::betweenLaneNormalization(
                tmp,
                which = "upper",
                offset = TRUE
            )
            normCounts <-  log(rawCounts + .1) + EDASeq::offst(tmp)
            normCounts <-  floor(exp(normCounts) - .1)

            message("Step 4 of 4: .quantileNormalization ...")
            tmp <- t(.quantileNormalization(t(normCounts)))
            tabDF_norm <- floor(tmp)
        }

        if (method == "geneLength") {
            tabDF <- tabDF[!(GenesCutID(as.matrix(rownames(tabDF))) == "?"), ]
            tabDF <- tabDF[!(GenesCutID(as.matrix(rownames(tabDF))) == "SLC35E2"), ]
            rownames(tabDF) <- GenesCutID(as.matrix(rownames(tabDF)))
            tabDF <- tabDF[rownames(tabDF) != "?",]
            tabDF <- tabDF[!duplicated(rownames(tabDF)), !duplicated(colnames(tabDF))]
            tabDF <- tabDF[rownames(tabDF) %in% rownames(geneInfo), ]
            tabDF <- as.matrix(tabDF)

            geneInfo <-
                geneInfo[rownames(geneInfo) %in% rownames(tabDF),]
            geneInfo <- geneInfo[!duplicated(rownames(geneInfo)),]
            toKeep <- which(geneInfo[, "geneLength"] != 0)
            geneInfo <- geneInfo[toKeep,]
            tabDF <- tabDF[toKeep,]
            geneInfo <- as.data.frame(geneInfo)
            tabDF <- round(tabDF)
            commonGenes <- intersect(rownames(tabDF), rownames(geneInfo))

            tabDF <- tabDF[commonGenes, ]
            geneInfo <- geneInfo[commonGenes, ]

            timeEstimated <-
                format(ncol(tabDF) * nrow(tabDF) / 80000, digits = 2)
            message(
                messageEstimation <- paste(
                    "I Need about ",
                    timeEstimated,
                    "seconds for this Complete Normalization Upper Quantile",
                    " [Processing 80k elements /s]  "
                )
            )

            message("Step 1 of 4: newSeqExpressionSet ...")
            system.time(tabDF_norm <-
                            EDASeq::newSeqExpressionSet(tabDF, featureData = geneInfo))
            message("Step 2 of 4: withinLaneNormalization ...")
            system.time(
                tabDF_norm <-
                    EDASeq::withinLaneNormalization(
                        tabDF_norm,
                        "geneLength",
                        which = "upper",
                        offset = FALSE
                    )
            )
            message("Step 3 of 4: betweenLaneNormalization ...")
            system.time(
                tabDF_norm <-
                    EDASeq::betweenLaneNormalization(tabDF_norm, which = "upper", offset = FALSE)
            )
            message("Step 4 of 4: exprs ...")

            #system.time(tabDF_norm <- EDASeq::exprs(tabDF_norm))
            system.time(tabDF_norm <- EDASeq::counts(tabDF_norm))
        }


        return(tabDF_norm)
    }


#' @title Differential expression analysis (DEA) using edgeR or limma package.
#' @description
#'    TCGAanalyze_DEA allows user to perform Differentially expression analysis (DEA),
#'    using edgeR package or limma to identify differentially expressed genes (DEGs).
#'     It is possible to do a two-class analysis.
#'
#'     TCGAanalyze_DEA performs DEA using following functions from edgeR:
#'     \enumerate{
#'     \item edgeR::DGEList converts the count matrix into an edgeR object.
#'     \item edgeR::estimateCommonDisp each gene gets assigned the same dispersion estimate.
#'     \item edgeR::exactTest performs pair-wise tests for differential expression between two groups.
#'     \item edgeR::topTags takes the output from exactTest(), adjusts the raw p-values using the
#'     False Discovery Rate (FDR) correction, and returns the top differentially expressed genes.
#'     }
#'     TCGAanalyze_DEA performs DEA using following functions from limma:
#'     \enumerate{
#'     \item limma::makeContrasts construct matrix of custom contrasts.
#'     \item limma::lmFit Fit linear model for each gene given a series of arrays.
#'     \item limma::contrasts.fit Given a linear model fit to microarray data, compute estimated coefficients and standard errors for a given set of contrasts.
#'     \item limma::eBayes Given a microarray linear model fit, compute moderated t-statistics, moderated F-statistic, and log-odds of differential expression by empirical Bayes moderation of the standard errors towards a common value.
#'     \item limma::toptable Extract a table of the top-ranked genes from a linear model fit.
#'     }
#' @param mat1 numeric matrix, each row represents a gene,
#' each column represents a sample with Cond1type
#' @param mat2 numeric matrix, each row represents a gene,
#' each column represents a sample with Cond2type
#' @param metadata Add metadata
#' @param Cond1type a string containing the class label of the samples in mat1
#'  (e.g., control group)
#' @param Cond2type a string containing the class label of the samples in mat2
#' (e.g., case group)
#' @param pipeline a string to specify which package to use ("limma" or "edgeR")
#' @param method is 'glmLRT' (1) or 'exactTest' (2) used for edgeR
#' (1) Fit a negative binomial generalized log-linear model to
#' the read counts for each gene
#' (2) Compute genewise exact tests for differences in the means between
#' two groups of negative-binomially distributed counts.
#' @param fdr.cut is a threshold to filter DEGs according their p-value corrected
#' @param logFC.cut is a threshold to filter DEGs according their logFC
#' @param elementsRatio is number of elements processed for second for time consumation estimation
#' @param batch.factors a vector containing strings to specify options for batch correction. Options are "Plate", "TSS", "Year", "Portion", "Center", and "Patients"
#' @param ClinicalDF a dataframe returned by GDCquery_clinic() to be used to extract year data
#' @param paired boolean to account for paired or non-paired samples. Set to TRUE for paired case
#' @param log.trans boolean to perform log cpm transformation. Set to TRUE for log transformation
#' @param trend boolean to perform limma-trend pipeline. Set to TRUE to go through limma-trend
#' @param MAT matrix containing expression set as all samples in columns and genes as rows. Do not provide if mat1 and mat2 are used
#' @param contrast.formula string input to determine coefficients and to design contrasts in a customized way
#' @param Condtypes vector of grouping for samples in MAT
#' @param voom boolean to perform voom transformation for limma-voom pipeline. Set to TRUE for voom transformation
#' @export
#' @examples
#' dataNorm <- TCGAbiolinks::TCGAanalyze_Normalization(dataBRCA, geneInfo)
#' dataFilt <- TCGAanalyze_Filtering(tabDF = dataBRCA, method = "quantile", qnt.cut =  0.25)
#' samplesNT <- TCGAquery_SampleTypes(colnames(dataFilt), typesample = c("NT"))
#' samplesTP <- TCGAquery_SampleTypes(colnames(dataFilt), typesample = c("TP"))
#' dataDEGs <- TCGAanalyze_DEA(mat1 = dataFilt[,samplesNT],
#'                             mat2 = dataFilt[,samplesTP],
#'                             Cond1type = "Normal",
#'                             Cond2type = "Tumor")
#'
#' @return table with DEGs containing for each gene logFC, logCPM, pValue,and FDR, also for each contrast
TCGAanalyze_DEA <-
    function (mat1,
              mat2,
              metadata = TRUE,
              Cond1type,
              Cond2type,
              pipeline = "edgeR",
              method = "exactTest",
              fdr.cut = 1,
              logFC.cut = 0,
              elementsRatio = 30000,
              batch.factors = NULL,
              ClinicalDF = data.frame(),
              paired = FALSE,
              log.trans = FALSE,
              voom = FALSE,
              trend = FALSE,
              MAT = data.frame(),
              contrast.formula = "",
              Condtypes = c())
    {
        if (pipeline == "limma") {
            if (!requireNamespace("limma", quietly = TRUE)) {
                stop("limma is needed. Please install it.",
                     call. = FALSE)
            }
        }

        if (!requireNamespace("edgeR", quietly = TRUE)) {
            stop("edgeR is needed. Please install it.",
                 call. = FALSE)
        }

        table.code <- c(
            "TP",
            "TR",
            "TB",
            "TRBM",
            "TAP",
            "TM",
            "TAM",
            "THOC",
            "TBM",
            "NB",
            "NT",
            "NBC",
            "NEBV",
            "NBM",
            "CELLC",
            "TRB",
            "CELL",
            "XP",
            "XCL"
        )
        names(table.code) <- c(
            "01",
            "02",
            "03",
            "04",
            "05",
            "06",
            "07",
            "08",
            "09",
            "10",
            "11",
            "12",
            "13",
            "14",
            "20",
            "40",
            "50",
            "60",
            "61"
        )
        if (nrow(MAT) == 0) {
            TOC <- cbind(mat1, mat2)
            Cond1num <- ncol(mat1)
            Cond2num <- ncol(mat2)
        }
        else {
            TOC <- MAT
        }
        if (metadata == TRUE) {
            my_IDs <- get_IDs(TOC)
            Plate <- factor(my_IDs$plate)
            Condition <- factor(my_IDs$condition)
            TSS <- factor(my_IDs$tss)
            Portion <- factor(my_IDs$portion)
            Center <- factor(my_IDs$center)
            Patients <- factor(my_IDs$patient)
        }
        if (paired == TRUE) {
            matched.query <- TCGAquery_MatchedCoupledSampleTypes(my_IDs$barcode,
                                                                 table.code[unique(my_IDs$sample)])
            my_IDs <- subset(my_IDs, barcode == matched.query)
            TOC <- TOC[, (names(TOC) %in% matched.query)]
        }
        if (nrow(ClinicalDF) > 0) {
            names(ClinicalDF)[names(ClinicalDF) == "bcr_patient_barcode"] <-
                "patient"
            ClinicalDF$age_at_diag_year <-
                floor(clinical$age_at_diagnosis / 365)
            ClinicalDF$diag_year <- ClinicalDF$age_at_diag_year +
                clinical$year_of_birth
            diag_yearDF <- ClinicalDF[, c("patient", "diag_year")]
            my_IDs <- merge(my_IDs, ClinicalDF, by = "patient")
            Year <- as.factor(my_IDs$diag_year)
        }
        options <- c("Plate", "TSS", "Year", "Portion", "Center",
                     "Patients")
        if (length(batch.factors) == 0) {
            message("Batch correction skipped since no factors provided")
        }
        else
            for (o in batch.factors) {
                if (o %in% options == FALSE)
                    stop(paste0(o, " is not a valid batch correction factor"))
                if (o == "Year" & nrow(ClinicalDF) == 0)
                    stop(
                        "batch correction using diagnosis year needs clinical info. Provide Clinical Data in arguments"
                    )
            }
        additiveformula <- paste(batch.factors, collapse = "+")
        message("----------------------- DEA -------------------------------")
        if (nrow(MAT) == 0) {
            message(message1 <- paste(
                "there are Cond1 type",
                Cond1type,
                "in ",
                Cond1num,
                "samples"
            ))
            message(message2 <- paste(
                "there are Cond2 type",
                Cond2type,
                "in ",
                Cond2num,
                "samples"
            ))
            message(message3 <-
                        paste("there are ", nrow(TOC), "features as miRNA or genes "))
        }
        else {
            message(message3 <-
                        paste("there are ", nrow(TOC), "features as miRNA or genes "))
        }
        timeEstimated <- format(ncol(TOC) * nrow(TOC) / elementsRatio,
                                digits = 2)
        message(
            messageEstimation <- paste(
                "I Need about ",
                timeEstimated,
                "seconds for this DEA. [Processing 30k elements /s]  "
            )
        )
        colnames(TOC) <- paste0("s", 1:ncol(TOC))
        if (length(Condtypes) > 0) {
            tumorType <- factor(x = Condtypes, levels = unique(Condtypes))
        }
        else {
            tumorType <- factor(x = rep(c(Cond1type, Cond2type),
                                        c(Cond1num, Cond2num)),
                                levels = c(Cond1type, Cond2type))
        }
        if (length(batch.factors) == 0 & length(Condtypes) > 0) {
            if (pipeline == "edgeR")
                design <- model.matrix( ~ tumorType)
            else
                design <- model.matrix( ~ 0 + tumorType)
        } else if (length(batch.factors) == 0 &
                   length(Condtypes) == 0) {
            if (pipeline == "edgeR")
                design <- model.matrix( ~ tumorType)
            else
                design <- model.matrix( ~ 0 + tumorType)
        } else if (length(batch.factors) > 0 & length(Condtypes) == 0) {
            if (pipeline == "edgeR")
                formula <- paste0("~tumorType+", additiveformula)
            else
                formula <- paste0("~0+tumorType+", additiveformula)
            design <- model.matrix(eval(parse(text = formula)))
        } else if (length(batch.factors) > 0 & length(Condtypes) > 0) {
            if (pipeline == "edgeR") {
                formula <- paste0("~tumorType+", additiveformula)
                if (length(Condtypes) > 2)
                    formula <- paste0("~0+tumorType+", additiveformula)
            }
            else
                formula <- paste0("~0+tumorType+", additiveformula)
            design <- model.matrix(eval(parse(text = formula)))
        }

        if (pipeline == "edgeR") {
            if (method == "exactTest") {
                DGE <- edgeR::DGEList(TOC, group = rep(c(Cond1type,
                                                         Cond2type), c(Cond1num, Cond2num)))
                disp <- edgeR::estimateCommonDisp(DGE)
                tested <- edgeR::exactTest(disp, pair = c(Cond1type,
                                                          Cond2type))
                logFC_table <- tested$table
                tableDEA <-
                    edgeR::topTags(tested, n = nrow(tested$table))$table
                tableDEA <- tableDEA[tableDEA$FDR <= fdr.cut,]
                tableDEA <- tableDEA[abs(tableDEA$logFC) >= logFC.cut,]
            }
            else if (method == "glmLRT") {
                if (length(unique(tumorType)) == 2) {
                    aDGEList <- edgeR::DGEList(counts = TOC, group = tumorType)
                    aDGEList <-
                        edgeR::estimateGLMCommonDisp(aDGEList, design)
                    aDGEList <-
                        edgeR::estimateGLMTagwiseDisp(aDGEList, design)
                    aGlmFit <-
                        edgeR::glmFit(
                            aDGEList,
                            design,
                            dispersion = aDGEList$tagwise.dispersion,
                            prior.count.total = 0
                        )


                    aGlmLRT <- edgeR::glmLRT(aGlmFit, coef = 2)
                    tableDEA <-
                        cbind(aGlmLRT$table,
                              FDR = p.adjust(aGlmLRT$table$PValue, "fdr"))
                    tableDEA <- tableDEA[tableDEA$FDR < fdr.cut, ]
                    tableDEA <-
                        tableDEA[abs(tableDEA$logFC) > logFC.cut, ]
                    if (all(grepl("ENSG", rownames(tableDEA))))
                        tableDEA <-
                        cbind(tableDEA, map.ensg(genes = rownames(tableDEA))[, 2:3])
                }
                else if (length(unique(tumorType)) > 2) {
                    aDGEList <- edgeR::DGEList(counts = TOC, group = tumorType)
                    colnames(design)[1:length(levels(tumorType))] <-
                        levels(tumorType)
                    prestr = "makeContrasts("
                    poststr = ",levels=design)"
                    commandstr = paste(prestr, contrast.formula,
                                       poststr, sep = "")
                    commandstr = paste0("limma::", commandstr)
                    cont.matrix <- eval(parse(text = commandstr))
                    aDGEList <- edgeR::estimateGLMCommonDisp(aDGEList,
                                                             design)
                    aDGEList <- edgeR::estimateGLMTagwiseDisp(aDGEList,
                                                              design)

                    aGlmFit <-
                        edgeR::glmFit(
                            aDGEList,
                            design,
                            dispersion = aDGEList$tagwise.dispersion,
                            prior.count.total = 0
                        )

                    tableDEA <- list()
                    for (mycoef in colnames(cont.matrix)) {
                        message(paste0("DEA for", " :", mycoef))
                        aGlmLRT <-
                            edgeR::glmLRT(aGlmFit, contrast = cont.matrix[, mycoef])
                        #print("---toptags---")
                        #print(topTags(aGlmLRT, adjust.method = "fdr",
                        #  sort.by = "PValue"))
                        tt <- aGlmLRT$table
                        tt <-
                            cbind(tt, FDR = p.adjust(aGlmLRT$table$PValue,
                                                     "fdr"))
                        tt <-
                            tt[(tt$FDR < fdr.cut & abs(as.numeric(tt$logFC)) >
                                    logFC.cut),]
                        tableDEA[[as.character(mycoef)]] <- tt
                        if (all(grepl("ENSG", rownames(tableDEA[[as.character(mycoef)]]))))
                            tableDEA[[as.character(mycoef)]] <-
                            cbind(tableDEA[[as.character(mycoef)]],
                                  map.ensg(genes = rownames(tableDEA[[as.character(mycoef)]]))[,
                                                                                               2:3])
                    }
                }
            }
            else
                stop(
                    paste0(
                        method,
                        " is not a valid DEA method option. Choose 'exactTest' or 'glmLRT' "
                    )
                )
        }
        else if (pipeline == "limma") {
            if (log.trans == TRUE)
                logCPM <- edgeR::cpm(TOC, log = TRUE, prior.count = 3)
            else
                logCPM <- TOC
            if (voom == TRUE) {
                message("Voom Transformation...")
                logCPM <- limma::voom(logCPM, design)
            }
            if (length(unique(tumorType)) == 2) {
                colnames(design)[1:2] <- c(Cond1type, Cond2type)
                contr <- paste0(Cond2type, "-", Cond1type)
                cont.matrix <- limma::makeContrasts(contrasts = contr,
                                                    levels = design)
                fit <- limma::lmFit(logCPM, design)
                fit <- limma::contrasts.fit(fit, cont.matrix)
                if (trend == TRUE) {
                    fit <- limma::eBayes(fit, trend = TRUE)
                }
                else {
                    fit <- limma::eBayes(fit, trend = FALSE)
                }
                tableDEA <-
                    limma::topTable(
                        fit,
                        coef = 1,
                        adjust.method = "fdr",
                        number = nrow(TOC)
                    )
                limma::volcanoplot(fit, highlight = 10)
                index <- which(tableDEA[, 4] < fdr.cut)
                tableDEA <- tableDEA[index,]
                neg_logFC.cut <- -1 * logFC.cut
                index <- which(abs(as.numeric(tableDEA$logFC)) >
                                   logFC.cut)
                tableDEA <- tableDEA[index,]
            }
            else if (length(unique(tumorType)) > 2) {
                DGE <- edgeR::DGEList(TOC, group = tumorType)
                colnames(design)[1:length(levels(tumorType))] <-
                    levels(tumorType)
                prestr = "makeContrasts("
                poststr = ",levels=colnames(design))"
                commandstr = paste(prestr, contrast.formula, poststr,
                                   sep = "")
                commandstr = paste0("limma::", commandstr)
                cont.matrix <- eval(parse(text = commandstr))
                fit <- limma::lmFit(logCPM, design)
                fit <- limma::contrasts.fit(fit, cont.matrix)
                if (trend == TRUE)
                    fit <- limma::eBayes(fit, trend = TRUE)
                else
                    fit <- limma::eBayes(fit, trend = FALSE)
                tableDEA <- list()
                for (mycoef in colnames(cont.matrix)) {
                    tableDEA[[as.character(mycoef)]] <- limma::topTable(
                        fit,
                        coef = mycoef,
                        adjust.method = "fdr",
                        number = nrow(MAT)
                    )
                    message(paste0("DEA for", " :", mycoef))
                    tempDEA <- tableDEA[[as.character(mycoef)]]
                    index.up <- which(tempDEA$adj.P.Val < fdr.cut &
                                          abs(as.numeric(tempDEA$logFC)) > logFC.cut)
                    tableDEA[[as.character(mycoef)]] <-
                        tempDEA[index.up,]
                    if (all(grepl("ENSG", rownames(tableDEA[[as.character(mycoef)]]))))
                        tableDEA[[as.character(mycoef)]] <-
                        cbind(tableDEA[[as.character(mycoef)]],
                              map.ensg(genes = rownames(tableDEA[[as.character(mycoef)]]))[,
                                                                                           2:3])
                }
            }
        }
        else
            stop(paste0(
                pipeline,
                " is not a valid pipeline option. Choose 'edgeR' or 'limma'"
            ))
        message("----------------------- END DEA -------------------------------")
        return(tableDEA)
    }


#' @title Batch correction using ComBat and Voom transformation using limma package.
#' @description
#'    TCGAbatch_correction allows user to perform a Voom correction on gene expression data and have it ready for DEA.
#'    One can also use ComBat for batch correction for exploratory analysis. If batch.factor or adjustment argument is "Year"
#'  please provide clinical data. If no batch factor is provided, the data will be voom corrected only
#'
#'     TCGAanalyze_DEA performs DEA using following functions from sva and limma:
#'     \enumerate{
#'     \item limma::voom Transform RNA-Seq Data Ready for Linear Modelling.
#'     \item sva::ComBat Adjust for batch effects using an empirical Bayes framework.
#'     }
#' @param tabDF numeric matrix, each row represents a gene,
#' each column represents a sample
#' @param batch.factor a string containing the batch factor to use for correction. Options are "Plate", "TSS", "Year", "Portion", "Center"
#' @param adjustment vector containing strings for factors to adjust for using ComBat. Options are "Plate", "TSS", "Year", "Portion", "Center"
#' @param UnpublishedData if TRUE perform a batch correction after adding new data
#' @param ClinicalDF a dataframe returned by GDCquery_clinic() to be used to extract year data
#' @param AnnotationDF a dataframe with column Batch indicating different batches of the samples in the tabDF
#' @export
#' @return data frame with ComBat batch correction applied
TCGAbatch_Correction <- function (tabDF,
                                  batch.factor = NULL,
                                  adjustment = NULL,
                                  ClinicalDF = data.frame(),
                                  UnpublishedData = FALSE,
                                  AnnotationDF = data.frame())

{
    if (!requireNamespace("sva", quietly = TRUE)) {
        stop("sva is needed. Please install it.",
             call. = FALSE)
    }
    if (UnpublishedData == TRUE) {
        batch.factor <- as.factor(AnnotationDF$Batch)
        batch_corr <-
            sva::ComBat(
                dat = tabDF,
                batch = batch.factor,
                par.prior = TRUE,
                prior.plots = TRUE
            )
    }

    if (UnpublishedData == FALSE) {
        if (length(batch.factor) == 0 & length(adjustment) == 0)
            message("batch correction will be skipped")
        else if (batch.factor %in% adjustment) {
            stop(paste0("Cannot adjust and correct for the same factor|"))
        }
        my_IDs <- get_IDs(tabDF)
        if (length(batch.factor) > 0 || length(adjustment) > 0)
            if ((nrow(ClinicalDF) > 0 & batch.factor == "Year") ||
                ("Year" %in% adjustment == TRUE & nrow(ClinicalDF) >
                 0)) {
                names(ClinicalDF)[names(ClinicalDF) == "bcr_patient_barcode"] <-
                    "patient"
                ClinicalDF$age_at_diag_year <-
                    floor(ClinicalDF$age_at_diagnosis / 365)
                ClinicalDF$diag_year <-
                    ClinicalDF$age_at_diag_year +
                    ClinicalDF$year_of_birth
                diag_yearDF <-
                    ClinicalDF[, c("patient", "diag_year")]
                Year <- merge(my_IDs, diag_yearDF, by = "patient")
                Year <- Year$diag_year
                Year <- as.factor(Year)
            }
        else if (nrow(ClinicalDF) == 0 & batch.factor == "Year") {
            stop("Cannot extract Year data. Clinical data was not provided")
        }
        Plate <- as.factor(my_IDs$plate)
        Condition <- as.factor(my_IDs$condition)
        TSS <- as.factor(my_IDs$tss)
        Portion <- as.factor(my_IDs$portion)
        Sequencing.Center <- as.factor(my_IDs$center)
        design.matrix <- model.matrix( ~ Condition)
        design.mod.combat <- model.matrix( ~ Condition)
        options <-
            c("Plate", "TSS", "Year", "Portion", "Sequencing Center")

        if (length(batch.factor) > 1)
            stop("Combat can only correct for one batch variable. Provide one batch factor")
        if (batch.factor %in% options == FALSE)
            stop(paste0(o, " is not a valid batch correction factor"))

        for (o in adjustment) {
            if (o %in% options == FALSE)
                stop(paste0(o, " is not a valid adjustment factor"))

        }
        adjustment.data <- c()
        for (a in adjustment) {
            if (a == "Sequencing Center")
                a <- Sequencing.Center
            adjustment.data <-
                cbind(eval(parse(text = a)), adjustment.data)
        }
        if (batch.factor == "Sequencing Center")
            batch.factor <- Sequencing.Center
        batchCombat <- eval(parse(text = batch.factor))
        if (length(adjustment) > 0) {
            adjustment.formula <- paste(adjustment, collapse = "+")
            adjustment.formula <- paste0("+", adjustment.formula)
            adjustment.formula <-
                paste0("~Condition", adjustment.formula)
            print(adjustment.formula)
            model <-
                data.frame(batchCombat, row.names = colnames(tabDF))
            design.mod.combat <-
                model.matrix(eval(parse(text = adjustment.formula)),
                             data = model)
        }
        print(unique(batchCombat))
        batch_corr <- sva::ComBat(
            dat = tabDF,
            batch = batchCombat,
            mod = design.mod.combat,
            par.prior = TRUE,
            prior.plots = TRUE
        )
    }

    return(batch_corr)
}

##Function to take raw counts by removing rows filtered after norm and filter process###

#' @title Use raw count from the DataPrep object which genes are removed by normalization and filtering steps.
#' @description function to keep raw counts after filtering and/or normalizing.
#' @param DataPrep DataPrep object returned by TCGAanalyze_Preprocessing()
#' @param DataFilt Filtered data frame containing samples in columns and genes in rows after normalization and/or filtering steps
#' @examples
#' \dontrun{
#'   dataPrep_raw <- UseRaw_afterFilter(dataPrep, dataFilt)
#' }
#' @export
#' @return Filtered return object similar to DataPrep with genes removed after normalization and filtering process.
UseRaw_afterFilter <- function(DataPrep, DataFilt) {
    rownames(DataPrep) <-
        lapply(rownames(DataPrep), function(x)
            gsub("[[:punct:]]\\d*", "", x))
    filtered.list <- setdiff(rownames(DataPrep), rownames(DataFilt))
    Res <- DataPrep[!rownames(DataPrep) %in% filtered.list,]
    return(Res)
}

#' @title Adding information related to DEGs genes from DEA as mean values in two conditions.
#' @description
#'    TCGAanalyze_LevelTab allows user to add information related to DEGs genes from
#'    Differentially expression analysis (DEA) such as mean values and in two conditions.
#' @param FC_FDR_table_mRNA Output of dataDEGs filter by abs(LogFC) >=1
#' @param typeCond1 a string containing the class label of the samples
#'  in TableCond1  (e.g., control group)
#' @param typeCond2 a string containing the class label of the samples
#' in TableCond2  (e.g., case group)
#' @param TableCond1 numeric matrix, each row represents a gene, each column
#'  represents a sample with Cond1type
#' @param TableCond2 numeric matrix, each row represents a gene, each column
#' represents a sample with Cond2type
#' @param typeOrder typeOrder
#' @export
#' @return table with DEGs, log Fold Change (FC), false discovery rate (FDR),
#' the gene expression level
#' for samples in  Cond1type, and Cond2type, and Delta value (the difference
#' of gene expression between the two
#' conditions multiplied logFC)
#' @examples
#' dataNorm <- TCGAbiolinks::TCGAanalyze_Normalization(dataBRCA, geneInfo)
#' dataFilt <- TCGAanalyze_Filtering(tabDF = dataBRCA, method = "quantile", qnt.cut =  0.25)
#' samplesNT <- TCGAquery_SampleTypes(colnames(dataFilt), typesample = c("NT"))
#' samplesTP <- TCGAquery_SampleTypes(colnames(dataFilt), typesample = c("TP"))
#' dataDEGs <- TCGAanalyze_DEA(dataFilt[,samplesNT],
#'                             dataFilt[,samplesTP],
#'                             Cond1type = "Normal",
#'                             Cond2type = "Tumor")
#' dataDEGsFilt <- dataDEGs[abs(dataDEGs$logFC) >= 1,]
#' dataTP <- dataFilt[,samplesTP]
#' dataTN <- dataFilt[,samplesNT]
#' dataDEGsFiltLevel <- TCGAanalyze_LevelTab(dataDEGsFilt,"Tumor","Normal",
#' dataTP,dataTN)
TCGAanalyze_LevelTab <- function(FC_FDR_table_mRNA,
                                 typeCond1,
                                 typeCond2,
                                 TableCond1,
                                 TableCond2,
                                 typeOrder = TRUE) {
    TF_enriched <- as.matrix(rownames(FC_FDR_table_mRNA))
    TableLevel <- matrix(0, nrow(TF_enriched), 6)
    TableLevel <- as.data.frame(TableLevel)

    colnames(TableLevel) <-
        c("mRNA", "logFC", "FDR", typeCond1, typeCond2, "Delta")


    TableLevel[, "mRNA"] <- TF_enriched
    Tabfilt <-
        FC_FDR_table_mRNA[which(rownames(FC_FDR_table_mRNA) %in%
                                    TF_enriched), ]
    TableLevel[, "logFC"] <-
        as.numeric(Tabfilt[TF_enriched, ][, "logFC"])
    TableLevel[, "FDR"] <- as.numeric(Tabfilt[TF_enriched, ][, "FDR"])


    MeanTumor <- matrix(0, nrow(TF_enriched), 1)
    MeanDiffTumorNormal <- matrix(0, nrow(TF_enriched), 1)

    for (i in 1:nrow(TF_enriched)) {
        TableLevel[i, typeCond1] <-
            mean(as.numeric(TableCond1[rownames(TableCond1) %in%
                                           TF_enriched[i] ,]))
        TableLevel[i, typeCond2] <-
            mean(as.numeric(TableCond2[rownames(TableCond2) %in%
                                           TF_enriched[i] ,]))
    }


    TableLevel[, "Delta"] <- as.numeric(abs(TableLevel[, "logFC"]) *
                                            TableLevel[, typeCond1])

    TableLevel <-
        TableLevel[order(as.numeric(TableLevel[, "Delta"]),
                         decreasing = typeOrder), ]

    rownames(TableLevel) <-  TableLevel[, "mRNA"]
    if (all(grepl("ENSG", rownames(TableLevel))))
        TableLevel <-
        cbind(TableLevel, map.ensg(genes = rownames(TableLevel))[, 2:3])
    return(TableLevel)
}

#' @title Enrichment analysis for Gene Ontology (GO) [BP,MF,CC] and Pathways
#' @description
#'   Researchers, in order to better understand the underlying biological
#'   processes, often want to retrieve a functional profile of a set of genes
#'   that might have an important role. This can be done by performing an
#'   enrichment analysis.
#'
#'We will perform an enrichment analysis on gene sets using the TCGAanalyze_EAcomplete
#'function. Given a set of genes that are
#'up-regulated under certain conditions, an enrichment analysis will find
#'identify classes of genes or proteins that are #'over-represented using
#'annotations for that gene set.
#' @param TFname is the name of the list of genes or TF's regulon.
#' @param RegulonList List of genes such as TF's regulon or DEGs where to find enrichment.
#' @export
#' @return Enrichment analysis GO[BP,MF,CC] and Pathways complete table enriched by genelist.
#' @examples
#' Genelist <- c("FN1","COL1A1")
#' ansEA <- TCGAanalyze_EAcomplete(TFname="DEA genes Normal Vs Tumor",Genelist)
#' \dontrun{
#' Genelist <- rownames(dataDEGsFiltLevel)
#' system.time(ansEA <- TCGAanalyze_EAcomplete(TFname="DEA genes Normal Vs Tumor",Genelist))
#' }
TCGAanalyze_EAcomplete <- function(TFname, RegulonList) {
    # This is a verification of the input
    # in case the List is like Gene|ID
    # we will get only the Gene
    if (all(grepl("\\|", RegulonList))) {
        RegulonList <- strsplit(RegulonList, "\\|")
        RegulonList <- unlist(lapply(RegulonList, function(x)
            x[1]))
    }

    print(
        paste(
            "I need about ",
            "1 minute to finish complete ",
            "Enrichment analysis GO[BP,MF,CC] and Pathways... "
        )
    )

    ResBP <- TCGAanalyze_EA(TFname, RegulonList, DAVID_BP_matrix,
                            EAGenes, GOtype = "DavidBP")
    print("GO Enrichment Analysis BP completed....done")
    ResMF <- TCGAanalyze_EA(TFname, RegulonList, DAVID_MF_matrix,
                            EAGenes, GOtype = "DavidMF")
    print("GO Enrichment Analysis MF completed....done")
    ResCC <- TCGAanalyze_EA(TFname, RegulonList, DAVID_CC_matrix,
                            EAGenes, GOtype = "DavidCC")
    print("GO Enrichment Analysis CC completed....done")
    ResPat <- TCGAanalyze_EA(TFname, RegulonList, listEA_pathways,
                             EAGenes, GOtype = "Pathway")
    print("Pathway Enrichment Analysis completed....done")

    ans <-
        list(
            ResBP = ResBP,
            ResMF = ResMF,
            ResCC = ResCC,
            ResPat = ResPat
        )
    return(ans)
}

#' @title Enrichment analysis of a gene-set with GO [BP,MF,CC]  and pathways.
#' @description
#' The rational behind a enrichment analysis ( gene-set, pathway etc) is to compute
#' statistics of whether the overlap between the focus list (signature) and the gene-set
#' is significant. ie the confidence that overlap between the list is not due to chance.
#'  The Gene Ontology project describes genes (gene products) using terms from
#'  three structured vocabularies: biological process, cellular component and molecular function.
#'  The Gene Ontology Enrichment component, also referred to as the GO Terms" component, allows
#'  the genes in any such "changed-gene" list to be characterized using the Gene Ontology terms
#'  annotated to them. It asks, whether for any particular GO term, the fraction of genes
#'  assigned to it in the "changed-gene" list is higher than expected by chance
#'  (is over-represented), relative to the fraction of genes assigned to that term in the
#'  reference set.
#'  In statistical terms it perform the analysis tests the null hypothesis that,
#'  for any particular ontology term, there is no difference in the proportion of genes
#'  annotated to it in the reference list and the proportion annotated to it in the test list.
#'  We adopted a Fisher Exact Test to perform the EA.
#' @param GeneName is the name of gene signatures list
#' @param TableEnrichment is a table related to annotations of gene symbols such as
#' GO[BP,MF,CC] and Pathways. It was created from DAVID gene ontology on-line.
#' @param RegulonList is a gene signature (lisf of genes) in which perform EA.
#' @param GOtype is type of gene ontology Biological process (BP), Molecular Function (MF),
#' Cellular componet (CC)
#' @param FDRThresh pvalue corrected (FDR) as threshold to selected significant
#' BP, MF,CC, or pathways. (default FDR < 0.01)
#' @param EAGenes is a table with informations about genes
#' such as ID, Gene, Description, Location and Family.
#' @param GeneSymbolsTable if it is TRUE will return a table with GeneSymbols in common GO or pathways.
# @export
#' @import stats
#' @return Table with enriched GO or pathways by selected gene signature.
#' @examples
#' \dontrun{
#' EAGenes <- get("EAGenes")
#' RegulonList <- rownames(dataDEGsFiltLevel)
#' ResBP <- TCGAanalyze_EA(GeneName="DEA genes Normal Vs Tumor",
#'                            RegulonList,DAVID_BP_matrix,
#'                            EAGenes,GOtype = "DavidBP")
#'}
TCGAanalyze_EA <-
    function (GeneName,
              RegulonList,
              TableEnrichment,
              EAGenes,
              GOtype,
              FDRThresh = 0.01,
              GeneSymbolsTable = FALSE)
    {
        topPathways <- nrow(TableEnrichment)
        topPathways_tab <- matrix(0, 1, topPathways)
        topPathways_tab <- as.matrix(topPathways_tab)
        rownames(topPathways_tab) <- GeneName
        rownames(EAGenes) <- toupper(rownames(EAGenes))
        EAGenes <- EAGenes[!duplicated(EAGenes[, "ID"]),]
        rownames(EAGenes) <- EAGenes[, "ID"]
        allgene <- EAGenes[, "ID"]
        current_pathway_from_EA <- as.matrix(TableEnrichment[, GOtype])
        TableNames <- gsub("David",
                           "",
                           paste("Top ", GOtype, " n. ",
                                 1:topPathways, " of ", topPathways, sep = ""))
        colnames(topPathways_tab) <- TableNames
        topPathways_tab <- as.data.frame(topPathways_tab)
        table_pathway_enriched <-
            matrix(1, nrow(current_pathway_from_EA),
                   8)
        colnames(table_pathway_enriched) <-
            c(
                "Pathway",
                "GenesInPathway",
                "Pvalue",
                "FDR",
                "CommonGenesPathway",
                "PercentPathway",
                "PercentRegulon",
                "CommonGeneSymbols"
            )
        table_pathway_enriched <- as.data.frame(table_pathway_enriched)
        for (i in 1:nrow(current_pathway_from_EA)) {
            table_pathway_enriched[i, "Pathway"] <-
                as.character(current_pathway_from_EA[i,])
            if (nrow(TableEnrichment) == 589) {
                genes_from_current_pathway_from_EA <-
                    GeneSplitRegulon(TableEnrichment[TableEnrichment[GOtype] ==
                                                         as.character(current_pathway_from_EA[i,]),][,
                                                                                                     "Molecules"], ",")
            }
            else {
                genes_from_current_pathway_from_EA <-
                    GeneSplitRegulon(TableEnrichment[TableEnrichment[GOtype] ==
                                                         as.character(current_pathway_from_EA[i,]),][,
                                                                                                     "Molecules"], ", ")
            }
            genes_common_pathway_TFregulon <-
                as.matrix(intersect(
                    toupper(RegulonList),
                    toupper(genes_from_current_pathway_from_EA)
                ))
            if (length(genes_common_pathway_TFregulon) != 0) {
                current_pathway_commongenes_num <-
                    length(genes_common_pathway_TFregulon)
                seta <- allgene %in% RegulonList
                setb <- allgene %in% genes_from_current_pathway_from_EA
                ft <- fisher.test(seta, setb)
                FisherpvalueTF <- ft$p.value
                table_pathway_enriched[i, "Pvalue"] <-
                    as.numeric(FisherpvalueTF)
                if (FisherpvalueTF < 0.01) {
                    current_pathway_commongenes_percent <- paste("(",
                                                                 format((
                                                                     current_pathway_commongenes_num / length(genes_from_current_pathway_from_EA)
                                                                 ) *
                                                                     100,
                                                                 digits = 2
                                                                 ), "%)")
                    current_pathway_commongenes_num_with_percent <-
                        gsub(
                            " ",
                            "",
                            paste(
                                current_pathway_commongenes_num,
                                current_pathway_commongenes_percent,
                                "pv=",
                                format(FisherpvalueTF, digits = 2)
                            )
                        )
                    table_pathway_enriched[i, "CommonGenesPathway"] <-
                        length(genes_common_pathway_TFregulon)
                    table_pathway_enriched[i, "CommonGeneSymbols"] <-
                        paste0(genes_common_pathway_TFregulon, collapse = ";")
                    table_pathway_enriched[i, "GenesInPathway"] <-
                        length(genes_from_current_pathway_from_EA)
                    table_pathway_enriched[i, "PercentPathway"] <-
                        as.numeric(table_pathway_enriched[i,
                                                          "CommonGenesPathway"]) /
                        as.numeric(table_pathway_enriched[i,
                                                          "GenesInPathway"]) * 100
                    table_pathway_enriched[i, "PercentRegulon"] <-
                        as.numeric(table_pathway_enriched[i,
                                                          "CommonGenesPathway"]) /
                        length(RegulonList) *
                        100
                }
            }
        }
        table_pathway_enriched <-
            table_pathway_enriched[order(table_pathway_enriched[,
                                                                "Pvalue"], decreasing = FALSE),]
        table_pathway_enriched <-
            table_pathway_enriched[table_pathway_enriched[,
                                                          "Pvalue"] < 0.01,]
        table_pathway_enriched[, "FDR"] <-
            p.adjust(table_pathway_enriched[,
                                            "Pvalue"], method = "fdr")
        table_pathway_enriched <-
            table_pathway_enriched[table_pathway_enriched[,
                                                          "FDR"] < FDRThresh,]
        table_pathway_enriched <-
            table_pathway_enriched[order(table_pathway_enriched[,
                                                                "FDR"], decreasing = FALSE),]

        table_pathway_enriched_filt <-
            table_pathway_enriched[table_pathway_enriched$FDR < FDRThresh, ]

        if (nrow(table_pathway_enriched) > 0) {
            tmp <- table_pathway_enriched
            tmp <- paste(
                tmp[, "Pathway"],
                "; FDR= ",
                format(tmp[,
                           "FDR"], digits = 3),
                "; (ng=",
                round(tmp[, "GenesInPathway"]),
                "); (ncommon=",
                format(tmp[, "CommonGenesPathway"],
                       digits = 2),
                ")",
                sep = ""
            )
            tmp <- as.matrix(tmp)
            topPathways_tab <-
                topPathways_tab[, 1:nrow(table_pathway_enriched),
                                drop = FALSE]
            topPathways_tab[1,] <- tmp
        }
        else {
            topPathways_tab <- NA
        }

        if (GeneSymbolsTable == FALSE) {
            return(topPathways_tab)
        }

        if (GeneSymbolsTable == TRUE) {
            return(table_pathway_enriched_filt)
        }
    }

#' @title Differentially expression analysis (DEA) using limma package.
#' @description Differentially expression analysis (DEA) using limma package.
#' @param FC.cut write
#' @param AffySet A matrix-like data object containing log-ratios or log-expression values
#' for a series of arrays, with rows corresponding to genes and columns to samples
#' @examples
#' \dontrun{
#' to add example
#' }
#' @export
#' @return List of list with tables in 2 by 2 comparison
#' of the top-ranked genes from a linear model fitted by DEA's limma
TCGAanalyze_DEA_Affy <- function(AffySet, FC.cut = 0.01) {
    if (!requireNamespace("Biobase", quietly = TRUE)) {
        stop("Biobase package is needed for this function to work. Please install it.",
             call. = FALSE)
    }
    if (!requireNamespace("limma", quietly = TRUE)) {
        stop("limma package is needed for this function to work. Please install it.",
             call. = FALSE)
    }
    Pdatatable <- Biobase::phenoData(AffySet)

    f <- factor(Pdatatable$Disease)
    groupColors <- names(table(f))

    tmp <- matrix(0, length(groupColors), length(groupColors))
    colnames(tmp) <- groupColors
    rownames(tmp) <- groupColors
    tmp[upper.tri(tmp)] <- 1


    sample_tab <- Pdatatable
    f <- factor(Pdatatable$Disease)
    design <- model.matrix( ~ 0 + f)
    colnames(design) <- levels(f)
    fit <-
        limma::lmFit(AffySet, design) ## fit is an object of class MArrayLM.

    groupColors <- names(table(Pdatatable$Disease))

    CompleteList <- vector("list", sum(tmp))

    k <- 1

    for (i in 1:length(groupColors)) {
        col1 <- colnames(tmp)[i]
        for (j in 1:length(groupColors)) {
            col2 <- rownames(tmp)[j]

            if (i != j) {
                if (tmp[i, j] != 0) {
                    Comparison <- paste(col2, "-", col1, sep = "")

                    if (i == 4 &&
                        j == 6) {
                        Comparison <- paste(col1, "-", col2, sep = "")
                    }
                    if (i == 5 &&
                        j == 6) {
                        Comparison <- paste(col1, "-", col2, sep = "")
                    }

                    print(paste(i, j, Comparison, "to do..."))

                    cont.matrix <-
                        limma::makeContrasts(I = Comparison, levels = design)

                    fit2 <- limma::contrasts.fit(fit, cont.matrix)
                    fit2 <- limma::eBayes(fit2)



                    sigI <-
                        limma::topTable(
                            fit2,
                            coef = 1,
                            adjust.method = "BH",
                            sort.by = "B",
                            p.value = 0.05,
                            lfc = FC.cut,
                            number = 50000
                        )

                    sigIbis <-
                        sigI[order(abs(as.numeric(sigI$logFC)), decreasing = TRUE), ]
                    names(CompleteList)[k] <- gsub("-", "_", Comparison)
                    CompleteList[[k]] <- sigIbis
                    k <- k + 1
                }
            }
        }

    }

    return(CompleteList)
}


#' @title Generate network
#' @description TCGAanalyze_analyseGRN perform gene regulatory network.
#' @param TFs a vector of genes.
#' @param normCounts is a matrix of gene expression with genes in rows and samples in columns.
#' @param kNum the number of nearest neighbors to consider to estimate the mutual information.
#' Must be less than the number of columns of normCounts.
#' @export
#' @return an adjacent matrix
TCGAanalyze_analyseGRN <- function(TFs, normCounts, kNum) {
    if (!requireNamespace("parmigene", quietly = TRUE)) {
        stop(
            "parmigene package is needed for this function to work. Please install it.",
            call. = FALSE
        )
    }
    MRcandidates <- intersect(rownames(normCounts), TFs)

    # Mutual information between TF and genes
    sampleNames <- colnames(normCounts)
    geneNames <- rownames(normCounts)

    messageMI_TFgenes <-
        paste(
            "Estimation of MI among [",
            length(MRcandidates),
            " TRs and ",
            nrow(normCounts),
            " genes].....",
            sep = ""
        )
    timeEstimatedMI_TFgenes1 <-
        length(MRcandidates) * nrow(normCounts) / 1000
    timeEstimatedMI_TFgenes <-
        format(timeEstimatedMI_TFgenes1 * ncol(normCounts) / 17000,
               digits = 2)
    messageEstimation <-
        print(
            paste(
                "I Need about ",
                timeEstimatedMI_TFgenes,
                "seconds for this MI estimation. [Processing 17000k elements /s]  "
            )
        )

    system.time(miTFGenes <-
                    parmigene::knnmi.cross(normCounts[MRcandidates,], normCounts, k = kNum))

    return(miTFGenes)

}

#' @title Generate pathview graph
#' @description TCGAanalyze_Pathview pathway based data integration and visualization.
#' @param dataDEGs dataDEGs
#' @param pathwayKEGG pathwayKEGG
#' @export
#' @return an adjacent matrix
#' @examples
#' \dontrun{
#'   dataDEGs <- data.frame(mRNA = c("TP53","TP63","TP73"), logFC = c(1,2,3))
#'   TCGAanalyze_Pathview(dataDEGs)
#' }
TCGAanalyze_Pathview <-
    function(dataDEGs, pathwayKEGG = "hsa05200") {
        if (!requireNamespace("clusterProfiler", quietly = TRUE)) {
            stop("clusterProfiler needed for this function to work. Please install it.",
                 call. = FALSE)
        }
        if (!requireNamespace("pathview", quietly = TRUE)) {
            stop("pathview needed for this function to work. Please install it.",
                 call. = FALSE)
        }
        # Converting Gene symbol to gene ID
        eg = as.data.frame(
            clusterProfiler::bitr(
                dataDEGs$mRNA,
                fromType = "SYMBOL",
                toType = "ENTREZID",
                OrgDb = "org.Hs.eg.db"
            )
        )
        eg <- eg[!duplicated(eg$SYMBOL), ]
        dataDEGs <- dataDEGs[dataDEGs$mRNA %in% eg$SYMBOL, ]
        dataDEGs <- dataDEGs[order(dataDEGs$mRNA, decreasing = FALSE), ]
        eg <- eg[order(eg$SYMBOL, decreasing = FALSE), ]
        dataDEGs$GeneID <- eg$ENTREZID
        dataDEGsFiltLevel_sub <-
            subset(dataDEGs, select = c("GeneID", "logFC"))
        genelistDEGs <- as.numeric(dataDEGsFiltLevel_sub$logFC)
        names(genelistDEGs) <- dataDEGsFiltLevel_sub$GeneID

        hsa05200 <- pathview::pathview(
            gene.data  = genelistDEGs,
            pathway.id = pathwayKEGG,
            species    = "hsa",
            limit      = list(gene = as.integer(max(
                abs(genelistDEGs)
            )))
        )

    }


#' @title infer gene regulatory networks
#' @description TCGAanalyze_networkInference taking expression data as input,
#' this will return an adjacency matrix of interactions
#' @param data expression data, genes in columns, samples in rows
#' @param optionMethod inference method, chose from aracne, c3net, clr and mrnet
#' @export
#' @return an adjacent matrix
TCGAanalyze_networkInference <-
    function(data, optionMethod = "clr") {
        # Converting Gene symbol to gene ID
        if (optionMethod == "c3net") {
            if (!requireNamespace("c3net", quietly = TRUE)) {
                stop(
                    "c3net package is needed for this function to work. Please install it.",
                    call. = FALSE
                )
            }

            net <- c3net::c3net(t(data))
        } else {
            if (!requireNamespace("minet", quietly = TRUE)) {
                stop(
                    "minet package is needed for this function to work. Please install it.",
                    call. = FALSE
                )
            }
            net <- minet::minet(data, method = optionMethod)
        }
        return(net)

    }


#' Creates a plot for GAIA output (all significant aberrant regions.)
#' @description
#' This function is a auxiliary function to visualize GAIA output
#' (all significant aberrant regions.)
#' @param calls A matrix with the following columns: Chromossome, Aberration Kind
#' Region Start, Region End, Region Size and score
#' @param threshold Score threshold (orange horizontal line in the plot)
#' @export
#' @importFrom graphics abline axis legend plot points
#' @return A plot with all significant aberrant regions.
#' @examples
#' call <- data.frame("Chromossome" = rep(9,100),
#'                    "Aberration Kind" = rep(c(-2,-1,0,1,2),20),
#'                    "Region Start [bp]" = 18259823:18259922,
#'                    "Region End [bp]" = 18259823:18259922,
#'                    "score" = rep(c(1,2,3,4),25))
#'  gaiaCNVplot(call,threshold = 0.01)
#'  call <- data.frame("Chromossome" = rep(c(1,9),50),
#'                     "Aberration Kind" = rep(c(-2,-1,0,1,2),20),
#'                     "Region Start [bp]" = 18259823:18259922,
#'                     "Region End [bp]" = 18259823:18259922,
#'                     "score" = rep(c(1,2,3,4),25))
#'  gaiaCNVplot(call,threshold = 0.01)
gaiaCNVplot <- function (calls,  threshold = 0.01) {
    Calls <-
        calls[order(calls[, grep("start", colnames(calls), ignore.case = TRUE)]), ]
    Calls <-
        Calls[order(Calls[, grep("chr", colnames(calls), ignore.case = TRUE)]), ]
    rownames(Calls) <- NULL
    Chromo <- Calls[, grep("chr", colnames(calls), ignore.case = TRUE)]
    Gains <-
        apply(Calls, 1, function(x)
            ifelse(x[grep("aberration", colnames(calls), ignore.case = TRUE)] == 1, x["score"], 0))
    Losses <-
        apply(Calls, 1, function(x)
            ifelse(x[grep("aberration", colnames(calls), ignore.case = TRUE)] == 0, x["score"], 0))
    plot(
        Gains,
        ylim = c(-max(Calls[, "score"] + 2), max(Calls[, "score"] + 2)),
        type = "h",
        col = "red",
        xlab = "Chromosome",
        ylab = "Score",
        xaxt = "n"
    )
    points(-(Losses), type = "h", col = "blue")
    # Draw origin line
    abline(h = 0, cex = 4)
    # Draw threshold lines
    abline(
        h = -log10(threshold),
        col = "orange",
        cex = 4,
        main = "test"
    )
    abline(
        h = log10(threshold),
        col = "orange",
        cex = 4,
        main = "test"
    )

    uni.chr <- unique(Chromo)
    temp <- rep(0, length(uni.chr))
    for (i in 1:length(uni.chr)) {
        temp[i] <- max(which(uni.chr[i] == Chromo))
    }
    for (i in 1:length(temp)) {
        abline(v = temp[i],
               col = "black",
               lty = "dashed")
    }
    nChroms <- length(uni.chr)
    begin <- c()
    for (d in 1:nChroms) {
        chrom <- sum(Chromo == uni.chr[d])
        begin <- append(begin, chrom)
    }
    temp2 <- rep(0, nChroms)
    for (i in 1:nChroms) {
        if (i == 1) {
            temp2[1] <- (begin[1] * 0.5)
        }
        else if (i > 1) {
            temp2[i] <- temp[i - 1] + (begin[i] * 0.5)
        }
    }
    uni.chr[uni.chr == 23] <- "X"
    uni.chr[uni.chr == 24] <- "Y"
    for (i in 1:length(temp)) {
        axis(1,
             at = temp2[i],
             labels = uni.chr[i],
             cex.axis = 1)
    }
    legend(
        x = 1,
        y = max(Calls[, "score"] + 2),
        y.intersp = 0.8,
        c("Amp"),
        pch = 15,
        col = c("red"),
        text.font = 3
    )
    legend(
        x = 1,
        y = -max(Calls[, "score"] + 0.5),
        y.intersp = 0.8,
        c("Del"),
        pch = 15,
        col = c("blue"),
        text.font = 3
    )
}

#' Get a matrix of interactions of genes from biogrid
#' @description
#' Using biogrid database, it will create a matrix of gene interactions.
#' If columns A and row B has value 1, it means the gene A and gene B interacts.
#' @param tmp.biogrid Biogrid table
#' @export
#' @param names.genes List of genes to filter from output. Default: consider all genes
#' @return A matrix with 1 for genes that interacts, 0 for no interaction.
#' @examples
#' names.genes.de <- c("PLCB1","MCL1","PRDX4","TTF2","TACC3", "PARP4","LSM1")
#' tmp.biogrid <- data.frame("Official.Symbol.Interactor.A" = names.genes.de,
#'                           "Official.Symbol.Interactor.B" = rev(names.genes.de))
#' net.biogrid.de <- getAdjacencyBiogrid(tmp.biogrid, names.genes.de)
#' \dontrun{
#'   file <- paste0("http://thebiogrid.org/downloads/archives/",
#'                  "Release%20Archive/BIOGRID-3.4.133/BIOGRID-ALL-3.4.133.tab2.zip")
#'   downloader::download(file,basename(file))
#'   unzip(basename(file),junkpaths =TRUE)
#'   tmp.biogrid <- read.csv(gsub("zip","txt",basename(file)),
#'                           header=TRUE, sep="\t", stringsAsFactors=FALSE)
#'   names.genes.de <- c("PLCB1","MCL1","PRDX4","TTF2","TACC3", "PARP4","LSM1")
#'   net.biogrid.de <- getAdjacencyBiogrid(tmp.biogrid, names.genes.de)
#' }
getAdjacencyBiogrid <- function(tmp.biogrid, names.genes = NULL) {
    it.a <- grep("Symbol", colnames(tmp.biogrid), value = TRUE)[1]
    it.b <- grep("Symbol", colnames(tmp.biogrid), value = TRUE)[2]

    if (is.null(names.genes)) {
        names.genes <-
            sort(union(unique(tmp.biogrid[, it.a]), unique(tmp.biogrid[, it.b])))
        ind <- seq(1, nrow(tmp.biogrid))
    } else {
        ind.A <- which(tmp.biogrid[, it.a] %in% names.genes)
        ind.B <- which(tmp.biogrid[, it.b] %in% names.genes)
        ind <- intersect(ind.A, ind.B)
    }

    mat.biogrid <- matrix(
        0,
        nrow = length(names.genes),
        ncol = length(names.genes),
        dimnames = list(names.genes, names.genes)
    )

    for (i in ind) {
        mat.biogrid[tmp.biogrid[i, it.a], tmp.biogrid[i, it.b]] <-
            mat.biogrid[tmp.biogrid[i, it.b], tmp.biogrid[i, it.a]] <- 1
    }
    diag(mat.biogrid) <- 0

    return(mat.biogrid)
}

#' Get GDC samples with both DNA methylation (HM450K) and Gene expression data from
#' GDC databse
#' @description
#' For a given TCGA project it gets the  samples (barcode) with both DNA methylation and Gene expression data
#' from GDC database
#' @param project A GDC project
#' @param n Number of samples to return. If NULL return all (default)
#' @param legacy Access legacy (hg19) or harmonized database (hg38).
#' @return A vector of barcodes
#' @export
#' @examples
#' # Get ACC samples with both  DNA methylation (HM450K) and gene expression aligned to hg19
#' samples <- matchedMetExp("TCGA-UCS", legacy = TRUE)
matchedMetExp <- function(project, legacy = FALSE, n = NULL) {
    if (legacy) {
        # get primary solid tumor samples: DNA methylation
        message("Download DNA methylation information")
        met450k <- GDCquery(
            project = project,
            data.category = "DNA methylation",
            platform = "Illumina Human Methylation 450",
            legacy = TRUE,
            sample.type = c("Primary Tumor")
        )

        # get primary solid tumor samples: RNAseq
        message("Download gene expression information")
        exp <- GDCquery(
            project = project,
            data.category = "Gene expression",
            data.type = "Gene expression quantification",
            platform = "Illumina HiSeq",
            file.type  = "results",
            sample.type = c("Primary Tumor"),
            legacy = TRUE
        )
    } else {
        # get primary solid tumor samples: DNA methylation
        message("Download DNA methylation information")
        met450k <- GDCquery(
            project = project,
            data.category = "DNA Methylation",
            platform = "Illumina Human Methylation 450",
            sample.type = c("Primary Tumor")
        )

        # get primary solid tumor samples: RNAseq
        message("Download gene expression information")
        exp <- GDCquery(
            project = project,
            data.category = "Transcriptome Profiling",
            data.type = "Gene Expression Quantification",
            workflow.type = "HTSeq - Counts"
        )


    }
    met450k.tp <-  met450k$results[[1]]$cases
    # Get patients with samples in both platforms
    exp.tp <-  exp$results[[1]]$cases
    patients <-
        unique(substr(exp.tp, 1, 15)[substr(exp.tp, 1, 12) %in% substr(met450k.tp, 1, 12)])
    if (!is.null(n))
        patients <- patients[1:n] # get only n samples
    return(patients)
}


#' @title Generate Stemness Score based on RNASeq (mRNAsi stemness index) Malta et al., Cell, 2018
#' @description TCGAanalyze_Stemness generate the mRNAsi score
#' @param stemSig is a vector of the stemness Signature generated using gelnet package
#' @param dataGE is a matrix of Gene expression (genes in rows, samples in cols) from TCGAprepare
#' @param annotation as default is FALSE.
#' If annotation == subtype it returns the molecular subtype of a sample.
#' If annotation == sampleType it returns the type of a sample (normal or tumor)
#' @export
#' @return table with samples and stemness score
#' @examples
#'  # Selecting TCGA breast cancer (10 samples) for example stored in dataBRCA
#'  dataNorm <- TCGAanalyze_Normalization(tabDF = dataBRCA, geneInfo =  geneInfo)
#'  # quantile filter of genes
#'  dataFilt <- TCGAanalyze_Filtering(tabDF = dataNorm,
#'                                   method = "quantile",
#'                                   qnt.cut =  0.25)
#'  dataBRCA_stemness <- TCGAanalyze_Stemness(stemSig = PCBC_stemSig,
#'  dataGE = dataFilt, annotation = "sampleType")
TCGAanalyze_Stemness <- function(stemSig,
                                 dataGE,
                                 annotation = FALSE) {
    reads <- dataGE
    X <- reads
    w <- stemSig
    commonStemsigGenes <- intersect(names(w), rownames(X))

    X <- X[commonStemsigGenes, ]
    w <- w[rownames(X)]

    # Score the Matrix X using Spearman correlation.

    s <-
        apply(X, 2, function(z) {
            cor(z, w, method = "sp", use = "complete.obs")
        })

    ## Scale the scores to be between 0 and 1
    s <- s - min(s)
    s <- s / max(s)

    dataSce_stemness <- cbind(s)

    dataAnnotationSC <- matrix(0, ncol(reads), 2)
    colnames(dataAnnotationSC) <- c("Sample", "Annotation")


    dataAnnotationSC <- as.data.frame(dataAnnotationSC)
    dataAnnotationSC$Sample <- colnames(reads)
    rownames(dataAnnotationSC) <- colnames(reads)

    dataAnnotationSC <-
        cbind(dataAnnotationSC, StemnessScore = rep(0, nrow(dataAnnotationSC)))
    dataAnnotationSC[rownames(dataSce_stemness), "StemnessScore"] <-
        as.numeric(dataSce_stemness)

    colnames(dataAnnotationSC)[1] <- "Sample"
    if (annotation == "sampleType") {
        sampleTP <-
            TCGAquery_SampleTypes(barcode = dataAnnotationSC$Sample, typesample = "TP")
        sampleNT <-
            TCGAquery_SampleTypes(barcode = dataAnnotationSC$Sample, typesample = "NT")

        dataAnnotationSC[sampleTP, "Annotation"] <- "TP"
        dataAnnotationSC[sampleNT, "Annotation"] <- "NT"
    }

    if (annotation == "subtype") {
        dataSubt <- TCGAquery_subtype(tumor = "BRCA")

        for (i in 1:nrow(dataAnnotationSC)) {
            curSample <- dataAnnotationSC$Sample[i]
            dataAnnotationSC$Annotation <-
                dataSubt[dataSubt$patient %in% substr(curSample, 1, 12), "BRCA_Subtype_PAM50"]
        }
    }

    return(dataAnnotationSC)
}

## ----setup, include=FALSE-----------------------------------------------------
knitr::opts_chunk$set(dpi = 300)
knitr::opts_chunk$set(cache=FALSE)
knitr::opts_chunk$set(echo = TRUE)

## ----message=FALSE, warning=FALSE, include=FALSE------------------------------
library(TCGAbiolinks)
library(SummarizedExperiment)
#library(dplyr)
#library(DT)

## ----echo=TRUE, warning=FALSE, eval=TRUE--------------------------------------
projects <- getGDCprojects()$project_id
as.data.frame(grep("TARGET", projects,value = TRUE))

## ----echo=TRUE, results='hide', message=FALSE, warning=FALSE, eval=FALSE------
# #Downloading and prepare TARGET CASE
# query_Target <- GDCquery(project = "TARGET-AML",
#                          data.category = "Transcriptome Profiling",
#                          data.type = "Gene Expression Quantification",
#                          workflow.type = "HTSeq - Counts")
# 
# samplesDown_Target <- getResults(query_Target, cols = c("cases"))
# 
# dataSmTB_Target <- TCGAquery_SampleTypes(barcode = samplesDown_Target,
#                                          typesample = "TB")
# 
# dataSmNB_Target <- TCGAquery_SampleTypes(barcode = samplesDown_Target,
#                                          typesample = "TBM")
# dataSmTB_short_Target <- dataSmTB_Target[1:10]
# dataSmNB_short_Target <- dataSmNB_Target[1:10]
# 
# queryDown_Target <- GDCquery(project = "TARGET-AML",
#                              data.category = "Transcriptome Profiling",
#                              data.type = "Gene Expression Quantification",
#                              workflow.type = "HTSeq - Counts",
#                              barcode = c(dataSmTB_short_Target, dataSmNB_short_Target))
# 
# GDCdownload(queryDown_Target)
# 
# ### SummarizedExperiment = TRUE
# data <- GDCprepare(queryDown_Target)
# 
# dataPrep_Target <- TCGAanalyze_Preprocessing(object = data,
#                                              cor.cut = 0.6,
#                                              datatype = "HTSeq - Counts")
# 
# dataNorm_Target <- TCGAanalyze_Normalization(tabDF = dataPrep_Target,
#                                              geneInfo = geneInfoHT,
#                                              method = "gcContent")
# 
# boxplot(dataPrep_Target, outline = FALSE)
# 
# boxplot(dataNorm_Target, outline = FALSE)
# 
# dataFilt_Target <- TCGAanalyze_Filtering(tabDF = dataNorm_Target,
#                                          method = "quantile",
#                                          qnt.cut =  0.25)

## ----echo=TRUE, results='hide', message=FALSE, warning=FALSE, eval=FALSE------
# CancerProject <- "TCGA-BRCA"
# DataDirectory <- paste0("../GDC/",gsub("-","_",CancerProject))
# FileNameData <- paste0(DataDirectory, "_","HTSeq_Counts",".rda")
# 
# query <- GDCquery(project = CancerProject,
#                   data.category = "Transcriptome Profiling",
#                   data.type = "Gene Expression Quantification",
#                   workflow.type = "HTSeq - Counts")
# 
# samplesDown <- getResults(query,cols = c("cases"))
# 
# dataSmTP <- TCGAquery_SampleTypes(barcode = samplesDown,
#                                   typesample = "TP")
# 
# dataSmNT <- TCGAquery_SampleTypes(barcode = samplesDown,
#                                   typesample = "NT")
# dataSmTP_short <- dataSmTP[1:10]
# dataSmNT_short <- dataSmNT[1:10]
# 
# queryDown <- GDCquery(project = CancerProject,
#                       data.category = "Transcriptome Profiling",
#                       data.type = "Gene Expression Quantification",
#                       workflow.type = "HTSeq - Counts",
#                       barcode = c(dataSmTP_short, dataSmNT_short))
# 
# GDCdownload(query = queryDown)
# 
# dataPrep1 <- GDCprepare(query = queryDown,
#                         save = TRUE,
#                         save.filename = "TCGA_BRCA_HTSeq_Countds.rda")
# 
# dataPrep <- TCGAanalyze_Preprocessing(object = dataPrep1,
#                                       cor.cut = 0.6,
#                                       datatype = "HTSeq - Counts")
# 
# 
# dataNorm <- TCGAanalyze_Normalization(tabDF = dataPrep,
#                                       geneInfo = geneInfoHT,
#                                       method = "gcContent")
# dataNorm <- TCGAanalyze_Normalization(tabDF = dataPrep,
#                                       geneInfo = geneInfoHT,
#                                       method = "geneLength")
# 
# dataFilt <- TCGAanalyze_Filtering(tabDF = dataNorm,
#                                   method = "quantile",
#                                   qnt.cut =  0.25)

## ----echo=TRUE, results='hide', message=FALSE, warning=FALSE, eval=FALSE------
# ### dataframe will have genes from dataFilt but raw counts from dataPrep
# dataPrep_raw <- UseRaw_afterFilter(dataPrep, dataFilt)

## ----echo=TRUE, results='hide', message=FALSE, warning=FALSE, eval=FALSE------
# ##use previously fetched BRCA data:
# Pam50.subtypes<-TCGA_MolecularSubtype(colnames(dataFilt))

## ----echo=TRUE, results='hide', message=FALSE, warning=FALSE, eval=FALSE------
# dataDEGs <- TCGAanalyze_DEA(mat1 = dataFilt[,dataSmTP_short],
#                             mat2 = dataFilt[,dataSmNT_short],
#                             pipeline="limma",
#                             Cond1type = "Normal",
#                             Cond2type = "Tumor",
#                             fdr.cut = 0.01 ,
#                             logFC.cut = 1,
#                             method = "glmLRT", ClinicalDF = data.frame())

## ----echo=TRUE, results='hide', message=FALSE, warning=FALSE, eval=FALSE------
# ### ##download and prepare lung data through GDC### ##
# query.lung <- GDCquery(project = "TCGA-LUSC",
#                        data.category = "Transcriptome Profiling",
#                        data.type = "Gene Expression Quantification",
#                        workflow.type = "HTSeq - Counts")
# 
# samplesDown.lusc <- getResults(query.lung,cols=c("cases"))
# 
# dataSmTP.lusc <- TCGAquery_SampleTypes(barcode = samplesDown.lusc,
#                                        typesample = "TP")
# 
# dataSmNT.lusc <- TCGAquery_SampleTypes(barcode = samplesDown.lusc,
#                                        typesample = "NT")
# dataSmTP_short.lusc <- dataSmTP.lusc[1:10]
# dataSmNT_short.lusc <- dataSmNT.lusc[1:10]
# length(dataSmTP.lusc)
# 
# 
# queryDown.lung <- GDCquery(project = "TCGA-LUSC",
#                            data.category = "Transcriptome Profiling",
#                            data.type = "Gene Expression Quantification",
#                            workflow.type = "HTSeq - Counts",
#                            barcode = c(dataSmTP.lusc, dataSmNT.lusc))
# 
# GDCdownload(query = queryDown.lung)
# 
# dataPrep1.tcga <- GDCprepare(query = queryDown.lung,
#                              save = TRUE,
#                              save.filename = "TCGA_LUSC_HTSeq_Countds.rda")
# dataPrep.tcga <- TCGAanalyze_Preprocessing(object = dataPrep1.tcga,
#                                            cor.cut = 0.6,
#                                            datatype = "HTSeq - Counts")
# 
# dataNorm.tcga <- TCGAanalyze_Normalization(tabDF = dataPrep.tcga,
#                                            geneInfo = geneInfoHT,
#                                            method = "gcContent")
# 
# dataNorm.tcga <- TCGAanalyze_Normalization(tabDF = dataNorm.tcga,
#                                            geneInfo = geneInfoHT,
#                                            method = "geneLength")
# dataFilt.tcga <- TCGAanalyze_Filtering(tabDF = dataNorm.tcga,
#                                        method = "quantile",
#                                        qnt.cut =  0.25)
# 
# ### #Filtering data so all samples have a pam50 subtype for LUSC
# 
# diff<-setdiff(colnames(dataFilt.tcga), TCGA_MolecularSubtype(colnames(dataFilt.tcga))$filtered)
# TCGA_MolecularSubtype(diff)$subtypes$barcodes
# 
# dataFilt.tcga.lusc<-dataFilt.tcga[,diff]
# LUSC.subtypes<-TCGA_MolecularSubtype(colnames(dataFilt.tcga.lusc))$subtypes$subtype
# 
# ### Differential expression analysis after correcting for "Plate" factor.
# DEG.lusc <- TCGAanalyze_DEA(MAT=dataFilt.tcga.lusc,
#                             pipeline="limma",
#                             batch.factors = c("Plate"),
#                             Cond1type = "Normal",
#                             Cond2type = "Tumor",
#                             fdr.cut = 0.01 ,
#                             logFC.cut = 1,
#                             method = "glmLRT", ClinicalDF = data.frame(),
#                             Condtypes = LUSC.subtypes,
#                             contrast.formula = "LUSC.basalvsLUSC.classical=LUSC.basal - LUSC.classical")

## ----echo=TRUE, results='hide', message=FALSE, warning=FALSE, eval=FALSE------
# 
# batch.corrected <- TCGAbatch_Correction(tabDF = dataFilt.tcga, batch.factor = "Plate")
# 
# batch.corrected.adjusted <- TCGAbatch_Correction(tabDF = dataFilt.tcga,
#                                                  batch.factor = "Plate",
#                                                  adjustment=c("TSS"))

## ----echo=TRUE, results='hide', message=FALSE, warning=FALSE, eval=FALSE------
# 
# #dataFilt is a gene expression matrix from pancancer33 RNASeq data that can be generated following our previous described workflow
# 
# sampleTP <- TCGAquery_SampleTypes(barcode = colnames(dataFilt), typesample = "TP")
# sampleNT <- TCGAquery_SampleTypes(barcode = colnames(dataFilt), typesample = "NT")
# dataFiltTP <- dataFilt[,sampleTP]
# dataFiltNT <- dataFilt[,sampleNT]
# 
# dataSubt_LUAD <-TCGAquery_subtype(tumor = "LUAD")
# sampleStageI_LUAD <- dataSubt_LUAD[dataSubt_LUAD$Tumor.stage %in% c("Stage I","Stage IA","Stage IB"),]
# dataFilt.LUAD.stageI.TP <- dataFiltTP[,substr(colnames(dataFiltTP),1,12) %in% sampleStageI_LUAD$patient]
# dataFilt.LUAD.stageI.NT <- dataFiltNT[,substr(colnames(dataFiltNT),1,12) %in% sampleStageI_LUAD$patient]
# 
# # here for example the end-user can replace LUSC with unpublished data in a dataframe containing counts.
# # and adding the information for LUSC.stageI.TP or LUSC.stageI.NT with unpublished data
# 
# dataSubt_LUSC <-TCGAquery_subtype(tumor = "LUSC")
# sampleStageI_LUSC <- dataSubt_LUSC[dataSubt_LUSC$T.stage %in% c("T1","T1a","T1b"),]
# dataFilt.LUSC.stageI.TP <- dataFiltTP[,substr(colnames(dataFiltTP),1,12) %in% sampleStageI_LUSC$patient]
# dataFilt.LUSC.stageI.NT <- dataFiltNT[,substr(colnames(dataFiltNT),1,12) %in% sampleStageI_LUSC$patient]
# 
# countsTable <-cbind(dataFilt.LUAD.stageI.TP,dataFilt.LUAD.stageI.NT,
#                     dataFilt.LUSC.stageI.TP, dataFilt.LUSC.stageI.NT)
# 
# AnnotationCounts <- matrix(0,ncol(countsTable),2)
# colnames(AnnotationCounts) <- c("Samples","Batch")
# rownames(AnnotationCounts) <- colnames(countsTable)
# 
# AnnotationCounts <- as.data.frame(AnnotationCounts)
# AnnotationCounts$Samples <- colnames(countsTable)
# 
# AnnotationCounts[colnames(dataFilt.LUAD.stageI.TP),"Batch"] <- "LUAD.stageI.TP"
# AnnotationCounts[colnames(dataFilt.LUAD.stageI.NT),"Batch"] <- "LUAD.stageI.NT"
# AnnotationCounts[colnames(dataFilt.LUSC.stageI.TP),"Batch"] <- "LUSC.stageI.TP"
# AnnotationCounts[colnames(dataFilt.LUSC.stageI.NT),"Batch"] <- "LUSC.stageI.NT"
# 
# countsCorrected <- TCGAbatch_Correction(tabDF =countsTable,
#                                         UnpublishedData = TRUE,
#                                         AnnotationDF = AnnotationCounts)

## ----echo=TRUE, results='hide', message=FALSE, warning=FALSE, eval=FALSE------
# Purity.BRCA <- TCGAtumor_purity(colnames(dataPrep.tcga), 0, 0, 0, 0, 0.7)

## ----echo=TRUE, results='hide', message=FALSE, warning=FALSE, eval=FALSE------
# ##Brain data through Recount2
# 
# brain.rec <- TCGAquery_recount2(project = "gtex", tissue = "brain")

## ----setup, include=FALSE-----------------------------------------------------
knitr::opts_chunk$set(echo = TRUE)
knitr::opts_knit$set(progress = FALSE)

## ----message=FALSE, warning=FALSE, include=FALSE------------------------------
library(TCGAbiolinks)
library(SummarizedExperiment)
library(dplyr)
library(DT)

## ----results = 'hide', message=FALSE, warning=FALSE, eval=FALSE---------------
# # Gene expression aligned against hg38
# query <- GDCquery(
#     project = "TCGA-GBM",
#     data.category = "Transcriptome Profiling",
#     data.type = "Gene Expression Quantification",
#     workflow.type = "STAR - Counts",
#     barcode = c("TCGA-14-0736-02A-01R-2005-01", "TCGA-06-0211-02A-02R-2005-01")
# )
# GDCdownload(query = query)
# data <- GDCprepare(query = query)

## ----message=FALSE, warning=FALSE, include=FALSE------------------------------
data <- gbm.exp.harmonized

## ----message=FALSE, warning=FALSE---------------------------------------------
datatable(
    as.data.frame(colData(data)), 
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
    rownames = FALSE
)

datatable(
    assay(data)[1:20,], 
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
    rownames = TRUE
)

rowRanges(data)

## ----eval = FALSE-------------------------------------------------------------
# query <- GDCquery(
#     project = "TCGA-ACC",
#     data.category = "Copy Number Variation",
#     data.type = "Copy Number Segment",
#     barcode = c( "TCGA-OR-A5KU-01A-11D-A29H-01", "TCGA-OR-A5JK-01A-11D-A29H-01")
# )
# GDCdownload(query)
# data <- GDCprepare(query)

## ----eval = FALSE-------------------------------------------------------------
# query <- GDCquery(
#     project = "TCGA-ACC",
#     data.category = "Copy Number Variation",
#     data.type = "Gene Level Copy Number",
#     access = "open"
# )
# GDCdownload(query)
# data <- GDCprepare(query)

## ----eval = FALSE-------------------------------------------------------------
# query <- GDCquery(
#     project = "TCGA-ACC",
#     data.category = "Copy Number Variation",
#     data.type = "Allele-specific Copy Number Segment",
#     access = "open"
# )
# GDCdownload(query)
# data <- GDCprepare(query)

## ----eval = FALSE-------------------------------------------------------------
# query <- GDCquery(
#     project = "TCGA-ACC",
#     data.category = "Copy Number Variation",
#     data.type = "Masked Copy Number Segment",
#     access = "open"
# )
# GDCdownload(query)
# data <- GDCprepare(query)

## ----eval = FALSE-------------------------------------------------------------
# # mRNA pipeline: https://gdc-docs.nci.nih.gov/Data/Bioinformatics_Pipelines/Expression_mRNA_Pipeline/
# query.exp.hg38 <- GDCquery(
#     project = "TCGA-GBM",
#     data.category = "Transcriptome Profiling",
#     data.type = "Gene Expression Quantification",
#     workflow.type = "STAR - Counts",
#     barcode =  c("TCGA-14-0736-02A-01R-2005-01", "TCGA-06-0211-02A-02R-2005-01")
# )
# GDCdownload(query.exp.hg38)
# expdat <- GDCprepare(
#     query = query.exp.hg38,
#     save = TRUE,
#     save.filename = "exp.rda"
# )

## ----eval = FALSE-------------------------------------------------------------
# library(TCGAbiolinks)
# query.mirna <- GDCquery(
#     project = "TARGET-AML",
#     experimental.strategy = "miRNA-Seq",
#     data.category = "Transcriptome Profiling",
#     barcode = c("TARGET-20-PATDNN","TARGET-20-PAPUNR"),
#     data.type = "miRNA Expression Quantification"
# )
# GDCdownload(query.mirna)
# mirna <- GDCprepare(
#     query = query.mirna,
#     save = TRUE,
#     save.filename = "mirna.rda"
# )
# 

## ----eval = FALSE-------------------------------------------------------------
# 
# query.isoform <- GDCquery(
#     project = "TARGET-AML",
#     experimental.strategy = "miRNA-Seq",
#     data.category = "Transcriptome Profiling",
#     barcode = c("TARGET-20-PATDNN","TARGET-20-PAPUNR"),
#     data.type = "Isoform Expression Quantification"
# )
# GDCdownload(query.isoform)
# 
# isoform <- GDCprepare(
#     query = query.isoform,
#     save = TRUE,
#     save.filename = "mirna-isoform.rda"
# )

## ----eval = FALSE-------------------------------------------------------------
# query_met.hg38 <- GDCquery(
#     project = "TCGA-BRCA",
#     data.category = "DNA Methylation",
#     data.type = "Methylation Beta Value",
#     platform = "Illumina Human Methylation 27",
#     barcode = c("TCGA-B6-A0IM")
# )
# GDCdownload(query_met.hg38)
# data.hg38 <- GDCprepare(query_met.hg38)
# 
# query_met.hg38 <- GDCquery(
#     project= "TCGA-LGG",
#     data.category = "DNA Methylation",
#     data.type = "Methylation Beta Value",
#     platform = "Illumina Human Methylation 450",
#     barcode = c("TCGA-HT-8111-01A-11D-2399-05","TCGA-HT-A5R5-01A-11D-A28N-05")
# )
# GDCdownload(query_met.hg38)
# data.hg38 <- GDCprepare(query_met.hg38)
# 
# 
# query_met.hg38 <- GDCquery(
#     project= "HCMI-CMDC",
#     data.category = "DNA Methylation",
#     data.type = "Methylation Beta Value",
#     platform = "Illumina Methylation Epic",
#     barcode = c("HCM-BROD-0045")
# )
# GDCdownload(query_met.hg38)
# data.hg38 <- GDCprepare(query_met.hg38)

## ----eval = FALSE-------------------------------------------------------------
# query <- GDCquery(
#     project = "TCGA-BRCA",
#     data.category = "DNA Methylation",
#     data.type = "Masked Intensities",
#     platform = "Illumina Human Methylation 27"
# )
# GDCdownload(query, files.per.chunk=10)
# betas <- GDCprepare(query)
# 
# query <- GDCquery(
#     project = "HCMI-CMDC",
#     data.category = "DNA Methylation",
#     data.type = "Masked Intensities",
#     platform = "Illumina Methylation Epic"
# )
# GDCdownload(query, files.per.chunk = 10)
# betas <- GDCprepare(query)
# 
# 
# query <- GDCquery(
#     project = "CPTAC-3",
#     data.category = "DNA Methylation",
#     data.type = "Masked Intensities",
#     platform = "Illumina Methylation Epic"
# )
# GDCdownload(query, files.per.chunk=10)
# betas <- GDCprepare(query)
# 
# query <- GDCquery(
#     project = "TCGA-BRCA",
#     data.category = "DNA Methylation",
#     data.type = "Masked Intensities",
#     platform = "Illumina Methylation Epic"
# )
# GDCdownload(query, files.per.chunk = 10)
# betas <- GDCprepare(query)
# 
# 

## ----eval = FALSE-------------------------------------------------------------
# query.rppa <- GDCquery(
#     project = "TCGA-ESCA",
#     data.category = "Proteome Profiling",
#     data.type = "Protein Expression Quantification"
# )
# GDCdownload(query.rppa)
# rppa <- GDCprepare(query.rppa)

## ----eval = FALSE-------------------------------------------------------------
# 
# query <- GDCquery(
#     project = "TCGA-COAD",
#     data.category = "Clinical",
#     data.type = "Clinical Supplement",
#     data.format = "BCR XML",
#     barcode = "TCGA-A6-5664"
# )
# GDCdownload(query)
# drug <- GDCprepare_clinic(query,"drug")
# 
# query <- GDCquery(
#     project = "TCGA-COAD",
#     data.category = "Clinical",
#     data.type = "Clinical Supplement",
#     data.format = "BCR OMF XML",
#     barcode = "TCGA-AD-6964"
# )
# GDCdownload(query)
# 
# 
# query <- GDCquery(
#     project = "TCGA-ACC",
#     data.category = "Clinical",
#     data.type = "Clinical Supplement",
#     data.format = "BCR Biotab"
# )
# GDCdownload(query)
# clinical.BCRtab.all <- GDCprepare(query)
# names(clinical.BCRtab.all)
# 
# query <- GDCquery(
#     project = "TCGA-ACC",
#     data.category = "Clinical",
#     data.type = "Clinical Supplement",
#     data.format = "BCR Biotab",
#     file.type = "radiation"
# )
# GDCdownload(query)
# clinical.BCRtab.radiation <- GDCprepare(query)

## ----eval = FALSE-------------------------------------------------------------
# query <- GDCquery(
#     project = "TCGA-HNSC",
#     data.category = "Simple Nucleotide Variation",
#     data.type = "Masked Somatic Mutation",
#     access = "open"
# )
# GDCdownload(query)
# maf <- GDCprepare(query)

## ----eval = FALSE-------------------------------------------------------------
# query.sc.analysis <- GDCquery(
#     project = "CPTAC-3",
#     data.category = "Transcriptome Profiling",
#     access = "open",
#     data.type = "Single Cell Analysis",
#     data.format =  "TSV"
# )
# GDCdownload(query.sc.analysis)
# Single.Cell.Analysis.list <- GDCprepare(query.sc.analysis)

## ----eval = FALSE,include=F---------------------------------------------------
# query.hdF5 <- GDCquery(
#     project = "CPTAC-3",
#     data.category = "Transcriptome Profiling",
#     access = "open",
#     data.type = "Single Cell Analysis",
#     barcode = c("CPT0167860015","CPT0206880004"),
#     data.format =  "HDF5"
# )
# GDCdownload(query.hdF5)
# df.HDF5 <- GDCprepare(query.hdF5)

## ----eval = FALSE-------------------------------------------------------------
# query.raw.counts <- GDCquery(
#     project = "CPTAC-3",
#     data.category = "Transcriptome Profiling",
#     access = "open",
#     data.type = "Gene Expression Quantification",
#     barcode = c("CPT0167860015","CPT0206880004"),
#     workflow.type = "CellRanger - 10x Raw Counts"
# )
# GDCdownload(query.raw.counts)
# raw.counts.list <- GDCprepare(query.raw.counts)

## ----eval = FALSE-------------------------------------------------------------
# query.filtered.counts <- GDCquery(
#     project = "CPTAC-3",
#     data.category = "Transcriptome Profiling",
#     access = "open",
#     data.type = "Gene Expression Quantification",
#     barcode = c("CPT0167860015","CPT0206880004"),
#     workflow.type = "CellRanger - 10x Filtered Counts"
# )
# GDCdownload(query.filtered.counts)
# filtered.counts.list <- GDCprepare(query.filtered.counts)

## ----eval = FALSE-------------------------------------------------------------
# query.sc.dea <- GDCquery(
#     project = "CPTAC-3",
#     data.category = "Transcriptome Profiling",
#     access = "open",
#     data.type = "Differential Gene Expression",
#     barcode = c("CPT0167860015","CPT0206880004"),
#     workflow.type = "Seurat - 10x Chromium"
# )
# GDCdownload(query.sc.dea)
# sc.dea.list <- GDCprepare(query.sc.dea)

## ----setup, include=FALSE-----------------------------------------------------
knitr::opts_chunk$set(echo = TRUE)
knitr::opts_knit$set(progress = FALSE)

## ----message=FALSE, warning=FALSE, eval=FALSE---------------------------------
# if (!requireNamespace("BiocManager", quietly=TRUE))
#     install.packages("BiocManager")
# BiocManager::install("TCGAbiolinks")

## ----message=FALSE, warning=FALSE, eval=FALSE---------------------------------
# if (!requireNamespace("BiocManager", quietly = TRUE))
#     install.packages("BiocManager")
# BiocManager::install("BioinformaticsFMRP/TCGAbiolinksGUI.data")
# BiocManager::install("BioinformaticsFMRP/TCGAbiolinks")

## ----message=FALSE, warning=FALSE, include=TRUE-------------------------------
library(TCGAbiolinks)
library(dplyr)
library(DT)

## -----------------------------------------------------------------------------
version
packageVersion("TCGAbiolinks")

## ----setup, include=FALSE-----------------------------------------------------
knitr::opts_chunk$set(dpi = 300)
knitr::opts_chunk$set(cache=FALSE)

## ----message = FALSE, warning = FALSE, include = FALSE------------------------
library(TCGAbiolinks)
library(SummarizedExperiment)
library(dplyr)
library(DT)

## ----eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE-------------------------
# library(SummarizedExperiment)
# library(TCGAbiolinks)
# 
# query.exp <- GDCquery(
#     project = "TCGA-BRCA",
#     data.category = "Transcriptome Profiling",
#     data.type = "Gene Expression Quantification",
#     workflow.type = "STAR - Counts",
#     sample.type = c("Primary Tumor","Solid Tissue Normal")
# )
# GDCdownload(
#     query = query.exp,
#     files.per.chunk = 100
# )
# 
# brca.exp <- GDCprepare(
#     query = query.exp,
#     save = TRUE,
#     save.filename = "brcaExp.rda"
# )
# 
# # get subtype information
# infomation.subtype <- TCGAquery_subtype(tumor = "BRCA")
# 
# # get clinical data
# information.clinical <- GDCquery_clinic(project = "TCGA-BRCA",type = "clinical")
# 
# # Which samples are Primary Tumor
# samples.primary.tumour <- brca.exp$barcode[brca.exp$shortLetterCode == "TP"]
# 
# # which samples are solid tissue normal
# samples.solid.tissue.normal <- brca.exp$barcode[brca.exp$shortLetterCode == "NT"]

## ----eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE-------------------------
# dataPrep <- TCGAanalyze_Preprocessing(
#     object = brca.exp,
#     cor.cut = 0.6
# )
# 
# dataNorm <- TCGAanalyze_Normalization(
#     tabDF = dataPrep,
#     geneInfo = geneInfoHT,
#     method = "gcContent"
# )
# 
# dataFilt <- TCGAanalyze_Filtering(
#     tabDF = dataNorm,
#     method = "quantile",
#     qnt.cut =  0.25
# )
# 
# dataDEGs <- TCGAanalyze_DEA(
#     mat1 = dataFilt[,samples.solid.tissue.normal],
#     mat2 = dataFilt[,samples.primary.tumour],
#     Cond1type = "Normal",
#     Cond2type = "Tumor",
#     fdr.cut = 0.01 ,
#     logFC.cut = 2,
#     method = "glmLRT",
#     pipeline = "edgeR"
# )

## ----eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE-------------------------
# ansEA <- TCGAanalyze_EAcomplete(
#     TFname = "DEA genes Normal Vs Tumor",
#     RegulonList = dataDEGs$gene_name
# )
# 
# TCGAvisualize_EAbarplot(
#     tf = rownames(ansEA$ResBP),
#     GOBPTab = ansEA$ResBP,
#     GOCCTab = ansEA$ResCC,
#     GOMFTab = ansEA$ResMF,
#     PathTab = ansEA$ResPat,
#     nRGTab = dataDEGs$gene_name,
#     nBar = 10
# )

## ----fig.width=6, fig.height=4, echo = FALSE, fig.align="center",hide=TRUE, message=FALSE,warning=FALSE----
library(png)
library(grid)
img <- readPNG("case1_EA.png")
grid.raster(img)

## ----eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE-------------------------
# 
# group1 <- TCGAquery_SampleTypes(colnames(dataFilt), typesample = c("NT"))
# group2 <- TCGAquery_SampleTypes(colnames(dataFilt), typesample = c("TP"))
# 
# dataSurv <- TCGAanalyze_SurvivalKM(
#     clinical_patient = dataClin,
#     dataGE = dataFilt,
#     Genelist = rownames(dataDEGs),
#     Survresult = FALSE,
#     ThreshTop = 0.67,
#     ThreshDown = 0.33,
#     p.cut = 0.05,
#     group1 = group1,
#     group2 = group2
# )

## ----eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE-------------------------
# 
# require(dnet)  # to change
# org.Hs.string <- dRDataLoader(RData = "org.Hs.string")
# 
# TabCoxNet <- TCGAvisualize_SurvivalCoxNET(
#     dataClin,
#     dataFilt,
#     Genelist = rownames(dataSurv),
#     scoreConfidence = 700,
#     org.Hs.string = org.Hs.string,
#     titlePlot = "Case Study n.1 dnet"
# )

## ----fig.width=6, fig.height=4, echo = FALSE, fig.align="center",hide=TRUE, message=FALSE,warning=FALSE----
library(png)
library(grid)
img <- readPNG("case1_dnet.png")
grid.raster(img)

## ----eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE-------------------------
# library(TCGAbiolinks)
# library(SummarizedExperiment)
# 
# query.exp <- GDCquery(
#     project = "TCGA-LGG",
#     data.category = "Transcriptome Profiling",
#     data.type = "Gene Expression Quantification",
#     workflow.type = "STAR - Counts",
#     sample.type = c("Primary Tumor")
# )
# 
# GDCdownload(query.exp)
# 
# lgg.exp <- GDCprepare(
#     query = query.exp,
#     save = FALSE
# )

## ----eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE-------------------------
# library(dplyr)
# 
# dataPrep <- TCGAanalyze_Preprocessing(
#     object = lgg.exp,
#     cor.cut = 0.6
# )
# dataNorm <- TCGAanalyze_Normalization(
#     tabDF = dataPrep,
#     geneInfo = geneInfoHT,
#     method = "gcContent"
# )
# 
# datFilt <- dataNorm %>%
#     TCGAanalyze_Filtering(method = "varFilter") %>%
#     TCGAanalyze_Filtering(method = "filter1") %>%
#     TCGAanalyze_Filtering(method = "filter2",foldChange = 1)
# 
# data_Hc2 <- TCGAanalyze_Clustering(
#     tabDF = datFilt,
#     method = "consensus",
#     methodHC = "ward.D2"
# )
# # Add  cluster information to Summarized Experiment
# colData(lgg.exp)$groupsHC <- paste0("EC",data_Hc2[[4]]$consensusClass)

## ----eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE-------------------------
# TCGAanalyze_survival(
#     data = colData(lgg.exp),
#     clusterCol = "groupsHC",
#     main = "TCGA kaplan meier survival plot from consensus cluster",
#     legend = "RNA Group",
#     height = 10,
#     risk.table = T,
#     conf.int = F,
#     color = c("black","red","blue","green3"),
#     filename = "survival_lgg_expression_subtypes.png"
# )

## ----fig.width=6, fig.height=4, echo = FALSE, fig.align="center",hide=TRUE, message=FALSE,warning=FALSE----
library(png)
library(grid)
img <- readPNG("case2_surv.png")
grid.raster(img)

## ----eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE-------------------------
# TCGAvisualize_Heatmap(
#     data = t(datFilt),
#     col.metadata =  colData(lgg.exp)[,
#                                      c("barcode",
#                                        "groupsHC",
#                                        "paper_Histology",
#                                        "paper_IDH.codel.subtype")
#     ],
#     col.colors =  list(
#         groupsHC = c(
#             "EC1"="black",
#             "EC2"="red",
#             "EC3"="blue",
#             "EC4"="green3")
#     ),
#     sortCol = "groupsHC",
#     type = "expression", # sets default color
#     scale = "row", # use z-scores for better visualization. Center gene expression level around 0.
#     title = "Heatmap from concensus cluster",
#     filename = "case2_Heatmap.png",
#     extremes = seq(-2,2,1),
#     color.levels = colorRampPalette(c("green", "black", "red"))(n = 5),
#     cluster_rows = TRUE,
#     cluster_columns = FALSE,
#     width = 1000,
#     height = 500
# )

## ----fig.width=6, fig.height=4, echo = FALSE, fig.align="center",hide=TRUE, message=FALSE,warning=FALSE----
library(jpeg)
library(grid)
img <- readJPEG("case2_Heatmap.jpg")
grid.raster(img)

## ----eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE-------------------------
# library(maftools)
# library(dplyr)
# query <- GDCquery(
#     project = "TCGA-LGG",
#     data.category = "Simple Nucleotide Variation",
#     access = "open",
#     data.type = "Masked Somatic Mutation",
#     workflow.type = "Aliquot Ensemble Somatic Variant Merging and Masking"
# )
# GDCdownload(query)
# LGGmut <- GDCprepare(query)
# # Selecting gene
# LGGmut.atr <- LGGmut %>% dplyr::filter(Hugo_Symbol == "ATR")
# 
# dataMut <- LGGmut.atr[!duplicated(LGGmut.atr$Tumor_Sample_Barcode),]
# dataMut$Tumor_Sample_Barcode <- substr(dataMut$Tumor_Sample_Barcode,1,12)
# 
# # Adding the Expression Cluster classification found before
# dataMut <- merge(dataMut, cluster, by.y = "patient", by.x = "Tumor_Sample_Barcode")

## ----eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE-------------------------
# library(TCGAbiolinks)
# library(SummarizedExperiment)
# 
# #-----------------------------------
# # STEP 1: Search, download, prepare |
# #-----------------------------------
# # 1.1 - DNA methylation
# # ----------------------------------
# query.met <- GDCquery(
#     project = "TCGA-ACC",
#     data.category = "DNA Methylation",
#     data.type = "Methylation Beta Value",
#     platform = "Illumina Human Methylation 450"
# )
# 
# GDCdownload(
#     query = query.met,
#     files.per.chunk = 20,
#     directory = "case3/GDCdata"
# )
# 
# acc.met <- GDCprepare(
#     query = query.met,
#     save = FALSE,
#     directory = "case3/GDCdata"
# )
# 
# #-----------------------------------
# # 1.2 - RNA expression
# # ----------------------------------
# query.exp <- GDCquery(
#     project = "TCGA-ACC",
#     data.category = "Transcriptome Profiling",
#     data.type = "Gene Expression Quantification",
#     workflow.type = "STAR - Counts"
# )
# 
# GDCdownload(
#     query = query.exp,
#     files.per.chunk = 20,
#     directory = "case3/GDCdata"
# )
# 
# acc.exp <- GDCprepare(
#     query = query.exp,
#     save = FALSE,
#     directory = "case3/GDCdata"
# )

## ----eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE-------------------------
# # na.omit
# acc.met <- acc.met[rowSums(is.na(assay(acc.met))) == 0,]
# 
# # Volcano plot
# acc.met <- TCGAanalyze_DMC(
#     data = acc.met,
#     groupCol = "subtype_MethyLevel",
#     group1 = "CIMP-high",
#     group2="CIMP-low",
#     p.cut = 10^-5,
#     diffmean.cut = 0.25,
#     legend = "State",
#     plot.filename = "case3/CIMP-highvsCIMP-low_metvolcano.png"
# )

## ----fig.width=6, fig.height=4, echo = FALSE, fig.align="center",hide=TRUE, message=FALSE,warning=FALSE----
library(png)
library(grid)
img <- readPNG("CIMP-highvsCIMP-low_metvolcano.png")
grid.raster(img)

## ----eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE-------------------------
# #-------------------------------------------------
# # 2.3 - DEA - Expression analysis - volcano plot
# # ------------------------------------------------
# acc.exp.aux <- subset(
#     acc.exp,
#     select = colData(acc.exp)$subtype_MethyLevel %in% c("CIMP-high","CIMP-low")
# )
# 
# idx <- colData(acc.exp.aux)$subtype_MethyLevel %in% c("CIMP-high")
# idx2 <- colData(acc.exp.aux)$subtype_MethyLevel %in% c("CIMP-low")
# 
# dataPrep <- TCGAanalyze_Preprocessing(
#     object = acc.exp.aux,
#     cor.cut = 0.6
# )
# 
# dataNorm <- TCGAanalyze_Normalization(
#     tabDF = dataPrep,
#     geneInfo = geneInfoHT,
#     method = "gcContent"
# )
# 
# dataFilt <- TCGAanalyze_Filtering(
#     tabDF = dataNorm,
#     qnt.cut = 0.25,
#     method = 'quantile'
# )
# 
# dataDEGs <- TCGAanalyze_DEA(
#     mat1 = dataFilt[,idx],
#     mat2 = dataFilt[,idx2],
#     Cond1type = "CIMP-high",
#     Cond2type = "CIMP-low",
#     method = "glmLRT"
# )
# 
# TCGAVisualize_volcano(
#     x = dataDEGs$logFC,
#     y = dataDEGs$FDR,
#     filename = "case3/Case3_volcanoexp.png",
#     x.cut = 3,
#     y.cut = 10^-5,
#     names = rownames(dataDEGs),
#     color = c("black","red","darkgreen"),
#     names.size = 2,
#     xlab = " Gene expression fold change (Log2)",
#     legend = "State",
#     title = "Volcano plot (CIMP-high vs CIMP-low)",
#     width = 10
# )

## ----fig.width=6, fig.height=4, echo = FALSE, fig.align="center",hide=TRUE, message=FALSE,warning=FALSE----
library(png)
library(grid)
img <- readPNG("figure5exp.png")
grid.raster(img)

## ----eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE-------------------------
# #------------------------------------------
# # 2.4 - Starburst plot
# # -----------------------------------------
# # If true the argument names of the genes in circle
# # (biologically significant genes, has a change in gene
# # expression and DNA methylation and respects all the thresholds)
# # will be shown
# # these genes are returned by the function see starburst object after the function is executed
# starburst <- TCGAvisualize_starburst(
#     met = acc.met,
#     exp = dataDEGs,
#     genome = "hg19"
#     group1 = "CIMP-high",
#     group2 = "CIMP-low",
#     filename = "case3/starburst.png",
#     met.platform = "450K",
#     met.p.cut = 10^-5,
#     exp.p.cut = 10^-5,
#     diffmean.cut = 0.25,
#     logFC.cut = 3,
#     names = FALSE,
#     height = 10,
#     width = 15,
#     dpi = 300
# )

## ----fig.width=6, fig.height=4, echo = FALSE, fig.align="center",hide=TRUE, message=FALSE,warning=FALSE----
library(png)
library(grid)
img <- readPNG("figure5star.png")
grid.raster(img)

## ----eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE-------------------------
# library(TCGAbiolinks)
# library(SummarizedExperiment)
# library(ELMER)
# library(parallel)
# dir.create("case4")
# setwd("case4")
# #-----------------------------------
# # STEP 1: Search, download, prepare |
# #-----------------------------------
# # 1.1 - DNA methylation
# # ----------------------------------
# query.met <- GDCquery(
#     project = "TCGA-KIRC",
#     data.category = "DNA Methylation",
#     data.type = "Methylation Beta Value",
#     platform = "Illumina Human Methylation 450"
# )
# GDCdownload(query.met)
# kirc.met <- GDCprepare(
#     query = query.met,
#     save = TRUE,
#     save.filename = "kircDNAmet.rda",
#     summarizedExperiment = TRUE
# )

## ----eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE-------------------------
# # Step 1.2 download expression data
# #-----------------------------------
# # 1.2 - RNA expression
# # ----------------------------------
# query.exp <- GDCquery(
#     project = "TCGA-KIRC",
#     data.category = "Transcriptome Profiling",
#     data.type = "Gene Expression Quantification",
#     workflow.type = "STAR - Counts"
# )
# GDCdownload(query.exp,files.per.chunk = 20)
# kirc.exp <- GDCprepare(
#     query = query.exp,
#     save = TRUE,
#     save.filename = "kircExp.rda"
# )

## ----eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE-------------------------
# distal.probes <- get.feature.probe(genome = "hg38", met.platform = "450K")

## ----eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE-------------------------
# library(MultiAssayExperiment)
# mae <- createMAE(
#     exp = kirc.exp,
#     met = kirc.met,
#     save = FALSE,
#     linearize.exp = TRUE,
#     filter.probes = distal.probes,
#     save.filename = "mae_kirc.rda",
#     met.platform = "450K",
#     genome = "hg38",
#     TCGA = TRUE
# )
# # Remove FFPE samples
# mae <- mae[,!mae$is_ffpe]

## ----eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE-------------------------
# group.col <- "definition"
# group1 <-  "Primary Tumor"
# group2 <- "Solid Tissue Normal"
# direction <- "hypo"
# dir.out <- file.path("kirc",direction)
# dir.create(dir.out, recursive = TRUE)
# #--------------------------------------
# # STEP 3: Analysis                     |
# #--------------------------------------
# # Step 3.1: Get diff methylated probes |
# #--------------------------------------
# sig.diff <- get.diff.meth(
#     data = mae,
#     group.col = group.col,
#     group1 =  group1,
#     group2 = group2,
#     minSubgroupFrac = 0.2,
#     sig.dif = 0.3,
#     diff.dir = direction, # Search for hypomethylated probes in group 1
#     cores = 1,
#     dir.out = dir.out,
#     pvalue = 0.01
# )
# 
# #-------------------------------------------------------------
# # Step 3.2: Identify significant probe-gene pairs            |
# #-------------------------------------------------------------
# # Collect nearby 20 genes for Sig.probes
# nearGenes <- GetNearGenes(
#     data = mae,
#     probes = sig.diff$probe,
#     numFlankingGenes = 20, # 10 upstream and 10 dowstream genes
#     cores = 1
# )
# 
# pair <- get.pair(
#     data = mae,
#     group.col = group.col,
#     group1 =  group1,
#     group2 = group2,
#     nearGenes = nearGenes,
#     minSubgroupFrac = 0.4, # % of samples to use in to create groups U/M
#     permu.dir = file.path(dir.out,"permu"),
#     permu.size = 100, # Please set to 100000 to get significant results
#     raw.pvalue  = 0.05,
#     Pe = 0.01, # Please set to 0.001 to get significant results
#     filter.probes = TRUE, # See preAssociationProbeFiltering function
#     filter.percentage = 0.05,
#     filter.portion = 0.3,
#     dir.out = dir.out,
#     cores = 1,
#     label = direction
# )
# 
# # Identify enriched motif for significantly hypomethylated probes which
# # have putative target genes.
# enriched.motif <- get.enriched.motif(
#     data = mae,
#     probes = pair$Probe,
#     dir.out = dir.out,
#     label = direction,
#     min.incidence = 10,
#     lower.OR = 1.1
# )
# 
# TF <- get.TFs(
#     data = mae,
#     group.col = group.col,
#     group1 =  group1,
#     group2 = group2,
#     minSubgroupFrac = 0.4,
#     enriched.motif = enriched.motif,
#     dir.out = dir.out,
#     cores = 1,
#     label = direction
# )

## ----eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE-------------------------
# scatter.plot(
#     data = mae,
#     byProbe = list(probe = sig.diff$probe[1], numFlankingGenes = 20),
#     category = "definition",
#     dir.out = "plots",
#     lm = TRUE, # Draw linear regression curve
#     save = TRUE
# )

## ----fig.width=6, fig.height=4, echo = FALSE, fig.align="center",hide=TRUE, message=FALSE,warning=FALSE----
library(png)
library(grid)
img <- readPNG("case4_elmer.png")
grid.raster(img)

## ----eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE-------------------------
# scatter.plot(
#     data = mae,
#     byTF = list(
#         TF = c("RUNX1","RUNX2","RUNX3"),
#         probe = enriched.motif[[names(enriched.motif)[10]]]
#     ),
#     category = "definition",
#     dir.out = "plots",
#     save = TRUE,
#     lm_line = TRUE
# )

## ----fig.width=6, fig.height=4, echo = FALSE, fig.align="center",hide=TRUE, message=FALSE,warning=FALSE----
library(png)
library(grid)
img <- readPNG("elmer1.png")
grid.raster(img)


## ----eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE-------------------------
# heatmapPairs(
#     data = mae,
#     group.col = "definition",
#     group1 = "Primary Tumor",
#     annotation.col = c("gender"),
#     group2 = "Solid Tissue Normal",
#     pairs = pair,
#     filename =  "heatmap.pdf"
# )

## ----fig.width=6, fig.height=4, echo = FALSE, fig.align="center",hide=TRUE, message=FALSE,warning=FALSE----
library(jpeg)
library(grid)
img <- readJPEG("elmer2.jpg")
grid.raster(img)

## ----fig.width=6, fig.height=4, echo = FALSE, fig.align="center",hide=TRUE, message=FALSE,warning=FALSE----
library(png)
library(grid)
img <- readPNG("elmer3.png")
grid.raster(img)

## ----sessionInfo--------------------------------------------------------------
sessionInfo()

## ----setup, include=FALSE-----------------------------------------------------
knitr::opts_chunk$set(echo = TRUE)
knitr::opts_knit$set(progress = FALSE)

## ----message=FALSE, warning=FALSE, include=FALSE------------------------------
library(TCGAbiolinks)
library(SummarizedExperiment)
library(dplyr)
library(DT)

## ----BCR_Biotab, results='hide', echo=TRUE, message=FALSE, warning=FALSE------
query <- GDCquery(
    project = "TCGA-ACC", 
    data.category = "Clinical",
    data.type = "Clinical Supplement", 
    data.format = "BCR Biotab"
)
GDCdownload(query)
clinical.BCRtab.all <- GDCprepare(query)
names(clinical.BCRtab.all)

## ----echo=TRUE, message=FALSE, warning=FALSE----------------------------------
clinical.BCRtab.all$clinical_drug_acc  %>% 
    head  %>% 
    DT::datatable(options = list(scrollX = TRUE, keys = TRUE))

## ----results = "hide",cache=TRUE, message=FALSE-------------------------------
library(TCGAbiolinks)
query <- GDCquery(
    project = "TCGA-ACC", 
    data.category = "Clinical",
    data.type = "Clinical Supplement", 
    data.format = "BCR Biotab"
)

GDCdownload(query)
clinical_tab_all <- GDCprepare(query)

## -----------------------------------------------------------------------------
# All available tables
names(clinical_tab_all)

# columns from clinical_patient
dplyr::glimpse(clinical_tab_all$clinical_patient_acc)

## ----results = "hide",cache=TRUE, message=FALSE,warning=FALSE-----------------
# Biospecimen BCR Biotab
query_biospecimen <- GDCquery(
    project = "TCGA-ACC", 
    data.category = "Biospecimen",
    data.type = "Biospecimen Supplement", 
    data.format = "BCR Biotab"
)
GDCdownload(query_biospecimen)
biospecimen_tab_all <- GDCprepare(query_biospecimen)

## -----------------------------------------------------------------------------
# All available tables
names(biospecimen_tab_all)

biospecimen_tab_all$biospecimen_sample_acc  %>% 
    head  %>% 
    DT::datatable(options = list(scrollX = TRUE, keys = TRUE))

## ----results='hide', echo=TRUE, message=FALSE, warning=FALSE------------------
clinical <- GDCquery_clinic(project = "TCGA-ACC", type = "clinical")

## ----echo=TRUE, message=FALSE, warning=FALSE----------------------------------
clinical %>%
    head %>% 
    DT::datatable(
        filter = 'top', 
        options = list(scrollX = TRUE, keys = TRUE, pageLength = 5),  
        rownames = FALSE
    )

## ----eval=FALSE,results='hide', echo=TRUE, message=FALSE, warning=FALSE-------
# clinical_beataml <- GDCquery_clinic(
#     project = "BEATAML1.0-COHORT",
#     type = "clinical"
# )
# 
# clinical_cptac2 <- GDCquery_clinic(
#     project = "CPTAC-2",
#     type = "clinical"
# )
# 
# clinical_genie <- GDCquery_clinic(
#     project = "GENIE-MSK",
#     type = "clinical"
# )

## ----results = 'hide',echo=TRUE, message=FALSE, warning=FALSE-----------------
query <- GDCquery(
    project = "TCGA-COAD", 
    data.category = "Clinical", 
    data.format = "bcr xml",
    barcode = c("TCGA-RU-A8FL","TCGA-AA-3972")
)
GDCdownload(query)
clinical <- GDCprepare_clinic(query, clinical.info = "patient")

## ----echo = TRUE, message = FALSE, warning = FALSE----------------------------
clinical %>% 
    datatable(filter = 'top', 
              options = list(scrollX = TRUE, keys = TRUE, pageLength = 5),  
              rownames = FALSE)

## ----results = 'hide', echo=TRUE, message=FALSE, warning=FALSE----------------
clinical.drug <- GDCprepare_clinic(query, clinical.info = "drug")

## ----echo = TRUE, message = FALSE, warning = FALSE----------------------------
clinical.drug %>% 
    datatable(filter = 'top', 
              options = list(scrollX = TRUE, keys = TRUE, pageLength = 5),  
              rownames = FALSE)

## ----results = 'hide', echo=TRUE, message=FALSE, warning=FALSE----------------
clinical.radiation <- GDCprepare_clinic(query, clinical.info = "radiation")

## ----echo = TRUE, message = FALSE, warning = FALSE----------------------------
clinical.radiation %>% 
    datatable(filter = 'top', 
              options = list(scrollX = TRUE, keys = TRUE, pageLength = 5),  
              rownames = FALSE)

## ----results = 'hide', echo=TRUE, message=FALSE, warning=FALSE----------------
clinical.admin <- GDCprepare_clinic(query, clinical.info = "admin")

## ----echo = TRUE, message = FALSE, warning = FALSE----------------------------
clinical.admin %>% 
    datatable(filter = 'top', 
              options = list(scrollX = TRUE, keys = TRUE, pageLength = 5),  
              rownames = FALSE)

## ----results = 'hide', echo=TRUE, message=FALSE, warning=FALSE----------------
# Pathology report from harmonized portal 
query_harmonized <- GDCquery(
    project = "TCGA-COAD", 
    data.category = "Biospecimen", 
    data.type = "Slide Image",
    experimental.strategy = "Diagnostic Slide",
    barcode = c("TCGA-RU-A8FL","TCGA-AA-3972")
)  

## ----echo=TRUE, message=FALSE, warning=FALSE----------------------------------
query_harmonized  %>% 
    getResults %>% 
    head  %>% 
    DT::datatable(options = list(scrollX = TRUE, keys = TRUE))

## ----eval = TRUE--------------------------------------------------------------
bar <- c(
    "TCGA-G9-6378-02A-11R-1789-07", "TCGA-CH-5767-04A-11R-1789-07",  
    "TCGA-G9-6332-60A-11R-1789-07", "TCGA-G9-6336-01A-11R-1789-07",
    "TCGA-G9-6336-11A-11R-1789-07", "TCGA-G9-7336-11A-11R-1789-07",
    "TCGA-G9-7336-04A-11R-1789-07", "TCGA-G9-7336-14A-11R-1789-07",
    "TCGA-G9-7036-04A-11R-1789-07", "TCGA-G9-7036-02A-11R-1789-07",
    "TCGA-G9-7036-11A-11R-1789-07", "TCGA-G9-7036-03A-11R-1789-07",
    "TCGA-G9-7036-10A-11R-1789-07", "TCGA-BH-A1ES-10A-11R-1789-07",
    "TCGA-BH-A1F0-10A-11R-1789-07", "TCGA-BH-A0BZ-02A-11R-1789-07",
    "TCGA-B6-A0WY-04A-11R-1789-07", "TCGA-BH-A1FG-04A-11R-1789-08",
    "TCGA-D8-A1JS-04A-11R-2089-08", "TCGA-AN-A0FN-11A-11R-8789-08",
    "TCGA-AR-A2LQ-12A-11R-8799-08", "TCGA-AR-A2LH-03A-11R-1789-07",
    "TCGA-BH-A1F8-04A-11R-5789-07", "TCGA-AR-A24T-04A-55R-1789-07",
    "TCGA-AO-A0J5-05A-11R-1789-07", "TCGA-BH-A0B4-11A-12R-1789-07",
    "TCGA-B6-A1KN-60A-13R-1789-07", "TCGA-AO-A0J5-01A-11R-1789-07",
    "TCGA-AO-A0J5-01A-11R-1789-07", "TCGA-G9-6336-11A-11R-1789-07",
    "TCGA-G9-6380-11A-11R-1789-07", "TCGA-G9-6380-01A-11R-1789-07",
    "TCGA-G9-6340-01A-11R-1789-07", "TCGA-G9-6340-11A-11R-1789-07"
)

S <- TCGAquery_SampleTypes(bar,"TP")
S2 <- TCGAquery_SampleTypes(bar,"NB")

# Retrieve multiple tissue types  NOT FROM THE SAME PATIENTS
SS <- TCGAquery_SampleTypes(bar,c("TP","NB"))

# Retrieve multiple tissue types  FROM THE SAME PATIENTS
SSS <- TCGAquery_MatchedCoupledSampleTypes(bar,c("NT","TP"))

## ----eval = FALSE-------------------------------------------------------------
# # This code will get all clinical indexed data from TCGA
# library(data.table)
# library(dplyr)
# library(regexPipes)
# clinical <- TCGAbiolinks:::getGDCprojects()$project_id %>%
#     regexPipes::grep("TCGA",value = TRUE) %>%
#     sort %>%
#     plyr::alply(1,GDCquery_clinic, .progress = "text") %>%
#     rbindlist
# readr::write_csv(clinical,path = paste0("all_clin_indexed.csv"))
# 
# # This code will get all clinical XML data from TCGA
# getclinical <- function(proj){
#     message(proj)
#     while(1){
#         result = tryCatch({
#             query <- GDCquery(project = proj, data.category = "Clinical",data.format = "bcr xml")
#             GDCdownload(query)
#             clinical <- GDCprepare_clinic(query, clinical.info = "patient")
#             for(i in c("admin","radiation","follow_up","drug","new_tumor_event")){
#                 message(i)
#                 aux <- GDCprepare_clinic(query, clinical.info = i)
#                 if(is.null(aux) || nrow(aux) == 0) next
#                 # add suffix manually if it already exists
#                 replicated <- which(grep("bcr_patient_barcode",colnames(aux), value = T,invert = T) %in% colnames(clinical))
#                 colnames(aux)[replicated] <- paste0(colnames(aux)[replicated],".",i)
#                 if(!is.null(aux)) clinical <- merge(clinical,aux,by = "bcr_patient_barcode", all = TRUE)
#             }
#             readr::write_csv(clinical,path = paste0(proj,"_clinical_from_XML.csv")) # Save the clinical data into a csv file
#             return(clinical)
#         }, error = function(e) {
#             message(paste0("Error clinical: ", proj))
#         })
#     }
# }
# clinical <- TCGAbiolinks:::getGDCprojects()$project_id %>%
#     regexPipes::grep("TCGA",value=T) %>% sort %>%
#     plyr::alply(1,getclinical, .progress = "text") %>%
#     rbindlist(fill = TRUE) %>% setDF %>% subset(!duplicated(clinical))
# 
# readr::write_csv(clinical,path = "all_clin_XML.csv")
# # result: https://drive.google.com/open?id=0B0-8N2fjttG-WWxSVE5MSGpva1U
# # Obs: this table has multiple lines for each patient, as the patient might have several followups, drug treatments,
# # new tumor events etc...

#' Clinical data TCGA BRCA
#' @docType data
#' @keywords internal
#' @name clinBRCA
#' @format A data frame with 1061 rows and 109 variables
NULL

#' tabSurvKMcompleteDEGs
#' @docType data
#' @keywords internal
#' @name tabSurvKMcompleteDEGs
#' @format A data frame with 200 rows and 7 variables
NULL



#' TCGA data matrix BRCA
#' @docType data
#' @keywords internal
#' @name dataBRCA
#' @format A data frame with 20531 rows (genes) and 50 variables (samples)
NULL

#' TCGA data SummarizedExperiment READ
#' @docType data
#' @keywords internal
#' @name dataREAD
#' @format A SummarizedExperiment of READ with 2 samples
NULL

#' TCGA data matrix READ
#' @docType data
#' @keywords internal
#' @name dataREAD_df
#' @format A data frame with 20531 rows (genes) and 2 variables (samples)
NULL

#' TCGA data matrix BRCA DEGs
#' @docType data
#' @keywords internal
#' @name dataDEGsFiltLevel
#' @format A data frame with 3649 rows and 6 variables
NULL

#' geneInfo for normalization of RNAseq data
#' @docType data
#' @keywords internal
#' @name geneInfo
#' @format A data frame with 20531 rows and 2 variables
NULL

#' geneInfoHT for normalization of HTseq data
#' @description
#' Code to generate the data in examples
#' @examples
#' \dontrun{
#' library(EDASeq)
#' library(biomaRt)
#' #get ensembl gene IDs for hg38
#' ensembl <- useMart("ensembl", dataset = "hsapiens_gene_ensembl")
#' biomart_getID <- getBM(attributes = c("ensembl_gene_id"), mart = ensembl)
#' #get gene length and GC content for all IDs
#'
#' step <- 500
#' geneInfoHT <- plyr::adply(seq(1,length(biomart_getID$ensembl_gene_id),step),.margins = 1,.fun = function(x){
#'     begin <- x
#'    end <- x + step
#'     if(end > length(biomart_getID$ensembl_gene_id)) end <- length(biomart_getID$ensembl_gene_id)
#'     file <- paste0("geneInfoHT_from_",begin,"_to_",end,".rda")
#'     if(!file.exists(file)){
#'         df <- getGeneLengthAndGCContent(biomart_getID$ensembl_gene_id[begin:end] , org="hsa", mode = c("biomart"))
#'         save(df,file = file)
#'     } else {
#'         df <- get(load(file))
#'     }
#'     df
#' },.progress = "time")
#' saveRDS(getdata, file = "getGLGC_download.RDS")a
#' save(getdata, file = "getGLGC_download.rda")
#' #Save output as data frame with correct header names
#' geneInfoHT <- data.frame(
#'     geneLength = getdata[,1] ,
#'     gcContent = getdata[,2]
#' )
#' #Save final table
#' save(geneInfoHT, file = "data/geneInfoHT.rda")
#' }
#' @docType data
#' @keywords internal
#' @name geneInfoHT
#' @format A data frame with 23486 rows and 2 variables
NULL

#' TCGA batch information from Biospecimen Metadata Browser
#' @docType data
#' @keywords internal
#' @name batch.info
#' @format A data frame with 11382 rows and 3 variables
NULL

#' TCGA CHOL MAF transformed to maftools object
#' @docType data
#' @keywords internal
#' @name chol_maf
#' @format An object of class  MAF
NULL

#' TCGA CHOL MAF
#' @docType data
#' @keywords internal
#' @name bcgsc.ca_CHOL.IlluminaHiSeq_DNASeq.1.somatic.maf
#' @format A tibble: 3,555 x 34
NULL

#' MSI data for two samples
#' @docType data
#' @keywords internal
#' @name msi_results
#' @format A data frame: 2 rows, 4 columns
NULL

#' A RangedSummarizedExperiment two samples with gene expression data from vignette
#' aligned against hg38
#' @docType data
#' @keywords internal
#' @name gbm.exp.harmonized
#' @format A RangedSummarizedExperiment: 56963 genes, 2 samples
NULL

#' A RangedSummarizedExperiment two samples with gene expression data from vignette
#' aligned against hg19
#' @docType data
#' @keywords internal
#' @name gbm.exp.legacy
#' @format A RangedSummarizedExperiment: 21022 genes, 2 samples
NULL

#' A DNA methylation RangedSummarizedExperiment for 8 samples (only first 20 probes)
#' aligned against hg19
#' @docType data
#' @keywords internal
#' @name met.gbm.27k
#' @format A RangedSummarizedExperiment: 20 probes, 8 samples
NULL

#' A list of data frames with clinical data parsed from XML (code in vignettes)
#' @docType data
#' @keywords internal
#' @name clinical.biotab
#' @format A list with 7 elements
NULL

#' A data frame with all TCGA molecular subtypes
#' @docType data
#' @keywords internal
#' @name pancan2018
#' @format A data frame with 7,734 lines and 10 columns
NULL

#' A numeric vector with stem cell-like signature trained on PCBC's dataset
#' @docType data
#' @keywords internal
#' @name SC_PCBC_stemSig
#' @format A numeric vector with 12956 genes
NULL

#' A numeric vector with SC-derived mesoderm (MESO) signature trained on PCBC's dataset
#' @docType data
#' @keywords internal
#' @name MESO_PCBC_stemSig
#' @format A numeric vector with 12956 genes
NULL


#' A numeric vector with SC-derived ectoderm (ECTO) signature trained on PCBC's dataset
#' @docType data
#' @keywords internal
#' @name ECTO_PCBC_stemSig
#' @format A numeric vector with 12956 genes
NULL


#' A numeric vector with SC-derived definitive endoderm (DE) signature trained on PCBC's dataset
#' @docType data
#' @keywords internal
#' @name DE_PCBC_stemSig
#' @format A numeric vector with 12956 genes
NULL

#' A numeric vector with stem cell (SC)-derived embryoid bodies (EB) signature trained on PCBC's dataset
#' @docType data
#' @keywords internal
#' @name EB_PCBC_stemSig
#' @format A numeric vector with 12956 genes
NULL

#' Result of gliomaclassifier function
#' @docType data
#' @keywords internal
#' @name classification
#' @format A list of data frames
NULL

## ----setup, include=FALSE-----------------------------------------------------
knitr::opts_chunk$set(echo = TRUE)
knitr::opts_knit$set(progress = FALSE)

## ---- eval = FALSE------------------------------------------------------------
#  if (!requireNamespace("BiocManager", quietly=TRUE))
#      install.packages("BiocManager")
#  BiocManager::install("TCGAbiolinksGUI", dependencies = TRUE)

## ---- eval = FALSE------------------------------------------------------------
#  if (!requireNamespace("BiocManager", quietly=TRUE))
#      install.packages("BiocManager")
#  devtools::install_github("BioinformaticsFMRP/TCGAbiolinksGUI.data",ref = "R_3.4")
#  devtools::install_github("BioinformaticsFMRP/TCGAbiolinksGUI")

## ---- eval = FALSE------------------------------------------------------------
#  library(TCGAbiolinksGUI)
#  TCGAbiolinksGUI()

## ----setup, include=FALSE-----------------------------------------------------
knitr::opts_chunk$set(echo = TRUE)
knitr::opts_knit$set(progress = FALSE)

## ----libs, message=FALSE, warning=FALSE, include=FALSE------------------------
library(TCGAbiolinks)
library(SummarizedExperiment)
library(dplyr)
library(DT)

## ----eval = TRUE, echo = FALSE------------------------------------------------
datatable(
    TCGAbiolinks:::getGDCprojects(),
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 10), 
    rownames = FALSE,
    caption = "List of projects"
)

## ----eval = TRUE, echo = FALSE------------------------------------------------
datatable(
    TCGAbiolinks:::getBarcodeDefinition(),
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 10), 
    rownames = FALSE,
    caption = "List sample types"
)

## ----Harmonized_data_options, echo=FALSE--------------------------------------
datatable(
    readr::read_csv("https://docs.google.com/spreadsheets/d/1f98kFdj9mxVDc1dv4xTZdx8iWgUiDYO-qiFJINvmTZs/export?format=csv&gid=2046985454",col_types = readr::cols()),
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 40), 
    rownames = FALSE
)

## ----message=FALSE, warning=FALSE---------------------------------------------
query <- GDCquery(
    project = c("TCGA-GBM", "TCGA-LGG"),
    data.category = "DNA Methylation",
    platform = c("Illumina Human Methylation 450"),
    sample.type = "Recurrent Tumor"
)
datatable(
    getResults(query), 
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
    rownames = FALSE
)

## ----message=FALSE, warning = FALSE, eval = FALSE-----------------------------
# query_met <- GDCquery(
#     project = "TCGA-COAD",
#     data.category = "DNA Methylation",
#     platform = c("Illumina Human Methylation 450")
# )
# query_exp <- GDCquery(
#     project = "TCGA-COAD",
#     data.category = "Transcriptome Profiling",
#     data.type = "Gene Expression Quantification",
#     workflow.type = "STAR - Counts"
# )
# 
# # Get all patients that have DNA methylation and gene expression.
# common.patients <- intersect(
#     substr(getResults(query_met, cols = "cases"), 1, 12),
#     substr(getResults(query_exp, cols = "cases"), 1, 12)
# )
# 
# # Only select the first 5 patients
# query_met <- GDCquery(
#     project = "TCGA-COAD",
#     data.category = "DNA Methylation",
#     platform = c("Illumina Human Methylation 450"),
#     barcode = common.patients[1:5]
# )
# 
# query_exp <- GDCquery(
#     project = "TCGA-COAD",
#     data.category = "Transcriptome Profiling",
#     data.type = "Gene Expression Quantification",
#     workflow.type = "STAR - Counts",
#     barcode = common.patients[1:5]
# )

## ----results_matched, message=FALSE, warning=FALSE, eval = FALSE--------------
# datatable(
#     getResults(query_met, cols = c("data_type","cases")),
#     filter = 'top',
#     options = list(scrollX = TRUE, keys = TRUE, pageLength = 5),
#     rownames = FALSE
# )
# datatable(
#     getResults(query_exp, cols = c("data_type","cases")),
#     filter = 'top',
#     options = list(scrollX = TRUE, keys = TRUE, pageLength = 5),
#     rownames = FALSE
# )

## ----queries,message=FALSE, warning=FALSE-------------------------------------
query <- GDCquery(
    project = "TCGA-ACC", 
    data.category = "Sequencing Reads",
    data.type = "Aligned Reads", 
    data.format = "bam",
    workflow.type = "STAR 2-Pass Transcriptome"
)
# Only first 10 to make render faster
datatable(
    getResults(query, rows = 1:10,cols = c("file_name","cases")), 
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
    rownames = FALSE
)

query <- GDCquery(
    project = "TCGA-ACC", 
    data.category = "Sequencing Reads",
    data.type = "Aligned Reads", 
    data.format = "bam",
    workflow.type = "STAR 2-Pass Genome"
)
# Only first 10 to make render faster
datatable(
    getResults(query, rows = 1:10,cols = c("file_name","cases")), 
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
    rownames = FALSE
)

query <- GDCquery(
    project = "TCGA-ACC", 
    data.category = "Sequencing Reads",
    data.type = "Aligned Reads", 
    data.format = "bam",
    workflow.type = "STAR 2-Pass Chimeric"
)
# Only first 10 to make render faster
datatable(
    getResults(query, rows = 1:10,cols = c("file_name","cases")), 
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
    rownames = FALSE
)

query <- GDCquery(
    project = "TCGA-ACC", 
    data.category = "Sequencing Reads",
    data.type = "Aligned Reads", 
    data.format = "bam",
    workflow.type = "BWA-aln"
)
# Only first 10 to make render faster
datatable(
    getResults(query, rows = 1:10,cols = c("file_name","cases")), 
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
    rownames = FALSE
)

query <- GDCquery(
    project = "TCGA-ACC", 
    data.category = "Sequencing Reads",
    data.type = "Aligned Reads", 
    data.format = "bam",
    workflow.type = "BWA with Mark Duplicates and BQSR"
)
# Only first 10 to make render faster
datatable(
    getResults(query, rows = 1:10,cols = c("file_name","cases")), 
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
    rownames = FALSE
)

## ----get_manifest, message = FALSE, warning = FALSE---------------------------
getManifest(query, save = FALSE) 

## ----message=FALSE, warning=FALSE---------------------------------------------
datatable(
    getResults(TCGAbiolinks:::GDCquery_ATAC_seq())[,c("file_name","file_size")], 
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
    rownames = FALSE
)

## ----GDCquery_ATAC_seq, message=FALSE, warning=FALSE,eval = FALSE-------------
# query <- TCGAbiolinks:::GDCquery_ATAC_seq(file.type = "rds")
# GDCdownload(query, method = "client")
# 
# query <- TCGAbiolinks:::GDCquery_ATAC_seq(file.type = "bigWigs")
# GDCdownload(query, method = "client")

## ----getSampleFilesSummary, message=FALSE, warning=FALSE,eval = TRUE----------
tab <-  getSampleFilesSummary(project = "TCGA-ACC")
datatable(
    head(tab),
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
    rownames = FALSE
)

---
title: "Compilation of TCGA molecular subtypes"
bibliography: bibliography.bib    
vignette: >
    %\VignetteIndexEntry{6. Compilation of TCGA molecular subtypes}
    %\VignetteEngine{knitr::rmarkdown}
    \usepackage[utf8]{inputenc}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(dpi = 300)
knitr::opts_chunk$set(cache=FALSE)
```

```{r message=FALSE, warning=FALSE, include=FALSE}
library(TCGAbiolinks)
library(SummarizedExperiment)
library(dplyr)
library(DT)
```


TCGAbiolinks retrieved molecular subtypes information from TCGA samples.
The functions `PanCancerAtlas_subtypes` and `TCGAquery_subtype` can be used to get the information tables.

While the `PanCancerAtlas_subtypes` function gives access to a curated table retrieved from synapse (probably with the most updated  molecular subtypes)
the `TCGAquery_subtype` function has the complete table also with sample information retrieved from the TCGA marker papers.

# `PanCancerAtlas_subtypes`: Curated molecular subtypes.

Data and description retrieved from synapse (https://www.synapse.org/#!Synapse:syn8402849)

Synapse has published a single file with all available molecular subtypes that have been described by TCGA (all tumor types and all molecular platforms), which can be accessed using the `PanCancerAtlas_subtypes` function as below:

```{r message=FALSE, warning=FALSE}
subtypes <- PanCancerAtlas_subtypes()
DT::datatable(
    data = subtypes,
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5),
    rownames = FALSE
)
```

The columns "Subtype_Selected" was selected as most prominent subtype classification (from the other columns)

|                                          | All available molecular data based-subtype                    | Selected subtype                                         | Number of samples | Link to file                                                                                                                                           | Reference        | link to paper                                                               |
|------------------------------------------|---------------------------------------------------------------|----------------------------------------------------------|-------------------|--------------------------------------------------------------------------------------------------------------------------------------------------------|------------------|-----------------------------------------------------------------------------|
| ACC                                      | mRNA, DNAmeth, protein, miRNA, CNA, COC, C1A.C1B              | DNAmeth                                                  | 91                | [Link](http://www.cell.com/cms/attachment/2062093088/2063584534/mmc3.xlsx)                                                                                     | Cancer Cell 2016 | [Link](http://www.cell.com/cancer-cell/fulltext/S1535-6108(16)30160-X)              |
| AML                                      | mRNA and miRNA                                                | mRNA                                                     | 187               | [Link](https://tcga-data.nci.nih.gov/docs/publications/laml_2012/TCGA.LAML.cNMF-clustering.20140820.xlsx)                                                      | NEJM 2013        | [Link](http://www.nejm.org/doi/full/10.1056/NEJMoa1301689)                          |
| BLCA                                     | mRNA subtypes                                                 | mRNA                                                     | 129               | [Link](https://tcga-data.nci.nih.gov/docs/publications/blca_2013/BLCA_cluster-assign-k4.tsv)                                                                   | Nature 2014      | [Link](http://www.nature.com/nature/journal/v507/n7492/full/nature12965.html)       |
| BRCA                                     | PAM50 (mRNA)                                                  | PAM50                                                    | 1218              | [Link](https://www.synapse.org/#!Synapse:syn3853594)                                                                                                           | Nature 2012      | [Link](http://www.nature.com/nature/journal/v490/n7418/full/nature11412.html#close) |
| GBM/LGG*                                 | mRNA, DNAmeth, protein, Supervised_DNAmeth                    | Supervised_DNAmeth                                       | 1122              | [Link](http://www.cell.com/cms/attachment/2045372863/2056783242/mmc2.xlsx)                                                                                     | Cell 2016        | [Link](http://www.cell.com/cell/abstract/S0092-8674(15)01692-X)                     |
| Pan-GI (preliminary) ESCA/STAD/COAD/READ |                           Molecular_Subtype                                |        Molecular_Subtype                                                  | 1011              | [Link](https://www.cell.com/cms/10.1016/j.ccell.2018.03.010/attachment/f1963baa-114d-4bb6-9595-0854aec15dbf/mmc2.xlsx)                                                                                                                             | Cancer Cell 2018   |                                           [Link](https://doi.org/10.1016/j.ccell.2018.03.010)                                    |
| HNSC                                     | mRNA, DNAmeth, RPPA, miRNA, CNA, Paradigm                     | mRNA                                                     | 279               | [Link](http://www.nature.com/nature/journal/v517/n7536/extref/nature14129-s2.zip) (TabS7.2)                                                                    | Nature 2015      | [Link](http://www.nature.com/nature/journal/v517/n7536/full/nature14129.html)       |
| KICH                                     | Eosinophilic                                                  | Eosinophilic                                             | 66                | [Link](https://www.synapse.org/#!Synapse:syn4463858)                                                                                                           | Cancer Cell 2014 | [Link](http://www.cell.com/cancer-cell/abstract/S1535-6108(14)00304-3)              |
| KIRC                                     | mRNA, miRNA                                                   | mRNA                                                     | 442               | [Link](http://www.nature.com/nature/journal/v499/n7456/extref/nature12222-s2.zip)                                                                              | Nature 2013      | [Link](http://www.nature.com/nature/journal/v499/n7456/full/nature12222.html)       |
| KIRP                                     | mRNA, DNAmeth, protein, miRNA, CNA, COC                       | COC                                                      | 161               | [Link](http://www.nejm.org/doi/suppl/10.1056/NEJMoa1505917/suppl_file/nejmoa1505917_appendix_3.xlsx)                                                           | NEJM 2015        | [Link](http://www.nejm.org/doi/full/10.1056/NEJMoa1505917#t=article)                |
| LIHC (preliminary)                       | mRNA, DNAmeth, protein, miRNA, CNA, Paradigma, iCluster       | iCluster                                                 | 196               | [Link](https://wiki.nci.nih.gov/download/attachments/139067884/Supplementary%20Tables-1-2016.xlsx?version=1&modificationDate=1452270515000&api=v2) (Table S1A) | not published    |                                                                             |
| LUAD                                     | DNAmeth, iCluster                                             | iCluster                                                 | 230               | [Link](http://www.nature.com/nature/journal/v511/n7511/extref/nature13385-s2.xlsx) (Table S7)                                                                  | Nature 2014      | [Link](http://www.nature.com/nature/journal/v511/n7511/full/nature13385.html)       |
| LUSC                                     | mRNA                                                          | mRNA                                                     | 178               | [Link](http://www.nature.com/nature/journal/v489/n7417/extref/nature11404-s2.zip) (Data file S7.5)                                                             | Nature 2012      | [Link](http://www.nature.com/nature/journal/v489/n7417/full/nature11404.html)       |
| OVCA                                     | mRNA                                                          | mRNA                                                     | 489               | [Link](https://www.synapse.org/#!Synapse:syn4213428)                                                                                                           | Nature 2011      | [Link](http://www.nature.com/nature/journal/v474/n7353/full/nature10166.html)       |
| PCPG                                     | mRNA, DNAmeth, protein, miRNA, CNA                            | mRNA                                                     | 178               | tableS2                                                                                                                                                | Cancer Cell 2017 | [Link](http://www.cell.com/cancer-cell/fulltext/S1535-6108(17)30001-6)              |
| PRAD                                     | mRNA, DNAmeth, protein, miRNA, CNA, icluster, mutation/fusion | mutation/fusion                                          | 333               | [Link](http://www.cell.com/cms/attachment/2062406705/2064289081/mmc2.xls)                                                                                      | Cell 2015        | [Link](http://www.cell.com/cell/abstract/S0092-8674(15)01339-2)                     |
| SKCM                                     | mRNA, DNAmeth, protein, miRNA, mutation                       | mutation                                                 | 331               | [Link](http://www.cell.com/cms/attachment/2048142118/2058244319/mmc2.xlsx) (Table S1D)                                                                         | Cell 2015        | [Link](http://www.cell.com/cell/abstract/S0092-8674(15)00634-0)                     |
| THCA                                     | mRNA, DNAmeth, protein, miRNA, CNA, histology                 | mRNA                                                     | 496               | [Link](http://www.cell.com/cms/attachment/2019646612/2039684990/mmc3.xlsx) (Table S2 - Tab1)                                                                   | Cell 2014        | [Link](http://www.cell.com/cell/fulltext/S0092-8674(14)01238-0#)                    |
| UCEC                                     | iCluster, MSI, CNA, mRNA                                      | iCluster - updated according to Pan-Gyne/Pathways groups | 538               | [Link](http://www.nature.com/nature/journal/v497/n7447/extref/nature12113-s2.zip) (datafile S1.1)                                                              | Nature 2013      | [Link](http://www.nature.com/nature/journal/v497/n7447/full/nature12113.html)       |
|                                          |                                                               |                                                          |                   | [Link](https://docs.google.com/spreadsheets/d/1Z1H3mXdO_sk9nc0v8df7VNS_XzXiu6vKGJRbK1qYoh4/edit#gid=2047911448)                                                |                  |                                                                             |
| UCS (preliminary)                        | mRNA                                                          | mRNA                                                     | 57                | [Link](https://www.synapse.org/#!Synapse:syn4214438)                                                                                                           | not published    |                                                                             |

# `TCGAquery_subtype`: Working with molecular subtypes data.

The Cancer Genome Atlas (TCGA) Research Network has reported integrated genome-wide 
studies of various diseases. We have added some of the subtypes defined by these
report in our package:

| TCGA dataset | Link                                                                 | Paper                                                                                                   | Journal          |
|--------------|----------------------------------------------------------------------|---------------------------------------------------------------------------------------------------------|------------------|
| ACC          | doi:10.1016/j.ccell.2016.04.002                                      | Comprehensive Pan-Genomic Characterization of Adrenocortical Carcinoma.                                 | Cancer cell 2016 |
| BRCA | https://www.cell.com/cancer-cell/fulltext/S1535-6108(18)30119-3  | A Comprehensive Pan-Cancer Molecular Study of Gynecologic and Breast Cancers | Cancer cell 2018 |
| BLCA	| http://www.cell.com/cell/fulltext/S0092-8674(17)31056-5	| Comprehensive Molecular Characterization of Muscle-Invasive Bladder Cancer	Cell 2017 | 
| CHOL	| http://www.sciencedirect.com/science/article/pii/S2211124717302140?via%3Dihub	| Integrative Genomic Analysis of Cholangiocarcinoma Identifies Distinct IDH-Mutant Molecular Profiles |	Cell Reports 2017|
| COAD  | http://www.nature.com/nature/journal/v487/n7407/abs/nature11252.html | Comprehensive molecular characterization of human colon and rectal cancer  | Nature 2012      |
| ESCA  | https://www.nature.com/articles/nature20805 | Integrated genomic characterization of oesophageal carcinoma  | Nature 2017      |
| GBM          | http://dx.doi.org/10.1016/j.cell.2015.12.028                         | Molecular Profiling Reveals Biologically Discrete Subsets and Pathways of Progression in Diffuse Glioma | Cell 2016        |
| HNSC         | http://www.nature.com/nature/journal/v517/n7536/abs/nature14129.html | Comprehensive genomic characterization of head and neck squamous cell carcinomas                        | Nature 2015      |
| KICH         | http://www.sciencedirect.com/science/article/pii/S1535610814003043   | The Somatic Genomic Landscape of Chromophobe Renal Cell Carcinoma                                       | Cancer cell 2014 |
| KIRC         | http://www.nature.com/nature/journal/v499/n7456/abs/nature12222.html | Comprehensive molecular characterization of clear cell renal cell carcinoma                             | Nature 2013      |
| KIRP         | http://www.nejm.org/doi/full/10.1056/NEJMoa1505917                   | Comprehensive Molecular Characterization of Papillary Renal-Cell Carcinoma                              | NEJM 2016        |
| LIHC	| http://linkinghub.elsevier.com/retrieve/pii/S0092-8674(17)30639-6	| Comprehensive and Integrative Genomic Characterization of Hepatocellular Carcinoma |	Cell 2017 | 
| LGG          | http://dx.doi.org/10.1016/j.cell.2015.12.028                         | Molecular Profiling Reveals Biologically Discrete Subsets and Pathways of Progression in Diffuse Glioma | Cell 2016        |
| LUAD         | http://www.nature.com/nature/journal/v511/n7511/abs/nature13385.html | Comprehensive molecular profiling of lung adenocarcinoma                                                | Nature 2014      |
| LUSC         | http://www.nature.com/nature/journal/v489/n7417/abs/nature11404.html | Comprehensive genomic characterization of squamous cell lung cancers                                    | Nature 2012      |
| PAAD	 | http://www.cell.com/cancer-cell/fulltext/S1535-6108(17)30299-4 |	Integrated Genomic Characterization of Pancreatic Ductal Adenocarcinoma |	Cancer Cell 2017 |
| PCPG         | http://dx.doi.org/10.1016/j.ccell.2017.01.001                        | Comprehensive Molecular Characterization of Pheochromocytoma and Paraganglioma                          | Cancer cell 2017 |
| PRAD         | http://www.sciencedirect.com/science/article/pii/S0092867415013392   | The Molecular Taxonomy of Primary Prostate Cancer                                                       | Cell 2015        |
| READ         | http://www.nature.com/nature/journal/v487/n7407/abs/nature11252.html | Comprehensive molecular characterization of human colon and rectal cancer                               | Nature 2012      |
| SARC	| http://www.cell.com/cell/fulltext/S0092-8674(17)31203-5	| Comprehensive and Integrated Genomic Characterization of Adult Soft Tissue Sarcomas	| Cell 2017| 
| SKCM         | http://www.sciencedirect.com/science/article/pii/S0092867415006340   | Genomic Classification of Cutaneous Melanoma                                                            | Cell 2015        |
| STAD         | http://www.nature.com/nature/journal/v511/n7511/abs/nature13385.html | Comprehensive molecular characterization of gastric adenocarcinoma                                      | Nature 2013      |
| THCA         | http://www.sciencedirect.com/science/article/pii/S0092867414012380   | Integrated Genomic Characterization of Papillary Thyroid Carcinoma                                      | Cell 2014        |
| UCEC         | http://www.nature.com/nature/journal/v497/n7447/abs/nature12113.html | Integrated genomic characterization of endometrial carcinoma                                            | Nature 2013      |
| UCS	| http://www.cell.com/cancer-cell/fulltext/S1535-6108(17)30053-3 | 	Integrated Molecular Characterization of Uterine Carcinosarcoma	Cancer |  Cell 2017 | 
| UVM	| http://www.cell.com/cancer-cell/fulltext/S1535-6108(17)30295-7 |	Integrative Analysis Identifies Four Molecular and Clinical Subsets in Uveal Melanoma	| Cancer Cell 2017 |	

These subtypes will be automatically added in the summarizedExperiment
object through GDCprepare. But you can also use the `TCGAquery_subtype` function
to retrieve this information.

```{r, eval = TRUE}
lgg.gbm.subtype <- TCGAquery_subtype(tumor = "lgg")
```

A subset of the LGG subytpe is shown below:
```{r, eval = TRUE, echo = FALSE}
datatable(
    lgg.gbm.subtype[1:10,],
    caption = "Table with LGG molecular subtypes from TCGAquery_subtype",
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
    rownames = FALSE
)
```


# Session Information
******
```{r sessionInfo}
sessionInfo()
```

---
title: "Stemness score"
bibliography: bibliography.bib    
vignette: >
    %\VignetteIndexEntry{11. Stemness score}
    %\VignetteEngine{knitr::rmarkdown}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(dpi = 300)
knitr::opts_chunk$set(cache = FALSE)
```


```{r, echo = FALSE,hide=TRUE, message=FALSE,warning=FALSE}
library(TCGAbiolinks)
```

```{r message=FALSE, warning=FALSE, include=FALSE}
library(SummarizedExperiment)
library(dplyr)
library(DT)
```

<br>

## Calculate stemness score with `TCGAanalyze_Stemness`
<hr>

If you use this function please also cite: 

**Malta TM, Sokolov A, Gentles AJ, et al. Machine Learning Identifies Stemness Features Associated with Oncogenic Dedifferentiation. Cell. 2018;173(2):338-354.e15.** (doi:10.1016/j.cell.2018.03.034)


## Data
<hr>

The input data are:
- a matrix (samples as columns, Gene names as rows) 
- the signature to calculate the correlation score.

Possible scores are: 

- SC_PCBC_stemSig - Stemness Score
- DE_PCBC_stemSig - endoderm score
- EB_PCBC_stemSig -  embryoid bodies score
- ECTO_PCBC_stemSig - ectoderm score
-  MESO_PCBC_stemSig - mesoderm score

# Function 
```{r, eval = TRUE, message = FALSE, results = "hide"}
# Selecting TCGA breast cancer (10 samples) for example stored in dataBRCA
dataNorm <- TCGAanalyze_Normalization(
    tabDF = dataBRCA, 
    geneInfo =  geneInfo
)

# quantile filter of genes
dataFilt <- TCGAanalyze_Filtering(
  tabDF = dataNorm,
  method = "quantile",
  qnt.cut =  0.25
)

data(SC_PCBC_stemSig)
Stemness_score <- TCGAanalyze_Stemness(
  stemSig = SC_PCBC_stemSig,
  dataGE = dataFilt
)
data(ECTO_PCBC_stemSig)
ECTO_score <- TCGAanalyze_Stemness(
  stemSig = ECTO_PCBC_stemSig,
  dataGE = dataFilt,
  colname.score = "ECTO_PCBC_stem_score"
)

data(MESO_PCBC_stemSig)
MESO_score <- TCGAanalyze_Stemness(
  stemSig = MESO_PCBC_stemSig,
  dataGE = dataFilt,
  colname.score = "MESO_PCBC_stem_score"
)
```

# Output
```{r, eval = T}
head(Stemness_score)
head(ECTO_score)
head(MESO_score)
```

---
title: "TCGAbiolinks version bump with new functions"
author: "Mohamed Mounir"
date: "`r BiocStyle::doc_date()`"
vignette: >
    %\VignetteIndexEntry{"10. TCGAbiolinks_Extension"}
    %\VignetteBuilder: knitr
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}
    %\VignetteEncoding{UTF-8}
output: html_document
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(dpi = 300)
knitr::opts_chunk$set(cache=FALSE)
knitr::opts_chunk$set(echo = TRUE)
```

<div class="panel panel-info">
<div class="panel-heading">New functionalities: TCGAbiolinks version bump</div>
<div class="panel-body">

**TCGAbiolinks** is providing functions to query and download TARGET data and also get SummarizedExperiments objects ready to use for downstream analysis. Moreover, a new design has been suggested for function **TCGAanalyze_DEA** to allow more user customization and support of **limma** pipeline

```{r message=FALSE, warning=FALSE, include=FALSE}
library(TCGAbiolinks)
library(SummarizedExperiment)
#library(dplyr)
#library(DT)
```

</div>
</div>


## Support of Therapeutically Applicable Research To Generate Effective Treatments (TARGET) data:

TARGET applies a comprehensive genomic approach to determine molecular changes that drive childhood cancers. Investigators form a collaborative network to facilitate discovery of molecular targets and translate those findings into the clinic. TARGET is managed by NCI's Office of Cancer Genomics and Cancer Therapy Evaluation Program.

###  Querying, downloading, and preparing TARGET data:

Below is an example to run to query, download, and prepare data from the TARGET initiative through **tcgabiolinks** package:

Available TARGET projects: 
```{r, echo=TRUE, warning=FALSE, eval=TRUE}
projects <- getGDCprojects()$project_id
as.data.frame(grep("TARGET", projects,value = TRUE))
```


```{r, echo=TRUE, results='hide', message=FALSE, warning=FALSE, eval=FALSE}
#Downloading and prepare TARGET CASE
query_Target <- GDCquery(project = "TARGET-AML", 
                         data.category = "Transcriptome Profiling", 
                         data.type = "Gene Expression Quantification", 
                         workflow.type = "HTSeq - Counts")

samplesDown_Target <- getResults(query_Target, cols = c("cases"))

dataSmTB_Target <- TCGAquery_SampleTypes(barcode = samplesDown_Target,
                                         typesample = "TB")

dataSmNB_Target <- TCGAquery_SampleTypes(barcode = samplesDown_Target,
                                         typesample = "TBM")
dataSmTB_short_Target <- dataSmTB_Target[1:10]
dataSmNB_short_Target <- dataSmNB_Target[1:10]

queryDown_Target <- GDCquery(project = "TARGET-AML", 
                             data.category = "Transcriptome Profiling",
                             data.type = "Gene Expression Quantification", 
                             workflow.type = "HTSeq - Counts", 
                             barcode = c(dataSmTB_short_Target, dataSmNB_short_Target))

GDCdownload(queryDown_Target)

### SummarizedExperiment = TRUE
data <- GDCprepare(queryDown_Target)

dataPrep_Target <- TCGAanalyze_Preprocessing(object = data, 
                                             cor.cut = 0.6,
                                             datatype = "HTSeq - Counts")                      

dataNorm_Target <- TCGAanalyze_Normalization(tabDF = dataPrep_Target,
                                             geneInfo = geneInfoHT,
                                             method = "gcContent") 

boxplot(dataPrep_Target, outline = FALSE)

boxplot(dataNorm_Target, outline = FALSE)

dataFilt_Target <- TCGAanalyze_Filtering(tabDF = dataNorm_Target,
                                         method = "quantile", 
                                         qnt.cut =  0.25)   
```


## Preparing BRCA data for downstream analysis: Differential Expression Analysis

```{r, echo=TRUE, results='hide', message=FALSE, warning=FALSE, eval=FALSE}
CancerProject <- "TCGA-BRCA"
DataDirectory <- paste0("../GDC/",gsub("-","_",CancerProject))
FileNameData <- paste0(DataDirectory, "_","HTSeq_Counts",".rda")

query <- GDCquery(project = CancerProject,
                  data.category = "Transcriptome Profiling",
                  data.type = "Gene Expression Quantification", 
                  workflow.type = "HTSeq - Counts")

samplesDown <- getResults(query,cols = c("cases"))

dataSmTP <- TCGAquery_SampleTypes(barcode = samplesDown,
                                  typesample = "TP")

dataSmNT <- TCGAquery_SampleTypes(barcode = samplesDown,
                                  typesample = "NT")
dataSmTP_short <- dataSmTP[1:10]
dataSmNT_short <- dataSmNT[1:10]

queryDown <- GDCquery(project = CancerProject, 
                      data.category = "Transcriptome Profiling",
                      data.type = "Gene Expression Quantification", 
                      workflow.type = "HTSeq - Counts", 
                      barcode = c(dataSmTP_short, dataSmNT_short))

GDCdownload(query = queryDown)

dataPrep1 <- GDCprepare(query = queryDown, 
                        save = TRUE, 
                        save.filename = "TCGA_BRCA_HTSeq_Countds.rda")

dataPrep <- TCGAanalyze_Preprocessing(object = dataPrep1, 
                                      cor.cut = 0.6,
                                      datatype = "HTSeq - Counts")


dataNorm <- TCGAanalyze_Normalization(tabDF = dataPrep,
                                      geneInfo = geneInfoHT,
                                      method = "gcContent")
dataNorm <- TCGAanalyze_Normalization(tabDF = dataPrep,
                                      geneInfo = geneInfoHT,
                                      method = "geneLength")

dataFilt <- TCGAanalyze_Filtering(tabDF = dataNorm,
                                  method = "quantile", 
                                  qnt.cut =  0.25)
```


## UseRaw_afterFilter: Keep raw counts after filtering

After applying filtering and normalization steps, this function reassigns raw counts to the filtered data frame of genesXsamples. This step could be useful for methods requiring to work with raw counts only (i.e edgeR pipeline) Arguments are:


* **DataPrep**: DataPrep object returned by GDCprepare()
* **Filtered**: data frame containing samples in columns and genes in rows after normalization and filtering steps


```{r, echo=TRUE, results='hide', message=FALSE, warning=FALSE, eval=FALSE}
### dataframe will have genes from dataFilt but raw counts from dataPrep
dataPrep_raw <- UseRaw_afterFilter(dataPrep, dataFilt)
```


## TCGA_MolecularSubtype: Query subtypes for cancer data:

This function takes a vector of TCGA barcodes as an input and returns a 2 elements list.

* **filtered**	vector of TCGA barcodes with no available subtype information.
* **Condtypes**	a dataframe with columns as the following: **samples**, **subtype**, **color**, **barcodes**.

--If more data is needed, please check *TabSubtypesCol_merged* data frame available in the package data. 

```{r, echo=TRUE, results='hide', message=FALSE, warning=FALSE, eval=FALSE}
##use previously fetched BRCA data:
Pam50.subtypes<-TCGA_MolecularSubtype(colnames(dataFilt))
```


## Differential expression analysis with TCGAanalyze_DEA():

**TCGAbiolinks** is providing a new design for the TCGAanalyze_DEA() function to perform differential expression analysis (DEA) either contrasting two groups or multiple sets by providing a formula for contrast. **Limma** pipeline was also added on top of the previously implemented one in **EdgeR**.

The function takes the following arguments for the version bump:

* **mat1**	numeric matrix, each row represents a gene, each column represents a sample with Cond1type
* **mat2**	numeric matrix, each row represents a gene, each column represents a sample with Cond2type
* **Cond1type**	a string containing the class label of the samples in mat1 (e.g., control group)
* **Cond2type**	a string containing the class label of the samples in mat2 (e.g., case group)
* **pipeline**	a string to specify which package to use ("limma" or "edgeR")
* **method**	is 'glmLRT' (1) or 'exactTest' (2) used for edgeR (1) Fit a negative binomial generalized log-linear model to the read counts for each gene (2) Compute genewise exact tests for differences in the means between two groups of negative-binomially distributed counts.
* **fdr.cu**t	is a threshold to filter DEGs according their p-value corrected
* **logFC.cut**	is a threshold to filter DEGs according their logFC elementsRatio	is number of elements processed for second for time consumation estimation
* **batch.factors**	a vector containing strings to specify options for batch correction. Options are "Plate", "TSS", "Year", "Portion", "Center", "Patients" and they are accounted for in the design matrix
* **ClinicalDF**	a dataframe returned by GDCquery_clinic() to be used as input to extract "Year" data for batch correction (blocking)
* **paired**	boolean to account for paired or non-paired samples. Set to TRUE for paired case
* **log.trans**	boolean to perform log cpm transformation. Set to TRUE for log transformation
* **voom** boolean to voom transform data. Set to true to apply transformation
* **trend**	boolean to perform limma-trend pipeline. Set to TRUE to go through limma-trend
* **MAT**	matrix containing expression set as all samples in columns and genes as rows. Do not provide if mat1 and mat2 are used
* **contrast.formula**	string input to determine coefficients and to design contrasts in a customized way
* **Condtypes**	vector of grouping for samples in MAT

###  Limma pipeline

This example will perform differential expression analysis between control and case groups matrices downloaded through tcgabiolinks from GDC portal. Other pipeline option could be **edgeR**.

```{r, echo=TRUE, results='hide', message=FALSE, warning=FALSE, eval=FALSE}
dataDEGs <- TCGAanalyze_DEA(mat1 = dataFilt[,dataSmTP_short],
                            mat2 = dataFilt[,dataSmNT_short],
                            pipeline="limma",
                            Cond1type = "Normal",
                            Cond2type = "Tumor",
                            fdr.cut = 0.01 ,
                            logFC.cut = 1,
                            method = "glmLRT", ClinicalDF = data.frame())
```

###  Customization of contrast using ---contrast.formula--- argument:

*contrast.formula* argument is a string formula formatted in a way to be used as an input for DEA using limma pipeline. Elements of contrast in the formula should be one of the unique elements in *CondTypes* vector. The example below shows the syntax *contrast.formula* argument should have. We are contrasting here between Pam50 molecular subtypes of some lung cancer samples.
**N.B**: Syntax for the contrast formula should be under this form
*formula<-"contrast1=type1-type2, contrast2=type2-type3, contrast3=type1-(type2+type3)/2,..."

*CondTypes* vector should preferably have no space character in its elements.

```{r, echo=TRUE, results='hide', message=FALSE, warning=FALSE, eval=FALSE}
### ##download and prepare lung data through GDC### ##
query.lung <- GDCquery(project = "TCGA-LUSC",
                       data.category = "Transcriptome Profiling",
                       data.type = "Gene Expression Quantification", 
                       workflow.type = "HTSeq - Counts")

samplesDown.lusc <- getResults(query.lung,cols=c("cases"))

dataSmTP.lusc <- TCGAquery_SampleTypes(barcode = samplesDown.lusc,
                                       typesample = "TP")

dataSmNT.lusc <- TCGAquery_SampleTypes(barcode = samplesDown.lusc,
                                       typesample = "NT")
dataSmTP_short.lusc <- dataSmTP.lusc[1:10]
dataSmNT_short.lusc <- dataSmNT.lusc[1:10]
length(dataSmTP.lusc)


queryDown.lung <- GDCquery(project = "TCGA-LUSC", 
                           data.category = "Transcriptome Profiling",
                           data.type = "Gene Expression Quantification", 
                           workflow.type = "HTSeq - Counts", 
                           barcode = c(dataSmTP.lusc, dataSmNT.lusc))

GDCdownload(query = queryDown.lung)

dataPrep1.tcga <- GDCprepare(query = queryDown.lung, 
                             save = TRUE, 
                             save.filename = "TCGA_LUSC_HTSeq_Countds.rda")
dataPrep.tcga <- TCGAanalyze_Preprocessing(object = dataPrep1.tcga, 
                                           cor.cut = 0.6,
                                           datatype = "HTSeq - Counts")

dataNorm.tcga <- TCGAanalyze_Normalization(tabDF = dataPrep.tcga,
                                           geneInfo = geneInfoHT,
                                           method = "gcContent")

dataNorm.tcga <- TCGAanalyze_Normalization(tabDF = dataNorm.tcga,
                                           geneInfo = geneInfoHT,
                                           method = "geneLength")
dataFilt.tcga <- TCGAanalyze_Filtering(tabDF = dataNorm.tcga,
                                       method = "quantile", 
                                       qnt.cut =  0.25)

### #Filtering data so all samples have a pam50 subtype for LUSC

diff<-setdiff(colnames(dataFilt.tcga), TCGA_MolecularSubtype(colnames(dataFilt.tcga))$filtered)
TCGA_MolecularSubtype(diff)$subtypes$barcodes

dataFilt.tcga.lusc<-dataFilt.tcga[,diff]
LUSC.subtypes<-TCGA_MolecularSubtype(colnames(dataFilt.tcga.lusc))$subtypes$subtype

### Differential expression analysis after correcting for "Plate" factor.
DEG.lusc <- TCGAanalyze_DEA(MAT=dataFilt.tcga.lusc,
                            pipeline="limma",
                            batch.factors = c("Plate"),
                            Cond1type = "Normal",
                            Cond2type = "Tumor",
                            fdr.cut = 0.01 ,
                            logFC.cut = 1,
                            method = "glmLRT", ClinicalDF = data.frame(),
                            Condtypes = LUSC.subtypes,
                            contrast.formula = "LUSC.basalvsLUSC.classical=LUSC.basal - LUSC.classical")
```

## TCGAbatch_correction: Handle batch correction and lima-voom transformation

This function calls **ComBat** from **sva** package to handle batch correction, display some plots for exploratory data analysis purposes. More specifically, it shows a plot with black as a kernel estimate of the empirical batch effect density and red as the parametric.

* **tabDF** numeric matrix, each row represents a gene each column represents a sample
* **batch.factor** batch.factor a string containing the batch factor to use for correction Options are "Plate", "TSS", "Year", "Portion", "Center", "Patients". The function accepts only one batch factor at a time
* **adjustment**  vector containing strings for covariate factors to adjust for using ComBat. Options are "Plate", "TSS", "Year", "Portion", "Center", "Patients"
* **ClinicalDF**  a dataframe returned by GDCquery_clinic() to be used to extract year data

On top of data exploration through **ComBat** plots, if no batch factor is provided nothing will be performed. Run the code below to see an example:

```{r, echo=TRUE, results='hide', message=FALSE, warning=FALSE, eval=FALSE}

batch.corrected <- TCGAbatch_Correction(tabDF = dataFilt.tcga, batch.factor = "Plate")

batch.corrected.adjusted <- TCGAbatch_Correction(tabDF = dataFilt.tcga, 
                                                 batch.factor = "Plate", 
                                                 adjustment=c("TSS"))
```

## TCGAbatch_correction: working with unpublished datasets

This function calls **ComBat** from **sva** package to handle batch correction, display some plots for exploratory data analysis purposes. More specifically, it shows a plot with black as a kernel estimate of the empirical batch effect density and red as the parametric.

* **tabDF** numeric matrix, each row represents a gene each column represents a sample
* **UnpublishedData**  if TRUE perform a batch correction after adding new data
* **AnnotationDF**  a dataframe with column Batch indicating different batches of the samples in the tabDF

On top of data exploration through **ComBat** plots, if no batch factor is provided nothing will be performed. Run the code below to see an example:

The following example shows how to consider two cancer type LUAD and LUSC and normal and tumor samples.
The end-user can replace LUSC with unpublished data for example.

```{r, echo=TRUE, results='hide', message=FALSE, warning=FALSE, eval=FALSE}

#dataFilt is a gene expression matrix from pancancer33 RNASeq data that can be generated following our previous described workflow

sampleTP <- TCGAquery_SampleTypes(barcode = colnames(dataFilt), typesample = "TP")
sampleNT <- TCGAquery_SampleTypes(barcode = colnames(dataFilt), typesample = "NT")
dataFiltTP <- dataFilt[,sampleTP]
dataFiltNT <- dataFilt[,sampleNT]
    
dataSubt_LUAD <-TCGAquery_subtype(tumor = "LUAD")
sampleStageI_LUAD <- dataSubt_LUAD[dataSubt_LUAD$Tumor.stage %in% c("Stage I","Stage IA","Stage IB"),]
dataFilt.LUAD.stageI.TP <- dataFiltTP[,substr(colnames(dataFiltTP),1,12) %in% sampleStageI_LUAD$patient]
dataFilt.LUAD.stageI.NT <- dataFiltNT[,substr(colnames(dataFiltNT),1,12) %in% sampleStageI_LUAD$patient]

# here for example the end-user can replace LUSC with unpublished data in a dataframe containing counts.
# and adding the information for LUSC.stageI.TP or LUSC.stageI.NT with unpublished data

dataSubt_LUSC <-TCGAquery_subtype(tumor = "LUSC")
sampleStageI_LUSC <- dataSubt_LUSC[dataSubt_LUSC$T.stage %in% c("T1","T1a","T1b"),]
dataFilt.LUSC.stageI.TP <- dataFiltTP[,substr(colnames(dataFiltTP),1,12) %in% sampleStageI_LUSC$patient]
dataFilt.LUSC.stageI.NT <- dataFiltNT[,substr(colnames(dataFiltNT),1,12) %in% sampleStageI_LUSC$patient]

countsTable <-cbind(dataFilt.LUAD.stageI.TP,dataFilt.LUAD.stageI.NT,
                    dataFilt.LUSC.stageI.TP, dataFilt.LUSC.stageI.NT)

AnnotationCounts <- matrix(0,ncol(countsTable),2)
colnames(AnnotationCounts) <- c("Samples","Batch")
rownames(AnnotationCounts) <- colnames(countsTable)

AnnotationCounts <- as.data.frame(AnnotationCounts)
AnnotationCounts$Samples <- colnames(countsTable)

AnnotationCounts[colnames(dataFilt.LUAD.stageI.TP),"Batch"] <- "LUAD.stageI.TP"
AnnotationCounts[colnames(dataFilt.LUAD.stageI.NT),"Batch"] <- "LUAD.stageI.NT"
AnnotationCounts[colnames(dataFilt.LUSC.stageI.TP),"Batch"] <- "LUSC.stageI.TP"
AnnotationCounts[colnames(dataFilt.LUSC.stageI.NT),"Batch"] <- "LUSC.stageI.NT"

countsCorrected <- TCGAbatch_Correction(tabDF =countsTable,
                                        UnpublishedData = TRUE, 
                                        AnnotationDF = AnnotationCounts)
```




## TCGAtumor_purity: Filter TCGA samples according to tumor purity

Function takes TCGA barcodes as input and filter them according to values specified by user. Default value for all of them is 0. Arguments are estimates using different measures imported from the TCGA consortium, and they are as the following (Refer to *[1]*):

* **estimate**	uses gene expression profiles of 141 immune genes and 141 stromal genes
* **absolute**	which uses somatic copy-number data (estimations were available for only 11 cancer types)
* **lump**	(leukocytes unmethylation for purity), which averages 44 non-methylated immune-specific CpG sites
* **ihc**	as estimated by image analysis of haematoxylin and eosin stain slides produced by the Nationwide Children's Hospital Biospecimen Core Resource
* **cpe**	CPE is a derived consensus measurement as the median purity level after normalizing levels from all methods to give them equal means and standard deviations.

The function returns a list object with "pure_barcodes"" attribute as a vector of pure samples and "filtered"" attribute as filtered samples with no purity info.
--For tumor purity info of all measured TCGA samples, please check *Tumor.purity* data frame available with the package.--

**[1] D. Aran, M. Sirota, and A. J. Butte. Systematic pan-cancer analysis of tumour purity. Nat Commun, 6:8971, 2015.**

```{r, echo=TRUE, results='hide', message=FALSE, warning=FALSE, eval=FALSE}
Purity.BRCA <- TCGAtumor_purity(colnames(dataPrep.tcga), 0, 0, 0, 0, 0.7)
```


## Download GTEx data available through the Recount2 project:

**Recount2** project has made gene count data available for the scientific community to download. Recount2 is an online resource consisting of RNA-seq gene and exon counts as well as coverage bigWig files for 2041 different studies. It is the second generation of the ReCount project. The raw sequencing data were processed with Rail-RNA as described in the recount2 paper. The purpose of this function is to get data processed under one single pipeline to avoid any technical variabilities affecting any downstream integrative analysis. The returned object will be a list with elements named "project_tissue" and as a SummarizedExperiment (SE) of gene counts per sample. This is particularly useful to study batch-free data or to increase the pool of healthy/normal samples.

Arguments are:

* **project**	string input specifying if it is *TCGA* data or *GTEx*.
* **tissue**	vector containing tissue(s) of interest to query.  

```{r, echo=TRUE, results='hide', message=FALSE, warning=FALSE, eval=FALSE}
##Brain data through Recount2

brain.rec <- TCGAquery_recount2(project = "gtex", tissue = "brain")
```

---
title: "Case Studies"
bibliography: bibliography.bib    
vignette: >
    %\VignetteIndexEntry{8. Case Studies}
    %\VignetteEngine{knitr::rmarkdown}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(dpi = 300)
knitr::opts_chunk$set(cache=FALSE)
```

```{r message = FALSE, warning = FALSE, include = FALSE}
library(TCGAbiolinks)
library(SummarizedExperiment)
library(dplyr)
library(DT)
```

# Introduction 

This vignette shows a complete workflow of the TCGAbiolinks package. 
The code is divided in 4 case study:

1. Expression pipeline (BRCA)
2. Expression pipeline (GBM)
3. Integration of DNA methylation and RNA expression pipeline (COAD)
4. ELMER pipeline (KIRC)

# Case study n. 1: Pan Cancer downstream analysis BRCA
```{r,eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE}
library(SummarizedExperiment)
library(TCGAbiolinks)

query.exp <- GDCquery(
    project = "TCGA-BRCA", 
    data.category = "Transcriptome Profiling",
    data.type = "Gene Expression Quantification", 
    workflow.type = "STAR - Counts",
    sample.type = c("Primary Tumor","Solid Tissue Normal")
)
GDCdownload(
    query = query.exp,
    files.per.chunk = 100
)

brca.exp <- GDCprepare(
    query = query.exp, 
    save = TRUE, 
    save.filename = "brcaExp.rda"
)

# get subtype information
infomation.subtype <- TCGAquery_subtype(tumor = "BRCA")

# get clinical data
information.clinical <- GDCquery_clinic(project = "TCGA-BRCA",type = "clinical") 

# Which samples are Primary Tumor
samples.primary.tumour <- brca.exp$barcode[brca.exp$shortLetterCode == "TP"]

# which samples are solid tissue normal
samples.solid.tissue.normal <- brca.exp$barcode[brca.exp$shortLetterCode == "NT"]
```

Using `TCGAnalyze_DEA`, we identified 4,815 differentially expression genes (DEG) (log 
fold change >=1 and FDR < 1%) between 113 normal and 1106 BRCA samples. In 
order to understand the underlying biological process from DEGs we performed an 
enrichment analysis using `TCGAnalyze_EA_complete` function.  

```{r,eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE}
dataPrep <- TCGAanalyze_Preprocessing(
    object = brca.exp, 
    cor.cut = 0.6
)                      

dataNorm <- TCGAanalyze_Normalization(
    tabDF = dataPrep,
    geneInfo = geneInfoHT,
    method = "gcContent"
)                

dataFilt <- TCGAanalyze_Filtering(
    tabDF = dataNorm,
    method = "quantile", 
    qnt.cut =  0.25
)   

dataDEGs <- TCGAanalyze_DEA(
    mat1 = dataFilt[,samples.solid.tissue.normal],
    mat2 = dataFilt[,samples.primary.tumour],
    Cond1type = "Normal",
    Cond2type = "Tumor",
    fdr.cut = 0.01 ,
    logFC.cut = 2,
    method = "glmLRT",
    pipeline = "edgeR"
)  
```

TCGAbiolinks outputs bar chart with the number of genes for the main categories of 
three ontologies (GO:biological process, GO:cellular component, and GO:molecular 
function, respectively). 

```{r,eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE}
ansEA <- TCGAanalyze_EAcomplete(
    TFname = "DEA genes Normal Vs Tumor",
    RegulonList = dataDEGs$gene_name
)  

TCGAvisualize_EAbarplot(
    tf = rownames(ansEA$ResBP),
    GOBPTab = ansEA$ResBP,
    GOCCTab = ansEA$ResCC,
    GOMFTab = ansEA$ResMF,
    PathTab = ansEA$ResPat,
    nRGTab = dataDEGs$gene_name,
    nBar = 10
)
```


The figure resulted from the code above is shown below.
```{r, fig.width=6, fig.height=4, echo = FALSE, fig.align="center",hide=TRUE, message=FALSE,warning=FALSE}
library(png)
library(grid)
img <- readPNG("case1_EA.png")
grid.raster(img)
```

The Kaplan-Meier analysis was used to compute survival univariate curves, and  
log-Ratio test was computed to assess the statistical significance by using 
TCGAanalyze_SurvivalKM function; starting with 3,390 DEGs genes we found 555 
significantly genes with p.value <0.05. 

```{r,eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE}

group1 <- TCGAquery_SampleTypes(colnames(dataFilt), typesample = c("NT"))
group2 <- TCGAquery_SampleTypes(colnames(dataFilt), typesample = c("TP"))

dataSurv <- TCGAanalyze_SurvivalKM(
    clinical_patient = dataClin,
    dataGE = dataFilt,
    Genelist = rownames(dataDEGs),
    Survresult = FALSE,
    ThreshTop = 0.67,
    ThreshDown = 0.33,
    p.cut = 0.05, 
    group1 = group1, 
    group2 = group2
)
```

Cox-regression analysis was used to compute survival multivariate curves, and cox 
p-value was computed to assess the statistical significance by using 
TCGAnalyze_SurvivalCoxNET function. Survival multivariate analysis found 160 
significantly genes according to the cox p-value FDR 5.00e-02. From DEGs that we 
found to correlate  significantly with survival by both univariate and multivariate 
analyses we analyzed the following network.

The interactome network graph was generated using STRING.,org.Hs.string version 
10 (Human functional protein association network). The network graph was resized 
by dnet package considering only multivariate survival genes, with strong interaction 
(threshold = 700) we obtained a subgraphsub graph of 24 nodes and 31 edges.

```{r,eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE}

require(dnet)  # to change
org.Hs.string <- dRDataLoader(RData = "org.Hs.string")

TabCoxNet <- TCGAvisualize_SurvivalCoxNET(
    dataClin,
    dataFilt, 
    Genelist = rownames(dataSurv),
    scoreConfidence = 700,
    org.Hs.string = org.Hs.string,
    titlePlot = "Case Study n.1 dnet"
)
```

The figure resulted from the code above is shown below.
```{r, fig.width=6, fig.height=4, echo = FALSE, fig.align="center",hide=TRUE, message=FALSE,warning=FALSE}
library(png)
library(grid)
img <- readPNG("case1_dnet.png")
grid.raster(img)
```

# Case study n. 2: Pan Cancer downstream analysis LGG

We focused on the analysis of LGG samples. In particular, we used TCGAbiolinks
to download 293 samples with molecular subtypes. Link the complete [complete code](https://gist.github.com/tiagochst/277651ebed998fd3d1952d3fbc376ef2).
.

```{r,eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE}
library(TCGAbiolinks)
library(SummarizedExperiment)

query.exp <- GDCquery(
    project = "TCGA-LGG", 
    data.category = "Transcriptome Profiling",
    data.type = "Gene Expression Quantification", 
    workflow.type = "STAR - Counts",
    sample.type = c("Primary Tumor")
)

GDCdownload(query.exp)

lgg.exp <- GDCprepare(
    query = query.exp, 
    save = FALSE
)
```

First, we searched for possible outliers using the `TCGAanalyze_Preprocessing` 
function, which performs an Array Array Intensity correlation AAIC.
We used all samples in expression data which contain molecular subtypes, filtering 
out samples without molecular information, and using only IDHmut-codel (n=85),
IDHmut-non-codel (n=141) and IDHwt (n=56), NA (11), to define a square 
symmetric matrix of pearson correlation among all samples (n=293). 
According to this matrix we found no samples with low correlation (cor.cut = 0.6) 
that can be identified as possible outliers, so we continued our analysis 
with 70 samples. 

Second, using the `TCGAanalyze_Normalization` function we normalized mRNA 
transcripts and miRNA, using EDASeq package. This function does use 
Within-lane normalization procedures to adjust for GC-content effect 
(or other gene-level effects) on read counts: loess robust local regression, 
global-scaling, and full-quantile normalization [@risso2011gc] and 
between-lane normalization procedures to adjust for distributional differences 
between lanes (e.g., sequencing depth): global-scaling and full-quantile 
normalization [@bullard2010evaluation].

Third, using the `TCGAanalyze_Filtering` function we applied 3 filters removing 
features / mRNAs with low signal across samples obtaining 4578, 4284, 
1187 mRNAs respectively. 

Then we applied two Hierarchical cluster analysis on 1187 mRNAs after the three 
filters described above, the first cluster using as method ward.D2, and the 
second with ConsensusClusterPlus.

After the two clustering analysis, with cut.tree = 4 we obtained n= 4 expression clusters (EC).


```{r,eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE}
library(dplyr)

dataPrep <- TCGAanalyze_Preprocessing(
    object = lgg.exp, 
    cor.cut = 0.6
)
dataNorm <- TCGAanalyze_Normalization(
    tabDF = dataPrep,
    geneInfo = geneInfoHT,
    method = "gcContent"
)

datFilt <- dataNorm %>% 
    TCGAanalyze_Filtering(method = "varFilter") %>%
    TCGAanalyze_Filtering(method = "filter1") %>%  
    TCGAanalyze_Filtering(method = "filter2",foldChange = 1)

data_Hc2 <- TCGAanalyze_Clustering(
    tabDF = datFilt,
    method = "consensus",
    methodHC = "ward.D2"
) 
# Add  cluster information to Summarized Experiment
colData(lgg.exp)$groupsHC <- paste0("EC",data_Hc2[[4]]$consensusClass)
```

The next steps will be to visualize the data. First, we created the survival plot.
```{r,eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE}
TCGAanalyze_survival(
    data = colData(lgg.exp),
    clusterCol = "groupsHC",
    main = "TCGA kaplan meier survival plot from consensus cluster",
    legend = "RNA Group",
    height = 10,
    risk.table = T,
    conf.int = F,
    color = c("black","red","blue","green3"),
    filename = "survival_lgg_expression_subtypes.png"
)
```


The result is showed below:
```{r, fig.width=6, fig.height=4, echo = FALSE, fig.align="center",hide=TRUE, message=FALSE,warning=FALSE}
library(png)
library(grid)
img <- readPNG("case2_surv.png")
grid.raster(img)
```

We will also, create a heatmap of the expression.
```{r,eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE}
TCGAvisualize_Heatmap(
    data = t(datFilt),
    col.metadata =  colData(lgg.exp)[,
                                     c("barcode",
                                       "groupsHC",
                                       "paper_Histology",
                                       "paper_IDH.codel.subtype")
    ],
    col.colors =  list(
        groupsHC = c(
            "EC1"="black",
            "EC2"="red",
            "EC3"="blue",
            "EC4"="green3")
    ),
    sortCol = "groupsHC",
    type = "expression", # sets default color
    scale = "row", # use z-scores for better visualization. Center gene expression level around 0.
    title = "Heatmap from concensus cluster", 
    filename = "case2_Heatmap.png",
    extremes = seq(-2,2,1),
    color.levels = colorRampPalette(c("green", "black", "red"))(n = 5),
    cluster_rows = TRUE,
    cluster_columns = FALSE,
    width = 1000,
    height = 500
)
```

The result is shown below:

```{r, fig.width=6, fig.height=4, echo = FALSE, fig.align="center",hide=TRUE, message=FALSE,warning=FALSE}
library(jpeg)
library(grid)
img <- readJPEG("case2_Heatmap.jpg")
grid.raster(img)
```

Finally, we will take a look in the mutation genes. We will first download the MAF file
with `GDCquery`,`GDCdownload` and `GDCprepare`. In this example we will investigate the gene "ATR".

```{r,eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE}
library(maftools)
library(dplyr)
query <- GDCquery(
    project = "TCGA-LGG", 
    data.category = "Simple Nucleotide Variation", 
    access = "open", 
    data.type = "Masked Somatic Mutation", 
    workflow.type = "Aliquot Ensemble Somatic Variant Merging and Masking"
)
GDCdownload(query)
LGGmut <- GDCprepare(query)
# Selecting gene
LGGmut.atr <- LGGmut %>% dplyr::filter(Hugo_Symbol == "ATR")

dataMut <- LGGmut.atr[!duplicated(LGGmut.atr$Tumor_Sample_Barcode),]
dataMut$Tumor_Sample_Barcode <- substr(dataMut$Tumor_Sample_Barcode,1,12)

# Adding the Expression Cluster classification found before
dataMut <- merge(dataMut, cluster, by.y = "patient", by.x = "Tumor_Sample_Barcode")
```

# Case study n. 3: Integration of methylation and expression for ACC

In recent years, it has been described the relationship between 
DNA methylation and gene expression and the study of this relationship 
is often difficult to accomplish.

This case study will show the steps to investigate the relationship
between the two types of data.

First, we downloaded ACC DNA methylation data for HumanMethylation450k platforms, and ACC RNA expression data for Illumina HiSeq platform. 

TCGAbiolinks adds by default the subtypes classification already published by researchers.

We will use this classification to do our examples. 
So, selected the groups CIMP-low and CIMP-high to do RNA expression and DNA methylation comparison.


```{r,eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE}
library(TCGAbiolinks)
library(SummarizedExperiment)

#-----------------------------------
# STEP 1: Search, download, prepare |
#-----------------------------------
# 1.1 - DNA methylation
# ----------------------------------
query.met <- GDCquery(
    project = "TCGA-ACC", 
    data.category = "DNA Methylation", 
    data.type = "Methylation Beta Value",
    platform = "Illumina Human Methylation 450"
)

GDCdownload(
    query = query.met, 
    files.per.chunk = 20,
    directory = "case3/GDCdata"
)

acc.met <- GDCprepare(
    query = query.met,
    save = FALSE,
    directory = "case3/GDCdata"
)

#-----------------------------------
# 1.2 - RNA expression
# ----------------------------------
query.exp <- GDCquery(
    project = "TCGA-ACC", 
    data.category = "Transcriptome Profiling",
    data.type = "Gene Expression Quantification", 
    workflow.type = "STAR - Counts"
)

GDCdownload( 
    query = query.exp,
    files.per.chunk = 20,
    directory = "case3/GDCdata"
)

acc.exp <- GDCprepare(
    query = query.exp, 
    save = FALSE,
    directory = "case3/GDCdata"
)
```

For DNA methylation, we perform a DMC (different methylated CpGs) analysis, which will give the difference of DNA methylation for the probes of the groups and their significance value.
The output can be seen in a volcano plot. 
Note: Depending on the number of samples this function can be very slow
due to the wilcoxon test, taking from hours to days.

```{r,eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE}
# na.omit
acc.met <- acc.met[rowSums(is.na(assay(acc.met))) == 0,]

# Volcano plot
acc.met <- TCGAanalyze_DMC(
    data = acc.met, 
    groupCol = "subtype_MethyLevel",
    group1 = "CIMP-high",
    group2="CIMP-low",
    p.cut = 10^-5,
    diffmean.cut = 0.25,
    legend = "State",
    plot.filename = "case3/CIMP-highvsCIMP-low_metvolcano.png"
)
```

The figure resulted from the code above is shown below:
```{r, fig.width=6, fig.height=4, echo = FALSE, fig.align="center",hide=TRUE, message=FALSE,warning=FALSE}
library(png)
library(grid)
img <- readPNG("CIMP-highvsCIMP-low_metvolcano.png")
grid.raster(img)
```


For the expression analysis, we do a DEA (differential expression analysis) which will give the fold change 
of gene expression and their significance value.
```{r,eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE}
#-------------------------------------------------
# 2.3 - DEA - Expression analysis - volcano plot
# ------------------------------------------------
acc.exp.aux <- subset(
    acc.exp, 
    select = colData(acc.exp)$subtype_MethyLevel %in% c("CIMP-high","CIMP-low")
)

idx <- colData(acc.exp.aux)$subtype_MethyLevel %in% c("CIMP-high")
idx2 <- colData(acc.exp.aux)$subtype_MethyLevel %in% c("CIMP-low")

dataPrep <- TCGAanalyze_Preprocessing(
    object = acc.exp.aux, 
    cor.cut = 0.6
)

dataNorm <- TCGAanalyze_Normalization(
    tabDF = dataPrep,
    geneInfo = geneInfoHT,
    method = "gcContent"
)

dataFilt <- TCGAanalyze_Filtering(
    tabDF = dataNorm,
    qnt.cut = 0.25,
    method = 'quantile'
)

dataDEGs <- TCGAanalyze_DEA(
    mat1 = dataFilt[,idx],
    mat2 = dataFilt[,idx2],
    Cond1type = "CIMP-high",
    Cond2type = "CIMP-low",
    method = "glmLRT"
)

TCGAVisualize_volcano(
    x = dataDEGs$logFC,
    y = dataDEGs$FDR,
    filename = "case3/Case3_volcanoexp.png",
    x.cut = 3,
    y.cut = 10^-5,
    names = rownames(dataDEGs),
    color = c("black","red","darkgreen"),
    names.size = 2,
    xlab = " Gene expression fold change (Log2)",
    legend = "State",
    title = "Volcano plot (CIMP-high vs CIMP-low)",
    width = 10
)
```

The figure resulted from the code above is shown below:
```{r, fig.width=6, fig.height=4, echo = FALSE, fig.align="center",hide=TRUE, message=FALSE,warning=FALSE}
library(png)
library(grid)
img <- readPNG("figure5exp.png")
grid.raster(img)
```

Finally, using both previous analysis we do a starburst plot to select the genes 
that are Candidate Biologically Significant.

Observation: over the time, the number of samples has increased and the clinical data updated.
We used only the samples that had a classification in the examples.
```{r,eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE}
#------------------------------------------
# 2.4 - Starburst plot
# -----------------------------------------
# If true the argument names of the genes in circle 
# (biologically significant genes, has a change in gene
# expression and DNA methylation and respects all the thresholds)
# will be shown
# these genes are returned by the function see starburst object after the function is executed
starburst <- TCGAvisualize_starburst(
    met = acc.met, 
    exp = dataDEGs,
    genome = "hg19"
    group1 = "CIMP-high",
    group2 = "CIMP-low",
    filename = "case3/starburst.png",
    met.platform = "450K",
    met.p.cut = 10^-5,
    exp.p.cut = 10^-5,
    diffmean.cut = 0.25,
    logFC.cut = 3,
    names = FALSE, 
    height = 10,
    width = 15,
    dpi = 300
)
```

The figure resulted from the code above is shown below:
```{r, fig.width=6, fig.height=4, echo = FALSE, fig.align="center",hide=TRUE, message=FALSE,warning=FALSE}
library(png)
library(grid)
img <- readPNG("figure5star.png")
grid.raster(img)
```

# Case study n. 4: ELMER pipeline - KIRC

An example of package to perform DNA methylation and RNA expression analysis is ELMER [@yao2015inferring,@elmer2,@yao2015demystifying]. 
ELMER, which is designed to combine DNA methylation and gene expression data from human tissues to infer multi-level cis-regulatory networks. 
ELMER uses DNA methylation to 
identify distal probes, and correlates them with the expression of nearby genes 
to identify one or more transcriptional targets. Transcription factor (TF) binding 
site analysis of those anti-correlated distal probes is coupled with expression analysis of all TFs to 
infer upstream regulators. This package can be easily applied to TCGA public 
available cancer data sets and custom DNA methylation and gene expression data sets.

ELMER analyses have the following steps: 

1. Organize data as a *MultiAssayExperiment* object
2. Identify distal probes with significantly different DNA methylation level when comparing two sample groups.
3. Identify putative target genes for differentially methylated distal probes, using methylation vs. expression correlation
4. Identify enriched motifs for each probe belonging to a significant probe-gene pair
5. Identify master regulatory Transcription Factors (TF) whose expression associate with DNA methylation changes at multiple regulatory regions.

We will present this the study KIRC by TCGAbiolinks and 
ELMER integration. 

<div class="panel panel-info">
<div class="panel-heading">ELMER package</div>
<div class="panel-body">

For more information, please consult the ELMER package:

- http://bioconductor.org/packages/ELMER/ 

And the following articles:

- http://www.biorxiv.org/content/early/2017/06/11/148726.full.pdf
- https://www.ncbi.nlm.nih.gov/pubmed/26446758
- https://genomebiology.biomedcentral.com/articles/10.1186/s13059-015-0668-3


</div>
</div>

For the DNA methylation data we will search the platform HumanMethylation450.
After, we will download the data and prepared into a *SummarizedExperiment* object.

```{r,eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE}
library(TCGAbiolinks)
library(SummarizedExperiment)
library(ELMER)
library(parallel)
dir.create("case4")
setwd("case4")
#-----------------------------------
# STEP 1: Search, download, prepare |
#-----------------------------------
# 1.1 - DNA methylation
# ----------------------------------
query.met <- GDCquery(
    project = "TCGA-KIRC", 
    data.category = "DNA Methylation", 
    data.type = "Methylation Beta Value",
    platform = "Illumina Human Methylation 450"
)
GDCdownload(query.met)
kirc.met <- GDCprepare(
    query = query.met,
    save = TRUE, 
    save.filename = "kircDNAmet.rda",
    summarizedExperiment = TRUE
)
```

For gene expression we will use Gene Expression Quantification.

```{r,eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE}
# Step 1.2 download expression data
#-----------------------------------
# 1.2 - RNA expression
# ----------------------------------
query.exp <- GDCquery(
    project = "TCGA-KIRC",
    data.category = "Transcriptome Profiling",
    data.type = "Gene Expression Quantification", 
    workflow.type = "STAR - Counts"
)
GDCdownload(query.exp,files.per.chunk = 20)
kirc.exp <- GDCprepare(
    query = query.exp, 
    save = TRUE, 
    save.filename = "kircExp.rda"
)
```

A MultiAssayExperiment object from the r BiocStyle::Biocpkg("MultiAssayExperiment") package is the input for multiple main functions of r BiocStyle::Biocpkg("ELMER").

We will first need to get distal probes (2 KB away from TSS).
```{r,eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE}
distal.probes <- get.feature.probe(genome = "hg38", met.platform = "450K")
```

To create it you can use the **createMAE** function. This function will keep only samples that
have both DNA methylation and gene expression.

```{r,eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE}
library(MultiAssayExperiment)
mae <- createMAE(
    exp = kirc.exp, 
    met = kirc.met,
    save = FALSE,
    linearize.exp = TRUE,
    filter.probes = distal.probes,
    save.filename = "mae_kirc.rda",
    met.platform = "450K",
    genome = "hg38",
    TCGA = TRUE
)
# Remove FFPE samples
mae <- mae[,!mae$is_ffpe]
```

We will execute ELMER to identify probes that are hypomethylated in tumor samples
compared to the normal samples.


```{r,eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE}
group.col <- "definition"
group1 <-  "Primary Tumor"
group2 <- "Solid Tissue Normal"
direction <- "hypo"
dir.out <- file.path("kirc",direction)
dir.create(dir.out, recursive = TRUE)
#--------------------------------------
# STEP 3: Analysis                     |
#--------------------------------------
# Step 3.1: Get diff methylated probes |
#--------------------------------------
sig.diff <- get.diff.meth(
    data = mae, 
    group.col = group.col,
    group1 =  group1,
    group2 = group2,
    minSubgroupFrac = 0.2,
    sig.dif = 0.3,
    diff.dir = direction, # Search for hypomethylated probes in group 1
    cores = 1, 
    dir.out = dir.out, 
    pvalue = 0.01
)

#-------------------------------------------------------------
# Step 3.2: Identify significant probe-gene pairs            |
#-------------------------------------------------------------
# Collect nearby 20 genes for Sig.probes
nearGenes <- GetNearGenes(
    data = mae, 
    probes = sig.diff$probe, 
    numFlankingGenes = 20, # 10 upstream and 10 dowstream genes
    cores = 1
)

pair <- get.pair(
    data = mae,
    group.col = group.col,
    group1 =  group1,
    group2 = group2,
    nearGenes = nearGenes,
    minSubgroupFrac = 0.4, # % of samples to use in to create groups U/M
    permu.dir = file.path(dir.out,"permu"),
    permu.size = 100, # Please set to 100000 to get significant results
    raw.pvalue  = 0.05,   
    Pe = 0.01, # Please set to 0.001 to get significant results
    filter.probes = TRUE, # See preAssociationProbeFiltering function
    filter.percentage = 0.05,
    filter.portion = 0.3,
    dir.out = dir.out,
    cores = 1,
    label = direction
)

# Identify enriched motif for significantly hypomethylated probes which 
# have putative target genes.
enriched.motif <- get.enriched.motif(
    data = mae,
    probes = pair$Probe, 
    dir.out = dir.out, 
    label = direction,
    min.incidence = 10,
    lower.OR = 1.1
)

TF <- get.TFs(
    data = mae, 
    group.col = group.col,
    group1 =  group1,
    group2 = group2,
    minSubgroupFrac = 0.4,
    enriched.motif = enriched.motif,
    dir.out = dir.out, 
    cores = 1, 
    label = direction
)
```

From this analysis it is possible to verify the relationship between nearby 20 
gene expression vs DNA methylation at this probe. The result of this is 
show by the ELMER scatter plot.

```{r,eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE}
scatter.plot(
    data = mae,
    byProbe = list(probe = sig.diff$probe[1], numFlankingGenes = 20), 
    category = "definition", 
    dir.out = "plots",
    lm = TRUE, # Draw linear regression curve
    save = TRUE
) 
```

The result is shown below:
```{r, fig.width=6, fig.height=4, echo = FALSE, fig.align="center",hide=TRUE, message=FALSE,warning=FALSE}
library(png)
library(grid)
img <- readPNG("case4_elmer.png")
grid.raster(img)
```

Each scatter plot showing the average DNA methylation level of sites with the UA6 motif in all KIRC samples plotted against the expression of the transcription factor ZNF677 and PEG3 respectively.
```{r,eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE}
scatter.plot(
    data = mae,
    byTF = list(
        TF = c("RUNX1","RUNX2","RUNX3"),
        probe = enriched.motif[[names(enriched.motif)[10]]]
    ), 
    category = "definition",
    dir.out = "plots",
    save = TRUE, 
    lm_line = TRUE
)
```

The result is shown below:
```{r, fig.width=6, fig.height=4, echo = FALSE, fig.align="center",hide=TRUE, message=FALSE,warning=FALSE}
library(png)
library(grid)
img <- readPNG("elmer1.png")
grid.raster(img)

```

You cen see the anticorrelated pairs of gene and probes by drawing a heatmap.

```{r,eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE}
heatmapPairs(
    data = mae, 
    group.col = "definition",
    group1 = "Primary Tumor", 
    annotation.col = c("gender"),
    group2 = "Solid Tissue Normal",
    pairs = pair,
    filename =  "heatmap.pdf"
)
```
The result is shown below:
```{r, fig.width=6, fig.height=4, echo = FALSE, fig.align="center",hide=TRUE, message=FALSE,warning=FALSE}
library(jpeg)
library(grid)
img <- readJPEG("elmer2.jpg")
grid.raster(img)
```

The plot shows the odds ratio (x axis) for the selected motifs with lower boundary of OR above 1.8. 
The range shows the 95% confidence interval for each Odds Ratio.

```{r, fig.width=6, fig.height=4, echo = FALSE, fig.align="center",hide=TRUE, message=FALSE,warning=FALSE}
library(png)
library(grid)
img <- readPNG("elmer3.png")
grid.raster(img)
```

******

# Session Information
******
```{r sessionInfo}
sessionInfo()
```

# References

---
title: "TCGAbiolinks: Clinical data"
date: "`r BiocStyle::doc_date()`"
vignette: >
  %\VignetteIndexEntry{"4. Clinical data"}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

<style> body {text-align: justify} </style>


```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
knitr::opts_knit$set(progress = FALSE)
```

```{r message=FALSE, warning=FALSE, include=FALSE}
library(TCGAbiolinks)
library(SummarizedExperiment)
library(dplyr)
library(DT)
```


**TCGAbiolinks** has provided a few functions to search, download and parse clinical data.
This section starts by explaining the different sources for clinical information in GDC, followed by the necessary
function to access these sources.


---
# Useful information


<div class="panel panel-info">
<div class="panel-heading">Different sources</div>
<div class="panel-body">

In GDC database the clinical data can be retrieved from different sources:

- indexed clinical: a refined clinical data that is created using the XML files.
- XML files: original source of the data
- BCR Biotab: tsv files parsed from XML files


There are two main differences between the indexed clinical and XML files:

- XML has more information: radiation, drugs information, follow-ups, biospecimen, etc. So the indexed one is only a subset of the XML files
- The indexed data contains the updated data with the follow up information. 
For example: if the patient is alive in the first time clinical data was collect and the in the next follow-up he is dead, 
the indexed data will show dead. The XML will have two fields, one for the first time saying he is alive (in the clinical part) and the follow-up saying he is dead. 
</div>
</div>

Other useful clinical information available are:

* Tissue slide image 
* Pathology report - Slide image


#  BCR Biotab


## Clinical
In this example we will fetch clinical data from  BCR Biotab files.

```{r BCR_Biotab, results='hide', echo=TRUE, message=FALSE, warning=FALSE}
query <- GDCquery(
    project = "TCGA-ACC", 
    data.category = "Clinical",
    data.type = "Clinical Supplement", 
    data.format = "BCR Biotab"
)
GDCdownload(query)
clinical.BCRtab.all <- GDCprepare(query)
names(clinical.BCRtab.all)
```

```{r  echo=TRUE, message=FALSE, warning=FALSE}
clinical.BCRtab.all$clinical_drug_acc  %>% 
    head  %>% 
    DT::datatable(options = list(scrollX = TRUE, keys = TRUE))
```


In this example we will fetch all ACC BCR Biotab files, and look for the ER status.

```{r, results = "hide",cache=TRUE, message=FALSE}
library(TCGAbiolinks)
query <- GDCquery(
    project = "TCGA-ACC", 
    data.category = "Clinical",
    data.type = "Clinical Supplement", 
    data.format = "BCR Biotab"
)

GDCdownload(query)
clinical_tab_all <- GDCprepare(query)
```

```{R}
# All available tables
names(clinical_tab_all)

# columns from clinical_patient
dplyr::glimpse(clinical_tab_all$clinical_patient_acc)
```

## Biospecimen


```{r, results = "hide",cache=TRUE, message=FALSE,warning=FALSE}
# Biospecimen BCR Biotab
query_biospecimen <- GDCquery(
    project = "TCGA-ACC", 
    data.category = "Biospecimen",
    data.type = "Biospecimen Supplement", 
    data.format = "BCR Biotab"
)
GDCdownload(query_biospecimen)
biospecimen_tab_all <- GDCprepare(query_biospecimen)
```

```{R}
# All available tables
names(biospecimen_tab_all)

biospecimen_tab_all$biospecimen_sample_acc  %>% 
    head  %>% 
    DT::datatable(options = list(scrollX = TRUE, keys = TRUE))
```


# Clinical indexed data

In this example we will fetch clinical indexed data (same as showed in the data portal).

```{r results='hide', echo=TRUE, message=FALSE, warning=FALSE}
clinical <- GDCquery_clinic(project = "TCGA-ACC", type = "clinical")
```

```{r  echo=TRUE, message=FALSE, warning=FALSE}
clinical %>%
    head %>% 
    DT::datatable(
        filter = 'top', 
        options = list(scrollX = TRUE, keys = TRUE, pageLength = 5),  
        rownames = FALSE
    )
```


```{r eval=FALSE,results='hide', echo=TRUE, message=FALSE, warning=FALSE}
clinical_beataml <- GDCquery_clinic(
    project = "BEATAML1.0-COHORT", 
    type = "clinical"
)

clinical_cptac2 <- GDCquery_clinic(
    project = "CPTAC-2", 
    type = "clinical"
)

clinical_genie <- GDCquery_clinic(
    project = "GENIE-MSK", 
    type = "clinical"
)
```


# XML clinical data

The process to get data directly from the XML are:
1. Use `GDCquery` and `GDCDownload` functions to search/download either biospecimen or clinical XML files
2. Use `GDCprepare_clinic` function to parse the XML files.

The relation between one patient and other clinical information are 1:n, 
one patient could have several radiation treatments. For that reason, we only give the option
to parse individual tables (only drug information, only radiation information,...)
The selection of the table is done by the argument `clinical.info`.

<div class="panel panel-info">
<div class="panel-heading">clinical.info options to parse information for each data category </div>
<div class="panel-body">
| data.category | clinical.info |
|------------|--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| Clinical | drug |
| Clinical | admin |
| Clinical | follow_up |
| Clinical | radiation |
| Clinical | patient |
| Clinical | stage_event |
| Clinical | new_tumor_event |
| Biospecimen | sample |
| Biospecimen | bio_patient |
| Biospecimen | analyte |
| Biospecimen | aliquot |
| Biospecimen | protocol |
| Biospecimen | portion |
| Biospecimen | slide |
| Other | msi |
</div>
</div>

Below are several examples fetching clinical data directly from the clinical XML files.

```{r results = 'hide',echo=TRUE, message=FALSE, warning=FALSE}
query <- GDCquery(
    project = "TCGA-COAD", 
    data.category = "Clinical", 
    data.format = "bcr xml",
    barcode = c("TCGA-RU-A8FL","TCGA-AA-3972")
)
GDCdownload(query)
clinical <- GDCprepare_clinic(query, clinical.info = "patient")
```

```{r  echo = TRUE, message = FALSE, warning = FALSE}
clinical %>% 
    datatable(filter = 'top', 
              options = list(scrollX = TRUE, keys = TRUE, pageLength = 5),  
              rownames = FALSE)
```

```{r results = 'hide', echo=TRUE, message=FALSE, warning=FALSE}
clinical.drug <- GDCprepare_clinic(query, clinical.info = "drug")
```

```{r  echo = TRUE, message = FALSE, warning = FALSE}
clinical.drug %>% 
    datatable(filter = 'top', 
              options = list(scrollX = TRUE, keys = TRUE, pageLength = 5),  
              rownames = FALSE)
```

```{r results = 'hide', echo=TRUE, message=FALSE, warning=FALSE}
clinical.radiation <- GDCprepare_clinic(query, clinical.info = "radiation")
```

```{r  echo = TRUE, message = FALSE, warning = FALSE}
clinical.radiation %>% 
    datatable(filter = 'top', 
              options = list(scrollX = TRUE, keys = TRUE, pageLength = 5),  
              rownames = FALSE)
```

```{r results = 'hide', echo=TRUE, message=FALSE, warning=FALSE}
clinical.admin <- GDCprepare_clinic(query, clinical.info = "admin")
```

```{r  echo = TRUE, message = FALSE, warning = FALSE}
clinical.admin %>% 
    datatable(filter = 'top', 
              options = list(scrollX = TRUE, keys = TRUE, pageLength = 5),  
              rownames = FALSE)
```



# Diagnostic Slide (SVS format)

```{r results = 'hide', echo=TRUE, message=FALSE, warning=FALSE}
# Pathology report from harmonized portal 
query_harmonized <- GDCquery(
    project = "TCGA-COAD", 
    data.category = "Biospecimen", 
    data.type = "Slide Image",
    experimental.strategy = "Diagnostic Slide",
    barcode = c("TCGA-RU-A8FL","TCGA-AA-3972")
)  
```

```{r echo=TRUE, message=FALSE, warning=FALSE}
query_harmonized  %>% 
    getResults %>% 
    head  %>% 
    DT::datatable(options = list(scrollX = TRUE, keys = TRUE))
```


# Filter functions 

Also, some functions to work with clinical data are provided.

For example the function `TCGAquery_SampleTypes` will filter barcodes based on a
type the argument typesample. 


| Argument 	| Description	|  	|
|------------	|--------------------------------------------------------------	|-----------------------------------------------	|
| barcode 	| is a list of samples as TCGA barcodes 	|  	|
| typesample 	| a character vector indicating tissue type to query. Example: 	|  	|
|  	| TP 	| PRIMARY TUMOR 	|
|  	| TR 	| RECURRENT TUMOR 	|
|  	| TB 	| Primary Blood Derived Cancer-Peripheral Blood 	|
|  	| TRBM 	| Recurrent Blood Derived Cancer-Bone Marrow 	|
|  	| TAP 	| Additional-New Primary 	|
|  	| TM 	| Metastatic 	|
|  	| TAM 	| Additional Metastatic 	|
|  	| THOC 	| Human Tumor Original Cells 	|
|  	| TBM 	| Primary Blood Derived Cancer-Bone Marrow 	|
|  	| NB 	| Blood Derived Normal 	|
|  	| NT 	| Solid Tissue Normal 	|
|  	| NBC 	| Buccal Cell Normal 	|
|  	| NEBV 	| EBV Immortalized Normal 	|
|  	| NBM 	| Bone Marrow Normal 	|


The function `TCGAquery_MatchedCoupledSampleTypes` will filter the samples that 
have all the typesample provided as argument. For example, if TP and TR are set 
as typesample, the function will return the barcodes of a patient if it has both types.
So, if it has a TP, but not a  TR, no barcode will be returned. If it has a TP and a TR
both barcodes are returned.

An example of the function is below:

```{r, eval = TRUE}
bar <- c(
    "TCGA-G9-6378-02A-11R-1789-07", "TCGA-CH-5767-04A-11R-1789-07",  
    "TCGA-G9-6332-60A-11R-1789-07", "TCGA-G9-6336-01A-11R-1789-07",
    "TCGA-G9-6336-11A-11R-1789-07", "TCGA-G9-7336-11A-11R-1789-07",
    "TCGA-G9-7336-04A-11R-1789-07", "TCGA-G9-7336-14A-11R-1789-07",
    "TCGA-G9-7036-04A-11R-1789-07", "TCGA-G9-7036-02A-11R-1789-07",
    "TCGA-G9-7036-11A-11R-1789-07", "TCGA-G9-7036-03A-11R-1789-07",
    "TCGA-G9-7036-10A-11R-1789-07", "TCGA-BH-A1ES-10A-11R-1789-07",
    "TCGA-BH-A1F0-10A-11R-1789-07", "TCGA-BH-A0BZ-02A-11R-1789-07",
    "TCGA-B6-A0WY-04A-11R-1789-07", "TCGA-BH-A1FG-04A-11R-1789-08",
    "TCGA-D8-A1JS-04A-11R-2089-08", "TCGA-AN-A0FN-11A-11R-8789-08",
    "TCGA-AR-A2LQ-12A-11R-8799-08", "TCGA-AR-A2LH-03A-11R-1789-07",
    "TCGA-BH-A1F8-04A-11R-5789-07", "TCGA-AR-A24T-04A-55R-1789-07",
    "TCGA-AO-A0J5-05A-11R-1789-07", "TCGA-BH-A0B4-11A-12R-1789-07",
    "TCGA-B6-A1KN-60A-13R-1789-07", "TCGA-AO-A0J5-01A-11R-1789-07",
    "TCGA-AO-A0J5-01A-11R-1789-07", "TCGA-G9-6336-11A-11R-1789-07",
    "TCGA-G9-6380-11A-11R-1789-07", "TCGA-G9-6380-01A-11R-1789-07",
    "TCGA-G9-6340-01A-11R-1789-07", "TCGA-G9-6340-11A-11R-1789-07"
)

S <- TCGAquery_SampleTypes(bar,"TP")
S2 <- TCGAquery_SampleTypes(bar,"NB")

# Retrieve multiple tissue types  NOT FROM THE SAME PATIENTS
SS <- TCGAquery_SampleTypes(bar,c("TP","NB"))

# Retrieve multiple tissue types  FROM THE SAME PATIENTS
SSS <- TCGAquery_MatchedCoupledSampleTypes(bar,c("NT","TP"))
```

# Other useful code

To get all the information for TGCA samples you can use the script below:
```{r, eval = FALSE}
# This code will get all clinical indexed data from TCGA
library(data.table)
library(dplyr)
library(regexPipes)
clinical <- TCGAbiolinks:::getGDCprojects()$project_id %>% 
    regexPipes::grep("TCGA",value = TRUE) %>% 
    sort %>% 
    plyr::alply(1,GDCquery_clinic, .progress = "text") %>% 
    rbindlist
readr::write_csv(clinical,path = paste0("all_clin_indexed.csv"))

# This code will get all clinical XML data from TCGA
getclinical <- function(proj){
    message(proj)
    while(1){
        result = tryCatch({
            query <- GDCquery(project = proj, data.category = "Clinical",data.format = "bcr xml")
            GDCdownload(query)
            clinical <- GDCprepare_clinic(query, clinical.info = "patient")
            for(i in c("admin","radiation","follow_up","drug","new_tumor_event")){
                message(i)
                aux <- GDCprepare_clinic(query, clinical.info = i)
                if(is.null(aux) || nrow(aux) == 0) next
                # add suffix manually if it already exists
                replicated <- which(grep("bcr_patient_barcode",colnames(aux), value = T,invert = T) %in% colnames(clinical))
                colnames(aux)[replicated] <- paste0(colnames(aux)[replicated],".",i)
                if(!is.null(aux)) clinical <- merge(clinical,aux,by = "bcr_patient_barcode", all = TRUE)
            }
            readr::write_csv(clinical,path = paste0(proj,"_clinical_from_XML.csv")) # Save the clinical data into a csv file
            return(clinical)
        }, error = function(e) {
            message(paste0("Error clinical: ", proj))
        })
    }
}
clinical <- TCGAbiolinks:::getGDCprojects()$project_id %>% 
    regexPipes::grep("TCGA",value=T) %>% sort %>% 
    plyr::alply(1,getclinical, .progress = "text") %>% 
    rbindlist(fill = TRUE) %>% setDF %>% subset(!duplicated(clinical))

readr::write_csv(clinical,path = "all_clin_XML.csv")
# result: https://drive.google.com/open?id=0B0-8N2fjttG-WWxSVE5MSGpva1U
# Obs: this table has multiple lines for each patient, as the patient might have several followups, drug treatments,
# new tumor events etc...
```

---
title: "TCGAbiolinks: Searching, downloading and visualizing mutation files"
date: "`r BiocStyle::doc_date()`"
vignette: >
  %\VignetteIndexEntry{"5. Mutation data"}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
knitr::opts_knit$set(progress = FALSE)
```

```{r message=FALSE, warning=FALSE, include=FALSE}
library(TCGAbiolinks)
library(SummarizedExperiment)
library(dplyr)
library(DT)
```



# Search and Download

**TCGAbiolinks** has provided a few functions to download mutation data from GDC.
There are two options to download the data:

1. Use `GDCquery`, `GDCdownload` and `GDCpreprare` to download MAF aligned against hg38
2. Use `GDCquery`, `GDCdownload` and `GDCpreprare` to download MAF aligned against hg19
3. Use `getMC3MAF()`, to download MC3 MAF from  https://gdc.cancer.gov/about-data/publications/mc3-2017

## Mutation data (hg38)

This example will download Aggregate GDC MAFs.
For more information please access https://github.com/NCI-GDC/gdc-maf-tool and 
[GDC docs](https://docs.gdc.cancer.gov/Data/Bioinformatics_Pipelines/DNA_Seq_Variant_Calling_Pipeline/).

```{r results = 'hide', echo=TRUE, message=FALSE, warning=FALSE,eval=F}
query <- GDCquery(
    project = "TCGA-CHOL", 
    data.category = "Simple Nucleotide Variation", 
    access = "open",
    data.type = "Masked Somatic Mutation", 
    workflow.type = "Aliquot Ensemble Somatic Variant Merging and Masking"
)
GDCdownload(query)
maf <- GDCprepare(query)
```
```{r results = 'hide', echo=TRUE, message=FALSE, warning=FALSE,eval=T,include=F}
maf <- chol_maf@data
```

```{r  echo = TRUE, message = FALSE, warning = FALSE}
# Only first 50 to make render faster
datatable(maf[1:20,],
          filter = 'top',
          options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
          rownames = FALSE)
```

## Mutation data MC3 file

This will download the MC3 MAF file from https://gdc.cancer.gov/about-data/publications/mc3-2017,
and add project each sample belongs.

```{r results = 'hide', echo=TRUE, message=FALSE, warning=FALSE,eval=FALSE}
maf <- getMC3MAF()
```


# Visualize the data
To visualize the data you can use the Bioconductor package [maftools](https://bioconductor.org/packages/release/bioc/html/maftools.html). For more information, please check its [vignette](https://bioconductor.org/packages/release/bioc/vignettes/maftools/inst/doc/maftools.html#rainfall-plots).


```{r  results = "hide",echo = TRUE, message = FALSE, warning = FALSE, eval=FALSE}
library(maftools)
library(dplyr)
query <- GDCquery(
    project = "TCGA-CHOL", 
    data.category = "Simple Nucleotide Variation", 
    access = "open",
    data.type = "Masked Somatic Mutation", 
    workflow.type = "Aliquot Ensemble Somatic Variant Merging and Masking"
)
GDCdownload(query)
maf <- GDCprepare(query)

maf <- maf %>% maftools::read.maf
```

```{r message=FALSE, warning=FALSE, include=FALSE}
library(maftools)
library(dplyr)
maf <- chol_maf
```

```{r  results = "hide",echo = TRUE, message = FALSE, warning = FALSE}
datatable(getSampleSummary(maf),
          filter = 'top',
          options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
          rownames = FALSE)
plotmafSummary(maf = maf, rmOutlier = TRUE, addStat = 'median', dashboard = TRUE)
```
```{r  echo = TRUE, message = FALSE,eval = FALSE, warning = FALSE}
oncoplot(maf = maf, top = 10, removeNonMutated = TRUE)
titv = titv(maf = maf, plot = FALSE, useSyn = TRUE)
#plot titv summary
plotTiTv(res = titv)
```

---
title: "Analyzing and visualizing TCGA data"
bibliography: bibliography.bib    
vignette: >
    %\VignetteIndexEntry{7. Analyzing and visualizing TCGA data}
    %\VignetteEngine{knitr::rmarkdown}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(dpi = 300)
knitr::opts_chunk$set(cache=FALSE)
```

```{r, echo = FALSE,hide=TRUE, message=FALSE,warning=FALSE}
devtools::load_all(".")
```
```{r message=FALSE, warning=FALSE, include=FALSE}
library(SummarizedExperiment)
library(dplyr)
library(DT)
```


# `TCGAanalyze`: Analyze data from TCGA. 
You can easily analyze data using following functions:

## `TCGAanalyze_Preprocessing`: Preprocessing of Gene Expression data (IlluminaHiSeq_RNASeqV2)

You can easily search TCGA samples, download and prepare a matrix of gene expression.
```{r, eval = FALSE}
# You can define a list of samples to query and download providing relative TCGA barcodes.
listSamples <- c(
    "TCGA-E9-A1NG-11A-52R-A14M-07","TCGA-BH-A1FC-11A-32R-A13Q-07",
    "TCGA-A7-A13G-11A-51R-A13Q-07","TCGA-BH-A0DK-11A-13R-A089-07",
    "TCGA-E9-A1RH-11A-34R-A169-07","TCGA-BH-A0AU-01A-11R-A12P-07",
    "TCGA-C8-A1HJ-01A-11R-A13Q-07","TCGA-A7-A13D-01A-13R-A12P-07",
    "TCGA-A2-A0CV-01A-31R-A115-07","TCGA-AQ-A0Y5-01A-11R-A14M-07"
)

# Query platform Illumina HiSeq with a list of barcode 
query <- GDCquery(
    project = "TCGA-BRCA", 
    data.category = "Transcriptome Profiling",
    data.type = "Gene Expression Quantification",
    barcode = listSamples
)

# Download a list of barcodes with platform IlluminaHiSeq_RNASeqV2
GDCdownload(query)

# Prepare expression matrix with geneID in the rows and samples (barcode) in the columns
# rsem.genes.results as values
BRCA.Rnaseq.SE <- GDCprepare(query)

BRCAMatrix <- assay(BRCA.Rnaseq.SE,"unstranded") 
# For gene expression if you need to see a boxplot correlation and AAIC plot to define outliers you can run
BRCA.RNAseq_CorOutliers <- TCGAanalyze_Preprocessing(BRCA.Rnaseq.SE)
```

The result is shown below:

```{r, eval = TRUE, echo = FALSE,size = 8}
library(TCGAbiolinks)
dataGE <- dataBRCA[sample(rownames(dataBRCA),10),sample(colnames(dataBRCA),7)]

knitr::kable(
    dataGE[1:10,2:3], digits = 2, 
    caption = "Example of a matrix of gene expression (10 genes in rows and 2 samples in columns)",
    row.names = TRUE
)
```

The result from `TCGAanalyze_Preprocessing` is shown below:
```{r, fig.width=6, fig.height=4, echo=FALSE, fig.align="center"}
library(png)
library(grid)
img <- readPNG("PreprocessingOutput.png")
grid.raster(img)
```

## `TCGAanalyze_DEA` `&` `TCGAanalyze_LevelTab`: Differential expression analysis (DEA)

Perform DEA (Differential expression analysis) to identify differentially expressed genes (DEGs) using the `TCGAanalyze_DEA` function. 

`TCGAanalyze_DEA` performs DEA using following functions from R \Biocpkg{edgeR}:

1. edgeR::DGEList converts the count matrix into an edgeR object.
2. edgeR::estimateCommonDisp each gene gets assigned the same dispersion estimate.
3. edgeR::exactTest performs pair-wise tests for differential expression between two groups.
4. edgeR::topTags takes the output from exactTest(), adjusts the raw p-values using the False Discovery Rate (FDR) correction, and returns the top differentially expressed genes.

This function receives as arguments:

* **mat1** The matrix of the first group (in the example, group 1 is the normal samples), 
* **mat2** The matrix of the  second group (in the example, group 2 is tumor samples)
* **Cond1type** Label for group 1
* **Cond1type** Label for group 2

Next, we filter the output of dataDEGs by abs(LogFC) >=1, and uses the
`TCGAanalyze_LevelTab` function to create a table with DEGs (differentially expressed genes), log Fold Change (FC), false discovery rate (FDR), the gene expression level for samples in Cond1type, and Cond2type, and Delta value (the difference of gene expression between the two conditions multiplied logFC).

```{r, eval = FALSE}
library(TCGAbiolinks)

# normalization of genes
dataNorm <- TCGAanalyze_Normalization(
    tabDF = BRCA.RNAseq_CorOutliers, 
    geneInfo =  geneInfoHT
)

# quantile filter of genes
dataFilt <- TCGAanalyze_Filtering(
    tabDF = dataNorm,
    method = "quantile", 
    qnt.cut =  0.25
)

# selection of normal samples "NT"
samplesNT <- TCGAquery_SampleTypes(
    barcode = colnames(dataFilt),
    typesample = c("NT")
)

# selection of tumor samples "TP"
samplesTP <- TCGAquery_SampleTypes(
    barcode = colnames(dataFilt), 
    typesample = c("TP")
)

# Diff.expr.analysis (DEA)
dataDEGs <- TCGAanalyze_DEA(
    mat1 = dataFilt[,samplesNT],
    mat2 = dataFilt[,samplesTP],
    Cond1type = "Normal",
    Cond2type = "Tumor",
    fdr.cut = 0.01 ,
    logFC.cut = 1,
    method = "glmLRT"
)

# DEGs table with expression values in normal and tumor samples
dataDEGsFiltLevel <- TCGAanalyze_LevelTab(
    FC_FDR_table_mRNA = dataDEGs,
    typeCond1 = "Tumor",
    typeCond2 = "Normal",
    TableCond1 = dataFilt[,samplesTP],
    TableCond2 = dataFilt[,samplesNT]
)

```
The result is shown below:

```{r, eval = TRUE, echo = FALSE}
library(TCGAbiolinks)
dataDEGsFiltLevel$FDR <- format(dataDEGsFiltLevel$FDR, scientific = TRUE)
knitr::kable(
    dataDEGsFiltLevel[1:10,], digits = 2,
    caption = "Table of DEGs after DEA", row.names = FALSE
)
```


Other examples are in the next sections.


### HTSeq data: Downstream analysis BRCA
```{r,eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE}

query <- GDCquery(
    project = "TCGA-BRCA",
    data.category = "Transcriptome Profiling",
    data.type = "Gene Expression Quantification", 
    workflow.type = "STAR - Counts"
)

samplesDown <- getResults(query,cols=c("cases"))

dataSmTP <- TCGAquery_SampleTypes(
    barcode = samplesDown,
    typesample = "TP"
)

dataSmNT <- TCGAquery_SampleTypes(
    barcode = samplesDown,
    typesample = "NT"
)
dataSmTP_short <- dataSmTP[1:10]
dataSmNT_short <- dataSmNT[1:10]

query.selected.samples <- GDCquery(
    project = "TCGA-BRCA", 
    data.category = "Transcriptome Profiling",
    data.type = "Gene Expression Quantification", 
    workflow.type = "STAR - Counts", 
    barcode = c(dataSmTP_short, dataSmNT_short)
)

GDCdownload(
    query = query.selected.samples
)

dataPrep <- GDCprepare(
    query = query.selected.samples, 
    save = TRUE
)

dataPrep <- TCGAanalyze_Preprocessing(
    object = dataPrep, 
    cor.cut = 0.6,
    datatype = "HTSeq - Counts"
)                      

dataNorm <- TCGAanalyze_Normalization(
    tabDF = dataPrep,
    geneInfo = geneInfoHT,
    method = "gcContent"
) 

boxplot(dataPrep, outline = FALSE)

boxplot(dataNorm, outline = FALSE)

dataFilt <- TCGAanalyze_Filtering(
    tabDF = dataNorm,
    method = "quantile", 
    qnt.cut =  0.25
)   

dataDEGs <- TCGAanalyze_DEA(
    mat1 = dataFilt[,dataSmTP_short],
    mat2 = dataFilt[,dataSmNT_short],
    Cond1type = "Normal",
    Cond2type = "Tumor",
    fdr.cut = 0.01 ,
    logFC.cut = 1,
    method = "glmLRT"
)  

```


### miRNA expression data: Downstream analysis BRCA
```{r,eval=FALSE,echo=TRUE,message=FALSE,warning=FALSE}
require(TCGAbiolinks)

query.miRNA <- GDCquery(
    project = "TCGA-BRCA", 
    experimental.strategy = "miRNA-Seq",
    data.category = "Transcriptome Profiling", 
    data.type = "miRNA Expression Quantification"
)

GDCdownload(query = query.miRNA)

dataAssy.miR <- GDCprepare(
    query = query.miRNA
)
rownames(dataAssy.miR) <- dataAssy.miR$miRNA_ID

# using read_count's data 
read_countData <-  colnames(dataAssy.miR)[grep("count", colnames(dataAssy.miR))]
dataAssy.miR <- dataAssy.miR[,read_countData]
colnames(dataAssy.miR) <- gsub("read_count_","", colnames(dataAssy.miR))

dataFilt <- TCGAanalyze_Filtering(
    tabDF = dataAssy.miR,
    method = "quantile", 
    qnt.cut =  0.25
)   

dataDEGs <- TCGAanalyze_DEA(
    mat1 = dataFilt[,dataSmNT_short.miR],
    mat2 = dataFilt[,dataSmTP_short.miR],
    Cond1type = "Normal",
    Cond2type = "Tumor",
    fdr.cut = 0.01 ,
    logFC.cut = 1,
    method = "glmLRT"
)  

```
## `TCGAanalyze_EAcomplete & TCGAvisualize_EAbarplot`: Enrichment Analysis

Researchers, in order to better understand the underlying biological processes, 
often want to retrieve a functional profile of a set of genes that might 
have an important role. This can be done by performing an enrichment analysis. 

We will perform an enrichment analysis on gene sets using the `TCGAanalyze_EAcomplete` 
function. 
Given a set of genes that are up-regulated under certain conditions, 
an enrichment analysis will identify classes of genes or proteins that 
are over-represented using annotations for that gene set.


To view the results you can use the `TCGAvisualize_EAbarplot` function as shown below.

```{r, eval = FALSE}
library(TCGAbiolinks)
# Enrichment Analysis EA
# Gene Ontology (GO) and Pathway enrichment by DEGs list
Genelist <- rownames(dataDEGsFiltLevel)

ansEA <- TCGAanalyze_EAcomplete(
    TFname = "DEA genes Normal Vs Tumor",
    RegulonList = Genelist
)

# Enrichment Analysis EA (TCGAVisualize)
# Gene Ontology (GO) and Pathway enrichment barPlot

TCGAvisualize_EAbarplot(
    tf = rownames(ansEA$ResBP), 
    GOBPTab = ansEA$ResBP,
    GOCCTab = ansEA$ResCC,
    GOMFTab = ansEA$ResMF,
    PathTab = ansEA$ResPat,
    nRGTab = Genelist, 
    nBar = 10
)

```
The result is shown below:
```{r, fig.width=6, fig.height=4, echo=FALSE, fig.align="center"}
library(png)
library(grid)
img <- readPNG("EAplot.png")
grid.raster(img)
```


The figure shows canonical pathways significantly overrepresented (enriched) by the DEGs 
(differentially expressed genes).
The most statistically significant canonical pathways identified 
in DEGs list are listed according to their p value corrected FDR (-Log) (colored bars) 
and the ratio of list genes found in each pathway over the total number of 
genes in that pathway (Ratio, red line).

## `TCGAanalyze_survival`: Survival Analysis

When analyzing survival, different problems come up than the ones discussed so far. 
One question is how do we deal with subjects dropping out of a
study. For example, assuming that we test a new cancer drug. While some subjects
die, others may believe that the new drug is not effective, and decide to drop out
of the study before the study is finished. A similar problem would be faced when
we investigate how long a machine lasts before it breaks down.

Using the clinical data, it is possible to create a survival plot with the 
function `TCGAanalyze_survival` as follows:

```{r, eval = FALSE}
clin.gbm <- GDCquery_clinic("TCGA-GBM", "clinical")
TCGAanalyze_survival(
    data = clin.gbm,
    clusterCol = "gender",
    main = "TCGA Set\n GBM",
    height = 10,
    width=10
)
```

The arguments of `TCGAanalyze_survival` are:

*  **clinical_patient** TCGA Clinical patient with the information days_to_death
*  **clusterCol** Column with groups to plot. This is a mandatory field, 
the caption will be based in this column
*  **legend** Legend title of the figure
*  **xlim** xlim x axis limits e.g. xlim = c(0, 1000). Present narrower X axis, but not affect survival estimates. 
*  **main**	 main title of the plot
*  **ylab**	y-axis text of the plot
*  **xlab** x-axis text of the plot
*  **filename**	 The name of the pdf file
*  **color** Define the colors of the lines.
*  **pvalue** Show pvalue in the plot. 
*  **risk.table** 	Show or not the risk table
*  **conf.int** 	Show confidence intervals for point estimates of survival curves.

The result is shown below:
```{r, fig.width=6, fig.height=4, echo = FALSE, fig.align="center",hide=TRUE, message=FALSE,warning=FALSE}
library(png)
library(grid)
img <- readPNG("case2_surv.png")
grid.raster(img)
```

## `TCGAanalyze_SurvivalKM`: Correlating gene expression and Survival Analysis

```{r, eval = FALSE}
library(TCGAbiolinks)
# Survival Analysis SA

clinical_patient_Cancer <- GDCquery_clinic("TCGA-BRCA","clinical")
dataBRCAcomplete <- log2(BRCA_rnaseqv2)

tokenStop <- 1

tabSurvKMcomplete <- NULL

for( i in 1: round(nrow(dataBRCAcomplete)/100)){
    message( paste( i, "of ", round(nrow(dataBRCAcomplete)/100)))
    tokenStart <- tokenStop
    tokenStop <- 100 * i
    tabSurvKM <- TCGAanalyze_SurvivalKM(
        clinical_patient_Cancer,
        dataBRCAcomplete,
        Genelist = rownames(dataBRCAcomplete)[tokenStart:tokenStop],
        Survresult = F,
        ThreshTop = 0.67,
        ThreshDown = 0.33
    )
    
    tabSurvKMcomplete <- rbind(tabSurvKMcomplete,tabSurvKM)
}

tabSurvKMcomplete <- tabSurvKMcomplete[tabSurvKMcomplete$pvalue < 0.01,]
tabSurvKMcomplete <- tabSurvKMcomplete[order(tabSurvKMcomplete$pvalue, decreasing=F),]

tabSurvKMcompleteDEGs <- tabSurvKMcomplete[
    rownames(tabSurvKMcomplete) %in% dataDEGsFiltLevel$mRNA,
]
```
The result is shown below:

```{r, fig.width=6, fig.height=4, echo=FALSE, fig.align="center"}
tabSurvKMcompleteDEGs$pvalue <- format(tabSurvKMcompleteDEGs$pvalue, scientific = TRUE)
knitr::kable(tabSurvKMcompleteDEGs[1:5,1:4], 
             digits = 2,
             caption = "Table KM-survival genes after SA",
             row.names = TRUE)
knitr::kable(tabSurvKMcompleteDEGs[1:5,5:7], 
             digits = 2,
             row.names = TRUE)
```

## `TCGAanalyze_DMR`: Differentially methylated regions Analysis

We will search for differentially methylated CpG sites using the `TCGAanalyze_DMR`
function. In order to find these regions we use the beta-values 
(methylation values ranging from 0.0 to 1.0) to compare two groups. 

First, it calculates the difference between the mean DNA methylation of each group
for each probe. 

Second, it test for differential expression between two groups using the wilcoxon test 
adjusting by the Benjamini-Hochberg method. The default arguments was set to
require a minimum absolute beta-values difference of 0.2 and an adjusted p-value
of < 0.01. 

After these tests, we save a volcano plot (x-axis:diff mean methylation,
y-axis: statistical significance) that will help the user identify the differentially
methylated CpG sites, then the results are saved in a csv file (DMR_results.groupCol.group1.group2.csv) and finally the object is returned with the calculus in the rowRanges.

The arguments of TCGAanalyze_DMR are:

| Argument 	| Description 	|
|--------------------------	|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------	|
| data 	| SummarizedExperiment obtained from the TCGAPrepare 	|
| groupCol 	| Columns with the groups inside the SummarizedExperiment object. (This will be obtained by the function colData(data)) 	|
| group1 	| In case our object has more than 2 groups, you should set the name of the group 	|
| group2 	| In case our object has more than 2 groups, you should set the name of the group 	|
| calculate.pvalues.probes 	| In order to get the probes faster the user can select to calculate the pvalues only for the probes with a difference in DNA methylation. The default is to calculate to all probes. Possible values: "all", "differential". Default "all" 	|
| plot.filename 	| Filename. Default: volcano.pdf, volcano.svg, volcano.png. If set to FALSE, there will be no plot. 	|
| ylab 	| y axis text 	|
| xlab 	| x axis text 	|
| title 	| main title. If not specified it will be "Volcano plot (group1 vs group2) 	|
| legend 	| Legend title 	|
| color 	| vector of colors to be used in graph 	|
| label 	| vector of labels to be used in the figure. Example: c("Not Significant","Hypermethylated in group1", "Hypomethylated in group1")) 	|
| xlim 	| x limits to cut image 	|
| ylim 	| y limits to cut image 	|
| p.cut 	| p values threshold. Default: 0.01 	|
| probe.names 	| is probe.names 	|
| diffmean.cut 	| diffmean threshold. Default: 0.2 	|
| paired 	| Wilcoxon paired parameter. Default: FALSE 	|
| adj.method 	| Adjusted method for the p-value calculation 	|
| overwrite 	| Overwrite the pvalues and diffmean values if already in the object for both groups? Default: FALSE 	|
| cores 	| Number of cores to be used in the non-parametric test Default = groupCol.group1.group2.rda 	|
| save 	| Save object with results? Default: TRUE 	|


```{r, eval = FALSE}
data <- TCGAanalyze_DMC(
    data = data, 
    groupCol = "methylation_subtype",
    group1 = "CIMP.H",
    group2 = "CIMP.L",
    p.cut = 10^-5,
    diffmean.cut = 0.25,
    legend = "State",
    plot.filename = "coad_CIMPHvsCIMPL_metvolcano.png"
)
```

The output will be a plot such as the figure below. The green dots are the 
probes that are hypomethylated in group 2 compared to group 1, 
while the red dots are the hypermethylated probes in group 2 compared to group 1


```{r, fig.width=6, fig.height=4, echo = FALSE, fig.align="center",hide=TRUE, message=FALSE,warning=FALSE}
library(png)
library(grid)
img <- readPNG("figure5met.png")
grid.raster(img)
```


Also, the `TCGAanalyze_DMR` 
function will save the plot as pdf and return the same SummarizedExperiment
that was given as input with the values of p-value,
p-value adjusted, diffmean and the group it belongs in the graph 
(non significant, hypomethylated, hypermethylated) in the rowRanges. 
The columns will be (where group1 and group2 are the names of the groups): 

* diffmean.group1.group2 (mean.group2 - mean.group1) 
* diffmean.group2.group1 (mean.group1 - mean.group2)
* p.value.group1.group2
* p.value.adj.group1.group2
* status.group1.group2 (Status of probes in group2 in relation to group1) 
* status.group2.group1 (Status of probes in group1 in relation to group2) 

This values can be view/acessed using the `rowRanges` 
acessesor (`rowRanges(data)`).

**Observation:** Calling the same function again, with the same arguments 
will only plot the results,  as it was already calculated. 
If you want to have them recalculated, please set
`overwrite` to `TRUE` or remove the calculated columns.

# `TCGAvisualize`: Visualize results from analysis functions with TCGA's data. 
You can easily visualize results from some following functions:

## `TCGAvisualize_Heatmap`: Create heatmaps with cluster bars

In order to have a better view of clusters, we normally use heatmaps.
`TCGAvisualize_Heatmap` will plot a heatmap and add to each sample bars representing
different features. This function is a wrapper to the package 
[ComplexHeatmap](http://bioconductor.org/packages/ComplexHeatmap/)  package,

The arguments of this function are:


* **data**	The object with the heatmap data (expression, methylation)
* **col.metadata** Metadata for the columns (patients). It should have the column bcr_patient_barcode or patient or ID with the patients barcodes.
* **row.metadata** Metadata for the rows genes (expression) or probes (methylation)
* **col.colors ** A list of names colors
* **row.colors ** A list of named colors
* **show_column_names **	Show column names names? Default: FALSE
* **show_row_names ** Show row names? Default: FALSE
* **cluster_rows ** Cluster rows ? Default: FALSE
* **cluster_columns** Cluster columns ? Default: FALSE
* **sortCol** Name of the column to be used to sort the columns
* **title** Title of the plot
* **type** Select the colors of the heatmap values. Possible values are "expression" (default), "methylation"
* **scale**	Use z-score to make the heamat? If we want to show differences between genes, it is good to make Z-score by samples (force each sample to have zero mean and standard deviation=1). If we want to show differences between samples, it is good to make Z-score by genes (force each gene to have zero mean and standard deviation=1). Possibilities: "row", "col. Default "none"


For more information please take a look on case study #2.

The result is shown below:
```{r, fig.width=6, fig.height=4, echo = FALSE, fig.align="center",hide=TRUE, message=FALSE,warning=FALSE}
library(jpeg)
library(grid)
img <- readJPEG("case2_Heatmap.jpg")
grid.raster(img)
```

## `TCGAvisualize_Volcano`: Create volcano plot 

Creates a volcano plot for DNA methylation or expression

The arguments of this function are:

| Argument 	| Description 	|
|-----------------	|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------	|
| x 	| x-axis data 	|
| y 	| y-axis data 	|
| filename 	| Filename. Default: volcano.pdf, volcano.svg, volcano.png 	|
| ylab 	| y axis text 	|
| xlab 	| x axis text 	|
| title 	| main title. If not specified it will be "Volcano plot (group1 vs group2) 	|
| legend 	| Legend title 	|
| label 	| vector of labels to be used in the figure. Example: c("Not Significant","Hypermethylated in group1", "Hypomethylated in group1"))#' 	|
| xlim 	| x limits to cut image 	|
| ylim 	| y limits to cut image 	|
| color 	| vector of colors to be used in graph 	|
| names 	| Names to be plotted if significant. Should be the same size of x and y 	|
| names.fill 	| Names should be filled in a color box? Default: TRUE 	|
| show.names 	| What names will be showd? Possibilities: "both", "significant", "highlighted" 	|
| x.cut 	| x-axis threshold. Default: 0.0 If you give only one number (e.g. 0.2) the cut-offs will be -0.2 and 0.2. Or you can give different cut-offs as a vector (e.g. c(-0.3,0.4)) 	|
| y.cut 	| p-values threshold. 	|
| height 	| Figure height 	|
| width 	| Figure width 	|
| highlight 	| List of genes/probes to be highlighted. It should be in the names argument. 	|
| highlight.color 	| Color of the points highlighted 	|
| names.size 	| Size of the names text 	|
| dpi 	| Figure dpi 	|
|  	|  	|
|  	|  	|
|  	|  	|
|  	|  	|
For more information please take a look on case study #3.

## `TCGAvisualize_PCA`: Principal Component Analysis plot for differentially expressed genes

In order to better understand our genes, we can perform a PCA to reduce the
number of dimensions of our gene set. The function `TCGAvisualize_PCA` will plot
the PCA for different groups.

The arguments of this function are:

* **dataFilt** The expression matrix after normalization and quantile filter
* **dataDEGsFiltLevel** The TCGAanalyze_LevelTab output
* **ntopgenes** number of DEGs genes to plot in PCA
* ** group1 a string containing the barcode list of the samples in control group
* ** group2 a string containing the barcode list of the samples in disease group


```{r, eval = FALSE}
# normalization of genes
dataNorm <- TCGAbiolinks::TCGAanalyze_Normalization(dataBRCA, geneInfo)

# quantile filter of genes
dataFilt <- TCGAanalyze_Filtering(
    tabDF = dataNorm,
    method = "quantile", 
    qnt.cut =  0.25
)

# selection of normal samples "NT" 
group1 <- TCGAquery_SampleTypes(colnames(dataFilt), typesample = c("NT"))
# selection of normal samples "TP" 
group2 <- TCGAquery_SampleTypes(colnames(dataFilt), typesample = c("TP"))

# Principal Component Analysis plot for ntop selected DEGs
pca <- TCGAvisualize_PCA(
    dataFilt = dataFilt,
    dataDEGsFiltLevel = dataDEGsFiltLevel,
    ntopgenes = 200, 
    group1 = group1,
    group2 =  group2
)
```

The result is shown below:
```{r, fig.width=6, fig.height=4, echo=FALSE, fig.align="center"}
library(png)
library(grid)
img <- readPNG("PCAtop200DEGs.png")
grid.raster(img)
```

## `TCGAvisualize_meanMethylation`: Mean DNA Methylation Analysis
Using the data and calculating the mean DNA methylation per group, it is possible 
to create a mean DNA methylation boxplot with the function 
`TCGAvisualize_meanMethylation` as follows:

```{r,include=FALSE,echo=FALSE, fig.height=5, message=FALSE, warning=FALSE,eval=FALSE}
query <- GDCquery(
    project = "TCGA-GBM",
    data.category = "DNA Methylation",
    platform = "Illumina Human Methylation 27",
    barcode = c(
        "TCGA-02-0058-01A-01D-0186-05", "TCGA-12-1597-01B-01D-0915-05",
        "TCGA-12-0829-01A-01D-0392-05", "TCGA-06-0155-01B-01D-0521-05",
        "TCGA-02-0099-01A-01D-0199-05", "TCGA-19-4068-01A-01D-1228-05",
        "TCGA-19-1788-01A-01D-0595-05", "TCGA-16-0848-01A-01D-0392-05"
    )
)
GDCdownload(query, method = "api")
data <- GDCprepare(query)

```


```{r, eval=FALSE, echo=TRUE, fig.height=5, message=FALSE, warning=FALSE}
query <- GDCquery(
    project = "TCGA-GBM",
    data.category = "DNA methylation",
    platform = "Illumina Human Methylation 27",
    barcode = c(
        "TCGA-02-0058-01A-01D-0186-05", "TCGA-12-1597-01B-01D-0915-05",
        "TCGA-12-0829-01A-01D-0392-05", "TCGA-06-0155-01B-01D-0521-05",
        "TCGA-02-0099-01A-01D-0199-05", "TCGA-19-4068-01A-01D-1228-05",
        "TCGA-19-1788-01A-01D-0595-05", "TCGA-16-0848-01A-01D-0392-05"
    )
)
GDCdownload(query, method = "api")
data <- GDCprepare(query)
```


## `TCGAvisualize_starburst`: Integration of gene expression and DNA methylation data 

The starburst plot is proposed to combine information from two volcano plots, 
and is applied for a study of DNA methylation and gene expression. It first introduced in 2010 [@noushmehr2010identification]. In order to
reproduce this plot, we will use the `TCGAvisualize_starburst` function.

The function creates Starburst plot for comparison of DNA methylation
and gene expression. The log10 (FDR-corrected P value) for DNA methylation is plotted in the x axis, and for gene expression in the y axis, for each gene. 
The black dashed line shows the FDR-adjusted P value of 0.01.

The arguments of this function are:

| Argument      | Description |   
|--------------|----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| exp | Object obtained by DEArnaSEQ function |
| group1 | The name of the group 1 Obs: Column p.value.adj.group1.group2 should exist |
| group2 | The name of the group 2. Obs: Column p.value.adj.group1.group2 should exist |
| exp.p.cut | expression p value cut-off |
| met.p.cut | methylation p value cut-off |
| diffmean.cut | If set, the probes with diffmean higher than methylation cut-off will be highlighted in the plot. And the data frame return will be subseted. |
| logFC.cut | If set, the probes with expression fold change higher than methylation cut-off will be highlighted in the plot. And the data frame return will be subseted. |
| met.platform | DNA methylation platform ("27K","450K" or "EPIC") |
| genome | Genome of reference ("hg38" or "hg19") used to identify nearest probes TSS |
| names | Add the names of the significant genes? Default: FALSE |
| names.fill | Names should be filled in a color box? Default: TRUE |
| filename | The filename of the file (it can be pdf, svg, png, etc) |
| return.plot | If true only plot object will be returned (pdf will not be created) |
| ylab | y axis text |
| xlab | x axis text |
| title | main title |
| legend | legend title |
| color | vector of colors to be used in graph |
| label | vector of labels to be used in graph |
| xlim | x limits to cut image |
| ylim | y limits to cut image |
| height | Figure height |
| width | Figure width |
| dpi | Figure dpi |

```{r, eval = FALSE}
starburst <- TCGAvisualize_starburst(
    met = coad.SummarizeExperiment, 
    exp = different.experssion.analysis.data,
    group1 = "CIMP.H",
    group2 = "CIMP.L",
    met.platform = "450K",
    genome = "hg19",
    met.p.cut = 10^-5, 
    exp.p.cut = 10^-5,
    names = TRUE
)
```

As a result, the function will a plot the figure below and return a matrix with 
the Gene_symbol and it status in relation to expression (up regulated/down regulated) and to methylation (Hyper/Hypo methylated). The case study 3, shows the complete pipeline
for creating this figure.


```{r, fig.width=6, fig.height=4, echo = FALSE, fig.align="center",hide=TRUE, message=FALSE,warning=FALSE}
library(png)
library(grid)
img <- readPNG("figure5star.png")
grid.raster(img)
```



# Session Information
******
```{r sessionInfo}
sessionInfo()
```

---
title: "Graphical User Interface (GUI)"
date: "`r BiocStyle::doc_date()`"
bibliography: bibliography.bib
vignette: >
  %\VignetteIndexEntry{"9. Graphical User Interface (GUI)"}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
knitr::opts_knit$set(progress = FALSE)
```

# Introduction


TCGAbiolinksGUI was created to help users more comfortable with graphical user interfaces (GUI) to search, download and analyze Cancer data. 
It offers a graphical user interface to the R/Bioconductor package 
[TCGAbiolinks](http://bioconductor.org/packages/TCGAbiolinks/) [@TCGAbiolinks], 
which is able to access The National Cancer Institute (NCI) Genomic Data Commons (GDC) through its  
[GDC Application Programming Interface (API)](https://gdc.cancer.gov/developers/gdc-application-programming-interface-api).
Additional packages from Bioconductor are included, such as [maftools](http://bioconductor.org/packages/maftools/) [@mayakonda2016maftools] and [ComplexHeatmap](http://bioconductor.org/packages/ComplexHeatmap/)  [@Gu20052016] packages to aid in visualizing the mutation data, 
[ELMER](http://bioconductor.org/packages/ELMER/) [@yao2015inferring] to 
identify regulatory enhancers using gene expression + DNA methylation data + motif analysis, 
[Pathview](http://bioconductor.org/packages/pathview/) [@luo2013pathview] for pathway-based data integration and visualization,
and [minfi](http://bioconductor.org/packages/minfi/) for the processing of DNA methylation raw idat files.

The GUI was created using [Shiny](https://shiny.rstudio.com/), 
a Web Application Framework for R, and uses
several packages to provide advanced features that can enhance Shiny apps, 
such as [shinyjs](https://github.com/daattali/shinyjs) to add JavaScript actions for the app,
[shinydashboard](https://github.com/rstudio/shinydashboard) to add dashboards 
and [shinyFiles](https://github.com/thomasp85/shinyFiles) to provide an API 
for client side access to the server file system. 
A running version of the GUI is found in [http://tcgabiolinks.fmrp.usp.br:3838/](http://tcgabiolinks.fmrp.usp.br:3838/)

This work has been supported by a grant from Henry Ford Hospital (H.N.) and by 
the São Paulo Research Foundation [FAPESP](http://www.fapesp.br/) (2016/01389-7 
to T.C.S. & H.N. and 2015/07925-5 to H.N.) the BridgeIRIS project, funded by INNOVIRIS, 
Region de Bruxelles Capitale, Brussels, Belgium, and by GENomic profiling of 
Gastrointestinal Inflammatory-Sensitive CANcers (GENGISCAN), Belgian FNRS PDR 
(T100914F to A.C., C.O. & G.B.). T.C.S. and B.P.B. were supported by the NCI 
Informatics Technology for Cancer Research program, NIH/NCI grant 1U01CA184826.

# Starting with TCGAbiolinksGUI 

## Installation 

To install the package from the [Bioconductor repository](http://bioconductor.org/packages/TCGAbiolinksGUI/) please use the following
code. 

```{r, eval = FALSE}
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("TCGAbiolinksGUI", dependencies = TRUE)
```

To install the development version of the package via GitHub:

```{r, eval = FALSE}
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
devtools::install_github("BioinformaticsFMRP/TCGAbiolinksGUI.data",ref = "R_3.4")
devtools::install_github("BioinformaticsFMRP/TCGAbiolinksGUI")
```

### Increasing loaded DLL

<div class="panel panel-danger">
<div class="panel-heading"> Increasing loaded DLL</div>
<div class="panel-body">

If you receive this error message:  `maximal number of DLLs reached...`
You will need to increase the maximum number of DLL R can load wit the
environment variable `R_MAX_NUM_DLLS`.

For MACOS please modify the file `/Library/Frameworks/R.framework/Resources/etc/Renviron`
and add `R_MAX_NUM_DLLS=150` in the end. Or you can run in R the following command as R administrator:
`system(' echo "R_MAX_NUM_DLLS=150" >> /Library/Frameworks/R.framework/Resources/etc/Renviron')`

For UBUNTU please modify the file `/usr/lib/R/etc/Renviron` and add `R_MAX_NUM_DLLS=150` in the end.
Or you can run in R the following command as R administrator:
`system(' echo "R_MAX_NUM_DLLS=150" >> /usr/lib/R/etc/Renviron')`

For other OS check https://stat.ethz.ch/R-manual/R-patched/library/base/html/Startup.html.

</div>
</div>

## Docker image

TCGAbiolinksGUI is available as Docker image (self-contained environments that contain everything needed to run the software), 
which can be easily run on Mac OS, Windows and Linux systems. 

The image can be obtained from Docker Hub: https://hub.docker.com/r/tiagochst/tcgabiolinksgui/

For more information please check: https://docs.docker.com/ and https://www.bioconductor.org/help/docker/

### Setting up image using graphical user interface (GUI) 

This [PDF](https://drive.google.com/open?id=0B0-8N2fjttG-QXp5LVlPQnVQejg) 
shows how to install and execute the image using [kitematic](https://kitematic.com/), which
offers a  graphical user interface (GUI) to control your app containers.

### Setting up image using command-line 

- Download image: docker pull tiagochst/tcgabiolinksgui
- To run RStudio Server and shiny-server, but the data is not saved if the container is stopped: 
`sudo docker run --name tcgabiolinksgui -d -P -v /home/$USER/docker:/home/rstudio -p 3333:8787 -p 3334:3838 tiagochst/tcgabiolinksgui`
1. For more information how data can be saved please read [this wiki](https://github.com/rocker-org/rocker/wiki/How-to-save-data) and see command below 

- To run RStudio Server, shiny-server and save the results in the host machine please use the code below: 
`sudo docker run --name tcgabiolinksgui -d -P -v /home/$USER/docker:/home/rstudio -p 3333:8787 -p 3334:3838 tiagochst/tcgabiolinksgui`
 1. In case Rstudio is not accessible please check if the folder created (docker) has the right permission
 2. If your system is windows or macOS you will need to change  `/home/$USER/docker` 
 to the correct system path. Examples can be found in this [github page](https://github.com/rocker-org/rocker/wiki/Sharing-files-with-host-machine)

- To stop the image:
1. Run  `sudo docker stop tcgabiolinksgui` to stop it

- To start the image again (after the first time ran with `docker run` and stopped).
1. Run  `sudo docker start tcgabiolinksgui` 

### Accessing the tools after the image is running:

- TCGAbiolinksGUI will be available at <your local IP>:3334/tcgabiolinksgui
- RStudio will be available at <your local IP>:3333 (***username: rstudio*** , ***password:rstudio***)

## Quick start

The following commands should be used to start the graphical user interface.

```{r, eval = FALSE}
library(TCGAbiolinksGUI)
TCGAbiolinksGUI()
```


## Video tutorials

To facilitate the use of this package, we have created some tutorial videos demonstrating the tool.
Some sections have video tutorials that if clicked will redirect to the video on youtube.
For the complete list of videos, please check this [youtube list](https://www.youtube.com/playlist?list=PLoDzAKMJh15m40f7OqOLAW0nJwkVStJIJ).

## PDF tutorials

For each section we created some PDFs with detailing the steps of each section: 
[Link to folder with PDFs](https://drive.google.com/drive/folders/0B0-8N2fjttG-Q25ldVVmUTVOTk0?usp=sharing)

## Workshops

* Bioc2017 (Boston, MA) - [workshop link](https://bioinformaticsfmrp.github.io/Bioc2017.TCGAbiolinks.ELMER/index.html)

## Question and issues
Please use [Github issues](https://github.com/BioinformaticsFMRP/TCGAbiolinksGUI/issues) if you want to file bug reports or feature requests.

# Citation

Please cite both TCGAbiolinks package and TCGAbiolinksGUI: 

* Silva TC, Colaprico A, Olsen C, Bontempi G, Ceccarelli M, Berman BP. , and Noushmehr H. "TCGAbiolinksGUI: A Graphical User Interface to analyze cancer molecular and clinical data."Bioinformatics -  Submitted for review.
* Colaprico A, Silva TC, Olsen C, Garofano L, Cava C, Garolini D, Sabedot T, Malta TM, Pagnotta SM, Castiglioni I, Ceccarelli M, Bontempi G and Noushmehr H. "TCGAbiolinks: an R/Bioconductor package for integrative analysis of TCGA data." Nucleic acids research (2015): gkv1507.

Other related publications to this package:

* "TCGA Workflow: Analyze cancer genomics and epigenomics data using Bioconductor packages". F1000Research [10.12688/f1000research.8923.1](http://dx.doi.org/doi:10.12688/f1000research.8923.1) [@10.12688/f1000research.8923.2]

If you used ELMER please cite:

* Yao, L., Shen, H., Laird, P. W., Farnham, P. J., & Berman, B. P. "Inferring regulatory element landscapes and transcription factor networks from cancer methylomes." Genome Biol 16 (2015): 105.
* Yao, Lijing, Benjamin P. Berman, and Peggy J. Farnham. "Demystifying the secret mission of enhancers: linking distal regulatory elements to target genes." Critical reviews in biochemistry and molecular biology 50.6 (2015): 550-573.

If you used OncoPrint plot and Heatmap Plot please cite:

* Gu, Zuguang, Roland Eils, and Matthias Schlesner. "Complex heatmaps reveal patterns and correlations in multidimensional genomic data." Bioinformatics (2016): btw313

If you used maftools please also cite:

* Mayakonda, Anand, and H. Phillip Koeffler. "Maftools: Efficient analysis, visualization and summarization of MAF files from large-scale cohort based cancer studies." bioRxiv (2016): 052662.

If you used Pathway plot please cite:

* Luo, Weijun, Brouwer and Cory (2013). “Pathview: an R/Bioconductor package for pathway-based data integration and visualization.” Bioinformatics, 29(14), pp. 1830-1831.


# References

---
title: "TCGAbiolinks: Searching GDC database"
date: "`r BiocStyle::doc_date()`"
vignette: >
    %\VignetteIndexEntry{"2. Searching GDC database"}
    %\VignetteEngine{knitr::rmarkdown}
    \usepackage[utf8]{inputenc}
---


<style> body {text-align: justify} </style>


```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
knitr::opts_knit$set(progress = FALSE)
```


**TCGAbiolinks** has provided a few functions to search GDC database.


---
```{r libs, message=FALSE, warning=FALSE, include=FALSE}
library(TCGAbiolinks)
library(SummarizedExperiment)
library(dplyr)
library(DT)
```


#  Useful information

<div class="panel panel-info">
<div class="panel-heading">Understanding the barcode</div>
<div class="panel-body">

A TCGA barcode is composed of a collection of identifiers. Each specifically identifies a TCGA data element. Refer to the following figure for an illustration of how metadata identifiers comprise a barcode. An aliquot barcode contains the highest number of identifiers.

Example: 

- Aliquot barcode: TCGA-G4-6317-02A-11D-2064-05
- Participant: TCGA-G4-6317
- Sample: TCGA-G4-6317-02

For more information check [GDC TCGA barcodes](https://docs.gdc.cancer.gov/Encyclopedia/pages/TCGA_Barcode/)
</div>
</div>

# Searching arguments

You can easily search GDC data using the `GDCquery` function.

Using a summary of filters as used in the TCGA portal, the function works
with the following arguments:

| ?project 	| A list of valid project (see table below)] 	|  	|
|-----------------------	|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------	|-------------------------------------	|
| data.category 	| A valid project (see list with TCGAbiolinks:::getProjectSummary(project)) 	|  	|
| data.type 	| A data type to filter the files to download 	|  	|
| workflow.type 	| GDC workflow type 	|  	|
| access 	| Filter by access type. Possible values: controlled, open 	|  	|
| platform 	| Example: 	|  	|
|  	| CGH- 1x1M_G4447A 	| IlluminaGA_RNASeqV2 	|
|  	| AgilentG4502A_07 	| IlluminaGA_mRNA_DGE 	|
|  	| Human1MDuo 	| HumanMethylation450 	|
|  	| HG-CGH-415K_G4124A 	| IlluminaGA_miRNASeq 	|
|  	| HumanHap550 	| IlluminaHiSeq_miRNASeq 	|
|  	| ABI 	| H-miRNA_8x15K 	|
|  	| HG-CGH-244A 	| SOLiD_DNASeq 	|
|  	| IlluminaDNAMethylation_OMA003_CPI 	| IlluminaGA_DNASeq_automated 	|
|  	| IlluminaDNAMethylation_OMA002_CPI 	| HG-U133_Plus_2 	|
|  	| HuEx- 1_0-st-v2 	| Mixed_DNASeq 	|
|  	| H-miRNA_8x15Kv2 	| IlluminaGA_DNASeq_curated 	|
|  	| MDA_RPPA_Core 	| IlluminaHiSeq_TotalRNASeqV2 	|
|  	| HT_HG-U133A 	| IlluminaHiSeq_DNASeq_automated 	|
|  	| diagnostic_images 	| microsat_i 	|
|  	| IlluminaHiSeq_RNASeq 	| SOLiD_DNASeq_curated 	|
|  	| IlluminaHiSeq_DNASeqC 	| Mixed_DNASeq_curated 	|
|  	| IlluminaGA_RNASeq 	| IlluminaGA_DNASeq_Cont_automated 	|
|  	| IlluminaGA_DNASeq 	| IlluminaHiSeq_WGBS 	|
|  	| pathology_reports 	| IlluminaHiSeq_DNASeq_Cont_automated 	|
|  	| Genome_Wide_SNP_6 	| bio 	|
|  	| tissue_images 	| Mixed_DNASeq_automated 	|
|  	| HumanMethylation27 	| Mixed_DNASeq_Cont_curated 	|
|  	| IlluminaHiSeq_RNASeqV2 	| Mixed_DNASeq_Cont 	|
| file.type 	| To be used in the legacy database for some platforms, to define which file types to be used. 	|  	|
| barcode 	| A list of barcodes to filter the files to download 	|  	|
| experimental.strategy 	| Filter to experimental strategy. Harmonized: WXS, RNA-Seq, miRNA-Seq, Genotyping Array. |  	|
| sample.type 	| A sample type to filter the files to download 	|  	|


## project options
The options for the field `project` are below:
```{r, eval = TRUE, echo = FALSE}
datatable(
    TCGAbiolinks:::getGDCprojects(),
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 10), 
    rownames = FALSE,
    caption = "List of projects"
)
```

## sample.type options
The options for the field `sample.type` are below:
```{r, eval = TRUE, echo = FALSE}
datatable(
    TCGAbiolinks:::getBarcodeDefinition(),
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 10), 
    rownames = FALSE,
    caption = "List sample types"
)
```

The other fields (data.category, data.type, workflow.type, platform, file.type) can be found below. 
Please, note that these tables are still incomplete.

## Harmonized data options 

```{r Harmonized_data_options, echo=FALSE}
datatable(
    readr::read_csv("https://docs.google.com/spreadsheets/d/1f98kFdj9mxVDc1dv4xTZdx8iWgUiDYO-qiFJINvmTZs/export?format=csv&gid=2046985454",col_types = readr::cols()),
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 40), 
    rownames = FALSE
)
```


# Harmonized database examples

## DNA methylation data: Recurrent tumor samples

In this example we will access the harmonized database
and search for all DNA methylation data for recurrent glioblastoma multiform (GBM) 
and low grade gliomas (LGG) samples.


```{r message=FALSE, warning=FALSE}
query <- GDCquery(
    project = c("TCGA-GBM", "TCGA-LGG"),
    data.category = "DNA Methylation",
    platform = c("Illumina Human Methylation 450"),
    sample.type = "Recurrent Tumor"
)
datatable(
    getResults(query), 
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
    rownames = FALSE
)
```

## Samples with DNA methylation and gene expression data

In this example we will access the harmonized database 
and search for all patients with DNA methylation (platform HumanMethylation450k) and gene expression data
for Colon Adenocarcinoma tumor (TCGA-COAD).


```{r message=FALSE, warning = FALSE, eval = FALSE}
query_met <- GDCquery(
    project = "TCGA-COAD",
    data.category = "DNA Methylation",
    platform = c("Illumina Human Methylation 450")
)
query_exp <- GDCquery(
    project = "TCGA-COAD",
    data.category = "Transcriptome Profiling",
    data.type = "Gene Expression Quantification", 
    workflow.type = "STAR - Counts"
)

# Get all patients that have DNA methylation and gene expression.
common.patients <- intersect(
    substr(getResults(query_met, cols = "cases"), 1, 12),
    substr(getResults(query_exp, cols = "cases"), 1, 12)
)

# Only select the first 5 patients
query_met <- GDCquery(
    project = "TCGA-COAD",
    data.category = "DNA Methylation",
    platform = c("Illumina Human Methylation 450"),
    barcode = common.patients[1:5]
)

query_exp <- GDCquery(
    project = "TCGA-COAD",
    data.category = "Transcriptome Profiling",
    data.type = "Gene Expression Quantification", 
    workflow.type = "STAR - Counts",
    barcode = common.patients[1:5]
)
```

```{r results_matched, message=FALSE, warning=FALSE, eval = FALSE}
datatable(
    getResults(query_met, cols = c("data_type","cases")),
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
    rownames = FALSE
)
datatable(
    getResults(query_exp, cols = c("data_type","cases")), 
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
    rownames = FALSE
)
```

## Raw Sequencing Data: Finding the match between file names and barcode for Controlled data.

This example shows how the user can search for breast cancer Raw Sequencing Data ("Controlled") 
and verify the name of the files and the barcodes associated with it.

```{r queries,message=FALSE, warning=FALSE}
query <- GDCquery(
    project = "TCGA-ACC", 
    data.category = "Sequencing Reads",
    data.type = "Aligned Reads", 
    data.format = "bam",
    workflow.type = "STAR 2-Pass Transcriptome"
)
# Only first 10 to make render faster
datatable(
    getResults(query, rows = 1:10,cols = c("file_name","cases")), 
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
    rownames = FALSE
)

query <- GDCquery(
    project = "TCGA-ACC", 
    data.category = "Sequencing Reads",
    data.type = "Aligned Reads", 
    data.format = "bam",
    workflow.type = "STAR 2-Pass Genome"
)
# Only first 10 to make render faster
datatable(
    getResults(query, rows = 1:10,cols = c("file_name","cases")), 
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
    rownames = FALSE
)

query <- GDCquery(
    project = "TCGA-ACC", 
    data.category = "Sequencing Reads",
    data.type = "Aligned Reads", 
    data.format = "bam",
    workflow.type = "STAR 2-Pass Chimeric"
)
# Only first 10 to make render faster
datatable(
    getResults(query, rows = 1:10,cols = c("file_name","cases")), 
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
    rownames = FALSE
)

query <- GDCquery(
    project = "TCGA-ACC", 
    data.category = "Sequencing Reads",
    data.type = "Aligned Reads", 
    data.format = "bam",
    workflow.type = "BWA-aln"
)
# Only first 10 to make render faster
datatable(
    getResults(query, rows = 1:10,cols = c("file_name","cases")), 
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
    rownames = FALSE
)

query <- GDCquery(
    project = "TCGA-ACC", 
    data.category = "Sequencing Reads",
    data.type = "Aligned Reads", 
    data.format = "bam",
    workflow.type = "BWA with Mark Duplicates and BQSR"
)
# Only first 10 to make render faster
datatable(
    getResults(query, rows = 1:10,cols = c("file_name","cases")), 
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
    rownames = FALSE
)
```


# Get Manifest file

If you want to get the manifest file from the query object you can use the function *getManifest*. If you 
set save to `TRUE` a txt file that can be used with GDC-client Data transfer tool (DTT) or with its GUI version [ddt-ui](https://github.com/NCI-GDC/dtt-ui) will be created.

```{r get_manifest, message = FALSE, warning = FALSE}
getManifest(query, save = FALSE) 
```

# ATAC-seq data

For the moment, ATAC-seq data is available at the [GDC publication page](https://gdc.cancer.gov/about-data/publications/ATACseq-AWG).
Also, for more details, you can check an ATAC-seq workshop at http://rpubs.com/tiagochst/atac_seq_workshop

The list of file available is below:
```{r message=FALSE, warning=FALSE}
datatable(
    getResults(TCGAbiolinks:::GDCquery_ATAC_seq())[,c("file_name","file_size")], 
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
    rownames = FALSE
)
```

You can use the function `GDCquery_ATAC_seq` filter the manifest table and use `GDCdownload` to save the data locally.
```{r GDCquery_ATAC_seq, message=FALSE, warning=FALSE,eval = FALSE}
query <- TCGAbiolinks:::GDCquery_ATAC_seq(file.type = "rds") 
GDCdownload(query, method = "client")

query <- TCGAbiolinks:::GDCquery_ATAC_seq(file.type = "bigWigs") 
GDCdownload(query, method = "client")
```

# Summary of available files per patient

Retrieve the numner of files under each data_category + data_type + experimental_strategy + platform.
Almost like https://portal.gdc.cancer.gov/exploration

```{r getSampleFilesSummary, message=FALSE, warning=FALSE,eval = TRUE}
tab <-  getSampleFilesSummary(project = "TCGA-ACC")
datatable(
    head(tab),
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
    rownames = FALSE
)
```

---
title: "Introduction"
date: "`r BiocStyle::doc_date()`"
vignette: >
  %\VignetteIndexEntry{"1. Introduction"}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
knitr::opts_knit$set(progress = FALSE)
```

<hr>
TCGAbiolinks is able to access The National Cancer Institute (NCI) Genomic Data Commons (GDC) thorough its  
[GDC Application Programming Interface (API)](https://gdc.cancer.gov/developers/gdc-application-programming-interface-api) 
to search, download and prepare relevant data for analysis in R. 

# News
<hr>
- April 2022:
  - Started to add support for GENCODE v36 pipelines
  - Add stemness score functions
- December 2019: 
  - Added support to non TCGA/TARGET projects - https://rpubs.com/tiagochst/TCGAbiolinks_RNA-seq_new_projects
  - Added support to linked Omics data retrieval - https://rpubs.com/tiagochst/linkedOmics
  - Included Glioma classifier from GUI to the main package - https://bioconductor.org/packages/devel/bioc/vignettes/TCGAbiolinks/inst/doc/classifiers.html
- Added support to BCR Biotab clinical files   
- Workshop materials (ATAC-seq, ELMER and TCGAbiolinks) were added to vignette (https://bioconductor.org/packages/devel/bioc/vignettes/TCGAbiolinks/inst/doc/index.html)


# Citation
<hr>
If you use TCGAbiolinks, please cite:

* Colaprico, Antonio, et al. "TCGAbiolinks: an R/Bioconductor package for integrative analysis of TCGA data." Nucleic acids research 44.8 (2015): e71-e71.
* Silva, Tiago C., et al. "TCGA Workflow: Analyze cancer genomics and epigenomics data using Bioconductor packages." F1000Research 5 (2016). (https://f1000research.com/articles/5-1542/v2)
* Mounir, Mohamed, et al. "New functionalities in the TCGAbiolinks package for the study and integration of cancer data from GDC and GTEx." PLoS computational biology 15.3 (2019): e1006701. (https://doi.org/10.1371/journal.pcbi.1006701)

# Other useful links
<hr>
* Gao, Galen F., et al. "Before and After: Comparison of Legacy and Harmonized TCGA Genomic Data Commons’ Data." Cell systems 9.1 (2019): 24-34. (https://doi.org/10.1016/j.cels.2019.06.006)

* TCGA Workflow Analyze cancer genomics and epigenomics data using Bioconductor packages: http://bioconductor.org/packages/TCGAWorkflow/

# Installation
<hr>

You can install the stable version from [Bioconductor](http://bioconductor.org/packages/release/bioc/html/TCGAbiolinks.html).
If you are having issues with the stable version, try using the development version.

* Stable version:
```{r message=FALSE, warning=FALSE, eval=FALSE}
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("TCGAbiolinks")
```

* Development version:
```{r message=FALSE, warning=FALSE, eval=FALSE}
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")
BiocManager::install("BioinformaticsFMRP/TCGAbiolinksGUI.data")
BiocManager::install("BioinformaticsFMRP/TCGAbiolinks")
```

# Question and issues
<hr>
Please use [Github issues](https://github.com/BioinformaticsFMRP/TCGAbiolinks/issues) if you want to file bug reports or feature requests.

# Required libraries
<hr>
The examples in this tutorial use the following libraries: 
```{r message=FALSE, warning=FALSE, include=TRUE}
library(TCGAbiolinks)
library(dplyr)
library(DT)
```

# Session info
<hr>
```{r}
version
packageVersion("TCGAbiolinks")
```

---
title: "Classifiers methods"
bibliography: bibliography.bib    
vignette: >
    %\VignetteIndexEntry{10. Classifiers}
    %\VignetteEngine{knitr::rmarkdown}
---
  
```{r setup, include=FALSE}
knitr::opts_chunk$set(dpi = 300)
knitr::opts_chunk$set(cache = FALSE)
```
  
```{r, echo = FALSE,hide=TRUE, message=FALSE,warning=FALSE}
library(TCGAbiolinks)
```

```{r message=FALSE, warning=FALSE, include=FALSE}
library(SummarizedExperiment)
library(dplyr)
library(DT)
```

<br>

## Classifying gliomas samples with `gliomaClassifier`
<hr>

Classifying glioma samples with DNA methylation array based on:


**Ceccarelli, Michele, et al. "Molecular profiling reveals biologically discrete subsets and pathways of progression in diffuse glioma." Cell 164.3 (2016): 550-563.** (https://doi.org/10.1016/j.cell.2015.12.028)

Possible classifications are: 

- Mesenchymal-like 
- Classic-like
- G-CIMP-high
- G-CIMP-low
- LGm6-GBM
- Codel

## Data
<hr>

The input data can be either a Summarized Experiment object of a matrix 
(samples as columns, probes as rows) from the following platforms:

- HM27
- HM450 
- EPIC array.

In this example we will retrieve two samples from TCGA and classify them expecting 
the same result as the paper.

```{r, eval = FALSE, message = FALSE, results = "hide"}
query <- GDCquery(
    project = "TCGA-GBM",
    data.category = "DNA Methylation",
    barcode = c("TCGA-06-0122","TCGA-14-1456"),
    platform = "Illumina Human Methylation 27",
    data.type = "Methylation Beta Value"
)
GDCdownload(query)
dnam <- GDCprepare(query)
```

```{r, eval = FALSE}
assay(dnam)[1:5,1:2]
```

## Function
<hr>

```{r, eval = FALSE}
classification <- gliomaClassifier(dnam)
```

## Results
<hr>
The classfier will return a list of 3 data frames:

1. Sample final classification
2. Each model final classification
3. Each class probability of classification

```{r, eval = FALSE}
names(classification)
classification$final.classification
classification$model.classifications
classification$model.probabilities
```

## Comparing results with paper
<hr>
```{R}
TCGAquery_subtype("GBM") %>%
 dplyr::filter(patient %in% c("TCGA-06-0122","TCGA-14-1456")) %>%
 dplyr::select("patient","Supervised.DNA.Methylation.Cluster")
```

---
title: "TCGAbiolinks: Downloading and preparing files for analysis"
date: "`r BiocStyle::doc_date()`"
vignette: >
  %\VignetteIndexEntry{"3. Downloading and preparing files for analysis"}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
knitr::opts_knit$set(progress = FALSE)
```

```{r message=FALSE, warning=FALSE, include=FALSE}
library(TCGAbiolinks)
library(SummarizedExperiment)
library(dplyr)
library(DT)
```

**TCGAbiolinks** has provided a few functions to download and prepare data from GDC for analysis.
This section starts by explaining the different downloads methods and the SummarizedExperiment object, which 
is the default data structure used in TCGAbiolinks, followed by some examples.


---

# Downloading and preparing data for analysis

<div class="panel panel-info">
<div class="panel-heading">Data download: Methods differences</div>
<div class="panel-body">


There are two methods to download GDC data using TCGAbiolinks:

- `client`: this method creates a MANIFEST file and downloads the data using [GDC Data Transfer Tool](https://gdc.cancer.gov/access-data/gdc-data-transfer-tool)
this method is more reliable but it might be slower compared to the api method.
- `api`: this method uses the [GDC Application Programming Interface (API)](https://gdc.cancer.gov/developers/gdc-application-programming-interface-api) to download the data.
This will create a MANIFEST file and the data downloaded will be compressed into a tar.gz file. If the size and the number of the files are too big this tar.gz will be too big
which might have a high probability of download failure. To solve that we created the `files.per.chunk` argument which will split the files
into small chunks, for example, if `chunks.per.download` is equal to 10 we will download only 10 files inside each tar.gz.

</div>
</div>



<div class="panel panel-info">
<div class="panel-heading">Data prepared: SummarizedExperiment object</div>
<div class="panel-body">


A [SummarizedExperiment object](http://www.nature.com/nmeth/journal/v12/n2/fig_tab/nmeth.3252_F2.html) 
has three main matrices that can be accessed using the [SummarizedExperiment package](http://bioconductor.org/packages/SummarizedExperiment/)): 

- Sample matrix information is accessed via `colData(data)`: stores sample information. TCGAbiolinks will add indexed clinical data and subtype information from marker TCGA papers.
- Assay matrix information is accessed via `assay(data)`: stores molecular data 
- Feature matrix information (gene information) is accessed via `rowRanges(data)`: stores metadata about the features, including their genomic ranges

</div>
</div>

<div class="panel panel-warning">
<div class="panel-heading">Summarized Experiment: annotation information</div>
<div class="panel-body">


When using the function `GDCprepare` there is an argument called `SummarizedExperiment`
which defines the output type a Summarized Experiment (default option) or a data frame.
To create a summarized Experiment object we annotate the data with genomic positions
with last patch release version of the genome available. 


Also,  the latest DNA methylation metadata is available at: [http://zwdzwd.github.io/InfiniumAnnotation](http://zwdzwd.github.io/InfiniumAnnotation)

</div>
</div>


<div class="panel panel-danger">
<div class="panel-heading">simpleWarning in file.create(to[okay]) error </div>
<div class="panel-body">

If you received the warning/error `simpleWarning in file.create(to[okay])` 
try setting `directory`
as described by some users:
https://github.com/BioinformaticsFMRP/TCGAbiolinks/issues/153#issuecomment-856385673

in `GDCprepare` and `GDCdownload`
```
<simpleWarning in file.create(to[okay]): cannot create file ... reason 'No such file or directory'>
```

</div>
</div>


## Arguments 

### `GDCdownload`

| Argument 	| Description	|
|-----------------|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| query           | A query for GDCquery function        |
| token.file      | Token file to download controlled data (only for method = "client")           |
| method          | Uses the API (POST method) or gdc client tool. Options "api", "client". API is faster, but the data might get corrupted in the download, and it might need to be executed again     |
| directory       | Directory/Folder where the data was downloaded. Default: GDCdata         |
| files.per.chunk | This will make the API method only download n (files.per.chunk) files at a time. This may reduce the download problems when the data size is too large. Expected a integer number (example files.per.chunk = 6) |

### `GDCprepare`
| Argument 	| Description	|
|-------------------------------	|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------	|
| query 	| A query for GDCquery function 	|
| save 	| Save result as RData object? 	|
| save.filename 	| Name of the file to be save if empty an automatic will be created 	|
| directory 	| Directory/Folder where the data was downloaded. Default: GDCdata 	|
| summarizedExperiment 	| Create a summarizedExperiment? Default TRUE (if possible) 	|
| remove.files.prepared 	| Remove the files read? Default: FALSE This argument will be considered only if save argument is set to true 	|
| add.gistic2.mut 	| If a list of genes (gene symbol) is given, columns with gistic2 results from GDAC firehose (hg19) and a column indicating if there is or not mutation in that gene (hg38) (TRUE or FALSE - use the MAF file for more information) will be added to the sample matrix in the summarized Experiment object. 	|
| mut.pipeline 	| If add.gistic2.mut is not NULL this field will be taken in consideration. Four separate variant calling pipelines are implemented for GDC data harmonization. Options: muse, varscan2, somaticsniper, MuTect2. For more information: https://gdc-docs.nci.nih.gov/Data/Bioinformatics_Pipelines/DNA_Seq_Variant_Calling_Pipeline/ 	|
| mutant_variant_classification 	| List of mutant_variant_classification that will be consider a sample mutant or not. Default: "Frame_Shift_Del", "Frame_Shift_Ins", "Missense_Mutation", "Nonsense_Mutation", "Splice_Site", "In_Frame_Del", "In_Frame_Ins", "Translation_Start_Site", "Nonstop_Mutation" 	|



## Search and download data for two samples from database

In this example we will download gene expression quantification from harmonized database 
(data aligned against genome of reference hg38).
Also, it shows the object data and metadata.

```{r results = 'hide', message=FALSE, warning=FALSE, eval=FALSE}
# Gene expression aligned against hg38
query <- GDCquery(
    project = "TCGA-GBM",
    data.category = "Transcriptome Profiling",
    data.type = "Gene Expression Quantification", 
    workflow.type = "STAR - Counts",
    barcode = c("TCGA-14-0736-02A-01R-2005-01", "TCGA-06-0211-02A-02R-2005-01")
)
GDCdownload(query = query)
data <- GDCprepare(query = query)
```

```{r message=FALSE, warning=FALSE, include=FALSE}
data <- gbm.exp.harmonized
```

```{r message=FALSE, warning=FALSE}
datatable(
    as.data.frame(colData(data)), 
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
    rownames = FALSE
)

datatable(
    assay(data)[1:20,], 
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
    rownames = TRUE
)

rowRanges(data)
```


# `GDCprepare`: Outputs

This function is still under development, it is not working for all cases. See the tables below with the status.
Examples of query, download, prepare can be found in this [gist](https://gist.github.com/tiagochst/a701bad3fa3800ade7063760755e0aad).

## Harmonized data

| Data.category               | Data.type                         | Workflow Type   | Output                                                                      |
|-----------------------------|-----------------------------------|-----------------|-----------------------------------------------------------------------------|
| Transcriptome Profiling     | Gene Expression Quantification    | STAR - Counts  | Dataframe or SummarizedExperiment|
|                             | Isoform Expression Quantification | Not needed      |        |
|                             | miRNA Expression Quantification   | Not needed      | Dataframe |
| Copy number variation       | Copy Number Segment               |                 | Dataframe  |
|                             | Masked Copy Number Segment        |                 | Dataframe  |
|                             | Gene Level Copy Number      |        | Dataframe  |
| DNA Methylation | Methylation Beta Value           |                 |   Dataframe or SummarizedExperiment   |
| Simple Nucleotide Variation | Masked Somatic Mutation           |                 |  Dataframe |
| Raw Sequencing Data         |               |       |          |
| Biospecimen                 | Slide Image        |         |         |
| Biospecimen                 | Biospecimen Supplement            |      |             |
| Clinical                    |                |       |                  |

# Examples


## Harmonized database: data aligned against hg38


### Copy Number Variation

#### Copy Number Segment
```{r, eval = FALSE}
query <- GDCquery(
    project = "TCGA-ACC", 
    data.category = "Copy Number Variation",
    data.type = "Copy Number Segment",
    barcode = c( "TCGA-OR-A5KU-01A-11D-A29H-01", "TCGA-OR-A5JK-01A-11D-A29H-01")
)
GDCdownload(query)
data <- GDCprepare(query)
```


#### Gene Level Copy Number

```{r, eval = FALSE}
query <- GDCquery(
    project = "TCGA-ACC",
    data.category = "Copy Number Variation",
    data.type = "Gene Level Copy Number",              
    access = "open"
)
GDCdownload(query)
data <- GDCprepare(query)
```


#### Allele-specific Copy Number Segment

```{r, eval = FALSE}
query <- GDCquery(
    project = "TCGA-ACC",
    data.category = "Copy Number Variation",
    data.type = "Allele-specific Copy Number Segment",              
    access = "open"
)
GDCdownload(query)
data <- GDCprepare(query)
```

#### Masked Copy Number Segment

```{r, eval = FALSE}
query <- GDCquery(
    project = "TCGA-ACC",
    data.category = "Copy Number Variation",
    data.type = "Masked Copy Number Segment",              
    access = "open"
)
GDCdownload(query)
data <- GDCprepare(query)
```

### Transcriptome Profiling 

#### Gene Expression Quantification

For more examples, please check: http://rpubs.com/tiagochst/TCGAbiolinks_RNA-seq_new_projects

```{r, eval = FALSE}
# mRNA pipeline: https://gdc-docs.nci.nih.gov/Data/Bioinformatics_Pipelines/Expression_mRNA_Pipeline/
query.exp.hg38 <- GDCquery(
    project = "TCGA-GBM", 
    data.category = "Transcriptome Profiling", 
    data.type = "Gene Expression Quantification", 
    workflow.type = "STAR - Counts",
    barcode =  c("TCGA-14-0736-02A-01R-2005-01", "TCGA-06-0211-02A-02R-2005-01")
)
GDCdownload(query.exp.hg38)
expdat <- GDCprepare(
    query = query.exp.hg38,
    save = TRUE, 
    save.filename = "exp.rda"
)
```


#### miRNA Expression Quantification
```{r, eval = FALSE}
library(TCGAbiolinks)
query.mirna <- GDCquery(
    project = "TARGET-AML", 
    experimental.strategy = "miRNA-Seq",
    data.category = "Transcriptome Profiling", 
    barcode = c("TARGET-20-PATDNN","TARGET-20-PAPUNR"),
    data.type = "miRNA Expression Quantification"
)
GDCdownload(query.mirna)
mirna <- GDCprepare(
    query = query.mirna,
    save = TRUE, 
    save.filename = "mirna.rda"
)

```


#### Isoform Expression Quantification
```{r, eval = FALSE}

query.isoform <- GDCquery(
    project = "TARGET-AML", 
    experimental.strategy = "miRNA-Seq",
    data.category = "Transcriptome Profiling", 
    barcode = c("TARGET-20-PATDNN","TARGET-20-PAPUNR"),
    data.type = "Isoform Expression Quantification"
)
GDCdownload(query.isoform)

isoform <- GDCprepare(
    query = query.isoform,
    save = TRUE, 
    save.filename = "mirna-isoform.rda"
)
```

### DNA methylation

#### Beta-values

```{r, eval = FALSE}
query_met.hg38 <- GDCquery(
    project = "TCGA-BRCA", 
    data.category = "DNA Methylation", 
    data.type = "Methylation Beta Value",
    platform = "Illumina Human Methylation 27", 
    barcode = c("TCGA-B6-A0IM")
)
GDCdownload(query_met.hg38)
data.hg38 <- GDCprepare(query_met.hg38)

query_met.hg38 <- GDCquery(
    project= "TCGA-LGG", 
    data.category = "DNA Methylation", 
    data.type = "Methylation Beta Value",
    platform = "Illumina Human Methylation 450", 
    barcode = c("TCGA-HT-8111-01A-11D-2399-05","TCGA-HT-A5R5-01A-11D-A28N-05")
)
GDCdownload(query_met.hg38)
data.hg38 <- GDCprepare(query_met.hg38)


query_met.hg38 <- GDCquery(
    project= "HCMI-CMDC", 
    data.category = "DNA Methylation", 
    data.type = "Methylation Beta Value",
    platform = "Illumina Methylation Epic", 
    barcode = c("HCM-BROD-0045")
)
GDCdownload(query_met.hg38)
data.hg38 <- GDCprepare(query_met.hg38)
```

#### IDAT files

```{R, eval = FALSE}
query <- GDCquery(
    project = "TCGA-BRCA",
    data.category = "DNA Methylation",
    data.type = "Masked Intensities",
    platform = "Illumina Human Methylation 27"
)
GDCdownload(query, files.per.chunk=10)
betas <- GDCprepare(query)

query <- GDCquery(
    project = "HCMI-CMDC",
    data.category = "DNA Methylation",
    data.type = "Masked Intensities",
    platform = "Illumina Methylation Epic"
)
GDCdownload(query, files.per.chunk = 10)
betas <- GDCprepare(query)


query <- GDCquery(
    project = "CPTAC-3",
    data.category = "DNA Methylation",
    data.type = "Masked Intensities",
    platform = "Illumina Methylation Epic"
)
GDCdownload(query, files.per.chunk=10)
betas <- GDCprepare(query)

query <- GDCquery(
    project = "TCGA-BRCA",
    data.category = "DNA Methylation",
    data.type = "Masked Intensities",
    platform = "Illumina Methylation Epic"
)
GDCdownload(query, files.per.chunk = 10)
betas <- GDCprepare(query)


```


### Proteome Profiling 

#### Protein Expression Quantification

```{r, eval = FALSE}
query.rppa <- GDCquery(
    project = "TCGA-ESCA", 
    data.category = "Proteome Profiling",
    data.type = "Protein Expression Quantification"
)
GDCdownload(query.rppa) 
rppa <- GDCprepare(query.rppa) 
```

### Clinical

```{R, eval = FALSE}

query <- GDCquery(
    project = "TCGA-COAD",
    data.category = "Clinical",
    data.type = "Clinical Supplement",
    data.format = "BCR XML",
    barcode = "TCGA-A6-5664"
)
GDCdownload(query)
drug <- GDCprepare_clinic(query,"drug")

query <- GDCquery(
    project = "TCGA-COAD",
    data.category = "Clinical",
    data.type = "Clinical Supplement",
    data.format = "BCR OMF XML",
    barcode = "TCGA-AD-6964"
)
GDCdownload(query)


query <- GDCquery(
    project = "TCGA-ACC", 
    data.category = "Clinical",
    data.type = "Clinical Supplement", 
    data.format = "BCR Biotab"
)
GDCdownload(query)
clinical.BCRtab.all <- GDCprepare(query)
names(clinical.BCRtab.all)

query <- GDCquery(
    project = "TCGA-ACC", 
    data.category = "Clinical",
    data.type = "Clinical Supplement", 
    data.format = "BCR Biotab",
    file.type = "radiation"
)
GDCdownload(query)
clinical.BCRtab.radiation <- GDCprepare(query)
```

### Simple Nucleotide Variation 

#### Masked Somatic Mutation

For more information please check:
https://docs.gdc.cancer.gov/Data/Bioinformatics_Pipelines/DNA_Seq_Variant_Calling_Pipeline/

```{r, eval = FALSE}
query <- GDCquery(
    project = "TCGA-HNSC", 
    data.category = "Simple Nucleotide Variation",
    data.type = "Masked Somatic Mutation",
    access = "open"
)
GDCdownload(query)
maf <- GDCprepare(query)
```

### Single cell

GDC Single Cell RNA-Seq information: 
https://docs.gdc.cancer.gov/Data/Bioinformatics_Pipelines/Expression_mRNA_Pipeline/#scrna-seq-pipeline-single-nuclei

```{r, eval = FALSE}
query.sc.analysis <- GDCquery(
    project = "CPTAC-3", 
    data.category = "Transcriptome Profiling",
    access = "open",
    data.type = "Single Cell Analysis",
    data.format =  "TSV"
)  
GDCdownload(query.sc.analysis)
Single.Cell.Analysis.list <- GDCprepare(query.sc.analysis)
```

```{r, eval = FALSE,include=F}
query.hdF5 <- GDCquery(
    project = "CPTAC-3", 
    data.category = "Transcriptome Profiling",
    access = "open",
    data.type = "Single Cell Analysis",
    barcode = c("CPT0167860015","CPT0206880004"),
    data.format =  "HDF5"
)  
GDCdownload(query.hdF5)
df.HDF5 <- GDCprepare(query.hdF5)
```

```{r, eval = FALSE}
query.raw.counts <- GDCquery(
    project = "CPTAC-3", 
    data.category = "Transcriptome Profiling",
    access = "open",
    data.type = "Gene Expression Quantification",
    barcode = c("CPT0167860015","CPT0206880004"),
    workflow.type = "CellRanger - 10x Raw Counts"
)  
GDCdownload(query.raw.counts)
raw.counts.list <- GDCprepare(query.raw.counts)
```

```{r, eval = FALSE}
query.filtered.counts <- GDCquery(
    project = "CPTAC-3", 
    data.category = "Transcriptome Profiling",
    access = "open",
    data.type = "Gene Expression Quantification",
    barcode = c("CPT0167860015","CPT0206880004"),
    workflow.type = "CellRanger - 10x Filtered Counts"
)  
GDCdownload(query.filtered.counts)
filtered.counts.list <- GDCprepare(query.filtered.counts)
```


```{r, eval = FALSE}
query.sc.dea <- GDCquery(
    project = "CPTAC-3", 
    data.category = "Transcriptome Profiling",
    access = "open",
    data.type = "Differential Gene Expression",
    barcode = c("CPT0167860015","CPT0206880004"),
    workflow.type = "Seurat - 10x Chromium"
)  
GDCdownload(query.sc.dea)
sc.dea.list <- GDCprepare(query.sc.dea)
```

---
title: "TCGAbiolinks: Searching GDC database"
date: "`r BiocStyle::doc_date()`"
vignette: >
    %\VignetteIndexEntry{"2. Searching GDC database"}
    %\VignetteEngine{knitr::rmarkdown}
    \usepackage[utf8]{inputenc}
---


<style> body {text-align: justify} </style>


```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
knitr::opts_knit$set(progress = FALSE)
```


**TCGAbiolinks** has provided a few functions to search GDC database.
This section starts by explaining the different GDC sources (Harmonized and Legacy Archive), followed by some examples
how to access them.


---
```{r message=FALSE, warning=FALSE, include=FALSE}
library(TCGAbiolinks)
library(SummarizedExperiment)
library(dplyr)
library(DT)
```


#  Useful information

<div class="panel panel-info">
<div class="panel-heading">Different sources: Legacy vs Harmonized</div>
<div class="panel-body">


There are two available sources to download GDC data using TCGAbiolinks:

- GDC Legacy Archive : provides access to an unmodified copy of data that was previously stored in
[CGHub](https://cghub.ucsc.edu/) and in the TCGA Data Portal hosted by the TCGA Data Coordinating Center (DCC), in which uses
as references GRCh37 (hg19) and GRCh36 (hg18).
- GDC harmonized database: data available was harmonized against GRCh38 (hg38) using GDC Bioinformatics Pipelines
which provides methods to the standardization of biospecimen and
clinical data.

</div>
</div>


<div class="panel panel-info">
<div class="panel-heading">Understanding the barcode</div>
<div class="panel-body">

A TCGA barcode is composed of a collection of identifiers. Each specifically identifies a TCGA data element. Refer to the following figure for an illustration of how metadata identifiers comprise a barcode. An aliquot barcode contains the highest number of identifiers.

Example: 

- Aliquot barcode: TCGA-G4-6317-02A-11D-2064-05
- Participant: TCGA-G4-6317
- Sample: TCGA-G4-6317-02

For more information check [GDC TCGA barcodes](https://docs.gdc.cancer.gov/Encyclopedia/pages/TCGA_Barcode/)
</div>
</div>

# Searching arguments

You can easily search GDC data using the `GDCquery` function.

Using a summary of filters as used in the TCGA portal, the function works
with the following arguments:

| ?project 	| A list of valid project (see table below)] 	|  	|
|-----------------------	|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------	|-------------------------------------	|
| data.category 	| A valid project (see list with TCGAbiolinks:::getProjectSummary(project)) 	|  	|
| data.type 	| A data type to filter the files to download 	|  	|
| workflow.type 	| GDC workflow type 	|  	|
| legacy 	| Search in the legacy repository 	|  	|
| access 	| Filter by access type. Possible values: controlled, open 	|  	|
| platform 	| Example: 	|  	|
|  	| CGH- 1x1M_G4447A 	| IlluminaGA_RNASeqV2 	|
|  	| AgilentG4502A_07 	| IlluminaGA_mRNA_DGE 	|
|  	| Human1MDuo 	| HumanMethylation450 	|
|  	| HG-CGH-415K_G4124A 	| IlluminaGA_miRNASeq 	|
|  	| HumanHap550 	| IlluminaHiSeq_miRNASeq 	|
|  	| ABI 	| H-miRNA_8x15K 	|
|  	| HG-CGH-244A 	| SOLiD_DNASeq 	|
|  	| IlluminaDNAMethylation_OMA003_CPI 	| IlluminaGA_DNASeq_automated 	|
|  	| IlluminaDNAMethylation_OMA002_CPI 	| HG-U133_Plus_2 	|
|  	| HuEx- 1_0-st-v2 	| Mixed_DNASeq 	|
|  	| H-miRNA_8x15Kv2 	| IlluminaGA_DNASeq_curated 	|
|  	| MDA_RPPA_Core 	| IlluminaHiSeq_TotalRNASeqV2 	|
|  	| HT_HG-U133A 	| IlluminaHiSeq_DNASeq_automated 	|
|  	| diagnostic_images 	| microsat_i 	|
|  	| IlluminaHiSeq_RNASeq 	| SOLiD_DNASeq_curated 	|
|  	| IlluminaHiSeq_DNASeqC 	| Mixed_DNASeq_curated 	|
|  	| IlluminaGA_RNASeq 	| IlluminaGA_DNASeq_Cont_automated 	|
|  	| IlluminaGA_DNASeq 	| IlluminaHiSeq_WGBS 	|
|  	| pathology_reports 	| IlluminaHiSeq_DNASeq_Cont_automated 	|
|  	| Genome_Wide_SNP_6 	| bio 	|
|  	| tissue_images 	| Mixed_DNASeq_automated 	|
|  	| HumanMethylation27 	| Mixed_DNASeq_Cont_curated 	|
|  	| IlluminaHiSeq_RNASeqV2 	| Mixed_DNASeq_Cont 	|
| file.type 	| To be used in the legacy database for some platforms, to define which file types to be used. 	|  	|
| barcode 	| A list of barcodes to filter the files to download 	|  	|
| experimental.strategy 	| Filter to experimental strategy. Harmonized: WXS, RNA-Seq, miRNA-Seq, Genotyping Array. Legacy: WXS, RNA-Seq, miRNA-Seq, Genotyping Array, DNA-Seq, Methylation array, Protein expression array, WXS,CGH array, VALIDATION, Gene expression array,WGS, MSI-Mono-Dinucleotide Assay, miRNA expression array, Mixed strategies, AMPLICON, Exon array, Total RNA-Seq, Capillary sequencing, Bisulfite-Seq 	|  	|
| sample.type 	| A sample type to filter the files to download 	|  	|


## project options
The options for the field `project` are below:
```{r, eval = TRUE, echo = FALSE}
datatable(
    TCGAbiolinks:::getGDCprojects(),
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 10), 
    rownames = FALSE,
    caption = "List of projects"
)
```

## sample.type options
The options for the field `sample.type` are below:
```{r, eval = TRUE, echo = FALSE}
datatable(
    TCGAbiolinks:::getBarcodeDefinition(),
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 10), 
    rownames = FALSE,
    caption = "List sample types"
)
```

The other fields (data.category, data.type, workflow.type, platform, file.type) can be found below. 
Please, note that these tables are still incomplete.

## Harmonized data options (`legacy = FALSE`)

```{r, echo=FALSE}
datatable(
    readr::read_csv("https://docs.google.com/spreadsheets/d/1f98kFdj9mxVDc1dv4xTZdx8iWgUiDYO-qiFJINvmTZs/export?format=csv&gid=2046985454",col_types = readr::cols()),
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 40), 
    rownames = FALSE
)
```

## Legacy archive data  options (`legacy = TRUE`)
```{r, echo=FALSE}
datatable(
    readr::read_csv("https://docs.google.com/spreadsheets/d/1f98kFdj9mxVDc1dv4xTZdx8iWgUiDYO-qiFJINvmTZs/export?format=csv&gid=1817673686",col_types = readr::cols()),
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 40), 
    rownames = FALSE
)
```

# Harmonized database examples

## DNA methylation data: Recurrent tumor samples

In this example we will access the harmonized database (`legacy = FALSE`) 
and search for all DNA methylation data for recurrent glioblastoma multiform (GBM) 
and low grade gliomas (LGG) samples.


```{r message=FALSE, warning=FALSE}
query <- GDCquery(
    project = c("TCGA-GBM", "TCGA-LGG"),
    data.category = "DNA Methylation",
    legacy = FALSE,
    platform = c("Illumina Human Methylation 450"),
    sample.type = "Recurrent Tumor"
)
datatable(
    getResults(query), 
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
    rownames = FALSE
)
```

## Samples with DNA methylation and gene expression data

In this example we will access the harmonized database (`legacy = FALSE`) 
and search for all patients with DNA methylation (platform HumanMethylation450k) and gene expression data
for Colon Adenocarcinoma tumor (TCGA-COAD).


```{r message=FALSE, warning = FALSE, eval = FALSE}
query.met <- GDCquery(
    project = "TCGA-COAD",
    data.category = "DNA Methylation",
    legacy = FALSE,
    platform = c("Illumina Human Methylation 450")
)
query.exp <- GDCquery(
    project = "TCGA-COAD",
    data.category = "Transcriptome Profiling",
    data.type = "Gene Expression Quantification", 
    workflow.type = "STAR - Counts"
)

# Get all patients that have DNA methylation and gene expression.
common.patients <- intersect(
    substr(getResults(query.met, cols = "cases"), 1, 12),
    substr(getResults(query.exp, cols = "cases"), 1, 12)
)

# Only seelct the first 5 patients
query.met <- GDCquery(
    project = "TCGA-COAD",
    data.category = "DNA Methylation",
    legacy = FALSE,
    platform = c("Illumina Human Methylation 450"),
    barcode = common.patients[1:5]
)

query.exp <- GDCquery(
    project = "TCGA-COAD",
    data.category = "Transcriptome Profiling",
    data.type = "Gene Expression Quantification", 
    workflow.type = "STAR - Counts",
    barcode = common.patients[1:5]
)
```

```{r results_matched, message=FALSE, warning=FALSE, eval = FALSE}
datatable(
    getResults(query.met, cols = c("data_type","cases")),
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
    rownames = FALSE
)
datatable(
    getResults(query.exp, cols = c("data_type","cases")), 
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
    rownames = FALSE
)
```

## Raw Sequencing Data: Finding the match between file names and barcode for Controlled data.

This example shows how the user can search for breast cancer Raw Sequencing Data ("Controlled") 
and verify the name of the files and the barcodes associated with it.

```{r message=FALSE, warning=FALSE}
query <- GDCquery(
    project = "TCGA-ACC", 
    data.category = "Sequencing Reads",
    data.type = "Aligned Reads", 
    data.format = "bam",
    workflow.type = "STAR 2-Pass Transcriptome"
)
# Only first 10 to make render faster
datatable(
    getResults(query, rows = 1:10,cols = c("file_name","cases")), 
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
    rownames = FALSE
)

query <- GDCquery(
    project = "TCGA-ACC", 
    data.category = "Sequencing Reads",
    data.type = "Aligned Reads", 
    data.format = "bam",
    workflow.type = "STAR 2-Pass Genome"
)
# Only first 10 to make render faster
datatable(
    getResults(query, rows = 1:10,cols = c("file_name","cases")), 
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
    rownames = FALSE
)

query <- GDCquery(
    project = "TCGA-ACC", 
    data.category = "Sequencing Reads",
    data.type = "Aligned Reads", 
    data.format = "bam",
    workflow.type = "STAR 2-Pass Chimeric"
)
# Only first 10 to make render faster
datatable(
    getResults(query, rows = 1:10,cols = c("file_name","cases")), 
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
    rownames = FALSE
)

query <- GDCquery(
    project = "TCGA-ACC", 
    data.category = "Sequencing Reads",
    data.type = "Aligned Reads", 
    data.format = "bam",
    workflow.type = "BWA-aln"
)
# Only first 10 to make render faster
datatable(
    getResults(query, rows = 1:10,cols = c("file_name","cases")), 
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
    rownames = FALSE
)

query <- GDCquery(
    project = "TCGA-ACC", 
    data.category = "Sequencing Reads",
    data.type = "Aligned Reads", 
    data.format = "bam",
    workflow.type = "BWA with Mark Duplicates and BQSR"
)
# Only first 10 to make render faster
datatable(
    getResults(query, rows = 1:10,cols = c("file_name","cases")), 
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
    rownames = FALSE
)
```


# Legacy archive examples

## DNA methylation

### Array-based assays

This example shows how the user can search for  glioblastoma multiform (GBM) 
and DNA methylation data 
for platform Illumina Human Methylation 450 and Illumina Human Methylation 27.

```{r message=FALSE, warning=FALSE}
query <- GDCquery(
    project = c("TCGA-GBM"),
    legacy = TRUE,
    data.category = "DNA methylation",
    platform = c("Illumina Human Methylation 450", "Illumina Human Methylation 27")
)
datatable(
    getResults(query, rows = 1:100), 
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
    rownames = FALSE
)
```

### whole-genome bisulfite sequencing (WGBS) 

```{r message = FALSE, warning = FALSE, eval = FALSE}

query <- GDCquery(
    project = c("TCGA-LUAD"),
    legacy = TRUE,
    data.category = "DNA methylation",
    data.type = "Methylation percentage",
    experimental.strategy = "Bisulfite-Seq"
)

# VCF - controlled data
query <- GDCquery(
    project = c("TCGA-LUAD"),
    legacy = TRUE,
    data.category = "DNA methylation",
    data.type = "Bisulfite sequence alignment",
    experimental.strategy = "Bisulfite-Seq"
)


# WGBS BAM files - controlled data
query <- GDCquery(
    project = c("TCGA-LUAD"),
    legacy = TRUE,
    data.type = "Aligned reads",
    data.category = "Raw sequencing data",
    experimental.strategy = "Bisulfite-Seq"
)
```


## Gene expression

This exmaple shows how the user can search for  glioblastoma multiform (GBM) 
gene expression data with the normalized results for expression of a gene. 
For more information about file.types check [GDC TCGA file types](https://gdc.cancer.gov/resources-tcga-users/legacy-archive-tcga-tag-descriptions)

```{r message=FALSE, warning=FALSE}
# Gene expression aligned against hg19.
query.exp.hg19 <- GDCquery(
    project = "TCGA-GBM",
    data.category = "Gene expression",
    data.type = "Gene expression quantification",
    platform = "Illumina HiSeq", 
    file.type  = "normalized_results",
    experimental.strategy = "RNA-Seq",
    barcode = c("TCGA-14-0736-02A-01R-2005-01", "TCGA-06-0211-02A-02R-2005-01"),
    legacy = TRUE
)

datatable(
    getResults(query.exp.hg19), 
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
    rownames = FALSE
)
```

# Get Manifest file

If you want to get the manifest file from the query object you can use the function *getManifest*. If you 
set save to TRUEm a txt file that can be used with GDC-client Data transfer tool (DTT) or with its GUI version [ddt-ui](https://github.com/NCI-GDC/dtt-ui) will be created.

```{r message=FALSE, warning=FALSE}
getManifest(query.exp.hg19,save = FALSE) 
```

# ATAC-seq data

For the moment, ATAC-seq data is available at the [GDC publication page](https://gdc.cancer.gov/about-data/publications/ATACseq-AWG).
Also, for more details, you can check an ATAC-seq workshop at http://rpubs.com/tiagochst/atac_seq_workshop

The list of file available is below:
```{r message=FALSE, warning=FALSE}

datatable(
    getResults(TCGAbiolinks:::GDCquery_ATAC_seq())[,c("file_name","file_size")], 
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
    rownames = FALSE
)
```

You can use the function `GDCquery_ATAC_seq` filter the manifest table and use `GDCdownload` to save the data locally.
```{r message=FALSE, warning=FALSE,eval = FALSE}
query <- TCGAbiolinks:::GDCquery_ATAC_seq(file.type = "rds") 
GDCdownload(query,method = "client")

query <- TCGAbiolinks:::GDCquery_ATAC_seq(file.type = "bigWigs") 
GDCdownload(query,method = "client")

```

# Summary of available files per patient

Retrieve the numner of files under each data_category + data_type + experimental_strategy + platform.
Almost like https://portal.gdc.cancer.gov/exploration

```{r message=FALSE, warning=FALSE,eval = TRUE}
tab <-  getSampleFilesSummary(project = "TCGA-ACC")
datatable(
    head(tab),
    filter = 'top',
    options = list(scrollX = TRUE, keys = TRUE, pageLength = 5), 
    rownames = FALSE
)
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/linkedOmics.R
\name{getLinkedOmicsData}
\alias{getLinkedOmicsData}
\title{Retrieve linkedOmics data}
\usage{
getLinkedOmicsData(project, dataset)
}
\arguments{
\item{project}{A linkedOmics project:
\itemize{
\item{TCGA-ACC}
\item{TCGA-BLCA}
\item{TCGA-BRCA}
\item{TCGA-CESC}
\item{TCGA-CHOL}
\item{TCGA-COADREAD}
\item{TCGA-DLBC}
\item{TCGA-ESCA}
\item{TCGA-GBM}
\item{TCGA-GBMLGG}
\item{TCGA-HNSC}
\item{TCGA-KICH}
\item{TCGA-KIPAN}
\item{TCGA-KIRC}
\item{TCGA-KIRP}
\item{TCGA-LAML}
\item{TCGA-LGG}
\item{TCGA-LIHC}
\item{TCGA-LUAD}
\item{TCGA-LUSC}
\item{TCGA-MESO}
\item{TCGA-OV}
\item{TCGA-PAAD}
\item{TCGA-PCPG}
\item{TCGA-PRAD}
\item{TCGA-SARC}
\item{TCGA-SKCM}
\item{TCGA-STAD}
\item{TCGA-STES}
\item{TCGA-TGCT}
\item{TCGA-THCA}
\item{TCGA-THYM}
\item{TCGA-UCEC}
\item{TCGA-UCS}
\item{TCGA-UVM}
\item{CPTAC-COAD}
}}

\item{dataset}{A dataset from the list below
\itemize{
\item{ Annotated mutation }
\item{ Clinical }
\item{ Glycoproteome (Gene level) }
\item{ Glycoproteome (Site level) }
\item{ Methylation (CpG-site level, HM27) }
\item{ Methylation (CpG-site level, HM450K) }
\item{ Methylation (Gene level, HM27) }
\item{ Methylation (Gene level, HM450K) }
\item{ miRNA (GA, Gene level) }
\item{ miRNA (GA, Isoform level) }
\item{ miRNA (GA, miRgene level) }
\item{ miRNA (Gene level) }
\item{ miRNA (HiSeq, Gene level) }
\item{ miRNA (HiSeq, miRgene level) }
\item{ miRNA (isoform level) }
\item{ miRNA (miRgene level) }
\item{ Mutation (Gene level) }
\item{ Mutation (Site level) }
\item{ Mutation raw file (Somatic and MSIndel) }
\item{ Phosphoproteome (Gene level) }
\item{ Phosphoproteome (Site level) }
\item{ Phosphoproteomics (Normal) }
\item{ Phosphoproteomics (Tumor) }
\item{ Proteome (Gene level) }
\item{ Proteome (Gene Level) }
\item{ Proteome (JHU, Gene level) }
\item{ Proteome (PNNL, Gene level, Normal TMT Unshared Log Ratio) }
\item{ Proteome (PNNL, Gene level, Tumor TMT Unshared Log Ratio) }
\item{ Proteome (PNNL, Gene level) }
\item{ Proteome (VU, Gene level, Label-free Unshared Counts) }
\item{ RNAseq (GA, Gene level) }
\item{ RNAseq (HiSeq, Gene level) }
\item{ RPPA (Analyte level) }
\item{ RPPA (Analyte Level) }
\item{ RPPA (Gene level) }
\item{ RPPA (Gene Level) }
\item{ SCNV (Focal level, log-ratio) }
\item{ SCNV (Focal level, Thresholded) }
\item{ SCNV (Gene level, log ratio) }
\item{ SCNV (Gene level, log-ratio) }
\item{ SCNV (Gene level, Thresholded) }
\item{ SCNV (Segment level) }
}}
}
\value{
A matrix with the data
}
\description{
Retrieve linkedOmics data from http://linkedomics.org/
}
\examples{
\dontrun{
TCGA_COAD_protein <- getLinkedOmicsData(
  project = "TCGA-COADREAD",
  dataset = "Proteome (Gene level)"
)
TCGA_COAD_RNASeq_hiseq <- getLinkedOmicsData(
  project = "TCGA-COADREAD",
  dataset = "RNAseq (HiSeq, Gene level)"
)
TCGA_COAD_RNASeq_ga <- getLinkedOmicsData(
  project = "TCGA-COADREAD",
  dataset = "RNAseq (GA, Gene level)"
)
TCGA_COAD_RPPA <- getLinkedOmicsData(
  project = "TCGA-COADREAD",
  dataset = "RPPA (Gene level)"
)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/visualize.R
\name{TCGAvisualize_SurvivalCoxNET}
\alias{TCGAvisualize_SurvivalCoxNET}
\title{Survival analysis with univariate Cox regression package (dnet)}
\usage{
TCGAvisualize_SurvivalCoxNET(
  clinical_patient,
  dataGE,
  Genelist,
  org.Hs.string,
  scoreConfidence = 700,
  titlePlot = "TCGAvisualize_SurvivalCoxNET Example"
)
}
\arguments{
\item{clinical_patient}{is a data.frame using function 'clinic' with information
related to barcode / samples such as bcr_patient_barcode, days_to_death ,
days_to_last_followup , vital_status, etc}

\item{dataGE}{is a matrix of Gene expression (genes in rows, samples in cols) from TCGAprepare}

\item{Genelist}{is a list of gene symbols where perform survival KM.}

\item{org.Hs.string}{an igraph object that contains a functional protein association network
in human. The network is extracted from the STRING database (version 10).}

\item{scoreConfidence}{restrict to those edges with high confidence (eg. score>=700)}

\item{titlePlot}{is the title to show in the final plot.}
}
\value{
net IGRAPH with related Cox survival genes in community (same pval and color) and with
interactions from STRING database.
}
\description{
TCGAvisualize_SurvivalCoxNET can help an user to identify a group of survival genes that are
significant from univariate Kaplan Meier Analysis and also for Cox Regression.
It shows in the end a network build with community of genes with similar range of pvalues from
Cox regression (same color) and that interaction among those genes is already validated in
literatures using the STRING database (version 9.1).
TCGAvisualize_SurvivalCoxNET perform survival analysis with univariate Cox regression
and package (dnet) using following functions wrapping from these packages:
\enumerate{
\item survival::coxph
\item igraph::subgraph.edges
\item igraph::layout.fruchterman.reingold
\item igraph::spinglass.community
\item igraph::communities
\item dnet::dRDataLoader
\item dnet::dNetInduce
\item dnet::dNetPipeline
\item dnet::visNet
\item dnet::dCommSignif
}
}
\details{
TCGAvisualize_SurvivalCoxNET allow user to perform the complete workflow using coxph
and dnet package related to survival analysis with an identification of gene-active networks from
high-throughput omics data using gene expression and clinical data.
\enumerate{
\item Cox regression survival analysis to obtain hazard ratio (HR) and p-values
\item fit a Cox proportional hazards model and ANOVA (Chisq test)
\item Network comunites
\item An igraph object that contains a functional protein  association network in human.
The network is extracted from the STRING database (version 9.1).
Only those associations with medium confidence (score>=400) are retained.
\item restrict to those edges with high confidence (score>=700)
\item extract network that only contains genes in pvals
\item Identification of gene-active network
\item visualisation of the gene-active network itself
\item the layout of the network visualisation (fixed in different visuals)
\item color nodes according to communities (identified via a spin-glass model and simulated annealing)
\item node sizes according to degrees
\item highlight different communities
\item visualize the subnetwork
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TCGAbiolinks.R
\docType{data}
\name{tabSurvKMcompleteDEGs}
\alias{tabSurvKMcompleteDEGs}
\title{tabSurvKMcompleteDEGs}
\format{
A data frame with 200 rows and 7 variables
}
\description{
tabSurvKMcompleteDEGs
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/analyze.R
\name{TCGAanalyze_networkInference}
\alias{TCGAanalyze_networkInference}
\title{infer gene regulatory networks}
\usage{
TCGAanalyze_networkInference(data, optionMethod = "clr")
}
\arguments{
\item{data}{expression data, genes in columns, samples in rows}

\item{optionMethod}{inference method, chose from aracne, c3net, clr and mrnet}
}
\value{
an adjacent matrix
}
\description{
TCGAanalyze_networkInference taking expression data as input,
this will return an adjacency matrix of interactions
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Stemness.R
\name{TCGAanalyze_Stemness}
\alias{TCGAanalyze_Stemness}
\title{Generate Stemness Score based on RNASeq (mRNAsi stemness index) Malta et al., Cell, 2018}
\usage{
TCGAanalyze_Stemness(stemSig, dataGE, colname.score = "stemness_score")
}
\arguments{
\item{stemSig}{is a vector of the stemness Signature generated using gelnet package.
Please check the data from https://www.ncbi.nlm.nih.gov/pmc/articles/PMC5902191/
\itemize{
\item \link[TCGAbiolinks]{SC_PCBC_stemSig} - Stemness Score
\item \link[TCGAbiolinks]{DE_PCBC_stemSig} - endoderm score
\item \link[TCGAbiolinks]{EB_PCBC_stemSig} -  embryoid bodies score
\item \link[TCGAbiolinks]{ECTO_PCBC_stemSig} - ectoderm score
\item \link[TCGAbiolinks]{MESO_PCBC_stemSig} - mesoderm score
}}

\item{dataGE}{is a matrix of Gene expression (genes in rows, samples in cols) from TCGAprepare}

\item{colname.score}{Column name of the output. Default "stemness_score"}
}
\value{
table with samples and selected score
}
\description{
TCGAanalyze_Stemness generate the mRNAsi score
}
\examples{
 # Selecting TCGA breast cancer (10 samples) for example stored in dataBRCA
 dataNorm <- TCGAanalyze_Normalization(
     tabDF = dataBRCA,
     geneInfo =  geneInfo
 )

 # quantile filter of genes
 dataFilt <- TCGAanalyze_Filtering(
   tabDF = dataNorm,
   method = "quantile",
   qnt.cut =  0.25
 )
 Stemness_score <- TCGAanalyze_Stemness(
     stemSig = SC_PCBC_stemSig,
     dataGE = dataFilt,
     colname.score = "SC_PCBC_stem_score"
  )
 ECTO_score <- TCGAanalyze_Stemness(
     stemSig = ECTO_PCBC_stemSig,
     dataGE = dataFilt,
     colname.score = "ECTO_PCBC_stem_score"
  )
  MESO_score <- TCGAanalyze_Stemness(
     stemSig = MESO_PCBC_stemSig,
     dataGE = dataFilt,
     colname.score = "MESO_PCBC_stem_score"
  )
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TCGAbiolinks.R
\docType{data}
\name{dataBRCA}
\alias{dataBRCA}
\title{TCGA data matrix BRCA}
\format{
A data frame with 20531 rows (genes) and 50 variables (samples)
}
\description{
TCGA data matrix BRCA
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/internal.R
\name{GenesCutID}
\alias{GenesCutID}
\title{GenesCutID}
\usage{
GenesCutID(GeneList)
}
\arguments{
\item{GeneList}{GeneList}
}
\value{
list of gene symbol without IDs
}
\description{
GenesCutID
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/analyze.R
\name{UseRaw_afterFilter}
\alias{UseRaw_afterFilter}
\title{Use raw count from the DataPrep object which genes are removed by normalization and filtering steps.}
\usage{
UseRaw_afterFilter(DataPrep, DataFilt)
}
\arguments{
\item{DataPrep}{DataPrep object returned by TCGAanalyze_Preprocessing()}

\item{DataFilt}{Filtered data frame containing samples in columns and genes in rows after normalization and/or filtering steps}
}
\value{
Filtered return object similar to DataPrep with genes removed after normalization and filtering process.
}
\description{
function to keep raw counts after filtering and/or normalizing.
}
\examples{
\dontrun{
  dataPrep_raw <- UseRaw_afterFilter(dataPrep, dataFilt)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/visualize.R
\name{TCGAvisualize_oncoprint}
\alias{TCGAvisualize_oncoprint}
\title{Creating a oncoprint}
\usage{
TCGAvisualize_oncoprint(
  mut,
  genes,
  filename,
  color,
  annotation.position = "bottom",
  annotation,
  height,
  width = 10,
  rm.empty.columns = FALSE,
  show.column.names = FALSE,
  show.row.barplot = TRUE,
  label.title = "Mutation",
  column.names.size = 8,
  label.font.size = 16,
  rows.font.size = 16,
  dist.col = 0.5,
  dist.row = 0.5,
  information = "Variant_Type",
  row.order = TRUE,
  col.order = TRUE,
  heatmap.legend.side = "bottom",
  annotation.legend.side = "bottom"
)
}
\arguments{
\item{mut}{A dataframe from the mutation annotation file (see TCGAquery_maf from TCGAbiolinks)}

\item{genes}{Gene list}

\item{filename}{name of the pdf}

\item{color}{named vector for the plot}

\item{annotation.position}{Position of the annotation "bottom" or "top"}

\item{annotation}{Matrix or data frame with the annotation.
Should have a column bcr_patient_barcode with the same ID of the mutation object}

\item{height}{pdf height}

\item{width}{pdf width}

\item{rm.empty.columns}{If there is no alteration in that sample, whether remove it on the oncoprint}

\item{show.column.names}{Show column names? Default: FALSE}

\item{show.row.barplot}{Show barplot annotation on rows?}

\item{label.title}{Title of the label}

\item{column.names.size}{Size of the fonts of the columns names}

\item{label.font.size}{Size of the fonts}

\item{rows.font.size}{Size of the fonts}

\item{dist.col}{distance between columns in the plot}

\item{dist.row}{distance between rows in the plot}

\item{information}{Which column to use as information from MAF.
Options: 1) "Variant_Classification" (The information will be "Frame_Shift_Del", "Frame_Shift_Ins",
        "In_Frame_Del", "In_Frame_Ins", "Missense_Mutation",  "Nonsense_Mutation",
             "Nonstop_Mutation",  "RNA",  "Silent" ,  "Splice_Site",  "Targeted_Region",  "Translation_Start_Site")
2) "Variant_Type" (The information will be INS,DEL,SNP)}

\item{row.order}{Order the genes (rows) Default:TRUE. Genes with more mutations will be in the first rows}

\item{col.order}{Order columns. Default:TRUE.}

\item{heatmap.legend.side}{Position of the heatmap legend}

\item{annotation.legend.side}{Position of the annotation legend}
}
\value{
A oncoprint plot
}
\description{
Creating a oncoprint
}
\examples{
\dontrun{
library(dplyr)
query <- GDCquery(
   project = "TCGA-CHOL",
   data.category = "Simple Nucleotide Variation",
   access = "open",
   legacy = FALSE,
   data.type = "Masked Somatic Mutation",
   workflow.type = "Aliquot Ensemble Somatic Variant Merging and Masking"
)
GDCdownload(query)
mut <- GDCprepare(query)
TCGAvisualize_oncoprint(mut = mut, genes = mut$Hugo_Symbol[1:10], rm.empty.columns = TRUE)
TCGAvisualize_oncoprint(
  mut = mut, genes = mut$Hugo_Symbol[1:10],
  filename = "onco.pdf",
  color = c("background"="#CCCCCC","DEL"="purple","INS"="yellow","SNP"="brown")
)
clin <- GDCquery_clinic("TCGA-ACC","clinical")
clin <- clin[,c("bcr_patient_barcode","disease","gender","tumor_stage","race","vital_status")]
TCGAvisualize_oncoprint(
   mut = mut, genes = mut$Hugo_Symbol[1:20],
   filename = "onco.pdf",
   annotation = clin,
   color=c("background"="#CCCCCC","DEL"="purple","INS"="yellow","SNP"="brown"),
   rows.font.size=10,
   heatmap.legend.side = "right",
   dist.col = 0,
   label.font.size = 10
)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/clinical.R
\name{PanCancerAtlas_subtypes}
\alias{PanCancerAtlas_subtypes}
\title{Retrieve table with TCGA molecular subtypes}
\usage{
PanCancerAtlas_subtypes()
}
\value{
a data.frame with barcode and molecular subtypes for 24 cancer types
}
\description{
PanCancerAtlas_subtypes is a curated table with molecular subtypes for 24 TCGA cancer types
}
\examples{
molecular.subtypes <- PanCancerAtlas_subtypes()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/visualize.R
\name{TCGAvisualize_Heatmap}
\alias{TCGAvisualize_Heatmap}
\title{Heatmap with more sensible behavior using heatmap.plus}
\usage{
TCGAvisualize_Heatmap(
  data,
  col.metadata,
  row.metadata,
  col.colors = NULL,
  row.colors = NULL,
  show_column_names = FALSE,
  show_row_names = FALSE,
  cluster_rows = FALSE,
  cluster_columns = FALSE,
  sortCol,
  extremes = NULL,
  rownames.size = 12,
  title = NULL,
  color.levels = NULL,
  values.label = NULL,
  filename = "heatmap.pdf",
  width = 10,
  height = 10,
  type = "expression",
  scale = "none",
  heatmap.legend.color.bar = "continuous"
)
}
\arguments{
\item{data}{The object to with the heatmap data (expression, methylation)}

\item{col.metadata}{Metadata for the columns (samples). It should have on of the following columns:
barcode (28 characters)  column to match with the samples. It will also work with
"bcr_patient_barcode"(12 chars),"patient"(12 chars),"sample"(16 chars) columns but as one patient might
have more than one sample, this coul lead to errors in the annotation.
The code will throw a warning in case two samples are from the same patient.}

\item{row.metadata}{Metadata for the rows  genes (expression) or probes (methylation)}

\item{col.colors}{A list of names colors}

\item{row.colors}{A list of named colors}

\item{show_column_names}{Show column names names? Default: FALSE}

\item{show_row_names}{Show row names? Default: FALSE}

\item{cluster_rows}{Cluster rows ? Default: FALSE}

\item{cluster_columns}{Cluster columns ? Default: FALSE}

\item{sortCol}{Name of the column to be used to sort the columns}

\item{extremes}{Extremes of colors (vector of 3 values)}

\item{rownames.size}{Rownames size}

\item{title}{Title of the plot}

\item{color.levels}{A vector with the colors (low level, middle level, high level)}

\item{values.label}{Text of the levels in the heatmap}

\item{filename}{Filename to save the heatmap. Default: heatmap.png}

\item{width}{figure width}

\item{height}{figure height}

\item{type}{Select the colors of the heatmap values. Possible values are
"expression" (default), "methylation"}

\item{scale}{Use z-score to make the heatmap?
If we want to show differences between genes, it is good to make Z-score by samples
(force each sample to have zero mean and standard deviation=1).
If we want to show differences between samples, it is good to make Z-score by genes
(force each gene to have zero mean and standard deviation=1).
Possibilities: "row", "col". Default "none"}

\item{heatmap.legend.color.bar}{Heatmap legends values type.
Options: "continuous", "discrete"}
}
\value{
Heatmap plotted in the device
}
\description{
Heatmap with more sensible behavior using heatmap.plus
}
\examples{
 row.mdat <- matrix(c("FALSE","FALSE",
                     "TRUE","TRUE",
                     "FALSE","FALSE",
                     "TRUE","FALSE",
                     "FALSE","TRUE"
                ),
              nrow = 5, ncol = 2, byrow = TRUE,
              dimnames = list(
                  c("probe1", "probe2","probe3","probe4","probe5"),
                  c("duplicated", "Enhancer region")))
dat <- matrix(c(0.3,0.2,0.3,1,1,0.1,1,1,0, 0.8,1,0.7,0.7,0.3,1),
             nrow = 5, ncol = 3, byrow = TRUE,
               dimnames = list(
               c("probe1", "probe2","probe3","probe4","probe5"),
               c("TCGA-DU-6410",
                 "TCGA-DU-A5TS",
                 "TCGA-HT-7688")))

mdat <- data.frame(patient=c("TCGA-DU-6410","TCGA-DU-A5TS","TCGA-HT-7688"),
                   Sex=c("Male","Female","Male"),
                   COCCluster=c("coc1","coc1","coc1"),
                   IDHtype=c("IDHwt","IDHMut-cod","IDHMut-noncod"))

TCGAvisualize_Heatmap(dat,
                    col.metadata = mdat,
                    row.metadata = row.mdat,
                    row.colors = list(duplicated = c("FALSE" = "pink",
                                                     "TRUE"="green"),
                                     "Enhancer region" = c("FALSE" = "purple",
                                                            "TRUE"="grey")),
                    col.colors = list(Sex = c("Male" = "blue", "Female"="red"),
                                      COCCluster=c("coc1"="grey"),
                                      IDHtype=c("IDHwt"="cyan",
                                      "IDHMut-cod"="tomato"
                                      ,"IDHMut-noncod"="gold")),
                    type = "methylation",
                    show_row_names=TRUE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/internal.R
\name{getResults}
\alias{getResults}
\title{Get the results table from query}
\usage{
getResults(query, rows, cols)
}
\arguments{
\item{query}{A object from GDCquery}

\item{rows}{Rows identifiers (row numbers)}

\item{cols}{Columns identifiers (col names)}
}
\value{
Table with query results
}
\description{
Get the results table from query, it can select columns with cols argument
and return a number of rows using rows argument.
}
\examples{
query <- GDCquery(
  project = "TCGA-GBM",
  data.category = "Transcriptome Profiling",
  data.type = "Gene Expression Quantification",
  workflow.type = "STAR - Counts",
  barcode = c("TCGA-14-0736-02A-01R-2005-01", "TCGA-06-0211-02A-02R-2005-01")
)
results <- getResults(query)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/analyze.R
\name{TCGAanalyze_DEA}
\alias{TCGAanalyze_DEA}
\title{Differential expression analysis (DEA) using edgeR or limma package.}
\usage{
TCGAanalyze_DEA(
  mat1,
  mat2,
  metadata = TRUE,
  Cond1type,
  Cond2type,
  pipeline = "edgeR",
  method = "exactTest",
  fdr.cut = 1,
  logFC.cut = 0,
  batch.factors = NULL,
  ClinicalDF = data.frame(),
  paired = FALSE,
  log.trans = FALSE,
  voom = FALSE,
  trend = FALSE,
  MAT = data.frame(),
  contrast.formula = "",
  Condtypes = c()
)
}
\arguments{
\item{mat1}{numeric matrix, each row represents a gene,
each column represents a sample with Cond1type}

\item{mat2}{numeric matrix, each row represents a gene,
each column represents a sample with Cond2type}

\item{metadata}{Add metadata}

\item{Cond1type}{a string containing the class label of the samples in mat1
(e.g., control group)}

\item{Cond2type}{a string containing the class label of the samples in mat2
(e.g., case group)}

\item{pipeline}{a string to specify which package to use ("limma" or "edgeR")}

\item{method}{is 'glmLRT' (1) or 'exactTest' (2) used for edgeR
(1) Fit a negative binomial generalized log-linear model to
the read counts for each gene
(2) Compute genewise exact tests for differences in the means between
two groups of negative-binomially distributed counts.}

\item{fdr.cut}{is a threshold to filter DEGs according their p-value corrected}

\item{logFC.cut}{is a threshold to filter DEGs according their logFC}

\item{batch.factors}{a vector containing strings to specify options for batch correction. Options are "Plate", "TSS", "Year", "Portion", "Center", and "Patients"}

\item{ClinicalDF}{a dataframe returned by GDCquery_clinic() to be used to extract year data}

\item{paired}{boolean to account for paired or non-paired samples. Set to TRUE for paired case}

\item{log.trans}{boolean to perform log cpm transformation. Set to TRUE for log transformation}

\item{voom}{boolean to perform voom transformation for limma-voom pipeline. Set to TRUE for voom transformation}

\item{trend}{boolean to perform limma-trend pipeline. Set to TRUE to go through limma-trend}

\item{MAT}{matrix containing expression set as all samples in columns and genes as rows. Do not provide if mat1 and mat2 are used}

\item{contrast.formula}{string input to determine coefficients and to design contrasts in a customized way}

\item{Condtypes}{vector of grouping for samples in MAT}
}
\value{
table with DEGs containing for each gene logFC, logCPM, pValue,and FDR, also for each contrast
}
\description{
TCGAanalyze_DEA allows user to perform Differentially expression analysis (DEA),
   using edgeR package or limma to identify differentially expressed genes (DEGs).
    It is possible to do a two-class analysis.

    TCGAanalyze_DEA performs DEA using following functions from edgeR:
    \enumerate{
    \item edgeR::DGEList converts the count matrix into an edgeR object.
    \item edgeR::estimateCommonDisp each gene gets assigned the same dispersion estimate.
    \item edgeR::exactTest performs pair-wise tests for differential expression between two groups.
    \item edgeR::topTags takes the output from exactTest(), adjusts the raw p-values using the
    False Discovery Rate (FDR) correction, and returns the top differentially expressed genes.
    }
    TCGAanalyze_DEA performs DEA using following functions from limma:
    \enumerate{
    \item limma::makeContrasts construct matrix of custom contrasts.
    \item limma::lmFit Fit linear model for each gene given a series of arrays.
    \item limma::contrasts.fit Given a linear model fit to microarray data, compute estimated coefficients and standard errors for a given set of contrasts.
    \item limma::eBayes Given a microarray linear model fit, compute moderated t-statistics, moderated F-statistic, and log-odds of differential expression by empirical Bayes moderation of the standard errors towards a common value.
    \item limma::toptable Extract a table of the top-ranked genes from a linear model fit.
    }
}
\examples{
dataNorm <- TCGAbiolinks::TCGAanalyze_Normalization(dataBRCA, geneInfo)
dataFilt <- TCGAanalyze_Filtering(tabDF = dataBRCA, method = "quantile", qnt.cut =  0.25)
samplesNT <- TCGAquery_SampleTypes(colnames(dataFilt), typesample = c("NT"))
samplesTP <- TCGAquery_SampleTypes(colnames(dataFilt), typesample = c("TP"))
dataDEGs <- TCGAanalyze_DEA(
   mat1 = dataFilt[,samplesNT],
   mat2 = dataFilt[,samplesTP],
   Cond1type = "Normal",
   Cond2type = "Tumor"
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/analyze.R
\name{TCGAanalyze_Preprocessing}
\alias{TCGAanalyze_Preprocessing}
\title{Array Array Intensity correlation (AAIC) and correlation boxplot to define outlier}
\usage{
TCGAanalyze_Preprocessing(
  object,
  cor.cut = 0,
  datatype = names(assays(object))[1],
  filename = NULL,
  width = 1000,
  height = 1000
)
}
\arguments{
\item{object}{gene expression of class RangedSummarizedExperiment from TCGAprepare}

\item{cor.cut}{is a threshold to filter samples according their spearman correlation in
samples by samples. default cor.cut is 0}

\item{datatype}{is a string from RangedSummarizedExperiment assay}

\item{filename}{Filename of the image file}

\item{width}{Image width}

\item{height}{Image height}
}
\value{
Plot with array array intensity correlation and boxplot of correlation samples by samples
}
\description{
TCGAanalyze_Preprocessing perform Array Array Intensity correlation (AAIC).
It defines a square symmetric matrix of spearman correlation among samples.
According this matrix and boxplot of correlation samples by samples it is possible
to find samples with low correlation that can be identified as possible outliers.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/visualize.R
\name{TCGAvisualize_BarPlot}
\alias{TCGAvisualize_BarPlot}
\title{Barplot of subtypes and clinical info in groups of gene expression clustered.}
\usage{
TCGAvisualize_BarPlot(
  DFfilt,
  DFclin,
  DFsubt,
  data_Hc2,
  Subtype,
  cbPalette,
  filename,
  width,
  height,
  dpi
)
}
\arguments{
\item{DFfilt}{write}

\item{DFclin}{write}

\item{DFsubt}{write}

\item{data_Hc2}{write}

\item{Subtype}{write}

\item{cbPalette}{Define the colors of the bar.}

\item{filename}{The name of the pdf file}

\item{width}{Image width}

\item{height}{Image height}

\item{dpi}{Image dpi}
}
\value{
barplot image in pdf or png file
}
\description{
Barplot of subtypes and clinical info in groups of gene expression clustered.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/biomart.R
\name{getTSS}
\alias{getTSS}
\title{getTSS to fetch GENCODE gene annotation (transcripts level) from Bioconductor package biomaRt
If upstream and downstream are specified in TSS list, promoter regions of GENCODE gene will be generated.}
\usage{
getTSS(
  genome = c("hg38", "hg19"),
  TSS = list(upstream = NULL, downstream = NULL)
)
}
\arguments{
\item{genome}{Which genome build will be used: hg38 (default) or hg19.}

\item{TSS}{A list. Contains upstream and downstream like TSS=list(upstream, downstream).
When upstream and downstream is specified, coordinates of promoter regions with gene annotation will be generated.}
}
\value{
GENCODE gene annotation if TSS is not specified. Coordinates of GENCODE gene promoter regions if TSS is specified.
}
\description{
getTSS to fetch GENCODE gene annotation (transcripts level) from Bioconductor package biomaRt
If upstream and downstream are specified in TSS list, promoter regions of GENCODE gene will be generated.
}
\examples{
# get GENCODE gene annotation (transcripts level)
\dontrun{
    getTSS <- getTSS()
    getTSS <- getTSS(genome.build = "hg38", TSS=list(upstream=1000, downstream=1000))
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/visualize.R
\name{TCGAvisualize_EAbarplot}
\alias{TCGAvisualize_EAbarplot}
\title{barPlot for a complete Enrichment Analysis}
\usage{
TCGAvisualize_EAbarplot(
  tf,
  GOMFTab,
  GOBPTab,
  GOCCTab,
  PathTab,
  nBar,
  nRGTab,
  filename = "TCGAvisualize_EAbarplot_Output.pdf",
  text.size = 1,
  mfrow = c(2, 2),
  xlim = NULL,
  fig.width = 30,
  fig.height = 15,
  color = c("orange", "cyan", "green", "yellow")
)
}
\arguments{
\item{tf}{is a list of gene symbols}

\item{GOMFTab}{is results from TCGAanalyze_EAcomplete related to Molecular Function (MF)}

\item{GOBPTab}{is results from TCGAanalyze_EAcomplete related to Biological Process (BP)}

\item{GOCCTab}{is results from TCGAanalyze_EAcomplete related to Cellular Component (CC)}

\item{PathTab}{is results from TCGAanalyze_EAcomplete related to Pathways EA}

\item{nBar}{is the number of bar histogram selected to show (default = 10)}

\item{nRGTab}{is the gene signature list with gene symbols.}

\item{filename}{Name for the pdf. If null it will return the plot.}

\item{text.size}{Text size}

\item{mfrow}{Vector with number of rows/columns of the plot. Default  2 rows/2 columns "c(2,2)"}

\item{xlim}{Upper limit of the x-axis.}

\item{fig.width}{Default 30}

\item{fig.height}{Default 15}

\item{color}{A vector of colors for each barplot. Deafult:  c("orange", "cyan","green","yellow")}
}
\value{
Complete barPlot from Enrichment Analysis showing significant (default FDR < 0.01)
BP,CC,MF and pathways enriched by list of genes.
}
\description{
The figure shows canonical pathways significantly overrepresented (enriched) by the DEGs
(differentially expressed genes).
The most statistically significant canonical pathways identified
in DEGs list are listed according to their p value corrected FDR (-Log) (colored bars)
and the ratio of list genes found in each pathway over the total number of
genes in that pathway (Ratio, red line).
}
\examples{
Genelist <- c("FN1","COL1A1")
ansEA <- TCGAanalyze_EAcomplete(TFname="DEA genes Normal Vs Tumor",Genelist)
TCGAvisualize_EAbarplot(tf = rownames(ansEA$ResBP),
         GOBPTab = ansEA$ResBP,
         GOCCTab = ansEA$ResCC,
         GOMFTab = ansEA$ResMF,
        PathTab = ansEA$ResPat,
         nRGTab = Genelist,
         nBar = 10,
         filename="a.pdf")
\dontrun{
Genelist <- rownames(dataDEGsFiltLevel)
system.time(ansEA <- TCGAanalyze_EAcomplete(TFname="DEA genes Normal Vs Tumor",Genelist))
# Enrichment Analysis EA (TCGAVisualize)
# Gene Ontology (GO) and Pathway enrichment barPlot
TCGAvisualize_EAbarplot(tf = rownames(ansEA$ResBP),
         GOBPTab = ansEA$ResBP,
         GOCCTab = ansEA$ResCC,
         GOMFTab = ansEA$ResMF,
        PathTab = ansEA$ResPat,
         nRGTab = Genelist,
         nBar = 10)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TCGAbiolinks.R
\docType{data}
\name{msi_results}
\alias{msi_results}
\title{MSI data for two samples}
\format{
A data frame: 2 rows, 4 columns
}
\description{
MSI data for two samples
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/classifiers.R
\name{gliomaClassifier}
\alias{gliomaClassifier}
\title{Gliomar classifier}
\usage{
gliomaClassifier(data)
}
\arguments{
\item{data}{DNA methylation matrix or Summarized Experiments with samples on columns
and probes on the rows}
}
\value{
A list of 3 data frames:
1) Sample final classification
2) Each model final classification
3) Each class probability of classification
}
\description{
Classify DNA methylation gliomas using data from
https://doi.org/10.1016/j.cell.2015.12.028
}
\examples{
\dontrun{
query <- GDCquery(
   project= "TCGA-GBM",
   data.category = "DNA methylation",
   barcode = c("TCGA-06-0122","TCGA-14-1456"),
   platform = "Illumina Human Methylation 27",
   legacy = TRUE
)
GDCdownload(query)
data.hg19 <- GDCprepare(query)
classification <- gliomaClassifier(data.hg19)

# Comparing reslts
TCGAquery_subtype("GBM") \%>\%
dplyr::filter(patient \%in\% c("TCGA-06-0122","TCGA-14-1456")) \%>\%
dplyr::select("patient","Supervised.DNA.Methylation.Cluster")
}
}
\author{
Tiago Chedraoui Silva, Tathiane Malta, Houtan Noushmehr
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/internal.R
\name{getGistic}
\alias{getGistic}
\title{Download GISTIC data from firehose}
\usage{
getGistic(disease, type = "thresholded")
}
\arguments{
\item{disease}{TCGA disease. Option available in
http://gdac.broadinstitute.org/runs/analyses__latest/data/}

\item{type}{Results type: thresholded or data}
}
\description{
Download GISTIC data from firehose from
http://gdac.broadinstitute.org/runs/analyses__latest/data/
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TCGAbiolinks.R
\docType{data}
\name{clinBRCA}
\alias{clinBRCA}
\title{Clinical data TCGA BRCA}
\format{
A data frame with 1061 rows and 109 variables
}
\description{
Clinical data TCGA BRCA
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methylation.R
\name{dmc.non.parametric.se}
\alias{dmc.non.parametric.se}
\title{Calculate pvalues}
\usage{
dmc.non.parametric.se(
  data,
  groupCol = NULL,
  group1 = NULL,
  group2 = NULL,
  paired = FALSE,
  adj.method = "BH",
  alternative = "two.sided",
  cores = 1
)
}
\arguments{
\item{data}{SummarizedExperiment obtained from the TCGAPrepare}

\item{groupCol}{Columns with the groups inside the SummarizedExperiment
object. (This will be obtained by the function colData(data))}

\item{group1}{In case our object has more than 2 groups, you should set the
groups}

\item{group2}{In case our object has more than 2 groups, you should set the
groups}

\item{paired}{Do a paired wilcoxon test? Default: True}

\item{adj.method}{P-value adjustment method. Default:"BH" Benjamini-Hochberg}

\item{alternative}{wilcoxon test alternative}

\item{cores}{Number of cores to be used}
}
\value{
Data frame with cols p values/p values adjusted

Data frame with two cols
        p-values/p-values adjusted
}
\description{
Calculate pvalues using wilcoxon test
}
\details{
Verify if the data is significant between two groups. For the methylation
   we search for probes that have a difference in the mean methylation and
   also a significant value.
   Input: A SummarizedExperiment object that will be used to
   compared two groups with wilcoxon test, a boolean value to do a
   paired or non-paired test
   Output: p-values (non-adj/adj) histograms, p-values (non-adj/adj)
}
\examples{
nrows <- 200; ncols <- 20
 counts <- matrix(runif(nrows * ncols, 1, 1e4), nrows,
           dimnames = list(paste0("cg",1:200),LETTERS[1:20]))
rowRanges <- GenomicRanges::GRanges(rep(c("chr1", "chr2"), c(50, 150)),
                   IRanges::IRanges(floor(runif(200, 1e5, 1e6)), width=100),
                    strand=sample(c("+", "-"), 200, TRUE),
                    feature_id=sprintf("ID\%03d", 1:200))
colData <- S4Vectors::DataFrame(Treatment=rep(c("ChIP", "Input"), 10),
                    row.names=LETTERS[1:20],
                    group=rep(c("group1","group2"),c(10,10)))
data <- SummarizedExperiment::SummarizedExperiment(
         assays=S4Vectors::SimpleList(counts=counts),
         rowRanges=rowRanges,
         colData=colData)
results <- TCGAbiolinks:::dmc.non.parametric.se(data,"group")
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TCGAbiolinks.R
\docType{data}
\name{BRCA_rnaseqv2}
\alias{BRCA_rnaseqv2}
\title{BRCA_rnaseqv2}
\format{
A data frame with 200 rows (genes) and 1172 variables (samples)
}
\description{
BRCA_rnaseqv2
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/clinical.R
\name{TCGA_MolecularSubtype}
\alias{TCGA_MolecularSubtype}
\title{Retrieve molecular subtypes for given TCGA barcodes}
\usage{
TCGA_MolecularSubtype(barcodes)
}
\arguments{
\item{barcodes}{is a vector of TCGA barcodes}
}
\value{
List with $subtypes attribute as a dataframe with barcodes,
samples, subtypes, and colors. The $filtered attribute is returned as filtered samples with no subtype info
}
\description{
TCGA_MolecularSubtype Retrieve molecular subtypes from TCGA consortium for a given set of barcodes
}
\examples{
TCGA_MolecularSubtype("TCGA-60-2721-01A-01R-0851-07")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/biomart.R
\name{get.GRCh.bioMart}
\alias{get.GRCh.bioMart}
\title{Get hg19 gene annotation or hg38 (gencode v36)}
\usage{
get.GRCh.bioMart(genome = c("hg19", "hg38"), as.granges = FALSE)
}
\arguments{
\item{genome}{hg38 or hg19}

\item{as.granges}{Output as GRanges or data.frame}
}
\description{
Get hg19 (from biomart) or hg38 (gencode v36) gene annotation
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/analyze.R
\name{TCGAanalyze_Clustering}
\alias{TCGAanalyze_Clustering}
\title{Hierarchical cluster analysis}
\usage{
TCGAanalyze_Clustering(tabDF, method, methodHC = "ward.D2")
}
\arguments{
\item{tabDF}{is a dataframe or numeric matrix, each row represents a gene,
each column represents a sample come from TCGAPrepare.}

\item{method}{is method to be used for generic cluster such as 'hclust'
or 'consensus'}

\item{methodHC}{is method to be used for Hierarchical cluster.}
}
\value{
object of class hclust if method selected is 'hclust'.
If method selected is 'Consensus' returns a list of length maxK
(maximum cluster number to evaluate.). Each element is a list containing
consensusMatrix (numerical matrix), consensusTree (hclust), consensusClass
(consensus class assignments). ConsensusClusterPlus also produces images.
}
\description{
Hierarchical cluster analysis using several methods such as
 ward.D", "ward.D2", "single", "complete", "average" (= UPGMA),
 "mcquitty" (= WPGMA), "median" (= WPGMC) or "centroid" (= UPGMC).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TCGAbiolinks.R
\docType{data}
\name{gbm.exp.legacy}
\alias{gbm.exp.legacy}
\title{A RangedSummarizedExperiment two samples with gene expression data from vignette
aligned against hg19}
\format{
A RangedSummarizedExperiment: 21022 genes, 2 samples
}
\description{
A RangedSummarizedExperiment two samples with gene expression data from vignette
aligned against hg19
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/internal.R
\name{getGDCInfo}
\alias{getGDCInfo}
\title{Check GDC server status}
\usage{
getGDCInfo()
}
\value{
Return true all status
}
\description{
Check GDC server status using the api
  https://api.gdc.cancer.gov/status
}
\examples{
info <- getGDCInfo()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TCGAbiolinks-package.R
\docType{package}
\name{TCGAbiolinks-package}
\alias{TCGAbiolinks}
\alias{TCGAbiolinks-package}
\title{The aim of TCGAbiolinks is : i) facilitate the TCGA open-access data retrieval,
ii) prepare the data using the appropriate pre-processing strategies,
 iii) provide the means to carry out different standard analyses and
 iv) allow the user to download a specific version of the data and thus to easily reproduce earlier research results.
  In more detail, the package provides multiple methods for analysis
(e.g., differential expression analysis, identifying differentially methylated regions)
and methods for visualization (e.g., survival plots, volcano plots, starburst plots) in order to easily develop complete analysis pipelines.}
\description{
The functions you're likely to need from \pkg{TCGAbiolinks} is
\code{\link{GDCdownload}}, \code{\link{GDCquery}}.
Otherwise refer to the vignettes to see
how to format the documentation.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/BioinformaticsFMRP/TCGAbiolinks}
  \item Report bugs at \url{https://github.com/BioinformaticsFMRP/TCGAbiolinks/issues}
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/clinical.R
\name{TCGAtumor_purity}
\alias{TCGAtumor_purity}
\title{Filters TCGA barcodes according to purity parameters}
\usage{
TCGAtumor_purity(barcodes, estimate, absolute, lump, ihc, cpe)
}
\arguments{
\item{barcodes}{is a vector of TCGA barcodes}

\item{estimate}{uses gene expression profiles of 141 immune genes and 141 stromal genes}

\item{absolute}{which uses somatic copy-number data (estimations were available for only 11 cancer types)}

\item{lump}{(leukocytes unmethylation for purity), which averages 44 non-methylated immune-specific CpG sites}

\item{ihc}{as estimated by image analysis of haematoxylin and eosin stain slides produced by the Nationwide Childrens Hospital Biospecimen Core Resource}

\item{cpe}{CPE is a derived consensus measurement as the median purity level after normalizing levels from all methods to give them equal means and s.ds}
}
\value{
List with $pure_barcodes attribute as a vector of pure samples and $filtered attribute as filtered samples with no purity info
}
\description{
TCGAtumor_purity Filters TCGA samples using 5 estimates from 5 methods as thresholds.
}
\examples{
dataTableSubt <- TCGAtumor_purity("TCGA-60-2721-01A-01R-0851-07",
                          estimate = 0.6,
                          absolute = 0.6,
                          ihc = 0.8,
                          lump = 0.8,
                          cpe = 0.7)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/analyze.R
\name{TCGAanalyze_Pathview}
\alias{TCGAanalyze_Pathview}
\title{Generate pathview graph}
\usage{
TCGAanalyze_Pathview(dataDEGs, pathwayKEGG = "hsa05200")
}
\arguments{
\item{dataDEGs}{dataDEGs}

\item{pathwayKEGG}{pathwayKEGG}
}
\value{
an adjacent matrix
}
\description{
TCGAanalyze_Pathview pathway based data integration and visualization.
}
\examples{
\dontrun{
  dataDEGs <- data.frame(mRNA = c("TP53","TP63","TP73"), logFC = c(1,2,3))
  TCGAanalyze_Pathview(dataDEGs)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/prepare.R
\name{TCGAprepare_Affy}
\alias{TCGAprepare_Affy}
\title{Prepare CEL files into an AffyBatch.}
\usage{
TCGAprepare_Affy(ClinData, PathFolder, TabCel)
}
\arguments{
\item{ClinData}{write}

\item{PathFolder}{write}

\item{TabCel}{write}
}
\value{
Normalized Expression data from Affy eSets
}
\description{
Prepare CEL files into an AffyBatch.
}
\examples{
\dontrun{
to add example
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/query.R
\name{GDCquery_Maf}
\alias{GDCquery_Maf}
\title{Retrieve open access maf files from GDC server}
\usage{
GDCquery_Maf(tumor, save.csv = FALSE, directory = "GDCdata", pipelines = NULL)
}
\arguments{
\item{tumor}{a valid tumor}

\item{save.csv}{Write maf file into a csv document}

\item{directory}{Directory/Folder where the data will downloaded. Default: GDCdata}

\item{pipelines}{Four separate variant calling pipelines are implemented for GDC data harmonization.
Options: muse, varscan2, somaticsniper, mutect2. For more information:
https://gdc-docs.nci.nih.gov/Data/Bioinformatics_Pipelines/DNA_Seq_Variant_Calling_Pipeline/}
}
\value{
A data frame with the maf file information
}
\description{
GDCquery_Maf uses the following guide to download maf files
  https://gdc-docs.nci.nih.gov/Data/Release_Notes/Data_Release_Notes/
}
\examples{
\dontrun{
   acc.muse.maf <- GDCquery_Maf("ACC", pipelines = "muse")
   acc.varscan2.maf <- GDCquery_Maf("ACC", pipelines = "varscan2")
   acc.somaticsniper.maf <- GDCquery_Maf("ACC", pipelines = "somaticsniper")
   acc.mutect.maf <- GDCquery_Maf("ACC", pipelines = "mutect2")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TCGAbiolinks.R
\docType{data}
\name{geneInfo}
\alias{geneInfo}
\title{geneInfo for normalization of RNAseq data}
\format{
A data frame with 20531 rows and 2 variables
}
\description{
geneInfo for normalization of RNAseq data
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/analyze.R
\name{getAdjacencyBiogrid}
\alias{getAdjacencyBiogrid}
\title{Get a matrix of interactions of genes from biogrid}
\usage{
getAdjacencyBiogrid(tmp.biogrid, names.genes = NULL)
}
\arguments{
\item{tmp.biogrid}{Biogrid table}

\item{names.genes}{List of genes to filter from output. Default: consider all genes}
}
\value{
A matrix with 1 for genes that interacts, 0 for no interaction.
}
\description{
Using biogrid database, it will create a matrix of gene interactions.
If columns A and row B has value 1, it means the gene A and gene B interacts.
}
\examples{
names.genes.de <- c("PLCB1","MCL1","PRDX4","TTF2","TACC3", "PARP4","LSM1")
tmp.biogrid <- data.frame("Official.Symbol.Interactor.A" = names.genes.de,
                          "Official.Symbol.Interactor.B" = rev(names.genes.de))
net.biogrid.de <- getAdjacencyBiogrid(tmp.biogrid, names.genes.de)
\dontrun{
  file <- paste0("http://thebiogrid.org/downloads/archives/",
                 "Release\%20Archive/BIOGRID-3.4.133/BIOGRID-ALL-3.4.133.tab2.zip")
  downloader::download(file,basename(file))
  unzip(basename(file),junkpaths =TRUE)
  tmp.biogrid <- read.csv(gsub("zip","txt",basename(file)),
                          header=TRUE, sep="\t", stringsAsFactors=FALSE)
  names.genes.de <- c("PLCB1","MCL1","PRDX4","TTF2","TACC3", "PARP4","LSM1")
  net.biogrid.de <- getAdjacencyBiogrid(tmp.biogrid, names.genes.de)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/clinical.R
\name{TCGAquery_subtype}
\alias{TCGAquery_subtype}
\title{Retrieve molecular subtypes for a given tumor}
\usage{
TCGAquery_subtype(tumor)
}
\arguments{
\item{tumor}{is a cancer Examples:
\tabular{lllll}{
lgg   \tab gbm \tab luad \tab stad \tab brca\cr
coad \tab read \tab  \tab  \tab
}}
}
\value{
a data.frame with barcode and molecular subtypes
}
\description{
TCGAquery_subtype Retrieve molecular subtypes for a given tumor
}
\examples{
dataSubt <- TCGAquery_subtype(tumor = "lgg")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/api.R
\name{getProjectSummary}
\alias{getProjectSummary}
\title{Get Project Summary from GDC}
\usage{
getProjectSummary(project)
}
\arguments{
\item{project}{A  GDC project}
}
\description{
Get Project Summary from GDC
}
\examples{
getProjectSummary("TCGA-ACC")
\dontrun{
getProjectSummary("CPTAC-2")
}
}
\author{
Tiago Chedraoui Silva
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/internal.R
\name{getGDCprojects}
\alias{getGDCprojects}
\title{Retrieve all GDC projects}
\usage{
getGDCprojects()
}
\value{
A data frame with last GDC projects
}
\description{
getGDCprojects uses the following api to get projects
  https://api.gdc.cancer.gov/projects
}
\examples{
projects <- getGDCprojects()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/clinical.R
\name{GDCprepare_clinic}
\alias{GDCprepare_clinic}
\title{Parsing clinical xml files}
\usage{
GDCprepare_clinic(query, clinical.info, directory = "GDCdata")
}
\arguments{
\item{query}{Result from GDCquery, with data.category set to Clinical}

\item{clinical.info}{Which information should be retrieved.
Options Clinical: drug, admin, follow_up,radiation, patient, stage_event or new_tumor_event
Options Biospecimen: protocol, admin, aliquot, analyte, bio_patient, sample, portion, slide}

\item{directory}{Directory/Folder where the data was downloaded. Default: GDCdata}
}
\value{
A data frame with the parsed values from the XML
}
\description{
This function receives the query argument and parses the clinical xml files
based on the desired information
}
\examples{
query <- GDCquery(
  project = "TCGA-COAD",
  data.category = "Clinical",
  data.format = "bcr xml",
  barcode = c("TCGA-RU-A8FL","TCGA-AA-3972")
)
GDCdownload(query)
clinical <- GDCprepare_clinic(query,"patient")
clinical.drug <- GDCprepare_clinic(query,"drug")
clinical.radiation <- GDCprepare_clinic(query,"radiation")
clinical.admin <- GDCprepare_clinic(query,"admin")
\dontrun{
query <- GDCquery(
   project = "TCGA-COAD",
   data.category = "Biospecimen",
   data.format = "bcr xml",
   data.type = "Biospecimen Supplement",
   barcode = c("TCGA-RU-A8FL","TCGA-AA-3972")
)
GDCdownload(query)
clinical <- GDCprepare_clinic(query,"admin")
clinical.drug <- GDCprepare_clinic(query,"sample")
clinical.radiation <- GDCprepare_clinic(query,"portion")
clinical.admin <- GDCprepare_clinic(query,"slide")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/analyze.R
\name{TCGAanalyze_DEA_Affy}
\alias{TCGAanalyze_DEA_Affy}
\title{Differentially expression analysis (DEA) using limma package.}
\usage{
TCGAanalyze_DEA_Affy(AffySet, FC.cut = 0.01)
}
\arguments{
\item{AffySet}{A matrix-like data object containing log-ratios or log-expression values
for a series of arrays, with rows corresponding to genes and columns to samples}

\item{FC.cut}{write}
}
\value{
List of list with tables in 2 by 2 comparison
of the top-ranked genes from a linear model fitted by DEA's limma
}
\description{
Differentially expression analysis (DEA) using limma package.
}
\examples{
\dontrun{
to add example
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methylation.R
\name{dmc.non.parametric}
\alias{dmc.non.parametric}
\title{Perform non-parametrix wilcoxon test}
\usage{
dmc.non.parametric(
  matrix,
  idx1 = NULL,
  idx2 = NULL,
  paired = FALSE,
  adj.method = "BH",
  alternative = "two.sided",
  cores = 1
)
}
\arguments{
\item{matrix}{A matrix}

\item{idx1}{Index columns group1}

\item{idx2}{Index columns group2}

\item{paired}{Do a paired wilcoxon test? Default: True}

\item{adj.method}{P-value adjustment method. Default:"BH" Benjamini-Hochberg}

\item{alternative}{wilcoxon test alternative}

\item{cores}{Number of cores to be used}
}
\value{
Data frame with p-values and diff mean
}
\description{
Perform non-parametrix wilcoxon test
}
\examples{
 nrows <- 200; ncols <- 20
 counts <- matrix(
   runif(nrows * ncols, 1, 1e4), nrows,
   dimnames = list(paste0("cg",1:200),paste0("S",1:20))
 )
 TCGAbiolinks:::dmc.non.parametric(counts,1:10,11:20)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/internal.R
\name{get_IDs}
\alias{get_IDs}
\title{Extract information from TCGA barcodes.}
\usage{
get_IDs(data)
}
\arguments{
\item{data}{numeric matrix, each row represents a gene, each column represents a sample}
}
\value{
data frame with columns 'project', 'tss','participant', 'sample', "portion", "plate", "center", "condition"
}
\description{
get_IDs allows user to extract metadata from barcodes. The dataframe returned has columns for
 'project', 'tss','participant', 'sample', "portion", "plate", and "center"
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/analyze.R
\name{TCGAbatch_Correction}
\alias{TCGAbatch_Correction}
\title{Batch correction using ComBat and Voom transformation using limma package.}
\usage{
TCGAbatch_Correction(
  tabDF,
  batch.factor = NULL,
  adjustment = NULL,
  ClinicalDF = data.frame(),
  UnpublishedData = FALSE,
  AnnotationDF = data.frame()
)
}
\arguments{
\item{tabDF}{numeric matrix, each row represents a gene,
each column represents a sample}

\item{batch.factor}{a string containing the batch factor to use for correction.
Options are "Plate", "TSS", "Year", "Portion", "Center"}

\item{adjustment}{vector containing strings for factors to adjust for using ComBat.
Options are "Plate", "TSS", "Year", "Portion", "Center"}

\item{ClinicalDF}{a dataframe returned by GDCquery_clinic() to be used to extract year data}

\item{UnpublishedData}{if TRUE perform a batch correction after adding new data}

\item{AnnotationDF}{a dataframe with column Batch indicating different batches of the samples in the tabDF}
}
\value{
data frame with ComBat batch correction applied
}
\description{
TCGAbatch_correction allows user to perform a Voom correction on gene expression data and have it ready for DEA.
   One can also use ComBat for batch correction for exploratory analysis. If batch.factor or adjustment argument is "Year"
 please provide clinical data. If no batch factor is provided, the data will be voom corrected only

    TCGAanalyze_DEA performs DEA using following functions from sva and limma:
    \enumerate{
    \item limma::voom Transform RNA-Seq Data Ready for Linear Modelling.
    \item sva::ComBat Adjust for batch effects using an empirical Bayes framework.
    }
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TCGAbiolinks.R
\docType{data}
\name{dataREAD}
\alias{dataREAD}
\title{TCGA data SummarizedExperiment READ}
\format{
A SummarizedExperiment of READ with 2 samples
}
\description{
TCGA data SummarizedExperiment READ
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/prepare.R
\name{colDataPrepare}
\alias{colDataPrepare}
\title{Create samples information matrix for GDC samples}
\usage{
colDataPrepare(barcode)
}
\arguments{
\item{barcode}{TCGA or TARGET barcode}
}
\description{
Create samples information matrix for GDC samples add subtype information
}
\examples{
 metadata <- colDataPrepare(c("TCGA-OR-A5K3-01A","C3N-00321-01"))
 metadata <- colDataPrepare(c("BLGSP-71-06-00157-01A",
                              "BLGSP-71-22-00332-01A"))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/query.R
\name{getMC3MAF}
\alias{getMC3MAF}
\title{Retrieve open access mc3 MAF file from GDC server}
\usage{
getMC3MAF()
}
\value{
A data frame with the MAF file information from https://gdc.cancer.gov/about-data/publications/mc3-2017
}
\description{
Download data from https://gdc.cancer.gov/about-data/publications/mc3-2017
  https://gdc-docs.nci.nih.gov/Data/Release_Notes/Data_Release_Notes/
}
\examples{
\dontrun{
   maf <- getMC3MAF()
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TCGAbiolinks.R
\docType{data}
\name{clinical.biotab}
\alias{clinical.biotab}
\title{A list of data frames with clinical data parsed from XML (code in vignettes)}
\format{
A list with 7 elements
}
\description{
A list of data frames with clinical data parsed from XML (code in vignettes)
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methylation.R
\name{TCGAvisualize_starburst}
\alias{TCGAvisualize_starburst}
\title{Create starburst plot}
\usage{
TCGAvisualize_starburst(
  met,
  exp,
  group1 = NULL,
  group2 = NULL,
  exp.p.cut = 0.01,
  met.p.cut = 0.01,
  diffmean.cut = 0,
  logFC.cut = 0,
  met.platform = c("Illumina Human Methylation 450", "Illumina Human Methylation 27",
    "Illumina Methylation Epic"),
  genome,
  names = FALSE,
  names.fill = TRUE,
  filename = "starburst.png",
  return.plot = FALSE,
  ylab = expression(atop("Gene Expression", paste(-Log[10],
    " (FDR corrected P values)"))),
  xlab = expression(atop("DNA Methylation", paste(-Log[10],
    " (FDR corrected P values)"))),
  title = "Starburst Plot",
  legend = "DNA Methylation/Expression Relation",
  color = NULL,
  label = c("Not Significant", "Up regulated & Hypo methylated",
    "Down regulated & Hypo methylated", "hypo methylated", "hyper methylated",
    "Up regulated", "Down regulated", "Up regulated & Hyper methylated",
    "Down regulated & Hyper methylated"),
  xlim = NULL,
  ylim = NULL,
  height = 10,
  width = 20,
  dpi = 600
)
}
\arguments{
\item{met}{A SummarizedExperiment with methylation data obtained from the
TCGAPrepare or Data frame from DMR_results file. Expected colData columns: diffmean,  p.value.adj  and p.value
Execute volcanoPlot function in order to obtain these values for the object.}

\item{exp}{Object obtained by DEArnaSEQ function}

\item{group1}{The name of the group 1
Obs: Column p.value.adj.group1.group2 should exist}

\item{group2}{The name of the group 2.
Obs: Column p.value.adj.group1.group2 should exist}

\item{exp.p.cut}{expression p value cut-off}

\item{met.p.cut}{methylation p value cut-off}

\item{diffmean.cut}{If set, the probes with diffmean higher
than methylation cut-off will be
 highlighted in the plot. And the data frame return will be subseted.}

\item{logFC.cut}{If set, the probes with expression fold
change higher than methylation cut-off will be
 highlighted in the plot. And the data frame return will be subseted.}

\item{met.platform}{DNA methylation platform  "Illumina Human Methylation 450",
"Illumina Human Methylation 27", "Illumina Methylation Epic"}

\item{genome}{Genome of reference ("hg38" or "hg19") used to identify nearest probes TSS}

\item{names}{Add the names of the significant genes? Default: FALSE}

\item{names.fill}{Names should be filled in a color box?  Default: TRUE}

\item{filename}{The filename of the file (it can be pdf, svg, png, etc)}

\item{return.plot}{If true only plot object will be returned (pdf will not be created)}

\item{ylab}{y axis text}

\item{xlab}{x axis text}

\item{title}{main title}

\item{legend}{legend title}

\item{color}{vector of colors to be used in graph}

\item{label}{vector of labels to be used in graph}

\item{xlim}{x limits to cut image}

\item{ylim}{y limits to cut image}

\item{height}{Figure height}

\item{width}{Figure width}

\item{dpi}{Figure dpi}
}
\value{
Save a starburst plot
}
\description{
Create Starburst plot for comparison of DNA methylation and gene expression.
   The log10 (FDR-corrected P value) is plotted for beta value for DNA
   methylation (x axis) and gene expression (y axis) for each gene.

   The black dashed line shows the FDR-adjusted P value of 0.01.

   You can set names to TRUE to get the names of the significant genes.

   Candidate biologically significant genes will be circled in the plot.

   Candidate biologically significant are the genes that respect the
   expression (logFC.cut), DNA methylation (diffmean.cut) and
   significance thresholds (exp.p.cut, met.p.cut)
}
\details{
Input: data with gene expression/methylation expression
   Output: starburst plot
}
\examples{
\dontrun{
library(SummarizedExperiment)
met <- TCGAbiolinks:::getMetPlatInfo(
   genome = "hg38",
   platform = "Illumina Human Methylation 27"
 )
values(met) <- NULL
met$probeID <- names(met)
nrows <- length(met); ncols <- 20
counts <- matrix(runif(nrows * ncols, 1, 1e4), nrows)
colData <- S4Vectors::DataFrame(
  Treatment = rep(c("ChIP", "Input"), 5),
  row.names = LETTERS[1:20],
  group = rep(c("group1","group2"),c(10,10))
)
met <- SummarizedExperiment::SummarizedExperiment(
         assays = S4Vectors::SimpleList(counts=counts),
         rowRanges = met,
         colData = colData
)
rowRanges(met)$diffmean.g1.g2 <- c(runif(nrows, -0.1, 0.1))
rowRanges(met)$diffmean.g2.g1 <- -1*(rowRanges(met)$diffmean.g1.g2)
rowRanges(met)$p.value.g1.g2 <- c(runif(nrows, 0, 1))
rowRanges(met)$p.value.adj.g1.g2 <- c(runif(nrows, 0, 1))
exp <- TCGAbiolinks:::get.GRCh.bioMart("hg38")
exp$logFC <- runif(nrow(exp), -5, 5)
exp$FDR <- runif(nrow(exp), 0.01, 1)

result <- TCGAvisualize_starburst(
  met,
  exp,
  exp.p.cut = 0.05,
  met.p.cut = 0.05,
  logFC.cut = 2,
  group1 = "g1",
  group2 = "g2",
  genome = "hg38",
  met.platform = "27k",
  diffmean.cut = 0.0,
  names  = TRUE
)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/analyze.R
\name{TCGAanalyze_EA}
\alias{TCGAanalyze_EA}
\title{Enrichment analysis of a gene-set with GO [BP,MF,CC]  and pathways.}
\usage{
TCGAanalyze_EA(
  GeneName,
  RegulonList,
  TableEnrichment,
  EAGenes,
  GOtype,
  FDRThresh = 0.01,
  GeneSymbolsTable = FALSE
)
}
\arguments{
\item{GeneName}{is the name of gene signatures list}

\item{RegulonList}{is a gene signature (lisf of genes) in which perform EA.}

\item{TableEnrichment}{is a table related to annotations of gene symbols such as
GO[BP,MF,CC] and Pathways. It was created from DAVID gene ontology on-line.}

\item{EAGenes}{is a table with informations about genes
such as ID, Gene, Description, Location and Family.}

\item{GOtype}{is type of gene ontology Biological process (BP), Molecular Function (MF),
Cellular componet (CC)}

\item{FDRThresh}{pvalue corrected (FDR) as threshold to selected significant
BP, MF,CC, or pathways. (default FDR < 0.01)}

\item{GeneSymbolsTable}{if it is TRUE will return a table with GeneSymbols in common GO or pathways.}
}
\value{
Table with enriched GO or pathways by selected gene signature.
}
\description{
The rational behind a enrichment analysis ( gene-set, pathway etc) is to compute
statistics of whether the overlap between the focus list (signature) and the gene-set
is significant. ie the confidence that overlap between the list is not due to chance.
 The Gene Ontology project describes genes (gene products) using terms from
 three structured vocabularies: biological process, cellular component and molecular function.
 The Gene Ontology Enrichment component, also referred to as the GO Terms" component, allows
 the genes in any such "changed-gene" list to be characterized using the Gene Ontology terms
 annotated to them. It asks, whether for any particular GO term, the fraction of genes
 assigned to it in the "changed-gene" list is higher than expected by chance
 (is over-represented), relative to the fraction of genes assigned to that term in the
 reference set.
 In statistical terms it perform the analysis tests the null hypothesis that,
 for any particular ontology term, there is no difference in the proportion of genes
 annotated to it in the reference list and the proportion annotated to it in the test list.
 We adopted a Fisher Exact Test to perform the EA.
}
\examples{
\dontrun{
EAGenes <- get("EAGenes")
RegulonList <- rownames(dataDEGsFiltLevel)
ResBP <- TCGAanalyze_EA(
  GeneName="DEA genes Normal Vs Tumor",
  RegulonList = RegulonList,
  TableEnrichment = DAVID_BP_matrix,
   EAGenes = EAGenes,
   GOtype = "DavidBP"
 )
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/query.R
\name{GDCquery_ATAC_seq}
\alias{GDCquery_ATAC_seq}
\title{Retrieve open access ATAC-seq files from GDC server}
\usage{
GDCquery_ATAC_seq(tumor = NULL, file.type = NULL)
}
\arguments{
\item{tumor}{a valid tumor}

\item{file.type}{Write maf file into a csv document}
}
\value{
A data frame with the maf file information
}
\description{
Retrieve open access ATAC-seq files from GDC server
 https://gdc.cancer.gov/about-data/publications/ATACseq-AWG
 Manifest available at: https://gdc.cancer.gov/files/public/file/ATACseq-AWG_Open_GDC-Manifest.txt
}
\examples{
 query <- GDCquery_ATAC_seq(file.type = "txt")
\dontrun{
   GDCdownload(query)
}
query <- GDCquery_ATAC_seq(tumor = "BRCA",file.type = "bigWigs")
\dontrun{
   GDCdownload(query,method = "client")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TCGAbiolinks.R
\docType{data}
\name{SC_PCBC_stemSig}
\alias{SC_PCBC_stemSig}
\title{A numeric vector with stem cell-like signature trained on PCBC's dataset}
\format{
A numeric vector with 12956 genes
}
\description{
A numeric vector with stem cell-like signature trained on PCBC's dataset
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/visualize.R
\name{TCGAvisualize_PCA}
\alias{TCGAvisualize_PCA}
\title{Principal components analysis (PCA) plot}
\usage{
TCGAvisualize_PCA(dataFilt, dataDEGsFiltLevel, ntopgenes, group1, group2)
}
\arguments{
\item{dataFilt}{A filtered dataframe or numeric matrix where each row represents a gene,
each column represents a sample from function TCGAanalyze_Filtering}

\item{dataDEGsFiltLevel}{table with DEGs, log Fold Change (FC), false discovery rate (FDR),
the gene expression level, etc, from function TCGAanalyze_LevelTab.}

\item{ntopgenes}{number of DEGs genes to plot in PCA}

\item{group1}{a string containing the barcode list of the samples in in control group}

\item{group2}{a string containing the barcode list of the samples in in disease group
the name of the group}
}
\value{
principal components analysis (PCA) plot of PC1 and PC2
}
\description{
TCGAvisualize_PCA performs a principal components analysis (PCA) on the given data matrix
  and returns the results as an object of class prcomp, and shows results in PCA level.
}
\examples{
# normalization of genes
dataNorm <- TCGAbiolinks::TCGAanalyze_Normalization(tabDF = dataBRCA, geneInfo = geneInfo,
method = "geneLength")
# quantile filter of genes
dataFilt <- TCGAanalyze_Filtering(tabDF = dataBRCA, method = "quantile", qnt.cut =  0.25)
# Principal Component Analysis plot for ntop selected DEGs
    # selection of normal samples "NT"
    group1 <- TCGAquery_SampleTypes(colnames(dataFilt), typesample = c("NT"))
    # selection of normal samples "TP"
    group2 <- TCGAquery_SampleTypes(colnames(dataFilt), typesample = c("TP"))
pca <- TCGAvisualize_PCA(dataFilt,dataDEGsFiltLevel, ntopgenes = 200, group1, group2)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TCGAbiolinks.R
\docType{data}
\name{met.gbm.27k}
\alias{met.gbm.27k}
\title{A DNA methylation RangedSummarizedExperiment for 8 samples (only first 20 probes)
aligned against hg19}
\format{
A RangedSummarizedExperiment: 20 probes, 8 samples
}
\description{
A DNA methylation RangedSummarizedExperiment for 8 samples (only first 20 probes)
aligned against hg19
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/prepare.R
\name{GDCprepare}
\alias{GDCprepare}
\title{Prepare GDC data}
\usage{
GDCprepare(
  query,
  save = FALSE,
  save.filename,
  directory = "GDCdata",
  summarizedExperiment = TRUE,
  remove.files.prepared = FALSE,
  add.gistic2.mut = NULL,
  mutant_variant_classification = c("Frame_Shift_Del", "Frame_Shift_Ins",
    "Missense_Mutation", "Nonsense_Mutation", "Splice_Site", "In_Frame_Del",
    "In_Frame_Ins", "Translation_Start_Site", "Nonstop_Mutation")
)
}
\arguments{
\item{query}{A query for GDCquery function}

\item{save}{Save result as RData object?}

\item{save.filename}{Name of the file to be save if empty an automatic will be created}

\item{directory}{Directory/Folder where the data was downloaded. Default: GDCdata}

\item{summarizedExperiment}{Create a summarizedExperiment? Default TRUE (if possible)}

\item{remove.files.prepared}{Remove the files read? Default: FALSE
This argument will be considered only if save argument is set to true}

\item{add.gistic2.mut}{If a list of genes (gene symbol) is given, columns with gistic2 results from GDAC firehose (hg19)
and a column indicating if there is or not mutation in that gene (hg38)
(TRUE or FALSE - use the MAF file for more information)
will be added to the sample matrix in the summarized Experiment object.}

\item{mutant_variant_classification}{List of mutant_variant_classification that will be
consider a sample mutant or not. Default: "Frame_Shift_Del", "Frame_Shift_Ins",
"Missense_Mutation", "Nonsense_Mutation", "Splice_Site", "In_Frame_Del",
"In_Frame_Ins", "Translation_Start_Site", "Nonstop_Mutation"}
}
\value{
A summarizedExperiment or a data.frame
}
\description{
Reads the data downloaded and prepare it into an R object
}
\examples{
\dontrun{
query <- GDCquery(
  project = "TCGA-KIRP",
  data.category = "Simple Nucleotide Variation",
  data.type = "Masked Somatic Mutation"
)
GDCdownload(query, method = "api", directory = "maf")
maf <- GDCprepare(query, directory = "maf")

}
}
\author{
Tiago Chedraoui Silva
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TCGAbiolinks.R
\docType{data}
\name{classification}
\alias{classification}
\title{Result of gliomaclassifier function}
\format{
A list of data frames
}
\description{
Result of gliomaclassifier function
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TCGAbiolinks.R
\docType{data}
\name{chol_maf}
\alias{chol_maf}
\title{TCGA CHOL MAF transformed to maftools object}
\format{
An object of class  MAF
}
\description{
TCGA CHOL MAF transformed to maftools object
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/analyze.R
\name{gaiaCNVplot}
\alias{gaiaCNVplot}
\title{Creates a plot for GAIA output (all significant aberrant regions.)}
\usage{
gaiaCNVplot(calls, threshold = 0.01)
}
\arguments{
\item{calls}{A matrix with the following columns: Chromossome, Aberration Kind
Region Start, Region End, Region Size and score}

\item{threshold}{Score threshold (orange horizontal line in the plot)}
}
\value{
A plot with all significant aberrant regions.
}
\description{
This function is a auxiliary function to visualize GAIA output
(all significant aberrant regions.)
}
\examples{
call <- data.frame("Chromossome" = rep(9,100),
                   "Aberration Kind" = rep(c(-2,-1,0,1,2),20),
                   "Region Start [bp]" = 18259823:18259922,
                   "Region End [bp]" = 18259823:18259922,
                   "score" = rep(c(1,2,3,4),25))
 gaiaCNVplot(call,threshold = 0.01)
 call <- data.frame("Chromossome" = rep(c(1,9),50),
                    "Aberration Kind" = rep(c(-2,-1,0,1,2),20),
                    "Region Start [bp]" = 18259823:18259922,
                    "Region End [bp]" = 18259823:18259922,
                    "score" = rep(c(1,2,3,4),25))
 gaiaCNVplot(call,threshold = 0.01)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methylation.R
\name{TCGAanalyze_survival}
\alias{TCGAanalyze_survival}
\title{Creates survival analysis}
\usage{
TCGAanalyze_survival(
  data,
  clusterCol = NULL,
  legend = "Legend",
  labels = NULL,
  risk.table = TRUE,
  xlim = NULL,
  main = "Kaplan-Meier Overall Survival Curves",
  ylab = "Probability of survival",
  xlab = "Time since diagnosis (days)",
  filename = "survival.pdf",
  color = NULL,
  height = 8,
  width = 12,
  dpi = 300,
  pvalue = TRUE,
  conf.int = TRUE,
  ...
)
}
\arguments{
\item{data}{TCGA Clinical patient with the information days_to_death}

\item{clusterCol}{Column with groups to plot. This is a mandatory field, the
caption will be based in this column}

\item{legend}{Legend title of the figure}

\item{labels}{labels of the plot}

\item{risk.table}{show or not the risk table}

\item{xlim}{x axis limits e.g. xlim = c(0, 1000). Present narrower X axis, but not affect survival estimates.}

\item{main}{main title of the plot}

\item{ylab}{y axis text of the plot}

\item{xlab}{x axis text of the plot}

\item{filename}{The name of the pdf file.}

\item{color}{Define the colors/Pallete for lines.}

\item{height}{Image height}

\item{width}{Image width}

\item{dpi}{Figure quality}

\item{pvalue}{show p-value of log-rank test}

\item{conf.int}{show confidence intervals for point estimates of survival curves.}

\item{...}{Further arguments passed to \link[survminer]{ggsurvplot}.}
}
\value{
Survival plot
}
\description{
Creates a survival plot from TCGA patient clinical data
using survival library. It uses the fields days_to_death and vital, plus a
columns for groups.
}
\examples{
 # clin <- GDCquery_clinic("TCGA-BRCA","clinical")
 clin <- data.frame(
      vital_status = c("alive","alive","alive","dead","alive",
                       "alive","dead","alive","dead","alive"),
      days_to_death = c(NA,NA,NA,172,NA,NA,3472,NA,786,NA),
      days_to_last_follow_up = c(3011,965,718,NA,1914,423,NA,5,656,1417),
      gender = c(rep("male",5),rep("female",5))
 )
TCGAanalyze_survival(clin, clusterCol="gender")
TCGAanalyze_survival(clin, clusterCol="gender", xlim = 1000)
TCGAanalyze_survival(clin,
                     clusterCol="gender",
                     risk.table = FALSE,
                     conf.int = FALSE,
                     color = c("pink","blue"))
TCGAanalyze_survival(clin,
                     clusterCol="gender",
                     risk.table = FALSE,
                     xlim = c(100,1000),
                     conf.int = FALSE,
                     color = c("Dark2"))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/clinical.R
\name{TCGAquery_MatchedCoupledSampleTypes}
\alias{TCGAquery_MatchedCoupledSampleTypes}
\title{Retrieve multiple tissue types from the same patients.}
\usage{
TCGAquery_MatchedCoupledSampleTypes(barcode, typesample)
}
\arguments{
\item{barcode}{barcode}

\item{typesample}{typesample}
}
\value{
a list of samples / barcode filtered by type sample selected
}
\description{
TCGAquery_MatchedCoupledSampleTypes
}
\examples{
 TCGAquery_MatchedCoupledSampleTypes(c("TCGA-B0-4698-01Z-00-DX1",
                             "TCGA-B0-4698-02Z-00-DX1"),
                             c("TP","TR"))
 barcode <- c("TARGET-20-PANSBH-02A-02D","TARGET-20-PANSBH-01A-02D",
              "TCGA-B0-4698-01Z-00-DX1","TCGA-CZ-4863-02Z-00-DX1",
              "TARGET-20-PANSZZ-02A-02D","TARGET-20-PANSZZ-11A-02D",
              "TCGA-B0-4699-01Z-00-DX1","TCGA-B0-4699-02Z-00-DX1"
              )
  TCGAquery_MatchedCoupledSampleTypes(barcode,c("TR","TP"))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/query.R
\name{TCGAquery_recount2}
\alias{TCGAquery_recount2}
\title{Query gene counts of TCGA and GTEx data from the Recount2 project}
\usage{
TCGAquery_recount2(project, tissue = c())
}
\arguments{
\item{project}{is a string denoting which project the user wants. Options are "tcga" and "gtex"}

\item{tissue}{a vector of tissue(s) to download. Options are "adipose tissue", "adrenal gland", "bladder","blood", "blood vessel", "bone marrow", "brain", "breast","cervix uteri", "colon", "esophagus", "fallopian tube","heart", "kidney", "liver", "lung", "muscle", "nerve", "ovary","pancreas", "pituitary", "prostate", "salivary gland", "skin", "small intestine", "spleen", "stomach", "testis", "thyroid", "uterus", "vagina"}
}
\value{
List with $subtypes attribute as a dataframe with barcodes, samples, subtypes, and colors. The $filtered attribute is returned as filtered samples with no subtype info
}
\description{
TCGArecount2_query queries and downloads data produced by the Recount2 project. User can specify which project and which tissue to query
}
\examples{
\dontrun{
 brain.rec<-TCGAquery_recount2(project = "gtex", tissue = "brain")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/api.R
\name{getNbCases}
\alias{getNbCases}
\title{Get Number of cases in GDC for a project}
\usage{
getNbCases(project, data.category, legacy = FALSE)
}
\arguments{
\item{project}{A  GDC project}

\item{data.category}{A  GDC project data category}

\item{legacy}{Select between Harmonized or Legacy database}
}
\description{
Get Number of cases in GDC for a project
}
\examples{
\dontrun{
getNbCases("TCGA-ACC","Clinical")
getNbCases("CPTAC-2","Clinical")
}
}
\author{
Tiago Chedraoui Silva
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/query.R
\name{GDCquery}
\alias{GDCquery}
\title{Query GDC data}
\usage{
GDCquery(
  project,
  data.category,
  data.type,
  workflow.type,
  access,
  platform,
  barcode,
  data.format,
  experimental.strategy,
  sample.type
)
}
\arguments{
\item{project}{A list of valid project (see list with TCGAbiolinks:::getGDCprojects()$project_id)]
\itemize{
\item{ BEATAML1.0-COHORT }
\item{ BEATAML1.0-CRENOLANIB }
\item{ CGCI-BLGSP }
\item{ CPTAC-2 }
\item{ CPTAC-3 }
\item{ CTSP-DLBCL1 }
\item{ FM-AD }
\item{ HCMI-CMDC }
\item{ MMRF-COMMPASS }
\item{ NCICCR-DLBCL }
\item{ OHSU-CNL }
\item{ ORGANOID-PANCREATIC }
\item{ TARGET-ALL-P1 }
\item{ TARGET-ALL-P2 }
\item{ TARGET-ALL-P3 }
\item{ TARGET-AML }
\item{ TARGET-CCSK }
\item{ TARGET-NBL }
\item{ TARGET-OS }
\item{ TARGET-RT }
\item{ TARGET-WT }
\item{ TCGA-ACC }
\item{ TCGA-BLCA }
\item{ TCGA-BRCA }
\item{ TCGA-CESC }
\item{ TCGA-CHOL }
\item{ TCGA-COAD }
\item{ TCGA-DLBC }
\item{ TCGA-ESCA }
\item{ TCGA-GBM }
\item{ TCGA-HNSC }
\item{ TCGA-KICH }
\item{ TCGA-KIRC }
\item{ TCGA-KIRP }
\item{ TCGA-LAML }
\item{ TCGA-LGG }
\item{ TCGA-LIHC }
\item{ TCGA-LUAD }
\item{ TCGA-LUSC }
\item{ TCGA-MESO }
\item{ TCGA-OV }
\item{ TCGA-PAAD }
\item{ TCGA-PCPG }
\item{ TCGA-PRAD }
\item{ TCGA-READ }
\item{ TCGA-SARC }
\item{ TCGA-SKCM }
\item{ TCGA-STAD }
\item{ TCGA-TGCT }
\item{ TCGA-THCA }
\item{ TCGA-THYM }
\item{ TCGA-UCEC }
\item{ TCGA-UCS }
\item{ TCGA-UVM }
\item{ VAREPOP-APOLLO }
}}

\item{data.category}{A valid project (see list with TCGAbiolinks:::getProjectSummary(project))
For the complete list please check the vignette.
List for harmonized database:
\itemize{
\item{ Biospecimen }
\item{ Clinical }
\item{ Copy Number Variation }
\item{ DNA Methylation }
\item{ Sequencing Reads }
\item{ Simple Nucleotide Variation }
\item{ Transcriptome Profiling }
}}

\item{data.type}{A data type to filter the files to download
For the complete list please check the vignette.}

\item{workflow.type}{GDC workflow type}

\item{access}{Filter by access type. Possible values: controlled, open}

\item{platform}{Example:
\tabular{ll}{
CGH- 1x1M_G4447A                   \tab IlluminaGA_RNASeqV2   \cr
AgilentG4502A_07                  \tab IlluminaGA_mRNA_DGE    \cr
Human1MDuo                        \tab HumanMethylation450    \cr
HG-CGH-415K_G4124A                \tab IlluminaGA_miRNASeq    \cr
HumanHap550                       \tab IlluminaHiSeq_miRNASeq \cr
ABI                               \tab H-miRNA_8x15K  \cr
HG-CGH-244A                       \tab SOLiD_DNASeq                \cr
IlluminaDNAMethylation_OMA003_CPI \tab IlluminaGA_DNASeq_automated   \cr
IlluminaDNAMethylation_OMA002_CPI \tab HG-U133_Plus_2                 \cr
HuEx- 1_0-st-v2 \tab Mixed_DNASeq                  \cr
H-miRNA_8x15Kv2 \tab IlluminaGA_DNASeq_curated      \cr
MDA_RPPA_Core   \tab IlluminaHiSeq_TotalRNASeqV2    \cr
HT_HG-U133A     \tab IlluminaHiSeq_DNASeq_automated \cr
diagnostic_images                 \tab microsat_i                     \cr
IlluminaHiSeq_RNASeq              \tab SOLiD_DNASeq_curated           \cr
IlluminaHiSeq_DNASeqC             \tab Mixed_DNASeq_curated           \cr
IlluminaGA_RNASeq                 \tab IlluminaGA_DNASeq_Cont_automated  \cr
IlluminaGA_DNASeq                 \tab IlluminaHiSeq_WGBS             \cr
pathology_reports                 \tab IlluminaHiSeq_DNASeq_Cont_automated\cr
Genome_Wide_SNP_6                 \tab bio                            \cr
tissue_images                     \tab Mixed_DNASeq_automated         \cr
HumanMethylation27                \tab Mixed_DNASeq_Cont_curated      \cr
IlluminaHiSeq_RNASeqV2            \tab Mixed_DNASeq_Cont
}}

\item{barcode}{A list of barcodes to filter the files to download}

\item{data.format}{Data format filter ("VCF", "TXT", "BAM","SVS","BCR XML","BCR SSF XML",
"TSV", "BCR Auxiliary XML", "BCR OMF XML", "BCR Biotab", "MAF", "BCR PPS XML", "XLSX")}

\item{experimental.strategy}{Filter to experimental strategy.
Harmonized: WXS, RNA-Seq, miRNA-Seq, Genotyping Array.}

\item{sample.type}{A sample type to filter the files to download}
}
\value{
A data frame with the results and the parameters used
}
\description{
Uses GDC API to search for search, it searches for both controlled and
  open-access data.
  For GDC data arguments project, data.category, data.type and workflow.type should be used
  Please, see the vignette for a table with the possibilities.
}
\examples{
query <- GDCquery(
   project = "TCGA-ACC",
   data.category = "Copy Number Variation",
   data.type = "Copy Number Segment"
)
\dontrun{
query <- GDCquery(
  project = "TARGET-AML",
  data.category = "Transcriptome Profiling",
  data.type = "miRNA Expression Quantification",
  workflow.type = "BCGSC miRNA Profiling",
  barcode = c("TARGET-20-PARUDL-03A-01R","TARGET-20-PASRRB-03A-01R")
)
query <- GDCquery(
   project = "TARGET-AML",
   data.category = "Transcriptome Profiling",
   data.type = "Gene Expression Quantification",
   workflow.type = "STAR - Counts",
   barcode = c("TARGET-20-PADZCG-04A-01R","TARGET-20-PARJCR-09A-01R")
)
query <- GDCquery(
   project = "TCGA-ACC",
   data.category =  "Copy Number Variation",
   data.type = "Masked Copy Number Segment",
   sample.type = c("Primary Tumor")
)
}
}
\author{
Tiago Chedraoui Silva
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/analyze.R
\name{matchedMetExp}
\alias{matchedMetExp}
\title{Get GDC primary tumors samples with both DNA methylation (HM450K) and Gene expression data}
\usage{
matchedMetExp(project, n = NULL)
}
\arguments{
\item{project}{A GDC project}

\item{n}{Number of samples to return. If NULL return all (default)}
}
\value{
A vector of barcodes
}
\description{
For a given TCGA project it gets the  primary tumors samples (barcode) with both
DNA methylation and Gene expression data from GDC database
}
\examples{
# Get ACC samples with both  DNA methylation (HM450K) and gene expression aligned to hg19
samples <- matchedMetExp("TCGA-UCS")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/analyze.R
\name{TCGAanalyze_LevelTab}
\alias{TCGAanalyze_LevelTab}
\title{Adding information related to DEGs genes from DEA as mean values in two conditions.}
\usage{
TCGAanalyze_LevelTab(
  FC_FDR_table_mRNA,
  typeCond1,
  typeCond2,
  TableCond1,
  TableCond2,
  typeOrder = TRUE
)
}
\arguments{
\item{FC_FDR_table_mRNA}{Output of dataDEGs filter by abs(LogFC) >=1}

\item{typeCond1}{a string containing the class label of the samples
in TableCond1  (e.g., control group)}

\item{typeCond2}{a string containing the class label of the samples
in TableCond2  (e.g., case group)}

\item{TableCond1}{numeric matrix, each row represents a gene, each column
represents a sample with Cond1type}

\item{TableCond2}{numeric matrix, each row represents a gene, each column
represents a sample with Cond2type}

\item{typeOrder}{typeOrder}
}
\value{
table with DEGs, log Fold Change (FC), false discovery rate (FDR),
the gene expression level
for samples in  Cond1type, and Cond2type, and Delta value (the difference
of gene expression between the two
conditions multiplied logFC)
}
\description{
TCGAanalyze_LevelTab allows user to add information related to DEGs genes from
   Differentially expression analysis (DEA) such as mean values and in two conditions.
}
\examples{
dataNorm <- TCGAbiolinks::TCGAanalyze_Normalization(dataBRCA, geneInfo)
dataFilt <- TCGAanalyze_Filtering(tabDF = dataBRCA, method = "quantile", qnt.cut =  0.25)
samplesNT <- TCGAquery_SampleTypes(colnames(dataFilt), typesample = c("NT"))
samplesTP <- TCGAquery_SampleTypes(colnames(dataFilt), typesample = c("TP"))
dataDEGs <- TCGAanalyze_DEA(
  dataFilt[,samplesNT],
  dataFilt[,samplesTP],
  Cond1type = "Normal",
  Cond2type = "Tumor"
)
dataDEGsFilt <- dataDEGs[abs(dataDEGs$logFC) >= 1,]
dataTP <- dataFilt[,samplesTP]
dataTN <- dataFilt[,samplesNT]
dataDEGsFiltLevel <- TCGAanalyze_LevelTab(
  FC_FDR_table_mRNA = dataDEGsFilt,
  typeCond1 = "Tumor",
  typeCond2 = "Normal",
  TableCond1 = dataTP,
  TableCond2 = dataTN
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/internal.R
\name{ggbiplot}
\alias{ggbiplot}
\title{Biplot for Principal Components using ggplot2}
\usage{
ggbiplot(
  pcobj,
  choices = 1:2,
  scale = 1,
  pc.biplot = TRUE,
  obs.scale = 1 - scale,
  var.scale = scale,
  groups = NULL,
  ellipse = FALSE,
  ellipse.prob = 0.68,
  labels = NULL,
  labels.size = 3,
  alpha = 1,
  var.axes = TRUE,
  circle = FALSE,
  circle.prob = 0.69,
  varname.size = 3,
  varname.adjust = 1.5,
  varname.abbrev = FALSE
)
}
\arguments{
\item{pcobj}{an object returned by prcomp() or princomp()}

\item{choices}{which PCs to plot}

\item{scale}{covariance biplot (scale = 1), form biplot (scale = 0).
When scale = 1, the inner product between the variables
approximates the covariance and the distance between
the points approximates the Mahalanobis distance.}

\item{pc.biplot}{for compatibility with biplot.princomp()}

\item{obs.scale}{scale factor to apply to observations}

\item{var.scale}{scale factor to apply to variables}

\item{groups}{optional factor variable indicating the groups that
the observations belong to. If provided the points
will be colored according to groups}

\item{ellipse}{draw a normal data ellipse for each group?}

\item{ellipse.prob}{size of the ellipse in Normal probability}

\item{labels}{optional vector of labels for the observations}

\item{labels.size}{size of the text used for the labels}

\item{alpha}{alpha transparency value for the points
(0 = transparent, 1 = opaque)}

\item{var.axes}{draw arrows for the variables?}

\item{circle}{draw a correlation circle?
(only applies when prcomp was called with scale = TRUE
and when var.scale = 1)}

\item{circle.prob}{definition of circle.prob}

\item{varname.size}{size of the text for variable names}

\item{varname.adjust}{adjustment factor the placement of the variable names,
>= 1 means farther from the arrow}

\item{varname.abbrev}{whether or not to abbreviate the variable names}
}
\value{
A ggplot2 plot
}
\description{
Biplot for Principal Components using ggplot2
}
\author{
Vincent Q. Vu.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/internal.R
\name{GeneSplitRegulon}
\alias{GeneSplitRegulon}
\title{GeneSplitRegulon}
\usage{
GeneSplitRegulon(Genelist, Sep)
}
\arguments{
\item{Genelist}{Genelist}

\item{Sep}{Sep}
}
\value{
GeneSplitRegulon
}
\description{
GeneSplitRegulon
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TCGAbiolinks.R
\docType{data}
\name{gbm.exp.harmonized}
\alias{gbm.exp.harmonized}
\title{A RangedSummarizedExperiment two samples with gene expression data from vignette
aligned against hg38}
\format{
A RangedSummarizedExperiment: 56963 genes, 2 samples
}
\description{
A RangedSummarizedExperiment two samples with gene expression data from vignette
aligned against hg38
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/download.R
\name{GDCdownload}
\alias{GDCdownload}
\title{Download GDC data}
\usage{
GDCdownload(
  query,
  token.file,
  method = "api",
  directory = "GDCdata",
  files.per.chunk = NULL
)
}
\arguments{
\item{query}{A query for GDCquery function}

\item{token.file}{Token file to download controlled data (only for method = "client")}

\item{method}{Uses the API (POST method) or gdc client tool. Options "api", "client".
API is faster, but the data might get corrupted in the download, and it might need to be executed again}

\item{directory}{Directory/Folder where the data was downloaded. Default: GDCdata}

\item{files.per.chunk}{This will make the API method only download n (files.per.chunk) files at a time.
This may reduce the download problems when the data size is too large. Expected a integer number (example files.per.chunk = 6)}
}
\value{
Shows the output from the GDC transfer tools
}
\description{
Uses GDC API or GDC transfer tool to download gdc data
  The user can use query argument
  The data from query will be save in a folder: project/data.category
}
\examples{
\dontrun{
# Download clinical data from XML
query <- GDCquery(project = "TCGA-COAD", data.category = "Clinical")
GDCdownload(query, files.per.chunk = 200)
query <- GDCquery(
  project = "TARGET-AML",
  data.category = "Transcriptome Profiling",
  data.type = "miRNA Expression Quantification",
  workflow.type = "BCGSC miRNA Profiling",
  barcode = c("TARGET-20-PARUDL-03A-01R", "TARGET-20-PASRRB-03A-01R")
)
# data will be saved in:
# example_data_dir/TARGET-AML/harmonized/Transcriptome_Profiling/miRNA_Expression_Quantification
GDCdownload(query, method = "client", directory = "example_data_dir")
query_acc_gbm <- GDCquery(
  project = c("TCGA-ACC", "TCGA-GBM"),
  data.category = "Transcriptome Profiling",
  data.type = "Gene Expression Quantification",
  workflow.type = "STAR - Counts"
)
GDCdownload(
  query = query_acc_gbm,
  method = "api",
  directory = "example",
  files.per.chunk = 50
)
}
}
\author{
Tiago Chedraoui Silva
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/clinical.R
\name{GDCquery_clinic}
\alias{GDCquery_clinic}
\title{Get GDC clinical data}
\usage{
GDCquery_clinic(project, type = "clinical", save.csv = FALSE)
}
\arguments{
\item{project}{A valid project (see list with getGDCprojects()$project_id)]
\itemize{
\item{ BEATAML1.0-COHORT }
\item{ BEATAML1.0-CRENOLANIB }
\item{ CGCI-BLGSP }
\item{ CPTAC-2 }
\item{ CPTAC-3 }
\item{ CTSP-DLBCL1 }
\item{ FM-AD }
\item{ HCMI-CMDC }
\item{ MMRF-COMMPASS }
\item{ NCICCR-DLBCL }
\item{ OHSU-CNL }
\item{ ORGANOID-PANCREATIC }
\item{ TARGET-ALL-P1 }
\item{ TARGET-ALL-P2 }
\item{ TARGET-ALL-P3 }
\item{ TARGET-AML }
\item{ TARGET-CCSK }
\item{ TARGET-NBL }
\item{ TARGET-OS }
\item{ TARGET-RT }
\item{ TARGET-WT }
\item{ TCGA-ACC }
\item{ TCGA-BLCA }
\item{ TCGA-BRCA }
\item{ TCGA-CESC }
\item{ TCGA-CHOL }
\item{ TCGA-COAD }
\item{ TCGA-DLBC }
\item{ TCGA-ESCA }
\item{ TCGA-GBM }
\item{ TCGA-HNSC }
\item{ TCGA-KICH }
\item{ TCGA-KIRC }
\item{ TCGA-KIRP }
\item{ TCGA-LAML }
\item{ TCGA-LGG }
\item{ TCGA-LIHC }
\item{ TCGA-LUAD }
\item{ TCGA-LUSC }
\item{ TCGA-MESO }
\item{ TCGA-OV }
\item{ TCGA-PAAD }
\item{ TCGA-PCPG }
\item{ TCGA-PRAD }
\item{ TCGA-READ }
\item{ TCGA-SARC }
\item{ TCGA-SKCM }
\item{ TCGA-STAD }
\item{ TCGA-TGCT }
\item{ TCGA-THCA }
\item{ TCGA-THYM }
\item{ TCGA-UCEC }
\item{ TCGA-UCS }
\item{ TCGA-UVM }
\item{ VAREPOP-APOLLO }
}}

\item{type}{A valid type. Options "clinical", "Biospecimen"  (see list with getGDCprojects()$project_id)]}

\item{save.csv}{Write clinical information into a csv document}
}
\value{
A data frame with the clinical information
}
\description{
GDCquery_clinic will download all clinical information from the API
as the one with using the button from each project
}
\examples{
clinical <- GDCquery_clinic(
   project = "TCGA-ACC",
   type = "clinical",
   save.csv = FALSE
 )
clinical <- GDCquery_clinic(
   project = "TCGA-ACC",
   type = "biospecimen",
   save.csv = FALSE
)
\dontrun{
clinical_cptac_3 <- GDCquery_clinic(
   project = "CPTAC-3",
   type = "clinical"
)
clinical_cptac_2 <- GDCquery_clinic(
   project = "CPTAC-2",
   type = "clinical"
)
clinical_HCMI_CMDC <- GDCquery_clinic(
   project = "HCMI-CMDC",
   type = "clinical"
)
clinical_GCI_HTMCP_CC <- GDCquery_clinic(
   project = "CGCI-HTMCP-CC",
   type = "clinical"
)
clinical <- GDCquery_clinic(
   project = "NCICCR-DLBCL",
   type = "clinical"
)
clinical <- GDCquery_clinic(
   project = "ORGANOID-PANCREATIC",
   type = "clinical"
)
}
}
\author{
Tiago Chedraoui Silva
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methylation.R
\name{TCGAanalyze_DMC}
\alias{TCGAanalyze_DMC}
\title{Differentially methylated regions Analysis}
\usage{
TCGAanalyze_DMC(
  data,
  groupCol = NULL,
  group1 = NULL,
  group2 = NULL,
  alternative = "two.sided",
  diffmean.cut = 0.2,
  paired = FALSE,
  adj.method = "BH",
  plot.filename = "methylation_volcano.pdf",
  ylab = expression(paste(-Log[10], " (FDR corrected P-values)")),
  xlab = expression(paste("DNA Methylation difference (", beta, "-values)")),
  title = NULL,
  legend = "Legend",
  color = c("black", "red", "darkgreen"),
  label = NULL,
  xlim = NULL,
  ylim = NULL,
  p.cut = 0.01,
  probe.names = FALSE,
  cores = 1,
  save = TRUE,
  save.directory = ".",
  filename = NULL
)
}
\arguments{
\item{data}{SummarizedExperiment obtained from the TCGAPrepare}

\item{groupCol}{Columns with the groups inside the SummarizedExperiment
object. (This will be obtained by the function colData(data))}

\item{group1}{In case our object has more than 2 groups, you should set
the name of the group}

\item{group2}{In case our object has more than 2 groups, you should set
the name of the group}

\item{alternative}{wilcoxon test alternative}

\item{diffmean.cut}{diffmean threshold. Default: 0.2}

\item{paired}{Wilcoxon paired parameter. Default: FALSE}

\item{adj.method}{Adjusted method for the p-value calculation}

\item{plot.filename}{Filename. Default: volcano.pdf, volcano.svg, volcano.png. If set to FALSE, there will be no plot.}

\item{ylab}{y axis text}

\item{xlab}{x axis text}

\item{title}{main title. If not specified it will be
"Volcano plot (group1 vs group2)}

\item{legend}{Legend title}

\item{color}{vector of colors to be used in graph}

\item{label}{vector of labels to be used in the figure.
Example: c("Not Significant","Hypermethylated in group1",
"Hypomethylated in group1"))}

\item{xlim}{x limits to cut image}

\item{ylim}{y limits to cut image}

\item{p.cut}{p values threshold. Default: 0.01}

\item{probe.names}{is probe.names}

\item{cores}{Number of cores to be used in the non-parametric test
Default = groupCol.group1.group2.rda}

\item{save}{Save object with results? Default: TRUE}

\item{save.directory}{Directory to save the files. Default: working directory}

\item{filename}{Name of the file to save the object.}
}
\value{
Volcano plot saved and the given data with the results
(diffmean.group1.group2,p.value.group1.group2,
p.value.adj.group1.group2,status.group1.group2)
in the rowRanges where group1 and group2 are the names of the groups
}
\description{
This function will search for differentially methylated CpG sites,
  which are regarded as possible functional regions involved
  in gene transcriptional regulation.

  In order to find these regions we use the beta-values (methylation values
  ranging from 0.0 to 1.0) to compare two groups.

  Firstly, it calculates the difference between the mean methylation of each
  group for each probes. Secondly, it calculates the p-value using the
  wilcoxon test using the Benjamini-Hochberg adjustment method.
  The default parameters will require a minimum absolute beta values delta
  of 0.2 and a false discovery rate (FDR)-adjusted Wilcoxon rank-sum P-value
  of < 0.01 for the difference.

  After these analysis, we save a volcano plot (x-axis:diff mean methylation,
  y-axis: significance) that will help the user identify the differentially
  methylated CpG sites and return the object with the calculus in the rowRanges.

  If the calculus already exists in the object it will not recalculated.
  You should set overwrite parameter to TRUE to force it, or remove the
  columns with the results from the object.
}
\examples{
nrows <- 200; ncols <- 20
 counts <- matrix(
   runif(nrows * ncols, 1, 1e4), nrows,
   dimnames = list(paste0("cg",1:200),paste0("S",1:20))
)
rowRanges <- GenomicRanges::GRanges(
  rep(c("chr1", "chr2"), c(50, 150)),
  IRanges::IRanges(floor(runif(200, 1e5, 1e6)), width = 100),
  strand = sample(c("+", "-"), 200, TRUE),
  feature_id = sprintf("ID\%03d", 1:200)
)
names(rowRanges) <-  paste0("cg",1:200)
colData <- S4Vectors::DataFrame(
  Treatment = rep(c("ChIP", "Input"), 5),
  row.names = paste0("S",1:20),
  group = rep(c("group1","group2"),c(10,10))
)
data <- SummarizedExperiment::SummarizedExperiment(
         assays=S4Vectors::SimpleList(counts=counts),
         rowRanges = rowRanges,
         colData = colData
)
SummarizedExperiment::colData(data)$group <- c(rep("group 1",ncol(data)/2),
                         rep("group 2",ncol(data)/2))
hypo.hyper <- TCGAanalyze_DMC(data, p.cut = 0.85,"group","group 1","group 2")
SummarizedExperiment::colData(data)$group2 <- c(rep("group_1",ncol(data)/2),
                         rep("group_2",ncol(data)/2))
hypo.hyper <- TCGAanalyze_DMC(
  data = data,
  p.cut = 0.85,
  groupCol = "group2",
  group1 = "group_1",
  group2 = "group_2"
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/analyze.R
\name{TCGAanalyze_SurvivalKM}
\alias{TCGAanalyze_SurvivalKM}
\title{survival analysis (SA) univariate with Kaplan-Meier (KM) method.}
\usage{
TCGAanalyze_SurvivalKM(
  clinical_patient,
  dataGE,
  Genelist,
  Survresult = FALSE,
  ThreshTop = 0.67,
  ThreshDown = 0.33,
  p.cut = 0.05,
  group1,
  group2
)
}
\arguments{
\item{clinical_patient}{is a data.frame using function 'clinic' with information
related to barcode / samples such as bcr_patient_barcode, days_to_death ,
days_to_last_follow_up , vital_status, etc}

\item{dataGE}{is a matrix of Gene expression (genes in rows, samples in cols) from TCGAprepare}

\item{Genelist}{is a list of gene symbols where perform survival KM.}

\item{Survresult}{is a parameter (default = FALSE) if is TRUE will show KM plot and results.}

\item{ThreshTop}{is a quantile threshold to identify samples with high expression of a gene}

\item{ThreshDown}{is a quantile threshold to identify samples with low expression of a gene}

\item{p.cut}{p.values threshold. Default: 0.05}

\item{group1}{a string containing the barcode list of the samples in in control group}

\item{group2}{a string containing the barcode list of the samples in in disease group}
}
\value{
table with survival genes pvalues from KM.
}
\description{
TCGAanalyze_SurvivalKM perform an univariate Kaplan-Meier (KM) survival analysis (SA).
It performed Kaplan-Meier survival univariate using complete follow up with all days
taking one gene a time from Genelist of gene symbols.
For each gene according its level of mean expression in cancer samples,
defining two thresholds for quantile
expression of that gene in all samples (default ThreshTop=0.67,ThreshDown=0.33) it is possible
to define a threshold of intensity of gene expression to divide the samples in 3 groups
(High, intermediate, low).
TCGAanalyze_SurvivalKM performs SA between High and low groups using following functions
from survival package
\enumerate{
\item survival::Surv
\item survival::survdiff
\item survival::survfit
}
}
\examples{
 # Selecting only 20 genes for example
 dataBRCAcomplete <- log2(dataBRCA[1:20,] + 1)

 # clinical_patient_Cancer <- GDCquery_clinic("TCGA-BRCA","clinical")
 clinical_patient_Cancer <- data.frame(
      bcr_patient_barcode = substr(colnames(dataBRCAcomplete),1,12),
      vital_status = c(rep("alive",3),"dead",rep("alive",2),rep(c("dead","alive"),2)),
      days_to_death = c(NA,NA,NA,172,NA,NA,3472,NA,786,NA),
      days_to_last_follow_up = c(3011,965,718,NA,1914,423,NA,5,656,1417)
 )

 group1 <- TCGAquery_SampleTypes(colnames(dataBRCAcomplete), typesample = c("NT"))
 group2 <- TCGAquery_SampleTypes(colnames(dataBRCAcomplete), typesample = c("TP"))

 tabSurvKM <- TCGAanalyze_SurvivalKM(
    clinical_patient = clinical_patient_Cancer,
    dataGE = dataBRCAcomplete,
    Genelist = rownames(dataBRCAcomplete),
    Survresult = FALSE,
    p.cut = 0.4,
    ThreshTop = 0.67,
    ThreshDown = 0.33,
    group1 = group1, # Control group
    group2 = group2
  ) # Disease group

 # If the groups are not specified group1 == group2 and all samples are used
 \dontrun{
 tabSurvKM <- TCGAanalyze_SurvivalKM(
   clinical_patient_Cancer,
   dataBRCAcomplete,
   Genelist = rownames(dataBRCAcomplete),
   Survresult = TRUE,
   p.cut = 0.2,
    ThreshTop = 0.67,
    ThreshDown = 0.33
  )
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TCGAbiolinks.R
\docType{data}
\name{batch.info}
\alias{batch.info}
\title{TCGA batch information from Biospecimen Metadata Browser}
\format{
A data frame with 11382 rows and 3 variables
}
\description{
TCGA batch information from Biospecimen Metadata Browser
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/api.R
\name{getSampleFilesSummary}
\alias{getSampleFilesSummary}
\title{Retrieve summary of files per sample in a project}
\usage{
getSampleFilesSummary(project, files.access = NA)
}
\arguments{
\item{project}{A GDC project}

\item{files.access}{Filter by file access ("open" or "controlled").
Default: no filter}
}
\value{
A data frame with the maf file information
}
\description{
Retrieve the numner of files under each
  data_category + data_type + experimental_strategy + platform
  Almost like https://portal.gdc.cancer.gov/exploration
}
\examples{
   summary <- getSampleFilesSummary("TCGA-UCS")
\dontrun{
   summary <- getSampleFilesSummary(c("TCGA-OV","TCGA-ACC"))
}
}
\author{
Tiago Chedraoui Silva
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TumorPurityInfo.R
\docType{data}
\name{Tumor.purity}
\alias{Tumor.purity}
\title{TCGA samples with their Tumor Purity measures}
\format{
A data frame with 9364 rows and 7 variables:
\describe{
  \item{Sample.ID}{Sample ID from TCGA barcodes, character string}
  \item{Cancer.type}{Cancer type, character string}
  \item{ESTIMATE}{uses gene expression profiles of 141 immune genes and 141 stromal genes, 0-1 value}
  \item{ABSOLUTE}{uses somatic copy-number data (estimations were available for only 11 cancer types), 0-1 value}
  \item{LUMP}{(leukocytes unmethylation for purity), which averages 44 non-methylated immune-specific CpG sites, 
0-1value}
  \item{IHC}{as estimated by image analysis of haematoxylin and eosin stain slides produced by the Nationwide 
Childrens Hospital Biospecimen Core Resource, 0-1 value}
  \item{CPE}{derived consensus measurement as the median purity level after normalizing levels from all methods to 
give them equal means and s.ds, 0-1 value}
  ...
}
}
\source{
\url{https://images.nature.com/original/nature-assets/ncomms/2015/151204/ncomms9971/extref/ncomms9971-s2.xlsx}
}
\usage{
Tumor.purity
}
\description{
A dataset containing the Sample Ids from TCGA tumor purity measured according to 4 estimates attributes of 9364 tumor patients
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/clinical.R
\name{TCGAquery_SampleTypes}
\alias{TCGAquery_SampleTypes}
\title{Retrieve multiple tissue types not from the same patients.}
\usage{
TCGAquery_SampleTypes(barcode, typesample)
}
\arguments{
\item{barcode}{is a list of samples as TCGA barcodes}

\item{typesample}{a character vector indicating tissue type to query.
Example:
\tabular{ll}{
TP \tab   PRIMARY SOLID TUMOR \cr
TR \tab   RECURRENT SOLID TUMOR \cr
TB \tab   Primary Blood Derived Cancer-Peripheral Blood \cr
TRBM \tab Recurrent Blood Derived Cancer-Bone Marrow \cr
TAP \tab  Additional-New Primary \cr
TM \tab   Metastatic \cr
TAM \tab  Additional Metastatic \cr
THOC \tab Human Tumor Original Cells \cr
TBM \tab  Primary Blood Derived Cancer-Bone Marrow \cr
NB \tab   Blood Derived Normal \cr
NT \tab   Solid Tissue Normal \cr
NBC \tab  Buccal Cell Normal \cr
NEBV \tab EBV Immortalized Normal \cr
NBM \tab  Bone Marrow Normal \cr
}}
}
\value{
a list of samples / barcode filtered by type sample selected
}
\description{
TCGAquery_SampleTypes for a given list of samples and types,
   return the union of samples that are from theses type.
}
\examples{
# selection of normal samples "NT"
barcode <- c("TCGA-B0-4698-01Z-00-DX1","TCGA-CZ-4863-02Z-00-DX1")
# Returns the second barcode
 TCGAquery_SampleTypes(barcode,"TR")
 # Returns both barcode
 TCGAquery_SampleTypes(barcode,c("TR","TP"))
 barcode <- c("TARGET-20-PANSBH-14A-02D","TARGET-20-PANSBH-01A-02D",
              "TCGA-B0-4698-01Z-00-DX1","TCGA-CZ-4863-02Z-00-DX1")
  TCGAquery_SampleTypes(barcode,c("TR","TP"))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TCGAbiolinks.R
\docType{data}
\name{pancan2018}
\alias{pancan2018}
\title{A data frame with all TCGA molecular subtypes}
\format{
A data frame with 7,734 lines and 10 columns
}
\description{
A data frame with all TCGA molecular subtypes
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Pam50Info.R
\docType{data}
\name{TabSubtypesCol_merged}
\alias{TabSubtypesCol_merged}
\title{TCGA samples with their Pam50 subtypes}
\format{
A data frame with 4768 rows and 3 variables:
\describe{
  \item{samples}{Sample ID from TCGA barcodes, character string}
  \item{subtype}{Pam50 classification, character string}
  \item{color}{color, character string}
  ...
}
}
\usage{
TabSubtypesCol_merged
}
\description{
A dataset containing the Sample Ids from TCGA and PAM50 subtyping attributes of 4768 tumor patients
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/visualize.R
\name{TCGAVisualize_volcano}
\alias{TCGAVisualize_volcano}
\title{Creates a volcano plot for DNA methylation or gene expression}
\usage{
TCGAVisualize_volcano(
  x,
  y,
  filename = "volcano.pdf",
  ylab = expression(paste(-Log[10], " (FDR corrected P-values)")),
  xlab = NULL,
  title = "Volcano plot",
  legend = NULL,
  label = NULL,
  xlim = NULL,
  ylim = NULL,
  color = c("black", "red", "green"),
  names = NULL,
  names.fill = TRUE,
  show.names = "significant",
  x.cut = 0,
  y.cut = 0.01,
  height = 5,
  width = 10,
  highlight = NULL,
  highlight.color = "orange",
  names.size = 4,
  dpi = 300
)
}
\arguments{
\item{x}{x-axis data (i.e. Diff mean beta-values or Log2FC).}

\item{y}{FDR adjusted p-value (q-value). This data will be transformed to -log10 values.}

\item{filename}{File name: volcano.pdf, volcano.svg, volcano.png. If NULL returns
the ggplot object.}

\item{ylab}{y axis text. Default: -Log10 FDR corrected P-values}

\item{xlab}{x axis text. Default: No text. Examples of input:
expression(paste(Log[2], "FoldChange"))}

\item{title}{main title. If not specified it will be
"Volcano plot (group1 vs group2)}

\item{legend}{Legend title}

\item{label}{vector of labels to be used in the figure.
Example: c("Not Significant","Hypermethylated in group1",
"Hypomethylated in group1"))#'}

\item{xlim}{x limits to cut image (i.e. c(-4,4))}

\item{ylim}{y limits to cut image (i.e. c(-1,10))}

\item{color}{vector of colors to be used in graph}

\item{names}{Names to be plotted if significant.
Should be the same size of x and y}

\item{names.fill}{Names should be filled in a color box?  Default: TRUE}

\item{show.names}{What names will be showed? Possibilities: "both", "significant", "highlighted"}

\item{x.cut}{x-axis threshold. Default: 0.0 If you give only one number (e.g. 0.2) the cut-offs will be
-0.2 and 0.2. Or you can give different cut-offs as a vector (e.g. c(-0.3,0.4))}

\item{y.cut}{q-values threshold (i.e. 0.01, 10^-10)}

\item{height}{Figure height}

\item{width}{Figure width}

\item{highlight}{List of genes/probes to be highlighted. It should be in the names argument.}

\item{highlight.color}{Color of the points highlighted}

\item{names.size}{Size of the names text}

\item{dpi}{Figure dpi}
}
\value{
Saves the volcano plot in the current folder
}
\description{
Creates a volcano plot from the
gene expression and DNA methylation analysis.
}
\details{
Creates a volcano plot from the gene expression and DNA methylation analysis.
   Please see the vignette for more information
}
\examples{
log2_foldchange <- runif(200, -2, 2)
fdr <- runif(200, 0.01, 1)
TCGAVisualize_volcano(
    x = log2_foldchange,
    y = fdr,
    x.cut = 1.5,
    y.cut = 0.01,
    title = "Title example",
    xlab = expression(paste(Log[2], "FoldChange"))
)
\dontrun{
beta_diff <- runif(200, -1, 1)
fdr <- runif(200, 0.01, 1)
TCGAVisualize_volcano(
    x = beta_diff,
    y = fdr,
    x.cut = 1.5,
    y.cut = 0.01,
    title = "Title example",
    xlab = expression(paste("DNA Methylation difference (", beta, "-values)"))
)
TCGAVisualize_volcano(
  x,
  y,
  filename = NULL,
  y.cut = 10000000,
  x.cut=0.8,
   names = rep("AAAA",length(x)),
   legend = "Status",
   names.fill = FALSE
)

TCGAVisualize_volcano(
  x,
  y,
  filename = NULL,
  y.cut = 10000000,
  x.cut = 0.8,
   names = as.character(1:length(x)),
   legend = "Status",
   names.fill = TRUE, highlight = c("1","2"),
   show = "both"
)
TCGAVisualize_volcano(
  x,
  y,
  filename = NULL,
  y.cut = 10000000,
  x.cut = c(-0.3,0.8),
  names = as.character(1:length(x)),
  legend = "Status",
  names.fill = TRUE,
  highlight = c("1","2"),
  show = "both"
)
}
while (!(is.null(dev.list()["RStudioGD"]))){dev.off()}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/analyze.R
\name{TCGAanalyze_analyseGRN}
\alias{TCGAanalyze_analyseGRN}
\title{Generate network}
\usage{
TCGAanalyze_analyseGRN(TFs, normCounts, kNum)
}
\arguments{
\item{TFs}{a vector of genes.}

\item{normCounts}{is a matrix of gene expression with genes in rows and samples in columns.}

\item{kNum}{the number of nearest neighbors to consider to estimate the mutual information.
Must be less than the number of columns of normCounts.}
}
\value{
an adjacent matrix
}
\description{
TCGAanalyze_analyseGRN perform gene regulatory network.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/api.R
\name{splitAPICall}
\alias{splitAPICall}
\title{internal function to break a huge API call into smaller ones
so it repects the max character limit of a string}
\usage{
splitAPICall(FUN, step = 20, items)
}
\arguments{
\item{FUN}{function that calls the API}

\item{step}{How many items to be evaluated per API call}

\item{items}{vector of items to be using within the function
(list of barcodes, aliquot ids, etc)}
}
\description{
internal function to break a huge API call into smaller ones
so it repects the max character limit of a string
}
\author{
Tiago Chedraoui Silva
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methylation.R
\name{TCGAvisualize_meanMethylation}
\alias{TCGAvisualize_meanMethylation}
\title{Mean methylation boxplot}
\usage{
TCGAvisualize_meanMethylation(
  data,
  groupCol = NULL,
  subgroupCol = NULL,
  shapes = NULL,
  print.pvalue = FALSE,
  plot.jitter = TRUE,
  jitter.size = 3,
  filename = "groupMeanMet.pdf",
  ylab = expression(paste("Mean DNA methylation (", beta, "-values)")),
  xlab = NULL,
  title = "Mean DNA methylation",
  labels = NULL,
  group.legend = NULL,
  subgroup.legend = NULL,
  color = NULL,
  y.limits = NULL,
  sort,
  order,
  legend.position = "top",
  legend.title.position = "top",
  legend.ncols = 3,
  add.axis.x.text = TRUE,
  width = 10,
  height = 10,
  dpi = 600,
  axis.text.x.angle = 90
)
}
\arguments{
\item{data}{SummarizedExperiment object obtained from TCGAPrepare}

\item{groupCol}{Columns in colData(data) that defines the groups. If no
columns defined a columns called "Patients" will be used}

\item{subgroupCol}{Columns in colData(data) that defines the subgroups.}

\item{shapes}{Shape vector of the subgroups. It must have the size of the levels
of the subgroups. Example: shapes = c(21,23) if for two levels}

\item{print.pvalue}{Print p-value for two groups}

\item{plot.jitter}{Plot jitter? Default TRUE}

\item{jitter.size}{Plot jitter size? Default 3}

\item{filename}{The name of the pdf that will be saved}

\item{ylab}{y axis text in the plot}

\item{xlab}{x axis text in the plot}

\item{title}{main title in the plot}

\item{labels}{Labels of the groups}

\item{group.legend}{Name of the group legend. DEFAULT: groupCol}

\item{subgroup.legend}{Name of the subgroup legend. DEFAULT: subgroupCol}

\item{color}{vector of colors to be used in graph}

\item{y.limits}{Change lower/upper y-axis limit}

\item{sort}{Sort boxplot by mean or median.
Possible values: mean.asc, mean.desc, median.asc, median.desc}

\item{order}{Order of the boxplots}

\item{legend.position}{Legend position ("top", "right","left","bottom")}

\item{legend.title.position}{Legend title position ("top", "right","left","bottom")}

\item{legend.ncols}{Number of columns of the legend}

\item{add.axis.x.text}{Add text to x-axis? Default: FALSE}

\item{width}{Plot width default:10}

\item{height}{Plot height default:10}

\item{dpi}{Pdf dpi default:600}

\item{axis.text.x.angle}{Angle of text in the x axis}
}
\value{
Save the pdf survival plot
}
\description{
Creates a mean methylation boxplot for groups (groupCol),
  subgroups will be highlighted as shapes if the subgroupCol was set.

  Observation: Data is a summarizedExperiment.
}
\examples{
nrows <- 200; ncols <- 21
counts <- matrix(runif(nrows * ncols, 0, 1), nrows)
rowRanges <- GenomicRanges::GRanges(rep(c("chr1", "chr2"), c(50, 150)),
                   IRanges::IRanges(floor(runif(200, 1e5, 1e6)), width=100),
                    strand=sample(c("+", "-"), 200, TRUE),
                    feature_id=sprintf("ID\%03d", 1:200))
colData <- S4Vectors::DataFrame(Treatment=rep(c("ChIP", "Input","Other"), 7),
                    row.names=LETTERS[1:21],
                    group=rep(c("group1","group2","group3"),c(7,7,7)),
                    subgroup=rep(c("subgroup1","subgroup2","subgroup3"),7))
data <- SummarizedExperiment::SummarizedExperiment(
         assays=S4Vectors::SimpleList(counts=counts),
         rowRanges=rowRanges,
         colData=colData)
TCGAvisualize_meanMethylation(data,groupCol  = "group")
# change lower/upper y-axis limit
TCGAvisualize_meanMethylation(data,groupCol  = "group", y.limits = c(0,1))
# change lower y-axis limit
TCGAvisualize_meanMethylation(data,groupCol  = "group", y.limits = 0)
TCGAvisualize_meanMethylation(data,groupCol  = "group", subgroupCol="subgroup")
TCGAvisualize_meanMethylation(data,groupCol  = "group")
TCGAvisualize_meanMethylation(data,groupCol  = "group",sort="mean.desc",filename="meandesc.pdf")
TCGAvisualize_meanMethylation(data,groupCol  = "group",sort="mean.asc",filename="meanasc.pdf")
TCGAvisualize_meanMethylation(data,groupCol  = "group",sort="median.asc",filename="medianasc.pdf")
TCGAvisualize_meanMethylation(data,groupCol  = "group",sort="median.desc",filename="mediandesc.pdf")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/api.R
\name{getNbFiles}
\alias{getNbFiles}
\title{Get Number of files in GDC for a project}
\usage{
getNbFiles(project, data.category)
}
\arguments{
\item{project}{A  GDC project}

\item{data.category}{A  GDC project data category}
}
\description{
Get Number of files in GDC for a project
}
\examples{
\dontrun{
getNbFiles("TCGA-ACC","Clinical")
getNbFiles("CPTAC-2","Clinical")
}
}
\author{
Tiago Chedraoui Silva
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TCGAbiolinks.R
\docType{data}
\name{bcgsc.ca_CHOL.IlluminaHiSeq_DNASeq.1.somatic.maf}
\alias{bcgsc.ca_CHOL.IlluminaHiSeq_DNASeq.1.somatic.maf}
\title{TCGA CHOL MAF}
\format{
A tibble: 3,555 x 34
}
\description{
TCGA CHOL MAF
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TCGAbiolinks.R
\docType{data}
\name{geneInfoHT}
\alias{geneInfoHT}
\title{geneInfoHT for normalization of HTseq data}
\format{
A data frame with 23486 rows and 2 variables
}
\description{
Code to generate the data in examples
}
\examples{
\dontrun{
library(EDASeq)
library(biomaRt)
#get ensembl gene IDs for hg38
ensembl <- useMart("ensembl", dataset = "hsapiens_gene_ensembl")
biomart_getID <- getBM(attributes = c("ensembl_gene_id"), mart = ensembl)
#get gene length and GC content for all IDs

step <- 500
geneInfoHT <- plyr::adply(seq(1,length(biomart_getID$ensembl_gene_id),step),.margins = 1,.fun = function(x){
    begin <- x
   end <- x + step
    if(end > length(biomart_getID$ensembl_gene_id)) end <- length(biomart_getID$ensembl_gene_id)
    file <- paste0("geneInfoHT_from_",begin,"_to_",end,".rda")
    if(!file.exists(file)){
        df <- getGeneLengthAndGCContent(biomart_getID$ensembl_gene_id[begin:end] , org="hsa", mode = c("biomart"))
        save(df,file = file)
    } else {
        df <- get(load(file))
    }
    df
},.progress = "time")
saveRDS(getdata, file = "getGLGC_download.RDS")a
save(getdata, file = "getGLGC_download.rda")
#Save output as data frame with correct header names
geneInfoHT <- data.frame(
    geneLength = getdata[,1] ,
    gcContent = getdata[,2]
)
#Save final table
save(geneInfoHT, file = "data/geneInfoHT.rda")
}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/analyze.R
\name{TCGAanalyze_Normalization}
\alias{TCGAanalyze_Normalization}
\title{normalization mRNA transcripts and miRNA using EDASeq package.}
\usage{
TCGAanalyze_Normalization(tabDF, geneInfo, method = "geneLength")
}
\arguments{
\item{tabDF}{Rnaseq numeric matrix, each row represents a gene,
each column represents a sample}

\item{geneInfo}{Information matrix of 20531 genes about geneLength and gcContent.
Two objects are provided: TCGAbiolinks::geneInfoHT,TCGAbiolinks::geneInfo}

\item{method}{is method of normalization such as 'gcContent' or 'geneLength'}
}
\value{
Rnaseq matrix normalized with counts slot holds the count data as a matrix
of non-negative integer count values, one row for each observational unit (gene or the like),
and one column for each sample.
}
\description{
TCGAanalyze_Normalization allows user to normalize mRNA transcripts and miRNA,
   using EDASeq package.

   Normalization for RNA-Seq Numerical and graphical
    summaries of RNA-Seq read data. Within-lane normalization procedures
   to adjust for GC-content effect (or other gene-level effects) on read counts:
   loess robust local regression, global-scaling, and full-quantile normalization
   (Risso et al., 2011). Between-lane normalization procedures to adjust for
   distributional differences between lanes (e.g., sequencing depth):
   global-scaling and full-quantile normalization (Bullard et al., 2010).

   For istance returns all mRNA or miRNA with mean across all
   samples, higher than the threshold defined quantile mean across all samples.

   TCGAanalyze_Normalization performs normalization using following functions
   from EDASeq
   \enumerate{
   \item  EDASeq::newSeqExpressionSet
   \item  EDASeq::withinLaneNormalization
   \item  EDASeq::betweenLaneNormalization
   \item  EDASeq::counts
   }
}
\examples{
dataNorm <- TCGAbiolinks::TCGAanalyze_Normalization(dataBRCA, geneInfo)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/analyze.R
\name{TCGAanalyze_Filtering}
\alias{TCGAanalyze_Filtering}
\title{Filtering mRNA transcripts and miRNA selecting a threshold.}
\usage{
TCGAanalyze_Filtering(
  tabDF,
  method,
  qnt.cut = 0.25,
  var.func = IQR,
  var.cutoff = 0.75,
  eta = 0.05,
  foldChange = 1
)
}
\arguments{
\item{tabDF}{is a dataframe or numeric matrix, each row represents a gene,
each column represents a sample come from TCGAPrepare}

\item{method}{is method of filtering such as 'quantile', 'varFilter', 'filter1', 'filter2'}

\item{qnt.cut}{is threshold selected as mean for filtering}

\item{var.func}{is function used as the per-feature filtering statistic.
See genefilter documentation}

\item{var.cutoff}{is a numeric value. See genefilter documentation}

\item{eta}{is a parameter for filter1. default eta = 0.05.}

\item{foldChange}{is a parameter for filter2. default foldChange = 1.}
}
\value{
A filtered dataframe or numeric matrix where each row represents a gene,
each column represents a sample
}
\description{
TCGAanalyze_Filtering allows user to filter mRNA transcripts and miRNA,
   samples, higher than the threshold defined quantile mean across all samples.
}
\examples{
dataNorm <- TCGAbiolinks::TCGAanalyze_Normalization(dataBRCA, geneInfo)
dataNorm <- TCGAanalyze_Normalization(tabDF = dataBRCA,
geneInfo = geneInfo,
method = "geneLength")
dataFilt <- TCGAanalyze_Filtering(tabDF = dataNorm, method = "quantile", qnt.cut = 0.25)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/analyze.R
\name{TCGAanalyze_EAcomplete}
\alias{TCGAanalyze_EAcomplete}
\title{Enrichment analysis for Gene Ontology (GO) [BP,MF,CC] and Pathways}
\usage{
TCGAanalyze_EAcomplete(TFname, RegulonList)
}
\arguments{
\item{TFname}{is the name of the list of genes or TF's regulon.}

\item{RegulonList}{List of genes such as TF's regulon or DEGs where to find enrichment.}
}
\value{
Enrichment analysis GO[BP,MF,CC] and Pathways complete table enriched by genelist.
}
\description{
Researchers, in order to better understand the underlying biological
  processes, often want to retrieve a functional profile of a set of genes
  that might have an important role. This can be done by performing an
  enrichment analysis.

We will perform an enrichment analysis on gene sets using the TCGAanalyze_EAcomplete
function. Given a set of genes that are
up-regulated under certain conditions, an enrichment analysis will find
identify classes of genes or proteins that are #'over-represented using
annotations for that gene set.
}
\examples{
Genelist <- c("FN1","COL1A1")
ansEA <- TCGAanalyze_EAcomplete(TFname="DEA genes Normal Vs Tumor",Genelist)
\dontrun{
Genelist <- rownames(dataDEGsFiltLevel)
system.time(ansEA <- TCGAanalyze_EAcomplete(TFname="DEA genes Normal Vs Tumor",Genelist))
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TCGAbiolinks.R
\docType{data}
\name{dataDEGsFiltLevel}
\alias{dataDEGsFiltLevel}
\title{TCGA data matrix BRCA DEGs}
\format{
A data frame with 3649 rows and 6 variables
}
\description{
TCGA data matrix BRCA DEGs
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/api.R
\name{getDataCategorySummary}
\alias{getDataCategorySummary}
\title{Create a Summary table for each sample in a project saying if it contains
or not files for a certain data category}
\usage{
getDataCategorySummary(project)
}
\arguments{
\item{project}{A GDC project}
}
\value{
A data frame
}
\description{
Create a Summary table for each sample in a project saying if it contains
or not files for a certain data category
}
\examples{
summary <- getDataCategorySummary("TCGA-ACC")
}
\author{
Tiago Chedraoui Silva
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/download.R
\name{getManifest}
\alias{getManifest}
\title{Get a Manifest from GDCquery output that can be used with GDC-client}
\usage{
getManifest(query, save = FALSE)
}
\arguments{
\item{query}{A query for GDCquery function}

\item{save}{Write Manifest to a txt file (tab separated)}
}
\description{
Get a Manifest from GDCquery output that can be used with GDC-client
}
\examples{
query <- GDCquery(
  project = "TARGET-AML",
  data.category = "Transcriptome Profiling",
  data.type = "Gene Expression Quantification",
  workflow.type = "STAR - Counts",
  barcode = c("TARGET-20-PADZCG-04A-01R", "TARGET-20-PARJCR-09A-01R")
)
getManifest(query)
}
